DROP TABLE IF EXISTS `blocked_photos`;
CREATE TABLE `blocked_photos` (
  `id` int(9) NOT NULL AUTO_INCREMENT,
  `u1` int(9) NOT NULL,
  `u2` int(9) NOT NULL,
  PRIMARY KEY (`id`,`u1`,`u2`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of blocked_photos
-- ----------------------------
DROP TABLE IF EXISTS `emails`;
CREATE TABLE `emails` (
  `id` int(9) NOT NULL AUTO_INCREMENT,
  `type` int(1) DEFAULT NULL,
  `uid` int(9) DEFAULT NULL,
  `code` varchar(300) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=64 DEFAULT CHARSET=utf8;

-- ----------------------------
-- Table structure for chat
-- ----------------------------
DROP TABLE IF EXISTS `chat`;
CREATE TABLE `chat` (
  `id` int(9) NOT NULL AUTO_INCREMENT,
  `s_id` int(9) NOT NULL,
  `r_id` int(9) NOT NULL,
  `message` text NOT NULL,
  `time` varchar(100) NOT NULL,
  `seen` int(1) NOT NULL DEFAULT '0',
  `notification` int(1) NOT NULL DEFAULT '0',
  `photo` int(1) NOT NULL DEFAULT '0',
  `access` int(1) NOT NULL DEFAULT '0',
  `fake` int(1) DEFAULT '0',
  `online_day` int(1) DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of chat
-- ----------------------------

-- ----------------------------
-- Table structure for config
-- ----------------------------
DROP TABLE IF EXISTS `config`;
CREATE TABLE `config` (
  `name` varchar(200) NOT NULL,
  `title` varchar(500) NOT NULL,
  `description` varchar(800) NOT NULL,
  `keywords` varchar(200) NOT NULL,
  `lang` varchar(100) NOT NULL,
  `videocall` varchar(100) NOT NULL,
  `fb_app_id` varchar(300) NOT NULL,
  `fb_app_secret` varchar(300) NOT NULL,
  `theme` varchar(200) NOT NULL,
  `logo` varchar(400) NOT NULL,
  `ads` text NOT NULL,
  `photo_review` int(1) DEFAULT '0',
  `paypal` varchar(100) DEFAULT NULL,
  `paygol` varchar(100) DEFAULT NULL,
  `currency` varchar(20) DEFAULT NULL,
  `ads2` text,
  `email` varchar(100) DEFAULT NULL,
  `terms` longtext,
  `privacy` longtext,
  `theme_mobile` varchar(100) DEFAULT NULL,
  `theme_landing` varchar(100) DEFAULT NULL,
  `theme_email` varchar(100) DEFAULT NULL,
  `email_verification` int(1) DEFAULT '0',
  `free_credits` int(9) DEFAULT '0',
  `free_premium` int(9) DEFAULT '0',
  `s3` varchar(200) DEFAULT NULL,
  `s3_key` varchar(200) DEFAULT NULL,
  `stripe_pub` varchar(200) DEFAULT NULL,
  `stripe_secret` varchar(200) DEFAULT NULL,
  `fortumo_service` varchar(200) DEFAULT NULL,
  `fortumo_secret` varchar(200) DEFAULT NULL,
  `twitter_key` varchar(200) DEFAULT NULL,
  `twitter_secret` varchar(200) DEFAULT NULL,
  `instagram_key` varchar(200) DEFAULT NULL,
  `instagram_secret` varchar(200) DEFAULT NULL,
  `google_key` varchar(200) DEFAULT NULL,
  `google_secret` varchar(200) DEFAULT NULL,
  `s3_bucket` varchar(200) DEFAULT NULL,
  `css` longtext,
  `js` longtext,
  `google_maps` varchar(200) DEFAULT NULL,
  PRIMARY KEY (`name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of config
-- ----------------------------
INSERT INTO `config` VALUES ('Social Match', 'Social Match - Meet new people', 'SocialMatch - Meet new people', 'videocalls,friends,twitter,chat,meet,people,friends,facebook,instagram', '1', '', '', '', 'default', 'https://datingscript.com/sm/themes/default/images/logo.png', '<script async src=\"//pagead2.googlesyndication.com/pagead/js/adsbygoogle.js\"></script>\n<ins class=\"adsbygoogle\"\n     style=\"display:inline-block;width:970px;height:90px\"\n     data-ad-client=\"ca-pub-4088683558391542\"\n     data-ad-slot=\"5560559355\"></ins>\n<script>\n(adsbygoogle = window.adsbygoogle || []).push({});\n</script>', '1', '', '333314', 'USD', '<script async src=\"//pagead2.googlesyndication.com/pagead/js/adsbygoogle.js\"></script>\r\n<!-- Match 2 -->\r\n<ins class=\"adsbygoogle\"\r\n style=\"display:inline-block;width:250px;height:250px\"\r\n data-ad-client=\"ca-pub-4088683558391542\"\r\n data-ad-slot=\"4712921352\"></ins>\r\n<script>\r\n(adsbygoogle = window.adsbygoogle || []).push({});\r\n</script>', 'no-reply@match.com', 'Your site terms here , this spaace allow html code', 'Your site privacy here , this spaace allow html code', 'mobile', 'landing', 'email', '0', '5000', '5', '', '', '', '', '', '', '', '', '', '', '', '', '', '<!-- add your custom css here -->\r\n<style>\r\n\r\n</style>', '<!-- add your custom js here -->\r\n<script>\r\n\r\n</script>', '');

-- ----------------------------
-- Table structure for config_accounts
-- ----------------------------
DROP TABLE IF EXISTS `config_accounts`;
CREATE TABLE `config_accounts` (
  `type` int(1) NOT NULL,
  `chat` int(9) NOT NULL,
  `videocall` int(1) NOT NULL,
  `private` int(1) NOT NULL,
  `visits` int(1) DEFAULT NULL,
  `fans` int(1) DEFAULT NULL,
  `mobile_ads` int(1) DEFAULT NULL,
  PRIMARY KEY (`type`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of config_accounts
-- ----------------------------
INSERT INTO `config_accounts` VALUES ('1', '10', '1', '0', '1', '1', '1');
INSERT INTO `config_accounts` VALUES ('2', '50', '1', '1', '1', '1', '0');

-- ----------------------------
-- Table structure for config_app_basic
-- ----------------------------
DROP TABLE IF EXISTS `config_app_basic`;
CREATE TABLE `config_app_basic` (
  `title` varchar(200) DEFAULT NULL,
  `subtitle` varchar(200) DEFAULT NULL,
  `logo` varchar(200) DEFAULT NULL,
  `background` varchar(200) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of config_app_basic
-- ----------------------------
INSERT INTO `config_app_basic` VALUES ('Social Match', 'Meet new people around you', 'http://datingscript.com/sm/logo.png', 'http://datingscript.com/sm/background1.jpg');

-- ----------------------------
-- Table structure for config_credits
-- ----------------------------
DROP TABLE IF EXISTS `config_credits`;
CREATE TABLE `config_credits` (
  `id` int(9) NOT NULL AUTO_INCREMENT,
  `credits` int(9) NOT NULL,
  `price` varchar(20) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=7 DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of config_credits
-- ----------------------------
INSERT INTO `config_credits` VALUES ('1', '500', '3.99');
INSERT INTO `config_credits` VALUES ('2', '1000', '5.99');
INSERT INTO `config_credits` VALUES ('3', '3000', '12.99');
INSERT INTO `config_credits` VALUES ('4', '5000', '15.99');
INSERT INTO `config_credits` VALUES ('5', '10000', '25.99');

-- ----------------------------
-- Table structure for config_email
-- ----------------------------
DROP TABLE IF EXISTS `config_email`;
CREATE TABLE `config_email` (
  `host` varchar(100) NOT NULL DEFAULT '',
  `port` int(9) DEFAULT NULL,
  `user` varchar(200) DEFAULT NULL,
  `password` varchar(200) DEFAULT NULL,
  PRIMARY KEY (`host`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of config_email
-- ----------------------------
INSERT INTO `config_email` VALUES ('', '0', '', '');

-- ----------------------------
-- Table structure for config_premium
-- ----------------------------
DROP TABLE IF EXISTS `config_premium`;
CREATE TABLE `config_premium` (
  `id` int(9) NOT NULL AUTO_INCREMENT,
  `days` int(9) NOT NULL,
  `price` int(9) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=4 DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of config_premium
-- ----------------------------
INSERT INTO `config_premium` VALUES ('1', '30', '10');
INSERT INTO `config_premium` VALUES ('2', '90', '25');
INSERT INTO `config_premium` VALUES ('3', '180', '50');

-- ----------------------------
-- Table structure for config_prices
-- ----------------------------
DROP TABLE IF EXISTS `config_prices`;
CREATE TABLE `config_prices` (
  `private` int(9) NOT NULL,
  `spotlight` int(9) NOT NULL,
  `chat` int(9) NOT NULL,
  PRIMARY KEY (`private`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of config_prices
-- ----------------------------
INSERT INTO `config_prices` VALUES ('200', '300', '100');

-- ----------------------------
-- Table structure for config_themes
-- ----------------------------
DROP TABLE IF EXISTS `config_themes`;
CREATE TABLE `config_themes` (
  `id` int(9) NOT NULL AUTO_INCREMENT,
  `type` int(1) DEFAULT NULL,
  `folder` varchar(200) DEFAULT NULL,
  `name` varchar(200) DEFAULT NULL,
  `screenshot` varchar(200) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=10 DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of config_themes
-- ----------------------------
INSERT INTO `config_themes` VALUES ('1', '1', 'default', 'SM Theme', 'themes/default/images/screenshot.jpg');
INSERT INTO `config_themes` VALUES ('2', '2', 'landing', 'SM Landing', 'themes/landing/images/screenshot.jpg');
INSERT INTO `config_themes` VALUES ('3', '3', 'mobile', 'SM Mobile', 'themes/mobile/images/screenshot.jpg');
INSERT INTO `config_themes` VALUES ('4', '4', 'email', 'SM Email', 'themes/email/img/screenshot.jpg');

-- ----------------------------
-- Table structure for gifts
-- ----------------------------
DROP TABLE IF EXISTS `gifts`;
CREATE TABLE `gifts` (
  `id` int(9) NOT NULL AUTO_INCREMENT,
  `gift` varchar(50) NOT NULL,
  `price` int(5) NOT NULL DEFAULT '0',
  `icon` varchar(100) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=26 DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of gifts
-- ----------------------------
INSERT INTO `gifts` VALUES ('1', 'Treasure', '500', 'themes/default/gifts/1.png');
INSERT INTO `gifts` VALUES ('2', 'Cake', '100', 'themes/default/gifts/2.png');
INSERT INTO `gifts` VALUES ('3', 'Wine', '100', 'themes/default/gifts/3.png');
INSERT INTO `gifts` VALUES ('4', 'Flowers ', '250', 'themes/default/gifts/4.png');
INSERT INTO `gifts` VALUES ('5', 'Present', '200', 'themes/default/gifts/5.png');
INSERT INTO `gifts` VALUES ('6', 'Heart candy', '150', 'themes/default/gifts/6.png');
INSERT INTO `gifts` VALUES ('7', 'kiss', '100', 'themes/default/gifts/7.png');
INSERT INTO `gifts` VALUES ('8', 'beer', '100', 'themes/default/gifts/8.png');
INSERT INTO `gifts` VALUES ('10', 'cup', '250', 'themes/default/gifts/10.png');
INSERT INTO `gifts` VALUES ('11', 'flower', '100', 'themes/default/gifts/11.png');
INSERT INTO `gifts` VALUES ('12', 'crown', '1500', 'themes/default/gifts/12.png');
INSERT INTO `gifts` VALUES ('13', 'hearts', '250', 'themes/default/gifts/13.png');
INSERT INTO `gifts` VALUES ('14', 'hear candy 2', '200', 'themes/default/gifts/14.png');
INSERT INTO `gifts` VALUES ('15', 'champagne', '500', 'themes/default/gifts/15.png');
INSERT INTO `gifts` VALUES ('16', 'coffe', '150', 'themes/default/gifts/16.png');
INSERT INTO `gifts` VALUES ('17', 'cupido', '250', 'themes/default/gifts/17.png');
INSERT INTO `gifts` VALUES ('18', 'flowers 3', '500', 'themes/default/gifts/18.png');
INSERT INTO `gifts` VALUES ('19', 'dairy love', '100', 'themes/default/gifts/19.png');
INSERT INTO `gifts` VALUES ('20', 'handcops', '500', 'themes/default/gifts/20.png');
INSERT INTO `gifts` VALUES ('21', 'heart', '100', 'themes/default/gifts/21.png');
INSERT INTO `gifts` VALUES ('22', 'heart 2', '250', 'themes/default/gifts/22.png');
INSERT INTO `gifts` VALUES ('23', 'heart 3', '150', 'themes/default/gifts/23.png');
INSERT INTO `gifts` VALUES ('24', 'ring', '1000', 'themes/default/gifts/24.png');
INSERT INTO `gifts` VALUES ('25', 'bear', '250', 'themes/default/gifts/26.png');

-- ----------------------------
-- Table structure for interest
-- ----------------------------
DROP TABLE IF EXISTS `interest`;
CREATE TABLE `interest` (
  `id` int(9) NOT NULL AUTO_INCREMENT,
  `name` varchar(100) NOT NULL,
  `count` int(9) DEFAULT '1',
  PRIMARY KEY (`id`,`name`),
  UNIQUE KEY `KEY` (`name`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of interest
-- ----------------------------

-- ----------------------------
-- Table structure for languages
-- ----------------------------
DROP TABLE IF EXISTS `languages`;
CREATE TABLE `languages` (
  `id` int(9) NOT NULL AUTO_INCREMENT,
  `prefix` varchar(5) NOT NULL,
  `name` varchar(100) NOT NULL,
  `visible` int(1) NOT NULL DEFAULT '1',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=49 DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of languages
-- ----------------------------
INSERT INTO `languages` VALUES ('1', 'en', 'English', '1');
INSERT INTO `languages` VALUES ('2', 'es', 'EspaÃ±ol', '1');
INSERT INTO `languages` VALUES ('3', 'sq', 'Shqiptar', '1');
INSERT INTO `languages` VALUES ('4', 'ar', 'Ø§Ù„Ø¹Ø±Ø¨ÙŠØ©', '1');
INSERT INTO `languages` VALUES ('5', 'be', 'Ð±ÐµÐ»Ð°Ñ€ÑƒÑÐºÑ–', '1');
INSERT INTO `languages` VALUES ('6', 'bg', 'Ð±Ð°Ð»Ð³Ð°Ñ€ÑÐºÑ–', '1');
INSERT INTO `languages` VALUES ('7', 'ca', 'CatalÃ ', '1');
INSERT INTO `languages` VALUES ('8', 'zh-CN', 'ä¸­å›½ç®€ä½“', '1');
INSERT INTO `languages` VALUES ('9', 'zh-TW', 'ä¸­åœ‹å‚³çµ±', '1');
INSERT INTO `languages` VALUES ('10', 'hr', 'Hrvatski', '1');
INSERT INTO `languages` VALUES ('11', 'cs', 'ÄŒeÅ¡tina', '1');
INSERT INTO `languages` VALUES ('12', 'da', 'Dansk', '1');
INSERT INTO `languages` VALUES ('13', 'nl', 'Nederlands', '1');
INSERT INTO `languages` VALUES ('14', 'et', 'Eesti', '1');
INSERT INTO `languages` VALUES ('15', 'tl', 'Pilipino', '1');
INSERT INTO `languages` VALUES ('16', 'fi', 'Suomi', '1');
INSERT INTO `languages` VALUES ('17', 'fr', 'FranÃ§ais', '1');
INSERT INTO `languages` VALUES ('18', 'ka', 'áƒ¥áƒáƒ áƒ—áƒ£áƒšáƒ˜', '1');
INSERT INTO `languages` VALUES ('19', 'de', 'Deutsch', '1');
INSERT INTO `languages` VALUES ('20', 'el', 'ÎµÎ»Î»Î·Î½Î¹ÎºÎ¬', '1');
INSERT INTO `languages` VALUES ('21', 'ht', 'Haitian C.', '1');
INSERT INTO `languages` VALUES ('22', 'iw', '×¢×‘×¨×™×ª', '1');
INSERT INTO `languages` VALUES ('23', 'hi', 'à¤¹à¤¿à¤¨à¥à¤¦à¥€', '1');
INSERT INTO `languages` VALUES ('24', 'hu', 'Magyar', '1');
INSERT INTO `languages` VALUES ('25', 'id', 'Indonesia', '1');
INSERT INTO `languages` VALUES ('26', 'ga', 'Irish', '1');
INSERT INTO `languages` VALUES ('27', 'it', 'Italiano', '1');
INSERT INTO `languages` VALUES ('28', 'ja', 'æ—¥æœ¬äºº', '1');
INSERT INTO `languages` VALUES ('29', 'ko', 'í•œêµ­ì˜', '1');
INSERT INTO `languages` VALUES ('30', 'la', 'Latina', '1');
INSERT INTO `languages` VALUES ('31', 'lt', 'LietuviÅ³', '1');
INSERT INTO `languages` VALUES ('32', 'mk', 'MÐ°ÐºÐµÐ´Ð¾Ð½ÑÐºÐ¸', '1');
INSERT INTO `languages` VALUES ('33', 'ms', 'Melayu', '1');
INSERT INTO `languages` VALUES ('34', 'no', 'Norsk', '1');
INSERT INTO `languages` VALUES ('35', 'fa', 'ÙØ§Ø±Ø³ÛŒ', '1');
INSERT INTO `languages` VALUES ('36', 'pl', 'Polski', '1');
INSERT INTO `languages` VALUES ('37', 'pt', 'PortuguÃªs', '1');
INSERT INTO `languages` VALUES ('38', 'ro', 'RomÃ¢n', '1');
INSERT INTO `languages` VALUES ('39', 'ru', 'PÑƒÑÑÐºÐ¸Ð¹', '1');
INSERT INTO `languages` VALUES ('40', 'sr', 'CÑ€Ð¿ÑÐºÐ¸', '1');
INSERT INTO `languages` VALUES ('41', 'sk', 'SlovenÄina', '1');
INSERT INTO `languages` VALUES ('42', 'sl', 'SlovenÅ¡Äina', '1');
INSERT INTO `languages` VALUES ('43', 'sv', 'Swedish', '1');
INSERT INTO `languages` VALUES ('44', 'th', 'TÃ¼rk', '1');
INSERT INTO `languages` VALUES ('45', 'tr', 'Turkish', '1');
INSERT INTO `languages` VALUES ('46', 'uk', 'Ð£ÐºÑ€Ð°Ñ—Ð½ÑÑŒÐºÐ¸Ð¹', '1');
INSERT INTO `languages` VALUES ('47', 'vi', 'tiáº¿ng Viá»‡t', '1');
INSERT INTO `languages` VALUES ('48', 'yi', '×™×™Ö´×“×™×©', '1');

-- ----------------------------
-- Table structure for photos
-- ----------------------------
DROP TABLE IF EXISTS `photos`;
CREATE TABLE `photos` (
  `id` int(9) NOT NULL AUTO_INCREMENT,
  `pid` int(9) NOT NULL,
  `cid` int(9) NOT NULL,
  `comment` text NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of photos
-- ----------------------------

-- ----------------------------
-- Table structure for photos_likes
-- ----------------------------
DROP TABLE IF EXISTS `photos_likes`;
CREATE TABLE `photos_likes` (
  `id` int(9) NOT NULL,
  `pid` int(9) NOT NULL,
  `uid` int(9) NOT NULL,
  `name` varchar(100) NOT NULL,
  PRIMARY KEY (`uid`,`pid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of photos_likes
-- ----------------------------

-- ----------------------------
-- Table structure for reports
-- ----------------------------
DROP TABLE IF EXISTS `reports`;
CREATE TABLE `reports` (
  `id` int(9) NOT NULL AUTO_INCREMENT,
  `reported` int(9) DEFAULT NULL,
  `reported_by` int(9) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;

-- ----------------------------
-- Records of reports
-- ----------------------------

-- ----------------------------
-- Table structure for site_lang
-- ----------------------------
DROP TABLE IF EXISTS `site_lang`;
CREATE TABLE `site_lang` (
  `id` int(9) NOT NULL,
  `lang_id` int(9) NOT NULL DEFAULT '1',
  `text` text NOT NULL,
  PRIMARY KEY (`id`,`lang_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of site_lang
-- ----------------------------
INSERT INTO `site_lang` VALUES ('0', '1', 'meet new people!');
INSERT INTO `site_lang` VALUES ('1', '1', 'Login');
INSERT INTO `site_lang` VALUES ('2', '1', 'Welcome to the fastest growing place to meet new people');
INSERT INTO `site_lang` VALUES ('3', '1', 'For now our site works only for Desktop users');
INSERT INTO `site_lang` VALUES ('4', '1', 'Please visit us from your laptop or PC');
INSERT INTO `site_lang` VALUES ('5', '1', 'Soon we will have our phone apps online');
INSERT INTO `site_lang` VALUES ('6', '1', 'SOON AVAILABLE');
INSERT INTO `site_lang` VALUES ('7', '1', 'Connect with ');
INSERT INTO `site_lang` VALUES ('8', '1', 'Create your account');
INSERT INTO `site_lang` VALUES ('9', '1', 'Welcome back');
INSERT INTO `site_lang` VALUES ('10', '1', 'Your email');
INSERT INTO `site_lang` VALUES ('11', '1', 'Your password');
INSERT INTO `site_lang` VALUES ('12', '1', 'do you forget your password?');
INSERT INTO `site_lang` VALUES ('13', '1', 'Login now');
INSERT INTO `site_lang` VALUES ('14', '1', 'Password recover');
INSERT INTO `site_lang` VALUES ('15', '1', 'Recover password');
INSERT INTO `site_lang` VALUES ('16', '1', 'Chat');
INSERT INTO `site_lang` VALUES ('17', '1', 'Powerfull private chat for meet new friends, you can send emoticons and private photos to anyone.');
INSERT INTO `site_lang` VALUES ('18', '1', 'Video Chat');
INSERT INTO `site_lang` VALUES ('19', '1', 'You can make quality videocalls for free to anyone, without limits of call duration, just enjoy seeing the person who is chatting with you');
INSERT INTO `site_lang` VALUES ('20', '1', 'People nearby');
INSERT INTO `site_lang` VALUES ('21', '1', 'We wont show your exact location, but you will be able to find people nearby who like the same things you do.');
INSERT INTO `site_lang` VALUES ('22', '1', 'Matches');
INSERT INTO `site_lang` VALUES ('23', '1', 'Play our popular Discover game and get matched with other users. Its a great way to break the ice and chat to new people.');
INSERT INTO `site_lang` VALUES ('24', '1', 'Become a member now');
INSERT INTO `site_lang` VALUES ('25', '1', 'Join the worlds bestest community for meeting new people!.');
INSERT INTO `site_lang` VALUES ('26', '1', 'Name');
INSERT INTO `site_lang` VALUES ('27', '1', 'Your name or nickname');
INSERT INTO `site_lang` VALUES ('28', '1', 'Email');
INSERT INTO `site_lang` VALUES ('29', '1', 'Password');
INSERT INTO `site_lang` VALUES ('30', '1', 'Birthday');
INSERT INTO `site_lang` VALUES ('31', '1', 'Please select');
INSERT INTO `site_lang` VALUES ('32', '1', 'City');
INSERT INTO `site_lang` VALUES ('33', '1', 'Where do you live?');
INSERT INTO `site_lang` VALUES ('34', '1', 'Gender');
INSERT INTO `site_lang` VALUES ('35', '1', 'Male');
INSERT INTO `site_lang` VALUES ('36', '1', 'Female');
INSERT INTO `site_lang` VALUES ('37', '1', 'Im here to');
INSERT INTO `site_lang` VALUES ('38', '1', 'Meet girls');
INSERT INTO `site_lang` VALUES ('39', '1', 'Meet boys');
INSERT INTO `site_lang` VALUES ('40', '1', 'Meet boys and girls');
INSERT INTO `site_lang` VALUES ('41', '1', 'Sign up');
INSERT INTO `site_lang` VALUES ('42', '1', 'By continuing, you are confirming that you have read and agree to our');
INSERT INTO `site_lang` VALUES ('43', '1', 'Terms and Conditions');
INSERT INTO `site_lang` VALUES ('44', '1', 'and');
INSERT INTO `site_lang` VALUES ('45', '1', 'Privacy Policy');
INSERT INTO `site_lang` VALUES ('46', '1', 'Profile');
INSERT INTO `site_lang` VALUES ('47', '1', 'Settings');
INSERT INTO `site_lang` VALUES ('48', '1', 'Logout');
INSERT INTO `site_lang` VALUES ('49', '1', 'Meet new people');
INSERT INTO `site_lang` VALUES ('50', '1', 'Discover');
INSERT INTO `site_lang` VALUES ('51', '1', 'Matches');
INSERT INTO `site_lang` VALUES ('52', '1', 'Most populars');
INSERT INTO `site_lang` VALUES ('53', '1', 'Fans');
INSERT INTO `site_lang` VALUES ('54', '1', 'Manage photos');
INSERT INTO `site_lang` VALUES ('55', '1', 'Settings');
INSERT INTO `site_lang` VALUES ('56', '1', 'All');
INSERT INTO `site_lang` VALUES ('57', '1', 'Fans');
INSERT INTO `site_lang` VALUES ('58', '1', 'Conversations');
INSERT INTO `site_lang` VALUES ('59', '1', 'Online now');
INSERT INTO `site_lang` VALUES ('60', '1', 'New messages');
INSERT INTO `site_lang` VALUES ('61', '1', 'Who to like');
INSERT INTO `site_lang` VALUES ('62', '1', 'Terms');
INSERT INTO `site_lang` VALUES ('63', '1', 'Privacy');
INSERT INTO `site_lang` VALUES ('64', '1', 'Contact');
INSERT INTO `site_lang` VALUES ('65', '1', 'Manage your photos');
INSERT INTO `site_lang` VALUES ('66', '1', 'All Photos');
INSERT INTO `site_lang` VALUES ('67', '1', 'Public Photos');
INSERT INTO `site_lang` VALUES ('68', '1', 'Private Photos');
INSERT INTO `site_lang` VALUES ('69', '1', 'Add your photos');
INSERT INTO `site_lang` VALUES ('70', '1', 'add photos');
INSERT INTO `site_lang` VALUES ('71', '1', 'Add yourself to the Spotlight');
INSERT INTO `site_lang` VALUES ('72', '1', 'Pick the photo you want to show in the Spotlight, cost ');
INSERT INTO `site_lang` VALUES ('73', '1', 'Credits');
INSERT INTO `site_lang` VALUES ('74', '1', 'Add photo');
INSERT INTO `site_lang` VALUES ('75', '1', 'Send gift to ');
INSERT INTO `site_lang` VALUES ('76', '1', 'Pick the gift you want to send to ');
INSERT INTO `site_lang` VALUES ('77', '1', 'Send gift');
INSERT INTO `site_lang` VALUES ('78', '1', 'Buy credits / Upgrade account');
INSERT INTO `site_lang` VALUES ('79', '1', 'Select credits package');
INSERT INTO `site_lang` VALUES ('80', '1', 'Select payment method');
INSERT INTO `site_lang` VALUES ('81', '1', 'Pay with');
INSERT INTO `site_lang` VALUES ('82', '1', 'Pay with');
INSERT INTO `site_lang` VALUES ('83', '1', 'Buy credits');
INSERT INTO `site_lang` VALUES ('84', '1', 'Premium Account Features');
INSERT INTO `site_lang` VALUES ('85', '1', 'new chats per day');
INSERT INTO `site_lang` VALUES ('86', '1', 'Unlimited videocalls');
INSERT INTO `site_lang` VALUES ('87', '1', 'Unblock all private photos');
INSERT INTO `site_lang` VALUES ('88', '1', 'Premium user badge');
INSERT INTO `site_lang` VALUES ('89', '1', 'Write text here');
INSERT INTO `site_lang` VALUES ('90', '1', 'Send');
INSERT INTO `site_lang` VALUES ('91', '1', 'Chat');
INSERT INTO `site_lang` VALUES ('92', '1', 'you have reached the limit of new daily conversations');
INSERT INTO `site_lang` VALUES ('93', '1', 'To continue chatting');
INSERT INTO `site_lang` VALUES ('94', '1', 'Buy');
INSERT INTO `site_lang` VALUES ('95', '1', 'more daily conversation');
INSERT INTO `site_lang` VALUES ('96', '1', 'or');
INSERT INTO `site_lang` VALUES ('97', '1', 'Upgrade your account to Premium');
INSERT INTO `site_lang` VALUES ('98', '1', 'and get up to');
INSERT INTO `site_lang` VALUES ('99', '1', 'daily conversations');
INSERT INTO `site_lang` VALUES ('100', '1', 'or wait until tomorrow for continue meeting people');
INSERT INTO `site_lang` VALUES ('101', '1', 'Your fans');
INSERT INTO `site_lang` VALUES ('102', '1', 'Privacy Policy');
INSERT INTO `site_lang` VALUES ('103', '1', 'Terms of Use');
INSERT INTO `site_lang` VALUES ('104', '1', 'Please complete your profile before start in ');
INSERT INTO `site_lang` VALUES ('105', '1', 'Your matches');
INSERT INTO `site_lang` VALUES ('106', '1', 'Filter Search');
INSERT INTO `site_lang` VALUES ('107', '1', 'All users');
INSERT INTO `site_lang` VALUES ('108', '1', 'Online now');
INSERT INTO `site_lang` VALUES ('109', '1', 'Show me');
INSERT INTO `site_lang` VALUES ('110', '1', 'Girls');
INSERT INTO `site_lang` VALUES ('111', '1', 'Boys');
INSERT INTO `site_lang` VALUES ('112', '1', 'Both');
INSERT INTO `site_lang` VALUES ('113', '1', 'who are between');
INSERT INTO `site_lang` VALUES ('114', '1', 'in a radius of');
INSERT INTO `site_lang` VALUES ('115', '1', 'World');
INSERT INTO `site_lang` VALUES ('116', '1', 'Most popular users');
INSERT INTO `site_lang` VALUES ('117', '1', 'About ');
INSERT INTO `site_lang` VALUES ('118', '1', 'Personal info');
INSERT INTO `site_lang` VALUES ('119', '1', 'years old');
INSERT INTO `site_lang` VALUES ('120', '1', 'Only boys');
INSERT INTO `site_lang` VALUES ('121', '1', 'Only girls');
INSERT INTO `site_lang` VALUES ('122', '1', 'boys and girls');
INSERT INTO `site_lang` VALUES ('123', '1', 'Credits successfully added to your account');
INSERT INTO `site_lang` VALUES ('124', '1', 'Now you have');
INSERT INTO `site_lang` VALUES ('125', '1', 'Ask permission to');
INSERT INTO `site_lang` VALUES ('126', '1', 'Unblock private photos');
INSERT INTO `site_lang` VALUES ('127', '1', 'Personal');
INSERT INTO `site_lang` VALUES ('128', '1', 'Credits');
INSERT INTO `site_lang` VALUES ('129', '1', 'Verify');
INSERT INTO `site_lang` VALUES ('130', '1', 'Change password');
INSERT INTO `site_lang` VALUES ('131', '1', 'Delete');
INSERT INTO `site_lang` VALUES ('132', '1', 'Personal information');
INSERT INTO `site_lang` VALUES ('133', '1', 'You can edit your profile information bellow');
INSERT INTO `site_lang` VALUES ('134', '1', 'Site language');
INSERT INTO `site_lang` VALUES ('135', '1', 'Update profile');
INSERT INTO `site_lang` VALUES ('136', '1', 'Verify account');
INSERT INTO `site_lang` VALUES ('137', '1', 'For verify your account , connect with your facebook account');
INSERT INTO `site_lang` VALUES ('138', '1', 'Connect with Facebook');
INSERT INTO `site_lang` VALUES ('139', '1', 'You are account is already verified');
INSERT INTO `site_lang` VALUES ('140', '1', 'Buy credits for send Gifs and Unblock private photos');
INSERT INTO `site_lang` VALUES ('141', '1', 'Account type');
INSERT INTO `site_lang` VALUES ('142', '1', 'Current credits');
INSERT INTO `site_lang` VALUES ('143', '1', 'Add credits');
INSERT INTO `site_lang` VALUES ('144', '1', 'Upgrade to premium account');
INSERT INTO `site_lang` VALUES ('145', '1', 'Change password');
INSERT INTO `site_lang` VALUES ('146', '1', 'You can change your current password bellow');
INSERT INTO `site_lang` VALUES ('147', '1', 'New password');
INSERT INTO `site_lang` VALUES ('148', '1', 'Profile desactivation');
INSERT INTO `site_lang` VALUES ('149', '1', 'After delete your profile, some of your data will be lost without recovery.');
INSERT INTO `site_lang` VALUES ('150', '1', 'Delete profile');
INSERT INTO `site_lang` VALUES ('152', '1', 'Verified');
INSERT INTO `site_lang` VALUES ('151', '1', 'Online now');
INSERT INTO `site_lang` VALUES ('153', '1', 'Nothing found');
INSERT INTO `site_lang` VALUES ('154', '1', 'people found');
INSERT INTO `site_lang` VALUES ('155', '1', 'No popular users near you');
INSERT INTO `site_lang` VALUES ('156', '1', 'You dont have any fans yet');
INSERT INTO `site_lang` VALUES ('157', '1', 'You dont have matches yet');
INSERT INTO `site_lang` VALUES ('158', '1', 'January');
INSERT INTO `site_lang` VALUES ('159', '1', 'February');
INSERT INTO `site_lang` VALUES ('160', '1', 'March');
INSERT INTO `site_lang` VALUES ('161', '1', 'April');
INSERT INTO `site_lang` VALUES ('162', '1', 'May');
INSERT INTO `site_lang` VALUES ('163', '1', 'June');
INSERT INTO `site_lang` VALUES ('164', '1', 'July');
INSERT INTO `site_lang` VALUES ('165', '1', 'August');
INSERT INTO `site_lang` VALUES ('166', '1', 'September');
INSERT INTO `site_lang` VALUES ('167', '1', 'October');
INSERT INTO `site_lang` VALUES ('168', '1', 'November');
INSERT INTO `site_lang` VALUES ('169', '1', 'December');
INSERT INTO `site_lang` VALUES ('170', '1', 'Buy');
INSERT INTO `site_lang` VALUES ('171', '1', 'Days Premium');
INSERT INTO `site_lang` VALUES ('172', '1', 'persons more like this');
INSERT INTO `site_lang` VALUES ('173', '1', 'like this');
INSERT INTO `site_lang` VALUES ('174', '1', 'Hello, can i have access to your private photos ?');
INSERT INTO `site_lang` VALUES ('175', '1', 'Yes');
INSERT INTO `site_lang` VALUES ('176', '1', 'No');
INSERT INTO `site_lang` VALUES ('177', '1', 'Hi');
INSERT INTO `site_lang` VALUES ('178', '1', 'If you dont remember your password, click the link below to set a new one:');
INSERT INTO `site_lang` VALUES ('179', '1', 'Login to my account');
INSERT INTO `site_lang` VALUES ('180', '1', 'Password recover');
INSERT INTO `site_lang` VALUES ('181', '1', 'Invalid email format');
INSERT INTO `site_lang` VALUES ('182', '1', 'Please fill all the inputs');
INSERT INTO `site_lang` VALUES ('183', '1', 'Email dont exist');
INSERT INTO `site_lang` VALUES ('184', '1', 'Wrong password');
INSERT INTO `site_lang` VALUES ('185', '1', 'Add a valid date');
INSERT INTO `site_lang` VALUES ('186', '1', 'Choose city from the autocomplete');
INSERT INTO `site_lang` VALUES ('187', '1', 'Password too short');
INSERT INTO `site_lang` VALUES ('188', '1', 'Email already exist, try another');
INSERT INTO `site_lang` VALUES ('189', '1', 'Yes, you can see my private photos');
INSERT INTO `site_lang` VALUES ('190', '1', 'No, i cant show you my private photos');
INSERT INTO `site_lang` VALUES ('191', '1', 'Buy private photos permission');
INSERT INTO `site_lang` VALUES ('192', '1', 'Get access to');
INSERT INTO `site_lang` VALUES ('193', '1', 'private photos for ');
INSERT INTO `site_lang` VALUES ('194', '1', 'Get access');
INSERT INTO `site_lang` VALUES ('195', '1', 'No thanks');
INSERT INTO `site_lang` VALUES ('196', '1', 'Please, select a payment method');
INSERT INTO `site_lang` VALUES ('197', '1', 'Please, select 1 photo');
INSERT INTO `site_lang` VALUES ('198', '1', 'Please, select 1 gift');
INSERT INTO `site_lang` VALUES ('199', '1', 'You dont have enought credits for send the gift');
INSERT INTO `site_lang` VALUES ('200', '1', 'Expand daily limitation ');
INSERT INTO `site_lang` VALUES ('201', '1', 'more daily conversation, cost ');
INSERT INTO `site_lang` VALUES ('202', '1', 'Yes, buy it!');
INSERT INTO `site_lang` VALUES ('203', '1', 'Information updated successfully');
INSERT INTO `site_lang` VALUES ('204', '1', 'Account termination');
INSERT INTO `site_lang` VALUES ('205', '1', 'Your data will be lost without recovery, continue?');
INSERT INTO `site_lang` VALUES ('206', '1', 'Yes, delete it!');
INSERT INTO `site_lang` VALUES ('207', '1', 'is in another videocall , you cant call now');
INSERT INTO `site_lang` VALUES ('208', '1', 'is offline, try again when your friend is online');
INSERT INTO `site_lang` VALUES ('209', '1', 'Please allow access to your Webcam.');
INSERT INTO `site_lang` VALUES ('210', '1', 'You are already in a videocall, you have to end the other call before start another');
INSERT INTO `site_lang` VALUES ('211', '1', 'Only premium users can make videocalls');
INSERT INTO `site_lang` VALUES ('212', '1', 'Impossible to make a call!');
INSERT INTO `site_lang` VALUES ('213', '1', 'You cant make videocall because you dont have webcam');
INSERT INTO `site_lang` VALUES ('214', '1', 'Too long wait');
INSERT INTO `site_lang` VALUES ('215', '1', 'Seems that your friend do not have webcam or he is not available');
INSERT INTO `site_lang` VALUES ('216', '1', 'End call');
INSERT INTO `site_lang` VALUES ('217', '1', 'Wait more');
INSERT INTO `site_lang` VALUES ('207', '35', 'is in another videocall , you cant call now');
INSERT INTO `site_lang` VALUES ('206', '35', 'Yes, delete it!');
INSERT INTO `site_lang` VALUES ('204', '35', 'Account termination');
INSERT INTO `site_lang` VALUES ('205', '35', 'Your data will be lost without recovery, continue?');
INSERT INTO `site_lang` VALUES ('203', '35', 'Information updated successfully');
INSERT INTO `site_lang` VALUES ('202', '35', 'Yes, buy it!');
INSERT INTO `site_lang` VALUES ('201', '35', 'more daily conversation, cost ');
INSERT INTO `site_lang` VALUES ('200', '35', 'Expand daily limitation ');
INSERT INTO `site_lang` VALUES ('199', '35', 'You dont have enought credits for send the gift');
INSERT INTO `site_lang` VALUES ('198', '35', 'Please, select 1 gift');
INSERT INTO `site_lang` VALUES ('196', '35', 'Please, select a payment method');
INSERT INTO `site_lang` VALUES ('197', '35', 'Please, select 1 photo');
INSERT INTO `site_lang` VALUES ('187', '35', 'Password too short');
INSERT INTO `site_lang` VALUES ('194', '35', 'Get access');
INSERT INTO `site_lang` VALUES ('195', '35', 'No thanks');
INSERT INTO `site_lang` VALUES ('193', '35', 'private photos for ');
INSERT INTO `site_lang` VALUES ('192', '35', 'Get access to');
INSERT INTO `site_lang` VALUES ('191', '35', 'Buy private photos permission');
INSERT INTO `site_lang` VALUES ('190', '35', 'No, i cant show you my private photos');
INSERT INTO `site_lang` VALUES ('189', '35', 'Yes, you can see my private photos');
INSERT INTO `site_lang` VALUES ('188', '35', 'Email already exist, try another');
INSERT INTO `site_lang` VALUES ('186', '35', 'Choose city from the autocomplete');
INSERT INTO `site_lang` VALUES ('185', '35', 'Add a valid date');
INSERT INTO `site_lang` VALUES ('184', '35', 'Wrong password');
INSERT INTO `site_lang` VALUES ('183', '35', 'Email dont exist');
INSERT INTO `site_lang` VALUES ('182', '35', 'Please fill all the inputs');
INSERT INTO `site_lang` VALUES ('181', '35', 'Invalid email format');
INSERT INTO `site_lang` VALUES ('180', '35', 'Password recover');
INSERT INTO `site_lang` VALUES ('179', '35', 'Login to my account');
INSERT INTO `site_lang` VALUES ('178', '35', 'If you dont remember your password, click the link below to set a new one:');
INSERT INTO `site_lang` VALUES ('177', '35', 'Hi');
INSERT INTO `site_lang` VALUES ('176', '35', 'No');
INSERT INTO `site_lang` VALUES ('175', '35', 'Yes');
INSERT INTO `site_lang` VALUES ('174', '35', 'Hello, can i have access to your private photos ?');
INSERT INTO `site_lang` VALUES ('173', '35', 'like this');
INSERT INTO `site_lang` VALUES ('172', '35', 'persons more like this');
INSERT INTO `site_lang` VALUES ('171', '35', 'Days Premium');
INSERT INTO `site_lang` VALUES ('170', '35', 'Buy');
INSERT INTO `site_lang` VALUES ('167', '35', 'October');
INSERT INTO `site_lang` VALUES ('168', '35', 'November');
INSERT INTO `site_lang` VALUES ('169', '35', 'December');
INSERT INTO `site_lang` VALUES ('158', '35', 'January');
INSERT INTO `site_lang` VALUES ('159', '35', 'February');
INSERT INTO `site_lang` VALUES ('160', '35', 'March');
INSERT INTO `site_lang` VALUES ('161', '35', 'April');
INSERT INTO `site_lang` VALUES ('162', '35', 'May');
INSERT INTO `site_lang` VALUES ('163', '35', 'June');
INSERT INTO `site_lang` VALUES ('164', '35', 'July');
INSERT INTO `site_lang` VALUES ('165', '35', 'August');
INSERT INTO `site_lang` VALUES ('166', '35', 'September');
INSERT INTO `site_lang` VALUES ('157', '35', 'You dont have matches yet');
INSERT INTO `site_lang` VALUES ('156', '35', 'You dont have any fans yet');
INSERT INTO `site_lang` VALUES ('155', '35', 'No popular users near you');
INSERT INTO `site_lang` VALUES ('154', '35', 'people found');
INSERT INTO `site_lang` VALUES ('152', '35', 'Verified');
INSERT INTO `site_lang` VALUES ('153', '35', 'Nothing found');
INSERT INTO `site_lang` VALUES ('151', '35', 'Online now');
INSERT INTO `site_lang` VALUES ('150', '35', 'Delete profile');
INSERT INTO `site_lang` VALUES ('149', '35', 'After delete your profile, some of your data will be lost without recovery.');
INSERT INTO `site_lang` VALUES ('148', '35', 'Profile desactivation');
INSERT INTO `site_lang` VALUES ('147', '35', 'New password');
INSERT INTO `site_lang` VALUES ('146', '35', 'You can change your current password bellow');
INSERT INTO `site_lang` VALUES ('141', '35', 'Account type');
INSERT INTO `site_lang` VALUES ('142', '35', 'Current credits');
INSERT INTO `site_lang` VALUES ('143', '35', 'Add credits');
INSERT INTO `site_lang` VALUES ('144', '35', 'Upgrade to premium account');
INSERT INTO `site_lang` VALUES ('145', '35', 'Change password');
INSERT INTO `site_lang` VALUES ('140', '35', 'Buy credits for send Gifs and Unblock private photos');
INSERT INTO `site_lang` VALUES ('139', '35', 'You are account is already verified');
INSERT INTO `site_lang` VALUES ('138', '35', 'Connect with Facebook');
INSERT INTO `site_lang` VALUES ('137', '35', 'For verify your account , connect with your facebook account');
INSERT INTO `site_lang` VALUES ('136', '35', 'Verify account');
INSERT INTO `site_lang` VALUES ('135', '35', 'Update profile');
INSERT INTO `site_lang` VALUES ('134', '35', 'Site language');
INSERT INTO `site_lang` VALUES ('133', '35', 'You can edit your profile information bellow');
INSERT INTO `site_lang` VALUES ('132', '35', 'Personal information');
INSERT INTO `site_lang` VALUES ('131', '35', 'Delete');
INSERT INTO `site_lang` VALUES ('130', '35', 'Change password');
INSERT INTO `site_lang` VALUES ('129', '35', 'Verify');
INSERT INTO `site_lang` VALUES ('128', '35', 'Credits');
INSERT INTO `site_lang` VALUES ('127', '35', 'Personal');
INSERT INTO `site_lang` VALUES ('126', '35', 'Unblock private photos');
INSERT INTO `site_lang` VALUES ('125', '35', 'Ask permission to');
INSERT INTO `site_lang` VALUES ('124', '35', 'Now you have');
INSERT INTO `site_lang` VALUES ('123', '35', 'Credits successfully added to your account');
INSERT INTO `site_lang` VALUES ('122', '35', 'boys and girls');
INSERT INTO `site_lang` VALUES ('121', '35', 'Only girls');
INSERT INTO `site_lang` VALUES ('120', '35', 'Only boys');
INSERT INTO `site_lang` VALUES ('119', '35', 'years old');
INSERT INTO `site_lang` VALUES ('118', '35', 'Personal info');
INSERT INTO `site_lang` VALUES ('117', '35', 'About ');
INSERT INTO `site_lang` VALUES ('116', '35', 'Most popular users');
INSERT INTO `site_lang` VALUES ('115', '35', 'World');
INSERT INTO `site_lang` VALUES ('114', '35', 'in a radius of');
INSERT INTO `site_lang` VALUES ('113', '35', 'who are between');
INSERT INTO `site_lang` VALUES ('112', '35', 'Both');
INSERT INTO `site_lang` VALUES ('111', '35', 'Boys');
INSERT INTO `site_lang` VALUES ('110', '35', 'Girls');
INSERT INTO `site_lang` VALUES ('109', '35', 'Show me');
INSERT INTO `site_lang` VALUES ('108', '35', 'Online now');
INSERT INTO `site_lang` VALUES ('107', '35', 'All users');
INSERT INTO `site_lang` VALUES ('106', '35', 'Filter Search');
INSERT INTO `site_lang` VALUES ('105', '35', 'Your matches');
INSERT INTO `site_lang` VALUES ('104', '35', 'Please complete your profile before start in ');
INSERT INTO `site_lang` VALUES ('103', '35', 'Terms of Use');
INSERT INTO `site_lang` VALUES ('102', '35', 'Privacy Policy');
INSERT INTO `site_lang` VALUES ('101', '35', 'Your fans');
INSERT INTO `site_lang` VALUES ('100', '35', 'or wait until tomorrow for continue meeting people');
INSERT INTO `site_lang` VALUES ('99', '35', 'daily conversations');
INSERT INTO `site_lang` VALUES ('98', '35', 'and get up to');
INSERT INTO `site_lang` VALUES ('94', '35', 'Buy');
INSERT INTO `site_lang` VALUES ('95', '35', 'more daily conversation');
INSERT INTO `site_lang` VALUES ('96', '35', 'or');
INSERT INTO `site_lang` VALUES ('97', '35', 'Upgrade your account to Premium');
INSERT INTO `site_lang` VALUES ('93', '35', 'To continue chatting');
INSERT INTO `site_lang` VALUES ('89', '35', 'Write text here');
INSERT INTO `site_lang` VALUES ('90', '35', 'Send');
INSERT INTO `site_lang` VALUES ('91', '35', 'Chat');
INSERT INTO `site_lang` VALUES ('92', '35', 'you have reached the limit of new daily conversations');
INSERT INTO `site_lang` VALUES ('88', '35', 'Premium user badge');
INSERT INTO `site_lang` VALUES ('87', '35', 'Unblock all private photos');
INSERT INTO `site_lang` VALUES ('83', '35', 'Buy credits');
INSERT INTO `site_lang` VALUES ('84', '35', 'Premium Account Features');
INSERT INTO `site_lang` VALUES ('85', '35', 'new chats per day');
INSERT INTO `site_lang` VALUES ('86', '35', 'Unlimited videocalls');
INSERT INTO `site_lang` VALUES ('82', '35', 'Pay with');
INSERT INTO `site_lang` VALUES ('80', '35', 'Select payment method');
INSERT INTO `site_lang` VALUES ('81', '35', 'Pay with');
INSERT INTO `site_lang` VALUES ('79', '35', 'Select credits package');
INSERT INTO `site_lang` VALUES ('78', '35', 'Buy credits / Upgrade account');
INSERT INTO `site_lang` VALUES ('77', '35', 'Send gift');
INSERT INTO `site_lang` VALUES ('76', '35', 'Pick the gift you want to send to ');
INSERT INTO `site_lang` VALUES ('75', '35', 'Send gift to ');
INSERT INTO `site_lang` VALUES ('74', '35', 'Add photo');
INSERT INTO `site_lang` VALUES ('73', '35', 'Credits');
INSERT INTO `site_lang` VALUES ('64', '35', 'Contact');
INSERT INTO `site_lang` VALUES ('65', '35', 'Manage your photos');
INSERT INTO `site_lang` VALUES ('66', '35', 'All Photos');
INSERT INTO `site_lang` VALUES ('67', '35', 'Public Photos');
INSERT INTO `site_lang` VALUES ('68', '35', 'Private Photos');
INSERT INTO `site_lang` VALUES ('69', '35', 'Add your photos');
INSERT INTO `site_lang` VALUES ('70', '35', 'add photos');
INSERT INTO `site_lang` VALUES ('71', '35', 'Add yourself to the Spotlight');
INSERT INTO `site_lang` VALUES ('72', '35', 'Pick the photo you want to show in the Spotlight, cost ');
INSERT INTO `site_lang` VALUES ('63', '35', 'Privacy');
INSERT INTO `site_lang` VALUES ('62', '35', 'Terms');
INSERT INTO `site_lang` VALUES ('61', '35', 'Who to like');
INSERT INTO `site_lang` VALUES ('60', '35', 'New messages');
INSERT INTO `site_lang` VALUES ('59', '35', 'Online now');
INSERT INTO `site_lang` VALUES ('58', '35', 'Conversations');
INSERT INTO `site_lang` VALUES ('57', '35', 'Fans');
INSERT INTO `site_lang` VALUES ('56', '35', 'All');
INSERT INTO `site_lang` VALUES ('55', '35', 'Settings');
INSERT INTO `site_lang` VALUES ('54', '35', 'Manage photos');
INSERT INTO `site_lang` VALUES ('53', '35', 'Fans');
INSERT INTO `site_lang` VALUES ('51', '35', 'Matches');
INSERT INTO `site_lang` VALUES ('52', '35', 'Most populars');
INSERT INTO `site_lang` VALUES ('50', '35', 'Discover');
INSERT INTO `site_lang` VALUES ('49', '35', 'Meet new people');
INSERT INTO `site_lang` VALUES ('48', '35', 'Logout');
INSERT INTO `site_lang` VALUES ('47', '35', 'Settings');
INSERT INTO `site_lang` VALUES ('46', '35', 'Profile');
INSERT INTO `site_lang` VALUES ('45', '35', 'Privacy Policy');
INSERT INTO `site_lang` VALUES ('44', '35', 'and');
INSERT INTO `site_lang` VALUES ('43', '35', 'Terms and Conditions');
INSERT INTO `site_lang` VALUES ('42', '35', 'By continuing, you are confirming that you have read and agree to our');
INSERT INTO `site_lang` VALUES ('41', '35', 'Sign up');
INSERT INTO `site_lang` VALUES ('40', '35', 'Meet boys and girls');
INSERT INTO `site_lang` VALUES ('39', '35', 'Meet boys');
INSERT INTO `site_lang` VALUES ('38', '35', 'Meet girls');
INSERT INTO `site_lang` VALUES ('37', '35', 'Im here to');
INSERT INTO `site_lang` VALUES ('36', '35', 'Female');
INSERT INTO `site_lang` VALUES ('35', '35', 'Male');
INSERT INTO `site_lang` VALUES ('34', '35', 'Gender');
INSERT INTO `site_lang` VALUES ('33', '35', 'Where do you live?');
INSERT INTO `site_lang` VALUES ('32', '35', 'City');
INSERT INTO `site_lang` VALUES ('26', '35', 'Name');
INSERT INTO `site_lang` VALUES ('27', '35', 'Your name or nickname');
INSERT INTO `site_lang` VALUES ('28', '35', 'Email');
INSERT INTO `site_lang` VALUES ('29', '35', 'Password');
INSERT INTO `site_lang` VALUES ('30', '35', 'Birthday');
INSERT INTO `site_lang` VALUES ('31', '35', 'Please select');
INSERT INTO `site_lang` VALUES ('25', '35', 'Join the worlds bestest community for meeting new people!.');
INSERT INTO `site_lang` VALUES ('24', '35', 'Become a member now');
INSERT INTO `site_lang` VALUES ('23', '35', 'Play our popular Discover game and get matched with other users. Its a great way to break the ice and chat to new people.');
INSERT INTO `site_lang` VALUES ('22', '35', 'Matches');
INSERT INTO `site_lang` VALUES ('18', '35', 'Video Chat');
INSERT INTO `site_lang` VALUES ('19', '35', 'You can make quality videocalls for free to anyone, without limits of call duration, just enjoy seeing the person who is chatting with you');
INSERT INTO `site_lang` VALUES ('21', '35', 'We wont show your exact location, but you will be able to find people nearby who like the same things you do.');
INSERT INTO `site_lang` VALUES ('20', '35', 'People nearby');
INSERT INTO `site_lang` VALUES ('17', '35', 'Powerfull private chat for meet new friends, you can send emoticons and private photos to anyone.');
INSERT INTO `site_lang` VALUES ('15', '35', 'Recover password');
INSERT INTO `site_lang` VALUES ('16', '35', 'Chat');
INSERT INTO `site_lang` VALUES ('14', '35', 'Password recover');
INSERT INTO `site_lang` VALUES ('13', '35', 'Login now');
INSERT INTO `site_lang` VALUES ('12', '35', 'do you forget your password?');
INSERT INTO `site_lang` VALUES ('11', '35', 'Your password');
INSERT INTO `site_lang` VALUES ('10', '35', 'Your email');
INSERT INTO `site_lang` VALUES ('9', '35', 'Welcome back');
INSERT INTO `site_lang` VALUES ('7', '35', 'Connect with ');
INSERT INTO `site_lang` VALUES ('8', '35', 'Create your account');
INSERT INTO `site_lang` VALUES ('6', '35', 'SOON AVAILABLE');
INSERT INTO `site_lang` VALUES ('5', '35', 'Soon we will have our phone apps online');
INSERT INTO `site_lang` VALUES ('4', '35', 'Please visit us from your laptop or PC');
INSERT INTO `site_lang` VALUES ('3', '35', 'For now our site works only for Desktop users');
INSERT INTO `site_lang` VALUES ('2', '35', 'Welcome to the fastest growing place to meet new people');
INSERT INTO `site_lang` VALUES ('1', '35', 'Login');
INSERT INTO `site_lang` VALUES ('0', '35', 'meet new people!');
INSERT INTO `site_lang` VALUES ('384', '34', 'Ok, i understand');
INSERT INTO `site_lang` VALUES ('383', '34', 'must like you for start a videocall');
INSERT INTO `site_lang` VALUES ('382', '34', 'dont like you');
INSERT INTO `site_lang` VALUES ('381', '34', 'calling...');
INSERT INTO `site_lang` VALUES ('380', '34', 'Welcome to');
INSERT INTO `site_lang` VALUES ('379', '34', 'Go to');
INSERT INTO `site_lang` VALUES ('378', '34', 'Please save your connection information in a safe place');
INSERT INTO `site_lang` VALUES ('377', '34', 'Password');
INSERT INTO `site_lang` VALUES ('376', '34', 'E-mail');
INSERT INTO `site_lang` VALUES ('375', '34', 'Here are your connection details');
INSERT INTO `site_lang` VALUES ('374', '34', 'Start meeting new people now');
INSERT INTO `site_lang` VALUES ('373', '34', 'More than 1 million people have joined $site_name You probably want to know some of them.');
INSERT INTO `site_lang` VALUES ('372', '34', 'Add photos and complete your profile');
INSERT INTO `site_lang` VALUES ('371', '34', 'Nobody is going to fall in love with a blank page. The more information you get, the more chances to find that special someone!');
INSERT INTO `site_lang` VALUES ('370', '34', 'Meet new people');
INSERT INTO `site_lang` VALUES ('369', '34', 'you can meet people instantly');
INSERT INTO `site_lang` VALUES ('368', '34', 'In');
INSERT INTO `site_lang` VALUES ('366', '34', 'Newsflash');
INSERT INTO `site_lang` VALUES ('367', '34', 'people in your area wants to know you');
INSERT INTO `site_lang` VALUES ('364', '34', 'Now you are a new member of');
INSERT INTO `site_lang` VALUES ('365', '34', 'Verify your account');
INSERT INTO `site_lang` VALUES ('363', '34', 'Here are a few tips');
INSERT INTO `site_lang` VALUES ('361', '34', 'Welcome');
INSERT INTO `site_lang` VALUES ('362', '34', 'Well done, now you are in');
INSERT INTO `site_lang` VALUES ('360', '34', 'Check out the profile');
INSERT INTO `site_lang` VALUES ('359', '34', 'and lives closer to you');
INSERT INTO `site_lang` VALUES ('358', '34', 'is new at');
INSERT INTO `site_lang` VALUES ('357', '34', 'is new and lives closer to you');
INSERT INTO `site_lang` VALUES ('356', '34', 'Have fun!');
INSERT INTO `site_lang` VALUES ('355', '34', 'Respond to');
INSERT INTO `site_lang` VALUES ('354', '34', 'you have a new message from');
INSERT INTO `site_lang` VALUES ('353', '34', 'New message from');
INSERT INTO `site_lang` VALUES ('352', '34', 'Go and say something to');
INSERT INTO `site_lang` VALUES ('351', '34', 'thinks the feeling is mutual');
INSERT INTO `site_lang` VALUES ('350', '34', 'Its a match!');
INSERT INTO `site_lang` VALUES ('349', '34', 'You have a match at');
INSERT INTO `site_lang` VALUES ('348', '34', 'if you forgot your password, click on the link below to get a new');
INSERT INTO `site_lang` VALUES ('347', '34', 'Choose a new password');
INSERT INTO `site_lang` VALUES ('346', '34', 'Unsubscribe');
INSERT INTO `site_lang` VALUES ('345', '34', 'You received this notice because you registered as');
INSERT INTO `site_lang` VALUES ('344', '34', 'Find out if you also like');
INSERT INTO `site_lang` VALUES ('343', '34', 'has seen you in discover and likes. The feeling is mutual?');
INSERT INTO `site_lang` VALUES ('342', '34', 'likes you and wants to chat in');
INSERT INTO `site_lang` VALUES ('341', '34', 'We sent you a email with your info, it may take up to 1 min to arrive');
INSERT INTO `site_lang` VALUES ('340', '34', 'Loading...');
INSERT INTO `site_lang` VALUES ('339', '34', 'of');
INSERT INTO `site_lang` VALUES ('338', '34', 'Photos of ');
INSERT INTO `site_lang` VALUES ('337', '34', 'is calling you..');
INSERT INTO `site_lang` VALUES ('336', '34', 'Password successfully changed');
INSERT INTO `site_lang` VALUES ('335', '34', 'Service cost');
INSERT INTO `site_lang` VALUES ('334', '34', 'Spotlight');
INSERT INTO `site_lang` VALUES ('333', '34', 'Wrong');
INSERT INTO `site_lang` VALUES ('332', '34', 'days of Premium');
INSERT INTO `site_lang` VALUES ('331', '34', 'username');
INSERT INTO `site_lang` VALUES ('330', '34', 'You need to write your username!');
INSERT INTO `site_lang` VALUES ('329', '34', 'Write your instagram username');
INSERT INTO `site_lang` VALUES ('328', '34', 'Press backspace key for smart return to the meeting section.');
INSERT INTO `site_lang` VALUES ('327', '34', 'Are you sure you want to report');
INSERT INTO `site_lang` VALUES ('326', '34', 'Report and block');
INSERT INTO `site_lang` VALUES ('325', '34', 'is blocking you or you blocked him, you cant chat with him sorry');
INSERT INTO `site_lang` VALUES ('324', '34', 'We sended you a email for verify your account');
INSERT INTO `site_lang` VALUES ('315', '34', 'days');
INSERT INTO `site_lang` VALUES ('316', '34', 'hours');
INSERT INTO `site_lang` VALUES ('317', '34', 'minutes');
INSERT INTO `site_lang` VALUES ('318', '34', 'seconds');
INSERT INTO `site_lang` VALUES ('319', '34', 'ago');
INSERT INTO `site_lang` VALUES ('320', '34', 'Please verify your account, check your email');
INSERT INTO `site_lang` VALUES ('321', '34', 'Please add a profile photo');
INSERT INTO `site_lang` VALUES ('322', '34', 'Hi, im');
INSERT INTO `site_lang` VALUES ('323', '34', 'years old and im from');
INSERT INTO `site_lang` VALUES ('297', '34', 'Messages');
INSERT INTO `site_lang` VALUES ('298', '34', 'Like');
INSERT INTO `site_lang` VALUES ('299', '34', 'Dislike');
INSERT INTO `site_lang` VALUES ('300', '34', 'AGE');
INSERT INTO `site_lang` VALUES ('301', '34', 'You dont have any visit yet');
INSERT INTO `site_lang` VALUES ('302', '34', 'visited');
INSERT INTO `site_lang` VALUES ('303', '34', 'You do not like anyone');
INSERT INTO `site_lang` VALUES ('304', '34', 'Cost');
INSERT INTO `site_lang` VALUES ('305', '34', 'Credits for $');
INSERT INTO `site_lang` VALUES ('306', '34', '0 seconds');
INSERT INTO `site_lang` VALUES ('307', '34', 'year');
INSERT INTO `site_lang` VALUES ('308', '34', 'month');
INSERT INTO `site_lang` VALUES ('309', '34', 'day');
INSERT INTO `site_lang` VALUES ('310', '34', 'hour');
INSERT INTO `site_lang` VALUES ('311', '34', 'minute');
INSERT INTO `site_lang` VALUES ('312', '34', 'second');
INSERT INTO `site_lang` VALUES ('313', '34', 'years');
INSERT INTO `site_lang` VALUES ('314', '34', 'months');
INSERT INTO `site_lang` VALUES ('295', '34', 'People i like');
INSERT INTO `site_lang` VALUES ('296', '34', 'people liked you, for see them');
INSERT INTO `site_lang` VALUES ('294', '34', 'Upgrade your account to premium');
INSERT INTO `site_lang` VALUES ('293', '34', 'people visited your profile for see them');
INSERT INTO `site_lang` VALUES ('292', '34', 'Delete');
INSERT INTO `site_lang` VALUES ('291', '34', 'Public photo');
INSERT INTO `site_lang` VALUES ('290', '34', 'Private photo');
INSERT INTO `site_lang` VALUES ('289', '34', 'Set as profile');
INSERT INTO `site_lang` VALUES ('288', '34', 'get seen by millions');
INSERT INTO `site_lang` VALUES ('287', '34', 'Add me here');
INSERT INTO `site_lang` VALUES ('286', '34', 'Visits');
INSERT INTO `site_lang` VALUES ('285', '34', 'Credits');
INSERT INTO `site_lang` VALUES ('284', '34', 'Photos');
INSERT INTO `site_lang` VALUES ('283', '34', 'Add');
INSERT INTO `site_lang` VALUES ('282', '34', 'Add from ');
INSERT INTO `site_lang` VALUES ('281', '34', 'Private photos');
INSERT INTO `site_lang` VALUES ('279', '34', 'No data');
INSERT INTO `site_lang` VALUES ('280', '34', 'Public Photos');
INSERT INTO `site_lang` VALUES ('277', '34', 'Report');
INSERT INTO `site_lang` VALUES ('278', '34', 'Fans');
INSERT INTO `site_lang` VALUES ('276', '34', 'Interests');
INSERT INTO `site_lang` VALUES ('275', '34', 'Please wait');
INSERT INTO `site_lang` VALUES ('273', '34', 'Month');
INSERT INTO `site_lang` VALUES ('274', '34', 'Year');
INSERT INTO `site_lang` VALUES ('272', '34', 'Day');
INSERT INTO `site_lang` VALUES ('271', '34', 'When someone send me a message');
INSERT INTO `site_lang` VALUES ('270', '34', 'When new users near me join in');
INSERT INTO `site_lang` VALUES ('269', '34', 'When i get a match');
INSERT INTO `site_lang` VALUES ('268', '34', 'When someone likes me');
INSERT INTO `site_lang` VALUES ('267', '34', 'None');
INSERT INTO `site_lang` VALUES ('266', '34', 'I own a motorbike');
INSERT INTO `site_lang` VALUES ('265', '34', 'I own a car');
INSERT INTO `site_lang` VALUES ('264', '34', 'Parents car');
INSERT INTO `site_lang` VALUES ('263', '34', 'Transport');
INSERT INTO `site_lang` VALUES ('262', '34', 'Drink');
INSERT INTO `site_lang` VALUES ('260', '34', 'No');
INSERT INTO `site_lang` VALUES ('261', '34', 'Sometimes');
INSERT INTO `site_lang` VALUES ('259', '34', 'Yes');
INSERT INTO `site_lang` VALUES ('258', '34', 'Smoke');
INSERT INTO `site_lang` VALUES ('257', '34', 'Alone');
INSERT INTO `site_lang` VALUES ('256', '34', 'With partner');
INSERT INTO `site_lang` VALUES ('255', '34', 'Student dormitory');
INSERT INTO `site_lang` VALUES ('254', '34', 'With housemate');
INSERT INTO `site_lang` VALUES ('253', '34', 'With parents');
INSERT INTO `site_lang` VALUES ('252', '34', 'Living');
INSERT INTO `site_lang` VALUES ('251', '34', 'Curvy');
INSERT INTO `site_lang` VALUES ('249', '34', 'Athletic');
INSERT INTO `site_lang` VALUES ('250', '34', 'Heavy set');
INSERT INTO `site_lang` VALUES ('248', '34', 'Average');
INSERT INTO `site_lang` VALUES ('247', '34', 'Slim');
INSERT INTO `site_lang` VALUES ('246', '34', 'Body type');
INSERT INTO `site_lang` VALUES ('245', '34', 'Other');
INSERT INTO `site_lang` VALUES ('244', '34', 'Indian');
INSERT INTO `site_lang` VALUES ('243', '34', 'Pacific Islander');
INSERT INTO `site_lang` VALUES ('242', '34', 'Hispanic/latin');
INSERT INTO `site_lang` VALUES ('241', '34', 'Native American');
INSERT INTO `site_lang` VALUES ('239', '34', 'Black');
INSERT INTO `site_lang` VALUES ('240', '34', 'White');
INSERT INTO `site_lang` VALUES ('237', '34', 'Asian');
INSERT INTO `site_lang` VALUES ('238', '34', 'Middle Eastern');
INSERT INTO `site_lang` VALUES ('236', '34', 'Ethnicity');
INSERT INTO `site_lang` VALUES ('235', '34', 'Weight');
INSERT INTO `site_lang` VALUES ('234', '34', 'more than');
INSERT INTO `site_lang` VALUES ('233', '34', 'less than');
INSERT INTO `site_lang` VALUES ('232', '34', 'Height');
INSERT INTO `site_lang` VALUES ('231', '34', 'Bisexual');
INSERT INTO `site_lang` VALUES ('230', '34', 'Straight');
INSERT INTO `site_lang` VALUES ('229', '34', 'Open-minded');
INSERT INTO `site_lang` VALUES ('228', '34', 'Gay');
INSERT INTO `site_lang` VALUES ('226', '34', 'Open');
INSERT INTO `site_lang` VALUES ('227', '34', 'Sexuality');
INSERT INTO `site_lang` VALUES ('224', '34', 'Single');
INSERT INTO `site_lang` VALUES ('225', '34', 'Taken');
INSERT INTO `site_lang` VALUES ('223', '34', 'Relationship');
INSERT INTO `site_lang` VALUES ('222', '34', 'Extended info (optional)');
INSERT INTO `site_lang` VALUES ('221', '34', 'Notifications');
INSERT INTO `site_lang` VALUES ('220', '34', 'UPGRADE');
INSERT INTO `site_lang` VALUES ('219', '34', 'Basic');
INSERT INTO `site_lang` VALUES ('218', '34', 'until');
INSERT INTO `site_lang` VALUES ('217', '34', 'Wait more');
INSERT INTO `site_lang` VALUES ('216', '34', 'End call');
INSERT INTO `site_lang` VALUES ('215', '34', 'Seems that your friend do not have webcam or he is not available');
INSERT INTO `site_lang` VALUES ('214', '34', 'Too long wait');
INSERT INTO `site_lang` VALUES ('213', '34', 'You cant make videocall because you dont have webcam');
INSERT INTO `site_lang` VALUES ('212', '34', 'Impossible to make a call!');
INSERT INTO `site_lang` VALUES ('211', '34', 'Only premium users can make videocalls');
INSERT INTO `site_lang` VALUES ('210', '34', 'You are already in a videocall, you have to end the other call before start another');
INSERT INTO `site_lang` VALUES ('209', '34', 'Please allow access to your Webcam.');
INSERT INTO `site_lang` VALUES ('208', '34', 'is offline, try again when your friend is online');
INSERT INTO `site_lang` VALUES ('207', '34', 'is in another videocall , you cant call now');
INSERT INTO `site_lang` VALUES ('206', '34', 'Yes, delete it!');
INSERT INTO `site_lang` VALUES ('205', '34', 'Your data will be lost without recovery, continue?');
INSERT INTO `site_lang` VALUES ('204', '34', 'Account termination');
INSERT INTO `site_lang` VALUES ('203', '34', 'Information updated successfully');
INSERT INTO `site_lang` VALUES ('202', '34', 'Yes, buy it!');
INSERT INTO `site_lang` VALUES ('201', '34', 'more daily conversation, cost ');
INSERT INTO `site_lang` VALUES ('200', '34', 'Expand daily limitation ');
INSERT INTO `site_lang` VALUES ('199', '34', 'You dont have enought credits for send the gift');
INSERT INTO `site_lang` VALUES ('198', '34', 'Please, select 1 gift');
INSERT INTO `site_lang` VALUES ('197', '34', 'Please, select 1 photo');
INSERT INTO `site_lang` VALUES ('196', '34', 'Please, select a payment method');
INSERT INTO `site_lang` VALUES ('195', '34', 'No thanks');
INSERT INTO `site_lang` VALUES ('194', '34', 'Get access');
INSERT INTO `site_lang` VALUES ('193', '34', 'private photos for ');
INSERT INTO `site_lang` VALUES ('192', '34', 'Get access to');
INSERT INTO `site_lang` VALUES ('191', '34', 'Buy private photos permission');
INSERT INTO `site_lang` VALUES ('190', '34', 'No, i cant show you my private photos');
INSERT INTO `site_lang` VALUES ('189', '34', 'Yes, you can see my private photos');
INSERT INTO `site_lang` VALUES ('188', '34', 'Email already exist, try another');
INSERT INTO `site_lang` VALUES ('187', '34', 'Password too short');
INSERT INTO `site_lang` VALUES ('186', '34', 'Choose city from the autocomplete');
INSERT INTO `site_lang` VALUES ('185', '34', 'Add a valid date');
INSERT INTO `site_lang` VALUES ('184', '34', 'Wrong password');
INSERT INTO `site_lang` VALUES ('183', '34', 'Email dont exist');
INSERT INTO `site_lang` VALUES ('182', '34', 'Please fill all the inputs');
INSERT INTO `site_lang` VALUES ('181', '34', 'Invalid email format');
INSERT INTO `site_lang` VALUES ('180', '34', 'Password recover');
INSERT INTO `site_lang` VALUES ('179', '34', 'Login to my account');
INSERT INTO `site_lang` VALUES ('178', '34', 'If you dont remember your password, click the link below to set a new one:');
INSERT INTO `site_lang` VALUES ('177', '34', 'Hi');
INSERT INTO `site_lang` VALUES ('176', '34', 'No');
INSERT INTO `site_lang` VALUES ('175', '34', 'Yes');
INSERT INTO `site_lang` VALUES ('174', '34', 'Hello, can i have access to your private photos ?');
INSERT INTO `site_lang` VALUES ('173', '34', 'like this');
INSERT INTO `site_lang` VALUES ('172', '34', 'persons more like this');
INSERT INTO `site_lang` VALUES ('170', '34', 'Buy');
INSERT INTO `site_lang` VALUES ('171', '34', 'Days Premium');
INSERT INTO `site_lang` VALUES ('169', '34', 'December');
INSERT INTO `site_lang` VALUES ('166', '34', 'September');
INSERT INTO `site_lang` VALUES ('167', '34', 'October');
INSERT INTO `site_lang` VALUES ('168', '34', 'November');
INSERT INTO `site_lang` VALUES ('165', '34', 'August');
INSERT INTO `site_lang` VALUES ('163', '34', 'June');
INSERT INTO `site_lang` VALUES ('164', '34', 'July');
INSERT INTO `site_lang` VALUES ('161', '34', 'April');
INSERT INTO `site_lang` VALUES ('162', '34', 'May');
INSERT INTO `site_lang` VALUES ('156', '34', 'You dont have any fans yet');
INSERT INTO `site_lang` VALUES ('157', '34', 'You dont have matches yet');
INSERT INTO `site_lang` VALUES ('158', '34', 'January');
INSERT INTO `site_lang` VALUES ('159', '34', 'February');
INSERT INTO `site_lang` VALUES ('160', '34', 'March');
INSERT INTO `site_lang` VALUES ('155', '34', 'No popular users near you');
INSERT INTO `site_lang` VALUES ('153', '34', 'Nothing found');
INSERT INTO `site_lang` VALUES ('154', '34', 'people found');
INSERT INTO `site_lang` VALUES ('151', '34', 'Online now');
INSERT INTO `site_lang` VALUES ('152', '34', 'Verified');
INSERT INTO `site_lang` VALUES ('150', '34', 'Delete profile');
INSERT INTO `site_lang` VALUES ('149', '34', 'After delete your profile, some of your data will be lost without recovery.');
INSERT INTO `site_lang` VALUES ('148', '34', 'Profile desactivation');
INSERT INTO `site_lang` VALUES ('147', '34', 'New password');
INSERT INTO `site_lang` VALUES ('146', '34', 'You can change your current password bellow');
INSERT INTO `site_lang` VALUES ('145', '34', 'Change password');
INSERT INTO `site_lang` VALUES ('143', '34', 'Add credits');
INSERT INTO `site_lang` VALUES ('144', '34', 'Upgrade to premium account');
INSERT INTO `site_lang` VALUES ('142', '34', 'Current credits');
INSERT INTO `site_lang` VALUES ('141', '34', 'Account type');
INSERT INTO `site_lang` VALUES ('140', '34', 'Buy credits for send Gifs and Unblock private photos');
INSERT INTO `site_lang` VALUES ('139', '34', 'You are account is already verified');
INSERT INTO `site_lang` VALUES ('138', '34', 'Connect with Facebook');
INSERT INTO `site_lang` VALUES ('137', '34', 'For verify your account , connect with your facebook account');
INSERT INTO `site_lang` VALUES ('136', '34', 'Verify account');
INSERT INTO `site_lang` VALUES ('134', '34', 'Site language');
INSERT INTO `site_lang` VALUES ('135', '34', 'Update profile');
INSERT INTO `site_lang` VALUES ('131', '34', 'Delete');
INSERT INTO `site_lang` VALUES ('132', '34', 'Personal information');
INSERT INTO `site_lang` VALUES ('133', '34', 'You can edit your profile information bellow');
INSERT INTO `site_lang` VALUES ('130', '34', 'Change password');
INSERT INTO `site_lang` VALUES ('128', '34', 'Credits');
INSERT INTO `site_lang` VALUES ('129', '34', 'Verify');
INSERT INTO `site_lang` VALUES ('127', '34', 'Personal');
INSERT INTO `site_lang` VALUES ('126', '34', 'Unblock private photos');
INSERT INTO `site_lang` VALUES ('125', '34', 'Ask permission to');
INSERT INTO `site_lang` VALUES ('124', '34', 'Now you have');
INSERT INTO `site_lang` VALUES ('123', '34', 'Credits successfully added to your account');
INSERT INTO `site_lang` VALUES ('122', '34', 'boys and girls');
INSERT INTO `site_lang` VALUES ('121', '34', 'Only girls');
INSERT INTO `site_lang` VALUES ('119', '34', 'years old');
INSERT INTO `site_lang` VALUES ('120', '34', 'Only boys');
INSERT INTO `site_lang` VALUES ('118', '34', 'Personal info');
INSERT INTO `site_lang` VALUES ('117', '34', 'About ');
INSERT INTO `site_lang` VALUES ('116', '34', 'Most popular users');
INSERT INTO `site_lang` VALUES ('115', '34', 'World');
INSERT INTO `site_lang` VALUES ('114', '34', 'in a radius of');
INSERT INTO `site_lang` VALUES ('113', '34', 'who are between');
INSERT INTO `site_lang` VALUES ('112', '34', 'Both');
INSERT INTO `site_lang` VALUES ('111', '34', 'Boys');
INSERT INTO `site_lang` VALUES ('110', '34', 'Girls');
INSERT INTO `site_lang` VALUES ('109', '34', 'Show me');
INSERT INTO `site_lang` VALUES ('108', '34', 'Online now');
INSERT INTO `site_lang` VALUES ('107', '34', 'All users');
INSERT INTO `site_lang` VALUES ('106', '34', 'Filter Search');
INSERT INTO `site_lang` VALUES ('104', '34', 'Please complete your profile before start in ');
INSERT INTO `site_lang` VALUES ('105', '34', 'Your matches');
INSERT INTO `site_lang` VALUES ('103', '34', 'Terms of Use');
INSERT INTO `site_lang` VALUES ('102', '34', 'Privacy Policy');
INSERT INTO `site_lang` VALUES ('101', '34', 'Your fans');
INSERT INTO `site_lang` VALUES ('100', '34', 'or wait until tomorrow for continue meeting people');
INSERT INTO `site_lang` VALUES ('98', '34', 'and get up to');
INSERT INTO `site_lang` VALUES ('99', '34', 'daily conversations');
INSERT INTO `site_lang` VALUES ('96', '34', 'or');
INSERT INTO `site_lang` VALUES ('97', '34', 'Upgrade your account to Premium');
INSERT INTO `site_lang` VALUES ('95', '34', 'more daily conversation');
INSERT INTO `site_lang` VALUES ('94', '34', 'Buy');
INSERT INTO `site_lang` VALUES ('93', '34', 'To continue chatting');
INSERT INTO `site_lang` VALUES ('92', '34', 'you have reached the limit of new daily conversations');
INSERT INTO `site_lang` VALUES ('91', '34', 'Chat');
INSERT INTO `site_lang` VALUES ('90', '34', 'Send');
INSERT INTO `site_lang` VALUES ('89', '34', 'Write text here');
INSERT INTO `site_lang` VALUES ('88', '34', 'Premium user badge');
INSERT INTO `site_lang` VALUES ('87', '34', 'Unblock all private photos');
INSERT INTO `site_lang` VALUES ('85', '34', 'new chats per day');
INSERT INTO `site_lang` VALUES ('86', '34', 'Unlimited videocalls');
INSERT INTO `site_lang` VALUES ('81', '34', 'Pay with');
INSERT INTO `site_lang` VALUES ('82', '34', 'Pay with');
INSERT INTO `site_lang` VALUES ('83', '34', 'Buy credits');
INSERT INTO `site_lang` VALUES ('84', '34', 'Premium Account Features');
INSERT INTO `site_lang` VALUES ('80', '34', 'Select payment method');
INSERT INTO `site_lang` VALUES ('79', '34', 'Select credits package');
INSERT INTO `site_lang` VALUES ('77', '34', 'Send gift');
INSERT INTO `site_lang` VALUES ('78', '34', 'Buy credits / Upgrade account');
INSERT INTO `site_lang` VALUES ('76', '34', 'Pick the gift you want to send to ');
INSERT INTO `site_lang` VALUES ('75', '34', 'Send gift to ');
INSERT INTO `site_lang` VALUES ('74', '34', 'Add photo');
INSERT INTO `site_lang` VALUES ('73', '34', 'Credits');
INSERT INTO `site_lang` VALUES ('72', '34', 'Pick the photo you want to show in the Spotlight, cost ');
INSERT INTO `site_lang` VALUES ('71', '34', 'Add yourself to the Spotlight');
INSERT INTO `site_lang` VALUES ('69', '34', 'Add your photos');
INSERT INTO `site_lang` VALUES ('70', '34', 'add photos');
INSERT INTO `site_lang` VALUES ('68', '34', 'Private Photos');
INSERT INTO `site_lang` VALUES ('67', '34', 'Public Photos');
INSERT INTO `site_lang` VALUES ('66', '34', 'All Photos');
INSERT INTO `site_lang` VALUES ('65', '34', 'Manage your photos');
INSERT INTO `site_lang` VALUES ('64', '34', 'Contact');
INSERT INTO `site_lang` VALUES ('63', '34', 'Privacy');
INSERT INTO `site_lang` VALUES ('62', '34', 'Terms');
INSERT INTO `site_lang` VALUES ('61', '34', 'Who to like');
INSERT INTO `site_lang` VALUES ('60', '34', 'New messages');
INSERT INTO `site_lang` VALUES ('59', '34', 'Online now');
INSERT INTO `site_lang` VALUES ('58', '34', 'Conversations');
INSERT INTO `site_lang` VALUES ('57', '34', 'Fans');
INSERT INTO `site_lang` VALUES ('56', '34', 'All');
INSERT INTO `site_lang` VALUES ('55', '34', 'Settings');
INSERT INTO `site_lang` VALUES ('51', '34', 'Matches');
INSERT INTO `site_lang` VALUES ('52', '34', 'Most populars');
INSERT INTO `site_lang` VALUES ('53', '34', 'Fans');
INSERT INTO `site_lang` VALUES ('54', '34', 'Manage photos');
INSERT INTO `site_lang` VALUES ('45', '34', 'Privacy Policy');
INSERT INTO `site_lang` VALUES ('46', '34', 'Profile');
INSERT INTO `site_lang` VALUES ('47', '34', 'Settings');
INSERT INTO `site_lang` VALUES ('48', '34', 'Logout');
INSERT INTO `site_lang` VALUES ('49', '34', 'Meet new people');
INSERT INTO `site_lang` VALUES ('50', '34', 'Discover');
INSERT INTO `site_lang` VALUES ('44', '34', 'and');
INSERT INTO `site_lang` VALUES ('43', '34', 'Terms and Conditions');
INSERT INTO `site_lang` VALUES ('37', '34', 'Im here to');
INSERT INTO `site_lang` VALUES ('38', '34', 'Meet girls');
INSERT INTO `site_lang` VALUES ('39', '34', 'Meet boys');
INSERT INTO `site_lang` VALUES ('40', '34', 'Meet boys and girls');
INSERT INTO `site_lang` VALUES ('41', '34', 'Sign up');
INSERT INTO `site_lang` VALUES ('42', '34', 'By continuing, you are confirming that you have read and agree to our');
INSERT INTO `site_lang` VALUES ('36', '34', 'Female');
INSERT INTO `site_lang` VALUES ('35', '34', 'Male');
INSERT INTO `site_lang` VALUES ('34', '34', 'Gender');
INSERT INTO `site_lang` VALUES ('33', '34', 'Where do you live?');
INSERT INTO `site_lang` VALUES ('32', '34', 'City');
INSERT INTO `site_lang` VALUES ('31', '34', 'Please select');
INSERT INTO `site_lang` VALUES ('30', '34', 'Birthday');
INSERT INTO `site_lang` VALUES ('28', '34', 'Email');
INSERT INTO `site_lang` VALUES ('29', '34', 'Password');
INSERT INTO `site_lang` VALUES ('25', '34', 'Join the worlds bestest community for meeting new people!.');
INSERT INTO `site_lang` VALUES ('27', '34', 'Your name or nickname');
INSERT INTO `site_lang` VALUES ('26', '34', 'Name');
INSERT INTO `site_lang` VALUES ('24', '34', 'Become a member now');
INSERT INTO `site_lang` VALUES ('23', '34', 'Play our popular Discover game and get matched with other users. Its a great way to break the ice and chat to new people.');
INSERT INTO `site_lang` VALUES ('22', '34', 'Matches');
INSERT INTO `site_lang` VALUES ('20', '34', 'People nearby');
INSERT INTO `site_lang` VALUES ('21', '34', 'We wont show your exact location, but you will be able to find people nearby who like the same things you do.');
INSERT INTO `site_lang` VALUES ('19', '34', 'You can make quality videocalls for free to anyone, without limits of call duration, just enjoy seeing the person who is chatting with you');
INSERT INTO `site_lang` VALUES ('18', '34', 'Video Chat');
INSERT INTO `site_lang` VALUES ('17', '34', 'Powerfull private chat for meet new friends, you can send emoticons and private photos to anyone.');
INSERT INTO `site_lang` VALUES ('16', '34', 'Chat');
INSERT INTO `site_lang` VALUES ('15', '34', 'Recover password');
INSERT INTO `site_lang` VALUES ('14', '34', 'Password recover');
INSERT INTO `site_lang` VALUES ('13', '34', 'Login now');
INSERT INTO `site_lang` VALUES ('12', '34', 'do you forget your password?');
INSERT INTO `site_lang` VALUES ('11', '34', 'Your password');
INSERT INTO `site_lang` VALUES ('10', '34', 'Your email');
INSERT INTO `site_lang` VALUES ('9', '34', 'Welcome back');
INSERT INTO `site_lang` VALUES ('8', '34', 'Create your account');
INSERT INTO `site_lang` VALUES ('7', '34', 'Connect with ');
INSERT INTO `site_lang` VALUES ('6', '34', 'SOON AVAILABLE');
INSERT INTO `site_lang` VALUES ('5', '34', 'Soon we will have our phone apps online');
INSERT INTO `site_lang` VALUES ('4', '34', 'Please visit us from your laptop or PC');
INSERT INTO `site_lang` VALUES ('3', '34', 'For now our site works only for Desktop users');
INSERT INTO `site_lang` VALUES ('2', '34', 'Welcome to the fastest growing place to meet new people');
INSERT INTO `site_lang` VALUES ('1', '34', 'Login');
INSERT INTO `site_lang` VALUES ('0', '34', 'meet new people!');
INSERT INTO `site_lang` VALUES ('384', '33', 'Ok, i understand');
INSERT INTO `site_lang` VALUES ('383', '33', 'must like you for start a videocall');
INSERT INTO `site_lang` VALUES ('382', '33', 'dont like you');
INSERT INTO `site_lang` VALUES ('381', '33', 'calling...');
INSERT INTO `site_lang` VALUES ('380', '33', 'Welcome to');
INSERT INTO `site_lang` VALUES ('379', '33', 'Go to');
INSERT INTO `site_lang` VALUES ('378', '33', 'Please save your connection information in a safe place');
INSERT INTO `site_lang` VALUES ('376', '33', 'E-mail');
INSERT INTO `site_lang` VALUES ('377', '33', 'Password');
INSERT INTO `site_lang` VALUES ('375', '33', 'Here are your connection details');
INSERT INTO `site_lang` VALUES ('373', '33', 'More than 1 million people have joined $site_name You probably want to know some of them.');
INSERT INTO `site_lang` VALUES ('374', '33', 'Start meeting new people now');
INSERT INTO `site_lang` VALUES ('372', '33', 'Add photos and complete your profile');
INSERT INTO `site_lang` VALUES ('370', '33', 'Meet new people');
INSERT INTO `site_lang` VALUES ('371', '33', 'Nobody is going to fall in love with a blank page. The more information you get, the more chances to find that special someone!');
INSERT INTO `site_lang` VALUES ('369', '33', 'you can meet people instantly');
INSERT INTO `site_lang` VALUES ('365', '33', 'Verify your account');
INSERT INTO `site_lang` VALUES ('366', '33', 'Newsflash');
INSERT INTO `site_lang` VALUES ('367', '33', 'people in your area wants to know you');
INSERT INTO `site_lang` VALUES ('368', '33', 'In');
INSERT INTO `site_lang` VALUES ('364', '33', 'Now you are a new member of');
INSERT INTO `site_lang` VALUES ('361', '33', 'Welcome');
INSERT INTO `site_lang` VALUES ('362', '33', 'Well done, now you are in');
INSERT INTO `site_lang` VALUES ('363', '33', 'Here are a few tips');
INSERT INTO `site_lang` VALUES ('360', '33', 'Check out the profile');
INSERT INTO `site_lang` VALUES ('358', '33', 'is new at');
INSERT INTO `site_lang` VALUES ('359', '33', 'and lives closer to you');
INSERT INTO `site_lang` VALUES ('355', '33', 'Respond to');
INSERT INTO `site_lang` VALUES ('356', '33', 'Have fun!');
INSERT INTO `site_lang` VALUES ('357', '33', 'is new and lives closer to you');
INSERT INTO `site_lang` VALUES ('354', '33', 'you have a new message from');
INSERT INTO `site_lang` VALUES ('353', '33', 'New message from');
INSERT INTO `site_lang` VALUES ('352', '33', 'Go and say something to');
INSERT INTO `site_lang` VALUES ('351', '33', 'thinks the feeling is mutual');
INSERT INTO `site_lang` VALUES ('349', '33', 'You have a match at');
INSERT INTO `site_lang` VALUES ('350', '33', 'Its a match!');
INSERT INTO `site_lang` VALUES ('348', '33', 'if you forgot your password, click on the link below to get a new');
INSERT INTO `site_lang` VALUES ('346', '33', 'Unsubscribe');
INSERT INTO `site_lang` VALUES ('347', '33', 'Choose a new password');
INSERT INTO `site_lang` VALUES ('345', '33', 'You received this notice because you registered as');
INSERT INTO `site_lang` VALUES ('344', '33', 'Find out if you also like');
INSERT INTO `site_lang` VALUES ('343', '33', 'has seen you in discover and likes. The feeling is mutual?');
INSERT INTO `site_lang` VALUES ('342', '33', 'likes you and wants to chat in');
INSERT INTO `site_lang` VALUES ('341', '33', 'We sent you a email with your info, it may take up to 1 min to arrive');
INSERT INTO `site_lang` VALUES ('340', '33', 'Loading...');
INSERT INTO `site_lang` VALUES ('338', '33', 'Photos of ');
INSERT INTO `site_lang` VALUES ('339', '33', 'of');
INSERT INTO `site_lang` VALUES ('336', '33', 'Password successfully changed');
INSERT INTO `site_lang` VALUES ('337', '33', 'is calling you..');
INSERT INTO `site_lang` VALUES ('335', '33', 'Service cost');
INSERT INTO `site_lang` VALUES ('333', '33', 'Wrong');
INSERT INTO `site_lang` VALUES ('334', '33', 'Spotlight');
INSERT INTO `site_lang` VALUES ('330', '33', 'You need to write your username!');
INSERT INTO `site_lang` VALUES ('331', '33', 'username');
INSERT INTO `site_lang` VALUES ('332', '33', 'days of Premium');
INSERT INTO `site_lang` VALUES ('328', '33', 'Press backspace key for smart return to the meeting section.');
INSERT INTO `site_lang` VALUES ('329', '33', 'Write your instagram username');
INSERT INTO `site_lang` VALUES ('327', '33', 'Are you sure you want to report');
INSERT INTO `site_lang` VALUES ('326', '33', 'Report and block');
INSERT INTO `site_lang` VALUES ('325', '33', 'is blocking you or you blocked him, you cant chat with him sorry');
INSERT INTO `site_lang` VALUES ('324', '33', 'We sended you a email for verify your account');
INSERT INTO `site_lang` VALUES ('323', '33', 'years old and im from');
INSERT INTO `site_lang` VALUES ('322', '33', 'Hi, im');
INSERT INTO `site_lang` VALUES ('321', '33', 'Please add a profile photo');
INSERT INTO `site_lang` VALUES ('320', '33', 'Please verify your account, check your email');
INSERT INTO `site_lang` VALUES ('319', '33', 'ago');
INSERT INTO `site_lang` VALUES ('318', '33', 'seconds');
INSERT INTO `site_lang` VALUES ('317', '33', 'minutes');
INSERT INTO `site_lang` VALUES ('316', '33', 'hours');
INSERT INTO `site_lang` VALUES ('315', '33', 'days');
INSERT INTO `site_lang` VALUES ('314', '33', 'months');
INSERT INTO `site_lang` VALUES ('313', '33', 'years');
INSERT INTO `site_lang` VALUES ('312', '33', 'second');
INSERT INTO `site_lang` VALUES ('311', '33', 'minute');
INSERT INTO `site_lang` VALUES ('310', '33', 'hour');
INSERT INTO `site_lang` VALUES ('309', '33', 'day');
INSERT INTO `site_lang` VALUES ('308', '33', 'month');
INSERT INTO `site_lang` VALUES ('307', '33', 'year');
INSERT INTO `site_lang` VALUES ('305', '33', 'Credits for $');
INSERT INTO `site_lang` VALUES ('306', '33', '0 seconds');
INSERT INTO `site_lang` VALUES ('304', '33', 'Cost');
INSERT INTO `site_lang` VALUES ('302', '33', 'visited');
INSERT INTO `site_lang` VALUES ('303', '33', 'You do not like anyone');
INSERT INTO `site_lang` VALUES ('299', '33', 'Dislike');
INSERT INTO `site_lang` VALUES ('300', '33', 'AGE');
INSERT INTO `site_lang` VALUES ('301', '33', 'You dont have any visit yet');
INSERT INTO `site_lang` VALUES ('298', '33', 'Like');
INSERT INTO `site_lang` VALUES ('297', '33', 'Messages');
INSERT INTO `site_lang` VALUES ('296', '33', 'people liked you, for see them');
INSERT INTO `site_lang` VALUES ('295', '33', 'People i like');
INSERT INTO `site_lang` VALUES ('294', '33', 'Upgrade your account to premium');
INSERT INTO `site_lang` VALUES ('293', '33', 'people visited your profile for see them');
INSERT INTO `site_lang` VALUES ('292', '33', 'Delete');
INSERT INTO `site_lang` VALUES ('291', '33', 'Public photo');
INSERT INTO `site_lang` VALUES ('290', '33', 'Private photo');
INSERT INTO `site_lang` VALUES ('289', '33', 'Set as profile');
INSERT INTO `site_lang` VALUES ('288', '33', 'get seen by millions');
INSERT INTO `site_lang` VALUES ('287', '33', 'Add me here');
INSERT INTO `site_lang` VALUES ('286', '33', 'Visits');
INSERT INTO `site_lang` VALUES ('285', '33', 'Credits');
INSERT INTO `site_lang` VALUES ('284', '33', 'Photos');
INSERT INTO `site_lang` VALUES ('283', '33', 'Add');
INSERT INTO `site_lang` VALUES ('282', '33', 'Add from ');
INSERT INTO `site_lang` VALUES ('279', '33', 'No data');
INSERT INTO `site_lang` VALUES ('280', '33', 'Public Photos');
INSERT INTO `site_lang` VALUES ('281', '33', 'Private photos');
INSERT INTO `site_lang` VALUES ('274', '33', 'Year');
INSERT INTO `site_lang` VALUES ('275', '33', 'Please wait');
INSERT INTO `site_lang` VALUES ('276', '33', 'Interests');
INSERT INTO `site_lang` VALUES ('277', '33', 'Report');
INSERT INTO `site_lang` VALUES ('278', '33', 'Fans');
INSERT INTO `site_lang` VALUES ('273', '33', 'Month');
INSERT INTO `site_lang` VALUES ('272', '33', 'Day');
INSERT INTO `site_lang` VALUES ('271', '33', 'When someone send me a message');
INSERT INTO `site_lang` VALUES ('270', '33', 'When new users near me join in');
INSERT INTO `site_lang` VALUES ('269', '33', 'When i get a match');
INSERT INTO `site_lang` VALUES ('268', '33', 'When someone likes me');
INSERT INTO `site_lang` VALUES ('267', '33', 'None');
INSERT INTO `site_lang` VALUES ('266', '33', 'I own a motorbike');
INSERT INTO `site_lang` VALUES ('265', '33', 'I own a car');
INSERT INTO `site_lang` VALUES ('264', '33', 'Parents car');
INSERT INTO `site_lang` VALUES ('263', '33', 'Transport');
INSERT INTO `site_lang` VALUES ('262', '33', 'Drink');
INSERT INTO `site_lang` VALUES ('261', '33', 'Sometimes');
INSERT INTO `site_lang` VALUES ('260', '33', 'No');
INSERT INTO `site_lang` VALUES ('259', '33', 'Yes');
INSERT INTO `site_lang` VALUES ('258', '33', 'Smoke');
INSERT INTO `site_lang` VALUES ('257', '33', 'Alone');
INSERT INTO `site_lang` VALUES ('256', '33', 'With partner');
INSERT INTO `site_lang` VALUES ('255', '33', 'Student dormitory');
INSERT INTO `site_lang` VALUES ('254', '33', 'With housemate');
INSERT INTO `site_lang` VALUES ('253', '33', 'With parents');
INSERT INTO `site_lang` VALUES ('252', '33', 'Living');
INSERT INTO `site_lang` VALUES ('251', '33', 'Curvy');
INSERT INTO `site_lang` VALUES ('250', '33', 'Heavy set');
INSERT INTO `site_lang` VALUES ('248', '33', 'Average');
INSERT INTO `site_lang` VALUES ('249', '33', 'Athletic');
INSERT INTO `site_lang` VALUES ('247', '33', 'Slim');
INSERT INTO `site_lang` VALUES ('246', '33', 'Body type');
INSERT INTO `site_lang` VALUES ('245', '33', 'Other');
INSERT INTO `site_lang` VALUES ('244', '33', 'Indian');
INSERT INTO `site_lang` VALUES ('243', '33', 'Pacific Islander');
INSERT INTO `site_lang` VALUES ('242', '33', 'Hispanic/latin');
INSERT INTO `site_lang` VALUES ('241', '33', 'Native American');
INSERT INTO `site_lang` VALUES ('240', '33', 'White');
INSERT INTO `site_lang` VALUES ('239', '33', 'Black');
INSERT INTO `site_lang` VALUES ('238', '33', 'Middle Eastern');
INSERT INTO `site_lang` VALUES ('237', '33', 'Asian');
INSERT INTO `site_lang` VALUES ('236', '33', 'Ethnicity');
INSERT INTO `site_lang` VALUES ('235', '33', 'Weight');
INSERT INTO `site_lang` VALUES ('234', '33', 'more than');
INSERT INTO `site_lang` VALUES ('233', '33', 'less than');
INSERT INTO `site_lang` VALUES ('232', '33', 'Height');
INSERT INTO `site_lang` VALUES ('231', '33', 'Bisexual');
INSERT INTO `site_lang` VALUES ('230', '33', 'Straight');
INSERT INTO `site_lang` VALUES ('229', '33', 'Open-minded');
INSERT INTO `site_lang` VALUES ('228', '33', 'Gay');
INSERT INTO `site_lang` VALUES ('227', '33', 'Sexuality');
INSERT INTO `site_lang` VALUES ('226', '33', 'Open');
INSERT INTO `site_lang` VALUES ('223', '33', 'Relationship');
INSERT INTO `site_lang` VALUES ('224', '33', 'Single');
INSERT INTO `site_lang` VALUES ('225', '33', 'Taken');
INSERT INTO `site_lang` VALUES ('220', '33', 'UPGRADE');
INSERT INTO `site_lang` VALUES ('221', '33', 'Notifications');
INSERT INTO `site_lang` VALUES ('222', '33', 'Extended info (optional)');
INSERT INTO `site_lang` VALUES ('219', '33', 'Basic');
INSERT INTO `site_lang` VALUES ('218', '33', 'until');
INSERT INTO `site_lang` VALUES ('216', '33', 'End call');
INSERT INTO `site_lang` VALUES ('217', '33', 'Wait more');
INSERT INTO `site_lang` VALUES ('215', '33', 'Seems that your friend do not have webcam or he is not available');
INSERT INTO `site_lang` VALUES ('214', '33', 'Too long wait');
INSERT INTO `site_lang` VALUES ('212', '33', 'Impossible to make a call!');
INSERT INTO `site_lang` VALUES ('213', '33', 'You cant make videocall because you dont have webcam');
INSERT INTO `site_lang` VALUES ('211', '33', 'Only premium users can make videocalls');
INSERT INTO `site_lang` VALUES ('209', '33', 'Please allow access to your Webcam.');
INSERT INTO `site_lang` VALUES ('210', '33', 'You are already in a videocall, you have to end the other call before start another');
INSERT INTO `site_lang` VALUES ('208', '33', 'is offline, try again when your friend is online');
INSERT INTO `site_lang` VALUES ('207', '33', 'is in another videocall , you cant call now');
INSERT INTO `site_lang` VALUES ('205', '33', 'Your data will be lost without recovery, continue?');
INSERT INTO `site_lang` VALUES ('206', '33', 'Yes, delete it!');
INSERT INTO `site_lang` VALUES ('202', '33', 'Yes, buy it!');
INSERT INTO `site_lang` VALUES ('203', '33', 'Information updated successfully');
INSERT INTO `site_lang` VALUES ('204', '33', 'Account termination');
INSERT INTO `site_lang` VALUES ('200', '33', 'Expand daily limitation ');
INSERT INTO `site_lang` VALUES ('201', '33', 'more daily conversation, cost ');
INSERT INTO `site_lang` VALUES ('199', '33', 'You dont have enought credits for send the gift');
INSERT INTO `site_lang` VALUES ('198', '33', 'Please, select 1 gift');
INSERT INTO `site_lang` VALUES ('197', '33', 'Please, select 1 photo');
INSERT INTO `site_lang` VALUES ('195', '33', 'No thanks');
INSERT INTO `site_lang` VALUES ('196', '33', 'Please, select a payment method');
INSERT INTO `site_lang` VALUES ('194', '33', 'Get access');
INSERT INTO `site_lang` VALUES ('193', '33', 'private photos for ');
INSERT INTO `site_lang` VALUES ('192', '33', 'Get access to');
INSERT INTO `site_lang` VALUES ('191', '33', 'Buy private photos permission');
INSERT INTO `site_lang` VALUES ('189', '33', 'Yes, you can see my private photos');
INSERT INTO `site_lang` VALUES ('190', '33', 'No, i cant show you my private photos');
INSERT INTO `site_lang` VALUES ('187', '33', 'Password too short');
INSERT INTO `site_lang` VALUES ('188', '33', 'Email already exist, try another');
INSERT INTO `site_lang` VALUES ('186', '33', 'Choose city from the autocomplete');
INSERT INTO `site_lang` VALUES ('185', '33', 'Add a valid date');
INSERT INTO `site_lang` VALUES ('184', '33', 'Wrong password');
INSERT INTO `site_lang` VALUES ('183', '33', 'Email dont exist');
INSERT INTO `site_lang` VALUES ('182', '33', 'Please fill all the inputs');
INSERT INTO `site_lang` VALUES ('181', '33', 'Invalid email format');
INSERT INTO `site_lang` VALUES ('180', '33', 'Password recover');
INSERT INTO `site_lang` VALUES ('179', '33', 'Login to my account');
INSERT INTO `site_lang` VALUES ('178', '33', 'If you dont remember your password, click the link below to set a new one:');
INSERT INTO `site_lang` VALUES ('177', '33', 'Hi');
INSERT INTO `site_lang` VALUES ('176', '33', 'No');
INSERT INTO `site_lang` VALUES ('175', '33', 'Yes');
INSERT INTO `site_lang` VALUES ('174', '33', 'Hello, can i have access to your private photos ?');
INSERT INTO `site_lang` VALUES ('173', '33', 'like this');
INSERT INTO `site_lang` VALUES ('172', '33', 'persons more like this');
INSERT INTO `site_lang` VALUES ('170', '33', 'Buy');
INSERT INTO `site_lang` VALUES ('171', '33', 'Days Premium');
INSERT INTO `site_lang` VALUES ('169', '33', 'December');
INSERT INTO `site_lang` VALUES ('168', '33', 'November');
INSERT INTO `site_lang` VALUES ('167', '33', 'October');
INSERT INTO `site_lang` VALUES ('166', '33', 'September');
INSERT INTO `site_lang` VALUES ('164', '33', 'July');
INSERT INTO `site_lang` VALUES ('165', '33', 'August');
INSERT INTO `site_lang` VALUES ('160', '33', 'March');
INSERT INTO `site_lang` VALUES ('161', '33', 'April');
INSERT INTO `site_lang` VALUES ('162', '33', 'May');
INSERT INTO `site_lang` VALUES ('163', '33', 'June');
INSERT INTO `site_lang` VALUES ('159', '33', 'February');
INSERT INTO `site_lang` VALUES ('158', '33', 'January');
INSERT INTO `site_lang` VALUES ('157', '33', 'You dont have matches yet');
INSERT INTO `site_lang` VALUES ('156', '33', 'You dont have any fans yet');
INSERT INTO `site_lang` VALUES ('155', '33', 'No popular users near you');
INSERT INTO `site_lang` VALUES ('154', '33', 'people found');
INSERT INTO `site_lang` VALUES ('153', '33', 'Nothing found');
INSERT INTO `site_lang` VALUES ('152', '33', 'Verified');
INSERT INTO `site_lang` VALUES ('150', '33', 'Delete profile');
INSERT INTO `site_lang` VALUES ('151', '33', 'Online now');
INSERT INTO `site_lang` VALUES ('149', '33', 'After delete your profile, some of your data will be lost without recovery.');
INSERT INTO `site_lang` VALUES ('147', '33', 'New password');
INSERT INTO `site_lang` VALUES ('148', '33', 'Profile desactivation');
INSERT INTO `site_lang` VALUES ('146', '33', 'You can change your current password bellow');
INSERT INTO `site_lang` VALUES ('145', '33', 'Change password');
INSERT INTO `site_lang` VALUES ('144', '33', 'Upgrade to premium account');
INSERT INTO `site_lang` VALUES ('142', '33', 'Current credits');
INSERT INTO `site_lang` VALUES ('143', '33', 'Add credits');
INSERT INTO `site_lang` VALUES ('141', '33', 'Account type');
INSERT INTO `site_lang` VALUES ('140', '33', 'Buy credits for send Gifs and Unblock private photos');
INSERT INTO `site_lang` VALUES ('139', '33', 'You are account is already verified');
INSERT INTO `site_lang` VALUES ('138', '33', 'Connect with Facebook');
INSERT INTO `site_lang` VALUES ('137', '33', 'For verify your account , connect with your facebook account');
INSERT INTO `site_lang` VALUES ('136', '33', 'Verify account');
INSERT INTO `site_lang` VALUES ('135', '33', 'Update profile');
INSERT INTO `site_lang` VALUES ('134', '33', 'Site language');
INSERT INTO `site_lang` VALUES ('133', '33', 'You can edit your profile information bellow');
INSERT INTO `site_lang` VALUES ('132', '33', 'Personal information');
INSERT INTO `site_lang` VALUES ('131', '33', 'Delete');
INSERT INTO `site_lang` VALUES ('130', '33', 'Change password');
INSERT INTO `site_lang` VALUES ('129', '33', 'Verify');
INSERT INTO `site_lang` VALUES ('128', '33', 'Credits');
INSERT INTO `site_lang` VALUES ('127', '33', 'Personal');
INSERT INTO `site_lang` VALUES ('126', '33', 'Unblock private photos');
INSERT INTO `site_lang` VALUES ('125', '33', 'Ask permission to');
INSERT INTO `site_lang` VALUES ('124', '33', 'Now you have');
INSERT INTO `site_lang` VALUES ('123', '33', 'Credits successfully added to your account');
INSERT INTO `site_lang` VALUES ('122', '33', 'boys and girls');
INSERT INTO `site_lang` VALUES ('121', '33', 'Only girls');
INSERT INTO `site_lang` VALUES ('119', '33', 'years old');
INSERT INTO `site_lang` VALUES ('120', '33', 'Only boys');
INSERT INTO `site_lang` VALUES ('118', '33', 'Personal info');
INSERT INTO `site_lang` VALUES ('117', '33', 'About ');
INSERT INTO `site_lang` VALUES ('116', '33', 'Most popular users');
INSERT INTO `site_lang` VALUES ('114', '33', 'in a radius of');
INSERT INTO `site_lang` VALUES ('115', '33', 'World');
INSERT INTO `site_lang` VALUES ('113', '33', 'who are between');
INSERT INTO `site_lang` VALUES ('112', '33', 'Both');
INSERT INTO `site_lang` VALUES ('111', '33', 'Boys');
INSERT INTO `site_lang` VALUES ('110', '33', 'Girls');
INSERT INTO `site_lang` VALUES ('109', '33', 'Show me');
INSERT INTO `site_lang` VALUES ('108', '33', 'Online now');
INSERT INTO `site_lang` VALUES ('107', '33', 'All users');
INSERT INTO `site_lang` VALUES ('105', '33', 'Your matches');
INSERT INTO `site_lang` VALUES ('106', '33', 'Filter Search');
INSERT INTO `site_lang` VALUES ('104', '33', 'Please complete your profile before start in ');
INSERT INTO `site_lang` VALUES ('103', '33', 'Terms of Use');
INSERT INTO `site_lang` VALUES ('102', '33', 'Privacy Policy');
INSERT INTO `site_lang` VALUES ('101', '33', 'Your fans');
INSERT INTO `site_lang` VALUES ('100', '33', 'or wait until tomorrow for continue meeting people');
INSERT INTO `site_lang` VALUES ('99', '33', 'daily conversations');
INSERT INTO `site_lang` VALUES ('95', '33', 'more daily conversation');
INSERT INTO `site_lang` VALUES ('96', '33', 'or');
INSERT INTO `site_lang` VALUES ('97', '33', 'Upgrade your account to Premium');
INSERT INTO `site_lang` VALUES ('98', '33', 'and get up to');
INSERT INTO `site_lang` VALUES ('91', '33', 'Chat');
INSERT INTO `site_lang` VALUES ('92', '33', 'you have reached the limit of new daily conversations');
INSERT INTO `site_lang` VALUES ('93', '33', 'To continue chatting');
INSERT INTO `site_lang` VALUES ('94', '33', 'Buy');
INSERT INTO `site_lang` VALUES ('86', '33', 'Unlimited videocalls');
INSERT INTO `site_lang` VALUES ('87', '33', 'Unblock all private photos');
INSERT INTO `site_lang` VALUES ('88', '33', 'Premium user badge');
INSERT INTO `site_lang` VALUES ('84', '33', 'Premium Account Features');
INSERT INTO `site_lang` VALUES ('90', '33', 'Send');
INSERT INTO `site_lang` VALUES ('89', '33', 'Write text here');
INSERT INTO `site_lang` VALUES ('85', '33', 'new chats per day');
INSERT INTO `site_lang` VALUES ('83', '33', 'Buy credits');
INSERT INTO `site_lang` VALUES ('82', '33', 'Pay with');
INSERT INTO `site_lang` VALUES ('81', '33', 'Pay with');
INSERT INTO `site_lang` VALUES ('80', '33', 'Select payment method');
INSERT INTO `site_lang` VALUES ('79', '33', 'Select credits package');
INSERT INTO `site_lang` VALUES ('78', '33', 'Buy credits / Upgrade account');
INSERT INTO `site_lang` VALUES ('77', '33', 'Send gift');
INSERT INTO `site_lang` VALUES ('76', '33', 'Pick the gift you want to send to ');
INSERT INTO `site_lang` VALUES ('75', '33', 'Send gift to ');
INSERT INTO `site_lang` VALUES ('74', '33', 'Add photo');
INSERT INTO `site_lang` VALUES ('73', '33', 'Credits');
INSERT INTO `site_lang` VALUES ('72', '33', 'Pick the photo you want to show in the Spotlight, cost ');
INSERT INTO `site_lang` VALUES ('70', '33', 'add photos');
INSERT INTO `site_lang` VALUES ('71', '33', 'Add yourself to the Spotlight');
INSERT INTO `site_lang` VALUES ('69', '33', 'Add your photos');
INSERT INTO `site_lang` VALUES ('68', '33', 'Private Photos');
INSERT INTO `site_lang` VALUES ('67', '33', 'Public Photos');
INSERT INTO `site_lang` VALUES ('66', '33', 'All Photos');
INSERT INTO `site_lang` VALUES ('65', '33', 'Manage your photos');
INSERT INTO `site_lang` VALUES ('64', '33', 'Contact');
INSERT INTO `site_lang` VALUES ('63', '33', 'Privacy');
INSERT INTO `site_lang` VALUES ('62', '33', 'Terms');
INSERT INTO `site_lang` VALUES ('61', '33', 'Who to like');
INSERT INTO `site_lang` VALUES ('60', '33', 'New messages');
INSERT INTO `site_lang` VALUES ('59', '33', 'Online now');
INSERT INTO `site_lang` VALUES ('58', '33', 'Conversations');
INSERT INTO `site_lang` VALUES ('57', '33', 'Fans');
INSERT INTO `site_lang` VALUES ('56', '33', 'All');
INSERT INTO `site_lang` VALUES ('55', '33', 'Settings');
INSERT INTO `site_lang` VALUES ('54', '33', 'Manage photos');
INSERT INTO `site_lang` VALUES ('53', '33', 'Fans');
INSERT INTO `site_lang` VALUES ('52', '33', 'Most populars');
INSERT INTO `site_lang` VALUES ('51', '33', 'Matches');
INSERT INTO `site_lang` VALUES ('50', '33', 'Discover');
INSERT INTO `site_lang` VALUES ('49', '33', 'Meet new people');
INSERT INTO `site_lang` VALUES ('48', '33', 'Logout');
INSERT INTO `site_lang` VALUES ('47', '33', 'Settings');
INSERT INTO `site_lang` VALUES ('46', '33', 'Profile');
INSERT INTO `site_lang` VALUES ('44', '33', 'and');
INSERT INTO `site_lang` VALUES ('45', '33', 'Privacy Policy');
INSERT INTO `site_lang` VALUES ('43', '33', 'Terms and Conditions');
INSERT INTO `site_lang` VALUES ('40', '33', 'Meet boys and girls');
INSERT INTO `site_lang` VALUES ('41', '33', 'Sign up');
INSERT INTO `site_lang` VALUES ('42', '33', 'By continuing, you are confirming that you have read and agree to our');
INSERT INTO `site_lang` VALUES ('39', '33', 'Meet boys');
INSERT INTO `site_lang` VALUES ('35', '33', 'Male');
INSERT INTO `site_lang` VALUES ('36', '33', 'Female');
INSERT INTO `site_lang` VALUES ('37', '33', 'Im here to');
INSERT INTO `site_lang` VALUES ('38', '33', 'Meet girls');
INSERT INTO `site_lang` VALUES ('34', '33', 'Gender');
INSERT INTO `site_lang` VALUES ('29', '33', 'Password');
INSERT INTO `site_lang` VALUES ('30', '33', 'Birthday');
INSERT INTO `site_lang` VALUES ('31', '33', 'Please select');
INSERT INTO `site_lang` VALUES ('32', '33', 'City');
INSERT INTO `site_lang` VALUES ('33', '33', 'Where do you live?');
INSERT INTO `site_lang` VALUES ('28', '33', 'Email');
INSERT INTO `site_lang` VALUES ('26', '33', 'Name');
INSERT INTO `site_lang` VALUES ('27', '33', 'Your name or nickname');
INSERT INTO `site_lang` VALUES ('24', '33', 'Become a member now');
INSERT INTO `site_lang` VALUES ('25', '33', 'Join the worlds bestest community for meeting new people!.');
INSERT INTO `site_lang` VALUES ('23', '33', 'Play our popular Discover game and get matched with other users. Its a great way to break the ice and chat to new people.');
INSERT INTO `site_lang` VALUES ('22', '33', 'Matches');
INSERT INTO `site_lang` VALUES ('21', '33', 'We wont show your exact location, but you will be able to find people nearby who like the same things you do.');
INSERT INTO `site_lang` VALUES ('20', '33', 'People nearby');
INSERT INTO `site_lang` VALUES ('18', '33', 'Video Chat');
INSERT INTO `site_lang` VALUES ('19', '33', 'You can make quality videocalls for free to anyone, without limits of call duration, just enjoy seeing the person who is chatting with you');
INSERT INTO `site_lang` VALUES ('16', '33', 'Chat');
INSERT INTO `site_lang` VALUES ('17', '33', 'Powerfull private chat for meet new friends, you can send emoticons and private photos to anyone.');
INSERT INTO `site_lang` VALUES ('15', '33', 'Recover password');
INSERT INTO `site_lang` VALUES ('14', '33', 'Password recover');
INSERT INTO `site_lang` VALUES ('13', '33', 'Login now');
INSERT INTO `site_lang` VALUES ('12', '33', 'do you forget your password?');
INSERT INTO `site_lang` VALUES ('11', '33', 'Your password');
INSERT INTO `site_lang` VALUES ('10', '33', 'Your email');
INSERT INTO `site_lang` VALUES ('8', '33', 'Create your account');
INSERT INTO `site_lang` VALUES ('9', '33', 'Welcome back');
INSERT INTO `site_lang` VALUES ('7', '33', 'Connect with ');
INSERT INTO `site_lang` VALUES ('5', '33', 'Soon we will have our phone apps online');
INSERT INTO `site_lang` VALUES ('6', '33', 'SOON AVAILABLE');
INSERT INTO `site_lang` VALUES ('4', '33', 'Please visit us from your laptop or PC');
INSERT INTO `site_lang` VALUES ('3', '33', 'For now our site works only for Desktop users');
INSERT INTO `site_lang` VALUES ('0', '33', 'meet new people!');
INSERT INTO `site_lang` VALUES ('1', '33', 'Login');
INSERT INTO `site_lang` VALUES ('2', '33', 'Welcome to the fastest growing place to meet new people');
INSERT INTO `site_lang` VALUES ('384', '32', 'Ok, i understand');
INSERT INTO `site_lang` VALUES ('383', '32', 'must like you for start a videocall');
INSERT INTO `site_lang` VALUES ('381', '32', 'calling...');
INSERT INTO `site_lang` VALUES ('382', '32', 'dont like you');
INSERT INTO `site_lang` VALUES ('380', '32', 'Welcome to');
INSERT INTO `site_lang` VALUES ('379', '32', 'Go to');
INSERT INTO `site_lang` VALUES ('378', '32', 'Please save your connection information in a safe place');
INSERT INTO `site_lang` VALUES ('377', '32', 'Password');
INSERT INTO `site_lang` VALUES ('376', '32', 'E-mail');
INSERT INTO `site_lang` VALUES ('375', '32', 'Here are your connection details');
INSERT INTO `site_lang` VALUES ('374', '32', 'Start meeting new people now');
INSERT INTO `site_lang` VALUES ('373', '32', 'More than 1 million people have joined $site_name You probably want to know some of them.');
INSERT INTO `site_lang` VALUES ('372', '32', 'Add photos and complete your profile');
INSERT INTO `site_lang` VALUES ('371', '32', 'Nobody is going to fall in love with a blank page. The more information you get, the more chances to find that special someone!');
INSERT INTO `site_lang` VALUES ('370', '32', 'Meet new people');
INSERT INTO `site_lang` VALUES ('369', '32', 'you can meet people instantly');
INSERT INTO `site_lang` VALUES ('368', '32', 'In');
INSERT INTO `site_lang` VALUES ('367', '32', 'people in your area wants to know you');
INSERT INTO `site_lang` VALUES ('365', '32', 'Verify your account');
INSERT INTO `site_lang` VALUES ('366', '32', 'Newsflash');
INSERT INTO `site_lang` VALUES ('364', '32', 'Now you are a new member of');
INSERT INTO `site_lang` VALUES ('363', '32', 'Here are a few tips');
INSERT INTO `site_lang` VALUES ('362', '32', 'Well done, now you are in');
INSERT INTO `site_lang` VALUES ('361', '32', 'Welcome');
INSERT INTO `site_lang` VALUES ('360', '32', 'Check out the profile');
INSERT INTO `site_lang` VALUES ('359', '32', 'and lives closer to you');
INSERT INTO `site_lang` VALUES ('358', '32', 'is new at');
INSERT INTO `site_lang` VALUES ('357', '32', 'is new and lives closer to you');
INSERT INTO `site_lang` VALUES ('356', '32', 'Have fun!');
INSERT INTO `site_lang` VALUES ('355', '32', 'Respond to');
INSERT INTO `site_lang` VALUES ('354', '32', 'you have a new message from');
INSERT INTO `site_lang` VALUES ('353', '32', 'New message from');
INSERT INTO `site_lang` VALUES ('352', '32', 'Go and say something to');
INSERT INTO `site_lang` VALUES ('351', '32', 'thinks the feeling is mutual');
INSERT INTO `site_lang` VALUES ('349', '32', 'You have a match at');
INSERT INTO `site_lang` VALUES ('350', '32', 'Its a match!');
INSERT INTO `site_lang` VALUES ('348', '32', 'if you forgot your password, click on the link below to get a new');
INSERT INTO `site_lang` VALUES ('347', '32', 'Choose a new password');
INSERT INTO `site_lang` VALUES ('346', '32', 'Unsubscribe');
INSERT INTO `site_lang` VALUES ('345', '32', 'You received this notice because you registered as');
INSERT INTO `site_lang` VALUES ('344', '32', 'Find out if you also like');
INSERT INTO `site_lang` VALUES ('343', '32', 'has seen you in discover and likes. The feeling is mutual?');
INSERT INTO `site_lang` VALUES ('342', '32', 'likes you and wants to chat in');
INSERT INTO `site_lang` VALUES ('341', '32', 'We sent you a email with your info, it may take up to 1 min to arrive');
INSERT INTO `site_lang` VALUES ('339', '32', 'of');
INSERT INTO `site_lang` VALUES ('340', '32', 'Loading...');
INSERT INTO `site_lang` VALUES ('338', '32', 'Photos of ');
INSERT INTO `site_lang` VALUES ('337', '32', 'is calling you..');
INSERT INTO `site_lang` VALUES ('336', '32', 'Password successfully changed');
INSERT INTO `site_lang` VALUES ('335', '32', 'Service cost');
INSERT INTO `site_lang` VALUES ('334', '32', 'Spotlight');
INSERT INTO `site_lang` VALUES ('333', '32', 'Wrong');
INSERT INTO `site_lang` VALUES ('332', '32', 'days of Premium');
INSERT INTO `site_lang` VALUES ('331', '32', 'username');
INSERT INTO `site_lang` VALUES ('330', '32', 'You need to write your username!');
INSERT INTO `site_lang` VALUES ('329', '32', 'Write your instagram username');
INSERT INTO `site_lang` VALUES ('328', '32', 'Press backspace key for smart return to the meeting section.');
INSERT INTO `site_lang` VALUES ('327', '32', 'Are you sure you want to report');
INSERT INTO `site_lang` VALUES ('326', '32', 'Report and block');
INSERT INTO `site_lang` VALUES ('325', '32', 'is blocking you or you blocked him, you cant chat with him sorry');
INSERT INTO `site_lang` VALUES ('324', '32', 'We sended you a email for verify your account');
INSERT INTO `site_lang` VALUES ('323', '32', 'years old and im from');
INSERT INTO `site_lang` VALUES ('322', '32', 'Hi, im');
INSERT INTO `site_lang` VALUES ('321', '32', 'Please add a profile photo');
INSERT INTO `site_lang` VALUES ('319', '32', 'ago');
INSERT INTO `site_lang` VALUES ('320', '32', 'Please verify your account, check your email');
INSERT INTO `site_lang` VALUES ('318', '32', 'seconds');
INSERT INTO `site_lang` VALUES ('317', '32', 'minutes');
INSERT INTO `site_lang` VALUES ('316', '32', 'hours');
INSERT INTO `site_lang` VALUES ('315', '32', 'days');
INSERT INTO `site_lang` VALUES ('314', '32', 'months');
INSERT INTO `site_lang` VALUES ('313', '32', 'years');
INSERT INTO `site_lang` VALUES ('311', '32', 'minute');
INSERT INTO `site_lang` VALUES ('312', '32', 'second');
INSERT INTO `site_lang` VALUES ('310', '32', 'hour');
INSERT INTO `site_lang` VALUES ('308', '32', 'month');
INSERT INTO `site_lang` VALUES ('309', '32', 'day');
INSERT INTO `site_lang` VALUES ('307', '32', 'year');
INSERT INTO `site_lang` VALUES ('306', '32', '0 seconds');
INSERT INTO `site_lang` VALUES ('302', '32', 'visited');
INSERT INTO `site_lang` VALUES ('303', '32', 'You do not like anyone');
INSERT INTO `site_lang` VALUES ('304', '32', 'Cost');
INSERT INTO `site_lang` VALUES ('305', '32', 'Credits for $');
INSERT INTO `site_lang` VALUES ('300', '32', 'AGE');
INSERT INTO `site_lang` VALUES ('301', '32', 'You dont have any visit yet');
INSERT INTO `site_lang` VALUES ('297', '32', 'Messages');
INSERT INTO `site_lang` VALUES ('298', '32', 'Like');
INSERT INTO `site_lang` VALUES ('299', '32', 'Dislike');
INSERT INTO `site_lang` VALUES ('295', '32', 'People i like');
INSERT INTO `site_lang` VALUES ('296', '32', 'people liked you, for see them');
INSERT INTO `site_lang` VALUES ('293', '32', 'people visited your profile for see them');
INSERT INTO `site_lang` VALUES ('294', '32', 'Upgrade your account to premium');
INSERT INTO `site_lang` VALUES ('292', '32', 'Delete');
INSERT INTO `site_lang` VALUES ('291', '32', 'Public photo');
INSERT INTO `site_lang` VALUES ('290', '32', 'Private photo');
INSERT INTO `site_lang` VALUES ('288', '32', 'get seen by millions');
INSERT INTO `site_lang` VALUES ('289', '32', 'Set as profile');
INSERT INTO `site_lang` VALUES ('287', '32', 'Add me here');
INSERT INTO `site_lang` VALUES ('285', '32', 'Credits');
INSERT INTO `site_lang` VALUES ('286', '32', 'Visits');
INSERT INTO `site_lang` VALUES ('283', '32', 'Add');
INSERT INTO `site_lang` VALUES ('284', '32', 'Photos');
INSERT INTO `site_lang` VALUES ('282', '32', 'Add from ');
INSERT INTO `site_lang` VALUES ('280', '32', 'Public Photos');
INSERT INTO `site_lang` VALUES ('281', '32', 'Private photos');
INSERT INTO `site_lang` VALUES ('279', '32', 'No data');
INSERT INTO `site_lang` VALUES ('278', '32', 'Fans');
INSERT INTO `site_lang` VALUES ('277', '32', 'Report');
INSERT INTO `site_lang` VALUES ('276', '32', 'Interests');
INSERT INTO `site_lang` VALUES ('274', '32', 'Year');
INSERT INTO `site_lang` VALUES ('275', '32', 'Please wait');
INSERT INTO `site_lang` VALUES ('271', '32', 'When someone send me a message');
INSERT INTO `site_lang` VALUES ('272', '32', 'Day');
INSERT INTO `site_lang` VALUES ('273', '32', 'Month');
INSERT INTO `site_lang` VALUES ('269', '32', 'When i get a match');
INSERT INTO `site_lang` VALUES ('270', '32', 'When new users near me join in');
INSERT INTO `site_lang` VALUES ('267', '32', 'None');
INSERT INTO `site_lang` VALUES ('268', '32', 'When someone likes me');
INSERT INTO `site_lang` VALUES ('265', '32', 'I own a car');
INSERT INTO `site_lang` VALUES ('266', '32', 'I own a motorbike');
INSERT INTO `site_lang` VALUES ('264', '32', 'Parents car');
INSERT INTO `site_lang` VALUES ('263', '32', 'Transport');
INSERT INTO `site_lang` VALUES ('262', '32', 'Drink');
INSERT INTO `site_lang` VALUES ('260', '32', 'No');
INSERT INTO `site_lang` VALUES ('261', '32', 'Sometimes');
INSERT INTO `site_lang` VALUES ('258', '32', 'Smoke');
INSERT INTO `site_lang` VALUES ('259', '32', 'Yes');
INSERT INTO `site_lang` VALUES ('257', '32', 'Alone');
INSERT INTO `site_lang` VALUES ('256', '32', 'With partner');
INSERT INTO `site_lang` VALUES ('255', '32', 'Student dormitory');
INSERT INTO `site_lang` VALUES ('254', '32', 'With housemate');
INSERT INTO `site_lang` VALUES ('252', '32', 'Living');
INSERT INTO `site_lang` VALUES ('253', '32', 'With parents');
INSERT INTO `site_lang` VALUES ('251', '32', 'Curvy');
INSERT INTO `site_lang` VALUES ('250', '32', 'Heavy set');
INSERT INTO `site_lang` VALUES ('249', '32', 'Athletic');
INSERT INTO `site_lang` VALUES ('248', '32', 'Average');
INSERT INTO `site_lang` VALUES ('247', '32', 'Slim');
INSERT INTO `site_lang` VALUES ('246', '32', 'Body type');
INSERT INTO `site_lang` VALUES ('245', '32', 'Other');
INSERT INTO `site_lang` VALUES ('244', '32', 'Indian');
INSERT INTO `site_lang` VALUES ('243', '32', 'Pacific Islander');
INSERT INTO `site_lang` VALUES ('242', '32', 'Hispanic/latin');
INSERT INTO `site_lang` VALUES ('241', '32', 'Native American');
INSERT INTO `site_lang` VALUES ('240', '32', 'White');
INSERT INTO `site_lang` VALUES ('239', '32', 'Black');
INSERT INTO `site_lang` VALUES ('238', '32', 'Middle Eastern');
INSERT INTO `site_lang` VALUES ('237', '32', 'Asian');
INSERT INTO `site_lang` VALUES ('236', '32', 'Ethnicity');
INSERT INTO `site_lang` VALUES ('234', '32', 'more than');
INSERT INTO `site_lang` VALUES ('235', '32', 'Weight');
INSERT INTO `site_lang` VALUES ('232', '32', 'Height');
INSERT INTO `site_lang` VALUES ('233', '32', 'less than');
INSERT INTO `site_lang` VALUES ('231', '32', 'Bisexual');
INSERT INTO `site_lang` VALUES ('230', '32', 'Straight');
INSERT INTO `site_lang` VALUES ('229', '32', 'Open-minded');
INSERT INTO `site_lang` VALUES ('228', '32', 'Gay');
INSERT INTO `site_lang` VALUES ('227', '32', 'Sexuality');
INSERT INTO `site_lang` VALUES ('226', '32', 'Open');
INSERT INTO `site_lang` VALUES ('223', '32', 'Relationship');
INSERT INTO `site_lang` VALUES ('224', '32', 'Single');
INSERT INTO `site_lang` VALUES ('225', '32', 'Taken');
INSERT INTO `site_lang` VALUES ('222', '32', 'Extended info (optional)');
INSERT INTO `site_lang` VALUES ('220', '32', 'UPGRADE');
INSERT INTO `site_lang` VALUES ('221', '32', 'Notifications');
INSERT INTO `site_lang` VALUES ('219', '32', 'Basic');
INSERT INTO `site_lang` VALUES ('218', '32', 'until');
INSERT INTO `site_lang` VALUES ('217', '32', 'Wait more');
INSERT INTO `site_lang` VALUES ('216', '32', 'End call');
INSERT INTO `site_lang` VALUES ('214', '32', 'Too long wait');
INSERT INTO `site_lang` VALUES ('215', '32', 'Seems that your friend do not have webcam or he is not available');
INSERT INTO `site_lang` VALUES ('213', '32', 'You cant make videocall because you dont have webcam');
INSERT INTO `site_lang` VALUES ('212', '32', 'Impossible to make a call!');
INSERT INTO `site_lang` VALUES ('211', '32', 'Only premium users can make videocalls');
INSERT INTO `site_lang` VALUES ('210', '32', 'You are already in a videocall, you have to end the other call before start another');
INSERT INTO `site_lang` VALUES ('209', '32', 'Please allow access to your Webcam.');
INSERT INTO `site_lang` VALUES ('208', '32', 'is offline, try again when your friend is online');
INSERT INTO `site_lang` VALUES ('207', '32', 'is in another videocall , you cant call now');
INSERT INTO `site_lang` VALUES ('206', '32', 'Yes, delete it!');
INSERT INTO `site_lang` VALUES ('205', '32', 'Your data will be lost without recovery, continue?');
INSERT INTO `site_lang` VALUES ('204', '32', 'Account termination');
INSERT INTO `site_lang` VALUES ('202', '32', 'Yes, buy it!');
INSERT INTO `site_lang` VALUES ('203', '32', 'Information updated successfully');
INSERT INTO `site_lang` VALUES ('201', '32', 'more daily conversation, cost ');
INSERT INTO `site_lang` VALUES ('200', '32', 'Expand daily limitation ');
INSERT INTO `site_lang` VALUES ('199', '32', 'You dont have enought credits for send the gift');
INSERT INTO `site_lang` VALUES ('198', '32', 'Please, select 1 gift');
INSERT INTO `site_lang` VALUES ('197', '32', 'Please, select 1 photo');
INSERT INTO `site_lang` VALUES ('196', '32', 'Please, select a payment method');
INSERT INTO `site_lang` VALUES ('195', '32', 'No thanks');
INSERT INTO `site_lang` VALUES ('194', '32', 'Get access');
INSERT INTO `site_lang` VALUES ('193', '32', 'private photos for ');
INSERT INTO `site_lang` VALUES ('192', '32', 'Get access to');
INSERT INTO `site_lang` VALUES ('191', '32', 'Buy private photos permission');
INSERT INTO `site_lang` VALUES ('189', '32', 'Yes, you can see my private photos');
INSERT INTO `site_lang` VALUES ('190', '32', 'No, i cant show you my private photos');
INSERT INTO `site_lang` VALUES ('188', '32', 'Email already exist, try another');
INSERT INTO `site_lang` VALUES ('186', '32', 'Choose city from the autocomplete');
INSERT INTO `site_lang` VALUES ('187', '32', 'Password too short');
INSERT INTO `site_lang` VALUES ('185', '32', 'Add a valid date');
INSERT INTO `site_lang` VALUES ('184', '32', 'Wrong password');
INSERT INTO `site_lang` VALUES ('183', '32', 'Email dont exist');
INSERT INTO `site_lang` VALUES ('182', '32', 'Please fill all the inputs');
INSERT INTO `site_lang` VALUES ('181', '32', 'Invalid email format');
INSERT INTO `site_lang` VALUES ('180', '32', 'Password recover');
INSERT INTO `site_lang` VALUES ('179', '32', 'Login to my account');
INSERT INTO `site_lang` VALUES ('178', '32', 'If you dont remember your password, click the link below to set a new one:');
INSERT INTO `site_lang` VALUES ('177', '32', 'Hi');
INSERT INTO `site_lang` VALUES ('176', '32', 'No');
INSERT INTO `site_lang` VALUES ('175', '32', 'Yes');
INSERT INTO `site_lang` VALUES ('173', '32', 'like this');
INSERT INTO `site_lang` VALUES ('174', '32', 'Hello, can i have access to your private photos ?');
INSERT INTO `site_lang` VALUES ('172', '32', 'persons more like this');
INSERT INTO `site_lang` VALUES ('167', '32', 'October');
INSERT INTO `site_lang` VALUES ('168', '32', 'November');
INSERT INTO `site_lang` VALUES ('169', '32', 'December');
INSERT INTO `site_lang` VALUES ('170', '32', 'Buy');
INSERT INTO `site_lang` VALUES ('171', '32', 'Days Premium');
INSERT INTO `site_lang` VALUES ('166', '32', 'September');
INSERT INTO `site_lang` VALUES ('165', '32', 'August');
INSERT INTO `site_lang` VALUES ('163', '32', 'June');
INSERT INTO `site_lang` VALUES ('164', '32', 'July');
INSERT INTO `site_lang` VALUES ('162', '32', 'May');
INSERT INTO `site_lang` VALUES ('161', '32', 'April');
INSERT INTO `site_lang` VALUES ('160', '32', 'March');
INSERT INTO `site_lang` VALUES ('158', '32', 'January');
INSERT INTO `site_lang` VALUES ('159', '32', 'February');
INSERT INTO `site_lang` VALUES ('154', '32', 'people found');
INSERT INTO `site_lang` VALUES ('155', '32', 'No popular users near you');
INSERT INTO `site_lang` VALUES ('156', '32', 'You dont have any fans yet');
INSERT INTO `site_lang` VALUES ('157', '32', 'You dont have matches yet');
INSERT INTO `site_lang` VALUES ('153', '32', 'Nothing found');
INSERT INTO `site_lang` VALUES ('152', '32', 'Verified');
INSERT INTO `site_lang` VALUES ('151', '32', 'Online now');
INSERT INTO `site_lang` VALUES ('150', '32', 'Delete profile');
INSERT INTO `site_lang` VALUES ('149', '32', 'After delete your profile, some of your data will be lost without recovery.');
INSERT INTO `site_lang` VALUES ('148', '32', 'Profile desactivation');
INSERT INTO `site_lang` VALUES ('147', '32', 'New password');
INSERT INTO `site_lang` VALUES ('146', '32', 'You can change your current password bellow');
INSERT INTO `site_lang` VALUES ('145', '32', 'Change password');
INSERT INTO `site_lang` VALUES ('144', '32', 'Upgrade to premium account');
INSERT INTO `site_lang` VALUES ('143', '32', 'Add credits');
INSERT INTO `site_lang` VALUES ('142', '32', 'Current credits');
INSERT INTO `site_lang` VALUES ('141', '32', 'Account type');
INSERT INTO `site_lang` VALUES ('140', '32', 'Buy credits for send Gifs and Unblock private photos');
INSERT INTO `site_lang` VALUES ('139', '32', 'You are account is already verified');
INSERT INTO `site_lang` VALUES ('138', '32', 'Connect with Facebook');
INSERT INTO `site_lang` VALUES ('137', '32', 'For verify your account , connect with your facebook account');
INSERT INTO `site_lang` VALUES ('136', '32', 'Verify account');
INSERT INTO `site_lang` VALUES ('135', '32', 'Update profile');
INSERT INTO `site_lang` VALUES ('134', '32', 'Site language');
INSERT INTO `site_lang` VALUES ('133', '32', 'You can edit your profile information bellow');
INSERT INTO `site_lang` VALUES ('132', '32', 'Personal information');
INSERT INTO `site_lang` VALUES ('131', '32', 'Delete');
INSERT INTO `site_lang` VALUES ('130', '32', 'Change password');
INSERT INTO `site_lang` VALUES ('129', '32', 'Verify');
INSERT INTO `site_lang` VALUES ('128', '32', 'Credits');
INSERT INTO `site_lang` VALUES ('127', '32', 'Personal');
INSERT INTO `site_lang` VALUES ('126', '32', 'Unblock private photos');
INSERT INTO `site_lang` VALUES ('125', '32', 'Ask permission to');
INSERT INTO `site_lang` VALUES ('124', '32', 'Now you have');
INSERT INTO `site_lang` VALUES ('123', '32', 'Credits successfully added to your account');
INSERT INTO `site_lang` VALUES ('122', '32', 'boys and girls');
INSERT INTO `site_lang` VALUES ('120', '32', 'Only boys');
INSERT INTO `site_lang` VALUES ('121', '32', 'Only girls');
INSERT INTO `site_lang` VALUES ('119', '32', 'years old');
INSERT INTO `site_lang` VALUES ('114', '32', 'in a radius of');
INSERT INTO `site_lang` VALUES ('115', '32', 'World');
INSERT INTO `site_lang` VALUES ('116', '32', 'Most popular users');
INSERT INTO `site_lang` VALUES ('117', '32', 'About ');
INSERT INTO `site_lang` VALUES ('118', '32', 'Personal info');
INSERT INTO `site_lang` VALUES ('113', '32', 'who are between');
INSERT INTO `site_lang` VALUES ('108', '32', 'Online now');
INSERT INTO `site_lang` VALUES ('109', '32', 'Show me');
INSERT INTO `site_lang` VALUES ('110', '32', 'Girls');
INSERT INTO `site_lang` VALUES ('111', '32', 'Boys');
INSERT INTO `site_lang` VALUES ('112', '32', 'Both');
INSERT INTO `site_lang` VALUES ('107', '32', 'All users');
INSERT INTO `site_lang` VALUES ('102', '32', 'Privacy Policy');
INSERT INTO `site_lang` VALUES ('103', '32', 'Terms of Use');
INSERT INTO `site_lang` VALUES ('104', '32', 'Please complete your profile before start in ');
INSERT INTO `site_lang` VALUES ('105', '32', 'Your matches');
INSERT INTO `site_lang` VALUES ('106', '32', 'Filter Search');
INSERT INTO `site_lang` VALUES ('101', '32', 'Your fans');
INSERT INTO `site_lang` VALUES ('97', '32', 'Upgrade your account to Premium');
INSERT INTO `site_lang` VALUES ('98', '32', 'and get up to');
INSERT INTO `site_lang` VALUES ('99', '32', 'daily conversations');
INSERT INTO `site_lang` VALUES ('100', '32', 'or wait until tomorrow for continue meeting people');
INSERT INTO `site_lang` VALUES ('96', '32', 'or');
INSERT INTO `site_lang` VALUES ('95', '32', 'more daily conversation');
INSERT INTO `site_lang` VALUES ('94', '32', 'Buy');
INSERT INTO `site_lang` VALUES ('93', '32', 'To continue chatting');
INSERT INTO `site_lang` VALUES ('92', '32', 'you have reached the limit of new daily conversations');
INSERT INTO `site_lang` VALUES ('91', '32', 'Chat');
INSERT INTO `site_lang` VALUES ('90', '32', 'Send');
INSERT INTO `site_lang` VALUES ('89', '32', 'Write text here');
INSERT INTO `site_lang` VALUES ('88', '32', 'Premium user badge');
INSERT INTO `site_lang` VALUES ('86', '32', 'Unlimited videocalls');
INSERT INTO `site_lang` VALUES ('87', '32', 'Unblock all private photos');
INSERT INTO `site_lang` VALUES ('85', '32', 'new chats per day');
INSERT INTO `site_lang` VALUES ('83', '32', 'Buy credits');
INSERT INTO `site_lang` VALUES ('84', '32', 'Premium Account Features');
INSERT INTO `site_lang` VALUES ('82', '32', 'Pay with');
INSERT INTO `site_lang` VALUES ('81', '32', 'Pay with');
INSERT INTO `site_lang` VALUES ('80', '32', 'Select payment method');
INSERT INTO `site_lang` VALUES ('79', '32', 'Select credits package');
INSERT INTO `site_lang` VALUES ('77', '32', 'Send gift');
INSERT INTO `site_lang` VALUES ('78', '32', 'Buy credits / Upgrade account');
INSERT INTO `site_lang` VALUES ('76', '32', 'Pick the gift you want to send to ');
INSERT INTO `site_lang` VALUES ('75', '32', 'Send gift to ');
INSERT INTO `site_lang` VALUES ('74', '32', 'Add photo');
INSERT INTO `site_lang` VALUES ('73', '32', 'Credits');
INSERT INTO `site_lang` VALUES ('72', '32', 'Pick the photo you want to show in the Spotlight, cost ');
INSERT INTO `site_lang` VALUES ('70', '32', 'add photos');
INSERT INTO `site_lang` VALUES ('71', '32', 'Add yourself to the Spotlight');
INSERT INTO `site_lang` VALUES ('68', '32', 'Private Photos');
INSERT INTO `site_lang` VALUES ('69', '32', 'Add your photos');
INSERT INTO `site_lang` VALUES ('67', '32', 'Public Photos');
INSERT INTO `site_lang` VALUES ('64', '32', 'Contact');
INSERT INTO `site_lang` VALUES ('65', '32', 'Manage your photos');
INSERT INTO `site_lang` VALUES ('66', '32', 'All Photos');
INSERT INTO `site_lang` VALUES ('61', '32', 'Who to like');
INSERT INTO `site_lang` VALUES ('62', '32', 'Terms');
INSERT INTO `site_lang` VALUES ('63', '32', 'Privacy');
INSERT INTO `site_lang` VALUES ('60', '32', 'New messages');
INSERT INTO `site_lang` VALUES ('58', '32', 'Conversations');
INSERT INTO `site_lang` VALUES ('59', '32', 'Online now');
INSERT INTO `site_lang` VALUES ('55', '32', 'Settings');
INSERT INTO `site_lang` VALUES ('56', '32', 'All');
INSERT INTO `site_lang` VALUES ('57', '32', 'Fans');
INSERT INTO `site_lang` VALUES ('54', '32', 'Manage photos');
INSERT INTO `site_lang` VALUES ('53', '32', 'Fans');
INSERT INTO `site_lang` VALUES ('52', '32', 'Most populars');
INSERT INTO `site_lang` VALUES ('51', '32', 'Matches');
INSERT INTO `site_lang` VALUES ('50', '32', 'Discover');
INSERT INTO `site_lang` VALUES ('49', '32', 'Meet new people');
INSERT INTO `site_lang` VALUES ('48', '32', 'Logout');
INSERT INTO `site_lang` VALUES ('47', '32', 'Settings');
INSERT INTO `site_lang` VALUES ('46', '32', 'Profile');
INSERT INTO `site_lang` VALUES ('45', '32', 'Privacy Policy');
INSERT INTO `site_lang` VALUES ('44', '32', 'and');
INSERT INTO `site_lang` VALUES ('43', '32', 'Terms and Conditions');
INSERT INTO `site_lang` VALUES ('41', '32', 'Sign up');
INSERT INTO `site_lang` VALUES ('42', '32', 'By continuing, you are confirming that you have read and agree to our');
INSERT INTO `site_lang` VALUES ('40', '32', 'Meet boys and girls');
INSERT INTO `site_lang` VALUES ('39', '32', 'Meet boys');
INSERT INTO `site_lang` VALUES ('38', '32', 'Meet girls');
INSERT INTO `site_lang` VALUES ('37', '32', 'Im here to');
INSERT INTO `site_lang` VALUES ('35', '32', 'Male');
INSERT INTO `site_lang` VALUES ('36', '32', 'Female');
INSERT INTO `site_lang` VALUES ('32', '32', 'City');
INSERT INTO `site_lang` VALUES ('33', '32', 'Where do you live?');
INSERT INTO `site_lang` VALUES ('34', '32', 'Gender');
INSERT INTO `site_lang` VALUES ('31', '32', 'Please select');
INSERT INTO `site_lang` VALUES ('30', '32', 'Birthday');
INSERT INTO `site_lang` VALUES ('29', '32', 'Password');
INSERT INTO `site_lang` VALUES ('28', '32', 'Email');
INSERT INTO `site_lang` VALUES ('26', '32', 'Name');
INSERT INTO `site_lang` VALUES ('27', '32', 'Your name or nickname');
INSERT INTO `site_lang` VALUES ('25', '32', 'Join the worlds bestest community for meeting new people!.');
INSERT INTO `site_lang` VALUES ('24', '32', 'Become a member now');
INSERT INTO `site_lang` VALUES ('23', '32', 'Play our popular Discover game and get matched with other users. Its a great way to break the ice and chat to new people.');
INSERT INTO `site_lang` VALUES ('22', '32', 'Matches');
INSERT INTO `site_lang` VALUES ('21', '32', 'We wont show your exact location, but you will be able to find people nearby who like the same things you do.');
INSERT INTO `site_lang` VALUES ('20', '32', 'People nearby');
INSERT INTO `site_lang` VALUES ('19', '32', 'You can make quality videocalls for free to anyone, without limits of call duration, just enjoy seeing the person who is chatting with you');
INSERT INTO `site_lang` VALUES ('18', '32', 'Video Chat');
INSERT INTO `site_lang` VALUES ('17', '32', 'Powerfull private chat for meet new friends, you can send emoticons and private photos to anyone.');
INSERT INTO `site_lang` VALUES ('16', '32', 'Chat');
INSERT INTO `site_lang` VALUES ('15', '32', 'Recover password');
INSERT INTO `site_lang` VALUES ('14', '32', 'Password recover');
INSERT INTO `site_lang` VALUES ('13', '32', 'Login now');
INSERT INTO `site_lang` VALUES ('9', '32', 'Welcome back');
INSERT INTO `site_lang` VALUES ('10', '32', 'Your email');
INSERT INTO `site_lang` VALUES ('11', '32', 'Your password');
INSERT INTO `site_lang` VALUES ('12', '32', 'do you forget your password?');
INSERT INTO `site_lang` VALUES ('8', '32', 'Create your account');
INSERT INTO `site_lang` VALUES ('7', '32', 'Connect with ');
INSERT INTO `site_lang` VALUES ('6', '32', 'SOON AVAILABLE');
INSERT INTO `site_lang` VALUES ('5', '32', 'Soon we will have our phone apps online');
INSERT INTO `site_lang` VALUES ('4', '32', 'Please visit us from your laptop or PC');
INSERT INTO `site_lang` VALUES ('3', '32', 'For now our site works only for Desktop users');
INSERT INTO `site_lang` VALUES ('2', '32', 'Welcome to the fastest growing place to meet new people');
INSERT INTO `site_lang` VALUES ('1', '32', 'Login');
INSERT INTO `site_lang` VALUES ('0', '32', 'meet new people!');
INSERT INTO `site_lang` VALUES ('384', '31', 'Ok, i understand');
INSERT INTO `site_lang` VALUES ('383', '31', 'must like you for start a videocall');
INSERT INTO `site_lang` VALUES ('382', '31', 'dont like you');
INSERT INTO `site_lang` VALUES ('381', '31', 'calling...');
INSERT INTO `site_lang` VALUES ('380', '31', 'Welcome to');
INSERT INTO `site_lang` VALUES ('379', '31', 'Go to');
INSERT INTO `site_lang` VALUES ('378', '31', 'Please save your connection information in a safe place');
INSERT INTO `site_lang` VALUES ('377', '31', 'Password');
INSERT INTO `site_lang` VALUES ('376', '31', 'E-mail');
INSERT INTO `site_lang` VALUES ('375', '31', 'Here are your connection details');
INSERT INTO `site_lang` VALUES ('374', '31', 'Start meeting new people now');
INSERT INTO `site_lang` VALUES ('373', '31', 'More than 1 million people have joined $site_name You probably want to know some of them.');
INSERT INTO `site_lang` VALUES ('372', '31', 'Add photos and complete your profile');
INSERT INTO `site_lang` VALUES ('371', '31', 'Nobody is going to fall in love with a blank page. The more information you get, the more chances to find that special someone!');
INSERT INTO `site_lang` VALUES ('370', '31', 'Meet new people');
INSERT INTO `site_lang` VALUES ('368', '31', 'In');
INSERT INTO `site_lang` VALUES ('369', '31', 'you can meet people instantly');
INSERT INTO `site_lang` VALUES ('367', '31', 'people in your area wants to know you');
INSERT INTO `site_lang` VALUES ('365', '31', 'Verify your account');
INSERT INTO `site_lang` VALUES ('366', '31', 'Newsflash');
INSERT INTO `site_lang` VALUES ('364', '31', 'Now you are a new member of');
INSERT INTO `site_lang` VALUES ('362', '31', 'Well done, now you are in');
INSERT INTO `site_lang` VALUES ('363', '31', 'Here are a few tips');
INSERT INTO `site_lang` VALUES ('360', '31', 'Check out the profile');
INSERT INTO `site_lang` VALUES ('361', '31', 'Welcome');
INSERT INTO `site_lang` VALUES ('359', '31', 'and lives closer to you');
INSERT INTO `site_lang` VALUES ('357', '31', 'is new and lives closer to you');
INSERT INTO `site_lang` VALUES ('358', '31', 'is new at');
INSERT INTO `site_lang` VALUES ('355', '31', 'Respond to');
INSERT INTO `site_lang` VALUES ('356', '31', 'Have fun!');
INSERT INTO `site_lang` VALUES ('353', '31', 'New message from');
INSERT INTO `site_lang` VALUES ('354', '31', 'you have a new message from');
INSERT INTO `site_lang` VALUES ('352', '31', 'Go and say something to');
INSERT INTO `site_lang` VALUES ('350', '31', 'Its a match!');
INSERT INTO `site_lang` VALUES ('351', '31', 'thinks the feeling is mutual');
INSERT INTO `site_lang` VALUES ('349', '31', 'You have a match at');
INSERT INTO `site_lang` VALUES ('348', '31', 'if you forgot your password, click on the link below to get a new');
INSERT INTO `site_lang` VALUES ('346', '31', 'Unsubscribe');
INSERT INTO `site_lang` VALUES ('347', '31', 'Choose a new password');
INSERT INTO `site_lang` VALUES ('345', '31', 'You received this notice because you registered as');
INSERT INTO `site_lang` VALUES ('343', '31', 'has seen you in discover and likes. The feeling is mutual?');
INSERT INTO `site_lang` VALUES ('344', '31', 'Find out if you also like');
INSERT INTO `site_lang` VALUES ('341', '31', 'We sent you a email with your info, it may take up to 1 min to arrive');
INSERT INTO `site_lang` VALUES ('342', '31', 'likes you and wants to chat in');
INSERT INTO `site_lang` VALUES ('339', '31', 'of');
INSERT INTO `site_lang` VALUES ('340', '31', 'Loading...');
INSERT INTO `site_lang` VALUES ('337', '31', 'is calling you..');
INSERT INTO `site_lang` VALUES ('338', '31', 'Photos of ');
INSERT INTO `site_lang` VALUES ('335', '31', 'Service cost');
INSERT INTO `site_lang` VALUES ('336', '31', 'Password successfully changed');
INSERT INTO `site_lang` VALUES ('333', '31', 'Wrong');
INSERT INTO `site_lang` VALUES ('334', '31', 'Spotlight');
INSERT INTO `site_lang` VALUES ('332', '31', 'days of Premium');
INSERT INTO `site_lang` VALUES ('331', '31', 'username');
INSERT INTO `site_lang` VALUES ('330', '31', 'You need to write your username!');
INSERT INTO `site_lang` VALUES ('329', '31', 'Write your instagram username');
INSERT INTO `site_lang` VALUES ('328', '31', 'Press backspace key for smart return to the meeting section.');
INSERT INTO `site_lang` VALUES ('327', '31', 'Are you sure you want to report');
INSERT INTO `site_lang` VALUES ('326', '31', 'Report and block');
INSERT INTO `site_lang` VALUES ('325', '31', 'is blocking you or you blocked him, you cant chat with him sorry');
INSERT INTO `site_lang` VALUES ('324', '31', 'We sended you a email for verify your account');
INSERT INTO `site_lang` VALUES ('323', '31', 'years old and im from');
INSERT INTO `site_lang` VALUES ('322', '31', 'Hi, im');
INSERT INTO `site_lang` VALUES ('321', '31', 'Please add a profile photo');
INSERT INTO `site_lang` VALUES ('319', '31', 'ago');
INSERT INTO `site_lang` VALUES ('320', '31', 'Please verify your account, check your email');
INSERT INTO `site_lang` VALUES ('318', '31', 'seconds');
INSERT INTO `site_lang` VALUES ('317', '31', 'minutes');
INSERT INTO `site_lang` VALUES ('316', '31', 'hours');
INSERT INTO `site_lang` VALUES ('315', '31', 'days');
INSERT INTO `site_lang` VALUES ('314', '31', 'months');
INSERT INTO `site_lang` VALUES ('313', '31', 'years');
INSERT INTO `site_lang` VALUES ('310', '31', 'hour');
INSERT INTO `site_lang` VALUES ('311', '31', 'minute');
INSERT INTO `site_lang` VALUES ('312', '31', 'second');
INSERT INTO `site_lang` VALUES ('309', '31', 'day');
INSERT INTO `site_lang` VALUES ('308', '31', 'month');
INSERT INTO `site_lang` VALUES ('307', '31', 'year');
INSERT INTO `site_lang` VALUES ('306', '31', '0 seconds');
INSERT INTO `site_lang` VALUES ('305', '31', 'Credits for $');
INSERT INTO `site_lang` VALUES ('304', '31', 'Cost');
INSERT INTO `site_lang` VALUES ('303', '31', 'You do not like anyone');
INSERT INTO `site_lang` VALUES ('299', '31', 'Dislike');
INSERT INTO `site_lang` VALUES ('300', '31', 'AGE');
INSERT INTO `site_lang` VALUES ('301', '31', 'You dont have any visit yet');
INSERT INTO `site_lang` VALUES ('302', '31', 'visited');
INSERT INTO `site_lang` VALUES ('298', '31', 'Like');
INSERT INTO `site_lang` VALUES ('297', '31', 'Messages');
INSERT INTO `site_lang` VALUES ('296', '31', 'people liked you, for see them');
INSERT INTO `site_lang` VALUES ('295', '31', 'People i like');
INSERT INTO `site_lang` VALUES ('294', '31', 'Upgrade your account to premium');
INSERT INTO `site_lang` VALUES ('293', '31', 'people visited your profile for see them');
INSERT INTO `site_lang` VALUES ('292', '31', 'Delete');
INSERT INTO `site_lang` VALUES ('291', '31', 'Public photo');
INSERT INTO `site_lang` VALUES ('289', '31', 'Set as profile');
INSERT INTO `site_lang` VALUES ('290', '31', 'Private photo');
INSERT INTO `site_lang` VALUES ('288', '31', 'get seen by millions');
INSERT INTO `site_lang` VALUES ('285', '31', 'Credits');
INSERT INTO `site_lang` VALUES ('286', '31', 'Visits');
INSERT INTO `site_lang` VALUES ('287', '31', 'Add me here');
INSERT INTO `site_lang` VALUES ('282', '31', 'Add from ');
INSERT INTO `site_lang` VALUES ('283', '31', 'Add');
INSERT INTO `site_lang` VALUES ('284', '31', 'Photos');
INSERT INTO `site_lang` VALUES ('281', '31', 'Private photos');
INSERT INTO `site_lang` VALUES ('279', '31', 'No data');
INSERT INTO `site_lang` VALUES ('280', '31', 'Public Photos');
INSERT INTO `site_lang` VALUES ('278', '31', 'Fans');
INSERT INTO `site_lang` VALUES ('277', '31', 'Report');
INSERT INTO `site_lang` VALUES ('276', '31', 'Interests');
INSERT INTO `site_lang` VALUES ('275', '31', 'Please wait');
INSERT INTO `site_lang` VALUES ('274', '31', 'Year');
INSERT INTO `site_lang` VALUES ('273', '31', 'Month');
INSERT INTO `site_lang` VALUES ('272', '31', 'Day');
INSERT INTO `site_lang` VALUES ('271', '31', 'When someone send me a message');
INSERT INTO `site_lang` VALUES ('269', '31', 'When i get a match');
INSERT INTO `site_lang` VALUES ('270', '31', 'When new users near me join in');
INSERT INTO `site_lang` VALUES ('268', '31', 'When someone likes me');
INSERT INTO `site_lang` VALUES ('267', '31', 'None');
INSERT INTO `site_lang` VALUES ('266', '31', 'I own a motorbike');
INSERT INTO `site_lang` VALUES ('265', '31', 'I own a car');
INSERT INTO `site_lang` VALUES ('264', '31', 'Parents car');
INSERT INTO `site_lang` VALUES ('263', '31', 'Transport');
INSERT INTO `site_lang` VALUES ('262', '31', 'Drink');
INSERT INTO `site_lang` VALUES ('261', '31', 'Sometimes');
INSERT INTO `site_lang` VALUES ('260', '31', 'No');
INSERT INTO `site_lang` VALUES ('259', '31', 'Yes');
INSERT INTO `site_lang` VALUES ('258', '31', 'Smoke');
INSERT INTO `site_lang` VALUES ('257', '31', 'Alone');
INSERT INTO `site_lang` VALUES ('256', '31', 'With partner');
INSERT INTO `site_lang` VALUES ('255', '31', 'Student dormitory');
INSERT INTO `site_lang` VALUES ('254', '31', 'With housemate');
INSERT INTO `site_lang` VALUES ('253', '31', 'With parents');
INSERT INTO `site_lang` VALUES ('252', '31', 'Living');
INSERT INTO `site_lang` VALUES ('251', '31', 'Curvy');
INSERT INTO `site_lang` VALUES ('249', '31', 'Athletic');
INSERT INTO `site_lang` VALUES ('250', '31', 'Heavy set');
INSERT INTO `site_lang` VALUES ('248', '31', 'Average');
INSERT INTO `site_lang` VALUES ('247', '31', 'Slim');
INSERT INTO `site_lang` VALUES ('246', '31', 'Body type');
INSERT INTO `site_lang` VALUES ('244', '31', 'Indian');
INSERT INTO `site_lang` VALUES ('245', '31', 'Other');
INSERT INTO `site_lang` VALUES ('243', '31', 'Pacific Islander');
INSERT INTO `site_lang` VALUES ('242', '31', 'Hispanic/latin');
INSERT INTO `site_lang` VALUES ('241', '31', 'Native American');
INSERT INTO `site_lang` VALUES ('240', '31', 'White');
INSERT INTO `site_lang` VALUES ('239', '31', 'Black');
INSERT INTO `site_lang` VALUES ('237', '31', 'Asian');
INSERT INTO `site_lang` VALUES ('238', '31', 'Middle Eastern');
INSERT INTO `site_lang` VALUES ('236', '31', 'Ethnicity');
INSERT INTO `site_lang` VALUES ('235', '31', 'Weight');
INSERT INTO `site_lang` VALUES ('234', '31', 'more than');
INSERT INTO `site_lang` VALUES ('232', '31', 'Height');
INSERT INTO `site_lang` VALUES ('233', '31', 'less than');
INSERT INTO `site_lang` VALUES ('231', '31', 'Bisexual');
INSERT INTO `site_lang` VALUES ('230', '31', 'Straight');
INSERT INTO `site_lang` VALUES ('229', '31', 'Open-minded');
INSERT INTO `site_lang` VALUES ('228', '31', 'Gay');
INSERT INTO `site_lang` VALUES ('227', '31', 'Sexuality');
INSERT INTO `site_lang` VALUES ('226', '31', 'Open');
INSERT INTO `site_lang` VALUES ('225', '31', 'Taken');
INSERT INTO `site_lang` VALUES ('224', '31', 'Single');
INSERT INTO `site_lang` VALUES ('219', '31', 'Basic');
INSERT INTO `site_lang` VALUES ('220', '31', 'UPGRADE');
INSERT INTO `site_lang` VALUES ('221', '31', 'Notifications');
INSERT INTO `site_lang` VALUES ('222', '31', 'Extended info (optional)');
INSERT INTO `site_lang` VALUES ('223', '31', 'Relationship');
INSERT INTO `site_lang` VALUES ('218', '31', 'until');
INSERT INTO `site_lang` VALUES ('215', '31', 'Seems that your friend do not have webcam or he is not available');
INSERT INTO `site_lang` VALUES ('217', '31', 'Wait more');
INSERT INTO `site_lang` VALUES ('216', '31', 'End call');
INSERT INTO `site_lang` VALUES ('214', '31', 'Too long wait');
INSERT INTO `site_lang` VALUES ('213', '31', 'You cant make videocall because you dont have webcam');
INSERT INTO `site_lang` VALUES ('212', '31', 'Impossible to make a call!');
INSERT INTO `site_lang` VALUES ('211', '31', 'Only premium users can make videocalls');
INSERT INTO `site_lang` VALUES ('210', '31', 'You are already in a videocall, you have to end the other call before start another');
INSERT INTO `site_lang` VALUES ('209', '31', 'Please allow access to your Webcam.');
INSERT INTO `site_lang` VALUES ('208', '31', 'is offline, try again when your friend is online');
INSERT INTO `site_lang` VALUES ('207', '31', 'is in another videocall , you cant call now');
INSERT INTO `site_lang` VALUES ('206', '31', 'Yes, delete it!');
INSERT INTO `site_lang` VALUES ('205', '31', 'Your data will be lost without recovery, continue?');
INSERT INTO `site_lang` VALUES ('204', '31', 'Account termination');
INSERT INTO `site_lang` VALUES ('203', '31', 'Information updated successfully');
INSERT INTO `site_lang` VALUES ('202', '31', 'Yes, buy it!');
INSERT INTO `site_lang` VALUES ('201', '31', 'more daily conversation, cost ');
INSERT INTO `site_lang` VALUES ('200', '31', 'Expand daily limitation ');
INSERT INTO `site_lang` VALUES ('199', '31', 'You dont have enought credits for send the gift');
INSERT INTO `site_lang` VALUES ('198', '31', 'Please, select 1 gift');
INSERT INTO `site_lang` VALUES ('197', '31', 'Please, select 1 photo');
INSERT INTO `site_lang` VALUES ('196', '31', 'Please, select a payment method');
INSERT INTO `site_lang` VALUES ('195', '31', 'No thanks');
INSERT INTO `site_lang` VALUES ('194', '31', 'Get access');
INSERT INTO `site_lang` VALUES ('193', '31', 'private photos for ');
INSERT INTO `site_lang` VALUES ('192', '31', 'Get access to');
INSERT INTO `site_lang` VALUES ('191', '31', 'Buy private photos permission');
INSERT INTO `site_lang` VALUES ('190', '31', 'No, i cant show you my private photos');
INSERT INTO `site_lang` VALUES ('189', '31', 'Yes, you can see my private photos');
INSERT INTO `site_lang` VALUES ('188', '31', 'Email already exist, try another');
INSERT INTO `site_lang` VALUES ('187', '31', 'Password too short');
INSERT INTO `site_lang` VALUES ('186', '31', 'Choose city from the autocomplete');
INSERT INTO `site_lang` VALUES ('182', '31', 'Please fill all the inputs');
INSERT INTO `site_lang` VALUES ('183', '31', 'Email dont exist');
INSERT INTO `site_lang` VALUES ('184', '31', 'Wrong password');
INSERT INTO `site_lang` VALUES ('185', '31', 'Add a valid date');
INSERT INTO `site_lang` VALUES ('179', '31', 'Login to my account');
INSERT INTO `site_lang` VALUES ('180', '31', 'Password recover');
INSERT INTO `site_lang` VALUES ('181', '31', 'Invalid email format');
INSERT INTO `site_lang` VALUES ('178', '31', 'If you dont remember your password, click the link below to set a new one:');
INSERT INTO `site_lang` VALUES ('174', '31', 'Hello, can i have access to your private photos ?');
INSERT INTO `site_lang` VALUES ('175', '31', 'Yes');
INSERT INTO `site_lang` VALUES ('176', '31', 'No');
INSERT INTO `site_lang` VALUES ('177', '31', 'Hi');
INSERT INTO `site_lang` VALUES ('173', '31', 'like this');
INSERT INTO `site_lang` VALUES ('167', '31', 'October');
INSERT INTO `site_lang` VALUES ('168', '31', 'November');
INSERT INTO `site_lang` VALUES ('169', '31', 'December');
INSERT INTO `site_lang` VALUES ('170', '31', 'Buy');
INSERT INTO `site_lang` VALUES ('171', '31', 'Days Premium');
INSERT INTO `site_lang` VALUES ('172', '31', 'persons more like this');
INSERT INTO `site_lang` VALUES ('166', '31', 'September');
INSERT INTO `site_lang` VALUES ('165', '31', 'August');
INSERT INTO `site_lang` VALUES ('164', '31', 'July');
INSERT INTO `site_lang` VALUES ('163', '31', 'June');
INSERT INTO `site_lang` VALUES ('161', '31', 'April');
INSERT INTO `site_lang` VALUES ('162', '31', 'May');
INSERT INTO `site_lang` VALUES ('160', '31', 'March');
INSERT INTO `site_lang` VALUES ('159', '31', 'February');
INSERT INTO `site_lang` VALUES ('158', '31', 'January');
INSERT INTO `site_lang` VALUES ('157', '31', 'You dont have matches yet');
INSERT INTO `site_lang` VALUES ('156', '31', 'You dont have any fans yet');
INSERT INTO `site_lang` VALUES ('154', '31', 'people found');
INSERT INTO `site_lang` VALUES ('155', '31', 'No popular users near you');
INSERT INTO `site_lang` VALUES ('152', '31', 'Verified');
INSERT INTO `site_lang` VALUES ('153', '31', 'Nothing found');
INSERT INTO `site_lang` VALUES ('150', '31', 'Delete profile');
INSERT INTO `site_lang` VALUES ('151', '31', 'Online now');
INSERT INTO `site_lang` VALUES ('149', '31', 'After delete your profile, some of your data will be lost without recovery.');
INSERT INTO `site_lang` VALUES ('148', '31', 'Profile desactivation');
INSERT INTO `site_lang` VALUES ('147', '31', 'New password');
INSERT INTO `site_lang` VALUES ('145', '31', 'Change password');
INSERT INTO `site_lang` VALUES ('146', '31', 'You can change your current password bellow');
INSERT INTO `site_lang` VALUES ('144', '31', 'Upgrade to premium account');
INSERT INTO `site_lang` VALUES ('143', '31', 'Add credits');
INSERT INTO `site_lang` VALUES ('142', '31', 'Current credits');
INSERT INTO `site_lang` VALUES ('141', '31', 'Account type');
INSERT INTO `site_lang` VALUES ('140', '31', 'Buy credits for send Gifs and Unblock private photos');
INSERT INTO `site_lang` VALUES ('139', '31', 'You are account is already verified');
INSERT INTO `site_lang` VALUES ('138', '31', 'Connect with Facebook');
INSERT INTO `site_lang` VALUES ('136', '31', 'Verify account');
INSERT INTO `site_lang` VALUES ('137', '31', 'For verify your account , connect with your facebook account');
INSERT INTO `site_lang` VALUES ('135', '31', 'Update profile');
INSERT INTO `site_lang` VALUES ('132', '31', 'Personal information');
INSERT INTO `site_lang` VALUES ('133', '31', 'You can edit your profile information bellow');
INSERT INTO `site_lang` VALUES ('134', '31', 'Site language');
INSERT INTO `site_lang` VALUES ('130', '31', 'Change password');
INSERT INTO `site_lang` VALUES ('131', '31', 'Delete');
INSERT INTO `site_lang` VALUES ('129', '31', 'Verify');
INSERT INTO `site_lang` VALUES ('128', '31', 'Credits');
INSERT INTO `site_lang` VALUES ('127', '31', 'Personal');
INSERT INTO `site_lang` VALUES ('125', '31', 'Ask permission to');
INSERT INTO `site_lang` VALUES ('126', '31', 'Unblock private photos');
INSERT INTO `site_lang` VALUES ('124', '31', 'Now you have');
INSERT INTO `site_lang` VALUES ('123', '31', 'Credits successfully added to your account');
INSERT INTO `site_lang` VALUES ('122', '31', 'boys and girls');
INSERT INTO `site_lang` VALUES ('121', '31', 'Only girls');
INSERT INTO `site_lang` VALUES ('120', '31', 'Only boys');
INSERT INTO `site_lang` VALUES ('119', '31', 'years old');
INSERT INTO `site_lang` VALUES ('118', '31', 'Personal info');
INSERT INTO `site_lang` VALUES ('117', '31', 'About ');
INSERT INTO `site_lang` VALUES ('116', '31', 'Most popular users');
INSERT INTO `site_lang` VALUES ('115', '31', 'World');
INSERT INTO `site_lang` VALUES ('114', '31', 'in a radius of');
INSERT INTO `site_lang` VALUES ('113', '31', 'who are between');
INSERT INTO `site_lang` VALUES ('112', '31', 'Both');
INSERT INTO `site_lang` VALUES ('111', '31', 'Boys');
INSERT INTO `site_lang` VALUES ('110', '31', 'Girls');
INSERT INTO `site_lang` VALUES ('108', '31', 'Online now');
INSERT INTO `site_lang` VALUES ('109', '31', 'Show me');
INSERT INTO `site_lang` VALUES ('107', '31', 'All users');
INSERT INTO `site_lang` VALUES ('106', '31', 'Filter Search');
INSERT INTO `site_lang` VALUES ('105', '31', 'Your matches');
INSERT INTO `site_lang` VALUES ('104', '31', 'Please complete your profile before start in ');
INSERT INTO `site_lang` VALUES ('103', '31', 'Terms of Use');
INSERT INTO `site_lang` VALUES ('102', '31', 'Privacy Policy');
INSERT INTO `site_lang` VALUES ('101', '31', 'Your fans');
INSERT INTO `site_lang` VALUES ('100', '31', 'or wait until tomorrow for continue meeting people');
INSERT INTO `site_lang` VALUES ('99', '31', 'daily conversations');
INSERT INTO `site_lang` VALUES ('98', '31', 'and get up to');
INSERT INTO `site_lang` VALUES ('97', '31', 'Upgrade your account to Premium');
INSERT INTO `site_lang` VALUES ('96', '31', 'or');
INSERT INTO `site_lang` VALUES ('95', '31', 'more daily conversation');
INSERT INTO `site_lang` VALUES ('94', '31', 'Buy');
INSERT INTO `site_lang` VALUES ('92', '31', 'you have reached the limit of new daily conversations');
INSERT INTO `site_lang` VALUES ('93', '31', 'To continue chatting');
INSERT INTO `site_lang` VALUES ('91', '31', 'Chat');
INSERT INTO `site_lang` VALUES ('90', '31', 'Send');
INSERT INTO `site_lang` VALUES ('89', '31', 'Write text here');
INSERT INTO `site_lang` VALUES ('88', '31', 'Premium user badge');
INSERT INTO `site_lang` VALUES ('87', '31', 'Unblock all private photos');
INSERT INTO `site_lang` VALUES ('86', '31', 'Unlimited videocalls');
INSERT INTO `site_lang` VALUES ('85', '31', 'new chats per day');
INSERT INTO `site_lang` VALUES ('83', '31', 'Buy credits');
INSERT INTO `site_lang` VALUES ('84', '31', 'Premium Account Features');
INSERT INTO `site_lang` VALUES ('81', '31', 'Pay with');
INSERT INTO `site_lang` VALUES ('82', '31', 'Pay with');
INSERT INTO `site_lang` VALUES ('80', '31', 'Select payment method');
INSERT INTO `site_lang` VALUES ('79', '31', 'Select credits package');
INSERT INTO `site_lang` VALUES ('78', '31', 'Buy credits / Upgrade account');
INSERT INTO `site_lang` VALUES ('77', '31', 'Send gift');
INSERT INTO `site_lang` VALUES ('76', '31', 'Pick the gift you want to send to ');
INSERT INTO `site_lang` VALUES ('75', '31', 'Send gift to ');
INSERT INTO `site_lang` VALUES ('74', '31', 'Add photo');
INSERT INTO `site_lang` VALUES ('73', '31', 'Credits');
INSERT INTO `site_lang` VALUES ('72', '31', 'Pick the photo you want to show in the Spotlight, cost ');
INSERT INTO `site_lang` VALUES ('71', '31', 'Add yourself to the Spotlight');
INSERT INTO `site_lang` VALUES ('70', '31', 'add photos');
INSERT INTO `site_lang` VALUES ('69', '31', 'Add your photos');
INSERT INTO `site_lang` VALUES ('68', '31', 'Private Photos');
INSERT INTO `site_lang` VALUES ('67', '31', 'Public Photos');
INSERT INTO `site_lang` VALUES ('66', '31', 'All Photos');
INSERT INTO `site_lang` VALUES ('65', '31', 'Manage your photos');
INSERT INTO `site_lang` VALUES ('64', '31', 'Contact');
INSERT INTO `site_lang` VALUES ('63', '31', 'Privacy');
INSERT INTO `site_lang` VALUES ('62', '31', 'Terms');
INSERT INTO `site_lang` VALUES ('61', '31', 'Who to like');
INSERT INTO `site_lang` VALUES ('60', '31', 'New messages');
INSERT INTO `site_lang` VALUES ('59', '31', 'Online now');
INSERT INTO `site_lang` VALUES ('58', '31', 'Conversations');
INSERT INTO `site_lang` VALUES ('57', '31', 'Fans');
INSERT INTO `site_lang` VALUES ('56', '31', 'All');
INSERT INTO `site_lang` VALUES ('55', '31', 'Settings');
INSERT INTO `site_lang` VALUES ('54', '31', 'Manage photos');
INSERT INTO `site_lang` VALUES ('53', '31', 'Fans');
INSERT INTO `site_lang` VALUES ('52', '31', 'Most populars');
INSERT INTO `site_lang` VALUES ('51', '31', 'Matches');
INSERT INTO `site_lang` VALUES ('50', '31', 'Discover');
INSERT INTO `site_lang` VALUES ('49', '31', 'Meet new people');
INSERT INTO `site_lang` VALUES ('48', '31', 'Logout');
INSERT INTO `site_lang` VALUES ('47', '31', 'Settings');
INSERT INTO `site_lang` VALUES ('43', '31', 'Terms and Conditions');
INSERT INTO `site_lang` VALUES ('44', '31', 'and');
INSERT INTO `site_lang` VALUES ('45', '31', 'Privacy Policy');
INSERT INTO `site_lang` VALUES ('46', '31', 'Profile');
INSERT INTO `site_lang` VALUES ('42', '31', 'By continuing, you are confirming that you have read and agree to our');
INSERT INTO `site_lang` VALUES ('41', '31', 'Sign up');
INSERT INTO `site_lang` VALUES ('40', '31', 'Meet boys and girls');
INSERT INTO `site_lang` VALUES ('39', '31', 'Meet boys');
INSERT INTO `site_lang` VALUES ('37', '31', 'Im here to');
INSERT INTO `site_lang` VALUES ('38', '31', 'Meet girls');
INSERT INTO `site_lang` VALUES ('32', '31', 'City');
INSERT INTO `site_lang` VALUES ('33', '31', 'Where do you live?');
INSERT INTO `site_lang` VALUES ('34', '31', 'Gender');
INSERT INTO `site_lang` VALUES ('35', '31', 'Male');
INSERT INTO `site_lang` VALUES ('36', '31', 'Female');
INSERT INTO `site_lang` VALUES ('31', '31', 'Please select');
INSERT INTO `site_lang` VALUES ('26', '31', 'Name');
INSERT INTO `site_lang` VALUES ('27', '31', 'Your name or nickname');
INSERT INTO `site_lang` VALUES ('28', '31', 'Email');
INSERT INTO `site_lang` VALUES ('29', '31', 'Password');
INSERT INTO `site_lang` VALUES ('30', '31', 'Birthday');
INSERT INTO `site_lang` VALUES ('24', '31', 'Become a member now');
INSERT INTO `site_lang` VALUES ('25', '31', 'Join the worlds bestest community for meeting new people!.');
INSERT INTO `site_lang` VALUES ('22', '31', 'Matches');
INSERT INTO `site_lang` VALUES ('23', '31', 'Play our popular Discover game and get matched with other users. Its a great way to break the ice and chat to new people.');
INSERT INTO `site_lang` VALUES ('20', '31', 'People nearby');
INSERT INTO `site_lang` VALUES ('21', '31', 'We wont show your exact location, but you will be able to find people nearby who like the same things you do.');
INSERT INTO `site_lang` VALUES ('19', '31', 'You can make quality videocalls for free to anyone, without limits of call duration, just enjoy seeing the person who is chatting with you');
INSERT INTO `site_lang` VALUES ('18', '31', 'Video Chat');
INSERT INTO `site_lang` VALUES ('16', '31', 'Chat');
INSERT INTO `site_lang` VALUES ('17', '31', 'Powerfull private chat for meet new friends, you can send emoticons and private photos to anyone.');
INSERT INTO `site_lang` VALUES ('15', '31', 'Recover password');
INSERT INTO `site_lang` VALUES ('14', '31', 'Password recover');
INSERT INTO `site_lang` VALUES ('13', '31', 'Login now');
INSERT INTO `site_lang` VALUES ('12', '31', 'do you forget your password?');
INSERT INTO `site_lang` VALUES ('11', '31', 'Your password');
INSERT INTO `site_lang` VALUES ('9', '31', 'Welcome back');
INSERT INTO `site_lang` VALUES ('10', '31', 'Your email');
INSERT INTO `site_lang` VALUES ('6', '31', 'SOON AVAILABLE');
INSERT INTO `site_lang` VALUES ('7', '31', 'Connect with ');
INSERT INTO `site_lang` VALUES ('8', '31', 'Create your account');
INSERT INTO `site_lang` VALUES ('5', '31', 'Soon we will have our phone apps online');
INSERT INTO `site_lang` VALUES ('4', '31', 'Please visit us from your laptop or PC');
INSERT INTO `site_lang` VALUES ('3', '31', 'For now our site works only for Desktop users');
INSERT INTO `site_lang` VALUES ('1', '31', 'Login');
INSERT INTO `site_lang` VALUES ('2', '31', 'Welcome to the fastest growing place to meet new people');
INSERT INTO `site_lang` VALUES ('0', '31', 'meet new people!');
INSERT INTO `site_lang` VALUES ('384', '30', 'Ok, i understand');
INSERT INTO `site_lang` VALUES ('383', '30', 'must like you for start a videocall');
INSERT INTO `site_lang` VALUES ('382', '30', 'dont like you');
INSERT INTO `site_lang` VALUES ('379', '30', 'Go to');
INSERT INTO `site_lang` VALUES ('380', '30', 'Welcome to');
INSERT INTO `site_lang` VALUES ('381', '30', 'calling...');
INSERT INTO `site_lang` VALUES ('378', '30', 'Please save your connection information in a safe place');
INSERT INTO `site_lang` VALUES ('377', '30', 'Password');
INSERT INTO `site_lang` VALUES ('376', '30', 'E-mail');
INSERT INTO `site_lang` VALUES ('375', '30', 'Here are your connection details');
INSERT INTO `site_lang` VALUES ('374', '30', 'Start meeting new people now');
INSERT INTO `site_lang` VALUES ('373', '30', 'More than 1 million people have joined $site_name You probably want to know some of them.');
INSERT INTO `site_lang` VALUES ('372', '30', 'Add photos and complete your profile');
INSERT INTO `site_lang` VALUES ('371', '30', 'Nobody is going to fall in love with a blank page. The more information you get, the more chances to find that special someone!');
INSERT INTO `site_lang` VALUES ('370', '30', 'Meet new people');
INSERT INTO `site_lang` VALUES ('369', '30', 'you can meet people instantly');
INSERT INTO `site_lang` VALUES ('366', '30', 'Newsflash');
INSERT INTO `site_lang` VALUES ('367', '30', 'people in your area wants to know you');
INSERT INTO `site_lang` VALUES ('368', '30', 'In');
INSERT INTO `site_lang` VALUES ('365', '30', 'Verify your account');
INSERT INTO `site_lang` VALUES ('363', '30', 'Here are a few tips');
INSERT INTO `site_lang` VALUES ('364', '30', 'Now you are a new member of');
INSERT INTO `site_lang` VALUES ('362', '30', 'Well done, now you are in');
INSERT INTO `site_lang` VALUES ('361', '30', 'Welcome');
INSERT INTO `site_lang` VALUES ('360', '30', 'Check out the profile');
INSERT INTO `site_lang` VALUES ('359', '30', 'and lives closer to you');
INSERT INTO `site_lang` VALUES ('357', '30', 'is new and lives closer to you');
INSERT INTO `site_lang` VALUES ('358', '30', 'is new at');
INSERT INTO `site_lang` VALUES ('355', '30', 'Respond to');
INSERT INTO `site_lang` VALUES ('356', '30', 'Have fun!');
INSERT INTO `site_lang` VALUES ('354', '30', 'you have a new message from');
INSERT INTO `site_lang` VALUES ('352', '30', 'Go and say something to');
INSERT INTO `site_lang` VALUES ('353', '30', 'New message from');
INSERT INTO `site_lang` VALUES ('351', '30', 'thinks the feeling is mutual');
INSERT INTO `site_lang` VALUES ('350', '30', 'Its a match!');
INSERT INTO `site_lang` VALUES ('349', '30', 'You have a match at');
INSERT INTO `site_lang` VALUES ('348', '30', 'if you forgot your password, click on the link below to get a new');
INSERT INTO `site_lang` VALUES ('347', '30', 'Choose a new password');
INSERT INTO `site_lang` VALUES ('346', '30', 'Unsubscribe');
INSERT INTO `site_lang` VALUES ('345', '30', 'You received this notice because you registered as');
INSERT INTO `site_lang` VALUES ('344', '30', 'Find out if you also like');
INSERT INTO `site_lang` VALUES ('343', '30', 'has seen you in discover and likes. The feeling is mutual?');
INSERT INTO `site_lang` VALUES ('342', '30', 'likes you and wants to chat in');
INSERT INTO `site_lang` VALUES ('341', '30', 'We sent you a email with your info, it may take up to 1 min to arrive');
INSERT INTO `site_lang` VALUES ('340', '30', 'Loading...');
INSERT INTO `site_lang` VALUES ('339', '30', 'of');
INSERT INTO `site_lang` VALUES ('338', '30', 'Photos of ');
INSERT INTO `site_lang` VALUES ('337', '30', 'is calling you..');
INSERT INTO `site_lang` VALUES ('336', '30', 'Password successfully changed');
INSERT INTO `site_lang` VALUES ('335', '30', 'Service cost');
INSERT INTO `site_lang` VALUES ('331', '30', 'username');
INSERT INTO `site_lang` VALUES ('332', '30', 'days of Premium');
INSERT INTO `site_lang` VALUES ('333', '30', 'Wrong');
INSERT INTO `site_lang` VALUES ('334', '30', 'Spotlight');
INSERT INTO `site_lang` VALUES ('330', '30', 'You need to write your username!');
INSERT INTO `site_lang` VALUES ('329', '30', 'Write your instagram username');
INSERT INTO `site_lang` VALUES ('328', '30', 'Press backspace key for smart return to the meeting section.');
INSERT INTO `site_lang` VALUES ('327', '30', 'Are you sure you want to report');
INSERT INTO `site_lang` VALUES ('326', '30', 'Report and block');
INSERT INTO `site_lang` VALUES ('325', '30', 'is blocking you or you blocked him, you cant chat with him sorry');
INSERT INTO `site_lang` VALUES ('323', '30', 'years old and im from');
INSERT INTO `site_lang` VALUES ('324', '30', 'We sended you a email for verify your account');
INSERT INTO `site_lang` VALUES ('322', '30', 'Hi, im');
INSERT INTO `site_lang` VALUES ('321', '30', 'Please add a profile photo');
INSERT INTO `site_lang` VALUES ('320', '30', 'Please verify your account, check your email');
INSERT INTO `site_lang` VALUES ('319', '30', 'ago');
INSERT INTO `site_lang` VALUES ('318', '30', 'seconds');
INSERT INTO `site_lang` VALUES ('317', '30', 'minutes');
INSERT INTO `site_lang` VALUES ('315', '30', 'days');
INSERT INTO `site_lang` VALUES ('316', '30', 'hours');
INSERT INTO `site_lang` VALUES ('314', '30', 'months');
INSERT INTO `site_lang` VALUES ('313', '30', 'years');
INSERT INTO `site_lang` VALUES ('312', '30', 'second');
INSERT INTO `site_lang` VALUES ('311', '30', 'minute');
INSERT INTO `site_lang` VALUES ('310', '30', 'hour');
INSERT INTO `site_lang` VALUES ('309', '30', 'day');
INSERT INTO `site_lang` VALUES ('308', '30', 'month');
INSERT INTO `site_lang` VALUES ('307', '30', 'year');
INSERT INTO `site_lang` VALUES ('306', '30', '0 seconds');
INSERT INTO `site_lang` VALUES ('305', '30', 'Credits for $');
INSERT INTO `site_lang` VALUES ('304', '30', 'Cost');
INSERT INTO `site_lang` VALUES ('303', '30', 'You do not like anyone');
INSERT INTO `site_lang` VALUES ('299', '30', 'Dislike');
INSERT INTO `site_lang` VALUES ('300', '30', 'AGE');
INSERT INTO `site_lang` VALUES ('301', '30', 'You dont have any visit yet');
INSERT INTO `site_lang` VALUES ('302', '30', 'visited');
INSERT INTO `site_lang` VALUES ('298', '30', 'Like');
INSERT INTO `site_lang` VALUES ('297', '30', 'Messages');
INSERT INTO `site_lang` VALUES ('296', '30', 'people liked you, for see them');
INSERT INTO `site_lang` VALUES ('293', '30', 'people visited your profile for see them');
INSERT INTO `site_lang` VALUES ('294', '30', 'Upgrade your account to premium');
INSERT INTO `site_lang` VALUES ('295', '30', 'People i like');
INSERT INTO `site_lang` VALUES ('292', '30', 'Delete');
INSERT INTO `site_lang` VALUES ('291', '30', 'Public photo');
INSERT INTO `site_lang` VALUES ('290', '30', 'Private photo');
INSERT INTO `site_lang` VALUES ('289', '30', 'Set as profile');
INSERT INTO `site_lang` VALUES ('288', '30', 'get seen by millions');
INSERT INTO `site_lang` VALUES ('286', '30', 'Visits');
INSERT INTO `site_lang` VALUES ('287', '30', 'Add me here');
INSERT INTO `site_lang` VALUES ('285', '30', 'Credits');
INSERT INTO `site_lang` VALUES ('284', '30', 'Photos');
INSERT INTO `site_lang` VALUES ('283', '30', 'Add');
INSERT INTO `site_lang` VALUES ('282', '30', 'Add from ');
INSERT INTO `site_lang` VALUES ('281', '30', 'Private photos');
INSERT INTO `site_lang` VALUES ('280', '30', 'Public Photos');
INSERT INTO `site_lang` VALUES ('279', '30', 'No data');
INSERT INTO `site_lang` VALUES ('278', '30', 'Fans');
INSERT INTO `site_lang` VALUES ('277', '30', 'Report');
INSERT INTO `site_lang` VALUES ('276', '30', 'Interests');
INSERT INTO `site_lang` VALUES ('275', '30', 'Please wait');
INSERT INTO `site_lang` VALUES ('274', '30', 'Year');
INSERT INTO `site_lang` VALUES ('273', '30', 'Month');
INSERT INTO `site_lang` VALUES ('272', '30', 'Day');
INSERT INTO `site_lang` VALUES ('271', '30', 'When someone send me a message');
INSERT INTO `site_lang` VALUES ('270', '30', 'When new users near me join in');
INSERT INTO `site_lang` VALUES ('269', '30', 'When i get a match');
INSERT INTO `site_lang` VALUES ('268', '30', 'When someone likes me');
INSERT INTO `site_lang` VALUES ('267', '30', 'None');
INSERT INTO `site_lang` VALUES ('266', '30', 'I own a motorbike');
INSERT INTO `site_lang` VALUES ('265', '30', 'I own a car');
INSERT INTO `site_lang` VALUES ('264', '30', 'Parents car');
INSERT INTO `site_lang` VALUES ('263', '30', 'Transport');
INSERT INTO `site_lang` VALUES ('262', '30', 'Drink');
INSERT INTO `site_lang` VALUES ('261', '30', 'Sometimes');
INSERT INTO `site_lang` VALUES ('260', '30', 'No');
INSERT INTO `site_lang` VALUES ('259', '30', 'Yes');
INSERT INTO `site_lang` VALUES ('258', '30', 'Smoke');
INSERT INTO `site_lang` VALUES ('257', '30', 'Alone');
INSERT INTO `site_lang` VALUES ('256', '30', 'With partner');
INSERT INTO `site_lang` VALUES ('255', '30', 'Student dormitory');
INSERT INTO `site_lang` VALUES ('254', '30', 'With housemate');
INSERT INTO `site_lang` VALUES ('253', '30', 'With parents');
INSERT INTO `site_lang` VALUES ('252', '30', 'Living');
INSERT INTO `site_lang` VALUES ('251', '30', 'Curvy');
INSERT INTO `site_lang` VALUES ('249', '30', 'Athletic');
INSERT INTO `site_lang` VALUES ('250', '30', 'Heavy set');
INSERT INTO `site_lang` VALUES ('248', '30', 'Average');
INSERT INTO `site_lang` VALUES ('243', '30', 'Pacific Islander');
INSERT INTO `site_lang` VALUES ('244', '30', 'Indian');
INSERT INTO `site_lang` VALUES ('245', '30', 'Other');
INSERT INTO `site_lang` VALUES ('246', '30', 'Body type');
INSERT INTO `site_lang` VALUES ('247', '30', 'Slim');
INSERT INTO `site_lang` VALUES ('238', '30', 'Middle Eastern');
INSERT INTO `site_lang` VALUES ('239', '30', 'Black');
INSERT INTO `site_lang` VALUES ('240', '30', 'White');
INSERT INTO `site_lang` VALUES ('241', '30', 'Native American');
INSERT INTO `site_lang` VALUES ('242', '30', 'Hispanic/latin');
INSERT INTO `site_lang` VALUES ('237', '30', 'Asian');
INSERT INTO `site_lang` VALUES ('231', '30', 'Bisexual');
INSERT INTO `site_lang` VALUES ('232', '30', 'Height');
INSERT INTO `site_lang` VALUES ('233', '30', 'less than');
INSERT INTO `site_lang` VALUES ('234', '30', 'more than');
INSERT INTO `site_lang` VALUES ('235', '30', 'Weight');
INSERT INTO `site_lang` VALUES ('236', '30', 'Ethnicity');
INSERT INTO `site_lang` VALUES ('230', '30', 'Straight');
INSERT INTO `site_lang` VALUES ('223', '30', 'Relationship');
INSERT INTO `site_lang` VALUES ('224', '30', 'Single');
INSERT INTO `site_lang` VALUES ('225', '30', 'Taken');
INSERT INTO `site_lang` VALUES ('226', '30', 'Open');
INSERT INTO `site_lang` VALUES ('227', '30', 'Sexuality');
INSERT INTO `site_lang` VALUES ('228', '30', 'Gay');
INSERT INTO `site_lang` VALUES ('229', '30', 'Open-minded');
INSERT INTO `site_lang` VALUES ('221', '30', 'Notifications');
INSERT INTO `site_lang` VALUES ('222', '30', 'Extended info (optional)');
INSERT INTO `site_lang` VALUES ('220', '30', 'UPGRADE');
INSERT INTO `site_lang` VALUES ('219', '30', 'Basic');
INSERT INTO `site_lang` VALUES ('218', '30', 'until');
INSERT INTO `site_lang` VALUES ('217', '30', 'Wait more');
INSERT INTO `site_lang` VALUES ('216', '30', 'End call');
INSERT INTO `site_lang` VALUES ('214', '30', 'Too long wait');
INSERT INTO `site_lang` VALUES ('215', '30', 'Seems that your friend do not have webcam or he is not available');
INSERT INTO `site_lang` VALUES ('213', '30', 'You cant make videocall because you dont have webcam');
INSERT INTO `site_lang` VALUES ('212', '30', 'Impossible to make a call!');
INSERT INTO `site_lang` VALUES ('211', '30', 'Only premium users can make videocalls');
INSERT INTO `site_lang` VALUES ('209', '30', 'Please allow access to your Webcam.');
INSERT INTO `site_lang` VALUES ('210', '30', 'You are already in a videocall, you have to end the other call before start another');
INSERT INTO `site_lang` VALUES ('208', '30', 'is offline, try again when your friend is online');
INSERT INTO `site_lang` VALUES ('207', '30', 'is in another videocall , you cant call now');
INSERT INTO `site_lang` VALUES ('206', '30', 'Yes, delete it!');
INSERT INTO `site_lang` VALUES ('205', '30', 'Your data will be lost without recovery, continue?');
INSERT INTO `site_lang` VALUES ('204', '30', 'Account termination');
INSERT INTO `site_lang` VALUES ('201', '30', 'more daily conversation, cost ');
INSERT INTO `site_lang` VALUES ('202', '30', 'Yes, buy it!');
INSERT INTO `site_lang` VALUES ('203', '30', 'Information updated successfully');
INSERT INTO `site_lang` VALUES ('200', '30', 'Expand daily limitation ');
INSERT INTO `site_lang` VALUES ('196', '30', 'Please, select a payment method');
INSERT INTO `site_lang` VALUES ('197', '30', 'Please, select 1 photo');
INSERT INTO `site_lang` VALUES ('198', '30', 'Please, select 1 gift');
INSERT INTO `site_lang` VALUES ('199', '30', 'You dont have enought credits for send the gift');
INSERT INTO `site_lang` VALUES ('195', '30', 'No thanks');
INSERT INTO `site_lang` VALUES ('194', '30', 'Get access');
INSERT INTO `site_lang` VALUES ('193', '30', 'private photos for ');
INSERT INTO `site_lang` VALUES ('192', '30', 'Get access to');
INSERT INTO `site_lang` VALUES ('191', '30', 'Buy private photos permission');
INSERT INTO `site_lang` VALUES ('190', '30', 'No, i cant show you my private photos');
INSERT INTO `site_lang` VALUES ('189', '30', 'Yes, you can see my private photos');
INSERT INTO `site_lang` VALUES ('188', '30', 'Email already exist, try another');
INSERT INTO `site_lang` VALUES ('187', '30', 'Password too short');
INSERT INTO `site_lang` VALUES ('186', '30', 'Choose city from the autocomplete');
INSERT INTO `site_lang` VALUES ('185', '30', 'Add a valid date');
INSERT INTO `site_lang` VALUES ('184', '30', 'Wrong password');
INSERT INTO `site_lang` VALUES ('183', '30', 'Email dont exist');
INSERT INTO `site_lang` VALUES ('182', '30', 'Please fill all the inputs');
INSERT INTO `site_lang` VALUES ('181', '30', 'Invalid email format');
INSERT INTO `site_lang` VALUES ('180', '30', 'Password recover');
INSERT INTO `site_lang` VALUES ('179', '30', 'Login to my account');
INSERT INTO `site_lang` VALUES ('177', '30', 'Hi');
INSERT INTO `site_lang` VALUES ('178', '30', 'If you dont remember your password, click the link below to set a new one:');
INSERT INTO `site_lang` VALUES ('174', '30', 'Hello, can i have access to your private photos ?');
INSERT INTO `site_lang` VALUES ('176', '30', 'No');
INSERT INTO `site_lang` VALUES ('175', '30', 'Yes');
INSERT INTO `site_lang` VALUES ('171', '30', 'Days Premium');
INSERT INTO `site_lang` VALUES ('172', '30', 'persons more like this');
INSERT INTO `site_lang` VALUES ('173', '30', 'like this');
INSERT INTO `site_lang` VALUES ('170', '30', 'Buy');
INSERT INTO `site_lang` VALUES ('168', '30', 'November');
INSERT INTO `site_lang` VALUES ('169', '30', 'December');
INSERT INTO `site_lang` VALUES ('167', '30', 'October');
INSERT INTO `site_lang` VALUES ('166', '30', 'September');
INSERT INTO `site_lang` VALUES ('164', '30', 'July');
INSERT INTO `site_lang` VALUES ('165', '30', 'August');
INSERT INTO `site_lang` VALUES ('163', '30', 'June');
INSERT INTO `site_lang` VALUES ('162', '30', 'May');
INSERT INTO `site_lang` VALUES ('161', '30', 'April');
INSERT INTO `site_lang` VALUES ('160', '30', 'March');
INSERT INTO `site_lang` VALUES ('159', '30', 'February');
INSERT INTO `site_lang` VALUES ('158', '30', 'January');
INSERT INTO `site_lang` VALUES ('157', '30', 'You dont have matches yet');
INSERT INTO `site_lang` VALUES ('156', '30', 'You dont have any fans yet');
INSERT INTO `site_lang` VALUES ('155', '30', 'No popular users near you');
INSERT INTO `site_lang` VALUES ('154', '30', 'people found');
INSERT INTO `site_lang` VALUES ('153', '30', 'Nothing found');
INSERT INTO `site_lang` VALUES ('152', '30', 'Verified');
INSERT INTO `site_lang` VALUES ('151', '30', 'Online now');
INSERT INTO `site_lang` VALUES ('150', '30', 'Delete profile');
INSERT INTO `site_lang` VALUES ('149', '30', 'After delete your profile, some of your data will be lost without recovery.');
INSERT INTO `site_lang` VALUES ('148', '30', 'Profile desactivation');
INSERT INTO `site_lang` VALUES ('147', '30', 'New password');
INSERT INTO `site_lang` VALUES ('145', '30', 'Change password');
INSERT INTO `site_lang` VALUES ('146', '30', 'You can change your current password bellow');
INSERT INTO `site_lang` VALUES ('144', '30', 'Upgrade to premium account');
INSERT INTO `site_lang` VALUES ('143', '30', 'Add credits');
INSERT INTO `site_lang` VALUES ('142', '30', 'Current credits');
INSERT INTO `site_lang` VALUES ('141', '30', 'Account type');
INSERT INTO `site_lang` VALUES ('140', '30', 'Buy credits for send Gifs and Unblock private photos');
INSERT INTO `site_lang` VALUES ('139', '30', 'You are account is already verified');
INSERT INTO `site_lang` VALUES ('138', '30', 'Connect with Facebook');
INSERT INTO `site_lang` VALUES ('137', '30', 'For verify your account , connect with your facebook account');
INSERT INTO `site_lang` VALUES ('136', '30', 'Verify account');
INSERT INTO `site_lang` VALUES ('135', '30', 'Update profile');
INSERT INTO `site_lang` VALUES ('134', '30', 'Site language');
INSERT INTO `site_lang` VALUES ('133', '30', 'You can edit your profile information bellow');
INSERT INTO `site_lang` VALUES ('132', '30', 'Personal information');
INSERT INTO `site_lang` VALUES ('131', '30', 'Delete');
INSERT INTO `site_lang` VALUES ('130', '30', 'Change password');
INSERT INTO `site_lang` VALUES ('129', '30', 'Verify');
INSERT INTO `site_lang` VALUES ('128', '30', 'Credits');
INSERT INTO `site_lang` VALUES ('127', '30', 'Personal');
INSERT INTO `site_lang` VALUES ('126', '30', 'Unblock private photos');
INSERT INTO `site_lang` VALUES ('125', '30', 'Ask permission to');
INSERT INTO `site_lang` VALUES ('124', '30', 'Now you have');
INSERT INTO `site_lang` VALUES ('123', '30', 'Credits successfully added to your account');
INSERT INTO `site_lang` VALUES ('122', '30', 'boys and girls');
INSERT INTO `site_lang` VALUES ('121', '30', 'Only girls');
INSERT INTO `site_lang` VALUES ('120', '30', 'Only boys');
INSERT INTO `site_lang` VALUES ('119', '30', 'years old');
INSERT INTO `site_lang` VALUES ('118', '30', 'Personal info');
INSERT INTO `site_lang` VALUES ('117', '30', 'About ');
INSERT INTO `site_lang` VALUES ('116', '30', 'Most popular users');
INSERT INTO `site_lang` VALUES ('115', '30', 'World');
INSERT INTO `site_lang` VALUES ('114', '30', 'in a radius of');
INSERT INTO `site_lang` VALUES ('113', '30', 'who are between');
INSERT INTO `site_lang` VALUES ('112', '30', 'Both');
INSERT INTO `site_lang` VALUES ('111', '30', 'Boys');
INSERT INTO `site_lang` VALUES ('110', '30', 'Girls');
INSERT INTO `site_lang` VALUES ('109', '30', 'Show me');
INSERT INTO `site_lang` VALUES ('108', '30', 'Online now');
INSERT INTO `site_lang` VALUES ('107', '30', 'All users');
INSERT INTO `site_lang` VALUES ('106', '30', 'Filter Search');
INSERT INTO `site_lang` VALUES ('105', '30', 'Your matches');
INSERT INTO `site_lang` VALUES ('104', '30', 'Please complete your profile before start in ');
INSERT INTO `site_lang` VALUES ('103', '30', 'Terms of Use');
INSERT INTO `site_lang` VALUES ('101', '30', 'Your fans');
INSERT INTO `site_lang` VALUES ('102', '30', 'Privacy Policy');
INSERT INTO `site_lang` VALUES ('100', '30', 'or wait until tomorrow for continue meeting people');
INSERT INTO `site_lang` VALUES ('97', '30', 'Upgrade your account to Premium');
INSERT INTO `site_lang` VALUES ('98', '30', 'and get up to');
INSERT INTO `site_lang` VALUES ('99', '30', 'daily conversations');
INSERT INTO `site_lang` VALUES ('96', '30', 'or');
INSERT INTO `site_lang` VALUES ('93', '30', 'To continue chatting');
INSERT INTO `site_lang` VALUES ('94', '30', 'Buy');
INSERT INTO `site_lang` VALUES ('95', '30', 'more daily conversation');
INSERT INTO `site_lang` VALUES ('92', '30', 'you have reached the limit of new daily conversations');
INSERT INTO `site_lang` VALUES ('88', '30', 'Premium user badge');
INSERT INTO `site_lang` VALUES ('89', '30', 'Write text here');
INSERT INTO `site_lang` VALUES ('90', '30', 'Send');
INSERT INTO `site_lang` VALUES ('91', '30', 'Chat');
INSERT INTO `site_lang` VALUES ('85', '30', 'new chats per day');
INSERT INTO `site_lang` VALUES ('86', '30', 'Unlimited videocalls');
INSERT INTO `site_lang` VALUES ('87', '30', 'Unblock all private photos');
INSERT INTO `site_lang` VALUES ('83', '30', 'Buy credits');
INSERT INTO `site_lang` VALUES ('84', '30', 'Premium Account Features');
INSERT INTO `site_lang` VALUES ('82', '30', 'Pay with');
INSERT INTO `site_lang` VALUES ('80', '30', 'Select payment method');
INSERT INTO `site_lang` VALUES ('81', '30', 'Pay with');
INSERT INTO `site_lang` VALUES ('79', '30', 'Select credits package');
INSERT INTO `site_lang` VALUES ('78', '30', 'Buy credits / Upgrade account');
INSERT INTO `site_lang` VALUES ('77', '30', 'Send gift');
INSERT INTO `site_lang` VALUES ('75', '30', 'Send gift to ');
INSERT INTO `site_lang` VALUES ('76', '30', 'Pick the gift you want to send to ');
INSERT INTO `site_lang` VALUES ('74', '30', 'Add photo');
INSERT INTO `site_lang` VALUES ('73', '30', 'Credits');
INSERT INTO `site_lang` VALUES ('72', '30', 'Pick the photo you want to show in the Spotlight, cost ');
INSERT INTO `site_lang` VALUES ('70', '30', 'add photos');
INSERT INTO `site_lang` VALUES ('71', '30', 'Add yourself to the Spotlight');
INSERT INTO `site_lang` VALUES ('68', '30', 'Private Photos');
INSERT INTO `site_lang` VALUES ('69', '30', 'Add your photos');
INSERT INTO `site_lang` VALUES ('66', '30', 'All Photos');
INSERT INTO `site_lang` VALUES ('67', '30', 'Public Photos');
INSERT INTO `site_lang` VALUES ('64', '30', 'Contact');
INSERT INTO `site_lang` VALUES ('65', '30', 'Manage your photos');
INSERT INTO `site_lang` VALUES ('63', '30', 'Privacy');
INSERT INTO `site_lang` VALUES ('62', '30', 'Terms');
INSERT INTO `site_lang` VALUES ('60', '30', 'New messages');
INSERT INTO `site_lang` VALUES ('61', '30', 'Who to like');
INSERT INTO `site_lang` VALUES ('59', '30', 'Online now');
INSERT INTO `site_lang` VALUES ('58', '30', 'Conversations');
INSERT INTO `site_lang` VALUES ('57', '30', 'Fans');
INSERT INTO `site_lang` VALUES ('54', '30', 'Manage photos');
INSERT INTO `site_lang` VALUES ('55', '30', 'Settings');
INSERT INTO `site_lang` VALUES ('56', '30', 'All');
INSERT INTO `site_lang` VALUES ('53', '30', 'Fans');
INSERT INTO `site_lang` VALUES ('52', '30', 'Most populars');
INSERT INTO `site_lang` VALUES ('51', '30', 'Matches');
INSERT INTO `site_lang` VALUES ('50', '30', 'Discover');
INSERT INTO `site_lang` VALUES ('48', '30', 'Logout');
INSERT INTO `site_lang` VALUES ('49', '30', 'Meet new people');
INSERT INTO `site_lang` VALUES ('47', '30', 'Settings');
INSERT INTO `site_lang` VALUES ('46', '30', 'Profile');
INSERT INTO `site_lang` VALUES ('44', '30', 'and');
INSERT INTO `site_lang` VALUES ('45', '30', 'Privacy Policy');
INSERT INTO `site_lang` VALUES ('43', '30', 'Terms and Conditions');
INSERT INTO `site_lang` VALUES ('42', '30', 'By continuing, you are confirming that you have read and agree to our');
INSERT INTO `site_lang` VALUES ('41', '30', 'Sign up');
INSERT INTO `site_lang` VALUES ('40', '30', 'Meet boys and girls');
INSERT INTO `site_lang` VALUES ('39', '30', 'Meet boys');
INSERT INTO `site_lang` VALUES ('38', '30', 'Meet girls');
INSERT INTO `site_lang` VALUES ('37', '30', 'Im here to');
INSERT INTO `site_lang` VALUES ('36', '30', 'Female');
INSERT INTO `site_lang` VALUES ('35', '30', 'Male');
INSERT INTO `site_lang` VALUES ('34', '30', 'Gender');
INSERT INTO `site_lang` VALUES ('32', '30', 'City');
INSERT INTO `site_lang` VALUES ('33', '30', 'Where do you live?');
INSERT INTO `site_lang` VALUES ('31', '30', 'Please select');
INSERT INTO `site_lang` VALUES ('29', '30', 'Password');
INSERT INTO `site_lang` VALUES ('30', '30', 'Birthday');
INSERT INTO `site_lang` VALUES ('28', '30', 'Email');
INSERT INTO `site_lang` VALUES ('27', '30', 'Your name or nickname');
INSERT INTO `site_lang` VALUES ('26', '30', 'Name');
INSERT INTO `site_lang` VALUES ('24', '30', 'Become a member now');
INSERT INTO `site_lang` VALUES ('25', '30', 'Join the worlds bestest community for meeting new people!.');
INSERT INTO `site_lang` VALUES ('23', '30', 'Play our popular Discover game and get matched with other users. Its a great way to break the ice and chat to new people.');
INSERT INTO `site_lang` VALUES ('22', '30', 'Matches');
INSERT INTO `site_lang` VALUES ('21', '30', 'We wont show your exact location, but you will be able to find people nearby who like the same things you do.');
INSERT INTO `site_lang` VALUES ('20', '30', 'People nearby');
INSERT INTO `site_lang` VALUES ('19', '30', 'You can make quality videocalls for free to anyone, without limits of call duration, just enjoy seeing the person who is chatting with you');
INSERT INTO `site_lang` VALUES ('18', '30', 'Video Chat');
INSERT INTO `site_lang` VALUES ('16', '30', 'Chat');
INSERT INTO `site_lang` VALUES ('17', '30', 'Powerfull private chat for meet new friends, you can send emoticons and private photos to anyone.');
INSERT INTO `site_lang` VALUES ('15', '30', 'Recover password');
INSERT INTO `site_lang` VALUES ('14', '30', 'Password recover');
INSERT INTO `site_lang` VALUES ('13', '30', 'Login now');
INSERT INTO `site_lang` VALUES ('12', '30', 'do you forget your password?');
INSERT INTO `site_lang` VALUES ('10', '30', 'Your email');
INSERT INTO `site_lang` VALUES ('11', '30', 'Your password');
INSERT INTO `site_lang` VALUES ('9', '30', 'Welcome back');
INSERT INTO `site_lang` VALUES ('8', '30', 'Create your account');
INSERT INTO `site_lang` VALUES ('7', '30', 'Connect with ');
INSERT INTO `site_lang` VALUES ('6', '30', 'SOON AVAILABLE');
INSERT INTO `site_lang` VALUES ('5', '30', 'Soon we will have our phone apps online');
INSERT INTO `site_lang` VALUES ('4', '30', 'Please visit us from your laptop or PC');
INSERT INTO `site_lang` VALUES ('3', '30', 'For now our site works only for Desktop users');
INSERT INTO `site_lang` VALUES ('2', '30', 'Welcome to the fastest growing place to meet new people');
INSERT INTO `site_lang` VALUES ('1', '30', 'Login');
INSERT INTO `site_lang` VALUES ('0', '30', 'meet new people!');
INSERT INTO `site_lang` VALUES ('384', '29', 'Ok, i understand');
INSERT INTO `site_lang` VALUES ('383', '29', 'must like you for start a videocall');
INSERT INTO `site_lang` VALUES ('382', '29', 'dont like you');
INSERT INTO `site_lang` VALUES ('381', '29', 'calling...');
INSERT INTO `site_lang` VALUES ('380', '29', 'Welcome to');
INSERT INTO `site_lang` VALUES ('379', '29', 'Go to');
INSERT INTO `site_lang` VALUES ('378', '29', 'Please save your connection information in a safe place');
INSERT INTO `site_lang` VALUES ('377', '29', 'Password');
INSERT INTO `site_lang` VALUES ('376', '29', 'E-mail');
INSERT INTO `site_lang` VALUES ('373', '29', 'More than 1 million people have joined $site_name You probably want to know some of them.');
INSERT INTO `site_lang` VALUES ('375', '29', 'Here are your connection details');
INSERT INTO `site_lang` VALUES ('374', '29', 'Start meeting new people now');
INSERT INTO `site_lang` VALUES ('372', '29', 'Add photos and complete your profile');
INSERT INTO `site_lang` VALUES ('371', '29', 'Nobody is going to fall in love with a blank page. The more information you get, the more chances to find that special someone!');
INSERT INTO `site_lang` VALUES ('370', '29', 'Meet new people');
INSERT INTO `site_lang` VALUES ('366', '29', 'Newsflash');
INSERT INTO `site_lang` VALUES ('369', '29', 'you can meet people instantly');
INSERT INTO `site_lang` VALUES ('368', '29', 'In');
INSERT INTO `site_lang` VALUES ('367', '29', 'people in your area wants to know you');
INSERT INTO `site_lang` VALUES ('365', '29', 'Verify your account');
INSERT INTO `site_lang` VALUES ('364', '29', 'Now you are a new member of');
INSERT INTO `site_lang` VALUES ('363', '29', 'Here are a few tips');
INSERT INTO `site_lang` VALUES ('362', '29', 'Well done, now you are in');
INSERT INTO `site_lang` VALUES ('361', '29', 'Welcome');
INSERT INTO `site_lang` VALUES ('360', '29', 'Check out the profile');
INSERT INTO `site_lang` VALUES ('359', '29', 'and lives closer to you');
INSERT INTO `site_lang` VALUES ('358', '29', 'is new at');
INSERT INTO `site_lang` VALUES ('357', '29', 'is new and lives closer to you');
INSERT INTO `site_lang` VALUES ('356', '29', 'Have fun!');
INSERT INTO `site_lang` VALUES ('352', '29', 'Go and say something to');
INSERT INTO `site_lang` VALUES ('353', '29', 'New message from');
INSERT INTO `site_lang` VALUES ('354', '29', 'you have a new message from');
INSERT INTO `site_lang` VALUES ('355', '29', 'Respond to');
INSERT INTO `site_lang` VALUES ('348', '29', 'if you forgot your password, click on the link below to get a new');
INSERT INTO `site_lang` VALUES ('351', '29', 'thinks the feeling is mutual');
INSERT INTO `site_lang` VALUES ('350', '29', 'Its a match!');
INSERT INTO `site_lang` VALUES ('349', '29', 'You have a match at');
INSERT INTO `site_lang` VALUES ('347', '29', 'Choose a new password');
INSERT INTO `site_lang` VALUES ('346', '29', 'Unsubscribe');
INSERT INTO `site_lang` VALUES ('345', '29', 'You received this notice because you registered as');
INSERT INTO `site_lang` VALUES ('344', '29', 'Find out if you also like');
INSERT INTO `site_lang` VALUES ('343', '29', 'has seen you in discover and likes. The feeling is mutual?');
INSERT INTO `site_lang` VALUES ('342', '29', 'likes you and wants to chat in');
INSERT INTO `site_lang` VALUES ('341', '29', 'We sent you a email with your info, it may take up to 1 min to arrive');
INSERT INTO `site_lang` VALUES ('340', '29', 'Loading...');
INSERT INTO `site_lang` VALUES ('339', '29', 'of');
INSERT INTO `site_lang` VALUES ('338', '29', 'Photos of ');
INSERT INTO `site_lang` VALUES ('337', '29', 'is calling you..');
INSERT INTO `site_lang` VALUES ('336', '29', 'Password successfully changed');
INSERT INTO `site_lang` VALUES ('335', '29', 'Service cost');
INSERT INTO `site_lang` VALUES ('334', '29', 'Spotlight');
INSERT INTO `site_lang` VALUES ('333', '29', 'Wrong');
INSERT INTO `site_lang` VALUES ('332', '29', 'days of Premium');
INSERT INTO `site_lang` VALUES ('331', '29', 'username');
INSERT INTO `site_lang` VALUES ('330', '29', 'You need to write your username!');
INSERT INTO `site_lang` VALUES ('329', '29', 'Write your instagram username');
INSERT INTO `site_lang` VALUES ('328', '29', 'Press backspace key for smart return to the meeting section.');
INSERT INTO `site_lang` VALUES ('327', '29', 'Are you sure you want to report');
INSERT INTO `site_lang` VALUES ('326', '29', 'Report and block');
INSERT INTO `site_lang` VALUES ('325', '29', 'is blocking you or you blocked him, you cant chat with him sorry');
INSERT INTO `site_lang` VALUES ('324', '29', 'We sended you a email for verify your account');
INSERT INTO `site_lang` VALUES ('323', '29', 'years old and im from');
INSERT INTO `site_lang` VALUES ('322', '29', 'Hi, im');
INSERT INTO `site_lang` VALUES ('321', '29', 'Please add a profile photo');
INSERT INTO `site_lang` VALUES ('320', '29', 'Please verify your account, check your email');
INSERT INTO `site_lang` VALUES ('319', '29', 'ago');
INSERT INTO `site_lang` VALUES ('318', '29', 'seconds');
INSERT INTO `site_lang` VALUES ('317', '29', 'minutes');
INSERT INTO `site_lang` VALUES ('316', '29', 'hours');
INSERT INTO `site_lang` VALUES ('313', '29', 'years');
INSERT INTO `site_lang` VALUES ('314', '29', 'months');
INSERT INTO `site_lang` VALUES ('315', '29', 'days');
INSERT INTO `site_lang` VALUES ('312', '29', 'second');
INSERT INTO `site_lang` VALUES ('307', '29', 'year');
INSERT INTO `site_lang` VALUES ('308', '29', 'month');
INSERT INTO `site_lang` VALUES ('309', '29', 'day');
INSERT INTO `site_lang` VALUES ('310', '29', 'hour');
INSERT INTO `site_lang` VALUES ('311', '29', 'minute');
INSERT INTO `site_lang` VALUES ('306', '29', '0 seconds');
INSERT INTO `site_lang` VALUES ('301', '29', 'You dont have any visit yet');
INSERT INTO `site_lang` VALUES ('302', '29', 'visited');
INSERT INTO `site_lang` VALUES ('303', '29', 'You do not like anyone');
INSERT INTO `site_lang` VALUES ('304', '29', 'Cost');
INSERT INTO `site_lang` VALUES ('305', '29', 'Credits for $');
INSERT INTO `site_lang` VALUES ('300', '29', 'AGE');
INSERT INTO `site_lang` VALUES ('295', '29', 'People i like');
INSERT INTO `site_lang` VALUES ('296', '29', 'people liked you, for see them');
INSERT INTO `site_lang` VALUES ('297', '29', 'Messages');
INSERT INTO `site_lang` VALUES ('298', '29', 'Like');
INSERT INTO `site_lang` VALUES ('299', '29', 'Dislike');
INSERT INTO `site_lang` VALUES ('294', '29', 'Upgrade your account to premium');
INSERT INTO `site_lang` VALUES ('291', '29', 'Public photo');
INSERT INTO `site_lang` VALUES ('292', '29', 'Delete');
INSERT INTO `site_lang` VALUES ('293', '29', 'people visited your profile for see them');
INSERT INTO `site_lang` VALUES ('290', '29', 'Private photo');
INSERT INTO `site_lang` VALUES ('289', '29', 'Set as profile');
INSERT INTO `site_lang` VALUES ('288', '29', 'get seen by millions');
INSERT INTO `site_lang` VALUES ('287', '29', 'Add me here');
INSERT INTO `site_lang` VALUES ('286', '29', 'Visits');
INSERT INTO `site_lang` VALUES ('285', '29', 'Credits');
INSERT INTO `site_lang` VALUES ('284', '29', 'Photos');
INSERT INTO `site_lang` VALUES ('283', '29', 'Add');
INSERT INTO `site_lang` VALUES ('282', '29', 'Add from ');
INSERT INTO `site_lang` VALUES ('281', '29', 'Private photos');
INSERT INTO `site_lang` VALUES ('278', '29', 'Fans');
INSERT INTO `site_lang` VALUES ('279', '29', 'No data');
INSERT INTO `site_lang` VALUES ('280', '29', 'Public Photos');
INSERT INTO `site_lang` VALUES ('277', '29', 'Report');
INSERT INTO `site_lang` VALUES ('273', '29', 'Month');
INSERT INTO `site_lang` VALUES ('274', '29', 'Year');
INSERT INTO `site_lang` VALUES ('275', '29', 'Please wait');
INSERT INTO `site_lang` VALUES ('276', '29', 'Interests');
INSERT INTO `site_lang` VALUES ('271', '29', 'When someone send me a message');
INSERT INTO `site_lang` VALUES ('272', '29', 'Day');
INSERT INTO `site_lang` VALUES ('270', '29', 'When new users near me join in');
INSERT INTO `site_lang` VALUES ('269', '29', 'When i get a match');
INSERT INTO `site_lang` VALUES ('268', '29', 'When someone likes me');
INSERT INTO `site_lang` VALUES ('267', '29', 'None');
INSERT INTO `site_lang` VALUES ('266', '29', 'I own a motorbike');
INSERT INTO `site_lang` VALUES ('265', '29', 'I own a car');
INSERT INTO `site_lang` VALUES ('264', '29', 'Parents car');
INSERT INTO `site_lang` VALUES ('263', '29', 'Transport');
INSERT INTO `site_lang` VALUES ('262', '29', 'Drink');
INSERT INTO `site_lang` VALUES ('261', '29', 'Sometimes');
INSERT INTO `site_lang` VALUES ('260', '29', 'No');
INSERT INTO `site_lang` VALUES ('257', '29', 'Alone');
INSERT INTO `site_lang` VALUES ('258', '29', 'Smoke');
INSERT INTO `site_lang` VALUES ('259', '29', 'Yes');
INSERT INTO `site_lang` VALUES ('256', '29', 'With partner');
INSERT INTO `site_lang` VALUES ('255', '29', 'Student dormitory');
INSERT INTO `site_lang` VALUES ('253', '29', 'With parents');
INSERT INTO `site_lang` VALUES ('254', '29', 'With housemate');
INSERT INTO `site_lang` VALUES ('251', '29', 'Curvy');
INSERT INTO `site_lang` VALUES ('252', '29', 'Living');
INSERT INTO `site_lang` VALUES ('250', '29', 'Heavy set');
INSERT INTO `site_lang` VALUES ('249', '29', 'Athletic');
INSERT INTO `site_lang` VALUES ('247', '29', 'Slim');
INSERT INTO `site_lang` VALUES ('248', '29', 'Average');
INSERT INTO `site_lang` VALUES ('244', '29', 'Indian');
INSERT INTO `site_lang` VALUES ('245', '29', 'Other');
INSERT INTO `site_lang` VALUES ('246', '29', 'Body type');
INSERT INTO `site_lang` VALUES ('243', '29', 'Pacific Islander');
INSERT INTO `site_lang` VALUES ('242', '29', 'Hispanic/latin');
INSERT INTO `site_lang` VALUES ('241', '29', 'Native American');
INSERT INTO `site_lang` VALUES ('240', '29', 'White');
INSERT INTO `site_lang` VALUES ('239', '29', 'Black');
INSERT INTO `site_lang` VALUES ('238', '29', 'Middle Eastern');
INSERT INTO `site_lang` VALUES ('237', '29', 'Asian');
INSERT INTO `site_lang` VALUES ('236', '29', 'Ethnicity');
INSERT INTO `site_lang` VALUES ('235', '29', 'Weight');
INSERT INTO `site_lang` VALUES ('234', '29', 'more than');
INSERT INTO `site_lang` VALUES ('233', '29', 'less than');
INSERT INTO `site_lang` VALUES ('232', '29', 'Height');
INSERT INTO `site_lang` VALUES ('231', '29', 'Bisexual');
INSERT INTO `site_lang` VALUES ('230', '29', 'Straight');
INSERT INTO `site_lang` VALUES ('229', '29', 'Open-minded');
INSERT INTO `site_lang` VALUES ('228', '29', 'Gay');
INSERT INTO `site_lang` VALUES ('227', '29', 'Sexuality');
INSERT INTO `site_lang` VALUES ('226', '29', 'Open');
INSERT INTO `site_lang` VALUES ('225', '29', 'Taken');
INSERT INTO `site_lang` VALUES ('224', '29', 'Single');
INSERT INTO `site_lang` VALUES ('223', '29', 'Relationship');
INSERT INTO `site_lang` VALUES ('222', '29', 'Extended info (optional)');
INSERT INTO `site_lang` VALUES ('219', '29', 'Basic');
INSERT INTO `site_lang` VALUES ('220', '29', 'UPGRADE');
INSERT INTO `site_lang` VALUES ('221', '29', 'Notifications');
INSERT INTO `site_lang` VALUES ('218', '29', 'until');
INSERT INTO `site_lang` VALUES ('216', '29', 'End call');
INSERT INTO `site_lang` VALUES ('217', '29', 'Wait more');
INSERT INTO `site_lang` VALUES ('215', '29', 'Seems that your friend do not have webcam or he is not available');
INSERT INTO `site_lang` VALUES ('214', '29', 'Too long wait');
INSERT INTO `site_lang` VALUES ('213', '29', 'You cant make videocall because you dont have webcam');
INSERT INTO `site_lang` VALUES ('212', '29', 'Impossible to make a call!');
INSERT INTO `site_lang` VALUES ('211', '29', 'Only premium users can make videocalls');
INSERT INTO `site_lang` VALUES ('210', '29', 'You are already in a videocall, you have to end the other call before start another');
INSERT INTO `site_lang` VALUES ('209', '29', 'Please allow access to your Webcam.');
INSERT INTO `site_lang` VALUES ('206', '29', 'Yes, delete it!');
INSERT INTO `site_lang` VALUES ('207', '29', 'is in another videocall , you cant call now');
INSERT INTO `site_lang` VALUES ('208', '29', 'is offline, try again when your friend is online');
INSERT INTO `site_lang` VALUES ('205', '29', 'Your data will be lost without recovery, continue?');
INSERT INTO `site_lang` VALUES ('204', '29', 'Account termination');
INSERT INTO `site_lang` VALUES ('203', '29', 'Information updated successfully');
INSERT INTO `site_lang` VALUES ('202', '29', 'Yes, buy it!');
INSERT INTO `site_lang` VALUES ('201', '29', 'more daily conversation, cost ');
INSERT INTO `site_lang` VALUES ('200', '29', 'Expand daily limitation ');
INSERT INTO `site_lang` VALUES ('199', '29', 'You dont have enought credits for send the gift');
INSERT INTO `site_lang` VALUES ('198', '29', 'Please, select 1 gift');
INSERT INTO `site_lang` VALUES ('197', '29', 'Please, select 1 photo');
INSERT INTO `site_lang` VALUES ('196', '29', 'Please, select a payment method');
INSERT INTO `site_lang` VALUES ('195', '29', 'No thanks');
INSERT INTO `site_lang` VALUES ('194', '29', 'Get access');
INSERT INTO `site_lang` VALUES ('193', '29', 'private photos for ');
INSERT INTO `site_lang` VALUES ('192', '29', 'Get access to');
INSERT INTO `site_lang` VALUES ('191', '29', 'Buy private photos permission');
INSERT INTO `site_lang` VALUES ('190', '29', 'No, i cant show you my private photos');
INSERT INTO `site_lang` VALUES ('189', '29', 'Yes, you can see my private photos');
INSERT INTO `site_lang` VALUES ('188', '29', 'Email already exist, try another');
INSERT INTO `site_lang` VALUES ('187', '29', 'Password too short');
INSERT INTO `site_lang` VALUES ('186', '29', 'Choose city from the autocomplete');
INSERT INTO `site_lang` VALUES ('185', '29', 'Add a valid date');
INSERT INTO `site_lang` VALUES ('184', '29', 'Wrong password');
INSERT INTO `site_lang` VALUES ('183', '29', 'Email dont exist');
INSERT INTO `site_lang` VALUES ('182', '29', 'Please fill all the inputs');
INSERT INTO `site_lang` VALUES ('181', '29', 'Invalid email format');
INSERT INTO `site_lang` VALUES ('180', '29', 'Password recover');
INSERT INTO `site_lang` VALUES ('179', '29', 'Login to my account');
INSERT INTO `site_lang` VALUES ('178', '29', 'If you dont remember your password, click the link below to set a new one:');
INSERT INTO `site_lang` VALUES ('177', '29', 'Hi');
INSERT INTO `site_lang` VALUES ('176', '29', 'No');
INSERT INTO `site_lang` VALUES ('175', '29', 'Yes');
INSERT INTO `site_lang` VALUES ('174', '29', 'Hello, can i have access to your private photos ?');
INSERT INTO `site_lang` VALUES ('173', '29', 'like this');
INSERT INTO `site_lang` VALUES ('172', '29', 'persons more like this');
INSERT INTO `site_lang` VALUES ('171', '29', 'Days Premium');
INSERT INTO `site_lang` VALUES ('170', '29', 'Buy');
INSERT INTO `site_lang` VALUES ('168', '29', 'November');
INSERT INTO `site_lang` VALUES ('169', '29', 'December');
INSERT INTO `site_lang` VALUES ('167', '29', 'October');
INSERT INTO `site_lang` VALUES ('165', '29', 'August');
INSERT INTO `site_lang` VALUES ('166', '29', 'September');
INSERT INTO `site_lang` VALUES ('163', '29', 'June');
INSERT INTO `site_lang` VALUES ('164', '29', 'July');
INSERT INTO `site_lang` VALUES ('155', '29', 'No popular users near you');
INSERT INTO `site_lang` VALUES ('156', '29', 'You dont have any fans yet');
INSERT INTO `site_lang` VALUES ('157', '29', 'You dont have matches yet');
INSERT INTO `site_lang` VALUES ('158', '29', 'January');
INSERT INTO `site_lang` VALUES ('159', '29', 'February');
INSERT INTO `site_lang` VALUES ('160', '29', 'March');
INSERT INTO `site_lang` VALUES ('161', '29', 'April');
INSERT INTO `site_lang` VALUES ('162', '29', 'May');
INSERT INTO `site_lang` VALUES ('154', '29', 'people found');
INSERT INTO `site_lang` VALUES ('152', '29', 'Verified');
INSERT INTO `site_lang` VALUES ('153', '29', 'Nothing found');
INSERT INTO `site_lang` VALUES ('151', '29', 'Online now');
INSERT INTO `site_lang` VALUES ('150', '29', 'Delete profile');
INSERT INTO `site_lang` VALUES ('149', '29', 'After delete your profile, some of your data will be lost without recovery.');
INSERT INTO `site_lang` VALUES ('148', '29', 'Profile desactivation');
INSERT INTO `site_lang` VALUES ('147', '29', 'New password');
INSERT INTO `site_lang` VALUES ('146', '29', 'You can change your current password bellow');
INSERT INTO `site_lang` VALUES ('145', '29', 'Change password');
INSERT INTO `site_lang` VALUES ('144', '29', 'Upgrade to premium account');
INSERT INTO `site_lang` VALUES ('143', '29', 'Add credits');
INSERT INTO `site_lang` VALUES ('142', '29', 'Current credits');
INSERT INTO `site_lang` VALUES ('138', '29', 'Connect with Facebook');
INSERT INTO `site_lang` VALUES ('139', '29', 'You are account is already verified');
INSERT INTO `site_lang` VALUES ('140', '29', 'Buy credits for send Gifs and Unblock private photos');
INSERT INTO `site_lang` VALUES ('141', '29', 'Account type');
INSERT INTO `site_lang` VALUES ('134', '29', 'Site language');
INSERT INTO `site_lang` VALUES ('137', '29', 'For verify your account , connect with your facebook account');
INSERT INTO `site_lang` VALUES ('136', '29', 'Verify account');
INSERT INTO `site_lang` VALUES ('135', '29', 'Update profile');
INSERT INTO `site_lang` VALUES ('133', '29', 'You can edit your profile information bellow');
INSERT INTO `site_lang` VALUES ('132', '29', 'Personal information');
INSERT INTO `site_lang` VALUES ('131', '29', 'Delete');
INSERT INTO `site_lang` VALUES ('130', '29', 'Change password');
INSERT INTO `site_lang` VALUES ('129', '29', 'Verify');
INSERT INTO `site_lang` VALUES ('128', '29', 'Credits');
INSERT INTO `site_lang` VALUES ('127', '29', 'Personal');
INSERT INTO `site_lang` VALUES ('126', '29', 'Unblock private photos');
INSERT INTO `site_lang` VALUES ('125', '29', 'Ask permission to');
INSERT INTO `site_lang` VALUES ('124', '29', 'Now you have');
INSERT INTO `site_lang` VALUES ('123', '29', 'Credits successfully added to your account');
INSERT INTO `site_lang` VALUES ('122', '29', 'boys and girls');
INSERT INTO `site_lang` VALUES ('121', '29', 'Only girls');
INSERT INTO `site_lang` VALUES ('120', '29', 'Only boys');
INSERT INTO `site_lang` VALUES ('119', '29', 'years old');
INSERT INTO `site_lang` VALUES ('118', '29', 'Personal info');
INSERT INTO `site_lang` VALUES ('117', '29', 'About ');
INSERT INTO `site_lang` VALUES ('116', '29', 'Most popular users');
INSERT INTO `site_lang` VALUES ('115', '29', 'World');
INSERT INTO `site_lang` VALUES ('114', '29', 'in a radius of');
INSERT INTO `site_lang` VALUES ('113', '29', 'who are between');
INSERT INTO `site_lang` VALUES ('112', '29', 'Both');
INSERT INTO `site_lang` VALUES ('111', '29', 'Boys');
INSERT INTO `site_lang` VALUES ('110', '29', 'Girls');
INSERT INTO `site_lang` VALUES ('109', '29', 'Show me');
INSERT INTO `site_lang` VALUES ('107', '29', 'All users');
INSERT INTO `site_lang` VALUES ('108', '29', 'Online now');
INSERT INTO `site_lang` VALUES ('106', '29', 'Filter Search');
INSERT INTO `site_lang` VALUES ('105', '29', 'Your matches');
INSERT INTO `site_lang` VALUES ('104', '29', 'Please complete your profile before start in ');
INSERT INTO `site_lang` VALUES ('103', '29', 'Terms of Use');
INSERT INTO `site_lang` VALUES ('101', '29', 'Your fans');
INSERT INTO `site_lang` VALUES ('102', '29', 'Privacy Policy');
INSERT INTO `site_lang` VALUES ('100', '29', 'or wait until tomorrow for continue meeting people');
INSERT INTO `site_lang` VALUES ('98', '29', 'and get up to');
INSERT INTO `site_lang` VALUES ('99', '29', 'daily conversations');
INSERT INTO `site_lang` VALUES ('92', '29', 'you have reached the limit of new daily conversations');
INSERT INTO `site_lang` VALUES ('96', '29', 'or');
INSERT INTO `site_lang` VALUES ('97', '29', 'Upgrade your account to Premium');
INSERT INTO `site_lang` VALUES ('95', '29', 'more daily conversation');
INSERT INTO `site_lang` VALUES ('94', '29', 'Buy');
INSERT INTO `site_lang` VALUES ('93', '29', 'To continue chatting');
INSERT INTO `site_lang` VALUES ('90', '29', 'Send');
INSERT INTO `site_lang` VALUES ('91', '29', 'Chat');
INSERT INTO `site_lang` VALUES ('88', '29', 'Premium user badge');
INSERT INTO `site_lang` VALUES ('89', '29', 'Write text here');
INSERT INTO `site_lang` VALUES ('87', '29', 'Unblock all private photos');
INSERT INTO `site_lang` VALUES ('85', '29', 'new chats per day');
INSERT INTO `site_lang` VALUES ('86', '29', 'Unlimited videocalls');
INSERT INTO `site_lang` VALUES ('84', '29', 'Premium Account Features');
INSERT INTO `site_lang` VALUES ('83', '29', 'Buy credits');
INSERT INTO `site_lang` VALUES ('81', '29', 'Pay with');
INSERT INTO `site_lang` VALUES ('82', '29', 'Pay with');
INSERT INTO `site_lang` VALUES ('78', '29', 'Buy credits / Upgrade account');
INSERT INTO `site_lang` VALUES ('79', '29', 'Select credits package');
INSERT INTO `site_lang` VALUES ('80', '29', 'Select payment method');
INSERT INTO `site_lang` VALUES ('77', '29', 'Send gift');
INSERT INTO `site_lang` VALUES ('76', '29', 'Pick the gift you want to send to ');
INSERT INTO `site_lang` VALUES ('75', '29', 'Send gift to ');
INSERT INTO `site_lang` VALUES ('73', '29', 'Credits');
INSERT INTO `site_lang` VALUES ('74', '29', 'Add photo');
INSERT INTO `site_lang` VALUES ('72', '29', 'Pick the photo you want to show in the Spotlight, cost ');
INSERT INTO `site_lang` VALUES ('71', '29', 'Add yourself to the Spotlight');
INSERT INTO `site_lang` VALUES ('70', '29', 'add photos');
INSERT INTO `site_lang` VALUES ('69', '29', 'Add your photos');
INSERT INTO `site_lang` VALUES ('68', '29', 'Private Photos');
INSERT INTO `site_lang` VALUES ('67', '29', 'Public Photos');
INSERT INTO `site_lang` VALUES ('66', '29', 'All Photos');
INSERT INTO `site_lang` VALUES ('65', '29', 'Manage your photos');
INSERT INTO `site_lang` VALUES ('64', '29', 'Contact');
INSERT INTO `site_lang` VALUES ('63', '29', 'Privacy');
INSERT INTO `site_lang` VALUES ('62', '29', 'Terms');
INSERT INTO `site_lang` VALUES ('61', '29', 'Who to like');
INSERT INTO `site_lang` VALUES ('60', '29', 'New messages');
INSERT INTO `site_lang` VALUES ('59', '29', 'Online now');
INSERT INTO `site_lang` VALUES ('58', '29', 'Conversations');
INSERT INTO `site_lang` VALUES ('57', '29', 'Fans');
INSERT INTO `site_lang` VALUES ('56', '29', 'All');
INSERT INTO `site_lang` VALUES ('55', '29', 'Settings');
INSERT INTO `site_lang` VALUES ('53', '29', 'Fans');
INSERT INTO `site_lang` VALUES ('54', '29', 'Manage photos');
INSERT INTO `site_lang` VALUES ('52', '29', 'Most populars');
INSERT INTO `site_lang` VALUES ('51', '29', 'Matches');
INSERT INTO `site_lang` VALUES ('50', '29', 'Discover');
INSERT INTO `site_lang` VALUES ('48', '29', 'Logout');
INSERT INTO `site_lang` VALUES ('49', '29', 'Meet new people');
INSERT INTO `site_lang` VALUES ('47', '29', 'Settings');
INSERT INTO `site_lang` VALUES ('46', '29', 'Profile');
INSERT INTO `site_lang` VALUES ('43', '29', 'Terms and Conditions');
INSERT INTO `site_lang` VALUES ('44', '29', 'and');
INSERT INTO `site_lang` VALUES ('45', '29', 'Privacy Policy');
INSERT INTO `site_lang` VALUES ('42', '29', 'By continuing, you are confirming that you have read and agree to our');
INSERT INTO `site_lang` VALUES ('41', '29', 'Sign up');
INSERT INTO `site_lang` VALUES ('40', '29', 'Meet boys and girls');
INSERT INTO `site_lang` VALUES ('39', '29', 'Meet boys');
INSERT INTO `site_lang` VALUES ('38', '29', 'Meet girls');
INSERT INTO `site_lang` VALUES ('36', '29', 'Female');
INSERT INTO `site_lang` VALUES ('37', '29', 'Im here to');
INSERT INTO `site_lang` VALUES ('34', '29', 'Gender');
INSERT INTO `site_lang` VALUES ('35', '29', 'Male');
INSERT INTO `site_lang` VALUES ('33', '29', 'Where do you live?');
INSERT INTO `site_lang` VALUES ('32', '29', 'City');
INSERT INTO `site_lang` VALUES ('31', '29', 'Please select');
INSERT INTO `site_lang` VALUES ('30', '29', 'Birthday');
INSERT INTO `site_lang` VALUES ('29', '29', 'Password');
INSERT INTO `site_lang` VALUES ('28', '29', 'Email');
INSERT INTO `site_lang` VALUES ('27', '29', 'Your name or nickname');
INSERT INTO `site_lang` VALUES ('26', '29', 'Name');
INSERT INTO `site_lang` VALUES ('25', '29', 'Join the worlds bestest community for meeting new people!.');
INSERT INTO `site_lang` VALUES ('24', '29', 'Become a member now');
INSERT INTO `site_lang` VALUES ('23', '29', 'Play our popular Discover game and get matched with other users. Its a great way to break the ice and chat to new people.');
INSERT INTO `site_lang` VALUES ('22', '29', 'Matches');
INSERT INTO `site_lang` VALUES ('21', '29', 'We wont show your exact location, but you will be able to find people nearby who like the same things you do.');
INSERT INTO `site_lang` VALUES ('20', '29', 'People nearby');
INSERT INTO `site_lang` VALUES ('19', '29', 'You can make quality videocalls for free to anyone, without limits of call duration, just enjoy seeing the person who is chatting with you');
INSERT INTO `site_lang` VALUES ('18', '29', 'Video Chat');
INSERT INTO `site_lang` VALUES ('17', '29', 'Powerfull private chat for meet new friends, you can send emoticons and private photos to anyone.');
INSERT INTO `site_lang` VALUES ('16', '29', 'Chat');
INSERT INTO `site_lang` VALUES ('15', '29', 'Recover password');
INSERT INTO `site_lang` VALUES ('14', '29', 'Password recover');
INSERT INTO `site_lang` VALUES ('13', '29', 'Login now');
INSERT INTO `site_lang` VALUES ('12', '29', 'do you forget your password?');
INSERT INTO `site_lang` VALUES ('11', '29', 'Your password');
INSERT INTO `site_lang` VALUES ('10', '29', 'Your email');
INSERT INTO `site_lang` VALUES ('9', '29', 'Welcome back');
INSERT INTO `site_lang` VALUES ('8', '29', 'Create your account');
INSERT INTO `site_lang` VALUES ('7', '29', 'Connect with ');
INSERT INTO `site_lang` VALUES ('6', '29', 'SOON AVAILABLE');
INSERT INTO `site_lang` VALUES ('5', '29', 'Soon we will have our phone apps online');
INSERT INTO `site_lang` VALUES ('4', '29', 'Please visit us from your laptop or PC');
INSERT INTO `site_lang` VALUES ('3', '29', 'For now our site works only for Desktop users');
INSERT INTO `site_lang` VALUES ('2', '29', 'Welcome to the fastest growing place to meet new people');
INSERT INTO `site_lang` VALUES ('1', '29', 'Login');
INSERT INTO `site_lang` VALUES ('0', '29', 'meet new people!');
INSERT INTO `site_lang` VALUES ('384', '28', 'Ok, i understand');
INSERT INTO `site_lang` VALUES ('383', '28', 'must like you for start a videocall');
INSERT INTO `site_lang` VALUES ('382', '28', 'dont like you');
INSERT INTO `site_lang` VALUES ('381', '28', 'calling...');
INSERT INTO `site_lang` VALUES ('380', '28', 'Welcome to');
INSERT INTO `site_lang` VALUES ('379', '28', 'Go to');
INSERT INTO `site_lang` VALUES ('378', '28', 'Please save your connection information in a safe place');
INSERT INTO `site_lang` VALUES ('376', '28', 'E-mail');
INSERT INTO `site_lang` VALUES ('377', '28', 'Password');
INSERT INTO `site_lang` VALUES ('375', '28', 'Here are your connection details');
INSERT INTO `site_lang` VALUES ('374', '28', 'Start meeting new people now');
INSERT INTO `site_lang` VALUES ('372', '28', 'Add photos and complete your profile');
INSERT INTO `site_lang` VALUES ('373', '28', 'More than 1 million people have joined $site_name You probably want to know some of them.');
INSERT INTO `site_lang` VALUES ('368', '28', 'In');
INSERT INTO `site_lang` VALUES ('369', '28', 'you can meet people instantly');
INSERT INTO `site_lang` VALUES ('370', '28', 'Meet new people');
INSERT INTO `site_lang` VALUES ('371', '28', 'Nobody is going to fall in love with a blank page. The more information you get, the more chances to find that special someone!');
INSERT INTO `site_lang` VALUES ('365', '28', 'Verify your account');
INSERT INTO `site_lang` VALUES ('366', '28', 'Newsflash');
INSERT INTO `site_lang` VALUES ('367', '28', 'people in your area wants to know you');
INSERT INTO `site_lang` VALUES ('364', '28', 'Now you are a new member of');
INSERT INTO `site_lang` VALUES ('363', '28', 'Here are a few tips');
INSERT INTO `site_lang` VALUES ('362', '28', 'Well done, now you are in');
INSERT INTO `site_lang` VALUES ('361', '28', 'Welcome');
INSERT INTO `site_lang` VALUES ('360', '28', 'Check out the profile');
INSERT INTO `site_lang` VALUES ('359', '28', 'and lives closer to you');
INSERT INTO `site_lang` VALUES ('358', '28', 'is new at');
INSERT INTO `site_lang` VALUES ('356', '28', 'Have fun!');
INSERT INTO `site_lang` VALUES ('357', '28', 'is new and lives closer to you');
INSERT INTO `site_lang` VALUES ('352', '28', 'Go and say something to');
INSERT INTO `site_lang` VALUES ('353', '28', 'New message from');
INSERT INTO `site_lang` VALUES ('354', '28', 'you have a new message from');
INSERT INTO `site_lang` VALUES ('355', '28', 'Respond to');
INSERT INTO `site_lang` VALUES ('350', '28', 'Its a match!');
INSERT INTO `site_lang` VALUES ('351', '28', 'thinks the feeling is mutual');
INSERT INTO `site_lang` VALUES ('349', '28', 'You have a match at');
INSERT INTO `site_lang` VALUES ('348', '28', 'if you forgot your password, click on the link below to get a new');
INSERT INTO `site_lang` VALUES ('347', '28', 'Choose a new password');
INSERT INTO `site_lang` VALUES ('346', '28', 'Unsubscribe');
INSERT INTO `site_lang` VALUES ('345', '28', 'You received this notice because you registered as');
INSERT INTO `site_lang` VALUES ('344', '28', 'Find out if you also like');
INSERT INTO `site_lang` VALUES ('343', '28', 'has seen you in discover and likes. The feeling is mutual?');
INSERT INTO `site_lang` VALUES ('342', '28', 'likes you and wants to chat in');
INSERT INTO `site_lang` VALUES ('341', '28', 'We sent you a email with your info, it may take up to 1 min to arrive');
INSERT INTO `site_lang` VALUES ('339', '28', 'of');
INSERT INTO `site_lang` VALUES ('340', '28', 'Loading...');
INSERT INTO `site_lang` VALUES ('337', '28', 'is calling you..');
INSERT INTO `site_lang` VALUES ('338', '28', 'Photos of ');
INSERT INTO `site_lang` VALUES ('331', '28', 'username');
INSERT INTO `site_lang` VALUES ('332', '28', 'days of Premium');
INSERT INTO `site_lang` VALUES ('333', '28', 'Wrong');
INSERT INTO `site_lang` VALUES ('334', '28', 'Spotlight');
INSERT INTO `site_lang` VALUES ('335', '28', 'Service cost');
INSERT INTO `site_lang` VALUES ('336', '28', 'Password successfully changed');
INSERT INTO `site_lang` VALUES ('330', '28', 'You need to write your username!');
INSERT INTO `site_lang` VALUES ('328', '28', 'Press backspace key for smart return to the meeting section.');
INSERT INTO `site_lang` VALUES ('329', '28', 'Write your instagram username');
INSERT INTO `site_lang` VALUES ('327', '28', 'Are you sure you want to report');
INSERT INTO `site_lang` VALUES ('326', '28', 'Report and block');
INSERT INTO `site_lang` VALUES ('325', '28', 'is blocking you or you blocked him, you cant chat with him sorry');
INSERT INTO `site_lang` VALUES ('324', '28', 'We sended you a email for verify your account');
INSERT INTO `site_lang` VALUES ('323', '28', 'years old and im from');
INSERT INTO `site_lang` VALUES ('322', '28', 'Hi, im');
INSERT INTO `site_lang` VALUES ('321', '28', 'Please add a profile photo');
INSERT INTO `site_lang` VALUES ('320', '28', 'Please verify your account, check your email');
INSERT INTO `site_lang` VALUES ('319', '28', 'ago');
INSERT INTO `site_lang` VALUES ('317', '28', 'minutes');
INSERT INTO `site_lang` VALUES ('318', '28', 'seconds');
INSERT INTO `site_lang` VALUES ('311', '28', 'minute');
INSERT INTO `site_lang` VALUES ('312', '28', 'second');
INSERT INTO `site_lang` VALUES ('313', '28', 'years');
INSERT INTO `site_lang` VALUES ('314', '28', 'months');
INSERT INTO `site_lang` VALUES ('315', '28', 'days');
INSERT INTO `site_lang` VALUES ('316', '28', 'hours');
INSERT INTO `site_lang` VALUES ('310', '28', 'hour');
INSERT INTO `site_lang` VALUES ('309', '28', 'day');
INSERT INTO `site_lang` VALUES ('308', '28', 'month');
INSERT INTO `site_lang` VALUES ('307', '28', 'year');
INSERT INTO `site_lang` VALUES ('305', '28', 'Credits for $');
INSERT INTO `site_lang` VALUES ('306', '28', '0 seconds');
INSERT INTO `site_lang` VALUES ('303', '28', 'You do not like anyone');
INSERT INTO `site_lang` VALUES ('304', '28', 'Cost');
INSERT INTO `site_lang` VALUES ('302', '28', 'visited');
INSERT INTO `site_lang` VALUES ('300', '28', 'AGE');
INSERT INTO `site_lang` VALUES ('301', '28', 'You dont have any visit yet');
INSERT INTO `site_lang` VALUES ('299', '28', 'Dislike');
INSERT INTO `site_lang` VALUES ('298', '28', 'Like');
INSERT INTO `site_lang` VALUES ('297', '28', 'Messages');
INSERT INTO `site_lang` VALUES ('296', '28', 'people liked you, for see them');
INSERT INTO `site_lang` VALUES ('295', '28', 'People i like');
INSERT INTO `site_lang` VALUES ('294', '28', 'Upgrade your account to premium');
INSERT INTO `site_lang` VALUES ('293', '28', 'people visited your profile for see them');
INSERT INTO `site_lang` VALUES ('292', '28', 'Delete');
INSERT INTO `site_lang` VALUES ('291', '28', 'Public photo');
INSERT INTO `site_lang` VALUES ('290', '28', 'Private photo');
INSERT INTO `site_lang` VALUES ('289', '28', 'Set as profile');
INSERT INTO `site_lang` VALUES ('288', '28', 'get seen by millions');
INSERT INTO `site_lang` VALUES ('286', '28', 'Visits');
INSERT INTO `site_lang` VALUES ('287', '28', 'Add me here');
INSERT INTO `site_lang` VALUES ('285', '28', 'Credits');
INSERT INTO `site_lang` VALUES ('284', '28', 'Photos');
INSERT INTO `site_lang` VALUES ('283', '28', 'Add');
INSERT INTO `site_lang` VALUES ('282', '28', 'Add from ');
INSERT INTO `site_lang` VALUES ('281', '28', 'Private photos');
INSERT INTO `site_lang` VALUES ('280', '28', 'Public Photos');
INSERT INTO `site_lang` VALUES ('279', '28', 'No data');
INSERT INTO `site_lang` VALUES ('278', '28', 'Fans');
INSERT INTO `site_lang` VALUES ('277', '28', 'Report');
INSERT INTO `site_lang` VALUES ('276', '28', 'Interests');
INSERT INTO `site_lang` VALUES ('274', '28', 'Year');
INSERT INTO `site_lang` VALUES ('275', '28', 'Please wait');
INSERT INTO `site_lang` VALUES ('273', '28', 'Month');
INSERT INTO `site_lang` VALUES ('272', '28', 'Day');
INSERT INTO `site_lang` VALUES ('271', '28', 'When someone send me a message');
INSERT INTO `site_lang` VALUES ('270', '28', 'When new users near me join in');
INSERT INTO `site_lang` VALUES ('268', '28', 'When someone likes me');
INSERT INTO `site_lang` VALUES ('269', '28', 'When i get a match');
INSERT INTO `site_lang` VALUES ('267', '28', 'None');
INSERT INTO `site_lang` VALUES ('266', '28', 'I own a motorbike');
INSERT INTO `site_lang` VALUES ('265', '28', 'I own a car');
INSERT INTO `site_lang` VALUES ('264', '28', 'Parents car');
INSERT INTO `site_lang` VALUES ('263', '28', 'Transport');
INSERT INTO `site_lang` VALUES ('262', '28', 'Drink');
INSERT INTO `site_lang` VALUES ('261', '28', 'Sometimes');
INSERT INTO `site_lang` VALUES ('260', '28', 'No');
INSERT INTO `site_lang` VALUES ('259', '28', 'Yes');
INSERT INTO `site_lang` VALUES ('258', '28', 'Smoke');
INSERT INTO `site_lang` VALUES ('257', '28', 'Alone');
INSERT INTO `site_lang` VALUES ('256', '28', 'With partner');
INSERT INTO `site_lang` VALUES ('255', '28', 'Student dormitory');
INSERT INTO `site_lang` VALUES ('254', '28', 'With housemate');
INSERT INTO `site_lang` VALUES ('253', '28', 'With parents');
INSERT INTO `site_lang` VALUES ('252', '28', 'Living');
INSERT INTO `site_lang` VALUES ('251', '28', 'Curvy');
INSERT INTO `site_lang` VALUES ('250', '28', 'Heavy set');
INSERT INTO `site_lang` VALUES ('249', '28', 'Athletic');
INSERT INTO `site_lang` VALUES ('248', '28', 'Average');
INSERT INTO `site_lang` VALUES ('247', '28', 'Slim');
INSERT INTO `site_lang` VALUES ('246', '28', 'Body type');
INSERT INTO `site_lang` VALUES ('245', '28', 'Other');
INSERT INTO `site_lang` VALUES ('244', '28', 'Indian');
INSERT INTO `site_lang` VALUES ('243', '28', 'Pacific Islander');
INSERT INTO `site_lang` VALUES ('242', '28', 'Hispanic/latin');
INSERT INTO `site_lang` VALUES ('241', '28', 'Native American');
INSERT INTO `site_lang` VALUES ('240', '28', 'White');
INSERT INTO `site_lang` VALUES ('239', '28', 'Black');
INSERT INTO `site_lang` VALUES ('238', '28', 'Middle Eastern');
INSERT INTO `site_lang` VALUES ('237', '28', 'Asian');
INSERT INTO `site_lang` VALUES ('236', '28', 'Ethnicity');
INSERT INTO `site_lang` VALUES ('234', '28', 'more than');
INSERT INTO `site_lang` VALUES ('235', '28', 'Weight');
INSERT INTO `site_lang` VALUES ('233', '28', 'less than');
INSERT INTO `site_lang` VALUES ('232', '28', 'Height');
INSERT INTO `site_lang` VALUES ('231', '28', 'Bisexual');
INSERT INTO `site_lang` VALUES ('230', '28', 'Straight');
INSERT INTO `site_lang` VALUES ('229', '28', 'Open-minded');
INSERT INTO `site_lang` VALUES ('228', '28', 'Gay');
INSERT INTO `site_lang` VALUES ('225', '28', 'Taken');
INSERT INTO `site_lang` VALUES ('226', '28', 'Open');
INSERT INTO `site_lang` VALUES ('227', '28', 'Sexuality');
INSERT INTO `site_lang` VALUES ('222', '28', 'Extended info (optional)');
INSERT INTO `site_lang` VALUES ('223', '28', 'Relationship');
INSERT INTO `site_lang` VALUES ('224', '28', 'Single');
INSERT INTO `site_lang` VALUES ('220', '28', 'UPGRADE');
INSERT INTO `site_lang` VALUES ('221', '28', 'Notifications');
INSERT INTO `site_lang` VALUES ('209', '28', 'Please allow access to your Webcam.');
INSERT INTO `site_lang` VALUES ('210', '28', 'You are already in a videocall, you have to end the other call before start another');
INSERT INTO `site_lang` VALUES ('211', '28', 'Only premium users can make videocalls');
INSERT INTO `site_lang` VALUES ('212', '28', 'Impossible to make a call!');
INSERT INTO `site_lang` VALUES ('213', '28', 'You cant make videocall because you dont have webcam');
INSERT INTO `site_lang` VALUES ('218', '28', 'until');
INSERT INTO `site_lang` VALUES ('219', '28', 'Basic');
INSERT INTO `site_lang` VALUES ('217', '28', 'Wait more');
INSERT INTO `site_lang` VALUES ('216', '28', 'End call');
INSERT INTO `site_lang` VALUES ('215', '28', 'Seems that your friend do not have webcam or he is not available');
INSERT INTO `site_lang` VALUES ('214', '28', 'Too long wait');
INSERT INTO `site_lang` VALUES ('208', '28', 'is offline, try again when your friend is online');
INSERT INTO `site_lang` VALUES ('207', '28', 'is in another videocall , you cant call now');
INSERT INTO `site_lang` VALUES ('206', '28', 'Yes, delete it!');
INSERT INTO `site_lang` VALUES ('205', '28', 'Your data will be lost without recovery, continue?');
INSERT INTO `site_lang` VALUES ('204', '28', 'Account termination');
INSERT INTO `site_lang` VALUES ('203', '28', 'Information updated successfully');
INSERT INTO `site_lang` VALUES ('202', '28', 'Yes, buy it!');
INSERT INTO `site_lang` VALUES ('201', '28', 'more daily conversation, cost ');
INSERT INTO `site_lang` VALUES ('200', '28', 'Expand daily limitation ');
INSERT INTO `site_lang` VALUES ('199', '28', 'You dont have enought credits for send the gift');
INSERT INTO `site_lang` VALUES ('198', '28', 'Please, select 1 gift');
INSERT INTO `site_lang` VALUES ('197', '28', 'Please, select 1 photo');
INSERT INTO `site_lang` VALUES ('196', '28', 'Please, select a payment method');
INSERT INTO `site_lang` VALUES ('195', '28', 'No thanks');
INSERT INTO `site_lang` VALUES ('194', '28', 'Get access');
INSERT INTO `site_lang` VALUES ('193', '28', 'private photos for ');
INSERT INTO `site_lang` VALUES ('192', '28', 'Get access to');
INSERT INTO `site_lang` VALUES ('191', '28', 'Buy private photos permission');
INSERT INTO `site_lang` VALUES ('190', '28', 'No, i cant show you my private photos');
INSERT INTO `site_lang` VALUES ('189', '28', 'Yes, you can see my private photos');
INSERT INTO `site_lang` VALUES ('188', '28', 'Email already exist, try another');
INSERT INTO `site_lang` VALUES ('187', '28', 'Password too short');
INSERT INTO `site_lang` VALUES ('185', '28', 'Add a valid date');
INSERT INTO `site_lang` VALUES ('186', '28', 'Choose city from the autocomplete');
INSERT INTO `site_lang` VALUES ('184', '28', 'Wrong password');
INSERT INTO `site_lang` VALUES ('183', '28', 'Email dont exist');
INSERT INTO `site_lang` VALUES ('182', '28', 'Please fill all the inputs');
INSERT INTO `site_lang` VALUES ('181', '28', 'Invalid email format');
INSERT INTO `site_lang` VALUES ('180', '28', 'Password recover');
INSERT INTO `site_lang` VALUES ('179', '28', 'Login to my account');
INSERT INTO `site_lang` VALUES ('178', '28', 'If you dont remember your password, click the link below to set a new one:');
INSERT INTO `site_lang` VALUES ('177', '28', 'Hi');
INSERT INTO `site_lang` VALUES ('176', '28', 'No');
INSERT INTO `site_lang` VALUES ('175', '28', 'Yes');
INSERT INTO `site_lang` VALUES ('173', '28', 'like this');
INSERT INTO `site_lang` VALUES ('174', '28', 'Hello, can i have access to your private photos ?');
INSERT INTO `site_lang` VALUES ('172', '28', 'persons more like this');
INSERT INTO `site_lang` VALUES ('171', '28', 'Days Premium');
INSERT INTO `site_lang` VALUES ('170', '28', 'Buy');
INSERT INTO `site_lang` VALUES ('169', '28', 'December');
INSERT INTO `site_lang` VALUES ('168', '28', 'November');
INSERT INTO `site_lang` VALUES ('167', '28', 'October');
INSERT INTO `site_lang` VALUES ('164', '28', 'July');
INSERT INTO `site_lang` VALUES ('165', '28', 'August');
INSERT INTO `site_lang` VALUES ('166', '28', 'September');
INSERT INTO `site_lang` VALUES ('163', '28', 'June');
INSERT INTO `site_lang` VALUES ('162', '28', 'May');
INSERT INTO `site_lang` VALUES ('160', '28', 'March');
INSERT INTO `site_lang` VALUES ('161', '28', 'April');
INSERT INTO `site_lang` VALUES ('159', '28', 'February');
INSERT INTO `site_lang` VALUES ('154', '28', 'people found');
INSERT INTO `site_lang` VALUES ('155', '28', 'No popular users near you');
INSERT INTO `site_lang` VALUES ('156', '28', 'You dont have any fans yet');
INSERT INTO `site_lang` VALUES ('158', '28', 'January');
INSERT INTO `site_lang` VALUES ('157', '28', 'You dont have matches yet');
INSERT INTO `site_lang` VALUES ('153', '28', 'Nothing found');
INSERT INTO `site_lang` VALUES ('151', '28', 'Online now');
INSERT INTO `site_lang` VALUES ('152', '28', 'Verified');
INSERT INTO `site_lang` VALUES ('150', '28', 'Delete profile');
INSERT INTO `site_lang` VALUES ('149', '28', 'After delete your profile, some of your data will be lost without recovery.');
INSERT INTO `site_lang` VALUES ('147', '28', 'New password');
INSERT INTO `site_lang` VALUES ('148', '28', 'Profile desactivation');
INSERT INTO `site_lang` VALUES ('146', '28', 'You can change your current password bellow');
INSERT INTO `site_lang` VALUES ('145', '28', 'Change password');
INSERT INTO `site_lang` VALUES ('144', '28', 'Upgrade to premium account');
INSERT INTO `site_lang` VALUES ('143', '28', 'Add credits');
INSERT INTO `site_lang` VALUES ('142', '28', 'Current credits');
INSERT INTO `site_lang` VALUES ('141', '28', 'Account type');
INSERT INTO `site_lang` VALUES ('140', '28', 'Buy credits for send Gifs and Unblock private photos');
INSERT INTO `site_lang` VALUES ('139', '28', 'You are account is already verified');
INSERT INTO `site_lang` VALUES ('138', '28', 'Connect with Facebook');
INSERT INTO `site_lang` VALUES ('137', '28', 'For verify your account , connect with your facebook account');
INSERT INTO `site_lang` VALUES ('136', '28', 'Verify account');
INSERT INTO `site_lang` VALUES ('135', '28', 'Update profile');
INSERT INTO `site_lang` VALUES ('134', '28', 'Site language');
INSERT INTO `site_lang` VALUES ('133', '28', 'You can edit your profile information bellow');
INSERT INTO `site_lang` VALUES ('132', '28', 'Personal information');
INSERT INTO `site_lang` VALUES ('131', '28', 'Delete');
INSERT INTO `site_lang` VALUES ('119', '28', 'years old');
INSERT INTO `site_lang` VALUES ('120', '28', 'Only boys');
INSERT INTO `site_lang` VALUES ('121', '28', 'Only girls');
INSERT INTO `site_lang` VALUES ('122', '28', 'boys and girls');
INSERT INTO `site_lang` VALUES ('123', '28', 'Credits successfully added to your account');
INSERT INTO `site_lang` VALUES ('130', '28', 'Change password');
INSERT INTO `site_lang` VALUES ('128', '28', 'Credits');
INSERT INTO `site_lang` VALUES ('129', '28', 'Verify');
INSERT INTO `site_lang` VALUES ('127', '28', 'Personal');
INSERT INTO `site_lang` VALUES ('126', '28', 'Unblock private photos');
INSERT INTO `site_lang` VALUES ('125', '28', 'Ask permission to');
INSERT INTO `site_lang` VALUES ('124', '28', 'Now you have');
INSERT INTO `site_lang` VALUES ('118', '28', 'Personal info');
INSERT INTO `site_lang` VALUES ('117', '28', 'About ');
INSERT INTO `site_lang` VALUES ('116', '28', 'Most popular users');
INSERT INTO `site_lang` VALUES ('108', '28', 'Online now');
INSERT INTO `site_lang` VALUES ('109', '28', 'Show me');
INSERT INTO `site_lang` VALUES ('110', '28', 'Girls');
INSERT INTO `site_lang` VALUES ('111', '28', 'Boys');
INSERT INTO `site_lang` VALUES ('112', '28', 'Both');
INSERT INTO `site_lang` VALUES ('113', '28', 'who are between');
INSERT INTO `site_lang` VALUES ('114', '28', 'in a radius of');
INSERT INTO `site_lang` VALUES ('115', '28', 'World');
INSERT INTO `site_lang` VALUES ('101', '28', 'Your fans');
INSERT INTO `site_lang` VALUES ('102', '28', 'Privacy Policy');
INSERT INTO `site_lang` VALUES ('103', '28', 'Terms of Use');
INSERT INTO `site_lang` VALUES ('104', '28', 'Please complete your profile before start in ');
INSERT INTO `site_lang` VALUES ('105', '28', 'Your matches');
INSERT INTO `site_lang` VALUES ('106', '28', 'Filter Search');
INSERT INTO `site_lang` VALUES ('107', '28', 'All users');
INSERT INTO `site_lang` VALUES ('100', '28', 'or wait until tomorrow for continue meeting people');
INSERT INTO `site_lang` VALUES ('99', '28', 'daily conversations');
INSERT INTO `site_lang` VALUES ('98', '28', 'and get up to');
INSERT INTO `site_lang` VALUES ('90', '28', 'Send');
INSERT INTO `site_lang` VALUES ('91', '28', 'Chat');
INSERT INTO `site_lang` VALUES ('92', '28', 'you have reached the limit of new daily conversations');
INSERT INTO `site_lang` VALUES ('93', '28', 'To continue chatting');
INSERT INTO `site_lang` VALUES ('96', '28', 'or');
INSERT INTO `site_lang` VALUES ('97', '28', 'Upgrade your account to Premium');
INSERT INTO `site_lang` VALUES ('95', '28', 'more daily conversation');
INSERT INTO `site_lang` VALUES ('94', '28', 'Buy');
INSERT INTO `site_lang` VALUES ('88', '28', 'Premium user badge');
INSERT INTO `site_lang` VALUES ('89', '28', 'Write text here');
INSERT INTO `site_lang` VALUES ('87', '28', 'Unblock all private photos');
INSERT INTO `site_lang` VALUES ('86', '28', 'Unlimited videocalls');
INSERT INTO `site_lang` VALUES ('84', '28', 'Premium Account Features');
INSERT INTO `site_lang` VALUES ('85', '28', 'new chats per day');
INSERT INTO `site_lang` VALUES ('83', '28', 'Buy credits');
INSERT INTO `site_lang` VALUES ('82', '28', 'Pay with');
INSERT INTO `site_lang` VALUES ('81', '28', 'Pay with');
INSERT INTO `site_lang` VALUES ('80', '28', 'Select payment method');
INSERT INTO `site_lang` VALUES ('79', '28', 'Select credits package');
INSERT INTO `site_lang` VALUES ('78', '28', 'Buy credits / Upgrade account');
INSERT INTO `site_lang` VALUES ('77', '28', 'Send gift');
INSERT INTO `site_lang` VALUES ('76', '28', 'Pick the gift you want to send to ');
INSERT INTO `site_lang` VALUES ('75', '28', 'Send gift to ');
INSERT INTO `site_lang` VALUES ('74', '28', 'Add photo');
INSERT INTO `site_lang` VALUES ('73', '28', 'Credits');
INSERT INTO `site_lang` VALUES ('72', '28', 'Pick the photo you want to show in the Spotlight, cost ');
INSERT INTO `site_lang` VALUES ('71', '28', 'Add yourself to the Spotlight');
INSERT INTO `site_lang` VALUES ('70', '28', 'add photos');
INSERT INTO `site_lang` VALUES ('69', '28', 'Add your photos');
INSERT INTO `site_lang` VALUES ('68', '28', 'Private Photos');
INSERT INTO `site_lang` VALUES ('67', '28', 'Public Photos');
INSERT INTO `site_lang` VALUES ('66', '28', 'All Photos');
INSERT INTO `site_lang` VALUES ('65', '28', 'Manage your photos');
INSERT INTO `site_lang` VALUES ('64', '28', 'Contact');
INSERT INTO `site_lang` VALUES ('63', '28', 'Privacy');
INSERT INTO `site_lang` VALUES ('62', '28', 'Terms');
INSERT INTO `site_lang` VALUES ('61', '28', 'Who to like');
INSERT INTO `site_lang` VALUES ('60', '28', 'New messages');
INSERT INTO `site_lang` VALUES ('59', '28', 'Online now');
INSERT INTO `site_lang` VALUES ('58', '28', 'Conversations');
INSERT INTO `site_lang` VALUES ('56', '28', 'All');
INSERT INTO `site_lang` VALUES ('57', '28', 'Fans');
INSERT INTO `site_lang` VALUES ('55', '28', 'Settings');
INSERT INTO `site_lang` VALUES ('54', '28', 'Manage photos');
INSERT INTO `site_lang` VALUES ('53', '28', 'Fans');
INSERT INTO `site_lang` VALUES ('52', '28', 'Most populars');
INSERT INTO `site_lang` VALUES ('51', '28', 'Matches');
INSERT INTO `site_lang` VALUES ('50', '28', 'Discover');
INSERT INTO `site_lang` VALUES ('49', '28', 'Meet new people');
INSERT INTO `site_lang` VALUES ('48', '28', 'Logout');
INSERT INTO `site_lang` VALUES ('47', '28', 'Settings');
INSERT INTO `site_lang` VALUES ('46', '28', 'Profile');
INSERT INTO `site_lang` VALUES ('45', '28', 'Privacy Policy');
INSERT INTO `site_lang` VALUES ('43', '28', 'Terms and Conditions');
INSERT INTO `site_lang` VALUES ('44', '28', 'and');
INSERT INTO `site_lang` VALUES ('39', '28', 'Meet boys');
INSERT INTO `site_lang` VALUES ('40', '28', 'Meet boys and girls');
INSERT INTO `site_lang` VALUES ('41', '28', 'Sign up');
INSERT INTO `site_lang` VALUES ('42', '28', 'By continuing, you are confirming that you have read and agree to our');
INSERT INTO `site_lang` VALUES ('24', '28', 'Become a member now');
INSERT INTO `site_lang` VALUES ('25', '28', 'Join the worlds bestest community for meeting new people!.');
INSERT INTO `site_lang` VALUES ('26', '28', 'Name');
INSERT INTO `site_lang` VALUES ('27', '28', 'Your name or nickname');
INSERT INTO `site_lang` VALUES ('28', '28', 'Email');
INSERT INTO `site_lang` VALUES ('29', '28', 'Password');
INSERT INTO `site_lang` VALUES ('30', '28', 'Birthday');
INSERT INTO `site_lang` VALUES ('31', '28', 'Please select');
INSERT INTO `site_lang` VALUES ('32', '28', 'City');
INSERT INTO `site_lang` VALUES ('33', '28', 'Where do you live?');
INSERT INTO `site_lang` VALUES ('34', '28', 'Gender');
INSERT INTO `site_lang` VALUES ('35', '28', 'Male');
INSERT INTO `site_lang` VALUES ('36', '28', 'Female');
INSERT INTO `site_lang` VALUES ('37', '28', 'Im here to');
INSERT INTO `site_lang` VALUES ('38', '28', 'Meet girls');
INSERT INTO `site_lang` VALUES ('23', '28', 'Play our popular Discover game and get matched with other users. Its a great way to break the ice and chat to new people.');
INSERT INTO `site_lang` VALUES ('22', '28', 'Matches');
INSERT INTO `site_lang` VALUES ('21', '28', 'We wont show your exact location, but you will be able to find people nearby who like the same things you do.');
INSERT INTO `site_lang` VALUES ('20', '28', 'People nearby');
INSERT INTO `site_lang` VALUES ('18', '28', 'Video Chat');
INSERT INTO `site_lang` VALUES ('19', '28', 'You can make quality videocalls for free to anyone, without limits of call duration, just enjoy seeing the person who is chatting with you');
INSERT INTO `site_lang` VALUES ('12', '28', 'do you forget your password?');
INSERT INTO `site_lang` VALUES ('13', '28', 'Login now');
INSERT INTO `site_lang` VALUES ('14', '28', 'Password recover');
INSERT INTO `site_lang` VALUES ('15', '28', 'Recover password');
INSERT INTO `site_lang` VALUES ('16', '28', 'Chat');
INSERT INTO `site_lang` VALUES ('17', '28', 'Powerfull private chat for meet new friends, you can send emoticons and private photos to anyone.');
INSERT INTO `site_lang` VALUES ('11', '28', 'Your password');
INSERT INTO `site_lang` VALUES ('10', '28', 'Your email');
INSERT INTO `site_lang` VALUES ('9', '28', 'Welcome back');
INSERT INTO `site_lang` VALUES ('8', '28', 'Create your account');
INSERT INTO `site_lang` VALUES ('7', '28', 'Connect with ');
INSERT INTO `site_lang` VALUES ('6', '28', 'SOON AVAILABLE');
INSERT INTO `site_lang` VALUES ('5', '28', 'Soon we will have our phone apps online');
INSERT INTO `site_lang` VALUES ('4', '28', 'Please visit us from your laptop or PC');
INSERT INTO `site_lang` VALUES ('381', '13', 'calling...');
INSERT INTO `site_lang` VALUES ('382', '13', 'dont like you');
INSERT INTO `site_lang` VALUES ('383', '13', 'must like you for start a videocall');
INSERT INTO `site_lang` VALUES ('384', '13', 'Ok, i understand');
INSERT INTO `site_lang` VALUES ('0', '28', 'meet new people!');
INSERT INTO `site_lang` VALUES ('1', '28', 'Login');
INSERT INTO `site_lang` VALUES ('2', '28', 'Welcome to the fastest growing place to meet new people');
INSERT INTO `site_lang` VALUES ('3', '28', 'For now our site works only for Desktop users');
INSERT INTO `site_lang` VALUES ('380', '13', 'Welcome to');
INSERT INTO `site_lang` VALUES ('379', '13', 'Go to');
INSERT INTO `site_lang` VALUES ('378', '13', 'Please save your connection information in a safe place');
INSERT INTO `site_lang` VALUES ('377', '13', 'Password');
INSERT INTO `site_lang` VALUES ('376', '13', 'E-mail');
INSERT INTO `site_lang` VALUES ('375', '13', 'Here are your connection details');
INSERT INTO `site_lang` VALUES ('374', '13', 'Start meeting new people now');
INSERT INTO `site_lang` VALUES ('373', '13', 'More than 1 million people have joined $site_name You probably want to know some of them.');
INSERT INTO `site_lang` VALUES ('372', '13', 'Add photos and complete your profile');
INSERT INTO `site_lang` VALUES ('371', '13', 'Nobody is going to fall in love with a blank page. The more information you get, the more chances to find that special someone!');
INSERT INTO `site_lang` VALUES ('370', '13', 'Meet new people');
INSERT INTO `site_lang` VALUES ('369', '13', 'you can meet people instantly');
INSERT INTO `site_lang` VALUES ('368', '13', 'In');
INSERT INTO `site_lang` VALUES ('367', '13', 'people in your area wants to know you');
INSERT INTO `site_lang` VALUES ('366', '13', 'Newsflash');
INSERT INTO `site_lang` VALUES ('365', '13', 'Verify your account');
INSERT INTO `site_lang` VALUES ('364', '13', 'Now you are a new member of');
INSERT INTO `site_lang` VALUES ('363', '13', 'Here are a few tips');
INSERT INTO `site_lang` VALUES ('362', '13', 'Well done, now you are in');
INSERT INTO `site_lang` VALUES ('361', '13', 'Welcome');
INSERT INTO `site_lang` VALUES ('360', '13', 'Check out the profile');
INSERT INTO `site_lang` VALUES ('359', '13', 'and lives closer to you');
INSERT INTO `site_lang` VALUES ('358', '13', 'is new at');
INSERT INTO `site_lang` VALUES ('357', '13', 'is new and lives closer to you');
INSERT INTO `site_lang` VALUES ('356', '13', 'Have fun!');
INSERT INTO `site_lang` VALUES ('355', '13', 'Respond to');
INSERT INTO `site_lang` VALUES ('354', '13', 'you have a new message from');
INSERT INTO `site_lang` VALUES ('353', '13', 'New message from');
INSERT INTO `site_lang` VALUES ('352', '13', 'Go and say something to');
INSERT INTO `site_lang` VALUES ('351', '13', 'thinks the feeling is mutual');
INSERT INTO `site_lang` VALUES ('350', '13', 'Its a match!');
INSERT INTO `site_lang` VALUES ('349', '13', 'You have a match at');
INSERT INTO `site_lang` VALUES ('348', '13', 'if you forgot your password, click on the link below to get a new');
INSERT INTO `site_lang` VALUES ('347', '13', 'Choose a new password');
INSERT INTO `site_lang` VALUES ('346', '13', 'Unsubscribe');
INSERT INTO `site_lang` VALUES ('345', '13', 'You received this notice because you registered as');
INSERT INTO `site_lang` VALUES ('344', '13', 'Find out if you also like');
INSERT INTO `site_lang` VALUES ('343', '13', 'has seen you in discover and likes. The feeling is mutual?');
INSERT INTO `site_lang` VALUES ('342', '13', 'likes you and wants to chat in');
INSERT INTO `site_lang` VALUES ('384', '27', 'Ok, i understand');
INSERT INTO `site_lang` VALUES ('383', '27', 'must like you for start a videocall');
INSERT INTO `site_lang` VALUES ('382', '27', 'dont like you');
INSERT INTO `site_lang` VALUES ('381', '27', 'calling...');
INSERT INTO `site_lang` VALUES ('384', '26', 'Ok, i understand');
INSERT INTO `site_lang` VALUES ('383', '26', 'must like you for start a videocall');
INSERT INTO `site_lang` VALUES ('382', '26', 'dont like you');
INSERT INTO `site_lang` VALUES ('381', '26', 'calling...');
INSERT INTO `site_lang` VALUES ('380', '26', 'Welcome to');
INSERT INTO `site_lang` VALUES ('379', '26', 'Go to');
INSERT INTO `site_lang` VALUES ('378', '26', 'Please save your connection information in a safe place');
INSERT INTO `site_lang` VALUES ('377', '26', 'Password');
INSERT INTO `site_lang` VALUES ('376', '26', 'E-mail');
INSERT INTO `site_lang` VALUES ('375', '26', 'Here are your connection details');
INSERT INTO `site_lang` VALUES ('374', '26', 'Start meeting new people now');
INSERT INTO `site_lang` VALUES ('373', '26', 'More than 1 million people have joined $site_name You probably want to know some of them.');
INSERT INTO `site_lang` VALUES ('372', '26', 'Add photos and complete your profile');
INSERT INTO `site_lang` VALUES ('371', '26', 'Nobody is going to fall in love with a blank page. The more information you get, the more chances to find that special someone!');
INSERT INTO `site_lang` VALUES ('370', '26', 'Meet new people');
INSERT INTO `site_lang` VALUES ('369', '26', 'you can meet people instantly');
INSERT INTO `site_lang` VALUES ('368', '26', 'In');
INSERT INTO `site_lang` VALUES ('367', '26', 'people in your area wants to know you');
INSERT INTO `site_lang` VALUES ('366', '26', 'Newsflash');
INSERT INTO `site_lang` VALUES ('365', '26', 'Verify your account');
INSERT INTO `site_lang` VALUES ('364', '26', 'Now you are a new member of');
INSERT INTO `site_lang` VALUES ('363', '26', 'Here are a few tips');
INSERT INTO `site_lang` VALUES ('362', '26', 'Well done, now you are in');
INSERT INTO `site_lang` VALUES ('361', '26', 'Welcome');
INSERT INTO `site_lang` VALUES ('360', '26', 'Check out the profile');
INSERT INTO `site_lang` VALUES ('359', '26', 'and lives closer to you');
INSERT INTO `site_lang` VALUES ('358', '26', 'is new at');
INSERT INTO `site_lang` VALUES ('357', '26', 'is new and lives closer to you');
INSERT INTO `site_lang` VALUES ('356', '26', 'Have fun!');
INSERT INTO `site_lang` VALUES ('355', '26', 'Respond to');
INSERT INTO `site_lang` VALUES ('354', '26', 'you have a new message from');
INSERT INTO `site_lang` VALUES ('353', '26', 'New message from');
INSERT INTO `site_lang` VALUES ('352', '26', 'Go and say something to');
INSERT INTO `site_lang` VALUES ('351', '26', 'thinks the feeling is mutual');
INSERT INTO `site_lang` VALUES ('349', '26', 'You have a match at');
INSERT INTO `site_lang` VALUES ('350', '26', 'Its a match!');
INSERT INTO `site_lang` VALUES ('347', '26', 'Choose a new password');
INSERT INTO `site_lang` VALUES ('348', '26', 'if you forgot your password, click on the link below to get a new');
INSERT INTO `site_lang` VALUES ('346', '26', 'Unsubscribe');
INSERT INTO `site_lang` VALUES ('344', '26', 'Find out if you also like');
INSERT INTO `site_lang` VALUES ('345', '26', 'You received this notice because you registered as');
INSERT INTO `site_lang` VALUES ('342', '26', 'likes you and wants to chat in');
INSERT INTO `site_lang` VALUES ('343', '26', 'has seen you in discover and likes. The feeling is mutual?');
INSERT INTO `site_lang` VALUES ('340', '26', 'Loading...');
INSERT INTO `site_lang` VALUES ('341', '26', 'We sent you a email with your info, it may take up to 1 min to arrive');
INSERT INTO `site_lang` VALUES ('339', '26', 'of');
INSERT INTO `site_lang` VALUES ('338', '26', 'Photos of ');
INSERT INTO `site_lang` VALUES ('337', '26', 'is calling you..');
INSERT INTO `site_lang` VALUES ('336', '26', 'Password successfully changed');
INSERT INTO `site_lang` VALUES ('335', '26', 'Service cost');
INSERT INTO `site_lang` VALUES ('329', '26', 'Write your instagram username');
INSERT INTO `site_lang` VALUES ('330', '26', 'You need to write your username!');
INSERT INTO `site_lang` VALUES ('331', '26', 'username');
INSERT INTO `site_lang` VALUES ('332', '26', 'days of Premium');
INSERT INTO `site_lang` VALUES ('333', '26', 'Wrong');
INSERT INTO `site_lang` VALUES ('334', '26', 'Spotlight');
INSERT INTO `site_lang` VALUES ('328', '26', 'Press backspace key for smart return to the meeting section.');
INSERT INTO `site_lang` VALUES ('327', '26', 'Are you sure you want to report');
INSERT INTO `site_lang` VALUES ('326', '26', 'Report and block');
INSERT INTO `site_lang` VALUES ('324', '26', 'We sended you a email for verify your account');
INSERT INTO `site_lang` VALUES ('325', '26', 'is blocking you or you blocked him, you cant chat with him sorry');
INSERT INTO `site_lang` VALUES ('321', '26', 'Please add a profile photo');
INSERT INTO `site_lang` VALUES ('322', '26', 'Hi, im');
INSERT INTO `site_lang` VALUES ('323', '26', 'years old and im from');
INSERT INTO `site_lang` VALUES ('320', '26', 'Please verify your account, check your email');
INSERT INTO `site_lang` VALUES ('319', '26', 'ago');
INSERT INTO `site_lang` VALUES ('318', '26', 'seconds');
INSERT INTO `site_lang` VALUES ('317', '26', 'minutes');
INSERT INTO `site_lang` VALUES ('315', '26', 'days');
INSERT INTO `site_lang` VALUES ('316', '26', 'hours');
INSERT INTO `site_lang` VALUES ('314', '26', 'months');
INSERT INTO `site_lang` VALUES ('313', '26', 'years');
INSERT INTO `site_lang` VALUES ('312', '26', 'second');
INSERT INTO `site_lang` VALUES ('311', '26', 'minute');
INSERT INTO `site_lang` VALUES ('310', '26', 'hour');
INSERT INTO `site_lang` VALUES ('309', '26', 'day');
INSERT INTO `site_lang` VALUES ('306', '26', '0 seconds');
INSERT INTO `site_lang` VALUES ('307', '26', 'year');
INSERT INTO `site_lang` VALUES ('308', '26', 'month');
INSERT INTO `site_lang` VALUES ('305', '26', 'Credits for $');
INSERT INTO `site_lang` VALUES ('304', '26', 'Cost');
INSERT INTO `site_lang` VALUES ('303', '26', 'You do not like anyone');
INSERT INTO `site_lang` VALUES ('302', '26', 'visited');
INSERT INTO `site_lang` VALUES ('301', '26', 'You dont have any visit yet');
INSERT INTO `site_lang` VALUES ('300', '26', 'AGE');
INSERT INTO `site_lang` VALUES ('299', '26', 'Dislike');
INSERT INTO `site_lang` VALUES ('298', '26', 'Like');
INSERT INTO `site_lang` VALUES ('297', '26', 'Messages');
INSERT INTO `site_lang` VALUES ('296', '26', 'people liked you, for see them');
INSERT INTO `site_lang` VALUES ('295', '26', 'People i like');
INSERT INTO `site_lang` VALUES ('294', '26', 'Upgrade your account to premium');
INSERT INTO `site_lang` VALUES ('293', '26', 'people visited your profile for see them');
INSERT INTO `site_lang` VALUES ('291', '26', 'Public photo');
INSERT INTO `site_lang` VALUES ('292', '26', 'Delete');
INSERT INTO `site_lang` VALUES ('290', '26', 'Private photo');
INSERT INTO `site_lang` VALUES ('289', '26', 'Set as profile');
INSERT INTO `site_lang` VALUES ('288', '26', 'get seen by millions');
INSERT INTO `site_lang` VALUES ('287', '26', 'Add me here');
INSERT INTO `site_lang` VALUES ('286', '26', 'Visits');
INSERT INTO `site_lang` VALUES ('282', '26', 'Add from ');
INSERT INTO `site_lang` VALUES ('283', '26', 'Add');
INSERT INTO `site_lang` VALUES ('284', '26', 'Photos');
INSERT INTO `site_lang` VALUES ('285', '26', 'Credits');
INSERT INTO `site_lang` VALUES ('281', '26', 'Private photos');
INSERT INTO `site_lang` VALUES ('280', '26', 'Public Photos');
INSERT INTO `site_lang` VALUES ('279', '26', 'No data');
INSERT INTO `site_lang` VALUES ('278', '26', 'Fans');
INSERT INTO `site_lang` VALUES ('276', '26', 'Interests');
INSERT INTO `site_lang` VALUES ('277', '26', 'Report');
INSERT INTO `site_lang` VALUES ('275', '26', 'Please wait');
INSERT INTO `site_lang` VALUES ('274', '26', 'Year');
INSERT INTO `site_lang` VALUES ('272', '26', 'Day');
INSERT INTO `site_lang` VALUES ('273', '26', 'Month');
INSERT INTO `site_lang` VALUES ('271', '26', 'When someone send me a message');
INSERT INTO `site_lang` VALUES ('269', '26', 'When i get a match');
INSERT INTO `site_lang` VALUES ('270', '26', 'When new users near me join in');
INSERT INTO `site_lang` VALUES ('268', '26', 'When someone likes me');
INSERT INTO `site_lang` VALUES ('266', '26', 'I own a motorbike');
INSERT INTO `site_lang` VALUES ('267', '26', 'None');
INSERT INTO `site_lang` VALUES ('265', '26', 'I own a car');
INSERT INTO `site_lang` VALUES ('264', '26', 'Parents car');
INSERT INTO `site_lang` VALUES ('263', '26', 'Transport');
INSERT INTO `site_lang` VALUES ('261', '26', 'Sometimes');
INSERT INTO `site_lang` VALUES ('262', '26', 'Drink');
INSERT INTO `site_lang` VALUES ('260', '26', 'No');
INSERT INTO `site_lang` VALUES ('259', '26', 'Yes');
INSERT INTO `site_lang` VALUES ('258', '26', 'Smoke');
INSERT INTO `site_lang` VALUES ('257', '26', 'Alone');
INSERT INTO `site_lang` VALUES ('256', '26', 'With partner');
INSERT INTO `site_lang` VALUES ('255', '26', 'Student dormitory');
INSERT INTO `site_lang` VALUES ('254', '26', 'With housemate');
INSERT INTO `site_lang` VALUES ('253', '26', 'With parents');
INSERT INTO `site_lang` VALUES ('251', '26', 'Curvy');
INSERT INTO `site_lang` VALUES ('252', '26', 'Living');
INSERT INTO `site_lang` VALUES ('250', '26', 'Heavy set');
INSERT INTO `site_lang` VALUES ('249', '26', 'Athletic');
INSERT INTO `site_lang` VALUES ('248', '26', 'Average');
INSERT INTO `site_lang` VALUES ('247', '26', 'Slim');
INSERT INTO `site_lang` VALUES ('245', '26', 'Other');
INSERT INTO `site_lang` VALUES ('246', '26', 'Body type');
INSERT INTO `site_lang` VALUES ('244', '26', 'Indian');
INSERT INTO `site_lang` VALUES ('243', '26', 'Pacific Islander');
INSERT INTO `site_lang` VALUES ('242', '26', 'Hispanic/latin');
INSERT INTO `site_lang` VALUES ('241', '26', 'Native American');
INSERT INTO `site_lang` VALUES ('240', '26', 'White');
INSERT INTO `site_lang` VALUES ('239', '26', 'Black');
INSERT INTO `site_lang` VALUES ('238', '26', 'Middle Eastern');
INSERT INTO `site_lang` VALUES ('237', '26', 'Asian');
INSERT INTO `site_lang` VALUES ('236', '26', 'Ethnicity');
INSERT INTO `site_lang` VALUES ('235', '26', 'Weight');
INSERT INTO `site_lang` VALUES ('234', '26', 'more than');
INSERT INTO `site_lang` VALUES ('233', '26', 'less than');
INSERT INTO `site_lang` VALUES ('229', '26', 'Open-minded');
INSERT INTO `site_lang` VALUES ('230', '26', 'Straight');
INSERT INTO `site_lang` VALUES ('231', '26', 'Bisexual');
INSERT INTO `site_lang` VALUES ('232', '26', 'Height');
INSERT INTO `site_lang` VALUES ('228', '26', 'Gay');
INSERT INTO `site_lang` VALUES ('227', '26', 'Sexuality');
INSERT INTO `site_lang` VALUES ('226', '26', 'Open');
INSERT INTO `site_lang` VALUES ('225', '26', 'Taken');
INSERT INTO `site_lang` VALUES ('224', '26', 'Single');
INSERT INTO `site_lang` VALUES ('223', '26', 'Relationship');
INSERT INTO `site_lang` VALUES ('222', '26', 'Extended info (optional)');
INSERT INTO `site_lang` VALUES ('221', '26', 'Notifications');
INSERT INTO `site_lang` VALUES ('220', '26', 'UPGRADE');
INSERT INTO `site_lang` VALUES ('219', '26', 'Basic');
INSERT INTO `site_lang` VALUES ('218', '26', 'until');
INSERT INTO `site_lang` VALUES ('217', '26', 'Wait more');
INSERT INTO `site_lang` VALUES ('216', '26', 'End call');
INSERT INTO `site_lang` VALUES ('215', '26', 'Seems that your friend do not have webcam or he is not available');
INSERT INTO `site_lang` VALUES ('214', '26', 'Too long wait');
INSERT INTO `site_lang` VALUES ('213', '26', 'You cant make videocall because you dont have webcam');
INSERT INTO `site_lang` VALUES ('212', '26', 'Impossible to make a call!');
INSERT INTO `site_lang` VALUES ('211', '26', 'Only premium users can make videocalls');
INSERT INTO `site_lang` VALUES ('210', '26', 'You are already in a videocall, you have to end the other call before start another');
INSERT INTO `site_lang` VALUES ('209', '26', 'Please allow access to your Webcam.');
INSERT INTO `site_lang` VALUES ('208', '26', 'is offline, try again when your friend is online');
INSERT INTO `site_lang` VALUES ('207', '26', 'is in another videocall , you cant call now');
INSERT INTO `site_lang` VALUES ('206', '26', 'Yes, delete it!');
INSERT INTO `site_lang` VALUES ('205', '26', 'Your data will be lost without recovery, continue?');
INSERT INTO `site_lang` VALUES ('204', '26', 'Account termination');
INSERT INTO `site_lang` VALUES ('203', '26', 'Information updated successfully');
INSERT INTO `site_lang` VALUES ('202', '26', 'Yes, buy it!');
INSERT INTO `site_lang` VALUES ('201', '26', 'more daily conversation, cost ');
INSERT INTO `site_lang` VALUES ('200', '26', 'Expand daily limitation ');
INSERT INTO `site_lang` VALUES ('199', '26', 'You dont have enought credits for send the gift');
INSERT INTO `site_lang` VALUES ('198', '26', 'Please, select 1 gift');
INSERT INTO `site_lang` VALUES ('197', '26', 'Please, select 1 photo');
INSERT INTO `site_lang` VALUES ('196', '26', 'Please, select a payment method');
INSERT INTO `site_lang` VALUES ('195', '26', 'No thanks');
INSERT INTO `site_lang` VALUES ('194', '26', 'Get access');
INSERT INTO `site_lang` VALUES ('193', '26', 'private photos for ');
INSERT INTO `site_lang` VALUES ('192', '26', 'Get access to');
INSERT INTO `site_lang` VALUES ('191', '26', 'Buy private photos permission');
INSERT INTO `site_lang` VALUES ('190', '26', 'No, i cant show you my private photos');
INSERT INTO `site_lang` VALUES ('189', '26', 'Yes, you can see my private photos');
INSERT INTO `site_lang` VALUES ('188', '26', 'Email already exist, try another');
INSERT INTO `site_lang` VALUES ('187', '26', 'Password too short');
INSERT INTO `site_lang` VALUES ('186', '26', 'Choose city from the autocomplete');
INSERT INTO `site_lang` VALUES ('185', '26', 'Add a valid date');
INSERT INTO `site_lang` VALUES ('184', '26', 'Wrong password');
INSERT INTO `site_lang` VALUES ('183', '26', 'Email dont exist');
INSERT INTO `site_lang` VALUES ('182', '26', 'Please fill all the inputs');
INSERT INTO `site_lang` VALUES ('181', '26', 'Invalid email format');
INSERT INTO `site_lang` VALUES ('180', '26', 'Password recover');
INSERT INTO `site_lang` VALUES ('179', '26', 'Login to my account');
INSERT INTO `site_lang` VALUES ('178', '26', 'If you dont remember your password, click the link below to set a new one:');
INSERT INTO `site_lang` VALUES ('177', '26', 'Hi');
INSERT INTO `site_lang` VALUES ('176', '26', 'No');
INSERT INTO `site_lang` VALUES ('175', '26', 'Yes');
INSERT INTO `site_lang` VALUES ('174', '26', 'Hello, can i have access to your private photos ?');
INSERT INTO `site_lang` VALUES ('173', '26', 'like this');
INSERT INTO `site_lang` VALUES ('172', '26', 'persons more like this');
INSERT INTO `site_lang` VALUES ('171', '26', 'Days Premium');
INSERT INTO `site_lang` VALUES ('168', '26', 'November');
INSERT INTO `site_lang` VALUES ('169', '26', 'December');
INSERT INTO `site_lang` VALUES ('170', '26', 'Buy');
INSERT INTO `site_lang` VALUES ('164', '26', 'July');
INSERT INTO `site_lang` VALUES ('165', '26', 'August');
INSERT INTO `site_lang` VALUES ('166', '26', 'September');
INSERT INTO `site_lang` VALUES ('167', '26', 'October');
INSERT INTO `site_lang` VALUES ('163', '26', 'June');
INSERT INTO `site_lang` VALUES ('159', '26', 'February');
INSERT INTO `site_lang` VALUES ('160', '26', 'March');
INSERT INTO `site_lang` VALUES ('161', '26', 'April');
INSERT INTO `site_lang` VALUES ('162', '26', 'May');
INSERT INTO `site_lang` VALUES ('158', '26', 'January');
INSERT INTO `site_lang` VALUES ('147', '26', 'New password');
INSERT INTO `site_lang` VALUES ('148', '26', 'Profile desactivation');
INSERT INTO `site_lang` VALUES ('149', '26', 'After delete your profile, some of your data will be lost without recovery.');
INSERT INTO `site_lang` VALUES ('150', '26', 'Delete profile');
INSERT INTO `site_lang` VALUES ('151', '26', 'Online now');
INSERT INTO `site_lang` VALUES ('152', '26', 'Verified');
INSERT INTO `site_lang` VALUES ('153', '26', 'Nothing found');
INSERT INTO `site_lang` VALUES ('154', '26', 'people found');
INSERT INTO `site_lang` VALUES ('155', '26', 'No popular users near you');
INSERT INTO `site_lang` VALUES ('156', '26', 'You dont have any fans yet');
INSERT INTO `site_lang` VALUES ('157', '26', 'You dont have matches yet');
INSERT INTO `site_lang` VALUES ('146', '26', 'You can change your current password bellow');
INSERT INTO `site_lang` VALUES ('145', '26', 'Change password');
INSERT INTO `site_lang` VALUES ('144', '26', 'Upgrade to premium account');
INSERT INTO `site_lang` VALUES ('143', '26', 'Add credits');
INSERT INTO `site_lang` VALUES ('142', '26', 'Current credits');
INSERT INTO `site_lang` VALUES ('139', '26', 'You are account is already verified');
INSERT INTO `site_lang` VALUES ('140', '26', 'Buy credits for send Gifs and Unblock private photos');
INSERT INTO `site_lang` VALUES ('141', '26', 'Account type');
INSERT INTO `site_lang` VALUES ('135', '26', 'Update profile');
INSERT INTO `site_lang` VALUES ('138', '26', 'Connect with Facebook');
INSERT INTO `site_lang` VALUES ('137', '26', 'For verify your account , connect with your facebook account');
INSERT INTO `site_lang` VALUES ('136', '26', 'Verify account');
INSERT INTO `site_lang` VALUES ('134', '26', 'Site language');
INSERT INTO `site_lang` VALUES ('133', '26', 'You can edit your profile information bellow');
INSERT INTO `site_lang` VALUES ('132', '26', 'Personal information');
INSERT INTO `site_lang` VALUES ('131', '26', 'Delete');
INSERT INTO `site_lang` VALUES ('129', '26', 'Verify');
INSERT INTO `site_lang` VALUES ('130', '26', 'Change password');
INSERT INTO `site_lang` VALUES ('127', '26', 'Personal');
INSERT INTO `site_lang` VALUES ('128', '26', 'Credits');
INSERT INTO `site_lang` VALUES ('126', '26', 'Unblock private photos');
INSERT INTO `site_lang` VALUES ('125', '26', 'Ask permission to');
INSERT INTO `site_lang` VALUES ('124', '26', 'Now you have');
INSERT INTO `site_lang` VALUES ('115', '26', 'World');
INSERT INTO `site_lang` VALUES ('116', '26', 'Most popular users');
INSERT INTO `site_lang` VALUES ('117', '26', 'About ');
INSERT INTO `site_lang` VALUES ('118', '26', 'Personal info');
INSERT INTO `site_lang` VALUES ('119', '26', 'years old');
INSERT INTO `site_lang` VALUES ('120', '26', 'Only boys');
INSERT INTO `site_lang` VALUES ('121', '26', 'Only girls');
INSERT INTO `site_lang` VALUES ('122', '26', 'boys and girls');
INSERT INTO `site_lang` VALUES ('123', '26', 'Credits successfully added to your account');
INSERT INTO `site_lang` VALUES ('114', '26', 'in a radius of');
INSERT INTO `site_lang` VALUES ('113', '26', 'who are between');
INSERT INTO `site_lang` VALUES ('111', '26', 'Boys');
INSERT INTO `site_lang` VALUES ('112', '26', 'Both');
INSERT INTO `site_lang` VALUES ('110', '26', 'Girls');
INSERT INTO `site_lang` VALUES ('109', '26', 'Show me');
INSERT INTO `site_lang` VALUES ('108', '26', 'Online now');
INSERT INTO `site_lang` VALUES ('107', '26', 'All users');
INSERT INTO `site_lang` VALUES ('106', '26', 'Filter Search');
INSERT INTO `site_lang` VALUES ('105', '26', 'Your matches');
INSERT INTO `site_lang` VALUES ('104', '26', 'Please complete your profile before start in ');
INSERT INTO `site_lang` VALUES ('103', '26', 'Terms of Use');
INSERT INTO `site_lang` VALUES ('102', '26', 'Privacy Policy');
INSERT INTO `site_lang` VALUES ('101', '26', 'Your fans');
INSERT INTO `site_lang` VALUES ('100', '26', 'or wait until tomorrow for continue meeting people');
INSERT INTO `site_lang` VALUES ('99', '26', 'daily conversations');
INSERT INTO `site_lang` VALUES ('98', '26', 'and get up to');
INSERT INTO `site_lang` VALUES ('97', '26', 'Upgrade your account to Premium');
INSERT INTO `site_lang` VALUES ('96', '26', 'or');
INSERT INTO `site_lang` VALUES ('95', '26', 'more daily conversation');
INSERT INTO `site_lang` VALUES ('94', '26', 'Buy');
INSERT INTO `site_lang` VALUES ('93', '26', 'To continue chatting');
INSERT INTO `site_lang` VALUES ('91', '26', 'Chat');
INSERT INTO `site_lang` VALUES ('92', '26', 'you have reached the limit of new daily conversations');
INSERT INTO `site_lang` VALUES ('87', '26', 'Unblock all private photos');
INSERT INTO `site_lang` VALUES ('90', '26', 'Send');
INSERT INTO `site_lang` VALUES ('89', '26', 'Write text here');
INSERT INTO `site_lang` VALUES ('88', '26', 'Premium user badge');
INSERT INTO `site_lang` VALUES ('86', '26', 'Unlimited videocalls');
INSERT INTO `site_lang` VALUES ('85', '26', 'new chats per day');
INSERT INTO `site_lang` VALUES ('84', '26', 'Premium Account Features');
INSERT INTO `site_lang` VALUES ('83', '26', 'Buy credits');
INSERT INTO `site_lang` VALUES ('82', '26', 'Pay with');
INSERT INTO `site_lang` VALUES ('81', '26', 'Pay with');
INSERT INTO `site_lang` VALUES ('80', '26', 'Select payment method');
INSERT INTO `site_lang` VALUES ('79', '26', 'Select credits package');
INSERT INTO `site_lang` VALUES ('78', '26', 'Buy credits / Upgrade account');
INSERT INTO `site_lang` VALUES ('77', '26', 'Send gift');
INSERT INTO `site_lang` VALUES ('76', '26', 'Pick the gift you want to send to ');
INSERT INTO `site_lang` VALUES ('75', '26', 'Send gift to ');
INSERT INTO `site_lang` VALUES ('74', '26', 'Add photo');
INSERT INTO `site_lang` VALUES ('73', '26', 'Credits');
INSERT INTO `site_lang` VALUES ('72', '26', 'Pick the photo you want to show in the Spotlight, cost ');
INSERT INTO `site_lang` VALUES ('67', '26', 'Public Photos');
INSERT INTO `site_lang` VALUES ('68', '26', 'Private Photos');
INSERT INTO `site_lang` VALUES ('69', '26', 'Add your photos');
INSERT INTO `site_lang` VALUES ('70', '26', 'add photos');
INSERT INTO `site_lang` VALUES ('71', '26', 'Add yourself to the Spotlight');
INSERT INTO `site_lang` VALUES ('66', '26', 'All Photos');
INSERT INTO `site_lang` VALUES ('65', '26', 'Manage your photos');
INSERT INTO `site_lang` VALUES ('64', '26', 'Contact');
INSERT INTO `site_lang` VALUES ('63', '26', 'Privacy');
INSERT INTO `site_lang` VALUES ('62', '26', 'Terms');
INSERT INTO `site_lang` VALUES ('61', '26', 'Who to like');
INSERT INTO `site_lang` VALUES ('60', '26', 'New messages');
INSERT INTO `site_lang` VALUES ('59', '26', 'Online now');
INSERT INTO `site_lang` VALUES ('57', '26', 'Fans');
INSERT INTO `site_lang` VALUES ('58', '26', 'Conversations');
INSERT INTO `site_lang` VALUES ('56', '26', 'All');
INSERT INTO `site_lang` VALUES ('55', '26', 'Settings');
INSERT INTO `site_lang` VALUES ('54', '26', 'Manage photos');
INSERT INTO `site_lang` VALUES ('53', '26', 'Fans');
INSERT INTO `site_lang` VALUES ('52', '26', 'Most populars');
INSERT INTO `site_lang` VALUES ('51', '26', 'Matches');
INSERT INTO `site_lang` VALUES ('50', '26', 'Discover');
INSERT INTO `site_lang` VALUES ('49', '26', 'Meet new people');
INSERT INTO `site_lang` VALUES ('48', '26', 'Logout');
INSERT INTO `site_lang` VALUES ('47', '26', 'Settings');
INSERT INTO `site_lang` VALUES ('46', '26', 'Profile');
INSERT INTO `site_lang` VALUES ('45', '26', 'Privacy Policy');
INSERT INTO `site_lang` VALUES ('44', '26', 'and');
INSERT INTO `site_lang` VALUES ('43', '26', 'Terms and Conditions');
INSERT INTO `site_lang` VALUES ('42', '26', 'By continuing, you are confirming that you have read and agree to our');
INSERT INTO `site_lang` VALUES ('41', '26', 'Sign up');
INSERT INTO `site_lang` VALUES ('40', '26', 'Meet boys and girls');
INSERT INTO `site_lang` VALUES ('39', '26', 'Meet boys');
INSERT INTO `site_lang` VALUES ('38', '26', 'Meet girls');
INSERT INTO `site_lang` VALUES ('37', '26', 'Im here to');
INSERT INTO `site_lang` VALUES ('36', '26', 'Female');
INSERT INTO `site_lang` VALUES ('35', '26', 'Male');
INSERT INTO `site_lang` VALUES ('34', '26', 'Gender');
INSERT INTO `site_lang` VALUES ('32', '26', 'City');
INSERT INTO `site_lang` VALUES ('33', '26', 'Where do you live?');
INSERT INTO `site_lang` VALUES ('31', '26', 'Please select');
INSERT INTO `site_lang` VALUES ('30', '26', 'Birthday');
INSERT INTO `site_lang` VALUES ('29', '26', 'Password');
INSERT INTO `site_lang` VALUES ('28', '26', 'Email');
INSERT INTO `site_lang` VALUES ('27', '26', 'Your name or nickname');
INSERT INTO `site_lang` VALUES ('26', '26', 'Name');
INSERT INTO `site_lang` VALUES ('25', '26', 'Join the worlds bestest community for meeting new people!.');
INSERT INTO `site_lang` VALUES ('24', '26', 'Become a member now');
INSERT INTO `site_lang` VALUES ('23', '26', 'Play our popular Discover game and get matched with other users. Its a great way to break the ice and chat to new people.');
INSERT INTO `site_lang` VALUES ('22', '26', 'Matches');
INSERT INTO `site_lang` VALUES ('20', '26', 'People nearby');
INSERT INTO `site_lang` VALUES ('21', '26', 'We wont show your exact location, but you will be able to find people nearby who like the same things you do.');
INSERT INTO `site_lang` VALUES ('19', '26', 'You can make quality videocalls for free to anyone, without limits of call duration, just enjoy seeing the person who is chatting with you');
INSERT INTO `site_lang` VALUES ('13', '26', 'Login now');
INSERT INTO `site_lang` VALUES ('14', '26', 'Password recover');
INSERT INTO `site_lang` VALUES ('15', '26', 'Recover password');
INSERT INTO `site_lang` VALUES ('16', '26', 'Chat');
INSERT INTO `site_lang` VALUES ('17', '26', 'Powerfull private chat for meet new friends, you can send emoticons and private photos to anyone.');
INSERT INTO `site_lang` VALUES ('18', '26', 'Video Chat');
INSERT INTO `site_lang` VALUES ('11', '26', 'Your password');
INSERT INTO `site_lang` VALUES ('12', '26', 'do you forget your password?');
INSERT INTO `site_lang` VALUES ('10', '26', 'Your email');
INSERT INTO `site_lang` VALUES ('9', '26', 'Welcome back');
INSERT INTO `site_lang` VALUES ('8', '26', 'Create your account');
INSERT INTO `site_lang` VALUES ('7', '26', 'Connect with ');
INSERT INTO `site_lang` VALUES ('6', '26', 'SOON AVAILABLE');
INSERT INTO `site_lang` VALUES ('5', '26', 'Soon we will have our phone apps online');
INSERT INTO `site_lang` VALUES ('4', '26', 'Please visit us from your laptop or PC');
INSERT INTO `site_lang` VALUES ('3', '26', 'For now our site works only for Desktop users');
INSERT INTO `site_lang` VALUES ('2', '26', 'Welcome to the fastest growing place to meet new people');
INSERT INTO `site_lang` VALUES ('1', '26', 'Login');
INSERT INTO `site_lang` VALUES ('0', '26', 'meet new people!');
INSERT INTO `site_lang` VALUES ('384', '25', 'Ok, i understand');
INSERT INTO `site_lang` VALUES ('383', '25', 'must like you for start a videocall');
INSERT INTO `site_lang` VALUES ('379', '25', 'Go to');
INSERT INTO `site_lang` VALUES ('380', '25', 'Welcome to');
INSERT INTO `site_lang` VALUES ('381', '25', 'calling...');
INSERT INTO `site_lang` VALUES ('382', '25', 'dont like you');
INSERT INTO `site_lang` VALUES ('378', '25', 'Please save your connection information in a safe place');
INSERT INTO `site_lang` VALUES ('377', '25', 'Password');
INSERT INTO `site_lang` VALUES ('376', '25', 'E-mail');
INSERT INTO `site_lang` VALUES ('375', '25', 'Here are your connection details');
INSERT INTO `site_lang` VALUES ('374', '25', 'Start meeting new people now');
INSERT INTO `site_lang` VALUES ('373', '25', 'More than 1 million people have joined $site_name You probably want to know some of them.');
INSERT INTO `site_lang` VALUES ('372', '25', 'Add photos and complete your profile');
INSERT INTO `site_lang` VALUES ('371', '25', 'Nobody is going to fall in love with a blank page. The more information you get, the more chances to find that special someone!');
INSERT INTO `site_lang` VALUES ('370', '25', 'Meet new people');
INSERT INTO `site_lang` VALUES ('369', '25', 'you can meet people instantly');
INSERT INTO `site_lang` VALUES ('368', '25', 'In');
INSERT INTO `site_lang` VALUES ('367', '25', 'people in your area wants to know you');
INSERT INTO `site_lang` VALUES ('366', '25', 'Newsflash');
INSERT INTO `site_lang` VALUES ('365', '25', 'Verify your account');
INSERT INTO `site_lang` VALUES ('364', '25', 'Now you are a new member of');
INSERT INTO `site_lang` VALUES ('363', '25', 'Here are a few tips');
INSERT INTO `site_lang` VALUES ('362', '25', 'Well done, now you are in');
INSERT INTO `site_lang` VALUES ('361', '25', 'Welcome');
INSERT INTO `site_lang` VALUES ('360', '25', 'Check out the profile');
INSERT INTO `site_lang` VALUES ('359', '25', 'and lives closer to you');
INSERT INTO `site_lang` VALUES ('358', '25', 'is new at');
INSERT INTO `site_lang` VALUES ('357', '25', 'is new and lives closer to you');
INSERT INTO `site_lang` VALUES ('356', '25', 'Have fun!');
INSERT INTO `site_lang` VALUES ('355', '25', 'Respond to');
INSERT INTO `site_lang` VALUES ('354', '25', 'you have a new message from');
INSERT INTO `site_lang` VALUES ('352', '25', 'Go and say something to');
INSERT INTO `site_lang` VALUES ('353', '25', 'New message from');
INSERT INTO `site_lang` VALUES ('351', '25', 'thinks the feeling is mutual');
INSERT INTO `site_lang` VALUES ('350', '25', 'Its a match!');
INSERT INTO `site_lang` VALUES ('349', '25', 'You have a match at');
INSERT INTO `site_lang` VALUES ('348', '25', 'if you forgot your password, click on the link below to get a new');
INSERT INTO `site_lang` VALUES ('347', '25', 'Choose a new password');
INSERT INTO `site_lang` VALUES ('346', '25', 'Unsubscribe');
INSERT INTO `site_lang` VALUES ('344', '25', 'Find out if you also like');
INSERT INTO `site_lang` VALUES ('345', '25', 'You received this notice because you registered as');
INSERT INTO `site_lang` VALUES ('343', '25', 'has seen you in discover and likes. The feeling is mutual?');
INSERT INTO `site_lang` VALUES ('342', '25', 'likes you and wants to chat in');
INSERT INTO `site_lang` VALUES ('341', '25', 'We sent you a email with your info, it may take up to 1 min to arrive');
INSERT INTO `site_lang` VALUES ('339', '25', 'of');
INSERT INTO `site_lang` VALUES ('340', '25', 'Loading...');
INSERT INTO `site_lang` VALUES ('338', '25', 'Photos of ');
INSERT INTO `site_lang` VALUES ('333', '25', 'Wrong');
INSERT INTO `site_lang` VALUES ('334', '25', 'Spotlight');
INSERT INTO `site_lang` VALUES ('335', '25', 'Service cost');
INSERT INTO `site_lang` VALUES ('336', '25', 'Password successfully changed');
INSERT INTO `site_lang` VALUES ('337', '25', 'is calling you..');
INSERT INTO `site_lang` VALUES ('332', '25', 'days of Premium');
INSERT INTO `site_lang` VALUES ('331', '25', 'username');
INSERT INTO `site_lang` VALUES ('330', '25', 'You need to write your username!');
INSERT INTO `site_lang` VALUES ('329', '25', 'Write your instagram username');
INSERT INTO `site_lang` VALUES ('328', '25', 'Press backspace key for smart return to the meeting section.');
INSERT INTO `site_lang` VALUES ('327', '25', 'Are you sure you want to report');
INSERT INTO `site_lang` VALUES ('326', '25', 'Report and block');
INSERT INTO `site_lang` VALUES ('325', '25', 'is blocking you or you blocked him, you cant chat with him sorry');
INSERT INTO `site_lang` VALUES ('324', '25', 'We sended you a email for verify your account');
INSERT INTO `site_lang` VALUES ('323', '25', 'years old and im from');
INSERT INTO `site_lang` VALUES ('322', '25', 'Hi, im');
INSERT INTO `site_lang` VALUES ('321', '25', 'Please add a profile photo');
INSERT INTO `site_lang` VALUES ('319', '25', 'ago');
INSERT INTO `site_lang` VALUES ('320', '25', 'Please verify your account, check your email');
INSERT INTO `site_lang` VALUES ('318', '25', 'seconds');
INSERT INTO `site_lang` VALUES ('317', '25', 'minutes');
INSERT INTO `site_lang` VALUES ('316', '25', 'hours');
INSERT INTO `site_lang` VALUES ('315', '25', 'days');
INSERT INTO `site_lang` VALUES ('314', '25', 'months');
INSERT INTO `site_lang` VALUES ('313', '25', 'years');
INSERT INTO `site_lang` VALUES ('312', '25', 'second');
INSERT INTO `site_lang` VALUES ('311', '25', 'minute');
INSERT INTO `site_lang` VALUES ('309', '25', 'day');
INSERT INTO `site_lang` VALUES ('310', '25', 'hour');
INSERT INTO `site_lang` VALUES ('308', '25', 'month');
INSERT INTO `site_lang` VALUES ('307', '25', 'year');
INSERT INTO `site_lang` VALUES ('306', '25', '0 seconds');
INSERT INTO `site_lang` VALUES ('304', '25', 'Cost');
INSERT INTO `site_lang` VALUES ('305', '25', 'Credits for $');
INSERT INTO `site_lang` VALUES ('302', '25', 'visited');
INSERT INTO `site_lang` VALUES ('303', '25', 'You do not like anyone');
INSERT INTO `site_lang` VALUES ('301', '25', 'You dont have any visit yet');
INSERT INTO `site_lang` VALUES ('300', '25', 'AGE');
INSERT INTO `site_lang` VALUES ('299', '25', 'Dislike');
INSERT INTO `site_lang` VALUES ('298', '25', 'Like');
INSERT INTO `site_lang` VALUES ('297', '25', 'Messages');
INSERT INTO `site_lang` VALUES ('296', '25', 'people liked you, for see them');
INSERT INTO `site_lang` VALUES ('294', '25', 'Upgrade your account to premium');
INSERT INTO `site_lang` VALUES ('295', '25', 'People i like');
INSERT INTO `site_lang` VALUES ('293', '25', 'people visited your profile for see them');
INSERT INTO `site_lang` VALUES ('292', '25', 'Delete');
INSERT INTO `site_lang` VALUES ('291', '25', 'Public photo');
INSERT INTO `site_lang` VALUES ('290', '25', 'Private photo');
INSERT INTO `site_lang` VALUES ('289', '25', 'Set as profile');
INSERT INTO `site_lang` VALUES ('288', '25', 'get seen by millions');
INSERT INTO `site_lang` VALUES ('287', '25', 'Add me here');
INSERT INTO `site_lang` VALUES ('286', '25', 'Visits');
INSERT INTO `site_lang` VALUES ('285', '25', 'Credits');
INSERT INTO `site_lang` VALUES ('284', '25', 'Photos');
INSERT INTO `site_lang` VALUES ('283', '25', 'Add');
INSERT INTO `site_lang` VALUES ('282', '25', 'Add from ');
INSERT INTO `site_lang` VALUES ('281', '25', 'Private photos');
INSERT INTO `site_lang` VALUES ('280', '25', 'Public Photos');
INSERT INTO `site_lang` VALUES ('279', '25', 'No data');
INSERT INTO `site_lang` VALUES ('278', '25', 'Fans');
INSERT INTO `site_lang` VALUES ('277', '25', 'Report');
INSERT INTO `site_lang` VALUES ('275', '25', 'Please wait');
INSERT INTO `site_lang` VALUES ('276', '25', 'Interests');
INSERT INTO `site_lang` VALUES ('274', '25', 'Year');
INSERT INTO `site_lang` VALUES ('272', '25', 'Day');
INSERT INTO `site_lang` VALUES ('273', '25', 'Month');
INSERT INTO `site_lang` VALUES ('271', '25', 'When someone send me a message');
INSERT INTO `site_lang` VALUES ('270', '25', 'When new users near me join in');
INSERT INTO `site_lang` VALUES ('269', '25', 'When i get a match');
INSERT INTO `site_lang` VALUES ('268', '25', 'When someone likes me');
INSERT INTO `site_lang` VALUES ('267', '25', 'None');
INSERT INTO `site_lang` VALUES ('266', '25', 'I own a motorbike');
INSERT INTO `site_lang` VALUES ('265', '25', 'I own a car');
INSERT INTO `site_lang` VALUES ('264', '25', 'Parents car');
INSERT INTO `site_lang` VALUES ('263', '25', 'Transport');
INSERT INTO `site_lang` VALUES ('262', '25', 'Drink');
INSERT INTO `site_lang` VALUES ('260', '25', 'No');
INSERT INTO `site_lang` VALUES ('261', '25', 'Sometimes');
INSERT INTO `site_lang` VALUES ('259', '25', 'Yes');
INSERT INTO `site_lang` VALUES ('258', '25', 'Smoke');
INSERT INTO `site_lang` VALUES ('256', '25', 'With partner');
INSERT INTO `site_lang` VALUES ('257', '25', 'Alone');
INSERT INTO `site_lang` VALUES ('255', '25', 'Student dormitory');
INSERT INTO `site_lang` VALUES ('254', '25', 'With housemate');
INSERT INTO `site_lang` VALUES ('253', '25', 'With parents');
INSERT INTO `site_lang` VALUES ('252', '25', 'Living');
INSERT INTO `site_lang` VALUES ('251', '25', 'Curvy');
INSERT INTO `site_lang` VALUES ('250', '25', 'Heavy set');
INSERT INTO `site_lang` VALUES ('249', '25', 'Athletic');
INSERT INTO `site_lang` VALUES ('248', '25', 'Average');
INSERT INTO `site_lang` VALUES ('247', '25', 'Slim');
INSERT INTO `site_lang` VALUES ('246', '25', 'Body type');
INSERT INTO `site_lang` VALUES ('245', '25', 'Other');
INSERT INTO `site_lang` VALUES ('244', '25', 'Indian');
INSERT INTO `site_lang` VALUES ('243', '25', 'Pacific Islander');
INSERT INTO `site_lang` VALUES ('242', '25', 'Hispanic/latin');
INSERT INTO `site_lang` VALUES ('241', '25', 'Native American');
INSERT INTO `site_lang` VALUES ('240', '25', 'White');
INSERT INTO `site_lang` VALUES ('239', '25', 'Black');
INSERT INTO `site_lang` VALUES ('238', '25', 'Middle Eastern');
INSERT INTO `site_lang` VALUES ('237', '25', 'Asian');
INSERT INTO `site_lang` VALUES ('236', '25', 'Ethnicity');
INSERT INTO `site_lang` VALUES ('235', '25', 'Weight');
INSERT INTO `site_lang` VALUES ('234', '25', 'more than');
INSERT INTO `site_lang` VALUES ('233', '25', 'less than');
INSERT INTO `site_lang` VALUES ('232', '25', 'Height');
INSERT INTO `site_lang` VALUES ('231', '25', 'Bisexual');
INSERT INTO `site_lang` VALUES ('230', '25', 'Straight');
INSERT INTO `site_lang` VALUES ('229', '25', 'Open-minded');
INSERT INTO `site_lang` VALUES ('225', '25', 'Taken');
INSERT INTO `site_lang` VALUES ('226', '25', 'Open');
INSERT INTO `site_lang` VALUES ('227', '25', 'Sexuality');
INSERT INTO `site_lang` VALUES ('228', '25', 'Gay');
INSERT INTO `site_lang` VALUES ('224', '25', 'Single');
INSERT INTO `site_lang` VALUES ('223', '25', 'Relationship');
INSERT INTO `site_lang` VALUES ('208', '25', 'is offline, try again when your friend is online');
INSERT INTO `site_lang` VALUES ('209', '25', 'Please allow access to your Webcam.');
INSERT INTO `site_lang` VALUES ('210', '25', 'You are already in a videocall, you have to end the other call before start another');
INSERT INTO `site_lang` VALUES ('211', '25', 'Only premium users can make videocalls');
INSERT INTO `site_lang` VALUES ('212', '25', 'Impossible to make a call!');
INSERT INTO `site_lang` VALUES ('213', '25', 'You cant make videocall because you dont have webcam');
INSERT INTO `site_lang` VALUES ('214', '25', 'Too long wait');
INSERT INTO `site_lang` VALUES ('215', '25', 'Seems that your friend do not have webcam or he is not available');
INSERT INTO `site_lang` VALUES ('216', '25', 'End call');
INSERT INTO `site_lang` VALUES ('217', '25', 'Wait more');
INSERT INTO `site_lang` VALUES ('218', '25', 'until');
INSERT INTO `site_lang` VALUES ('219', '25', 'Basic');
INSERT INTO `site_lang` VALUES ('220', '25', 'UPGRADE');
INSERT INTO `site_lang` VALUES ('221', '25', 'Notifications');
INSERT INTO `site_lang` VALUES ('222', '25', 'Extended info (optional)');
INSERT INTO `site_lang` VALUES ('207', '25', 'is in another videocall , you cant call now');
INSERT INTO `site_lang` VALUES ('206', '25', 'Yes, delete it!');
INSERT INTO `site_lang` VALUES ('204', '25', 'Account termination');
INSERT INTO `site_lang` VALUES ('205', '25', 'Your data will be lost without recovery, continue?');
INSERT INTO `site_lang` VALUES ('203', '25', 'Information updated successfully');
INSERT INTO `site_lang` VALUES ('202', '25', 'Yes, buy it!');
INSERT INTO `site_lang` VALUES ('201', '25', 'more daily conversation, cost ');
INSERT INTO `site_lang` VALUES ('200', '25', 'Expand daily limitation ');
INSERT INTO `site_lang` VALUES ('199', '25', 'You dont have enought credits for send the gift');
INSERT INTO `site_lang` VALUES ('198', '25', 'Please, select 1 gift');
INSERT INTO `site_lang` VALUES ('197', '25', 'Please, select 1 photo');
INSERT INTO `site_lang` VALUES ('196', '25', 'Please, select a payment method');
INSERT INTO `site_lang` VALUES ('195', '25', 'No thanks');
INSERT INTO `site_lang` VALUES ('194', '25', 'Get access');
INSERT INTO `site_lang` VALUES ('193', '25', 'private photos for ');
INSERT INTO `site_lang` VALUES ('192', '25', 'Get access to');
INSERT INTO `site_lang` VALUES ('191', '25', 'Buy private photos permission');
INSERT INTO `site_lang` VALUES ('190', '25', 'No, i cant show you my private photos');
INSERT INTO `site_lang` VALUES ('187', '25', 'Password too short');
INSERT INTO `site_lang` VALUES ('188', '25', 'Email already exist, try another');
INSERT INTO `site_lang` VALUES ('189', '25', 'Yes, you can see my private photos');
INSERT INTO `site_lang` VALUES ('186', '25', 'Choose city from the autocomplete');
INSERT INTO `site_lang` VALUES ('185', '25', 'Add a valid date');
INSERT INTO `site_lang` VALUES ('183', '25', 'Email dont exist');
INSERT INTO `site_lang` VALUES ('184', '25', 'Wrong password');
INSERT INTO `site_lang` VALUES ('182', '25', 'Please fill all the inputs');
INSERT INTO `site_lang` VALUES ('181', '25', 'Invalid email format');
INSERT INTO `site_lang` VALUES ('180', '25', 'Password recover');
INSERT INTO `site_lang` VALUES ('179', '25', 'Login to my account');
INSERT INTO `site_lang` VALUES ('178', '25', 'If you dont remember your password, click the link below to set a new one:');
INSERT INTO `site_lang` VALUES ('177', '25', 'Hi');
INSERT INTO `site_lang` VALUES ('176', '25', 'No');
INSERT INTO `site_lang` VALUES ('175', '25', 'Yes');
INSERT INTO `site_lang` VALUES ('174', '25', 'Hello, can i have access to your private photos ?');
INSERT INTO `site_lang` VALUES ('173', '25', 'like this');
INSERT INTO `site_lang` VALUES ('172', '25', 'persons more like this');
INSERT INTO `site_lang` VALUES ('171', '25', 'Days Premium');
INSERT INTO `site_lang` VALUES ('170', '25', 'Buy');
INSERT INTO `site_lang` VALUES ('169', '25', 'December');
INSERT INTO `site_lang` VALUES ('168', '25', 'November');
INSERT INTO `site_lang` VALUES ('167', '25', 'October');
INSERT INTO `site_lang` VALUES ('166', '25', 'September');
INSERT INTO `site_lang` VALUES ('164', '25', 'July');
INSERT INTO `site_lang` VALUES ('165', '25', 'August');
INSERT INTO `site_lang` VALUES ('163', '25', 'June');
INSERT INTO `site_lang` VALUES ('162', '25', 'May');
INSERT INTO `site_lang` VALUES ('161', '25', 'April');
INSERT INTO `site_lang` VALUES ('160', '25', 'March');
INSERT INTO `site_lang` VALUES ('159', '25', 'February');
INSERT INTO `site_lang` VALUES ('158', '25', 'January');
INSERT INTO `site_lang` VALUES ('157', '25', 'You dont have matches yet');
INSERT INTO `site_lang` VALUES ('156', '25', 'You dont have any fans yet');
INSERT INTO `site_lang` VALUES ('155', '25', 'No popular users near you');
INSERT INTO `site_lang` VALUES ('154', '25', 'people found');
INSERT INTO `site_lang` VALUES ('153', '25', 'Nothing found');
INSERT INTO `site_lang` VALUES ('152', '25', 'Verified');
INSERT INTO `site_lang` VALUES ('151', '25', 'Online now');
INSERT INTO `site_lang` VALUES ('150', '25', 'Delete profile');
INSERT INTO `site_lang` VALUES ('149', '25', 'After delete your profile, some of your data will be lost without recovery.');
INSERT INTO `site_lang` VALUES ('148', '25', 'Profile desactivation');
INSERT INTO `site_lang` VALUES ('147', '25', 'New password');
INSERT INTO `site_lang` VALUES ('146', '25', 'You can change your current password bellow');
INSERT INTO `site_lang` VALUES ('145', '25', 'Change password');
INSERT INTO `site_lang` VALUES ('144', '25', 'Upgrade to premium account');
INSERT INTO `site_lang` VALUES ('143', '25', 'Add credits');
INSERT INTO `site_lang` VALUES ('142', '25', 'Current credits');
INSERT INTO `site_lang` VALUES ('141', '25', 'Account type');
INSERT INTO `site_lang` VALUES ('140', '25', 'Buy credits for send Gifs and Unblock private photos');
INSERT INTO `site_lang` VALUES ('139', '25', 'You are account is already verified');
INSERT INTO `site_lang` VALUES ('138', '25', 'Connect with Facebook');
INSERT INTO `site_lang` VALUES ('137', '25', 'For verify your account , connect with your facebook account');
INSERT INTO `site_lang` VALUES ('136', '25', 'Verify account');
INSERT INTO `site_lang` VALUES ('135', '25', 'Update profile');
INSERT INTO `site_lang` VALUES ('134', '25', 'Site language');
INSERT INTO `site_lang` VALUES ('133', '25', 'You can edit your profile information bellow');
INSERT INTO `site_lang` VALUES ('132', '25', 'Personal information');
INSERT INTO `site_lang` VALUES ('131', '25', 'Delete');
INSERT INTO `site_lang` VALUES ('130', '25', 'Change password');
INSERT INTO `site_lang` VALUES ('129', '25', 'Verify');
INSERT INTO `site_lang` VALUES ('128', '25', 'Credits');
INSERT INTO `site_lang` VALUES ('127', '25', 'Personal');
INSERT INTO `site_lang` VALUES ('126', '25', 'Unblock private photos');
INSERT INTO `site_lang` VALUES ('125', '25', 'Ask permission to');
INSERT INTO `site_lang` VALUES ('124', '25', 'Now you have');
INSERT INTO `site_lang` VALUES ('123', '25', 'Credits successfully added to your account');
INSERT INTO `site_lang` VALUES ('122', '25', 'boys and girls');
INSERT INTO `site_lang` VALUES ('121', '25', 'Only girls');
INSERT INTO `site_lang` VALUES ('120', '25', 'Only boys');
INSERT INTO `site_lang` VALUES ('119', '25', 'years old');
INSERT INTO `site_lang` VALUES ('118', '25', 'Personal info');
INSERT INTO `site_lang` VALUES ('117', '25', 'About ');
INSERT INTO `site_lang` VALUES ('116', '25', 'Most popular users');
INSERT INTO `site_lang` VALUES ('115', '25', 'World');
INSERT INTO `site_lang` VALUES ('114', '25', 'in a radius of');
INSERT INTO `site_lang` VALUES ('113', '25', 'who are between');
INSERT INTO `site_lang` VALUES ('112', '25', 'Both');
INSERT INTO `site_lang` VALUES ('111', '25', 'Boys');
INSERT INTO `site_lang` VALUES ('110', '25', 'Girls');
INSERT INTO `site_lang` VALUES ('109', '25', 'Show me');
INSERT INTO `site_lang` VALUES ('108', '25', 'Online now');
INSERT INTO `site_lang` VALUES ('107', '25', 'All users');
INSERT INTO `site_lang` VALUES ('106', '25', 'Filter Search');
INSERT INTO `site_lang` VALUES ('105', '25', 'Your matches');
INSERT INTO `site_lang` VALUES ('104', '25', 'Please complete your profile before start in ');
INSERT INTO `site_lang` VALUES ('103', '25', 'Terms of Use');
INSERT INTO `site_lang` VALUES ('102', '25', 'Privacy Policy');
INSERT INTO `site_lang` VALUES ('101', '25', 'Your fans');
INSERT INTO `site_lang` VALUES ('100', '25', 'or wait until tomorrow for continue meeting people');
INSERT INTO `site_lang` VALUES ('99', '25', 'daily conversations');
INSERT INTO `site_lang` VALUES ('98', '25', 'and get up to');
INSERT INTO `site_lang` VALUES ('97', '25', 'Upgrade your account to Premium');
INSERT INTO `site_lang` VALUES ('96', '25', 'or');
INSERT INTO `site_lang` VALUES ('94', '25', 'Buy');
INSERT INTO `site_lang` VALUES ('95', '25', 'more daily conversation');
INSERT INTO `site_lang` VALUES ('92', '25', 'you have reached the limit of new daily conversations');
INSERT INTO `site_lang` VALUES ('93', '25', 'To continue chatting');
INSERT INTO `site_lang` VALUES ('89', '25', 'Write text here');
INSERT INTO `site_lang` VALUES ('90', '25', 'Send');
INSERT INTO `site_lang` VALUES ('91', '25', 'Chat');
INSERT INTO `site_lang` VALUES ('86', '25', 'Unlimited videocalls');
INSERT INTO `site_lang` VALUES ('87', '25', 'Unblock all private photos');
INSERT INTO `site_lang` VALUES ('88', '25', 'Premium user badge');
INSERT INTO `site_lang` VALUES ('84', '25', 'Premium Account Features');
INSERT INTO `site_lang` VALUES ('85', '25', 'new chats per day');
INSERT INTO `site_lang` VALUES ('83', '25', 'Buy credits');
INSERT INTO `site_lang` VALUES ('81', '25', 'Pay with');
INSERT INTO `site_lang` VALUES ('82', '25', 'Pay with');
INSERT INTO `site_lang` VALUES ('80', '25', 'Select payment method');
INSERT INTO `site_lang` VALUES ('79', '25', 'Select credits package');
INSERT INTO `site_lang` VALUES ('78', '25', 'Buy credits / Upgrade account');
INSERT INTO `site_lang` VALUES ('76', '25', 'Pick the gift you want to send to ');
INSERT INTO `site_lang` VALUES ('77', '25', 'Send gift');
INSERT INTO `site_lang` VALUES ('75', '25', 'Send gift to ');
INSERT INTO `site_lang` VALUES ('74', '25', 'Add photo');
INSERT INTO `site_lang` VALUES ('73', '25', 'Credits');
INSERT INTO `site_lang` VALUES ('72', '25', 'Pick the photo you want to show in the Spotlight, cost ');
INSERT INTO `site_lang` VALUES ('71', '25', 'Add yourself to the Spotlight');
INSERT INTO `site_lang` VALUES ('70', '25', 'add photos');
INSERT INTO `site_lang` VALUES ('69', '25', 'Add your photos');
INSERT INTO `site_lang` VALUES ('68', '25', 'Private Photos');
INSERT INTO `site_lang` VALUES ('67', '25', 'Public Photos');
INSERT INTO `site_lang` VALUES ('66', '25', 'All Photos');
INSERT INTO `site_lang` VALUES ('65', '25', 'Manage your photos');
INSERT INTO `site_lang` VALUES ('64', '25', 'Contact');
INSERT INTO `site_lang` VALUES ('63', '25', 'Privacy');
INSERT INTO `site_lang` VALUES ('61', '25', 'Who to like');
INSERT INTO `site_lang` VALUES ('62', '25', 'Terms');
INSERT INTO `site_lang` VALUES ('60', '25', 'New messages');
INSERT INTO `site_lang` VALUES ('59', '25', 'Online now');
INSERT INTO `site_lang` VALUES ('57', '25', 'Fans');
INSERT INTO `site_lang` VALUES ('58', '25', 'Conversations');
INSERT INTO `site_lang` VALUES ('56', '25', 'All');
INSERT INTO `site_lang` VALUES ('55', '25', 'Settings');
INSERT INTO `site_lang` VALUES ('54', '25', 'Manage photos');
INSERT INTO `site_lang` VALUES ('53', '25', 'Fans');
INSERT INTO `site_lang` VALUES ('51', '25', 'Matches');
INSERT INTO `site_lang` VALUES ('52', '25', 'Most populars');
INSERT INTO `site_lang` VALUES ('50', '25', 'Discover');
INSERT INTO `site_lang` VALUES ('49', '25', 'Meet new people');
INSERT INTO `site_lang` VALUES ('48', '25', 'Logout');
INSERT INTO `site_lang` VALUES ('47', '25', 'Settings');
INSERT INTO `site_lang` VALUES ('46', '25', 'Profile');
INSERT INTO `site_lang` VALUES ('44', '25', 'and');
INSERT INTO `site_lang` VALUES ('45', '25', 'Privacy Policy');
INSERT INTO `site_lang` VALUES ('43', '25', 'Terms and Conditions');
INSERT INTO `site_lang` VALUES ('42', '25', 'By continuing, you are confirming that you have read and agree to our');
INSERT INTO `site_lang` VALUES ('41', '25', 'Sign up');
INSERT INTO `site_lang` VALUES ('40', '25', 'Meet boys and girls');
INSERT INTO `site_lang` VALUES ('39', '25', 'Meet boys');
INSERT INTO `site_lang` VALUES ('38', '25', 'Meet girls');
INSERT INTO `site_lang` VALUES ('37', '25', 'Im here to');
INSERT INTO `site_lang` VALUES ('36', '25', 'Female');
INSERT INTO `site_lang` VALUES ('35', '25', 'Male');
INSERT INTO `site_lang` VALUES ('34', '25', 'Gender');
INSERT INTO `site_lang` VALUES ('33', '25', 'Where do you live?');
INSERT INTO `site_lang` VALUES ('32', '25', 'City');
INSERT INTO `site_lang` VALUES ('31', '25', 'Please select');
INSERT INTO `site_lang` VALUES ('29', '25', 'Password');
INSERT INTO `site_lang` VALUES ('30', '25', 'Birthday');
INSERT INTO `site_lang` VALUES ('28', '25', 'Email');
INSERT INTO `site_lang` VALUES ('27', '25', 'Your name or nickname');
INSERT INTO `site_lang` VALUES ('26', '25', 'Name');
INSERT INTO `site_lang` VALUES ('25', '25', 'Join the worlds bestest community for meeting new people!.');
INSERT INTO `site_lang` VALUES ('24', '25', 'Become a member now');
INSERT INTO `site_lang` VALUES ('23', '25', 'Play our popular Discover game and get matched with other users. Its a great way to break the ice and chat to new people.');
INSERT INTO `site_lang` VALUES ('22', '25', 'Matches');
INSERT INTO `site_lang` VALUES ('21', '25', 'We wont show your exact location, but you will be able to find people nearby who like the same things you do.');
INSERT INTO `site_lang` VALUES ('20', '25', 'People nearby');
INSERT INTO `site_lang` VALUES ('18', '25', 'Video Chat');
INSERT INTO `site_lang` VALUES ('19', '25', 'You can make quality videocalls for free to anyone, without limits of call duration, just enjoy seeing the person who is chatting with you');
INSERT INTO `site_lang` VALUES ('17', '25', 'Powerfull private chat for meet new friends, you can send emoticons and private photos to anyone.');
INSERT INTO `site_lang` VALUES ('15', '25', 'Recover password');
INSERT INTO `site_lang` VALUES ('16', '25', 'Chat');
INSERT INTO `site_lang` VALUES ('14', '25', 'Password recover');
INSERT INTO `site_lang` VALUES ('13', '25', 'Login now');
INSERT INTO `site_lang` VALUES ('12', '25', 'do you forget your password?');
INSERT INTO `site_lang` VALUES ('11', '25', 'Your password');
INSERT INTO `site_lang` VALUES ('9', '25', 'Welcome back');
INSERT INTO `site_lang` VALUES ('10', '25', 'Your email');
INSERT INTO `site_lang` VALUES ('8', '25', 'Create your account');
INSERT INTO `site_lang` VALUES ('3', '25', 'For now our site works only for Desktop users');
INSERT INTO `site_lang` VALUES ('7', '25', 'Connect with ');
INSERT INTO `site_lang` VALUES ('6', '25', 'SOON AVAILABLE');
INSERT INTO `site_lang` VALUES ('5', '25', 'Soon we will have our phone apps online');
INSERT INTO `site_lang` VALUES ('4', '25', 'Please visit us from your laptop or PC');
INSERT INTO `site_lang` VALUES ('2', '25', 'Welcome to the fastest growing place to meet new people');
INSERT INTO `site_lang` VALUES ('1', '25', 'Login');
INSERT INTO `site_lang` VALUES ('0', '25', 'meet new people!');
INSERT INTO `site_lang` VALUES ('384', '24', 'Ok, i understand');
INSERT INTO `site_lang` VALUES ('383', '24', 'must like you for start a videocall');
INSERT INTO `site_lang` VALUES ('382', '24', 'dont like you');
INSERT INTO `site_lang` VALUES ('381', '24', 'calling...');
INSERT INTO `site_lang` VALUES ('380', '24', 'Welcome to');
INSERT INTO `site_lang` VALUES ('379', '24', 'Go to');
INSERT INTO `site_lang` VALUES ('378', '24', 'Please save your connection information in a safe place');
INSERT INTO `site_lang` VALUES ('377', '24', 'Password');
INSERT INTO `site_lang` VALUES ('376', '24', 'E-mail');
INSERT INTO `site_lang` VALUES ('375', '24', 'Here are your connection details');
INSERT INTO `site_lang` VALUES ('374', '24', 'Start meeting new people now');
INSERT INTO `site_lang` VALUES ('373', '24', 'More than 1 million people have joined $site_name You probably want to know some of them.');
INSERT INTO `site_lang` VALUES ('372', '24', 'Add photos and complete your profile');
INSERT INTO `site_lang` VALUES ('371', '24', 'Nobody is going to fall in love with a blank page. The more information you get, the more chances to find that special someone!');
INSERT INTO `site_lang` VALUES ('370', '24', 'Meet new people');
INSERT INTO `site_lang` VALUES ('369', '24', 'you can meet people instantly');
INSERT INTO `site_lang` VALUES ('368', '24', 'In');
INSERT INTO `site_lang` VALUES ('365', '24', 'Verify your account');
INSERT INTO `site_lang` VALUES ('366', '24', 'Newsflash');
INSERT INTO `site_lang` VALUES ('367', '24', 'people in your area wants to know you');
INSERT INTO `site_lang` VALUES ('364', '24', 'Now you are a new member of');
INSERT INTO `site_lang` VALUES ('363', '24', 'Here are a few tips');
INSERT INTO `site_lang` VALUES ('361', '24', 'Welcome');
INSERT INTO `site_lang` VALUES ('362', '24', 'Well done, now you are in');
INSERT INTO `site_lang` VALUES ('360', '24', 'Check out the profile');
INSERT INTO `site_lang` VALUES ('359', '24', 'and lives closer to you');
INSERT INTO `site_lang` VALUES ('358', '24', 'is new at');
INSERT INTO `site_lang` VALUES ('357', '24', 'is new and lives closer to you');
INSERT INTO `site_lang` VALUES ('356', '24', 'Have fun!');
INSERT INTO `site_lang` VALUES ('355', '24', 'Respond to');
INSERT INTO `site_lang` VALUES ('354', '24', 'you have a new message from');
INSERT INTO `site_lang` VALUES ('353', '24', 'New message from');
INSERT INTO `site_lang` VALUES ('352', '24', 'Go and say something to');
INSERT INTO `site_lang` VALUES ('351', '24', 'thinks the feeling is mutual');
INSERT INTO `site_lang` VALUES ('350', '24', 'Its a match!');
INSERT INTO `site_lang` VALUES ('349', '24', 'You have a match at');
INSERT INTO `site_lang` VALUES ('348', '24', 'if you forgot your password, click on the link below to get a new');
INSERT INTO `site_lang` VALUES ('346', '24', 'Unsubscribe');
INSERT INTO `site_lang` VALUES ('347', '24', 'Choose a new password');
INSERT INTO `site_lang` VALUES ('345', '24', 'You received this notice because you registered as');
INSERT INTO `site_lang` VALUES ('344', '24', 'Find out if you also like');
INSERT INTO `site_lang` VALUES ('343', '24', 'has seen you in discover and likes. The feeling is mutual?');
INSERT INTO `site_lang` VALUES ('342', '24', 'likes you and wants to chat in');
INSERT INTO `site_lang` VALUES ('341', '24', 'We sent you a email with your info, it may take up to 1 min to arrive');
INSERT INTO `site_lang` VALUES ('339', '24', 'of');
INSERT INTO `site_lang` VALUES ('340', '24', 'Loading...');
INSERT INTO `site_lang` VALUES ('338', '24', 'Photos of ');
INSERT INTO `site_lang` VALUES ('337', '24', 'is calling you..');
INSERT INTO `site_lang` VALUES ('336', '24', 'Password successfully changed');
INSERT INTO `site_lang` VALUES ('335', '24', 'Service cost');
INSERT INTO `site_lang` VALUES ('334', '24', 'Spotlight');
INSERT INTO `site_lang` VALUES ('333', '24', 'Wrong');
INSERT INTO `site_lang` VALUES ('331', '24', 'username');
INSERT INTO `site_lang` VALUES ('332', '24', 'days of Premium');
INSERT INTO `site_lang` VALUES ('330', '24', 'You need to write your username!');
INSERT INTO `site_lang` VALUES ('329', '24', 'Write your instagram username');
INSERT INTO `site_lang` VALUES ('328', '24', 'Press backspace key for smart return to the meeting section.');
INSERT INTO `site_lang` VALUES ('327', '24', 'Are you sure you want to report');
INSERT INTO `site_lang` VALUES ('326', '24', 'Report and block');
INSERT INTO `site_lang` VALUES ('325', '24', 'is blocking you or you blocked him, you cant chat with him sorry');
INSERT INTO `site_lang` VALUES ('324', '24', 'We sended you a email for verify your account');
INSERT INTO `site_lang` VALUES ('323', '24', 'years old and im from');
INSERT INTO `site_lang` VALUES ('322', '24', 'Hi, im');
INSERT INTO `site_lang` VALUES ('321', '24', 'Please add a profile photo');
INSERT INTO `site_lang` VALUES ('320', '24', 'Please verify your account, check your email');
INSERT INTO `site_lang` VALUES ('319', '24', 'ago');
INSERT INTO `site_lang` VALUES ('317', '24', 'minutes');
INSERT INTO `site_lang` VALUES ('318', '24', 'seconds');
INSERT INTO `site_lang` VALUES ('316', '24', 'hours');
INSERT INTO `site_lang` VALUES ('314', '24', 'months');
INSERT INTO `site_lang` VALUES ('315', '24', 'days');
INSERT INTO `site_lang` VALUES ('313', '24', 'years');
INSERT INTO `site_lang` VALUES ('308', '24', 'month');
INSERT INTO `site_lang` VALUES ('309', '24', 'day');
INSERT INTO `site_lang` VALUES ('310', '24', 'hour');
INSERT INTO `site_lang` VALUES ('311', '24', 'minute');
INSERT INTO `site_lang` VALUES ('312', '24', 'second');
INSERT INTO `site_lang` VALUES ('307', '24', 'year');
INSERT INTO `site_lang` VALUES ('303', '24', 'You do not like anyone');
INSERT INTO `site_lang` VALUES ('304', '24', 'Cost');
INSERT INTO `site_lang` VALUES ('305', '24', 'Credits for $');
INSERT INTO `site_lang` VALUES ('306', '24', '0 seconds');
INSERT INTO `site_lang` VALUES ('302', '24', 'visited');
INSERT INTO `site_lang` VALUES ('297', '24', 'Messages');
INSERT INTO `site_lang` VALUES ('298', '24', 'Like');
INSERT INTO `site_lang` VALUES ('299', '24', 'Dislike');
INSERT INTO `site_lang` VALUES ('300', '24', 'AGE');
INSERT INTO `site_lang` VALUES ('301', '24', 'You dont have any visit yet');
INSERT INTO `site_lang` VALUES ('294', '24', 'Upgrade your account to premium');
INSERT INTO `site_lang` VALUES ('295', '24', 'People i like');
INSERT INTO `site_lang` VALUES ('296', '24', 'people liked you, for see them');
INSERT INTO `site_lang` VALUES ('293', '24', 'people visited your profile for see them');
INSERT INTO `site_lang` VALUES ('292', '24', 'Delete');
INSERT INTO `site_lang` VALUES ('291', '24', 'Public photo');
INSERT INTO `site_lang` VALUES ('290', '24', 'Private photo');
INSERT INTO `site_lang` VALUES ('289', '24', 'Set as profile');
INSERT INTO `site_lang` VALUES ('288', '24', 'get seen by millions');
INSERT INTO `site_lang` VALUES ('287', '24', 'Add me here');
INSERT INTO `site_lang` VALUES ('285', '24', 'Credits');
INSERT INTO `site_lang` VALUES ('286', '24', 'Visits');
INSERT INTO `site_lang` VALUES ('284', '24', 'Photos');
INSERT INTO `site_lang` VALUES ('283', '24', 'Add');
INSERT INTO `site_lang` VALUES ('281', '24', 'Private photos');
INSERT INTO `site_lang` VALUES ('282', '24', 'Add from ');
INSERT INTO `site_lang` VALUES ('280', '24', 'Public Photos');
INSERT INTO `site_lang` VALUES ('277', '24', 'Report');
INSERT INTO `site_lang` VALUES ('278', '24', 'Fans');
INSERT INTO `site_lang` VALUES ('279', '24', 'No data');
INSERT INTO `site_lang` VALUES ('275', '24', 'Please wait');
INSERT INTO `site_lang` VALUES ('276', '24', 'Interests');
INSERT INTO `site_lang` VALUES ('274', '24', 'Year');
INSERT INTO `site_lang` VALUES ('273', '24', 'Month');
INSERT INTO `site_lang` VALUES ('272', '24', 'Day');
INSERT INTO `site_lang` VALUES ('271', '24', 'When someone send me a message');
INSERT INTO `site_lang` VALUES ('270', '24', 'When new users near me join in');
INSERT INTO `site_lang` VALUES ('269', '24', 'When i get a match');
INSERT INTO `site_lang` VALUES ('268', '24', 'When someone likes me');
INSERT INTO `site_lang` VALUES ('267', '24', 'None');
INSERT INTO `site_lang` VALUES ('266', '24', 'I own a motorbike');
INSERT INTO `site_lang` VALUES ('265', '24', 'I own a car');
INSERT INTO `site_lang` VALUES ('264', '24', 'Parents car');
INSERT INTO `site_lang` VALUES ('263', '24', 'Transport');
INSERT INTO `site_lang` VALUES ('259', '24', 'Yes');
INSERT INTO `site_lang` VALUES ('260', '24', 'No');
INSERT INTO `site_lang` VALUES ('261', '24', 'Sometimes');
INSERT INTO `site_lang` VALUES ('262', '24', 'Drink');
INSERT INTO `site_lang` VALUES ('257', '24', 'Alone');
INSERT INTO `site_lang` VALUES ('258', '24', 'Smoke');
INSERT INTO `site_lang` VALUES ('256', '24', 'With partner');
INSERT INTO `site_lang` VALUES ('253', '24', 'With parents');
INSERT INTO `site_lang` VALUES ('254', '24', 'With housemate');
INSERT INTO `site_lang` VALUES ('255', '24', 'Student dormitory');
INSERT INTO `site_lang` VALUES ('250', '24', 'Heavy set');
INSERT INTO `site_lang` VALUES ('251', '24', 'Curvy');
INSERT INTO `site_lang` VALUES ('252', '24', 'Living');
INSERT INTO `site_lang` VALUES ('249', '24', 'Athletic');
INSERT INTO `site_lang` VALUES ('248', '24', 'Average');
INSERT INTO `site_lang` VALUES ('247', '24', 'Slim');
INSERT INTO `site_lang` VALUES ('246', '24', 'Body type');
INSERT INTO `site_lang` VALUES ('245', '24', 'Other');
INSERT INTO `site_lang` VALUES ('244', '24', 'Indian');
INSERT INTO `site_lang` VALUES ('243', '24', 'Pacific Islander');
INSERT INTO `site_lang` VALUES ('242', '24', 'Hispanic/latin');
INSERT INTO `site_lang` VALUES ('241', '24', 'Native American');
INSERT INTO `site_lang` VALUES ('240', '24', 'White');
INSERT INTO `site_lang` VALUES ('239', '24', 'Black');
INSERT INTO `site_lang` VALUES ('238', '24', 'Middle Eastern');
INSERT INTO `site_lang` VALUES ('237', '24', 'Asian');
INSERT INTO `site_lang` VALUES ('236', '24', 'Ethnicity');
INSERT INTO `site_lang` VALUES ('235', '24', 'Weight');
INSERT INTO `site_lang` VALUES ('234', '24', 'more than');
INSERT INTO `site_lang` VALUES ('233', '24', 'less than');
INSERT INTO `site_lang` VALUES ('232', '24', 'Height');
INSERT INTO `site_lang` VALUES ('231', '24', 'Bisexual');
INSERT INTO `site_lang` VALUES ('230', '24', 'Straight');
INSERT INTO `site_lang` VALUES ('228', '24', 'Gay');
INSERT INTO `site_lang` VALUES ('229', '24', 'Open-minded');
INSERT INTO `site_lang` VALUES ('227', '24', 'Sexuality');
INSERT INTO `site_lang` VALUES ('226', '24', 'Open');
INSERT INTO `site_lang` VALUES ('225', '24', 'Taken');
INSERT INTO `site_lang` VALUES ('224', '24', 'Single');
INSERT INTO `site_lang` VALUES ('223', '24', 'Relationship');
INSERT INTO `site_lang` VALUES ('222', '24', 'Extended info (optional)');
INSERT INTO `site_lang` VALUES ('221', '24', 'Notifications');
INSERT INTO `site_lang` VALUES ('216', '24', 'End call');
INSERT INTO `site_lang` VALUES ('217', '24', 'Wait more');
INSERT INTO `site_lang` VALUES ('218', '24', 'until');
INSERT INTO `site_lang` VALUES ('219', '24', 'Basic');
INSERT INTO `site_lang` VALUES ('220', '24', 'UPGRADE');
INSERT INTO `site_lang` VALUES ('215', '24', 'Seems that your friend do not have webcam or he is not available');
INSERT INTO `site_lang` VALUES ('214', '24', 'Too long wait');
INSERT INTO `site_lang` VALUES ('213', '24', 'You cant make videocall because you dont have webcam');
INSERT INTO `site_lang` VALUES ('212', '24', 'Impossible to make a call!');
INSERT INTO `site_lang` VALUES ('211', '24', 'Only premium users can make videocalls');
INSERT INTO `site_lang` VALUES ('210', '24', 'You are already in a videocall, you have to end the other call before start another');
INSERT INTO `site_lang` VALUES ('209', '24', 'Please allow access to your Webcam.');
INSERT INTO `site_lang` VALUES ('208', '24', 'is offline, try again when your friend is online');
INSERT INTO `site_lang` VALUES ('207', '24', 'is in another videocall , you cant call now');
INSERT INTO `site_lang` VALUES ('206', '24', 'Yes, delete it!');
INSERT INTO `site_lang` VALUES ('205', '24', 'Your data will be lost without recovery, continue?');
INSERT INTO `site_lang` VALUES ('204', '24', 'Account termination');
INSERT INTO `site_lang` VALUES ('203', '24', 'Information updated successfully');
INSERT INTO `site_lang` VALUES ('202', '24', 'Yes, buy it!');
INSERT INTO `site_lang` VALUES ('201', '24', 'more daily conversation, cost ');
INSERT INTO `site_lang` VALUES ('200', '24', 'Expand daily limitation ');
INSERT INTO `site_lang` VALUES ('199', '24', 'You dont have enought credits for send the gift');
INSERT INTO `site_lang` VALUES ('198', '24', 'Please, select 1 gift');
INSERT INTO `site_lang` VALUES ('197', '24', 'Please, select 1 photo');
INSERT INTO `site_lang` VALUES ('196', '24', 'Please, select a payment method');
INSERT INTO `site_lang` VALUES ('195', '24', 'No thanks');
INSERT INTO `site_lang` VALUES ('194', '24', 'Get access');
INSERT INTO `site_lang` VALUES ('193', '24', 'private photos for ');
INSERT INTO `site_lang` VALUES ('192', '24', 'Get access to');
INSERT INTO `site_lang` VALUES ('191', '24', 'Buy private photos permission');
INSERT INTO `site_lang` VALUES ('190', '24', 'No, i cant show you my private photos');
INSERT INTO `site_lang` VALUES ('189', '24', 'Yes, you can see my private photos');
INSERT INTO `site_lang` VALUES ('188', '24', 'Email already exist, try another');
INSERT INTO `site_lang` VALUES ('187', '24', 'Password too short');
INSERT INTO `site_lang` VALUES ('186', '24', 'Choose city from the autocomplete');
INSERT INTO `site_lang` VALUES ('185', '24', 'Add a valid date');
INSERT INTO `site_lang` VALUES ('184', '24', 'Wrong password');
INSERT INTO `site_lang` VALUES ('183', '24', 'Email dont exist');
INSERT INTO `site_lang` VALUES ('182', '24', 'Please fill all the inputs');
INSERT INTO `site_lang` VALUES ('181', '24', 'Invalid email format');
INSERT INTO `site_lang` VALUES ('180', '24', 'Password recover');
INSERT INTO `site_lang` VALUES ('179', '24', 'Login to my account');
INSERT INTO `site_lang` VALUES ('178', '24', 'If you dont remember your password, click the link below to set a new one:');
INSERT INTO `site_lang` VALUES ('177', '24', 'Hi');
INSERT INTO `site_lang` VALUES ('176', '24', 'No');
INSERT INTO `site_lang` VALUES ('175', '24', 'Yes');
INSERT INTO `site_lang` VALUES ('174', '24', 'Hello, can i have access to your private photos ?');
INSERT INTO `site_lang` VALUES ('173', '24', 'like this');
INSERT INTO `site_lang` VALUES ('172', '24', 'persons more like this');
INSERT INTO `site_lang` VALUES ('171', '24', 'Days Premium');
INSERT INTO `site_lang` VALUES ('170', '24', 'Buy');
INSERT INTO `site_lang` VALUES ('169', '24', 'December');
INSERT INTO `site_lang` VALUES ('168', '24', 'November');
INSERT INTO `site_lang` VALUES ('167', '24', 'October');
INSERT INTO `site_lang` VALUES ('166', '24', 'September');
INSERT INTO `site_lang` VALUES ('165', '24', 'August');
INSERT INTO `site_lang` VALUES ('164', '24', 'July');
INSERT INTO `site_lang` VALUES ('163', '24', 'June');
INSERT INTO `site_lang` VALUES ('158', '24', 'January');
INSERT INTO `site_lang` VALUES ('159', '24', 'February');
INSERT INTO `site_lang` VALUES ('160', '24', 'March');
INSERT INTO `site_lang` VALUES ('161', '24', 'April');
INSERT INTO `site_lang` VALUES ('162', '24', 'May');
INSERT INTO `site_lang` VALUES ('154', '24', 'people found');
INSERT INTO `site_lang` VALUES ('155', '24', 'No popular users near you');
INSERT INTO `site_lang` VALUES ('156', '24', 'You dont have any fans yet');
INSERT INTO `site_lang` VALUES ('157', '24', 'You dont have matches yet');
INSERT INTO `site_lang` VALUES ('151', '24', 'Online now');
INSERT INTO `site_lang` VALUES ('152', '24', 'Verified');
INSERT INTO `site_lang` VALUES ('153', '24', 'Nothing found');
INSERT INTO `site_lang` VALUES ('148', '24', 'Profile desactivation');
INSERT INTO `site_lang` VALUES ('149', '24', 'After delete your profile, some of your data will be lost without recovery.');
INSERT INTO `site_lang` VALUES ('150', '24', 'Delete profile');
INSERT INTO `site_lang` VALUES ('147', '24', 'New password');
INSERT INTO `site_lang` VALUES ('146', '24', 'You can change your current password bellow');
INSERT INTO `site_lang` VALUES ('145', '24', 'Change password');
INSERT INTO `site_lang` VALUES ('144', '24', 'Upgrade to premium account');
INSERT INTO `site_lang` VALUES ('143', '24', 'Add credits');
INSERT INTO `site_lang` VALUES ('142', '24', 'Current credits');
INSERT INTO `site_lang` VALUES ('141', '24', 'Account type');
INSERT INTO `site_lang` VALUES ('140', '24', 'Buy credits for send Gifs and Unblock private photos');
INSERT INTO `site_lang` VALUES ('139', '24', 'You are account is already verified');
INSERT INTO `site_lang` VALUES ('138', '24', 'Connect with Facebook');
INSERT INTO `site_lang` VALUES ('137', '24', 'For verify your account , connect with your facebook account');
INSERT INTO `site_lang` VALUES ('136', '24', 'Verify account');
INSERT INTO `site_lang` VALUES ('135', '24', 'Update profile');
INSERT INTO `site_lang` VALUES ('134', '24', 'Site language');
INSERT INTO `site_lang` VALUES ('130', '24', 'Change password');
INSERT INTO `site_lang` VALUES ('131', '24', 'Delete');
INSERT INTO `site_lang` VALUES ('132', '24', 'Personal information');
INSERT INTO `site_lang` VALUES ('133', '24', 'You can edit your profile information bellow');
INSERT INTO `site_lang` VALUES ('129', '24', 'Verify');
INSERT INTO `site_lang` VALUES ('128', '24', 'Credits');
INSERT INTO `site_lang` VALUES ('127', '24', 'Personal');
INSERT INTO `site_lang` VALUES ('126', '24', 'Unblock private photos');
INSERT INTO `site_lang` VALUES ('125', '24', 'Ask permission to');
INSERT INTO `site_lang` VALUES ('124', '24', 'Now you have');
INSERT INTO `site_lang` VALUES ('123', '24', 'Credits successfully added to your account');
INSERT INTO `site_lang` VALUES ('122', '24', 'boys and girls');
INSERT INTO `site_lang` VALUES ('121', '24', 'Only girls');
INSERT INTO `site_lang` VALUES ('119', '24', 'years old');
INSERT INTO `site_lang` VALUES ('120', '24', 'Only boys');
INSERT INTO `site_lang` VALUES ('118', '24', 'Personal info');
INSERT INTO `site_lang` VALUES ('117', '24', 'About ');
INSERT INTO `site_lang` VALUES ('116', '24', 'Most popular users');
INSERT INTO `site_lang` VALUES ('114', '24', 'in a radius of');
INSERT INTO `site_lang` VALUES ('115', '24', 'World');
INSERT INTO `site_lang` VALUES ('113', '24', 'who are between');
INSERT INTO `site_lang` VALUES ('112', '24', 'Both');
INSERT INTO `site_lang` VALUES ('111', '24', 'Boys');
INSERT INTO `site_lang` VALUES ('110', '24', 'Girls');
INSERT INTO `site_lang` VALUES ('109', '24', 'Show me');
INSERT INTO `site_lang` VALUES ('108', '24', 'Online now');
INSERT INTO `site_lang` VALUES ('107', '24', 'All users');
INSERT INTO `site_lang` VALUES ('106', '24', 'Filter Search');
INSERT INTO `site_lang` VALUES ('105', '24', 'Your matches');
INSERT INTO `site_lang` VALUES ('104', '24', 'Please complete your profile before start in ');
INSERT INTO `site_lang` VALUES ('103', '24', 'Terms of Use');
INSERT INTO `site_lang` VALUES ('102', '24', 'Privacy Policy');
INSERT INTO `site_lang` VALUES ('101', '24', 'Your fans');
INSERT INTO `site_lang` VALUES ('100', '24', 'or wait until tomorrow for continue meeting people');
INSERT INTO `site_lang` VALUES ('98', '24', 'and get up to');
INSERT INTO `site_lang` VALUES ('99', '24', 'daily conversations');
INSERT INTO `site_lang` VALUES ('97', '24', 'Upgrade your account to Premium');
INSERT INTO `site_lang` VALUES ('96', '24', 'or');
INSERT INTO `site_lang` VALUES ('94', '24', 'Buy');
INSERT INTO `site_lang` VALUES ('95', '24', 'more daily conversation');
INSERT INTO `site_lang` VALUES ('93', '24', 'To continue chatting');
INSERT INTO `site_lang` VALUES ('90', '24', 'Send');
INSERT INTO `site_lang` VALUES ('91', '24', 'Chat');
INSERT INTO `site_lang` VALUES ('92', '24', 'you have reached the limit of new daily conversations');
INSERT INTO `site_lang` VALUES ('89', '24', 'Write text here');
INSERT INTO `site_lang` VALUES ('88', '24', 'Premium user badge');
INSERT INTO `site_lang` VALUES ('87', '24', 'Unblock all private photos');
INSERT INTO `site_lang` VALUES ('86', '24', 'Unlimited videocalls');
INSERT INTO `site_lang` VALUES ('79', '24', 'Select credits package');
INSERT INTO `site_lang` VALUES ('80', '24', 'Select payment method');
INSERT INTO `site_lang` VALUES ('81', '24', 'Pay with');
INSERT INTO `site_lang` VALUES ('82', '24', 'Pay with');
INSERT INTO `site_lang` VALUES ('83', '24', 'Buy credits');
INSERT INTO `site_lang` VALUES ('84', '24', 'Premium Account Features');
INSERT INTO `site_lang` VALUES ('85', '24', 'new chats per day');
INSERT INTO `site_lang` VALUES ('69', '24', 'Add your photos');
INSERT INTO `site_lang` VALUES ('70', '24', 'add photos');
INSERT INTO `site_lang` VALUES ('71', '24', 'Add yourself to the Spotlight');
INSERT INTO `site_lang` VALUES ('72', '24', 'Pick the photo you want to show in the Spotlight, cost ');
INSERT INTO `site_lang` VALUES ('73', '24', 'Credits');
INSERT INTO `site_lang` VALUES ('74', '24', 'Add photo');
INSERT INTO `site_lang` VALUES ('75', '24', 'Send gift to ');
INSERT INTO `site_lang` VALUES ('76', '24', 'Pick the gift you want to send to ');
INSERT INTO `site_lang` VALUES ('78', '24', 'Buy credits / Upgrade account');
INSERT INTO `site_lang` VALUES ('77', '24', 'Send gift');
INSERT INTO `site_lang` VALUES ('68', '24', 'Private Photos');
INSERT INTO `site_lang` VALUES ('67', '24', 'Public Photos');
INSERT INTO `site_lang` VALUES ('66', '24', 'All Photos');
INSERT INTO `site_lang` VALUES ('64', '24', 'Contact');
INSERT INTO `site_lang` VALUES ('65', '24', 'Manage your photos');
INSERT INTO `site_lang` VALUES ('63', '24', 'Privacy');
INSERT INTO `site_lang` VALUES ('62', '24', 'Terms');
INSERT INTO `site_lang` VALUES ('61', '24', 'Who to like');
INSERT INTO `site_lang` VALUES ('60', '24', 'New messages');
INSERT INTO `site_lang` VALUES ('59', '24', 'Online now');
INSERT INTO `site_lang` VALUES ('58', '24', 'Conversations');
INSERT INTO `site_lang` VALUES ('57', '24', 'Fans');
INSERT INTO `site_lang` VALUES ('56', '24', 'All');
INSERT INTO `site_lang` VALUES ('55', '24', 'Settings');
INSERT INTO `site_lang` VALUES ('54', '24', 'Manage photos');
INSERT INTO `site_lang` VALUES ('53', '24', 'Fans');
INSERT INTO `site_lang` VALUES ('52', '24', 'Most populars');
INSERT INTO `site_lang` VALUES ('51', '24', 'Matches');
INSERT INTO `site_lang` VALUES ('50', '24', 'Discover');
INSERT INTO `site_lang` VALUES ('49', '24', 'Meet new people');
INSERT INTO `site_lang` VALUES ('47', '24', 'Settings');
INSERT INTO `site_lang` VALUES ('48', '24', 'Logout');
INSERT INTO `site_lang` VALUES ('46', '24', 'Profile');
INSERT INTO `site_lang` VALUES ('45', '24', 'Privacy Policy');
INSERT INTO `site_lang` VALUES ('44', '24', 'and');
INSERT INTO `site_lang` VALUES ('43', '24', 'Terms and Conditions');
INSERT INTO `site_lang` VALUES ('42', '24', 'By continuing, you are confirming that you have read and agree to our');
INSERT INTO `site_lang` VALUES ('28', '24', 'Email');
INSERT INTO `site_lang` VALUES ('29', '24', 'Password');
INSERT INTO `site_lang` VALUES ('30', '24', 'Birthday');
INSERT INTO `site_lang` VALUES ('31', '24', 'Please select');
INSERT INTO `site_lang` VALUES ('32', '24', 'City');
INSERT INTO `site_lang` VALUES ('33', '24', 'Where do you live?');
INSERT INTO `site_lang` VALUES ('34', '24', 'Gender');
INSERT INTO `site_lang` VALUES ('35', '24', 'Male');
INSERT INTO `site_lang` VALUES ('36', '24', 'Female');
INSERT INTO `site_lang` VALUES ('37', '24', 'Im here to');
INSERT INTO `site_lang` VALUES ('38', '24', 'Meet girls');
INSERT INTO `site_lang` VALUES ('39', '24', 'Meet boys');
INSERT INTO `site_lang` VALUES ('40', '24', 'Meet boys and girls');
INSERT INTO `site_lang` VALUES ('41', '24', 'Sign up');
INSERT INTO `site_lang` VALUES ('27', '24', 'Your name or nickname');
INSERT INTO `site_lang` VALUES ('26', '24', 'Name');
INSERT INTO `site_lang` VALUES ('25', '24', 'Join the worlds bestest community for meeting new people!.');
INSERT INTO `site_lang` VALUES ('24', '24', 'Become a member now');
INSERT INTO `site_lang` VALUES ('23', '24', 'Play our popular Discover game and get matched with other users. Its a great way to break the ice and chat to new people.');
INSERT INTO `site_lang` VALUES ('22', '24', 'Matches');
INSERT INTO `site_lang` VALUES ('21', '24', 'We wont show your exact location, but you will be able to find people nearby who like the same things you do.');
INSERT INTO `site_lang` VALUES ('20', '24', 'People nearby');
INSERT INTO `site_lang` VALUES ('19', '24', 'You can make quality videocalls for free to anyone, without limits of call duration, just enjoy seeing the person who is chatting with you');
INSERT INTO `site_lang` VALUES ('18', '24', 'Video Chat');
INSERT INTO `site_lang` VALUES ('16', '24', 'Chat');
INSERT INTO `site_lang` VALUES ('17', '24', 'Powerfull private chat for meet new friends, you can send emoticons and private photos to anyone.');
INSERT INTO `site_lang` VALUES ('15', '24', 'Recover password');
INSERT INTO `site_lang` VALUES ('14', '24', 'Password recover');
INSERT INTO `site_lang` VALUES ('13', '24', 'Login now');
INSERT INTO `site_lang` VALUES ('12', '24', 'do you forget your password?');
INSERT INTO `site_lang` VALUES ('11', '24', 'Your password');
INSERT INTO `site_lang` VALUES ('10', '24', 'Your email');
INSERT INTO `site_lang` VALUES ('9', '24', 'Welcome back');
INSERT INTO `site_lang` VALUES ('8', '24', 'Create your account');
INSERT INTO `site_lang` VALUES ('7', '24', 'Connect with ');
INSERT INTO `site_lang` VALUES ('6', '24', 'SOON AVAILABLE');
INSERT INTO `site_lang` VALUES ('5', '24', 'Soon we will have our phone apps online');
INSERT INTO `site_lang` VALUES ('4', '24', 'Please visit us from your laptop or PC');
INSERT INTO `site_lang` VALUES ('3', '24', 'For now our site works only for Desktop users');
INSERT INTO `site_lang` VALUES ('2', '24', 'Welcome to the fastest growing place to meet new people');
INSERT INTO `site_lang` VALUES ('1', '24', 'Login');
INSERT INTO `site_lang` VALUES ('0', '24', 'meet new people!');
INSERT INTO `site_lang` VALUES ('384', '23', 'Ok, i understand');
INSERT INTO `site_lang` VALUES ('383', '23', 'must like you for start a videocall');
INSERT INTO `site_lang` VALUES ('382', '23', 'dont like you');
INSERT INTO `site_lang` VALUES ('381', '23', 'calling...');
INSERT INTO `site_lang` VALUES ('380', '23', 'Welcome to');
INSERT INTO `site_lang` VALUES ('379', '23', 'Go to');
INSERT INTO `site_lang` VALUES ('378', '23', 'Please save your connection information in a safe place');
INSERT INTO `site_lang` VALUES ('377', '23', 'Password');
INSERT INTO `site_lang` VALUES ('376', '23', 'E-mail');
INSERT INTO `site_lang` VALUES ('375', '23', 'Here are your connection details');
INSERT INTO `site_lang` VALUES ('374', '23', 'Start meeting new people now');
INSERT INTO `site_lang` VALUES ('373', '23', 'More than 1 million people have joined $site_name You probably want to know some of them.');
INSERT INTO `site_lang` VALUES ('372', '23', 'Add photos and complete your profile');
INSERT INTO `site_lang` VALUES ('371', '23', 'Nobody is going to fall in love with a blank page. The more information you get, the more chances to find that special someone!');
INSERT INTO `site_lang` VALUES ('367', '23', 'people in your area wants to know you');
INSERT INTO `site_lang` VALUES ('368', '23', 'In');
INSERT INTO `site_lang` VALUES ('369', '23', 'you can meet people instantly');
INSERT INTO `site_lang` VALUES ('370', '23', 'Meet new people');
INSERT INTO `site_lang` VALUES ('366', '23', 'Newsflash');
INSERT INTO `site_lang` VALUES ('364', '23', 'Now you are a new member of');
INSERT INTO `site_lang` VALUES ('365', '23', 'Verify your account');
INSERT INTO `site_lang` VALUES ('363', '23', 'Here are a few tips');
INSERT INTO `site_lang` VALUES ('359', '23', 'and lives closer to you');
INSERT INTO `site_lang` VALUES ('360', '23', 'Check out the profile');
INSERT INTO `site_lang` VALUES ('361', '23', 'Welcome');
INSERT INTO `site_lang` VALUES ('362', '23', 'Well done, now you are in');
INSERT INTO `site_lang` VALUES ('358', '23', 'is new at');
INSERT INTO `site_lang` VALUES ('355', '23', 'Respond to');
INSERT INTO `site_lang` VALUES ('356', '23', 'Have fun!');
INSERT INTO `site_lang` VALUES ('357', '23', 'is new and lives closer to you');
INSERT INTO `site_lang` VALUES ('354', '23', 'you have a new message from');
INSERT INTO `site_lang` VALUES ('353', '23', 'New message from');
INSERT INTO `site_lang` VALUES ('352', '23', 'Go and say something to');
INSERT INTO `site_lang` VALUES ('351', '23', 'thinks the feeling is mutual');
INSERT INTO `site_lang` VALUES ('350', '23', 'Its a match!');
INSERT INTO `site_lang` VALUES ('349', '23', 'You have a match at');
INSERT INTO `site_lang` VALUES ('348', '23', 'if you forgot your password, click on the link below to get a new');
INSERT INTO `site_lang` VALUES ('347', '23', 'Choose a new password');
INSERT INTO `site_lang` VALUES ('346', '23', 'Unsubscribe');
INSERT INTO `site_lang` VALUES ('344', '23', 'Find out if you also like');
INSERT INTO `site_lang` VALUES ('345', '23', 'You received this notice because you registered as');
INSERT INTO `site_lang` VALUES ('343', '23', 'has seen you in discover and likes. The feeling is mutual?');
INSERT INTO `site_lang` VALUES ('342', '23', 'likes you and wants to chat in');
INSERT INTO `site_lang` VALUES ('341', '23', 'We sent you a email with your info, it may take up to 1 min to arrive');
INSERT INTO `site_lang` VALUES ('340', '23', 'Loading...');
INSERT INTO `site_lang` VALUES ('339', '23', 'of');
INSERT INTO `site_lang` VALUES ('338', '23', 'Photos of ');
INSERT INTO `site_lang` VALUES ('337', '23', 'is calling you..');
INSERT INTO `site_lang` VALUES ('336', '23', 'Password successfully changed');
INSERT INTO `site_lang` VALUES ('335', '23', 'Service cost');
INSERT INTO `site_lang` VALUES ('333', '23', 'Wrong');
INSERT INTO `site_lang` VALUES ('334', '23', 'Spotlight');
INSERT INTO `site_lang` VALUES ('330', '23', 'You need to write your username!');
INSERT INTO `site_lang` VALUES ('331', '23', 'username');
INSERT INTO `site_lang` VALUES ('332', '23', 'days of Premium');
INSERT INTO `site_lang` VALUES ('329', '23', 'Write your instagram username');
INSERT INTO `site_lang` VALUES ('328', '23', 'Press backspace key for smart return to the meeting section.');
INSERT INTO `site_lang` VALUES ('326', '23', 'Report and block');
INSERT INTO `site_lang` VALUES ('327', '23', 'Are you sure you want to report');
INSERT INTO `site_lang` VALUES ('325', '23', 'is blocking you or you blocked him, you cant chat with him sorry');
INSERT INTO `site_lang` VALUES ('323', '23', 'years old and im from');
INSERT INTO `site_lang` VALUES ('324', '23', 'We sended you a email for verify your account');
INSERT INTO `site_lang` VALUES ('322', '23', 'Hi, im');
INSERT INTO `site_lang` VALUES ('321', '23', 'Please add a profile photo');
INSERT INTO `site_lang` VALUES ('320', '23', 'Please verify your account, check your email');
INSERT INTO `site_lang` VALUES ('319', '23', 'ago');
INSERT INTO `site_lang` VALUES ('318', '23', 'seconds');
INSERT INTO `site_lang` VALUES ('317', '23', 'minutes');
INSERT INTO `site_lang` VALUES ('316', '23', 'hours');
INSERT INTO `site_lang` VALUES ('315', '23', 'days');
INSERT INTO `site_lang` VALUES ('314', '23', 'months');
INSERT INTO `site_lang` VALUES ('313', '23', 'years');
INSERT INTO `site_lang` VALUES ('312', '23', 'second');
INSERT INTO `site_lang` VALUES ('311', '23', 'minute');
INSERT INTO `site_lang` VALUES ('310', '23', 'hour');
INSERT INTO `site_lang` VALUES ('308', '23', 'month');
INSERT INTO `site_lang` VALUES ('309', '23', 'day');
INSERT INTO `site_lang` VALUES ('307', '23', 'year');
INSERT INTO `site_lang` VALUES ('305', '23', 'Credits for $');
INSERT INTO `site_lang` VALUES ('306', '23', '0 seconds');
INSERT INTO `site_lang` VALUES ('304', '23', 'Cost');
INSERT INTO `site_lang` VALUES ('303', '23', 'You do not like anyone');
INSERT INTO `site_lang` VALUES ('302', '23', 'visited');
INSERT INTO `site_lang` VALUES ('300', '23', 'AGE');
INSERT INTO `site_lang` VALUES ('301', '23', 'You dont have any visit yet');
INSERT INTO `site_lang` VALUES ('298', '23', 'Like');
INSERT INTO `site_lang` VALUES ('299', '23', 'Dislike');
INSERT INTO `site_lang` VALUES ('295', '23', 'People i like');
INSERT INTO `site_lang` VALUES ('296', '23', 'people liked you, for see them');
INSERT INTO `site_lang` VALUES ('297', '23', 'Messages');
INSERT INTO `site_lang` VALUES ('294', '23', 'Upgrade your account to premium');
INSERT INTO `site_lang` VALUES ('293', '23', 'people visited your profile for see them');
INSERT INTO `site_lang` VALUES ('292', '23', 'Delete');
INSERT INTO `site_lang` VALUES ('291', '23', 'Public photo');
INSERT INTO `site_lang` VALUES ('290', '23', 'Private photo');
INSERT INTO `site_lang` VALUES ('289', '23', 'Set as profile');
INSERT INTO `site_lang` VALUES ('288', '23', 'get seen by millions');
INSERT INTO `site_lang` VALUES ('287', '23', 'Add me here');
INSERT INTO `site_lang` VALUES ('286', '23', 'Visits');
INSERT INTO `site_lang` VALUES ('285', '23', 'Credits');
INSERT INTO `site_lang` VALUES ('284', '23', 'Photos');
INSERT INTO `site_lang` VALUES ('283', '23', 'Add');
INSERT INTO `site_lang` VALUES ('282', '23', 'Add from ');
INSERT INTO `site_lang` VALUES ('281', '23', 'Private photos');
INSERT INTO `site_lang` VALUES ('280', '23', 'Public Photos');
INSERT INTO `site_lang` VALUES ('279', '23', 'No data');
INSERT INTO `site_lang` VALUES ('278', '23', 'Fans');
INSERT INTO `site_lang` VALUES ('277', '23', 'Report');
INSERT INTO `site_lang` VALUES ('275', '23', 'Please wait');
INSERT INTO `site_lang` VALUES ('276', '23', 'Interests');
INSERT INTO `site_lang` VALUES ('274', '23', 'Year');
INSERT INTO `site_lang` VALUES ('272', '23', 'Day');
INSERT INTO `site_lang` VALUES ('273', '23', 'Month');
INSERT INTO `site_lang` VALUES ('271', '23', 'When someone send me a message');
INSERT INTO `site_lang` VALUES ('270', '23', 'When new users near me join in');
INSERT INTO `site_lang` VALUES ('269', '23', 'When i get a match');
INSERT INTO `site_lang` VALUES ('268', '23', 'When someone likes me');
INSERT INTO `site_lang` VALUES ('267', '23', 'None');
INSERT INTO `site_lang` VALUES ('266', '23', 'I own a motorbike');
INSERT INTO `site_lang` VALUES ('265', '23', 'I own a car');
INSERT INTO `site_lang` VALUES ('264', '23', 'Parents car');
INSERT INTO `site_lang` VALUES ('263', '23', 'Transport');
INSERT INTO `site_lang` VALUES ('262', '23', 'Drink');
INSERT INTO `site_lang` VALUES ('260', '23', 'No');
INSERT INTO `site_lang` VALUES ('261', '23', 'Sometimes');
INSERT INTO `site_lang` VALUES ('259', '23', 'Yes');
INSERT INTO `site_lang` VALUES ('258', '23', 'Smoke');
INSERT INTO `site_lang` VALUES ('257', '23', 'Alone');
INSERT INTO `site_lang` VALUES ('256', '23', 'With partner');
INSERT INTO `site_lang` VALUES ('255', '23', 'Student dormitory');
INSERT INTO `site_lang` VALUES ('254', '23', 'With housemate');
INSERT INTO `site_lang` VALUES ('253', '23', 'With parents');
INSERT INTO `site_lang` VALUES ('252', '23', 'Living');
INSERT INTO `site_lang` VALUES ('251', '23', 'Curvy');
INSERT INTO `site_lang` VALUES ('250', '23', 'Heavy set');
INSERT INTO `site_lang` VALUES ('249', '23', 'Athletic');
INSERT INTO `site_lang` VALUES ('248', '23', 'Average');
INSERT INTO `site_lang` VALUES ('247', '23', 'Slim');
INSERT INTO `site_lang` VALUES ('246', '23', 'Body type');
INSERT INTO `site_lang` VALUES ('245', '23', 'Other');
INSERT INTO `site_lang` VALUES ('244', '23', 'Indian');
INSERT INTO `site_lang` VALUES ('243', '23', 'Pacific Islander');
INSERT INTO `site_lang` VALUES ('242', '23', 'Hispanic/latin');
INSERT INTO `site_lang` VALUES ('241', '23', 'Native American');
INSERT INTO `site_lang` VALUES ('240', '23', 'White');
INSERT INTO `site_lang` VALUES ('239', '23', 'Black');
INSERT INTO `site_lang` VALUES ('238', '23', 'Middle Eastern');
INSERT INTO `site_lang` VALUES ('237', '23', 'Asian');
INSERT INTO `site_lang` VALUES ('236', '23', 'Ethnicity');
INSERT INTO `site_lang` VALUES ('235', '23', 'Weight');
INSERT INTO `site_lang` VALUES ('234', '23', 'more than');
INSERT INTO `site_lang` VALUES ('233', '23', 'less than');
INSERT INTO `site_lang` VALUES ('232', '23', 'Height');
INSERT INTO `site_lang` VALUES ('231', '23', 'Bisexual');
INSERT INTO `site_lang` VALUES ('230', '23', 'Straight');
INSERT INTO `site_lang` VALUES ('229', '23', 'Open-minded');
INSERT INTO `site_lang` VALUES ('228', '23', 'Gay');
INSERT INTO `site_lang` VALUES ('227', '23', 'Sexuality');
INSERT INTO `site_lang` VALUES ('226', '23', 'Open');
INSERT INTO `site_lang` VALUES ('225', '23', 'Taken');
INSERT INTO `site_lang` VALUES ('224', '23', 'Single');
INSERT INTO `site_lang` VALUES ('216', '23', 'End call');
INSERT INTO `site_lang` VALUES ('217', '23', 'Wait more');
INSERT INTO `site_lang` VALUES ('218', '23', 'until');
INSERT INTO `site_lang` VALUES ('219', '23', 'Basic');
INSERT INTO `site_lang` VALUES ('220', '23', 'UPGRADE');
INSERT INTO `site_lang` VALUES ('221', '23', 'Notifications');
INSERT INTO `site_lang` VALUES ('222', '23', 'Extended info (optional)');
INSERT INTO `site_lang` VALUES ('223', '23', 'Relationship');
INSERT INTO `site_lang` VALUES ('214', '23', 'Too long wait');
INSERT INTO `site_lang` VALUES ('215', '23', 'Seems that your friend do not have webcam or he is not available');
INSERT INTO `site_lang` VALUES ('211', '23', 'Only premium users can make videocalls');
INSERT INTO `site_lang` VALUES ('212', '23', 'Impossible to make a call!');
INSERT INTO `site_lang` VALUES ('213', '23', 'You cant make videocall because you dont have webcam');
INSERT INTO `site_lang` VALUES ('208', '23', 'is offline, try again when your friend is online');
INSERT INTO `site_lang` VALUES ('209', '23', 'Please allow access to your Webcam.');
INSERT INTO `site_lang` VALUES ('210', '23', 'You are already in a videocall, you have to end the other call before start another');
INSERT INTO `site_lang` VALUES ('206', '23', 'Yes, delete it!');
INSERT INTO `site_lang` VALUES ('207', '23', 'is in another videocall , you cant call now');
INSERT INTO `site_lang` VALUES ('204', '23', 'Account termination');
INSERT INTO `site_lang` VALUES ('205', '23', 'Your data will be lost without recovery, continue?');
INSERT INTO `site_lang` VALUES ('197', '23', 'Please, select 1 photo');
INSERT INTO `site_lang` VALUES ('198', '23', 'Please, select 1 gift');
INSERT INTO `site_lang` VALUES ('203', '23', 'Information updated successfully');
INSERT INTO `site_lang` VALUES ('202', '23', 'Yes, buy it!');
INSERT INTO `site_lang` VALUES ('201', '23', 'more daily conversation, cost ');
INSERT INTO `site_lang` VALUES ('200', '23', 'Expand daily limitation ');
INSERT INTO `site_lang` VALUES ('199', '23', 'You dont have enought credits for send the gift');
INSERT INTO `site_lang` VALUES ('187', '23', 'Password too short');
INSERT INTO `site_lang` VALUES ('188', '23', 'Email already exist, try another');
INSERT INTO `site_lang` VALUES ('196', '23', 'Please, select a payment method');
INSERT INTO `site_lang` VALUES ('195', '23', 'No thanks');
INSERT INTO `site_lang` VALUES ('194', '23', 'Get access');
INSERT INTO `site_lang` VALUES ('193', '23', 'private photos for ');
INSERT INTO `site_lang` VALUES ('192', '23', 'Get access to');
INSERT INTO `site_lang` VALUES ('191', '23', 'Buy private photos permission');
INSERT INTO `site_lang` VALUES ('190', '23', 'No, i cant show you my private photos');
INSERT INTO `site_lang` VALUES ('189', '23', 'Yes, you can see my private photos');
INSERT INTO `site_lang` VALUES ('186', '23', 'Choose city from the autocomplete');
INSERT INTO `site_lang` VALUES ('185', '23', 'Add a valid date');
INSERT INTO `site_lang` VALUES ('184', '23', 'Wrong password');
INSERT INTO `site_lang` VALUES ('183', '23', 'Email dont exist');
INSERT INTO `site_lang` VALUES ('182', '23', 'Please fill all the inputs');
INSERT INTO `site_lang` VALUES ('181', '23', 'Invalid email format');
INSERT INTO `site_lang` VALUES ('180', '23', 'Password recover');
INSERT INTO `site_lang` VALUES ('179', '23', 'Login to my account');
INSERT INTO `site_lang` VALUES ('178', '23', 'If you dont remember your password, click the link below to set a new one:');
INSERT INTO `site_lang` VALUES ('176', '23', 'No');
INSERT INTO `site_lang` VALUES ('177', '23', 'Hi');
INSERT INTO `site_lang` VALUES ('175', '23', 'Yes');
INSERT INTO `site_lang` VALUES ('174', '23', 'Hello, can i have access to your private photos ?');
INSERT INTO `site_lang` VALUES ('173', '23', 'like this');
INSERT INTO `site_lang` VALUES ('157', '23', 'You dont have matches yet');
INSERT INTO `site_lang` VALUES ('172', '23', 'persons more like this');
INSERT INTO `site_lang` VALUES ('171', '23', 'Days Premium');
INSERT INTO `site_lang` VALUES ('170', '23', 'Buy');
INSERT INTO `site_lang` VALUES ('169', '23', 'December');
INSERT INTO `site_lang` VALUES ('168', '23', 'November');
INSERT INTO `site_lang` VALUES ('167', '23', 'October');
INSERT INTO `site_lang` VALUES ('166', '23', 'September');
INSERT INTO `site_lang` VALUES ('165', '23', 'August');
INSERT INTO `site_lang` VALUES ('164', '23', 'July');
INSERT INTO `site_lang` VALUES ('163', '23', 'June');
INSERT INTO `site_lang` VALUES ('162', '23', 'May');
INSERT INTO `site_lang` VALUES ('161', '23', 'April');
INSERT INTO `site_lang` VALUES ('160', '23', 'March');
INSERT INTO `site_lang` VALUES ('158', '23', 'January');
INSERT INTO `site_lang` VALUES ('159', '23', 'February');
INSERT INTO `site_lang` VALUES ('151', '23', 'Online now');
INSERT INTO `site_lang` VALUES ('152', '23', 'Verified');
INSERT INTO `site_lang` VALUES ('153', '23', 'Nothing found');
INSERT INTO `site_lang` VALUES ('154', '23', 'people found');
INSERT INTO `site_lang` VALUES ('155', '23', 'No popular users near you');
INSERT INTO `site_lang` VALUES ('156', '23', 'You dont have any fans yet');
INSERT INTO `site_lang` VALUES ('150', '23', 'Delete profile');
INSERT INTO `site_lang` VALUES ('148', '23', 'Profile desactivation');
INSERT INTO `site_lang` VALUES ('149', '23', 'After delete your profile, some of your data will be lost without recovery.');
INSERT INTO `site_lang` VALUES ('146', '23', 'You can change your current password bellow');
INSERT INTO `site_lang` VALUES ('147', '23', 'New password');
INSERT INTO `site_lang` VALUES ('144', '23', 'Upgrade to premium account');
INSERT INTO `site_lang` VALUES ('145', '23', 'Change password');
INSERT INTO `site_lang` VALUES ('143', '23', 'Add credits');
INSERT INTO `site_lang` VALUES ('142', '23', 'Current credits');
INSERT INTO `site_lang` VALUES ('141', '23', 'Account type');
INSERT INTO `site_lang` VALUES ('140', '23', 'Buy credits for send Gifs and Unblock private photos');
INSERT INTO `site_lang` VALUES ('139', '23', 'You are account is already verified');
INSERT INTO `site_lang` VALUES ('138', '23', 'Connect with Facebook');
INSERT INTO `site_lang` VALUES ('137', '23', 'For verify your account , connect with your facebook account');
INSERT INTO `site_lang` VALUES ('136', '23', 'Verify account');
INSERT INTO `site_lang` VALUES ('135', '23', 'Update profile');
INSERT INTO `site_lang` VALUES ('134', '23', 'Site language');
INSERT INTO `site_lang` VALUES ('133', '23', 'You can edit your profile information bellow');
INSERT INTO `site_lang` VALUES ('132', '23', 'Personal information');
INSERT INTO `site_lang` VALUES ('131', '23', 'Delete');
INSERT INTO `site_lang` VALUES ('130', '23', 'Change password');
INSERT INTO `site_lang` VALUES ('129', '23', 'Verify');
INSERT INTO `site_lang` VALUES ('128', '23', 'Credits');
INSERT INTO `site_lang` VALUES ('127', '23', 'Personal');
INSERT INTO `site_lang` VALUES ('126', '23', 'Unblock private photos');
INSERT INTO `site_lang` VALUES ('125', '23', 'Ask permission to');
INSERT INTO `site_lang` VALUES ('124', '23', 'Now you have');
INSERT INTO `site_lang` VALUES ('123', '23', 'Credits successfully added to your account');
INSERT INTO `site_lang` VALUES ('122', '23', 'boys and girls');
INSERT INTO `site_lang` VALUES ('121', '23', 'Only girls');
INSERT INTO `site_lang` VALUES ('120', '23', 'Only boys');
INSERT INTO `site_lang` VALUES ('119', '23', 'years old');
INSERT INTO `site_lang` VALUES ('118', '23', 'Personal info');
INSERT INTO `site_lang` VALUES ('117', '23', 'About ');
INSERT INTO `site_lang` VALUES ('116', '23', 'Most popular users');
INSERT INTO `site_lang` VALUES ('114', '23', 'in a radius of');
INSERT INTO `site_lang` VALUES ('115', '23', 'World');
INSERT INTO `site_lang` VALUES ('112', '23', 'Both');
INSERT INTO `site_lang` VALUES ('113', '23', 'who are between');
INSERT INTO `site_lang` VALUES ('111', '23', 'Boys');
INSERT INTO `site_lang` VALUES ('110', '23', 'Girls');
INSERT INTO `site_lang` VALUES ('109', '23', 'Show me');
INSERT INTO `site_lang` VALUES ('106', '23', 'Filter Search');
INSERT INTO `site_lang` VALUES ('107', '23', 'All users');
INSERT INTO `site_lang` VALUES ('108', '23', 'Online now');
INSERT INTO `site_lang` VALUES ('105', '23', 'Your matches');
INSERT INTO `site_lang` VALUES ('104', '23', 'Please complete your profile before start in ');
INSERT INTO `site_lang` VALUES ('103', '23', 'Terms of Use');
INSERT INTO `site_lang` VALUES ('102', '23', 'Privacy Policy');
INSERT INTO `site_lang` VALUES ('101', '23', 'Your fans');
INSERT INTO `site_lang` VALUES ('100', '23', 'or wait until tomorrow for continue meeting people');
INSERT INTO `site_lang` VALUES ('99', '23', 'daily conversations');
INSERT INTO `site_lang` VALUES ('98', '23', 'and get up to');
INSERT INTO `site_lang` VALUES ('97', '23', 'Upgrade your account to Premium');
INSERT INTO `site_lang` VALUES ('96', '23', 'or');
INSERT INTO `site_lang` VALUES ('95', '23', 'more daily conversation');
INSERT INTO `site_lang` VALUES ('92', '23', 'you have reached the limit of new daily conversations');
INSERT INTO `site_lang` VALUES ('94', '23', 'Buy');
INSERT INTO `site_lang` VALUES ('93', '23', 'To continue chatting');
INSERT INTO `site_lang` VALUES ('91', '23', 'Chat');
INSERT INTO `site_lang` VALUES ('90', '23', 'Send');
INSERT INTO `site_lang` VALUES ('89', '23', 'Write text here');
INSERT INTO `site_lang` VALUES ('88', '23', 'Premium user badge');
INSERT INTO `site_lang` VALUES ('87', '23', 'Unblock all private photos');
INSERT INTO `site_lang` VALUES ('86', '23', 'Unlimited videocalls');
INSERT INTO `site_lang` VALUES ('80', '23', 'Select payment method');
INSERT INTO `site_lang` VALUES ('85', '23', 'new chats per day');
INSERT INTO `site_lang` VALUES ('84', '23', 'Premium Account Features');
INSERT INTO `site_lang` VALUES ('83', '23', 'Buy credits');
INSERT INTO `site_lang` VALUES ('82', '23', 'Pay with');
INSERT INTO `site_lang` VALUES ('81', '23', 'Pay with');
INSERT INTO `site_lang` VALUES ('79', '23', 'Select credits package');
INSERT INTO `site_lang` VALUES ('78', '23', 'Buy credits / Upgrade account');
INSERT INTO `site_lang` VALUES ('77', '23', 'Send gift');
INSERT INTO `site_lang` VALUES ('76', '23', 'Pick the gift you want to send to ');
INSERT INTO `site_lang` VALUES ('75', '23', 'Send gift to ');
INSERT INTO `site_lang` VALUES ('74', '23', 'Add photo');
INSERT INTO `site_lang` VALUES ('73', '23', 'Credits');
INSERT INTO `site_lang` VALUES ('72', '23', 'Pick the photo you want to show in the Spotlight, cost ');
INSERT INTO `site_lang` VALUES ('71', '23', 'Add yourself to the Spotlight');
INSERT INTO `site_lang` VALUES ('70', '23', 'add photos');
INSERT INTO `site_lang` VALUES ('69', '23', 'Add your photos');
INSERT INTO `site_lang` VALUES ('68', '23', 'Private Photos');
INSERT INTO `site_lang` VALUES ('67', '23', 'Public Photos');
INSERT INTO `site_lang` VALUES ('66', '23', 'All Photos');
INSERT INTO `site_lang` VALUES ('65', '23', 'Manage your photos');
INSERT INTO `site_lang` VALUES ('64', '23', 'Contact');
INSERT INTO `site_lang` VALUES ('63', '23', 'Privacy');
INSERT INTO `site_lang` VALUES ('62', '23', 'Terms');
INSERT INTO `site_lang` VALUES ('61', '23', 'Who to like');
INSERT INTO `site_lang` VALUES ('60', '23', 'New messages');
INSERT INTO `site_lang` VALUES ('59', '23', 'Online now');
INSERT INTO `site_lang` VALUES ('58', '23', 'Conversations');
INSERT INTO `site_lang` VALUES ('57', '23', 'Fans');
INSERT INTO `site_lang` VALUES ('56', '23', 'All');
INSERT INTO `site_lang` VALUES ('55', '23', 'Settings');
INSERT INTO `site_lang` VALUES ('54', '23', 'Manage photos');
INSERT INTO `site_lang` VALUES ('53', '23', 'Fans');
INSERT INTO `site_lang` VALUES ('52', '23', 'Most populars');
INSERT INTO `site_lang` VALUES ('51', '23', 'Matches');
INSERT INTO `site_lang` VALUES ('50', '23', 'Discover');
INSERT INTO `site_lang` VALUES ('49', '23', 'Meet new people');
INSERT INTO `site_lang` VALUES ('48', '23', 'Logout');
INSERT INTO `site_lang` VALUES ('47', '23', 'Settings');
INSERT INTO `site_lang` VALUES ('46', '23', 'Profile');
INSERT INTO `site_lang` VALUES ('45', '23', 'Privacy Policy');
INSERT INTO `site_lang` VALUES ('44', '23', 'and');
INSERT INTO `site_lang` VALUES ('43', '23', 'Terms and Conditions');
INSERT INTO `site_lang` VALUES ('42', '23', 'By continuing, you are confirming that you have read and agree to our');
INSERT INTO `site_lang` VALUES ('41', '23', 'Sign up');
INSERT INTO `site_lang` VALUES ('40', '23', 'Meet boys and girls');
INSERT INTO `site_lang` VALUES ('37', '23', 'Im here to');
INSERT INTO `site_lang` VALUES ('38', '23', 'Meet girls');
INSERT INTO `site_lang` VALUES ('39', '23', 'Meet boys');
INSERT INTO `site_lang` VALUES ('36', '23', 'Female');
INSERT INTO `site_lang` VALUES ('32', '23', 'City');
INSERT INTO `site_lang` VALUES ('33', '23', 'Where do you live?');
INSERT INTO `site_lang` VALUES ('34', '23', 'Gender');
INSERT INTO `site_lang` VALUES ('35', '23', 'Male');
INSERT INTO `site_lang` VALUES ('26', '23', 'Name');
INSERT INTO `site_lang` VALUES ('27', '23', 'Your name or nickname');
INSERT INTO `site_lang` VALUES ('28', '23', 'Email');
INSERT INTO `site_lang` VALUES ('29', '23', 'Password');
INSERT INTO `site_lang` VALUES ('30', '23', 'Birthday');
INSERT INTO `site_lang` VALUES ('31', '23', 'Please select');
INSERT INTO `site_lang` VALUES ('22', '23', 'Matches');
INSERT INTO `site_lang` VALUES ('23', '23', 'Play our popular Discover game and get matched with other users. Its a great way to break the ice and chat to new people.');
INSERT INTO `site_lang` VALUES ('24', '23', 'Become a member now');
INSERT INTO `site_lang` VALUES ('25', '23', 'Join the worlds bestest community for meeting new people!.');
INSERT INTO `site_lang` VALUES ('21', '23', 'We wont show your exact location, but you will be able to find people nearby who like the same things you do.');
INSERT INTO `site_lang` VALUES ('20', '23', 'People nearby');
INSERT INTO `site_lang` VALUES ('19', '23', 'You can make quality videocalls for free to anyone, without limits of call duration, just enjoy seeing the person who is chatting with you');
INSERT INTO `site_lang` VALUES ('18', '23', 'Video Chat');
INSERT INTO `site_lang` VALUES ('16', '23', 'Chat');
INSERT INTO `site_lang` VALUES ('17', '23', 'Powerfull private chat for meet new friends, you can send emoticons and private photos to anyone.');
INSERT INTO `site_lang` VALUES ('15', '23', 'Recover password');
INSERT INTO `site_lang` VALUES ('13', '23', 'Login now');
INSERT INTO `site_lang` VALUES ('14', '23', 'Password recover');
INSERT INTO `site_lang` VALUES ('12', '23', 'do you forget your password?');
INSERT INTO `site_lang` VALUES ('11', '23', 'Your password');
INSERT INTO `site_lang` VALUES ('10', '23', 'Your email');
INSERT INTO `site_lang` VALUES ('9', '23', 'Welcome back');
INSERT INTO `site_lang` VALUES ('8', '23', 'Create your account');
INSERT INTO `site_lang` VALUES ('7', '23', 'Connect with ');
INSERT INTO `site_lang` VALUES ('6', '23', 'SOON AVAILABLE');
INSERT INTO `site_lang` VALUES ('5', '23', 'Soon we will have our phone apps online');
INSERT INTO `site_lang` VALUES ('4', '23', 'Please visit us from your laptop or PC');
INSERT INTO `site_lang` VALUES ('2', '23', 'Welcome to the fastest growing place to meet new people');
INSERT INTO `site_lang` VALUES ('3', '23', 'For now our site works only for Desktop users');
INSERT INTO `site_lang` VALUES ('384', '22', 'Ok, i understand');
INSERT INTO `site_lang` VALUES ('0', '23', 'meet new people!');
INSERT INTO `site_lang` VALUES ('1', '23', 'Login');
INSERT INTO `site_lang` VALUES ('383', '22', 'must like you for start a videocall');
INSERT INTO `site_lang` VALUES ('381', '22', 'calling...');
INSERT INTO `site_lang` VALUES ('382', '22', 'dont like you');
INSERT INTO `site_lang` VALUES ('379', '22', 'Go to');
INSERT INTO `site_lang` VALUES ('380', '22', 'Welcome to');
INSERT INTO `site_lang` VALUES ('378', '22', 'Please save your connection information in a safe place');
INSERT INTO `site_lang` VALUES ('377', '22', 'Password');
INSERT INTO `site_lang` VALUES ('376', '22', 'E-mail');
INSERT INTO `site_lang` VALUES ('375', '22', 'Here are your connection details');
INSERT INTO `site_lang` VALUES ('374', '22', 'Start meeting new people now');
INSERT INTO `site_lang` VALUES ('373', '22', 'More than 1 million people have joined $site_name You probably want to know some of them.');
INSERT INTO `site_lang` VALUES ('372', '22', 'Add photos and complete your profile');
INSERT INTO `site_lang` VALUES ('371', '22', 'Nobody is going to fall in love with a blank page. The more information you get, the more chances to find that special someone!');
INSERT INTO `site_lang` VALUES ('370', '22', 'Meet new people');
INSERT INTO `site_lang` VALUES ('369', '22', 'you can meet people instantly');
INSERT INTO `site_lang` VALUES ('368', '22', 'In');
INSERT INTO `site_lang` VALUES ('367', '22', 'people in your area wants to know you');
INSERT INTO `site_lang` VALUES ('366', '22', 'Newsflash');
INSERT INTO `site_lang` VALUES ('365', '22', 'Verify your account');
INSERT INTO `site_lang` VALUES ('364', '22', 'Now you are a new member of');
INSERT INTO `site_lang` VALUES ('363', '22', 'Here are a few tips');
INSERT INTO `site_lang` VALUES ('362', '22', 'Well done, now you are in');
INSERT INTO `site_lang` VALUES ('361', '22', 'Welcome');
INSERT INTO `site_lang` VALUES ('360', '22', 'Check out the profile');
INSERT INTO `site_lang` VALUES ('359', '22', 'and lives closer to you');
INSERT INTO `site_lang` VALUES ('358', '22', 'is new at');
INSERT INTO `site_lang` VALUES ('357', '22', 'is new and lives closer to you');
INSERT INTO `site_lang` VALUES ('356', '22', 'Have fun!');
INSERT INTO `site_lang` VALUES ('355', '22', 'Respond to');
INSERT INTO `site_lang` VALUES ('354', '22', 'you have a new message from');
INSERT INTO `site_lang` VALUES ('353', '22', 'New message from');
INSERT INTO `site_lang` VALUES ('352', '22', 'Go and say something to');
INSERT INTO `site_lang` VALUES ('351', '22', 'thinks the feeling is mutual');
INSERT INTO `site_lang` VALUES ('350', '22', 'Its a match!');
INSERT INTO `site_lang` VALUES ('349', '22', 'You have a match at');
INSERT INTO `site_lang` VALUES ('348', '22', 'if you forgot your password, click on the link below to get a new');
INSERT INTO `site_lang` VALUES ('347', '22', 'Choose a new password');
INSERT INTO `site_lang` VALUES ('346', '22', 'Unsubscribe');
INSERT INTO `site_lang` VALUES ('345', '22', 'You received this notice because you registered as');
INSERT INTO `site_lang` VALUES ('344', '22', 'Find out if you also like');
INSERT INTO `site_lang` VALUES ('343', '22', 'has seen you in discover and likes. The feeling is mutual?');
INSERT INTO `site_lang` VALUES ('342', '22', 'likes you and wants to chat in');
INSERT INTO `site_lang` VALUES ('341', '22', 'We sent you a email with your info, it may take up to 1 min to arrive');
INSERT INTO `site_lang` VALUES ('340', '22', 'Loading...');
INSERT INTO `site_lang` VALUES ('338', '22', 'Photos of ');
INSERT INTO `site_lang` VALUES ('339', '22', 'of');
INSERT INTO `site_lang` VALUES ('337', '22', 'is calling you..');
INSERT INTO `site_lang` VALUES ('336', '22', 'Password successfully changed');
INSERT INTO `site_lang` VALUES ('335', '22', 'Service cost');
INSERT INTO `site_lang` VALUES ('334', '22', 'Spotlight');
INSERT INTO `site_lang` VALUES ('333', '22', 'Wrong');
INSERT INTO `site_lang` VALUES ('332', '22', 'days of Premium');
INSERT INTO `site_lang` VALUES ('331', '22', 'username');
INSERT INTO `site_lang` VALUES ('330', '22', 'You need to write your username!');
INSERT INTO `site_lang` VALUES ('329', '22', 'Write your instagram username');
INSERT INTO `site_lang` VALUES ('328', '22', 'Press backspace key for smart return to the meeting section.');
INSERT INTO `site_lang` VALUES ('327', '22', 'Are you sure you want to report');
INSERT INTO `site_lang` VALUES ('326', '22', 'Report and block');
INSERT INTO `site_lang` VALUES ('325', '22', 'is blocking you or you blocked him, you cant chat with him sorry');
INSERT INTO `site_lang` VALUES ('324', '22', 'We sended you a email for verify your account');
INSERT INTO `site_lang` VALUES ('323', '22', 'years old and im from');
INSERT INTO `site_lang` VALUES ('322', '22', 'Hi, im');
INSERT INTO `site_lang` VALUES ('321', '22', 'Please add a profile photo');
INSERT INTO `site_lang` VALUES ('320', '22', 'Please verify your account, check your email');
INSERT INTO `site_lang` VALUES ('319', '22', 'ago');
INSERT INTO `site_lang` VALUES ('318', '22', 'seconds');
INSERT INTO `site_lang` VALUES ('317', '22', 'minutes');
INSERT INTO `site_lang` VALUES ('316', '22', 'hours');
INSERT INTO `site_lang` VALUES ('315', '22', 'days');
INSERT INTO `site_lang` VALUES ('314', '22', 'months');
INSERT INTO `site_lang` VALUES ('313', '22', 'years');
INSERT INTO `site_lang` VALUES ('312', '22', 'second');
INSERT INTO `site_lang` VALUES ('311', '22', 'minute');
INSERT INTO `site_lang` VALUES ('310', '22', 'hour');
INSERT INTO `site_lang` VALUES ('309', '22', 'day');
INSERT INTO `site_lang` VALUES ('308', '22', 'month');
INSERT INTO `site_lang` VALUES ('307', '22', 'year');
INSERT INTO `site_lang` VALUES ('306', '22', '0 seconds');
INSERT INTO `site_lang` VALUES ('305', '22', 'Credits for $');
INSERT INTO `site_lang` VALUES ('304', '22', 'Cost');
INSERT INTO `site_lang` VALUES ('303', '22', 'You do not like anyone');
INSERT INTO `site_lang` VALUES ('302', '22', 'visited');
INSERT INTO `site_lang` VALUES ('301', '22', 'You dont have any visit yet');
INSERT INTO `site_lang` VALUES ('300', '22', 'AGE');
INSERT INTO `site_lang` VALUES ('299', '22', 'Dislike');
INSERT INTO `site_lang` VALUES ('298', '22', 'Like');
INSERT INTO `site_lang` VALUES ('297', '22', 'Messages');
INSERT INTO `site_lang` VALUES ('296', '22', 'people liked you, for see them');
INSERT INTO `site_lang` VALUES ('295', '22', 'People i like');
INSERT INTO `site_lang` VALUES ('289', '22', 'Set as profile');
INSERT INTO `site_lang` VALUES ('290', '22', 'Private photo');
INSERT INTO `site_lang` VALUES ('291', '22', 'Public photo');
INSERT INTO `site_lang` VALUES ('292', '22', 'Delete');
INSERT INTO `site_lang` VALUES ('293', '22', 'people visited your profile for see them');
INSERT INTO `site_lang` VALUES ('294', '22', 'Upgrade your account to premium');
INSERT INTO `site_lang` VALUES ('287', '22', 'Add me here');
INSERT INTO `site_lang` VALUES ('288', '22', 'get seen by millions');
INSERT INTO `site_lang` VALUES ('285', '22', 'Credits');
INSERT INTO `site_lang` VALUES ('286', '22', 'Visits');
INSERT INTO `site_lang` VALUES ('283', '22', 'Add');
INSERT INTO `site_lang` VALUES ('284', '22', 'Photos');
INSERT INTO `site_lang` VALUES ('282', '22', 'Add from ');
INSERT INTO `site_lang` VALUES ('279', '22', 'No data');
INSERT INTO `site_lang` VALUES ('280', '22', 'Public Photos');
INSERT INTO `site_lang` VALUES ('281', '22', 'Private photos');
INSERT INTO `site_lang` VALUES ('274', '22', 'Year');
INSERT INTO `site_lang` VALUES ('275', '22', 'Please wait');
INSERT INTO `site_lang` VALUES ('276', '22', 'Interests');
INSERT INTO `site_lang` VALUES ('277', '22', 'Report');
INSERT INTO `site_lang` VALUES ('278', '22', 'Fans');
INSERT INTO `site_lang` VALUES ('272', '22', 'Day');
INSERT INTO `site_lang` VALUES ('273', '22', 'Month');
INSERT INTO `site_lang` VALUES ('271', '22', 'When someone send me a message');
INSERT INTO `site_lang` VALUES ('270', '22', 'When new users near me join in');
INSERT INTO `site_lang` VALUES ('269', '22', 'When i get a match');
INSERT INTO `site_lang` VALUES ('267', '22', 'None');
INSERT INTO `site_lang` VALUES ('268', '22', 'When someone likes me');
INSERT INTO `site_lang` VALUES ('262', '22', 'Drink');
INSERT INTO `site_lang` VALUES ('263', '22', 'Transport');
INSERT INTO `site_lang` VALUES ('264', '22', 'Parents car');
INSERT INTO `site_lang` VALUES ('265', '22', 'I own a car');
INSERT INTO `site_lang` VALUES ('266', '22', 'I own a motorbike');
INSERT INTO `site_lang` VALUES ('261', '22', 'Sometimes');
INSERT INTO `site_lang` VALUES ('260', '22', 'No');
INSERT INTO `site_lang` VALUES ('259', '22', 'Yes');
INSERT INTO `site_lang` VALUES ('258', '22', 'Smoke');
INSERT INTO `site_lang` VALUES ('256', '22', 'With partner');
INSERT INTO `site_lang` VALUES ('257', '22', 'Alone');
INSERT INTO `site_lang` VALUES ('255', '22', 'Student dormitory');
INSERT INTO `site_lang` VALUES ('253', '22', 'With parents');
INSERT INTO `site_lang` VALUES ('254', '22', 'With housemate');
INSERT INTO `site_lang` VALUES ('252', '22', 'Living');
INSERT INTO `site_lang` VALUES ('251', '22', 'Curvy');
INSERT INTO `site_lang` VALUES ('250', '22', 'Heavy set');
INSERT INTO `site_lang` VALUES ('249', '22', 'Athletic');
INSERT INTO `site_lang` VALUES ('242', '22', 'Hispanic/latin');
INSERT INTO `site_lang` VALUES ('248', '22', 'Average');
INSERT INTO `site_lang` VALUES ('247', '22', 'Slim');
INSERT INTO `site_lang` VALUES ('246', '22', 'Body type');
INSERT INTO `site_lang` VALUES ('239', '22', 'Black');
INSERT INTO `site_lang` VALUES ('245', '22', 'Other');
INSERT INTO `site_lang` VALUES ('244', '22', 'Indian');
INSERT INTO `site_lang` VALUES ('243', '22', 'Pacific Islander');
INSERT INTO `site_lang` VALUES ('241', '22', 'Native American');
INSERT INTO `site_lang` VALUES ('240', '22', 'White');
INSERT INTO `site_lang` VALUES ('238', '22', 'Middle Eastern');
INSERT INTO `site_lang` VALUES ('236', '22', 'Ethnicity');
INSERT INTO `site_lang` VALUES ('237', '22', 'Asian');
INSERT INTO `site_lang` VALUES ('235', '22', 'Weight');
INSERT INTO `site_lang` VALUES ('234', '22', 'more than');
INSERT INTO `site_lang` VALUES ('233', '22', 'less than');
INSERT INTO `site_lang` VALUES ('232', '22', 'Height');
INSERT INTO `site_lang` VALUES ('231', '22', 'Bisexual');
INSERT INTO `site_lang` VALUES ('230', '22', 'Straight');
INSERT INTO `site_lang` VALUES ('229', '22', 'Open-minded');
INSERT INTO `site_lang` VALUES ('228', '22', 'Gay');
INSERT INTO `site_lang` VALUES ('227', '22', 'Sexuality');
INSERT INTO `site_lang` VALUES ('226', '22', 'Open');
INSERT INTO `site_lang` VALUES ('225', '22', 'Taken');
INSERT INTO `site_lang` VALUES ('224', '22', 'Single');
INSERT INTO `site_lang` VALUES ('223', '22', 'Relationship');
INSERT INTO `site_lang` VALUES ('222', '22', 'Extended info (optional)');
INSERT INTO `site_lang` VALUES ('221', '22', 'Notifications');
INSERT INTO `site_lang` VALUES ('220', '22', 'UPGRADE');
INSERT INTO `site_lang` VALUES ('219', '22', 'Basic');
INSERT INTO `site_lang` VALUES ('217', '22', 'Wait more');
INSERT INTO `site_lang` VALUES ('218', '22', 'until');
INSERT INTO `site_lang` VALUES ('216', '22', 'End call');
INSERT INTO `site_lang` VALUES ('215', '22', 'Seems that your friend do not have webcam or he is not available');
INSERT INTO `site_lang` VALUES ('212', '22', 'Impossible to make a call!');
INSERT INTO `site_lang` VALUES ('213', '22', 'You cant make videocall because you dont have webcam');
INSERT INTO `site_lang` VALUES ('214', '22', 'Too long wait');
INSERT INTO `site_lang` VALUES ('209', '22', 'Please allow access to your Webcam.');
INSERT INTO `site_lang` VALUES ('211', '22', 'Only premium users can make videocalls');
INSERT INTO `site_lang` VALUES ('210', '22', 'You are already in a videocall, you have to end the other call before start another');
INSERT INTO `site_lang` VALUES ('208', '22', 'is offline, try again when your friend is online');
INSERT INTO `site_lang` VALUES ('207', '22', 'is in another videocall , you cant call now');
INSERT INTO `site_lang` VALUES ('206', '22', 'Yes, delete it!');
INSERT INTO `site_lang` VALUES ('205', '22', 'Your data will be lost without recovery, continue?');
INSERT INTO `site_lang` VALUES ('204', '22', 'Account termination');
INSERT INTO `site_lang` VALUES ('203', '22', 'Information updated successfully');
INSERT INTO `site_lang` VALUES ('201', '22', 'more daily conversation, cost ');
INSERT INTO `site_lang` VALUES ('202', '22', 'Yes, buy it!');
INSERT INTO `site_lang` VALUES ('200', '22', 'Expand daily limitation ');
INSERT INTO `site_lang` VALUES ('199', '22', 'You dont have enought credits for send the gift');
INSERT INTO `site_lang` VALUES ('198', '22', 'Please, select 1 gift');
INSERT INTO `site_lang` VALUES ('197', '22', 'Please, select 1 photo');
INSERT INTO `site_lang` VALUES ('196', '22', 'Please, select a payment method');
INSERT INTO `site_lang` VALUES ('194', '22', 'Get access');
INSERT INTO `site_lang` VALUES ('195', '22', 'No thanks');
INSERT INTO `site_lang` VALUES ('193', '22', 'private photos for ');
INSERT INTO `site_lang` VALUES ('192', '22', 'Get access to');
INSERT INTO `site_lang` VALUES ('191', '22', 'Buy private photos permission');
INSERT INTO `site_lang` VALUES ('190', '22', 'No, i cant show you my private photos');
INSERT INTO `site_lang` VALUES ('189', '22', 'Yes, you can see my private photos');
INSERT INTO `site_lang` VALUES ('188', '22', 'Email already exist, try another');
INSERT INTO `site_lang` VALUES ('187', '22', 'Password too short');
INSERT INTO `site_lang` VALUES ('186', '22', 'Choose city from the autocomplete');
INSERT INTO `site_lang` VALUES ('185', '22', 'Add a valid date');
INSERT INTO `site_lang` VALUES ('184', '22', 'Wrong password');
INSERT INTO `site_lang` VALUES ('183', '22', 'Email dont exist');
INSERT INTO `site_lang` VALUES ('182', '22', 'Please fill all the inputs');
INSERT INTO `site_lang` VALUES ('181', '22', 'Invalid email format');
INSERT INTO `site_lang` VALUES ('180', '22', 'Password recover');
INSERT INTO `site_lang` VALUES ('179', '22', 'Login to my account');
INSERT INTO `site_lang` VALUES ('178', '22', 'If you dont remember your password, click the link below to set a new one:');
INSERT INTO `site_lang` VALUES ('176', '22', 'No');
INSERT INTO `site_lang` VALUES ('177', '22', 'Hi');
INSERT INTO `site_lang` VALUES ('175', '22', 'Yes');
INSERT INTO `site_lang` VALUES ('168', '22', 'November');
INSERT INTO `site_lang` VALUES ('169', '22', 'December');
INSERT INTO `site_lang` VALUES ('170', '22', 'Buy');
INSERT INTO `site_lang` VALUES ('171', '22', 'Days Premium');
INSERT INTO `site_lang` VALUES ('172', '22', 'persons more like this');
INSERT INTO `site_lang` VALUES ('173', '22', 'like this');
INSERT INTO `site_lang` VALUES ('174', '22', 'Hello, can i have access to your private photos ?');
INSERT INTO `site_lang` VALUES ('167', '22', 'October');
INSERT INTO `site_lang` VALUES ('166', '22', 'September');
INSERT INTO `site_lang` VALUES ('165', '22', 'August');
INSERT INTO `site_lang` VALUES ('161', '22', 'April');
INSERT INTO `site_lang` VALUES ('162', '22', 'May');
INSERT INTO `site_lang` VALUES ('163', '22', 'June');
INSERT INTO `site_lang` VALUES ('164', '22', 'July');
INSERT INTO `site_lang` VALUES ('160', '22', 'March');
INSERT INTO `site_lang` VALUES ('159', '22', 'February');
INSERT INTO `site_lang` VALUES ('158', '22', 'January');
INSERT INTO `site_lang` VALUES ('156', '22', 'You dont have any fans yet');
INSERT INTO `site_lang` VALUES ('157', '22', 'You dont have matches yet');
INSERT INTO `site_lang` VALUES ('155', '22', 'No popular users near you');
INSERT INTO `site_lang` VALUES ('153', '22', 'Nothing found');
INSERT INTO `site_lang` VALUES ('154', '22', 'people found');
INSERT INTO `site_lang` VALUES ('152', '22', 'Verified');
INSERT INTO `site_lang` VALUES ('151', '22', 'Online now');
INSERT INTO `site_lang` VALUES ('150', '22', 'Delete profile');
INSERT INTO `site_lang` VALUES ('149', '22', 'After delete your profile, some of your data will be lost without recovery.');
INSERT INTO `site_lang` VALUES ('148', '22', 'Profile desactivation');
INSERT INTO `site_lang` VALUES ('147', '22', 'New password');
INSERT INTO `site_lang` VALUES ('146', '22', 'You can change your current password bellow');
INSERT INTO `site_lang` VALUES ('145', '22', 'Change password');
INSERT INTO `site_lang` VALUES ('144', '22', 'Upgrade to premium account');
INSERT INTO `site_lang` VALUES ('141', '22', 'Account type');
INSERT INTO `site_lang` VALUES ('142', '22', 'Current credits');
INSERT INTO `site_lang` VALUES ('143', '22', 'Add credits');
INSERT INTO `site_lang` VALUES ('140', '22', 'Buy credits for send Gifs and Unblock private photos');
INSERT INTO `site_lang` VALUES ('139', '22', 'You are account is already verified');
INSERT INTO `site_lang` VALUES ('138', '22', 'Connect with Facebook');
INSERT INTO `site_lang` VALUES ('136', '22', 'Verify account');
INSERT INTO `site_lang` VALUES ('137', '22', 'For verify your account , connect with your facebook account');
INSERT INTO `site_lang` VALUES ('135', '22', 'Update profile');
INSERT INTO `site_lang` VALUES ('134', '22', 'Site language');
INSERT INTO `site_lang` VALUES ('133', '22', 'You can edit your profile information bellow');
INSERT INTO `site_lang` VALUES ('132', '22', 'Personal information');
INSERT INTO `site_lang` VALUES ('131', '22', 'Delete');
INSERT INTO `site_lang` VALUES ('130', '22', 'Change password');
INSERT INTO `site_lang` VALUES ('129', '22', 'Verify');
INSERT INTO `site_lang` VALUES ('128', '22', 'Credits');
INSERT INTO `site_lang` VALUES ('127', '22', 'Personal');
INSERT INTO `site_lang` VALUES ('126', '22', 'Unblock private photos');
INSERT INTO `site_lang` VALUES ('125', '22', 'Ask permission to');
INSERT INTO `site_lang` VALUES ('124', '22', 'Now you have');
INSERT INTO `site_lang` VALUES ('123', '22', 'Credits successfully added to your account');
INSERT INTO `site_lang` VALUES ('122', '22', 'boys and girls');
INSERT INTO `site_lang` VALUES ('121', '22', 'Only girls');
INSERT INTO `site_lang` VALUES ('120', '22', 'Only boys');
INSERT INTO `site_lang` VALUES ('119', '22', 'years old');
INSERT INTO `site_lang` VALUES ('118', '22', 'Personal info');
INSERT INTO `site_lang` VALUES ('117', '22', 'About ');
INSERT INTO `site_lang` VALUES ('116', '22', 'Most popular users');
INSERT INTO `site_lang` VALUES ('115', '22', 'World');
INSERT INTO `site_lang` VALUES ('114', '22', 'in a radius of');
INSERT INTO `site_lang` VALUES ('113', '22', 'who are between');
INSERT INTO `site_lang` VALUES ('112', '22', 'Both');
INSERT INTO `site_lang` VALUES ('111', '22', 'Boys');
INSERT INTO `site_lang` VALUES ('110', '22', 'Girls');
INSERT INTO `site_lang` VALUES ('109', '22', 'Show me');
INSERT INTO `site_lang` VALUES ('107', '22', 'All users');
INSERT INTO `site_lang` VALUES ('108', '22', 'Online now');
INSERT INTO `site_lang` VALUES ('105', '22', 'Your matches');
INSERT INTO `site_lang` VALUES ('106', '22', 'Filter Search');
INSERT INTO `site_lang` VALUES ('101', '22', 'Your fans');
INSERT INTO `site_lang` VALUES ('102', '22', 'Privacy Policy');
INSERT INTO `site_lang` VALUES ('103', '22', 'Terms of Use');
INSERT INTO `site_lang` VALUES ('104', '22', 'Please complete your profile before start in ');
INSERT INTO `site_lang` VALUES ('97', '22', 'Upgrade your account to Premium');
INSERT INTO `site_lang` VALUES ('98', '22', 'and get up to');
INSERT INTO `site_lang` VALUES ('99', '22', 'daily conversations');
INSERT INTO `site_lang` VALUES ('100', '22', 'or wait until tomorrow for continue meeting people');
INSERT INTO `site_lang` VALUES ('96', '22', 'or');
INSERT INTO `site_lang` VALUES ('93', '22', 'To continue chatting');
INSERT INTO `site_lang` VALUES ('94', '22', 'Buy');
INSERT INTO `site_lang` VALUES ('95', '22', 'more daily conversation');
INSERT INTO `site_lang` VALUES ('92', '22', 'you have reached the limit of new daily conversations');
INSERT INTO `site_lang` VALUES ('89', '22', 'Write text here');
INSERT INTO `site_lang` VALUES ('90', '22', 'Send');
INSERT INTO `site_lang` VALUES ('91', '22', 'Chat');
INSERT INTO `site_lang` VALUES ('88', '22', 'Premium user badge');
INSERT INTO `site_lang` VALUES ('87', '22', 'Unblock all private photos');
INSERT INTO `site_lang` VALUES ('86', '22', 'Unlimited videocalls');
INSERT INTO `site_lang` VALUES ('85', '22', 'new chats per day');
INSERT INTO `site_lang` VALUES ('84', '22', 'Premium Account Features');
INSERT INTO `site_lang` VALUES ('83', '22', 'Buy credits');
INSERT INTO `site_lang` VALUES ('82', '22', 'Pay with');
INSERT INTO `site_lang` VALUES ('81', '22', 'Pay with');
INSERT INTO `site_lang` VALUES ('80', '22', 'Select payment method');
INSERT INTO `site_lang` VALUES ('79', '22', 'Select credits package');
INSERT INTO `site_lang` VALUES ('78', '22', 'Buy credits / Upgrade account');
INSERT INTO `site_lang` VALUES ('77', '22', 'Send gift');
INSERT INTO `site_lang` VALUES ('76', '22', 'Pick the gift you want to send to ');
INSERT INTO `site_lang` VALUES ('74', '22', 'Add photo');
INSERT INTO `site_lang` VALUES ('75', '22', 'Send gift to ');
INSERT INTO `site_lang` VALUES ('73', '22', 'Credits');
INSERT INTO `site_lang` VALUES ('72', '22', 'Pick the photo you want to show in the Spotlight, cost ');
INSERT INTO `site_lang` VALUES ('71', '22', 'Add yourself to the Spotlight');
INSERT INTO `site_lang` VALUES ('70', '22', 'add photos');
INSERT INTO `site_lang` VALUES ('69', '22', 'Add your photos');
INSERT INTO `site_lang` VALUES ('67', '22', 'Public Photos');
INSERT INTO `site_lang` VALUES ('68', '22', 'Private Photos');
INSERT INTO `site_lang` VALUES ('66', '22', 'All Photos');
INSERT INTO `site_lang` VALUES ('65', '22', 'Manage your photos');
INSERT INTO `site_lang` VALUES ('64', '22', 'Contact');
INSERT INTO `site_lang` VALUES ('63', '22', 'Privacy');
INSERT INTO `site_lang` VALUES ('62', '22', 'Terms');
INSERT INTO `site_lang` VALUES ('60', '22', 'New messages');
INSERT INTO `site_lang` VALUES ('61', '22', 'Who to like');
INSERT INTO `site_lang` VALUES ('59', '22', 'Online now');
INSERT INTO `site_lang` VALUES ('56', '22', 'All');
INSERT INTO `site_lang` VALUES ('57', '22', 'Fans');
INSERT INTO `site_lang` VALUES ('58', '22', 'Conversations');
INSERT INTO `site_lang` VALUES ('53', '22', 'Fans');
INSERT INTO `site_lang` VALUES ('54', '22', 'Manage photos');
INSERT INTO `site_lang` VALUES ('55', '22', 'Settings');
INSERT INTO `site_lang` VALUES ('50', '22', 'Discover');
INSERT INTO `site_lang` VALUES ('51', '22', 'Matches');
INSERT INTO `site_lang` VALUES ('52', '22', 'Most populars');
INSERT INTO `site_lang` VALUES ('48', '22', 'Logout');
INSERT INTO `site_lang` VALUES ('49', '22', 'Meet new people');
INSERT INTO `site_lang` VALUES ('47', '22', 'Settings');
INSERT INTO `site_lang` VALUES ('46', '22', 'Profile');
INSERT INTO `site_lang` VALUES ('44', '22', 'and');
INSERT INTO `site_lang` VALUES ('45', '22', 'Privacy Policy');
INSERT INTO `site_lang` VALUES ('43', '22', 'Terms and Conditions');
INSERT INTO `site_lang` VALUES ('42', '22', 'By continuing, you are confirming that you have read and agree to our');
INSERT INTO `site_lang` VALUES ('41', '22', 'Sign up');
INSERT INTO `site_lang` VALUES ('40', '22', 'Meet boys and girls');
INSERT INTO `site_lang` VALUES ('39', '22', 'Meet boys');
INSERT INTO `site_lang` VALUES ('38', '22', 'Meet girls');
INSERT INTO `site_lang` VALUES ('37', '22', 'Im here to');
INSERT INTO `site_lang` VALUES ('36', '22', 'Female');
INSERT INTO `site_lang` VALUES ('35', '22', 'Male');
INSERT INTO `site_lang` VALUES ('34', '22', 'Gender');
INSERT INTO `site_lang` VALUES ('33', '22', 'Where do you live?');
INSERT INTO `site_lang` VALUES ('32', '22', 'City');
INSERT INTO `site_lang` VALUES ('31', '22', 'Please select');
INSERT INTO `site_lang` VALUES ('30', '22', 'Birthday');
INSERT INTO `site_lang` VALUES ('29', '22', 'Password');
INSERT INTO `site_lang` VALUES ('28', '22', 'Email');
INSERT INTO `site_lang` VALUES ('27', '22', 'Your name or nickname');
INSERT INTO `site_lang` VALUES ('26', '22', 'Name');
INSERT INTO `site_lang` VALUES ('25', '22', 'Join the worlds bestest community for meeting new people!.');
INSERT INTO `site_lang` VALUES ('24', '22', 'Become a member now');
INSERT INTO `site_lang` VALUES ('23', '22', 'Play our popular Discover game and get matched with other users. Its a great way to break the ice and chat to new people.');
INSERT INTO `site_lang` VALUES ('22', '22', 'Matches');
INSERT INTO `site_lang` VALUES ('21', '22', 'We wont show your exact location, but you will be able to find people nearby who like the same things you do.');
INSERT INTO `site_lang` VALUES ('20', '22', 'People nearby');
INSERT INTO `site_lang` VALUES ('19', '22', 'You can make quality videocalls for free to anyone, without limits of call duration, just enjoy seeing the person who is chatting with you');
INSERT INTO `site_lang` VALUES ('18', '22', 'Video Chat');
INSERT INTO `site_lang` VALUES ('17', '22', 'Powerfull private chat for meet new friends, you can send emoticons and private photos to anyone.');
INSERT INTO `site_lang` VALUES ('16', '22', 'Chat');
INSERT INTO `site_lang` VALUES ('15', '22', 'Recover password');
INSERT INTO `site_lang` VALUES ('14', '22', 'Password recover');
INSERT INTO `site_lang` VALUES ('12', '22', 'do you forget your password?');
INSERT INTO `site_lang` VALUES ('13', '22', 'Login now');
INSERT INTO `site_lang` VALUES ('11', '22', 'Your password');
INSERT INTO `site_lang` VALUES ('10', '22', 'Your email');
INSERT INTO `site_lang` VALUES ('9', '22', 'Welcome back');
INSERT INTO `site_lang` VALUES ('8', '22', 'Create your account');
INSERT INTO `site_lang` VALUES ('7', '22', 'Connect with ');
INSERT INTO `site_lang` VALUES ('6', '22', 'SOON AVAILABLE');
INSERT INTO `site_lang` VALUES ('5', '22', 'Soon we will have our phone apps online');
INSERT INTO `site_lang` VALUES ('4', '22', 'Please visit us from your laptop or PC');
INSERT INTO `site_lang` VALUES ('3', '22', 'For now our site works only for Desktop users');
INSERT INTO `site_lang` VALUES ('2', '22', 'Welcome to the fastest growing place to meet new people');
INSERT INTO `site_lang` VALUES ('1', '22', 'Login');
INSERT INTO `site_lang` VALUES ('0', '22', 'meet new people!');
INSERT INTO `site_lang` VALUES ('384', '21', 'Ok, i understand');
INSERT INTO `site_lang` VALUES ('383', '21', 'must like you for start a videocall');
INSERT INTO `site_lang` VALUES ('382', '21', 'dont like you');
INSERT INTO `site_lang` VALUES ('381', '21', 'calling...');
INSERT INTO `site_lang` VALUES ('380', '21', 'Welcome to');
INSERT INTO `site_lang` VALUES ('379', '21', 'Go to');
INSERT INTO `site_lang` VALUES ('378', '21', 'Please save your connection information in a safe place');
INSERT INTO `site_lang` VALUES ('377', '21', 'Password');
INSERT INTO `site_lang` VALUES ('376', '21', 'E-mail');
INSERT INTO `site_lang` VALUES ('375', '21', 'Here are your connection details');
INSERT INTO `site_lang` VALUES ('374', '21', 'Start meeting new people now');
INSERT INTO `site_lang` VALUES ('373', '21', 'More than 1 million people have joined $site_name You probably want to know some of them.');
INSERT INTO `site_lang` VALUES ('372', '21', 'Add photos and complete your profile');
INSERT INTO `site_lang` VALUES ('371', '21', 'Nobody is going to fall in love with a blank page. The more information you get, the more chances to find that special someone!');
INSERT INTO `site_lang` VALUES ('370', '21', 'Meet new people');
INSERT INTO `site_lang` VALUES ('369', '21', 'you can meet people instantly');
INSERT INTO `site_lang` VALUES ('368', '21', 'In');
INSERT INTO `site_lang` VALUES ('367', '21', 'people in your area wants to know you');
INSERT INTO `site_lang` VALUES ('366', '21', 'Newsflash');
INSERT INTO `site_lang` VALUES ('365', '21', 'Verify your account');
INSERT INTO `site_lang` VALUES ('364', '21', 'Now you are a new member of');
INSERT INTO `site_lang` VALUES ('363', '21', 'Here are a few tips');
INSERT INTO `site_lang` VALUES ('355', '21', 'Respond to');
INSERT INTO `site_lang` VALUES ('356', '21', 'Have fun!');
INSERT INTO `site_lang` VALUES ('357', '21', 'is new and lives closer to you');
INSERT INTO `site_lang` VALUES ('358', '21', 'is new at');
INSERT INTO `site_lang` VALUES ('359', '21', 'and lives closer to you');
INSERT INTO `site_lang` VALUES ('361', '21', 'Welcome');
INSERT INTO `site_lang` VALUES ('362', '21', 'Well done, now you are in');
INSERT INTO `site_lang` VALUES ('360', '21', 'Check out the profile');
INSERT INTO `site_lang` VALUES ('347', '21', 'Choose a new password');
INSERT INTO `site_lang` VALUES ('348', '21', 'if you forgot your password, click on the link below to get a new');
INSERT INTO `site_lang` VALUES ('349', '21', 'You have a match at');
INSERT INTO `site_lang` VALUES ('350', '21', 'Its a match!');
INSERT INTO `site_lang` VALUES ('351', '21', 'thinks the feeling is mutual');
INSERT INTO `site_lang` VALUES ('352', '21', 'Go and say something to');
INSERT INTO `site_lang` VALUES ('353', '21', 'New message from');
INSERT INTO `site_lang` VALUES ('354', '21', 'you have a new message from');
INSERT INTO `site_lang` VALUES ('346', '21', 'Unsubscribe');
INSERT INTO `site_lang` VALUES ('345', '21', 'You received this notice because you registered as');
INSERT INTO `site_lang` VALUES ('344', '21', 'Find out if you also like');
INSERT INTO `site_lang` VALUES ('343', '21', 'has seen you in discover and likes. The feeling is mutual?');
INSERT INTO `site_lang` VALUES ('342', '21', 'likes you and wants to chat in');
INSERT INTO `site_lang` VALUES ('341', '21', 'We sent you a email with your info, it may take up to 1 min to arrive');
INSERT INTO `site_lang` VALUES ('339', '21', 'of');
INSERT INTO `site_lang` VALUES ('340', '21', 'Loading...');
INSERT INTO `site_lang` VALUES ('333', '21', 'Wrong');
INSERT INTO `site_lang` VALUES ('334', '21', 'Spotlight');
INSERT INTO `site_lang` VALUES ('335', '21', 'Service cost');
INSERT INTO `site_lang` VALUES ('336', '21', 'Password successfully changed');
INSERT INTO `site_lang` VALUES ('337', '21', 'is calling you..');
INSERT INTO `site_lang` VALUES ('338', '21', 'Photos of ');
INSERT INTO `site_lang` VALUES ('332', '21', 'days of Premium');
INSERT INTO `site_lang` VALUES ('331', '21', 'username');
INSERT INTO `site_lang` VALUES ('330', '21', 'You need to write your username!');
INSERT INTO `site_lang` VALUES ('329', '21', 'Write your instagram username');
INSERT INTO `site_lang` VALUES ('328', '21', 'Press backspace key for smart return to the meeting section.');
INSERT INTO `site_lang` VALUES ('326', '21', 'Report and block');
INSERT INTO `site_lang` VALUES ('327', '21', 'Are you sure you want to report');
INSERT INTO `site_lang` VALUES ('325', '21', 'is blocking you or you blocked him, you cant chat with him sorry');
INSERT INTO `site_lang` VALUES ('324', '21', 'We sended you a email for verify your account');
INSERT INTO `site_lang` VALUES ('323', '21', 'years old and im from');
INSERT INTO `site_lang` VALUES ('322', '21', 'Hi, im');
INSERT INTO `site_lang` VALUES ('321', '21', 'Please add a profile photo');
INSERT INTO `site_lang` VALUES ('319', '21', 'ago');
INSERT INTO `site_lang` VALUES ('320', '21', 'Please verify your account, check your email');
INSERT INTO `site_lang` VALUES ('318', '21', 'seconds');
INSERT INTO `site_lang` VALUES ('317', '21', 'minutes');
INSERT INTO `site_lang` VALUES ('316', '21', 'hours');
INSERT INTO `site_lang` VALUES ('315', '21', 'days');
INSERT INTO `site_lang` VALUES ('313', '21', 'years');
INSERT INTO `site_lang` VALUES ('314', '21', 'months');
INSERT INTO `site_lang` VALUES ('312', '21', 'second');
INSERT INTO `site_lang` VALUES ('311', '21', 'minute');
INSERT INTO `site_lang` VALUES ('310', '21', 'hour');
INSERT INTO `site_lang` VALUES ('309', '21', 'day');
INSERT INTO `site_lang` VALUES ('308', '21', 'month');
INSERT INTO `site_lang` VALUES ('307', '21', 'year');
INSERT INTO `site_lang` VALUES ('306', '21', '0 seconds');
INSERT INTO `site_lang` VALUES ('305', '21', 'Credits for $');
INSERT INTO `site_lang` VALUES ('304', '21', 'Cost');
INSERT INTO `site_lang` VALUES ('303', '21', 'You do not like anyone');
INSERT INTO `site_lang` VALUES ('302', '21', 'visited');
INSERT INTO `site_lang` VALUES ('301', '21', 'You dont have any visit yet');
INSERT INTO `site_lang` VALUES ('300', '21', 'AGE');
INSERT INTO `site_lang` VALUES ('299', '21', 'Dislike');
INSERT INTO `site_lang` VALUES ('298', '21', 'Like');
INSERT INTO `site_lang` VALUES ('297', '21', 'Messages');
INSERT INTO `site_lang` VALUES ('296', '21', 'people liked you, for see them');
INSERT INTO `site_lang` VALUES ('295', '21', 'People i like');
INSERT INTO `site_lang` VALUES ('294', '21', 'Upgrade your account to premium');
INSERT INTO `site_lang` VALUES ('293', '21', 'people visited your profile for see them');
INSERT INTO `site_lang` VALUES ('292', '21', 'Delete');
INSERT INTO `site_lang` VALUES ('291', '21', 'Public photo');
INSERT INTO `site_lang` VALUES ('290', '21', 'Private photo');
INSERT INTO `site_lang` VALUES ('287', '21', 'Add me here');
INSERT INTO `site_lang` VALUES ('288', '21', 'get seen by millions');
INSERT INTO `site_lang` VALUES ('289', '21', 'Set as profile');
INSERT INTO `site_lang` VALUES ('286', '21', 'Visits');
INSERT INTO `site_lang` VALUES ('285', '21', 'Credits');
INSERT INTO `site_lang` VALUES ('284', '21', 'Photos');
INSERT INTO `site_lang` VALUES ('283', '21', 'Add');
INSERT INTO `site_lang` VALUES ('282', '21', 'Add from ');
INSERT INTO `site_lang` VALUES ('281', '21', 'Private photos');
INSERT INTO `site_lang` VALUES ('280', '21', 'Public Photos');
INSERT INTO `site_lang` VALUES ('279', '21', 'No data');
INSERT INTO `site_lang` VALUES ('274', '21', 'Year');
INSERT INTO `site_lang` VALUES ('275', '21', 'Please wait');
INSERT INTO `site_lang` VALUES ('276', '21', 'Interests');
INSERT INTO `site_lang` VALUES ('277', '21', 'Report');
INSERT INTO `site_lang` VALUES ('278', '21', 'Fans');
INSERT INTO `site_lang` VALUES ('273', '21', 'Month');
INSERT INTO `site_lang` VALUES ('271', '21', 'When someone send me a message');
INSERT INTO `site_lang` VALUES ('272', '21', 'Day');
INSERT INTO `site_lang` VALUES ('270', '21', 'When new users near me join in');
INSERT INTO `site_lang` VALUES ('269', '21', 'When i get a match');
INSERT INTO `site_lang` VALUES ('267', '21', 'None');
INSERT INTO `site_lang` VALUES ('268', '21', 'When someone likes me');
INSERT INTO `site_lang` VALUES ('266', '21', 'I own a motorbike');
INSERT INTO `site_lang` VALUES ('265', '21', 'I own a car');
INSERT INTO `site_lang` VALUES ('264', '21', 'Parents car');
INSERT INTO `site_lang` VALUES ('263', '21', 'Transport');
INSERT INTO `site_lang` VALUES ('262', '21', 'Drink');
INSERT INTO `site_lang` VALUES ('261', '21', 'Sometimes');
INSERT INTO `site_lang` VALUES ('259', '21', 'Yes');
INSERT INTO `site_lang` VALUES ('260', '21', 'No');
INSERT INTO `site_lang` VALUES ('258', '21', 'Smoke');
INSERT INTO `site_lang` VALUES ('257', '21', 'Alone');
INSERT INTO `site_lang` VALUES ('256', '21', 'With partner');
INSERT INTO `site_lang` VALUES ('255', '21', 'Student dormitory');
INSERT INTO `site_lang` VALUES ('254', '21', 'With housemate');
INSERT INTO `site_lang` VALUES ('253', '21', 'With parents');
INSERT INTO `site_lang` VALUES ('252', '21', 'Living');
INSERT INTO `site_lang` VALUES ('251', '21', 'Curvy');
INSERT INTO `site_lang` VALUES ('250', '21', 'Heavy set');
INSERT INTO `site_lang` VALUES ('249', '21', 'Athletic');
INSERT INTO `site_lang` VALUES ('248', '21', 'Average');
INSERT INTO `site_lang` VALUES ('247', '21', 'Slim');
INSERT INTO `site_lang` VALUES ('246', '21', 'Body type');
INSERT INTO `site_lang` VALUES ('245', '21', 'Other');
INSERT INTO `site_lang` VALUES ('244', '21', 'Indian');
INSERT INTO `site_lang` VALUES ('243', '21', 'Pacific Islander');
INSERT INTO `site_lang` VALUES ('242', '21', 'Hispanic/latin');
INSERT INTO `site_lang` VALUES ('241', '21', 'Native American');
INSERT INTO `site_lang` VALUES ('239', '21', 'Black');
INSERT INTO `site_lang` VALUES ('240', '21', 'White');
INSERT INTO `site_lang` VALUES ('238', '21', 'Middle Eastern');
INSERT INTO `site_lang` VALUES ('232', '21', 'Height');
INSERT INTO `site_lang` VALUES ('233', '21', 'less than');
INSERT INTO `site_lang` VALUES ('234', '21', 'more than');
INSERT INTO `site_lang` VALUES ('235', '21', 'Weight');
INSERT INTO `site_lang` VALUES ('236', '21', 'Ethnicity');
INSERT INTO `site_lang` VALUES ('237', '21', 'Asian');
INSERT INTO `site_lang` VALUES ('231', '21', 'Bisexual');
INSERT INTO `site_lang` VALUES ('230', '21', 'Straight');
INSERT INTO `site_lang` VALUES ('228', '21', 'Gay');
INSERT INTO `site_lang` VALUES ('229', '21', 'Open-minded');
INSERT INTO `site_lang` VALUES ('227', '21', 'Sexuality');
INSERT INTO `site_lang` VALUES ('226', '21', 'Open');
INSERT INTO `site_lang` VALUES ('225', '21', 'Taken');
INSERT INTO `site_lang` VALUES ('224', '21', 'Single');
INSERT INTO `site_lang` VALUES ('223', '21', 'Relationship');
INSERT INTO `site_lang` VALUES ('222', '21', 'Extended info (optional)');
INSERT INTO `site_lang` VALUES ('216', '21', 'End call');
INSERT INTO `site_lang` VALUES ('217', '21', 'Wait more');
INSERT INTO `site_lang` VALUES ('218', '21', 'until');
INSERT INTO `site_lang` VALUES ('219', '21', 'Basic');
INSERT INTO `site_lang` VALUES ('220', '21', 'UPGRADE');
INSERT INTO `site_lang` VALUES ('221', '21', 'Notifications');
INSERT INTO `site_lang` VALUES ('214', '21', 'Too long wait');
INSERT INTO `site_lang` VALUES ('215', '21', 'Seems that your friend do not have webcam or he is not available');
INSERT INTO `site_lang` VALUES ('213', '21', 'You cant make videocall because you dont have webcam');
INSERT INTO `site_lang` VALUES ('212', '21', 'Impossible to make a call!');
INSERT INTO `site_lang` VALUES ('211', '21', 'Only premium users can make videocalls');
INSERT INTO `site_lang` VALUES ('210', '21', 'You are already in a videocall, you have to end the other call before start another');
INSERT INTO `site_lang` VALUES ('209', '21', 'Please allow access to your Webcam.');
INSERT INTO `site_lang` VALUES ('208', '21', 'is offline, try again when your friend is online');
INSERT INTO `site_lang` VALUES ('206', '21', 'Yes, delete it!');
INSERT INTO `site_lang` VALUES ('207', '21', 'is in another videocall , you cant call now');
INSERT INTO `site_lang` VALUES ('205', '21', 'Your data will be lost without recovery, continue?');
INSERT INTO `site_lang` VALUES ('204', '21', 'Account termination');
INSERT INTO `site_lang` VALUES ('202', '21', 'Yes, buy it!');
INSERT INTO `site_lang` VALUES ('203', '21', 'Information updated successfully');
INSERT INTO `site_lang` VALUES ('201', '21', 'more daily conversation, cost ');
INSERT INTO `site_lang` VALUES ('200', '21', 'Expand daily limitation ');
INSERT INTO `site_lang` VALUES ('199', '21', 'You dont have enought credits for send the gift');
INSERT INTO `site_lang` VALUES ('198', '21', 'Please, select 1 gift');
INSERT INTO `site_lang` VALUES ('197', '21', 'Please, select 1 photo');
INSERT INTO `site_lang` VALUES ('196', '21', 'Please, select a payment method');
INSERT INTO `site_lang` VALUES ('195', '21', 'No thanks');
INSERT INTO `site_lang` VALUES ('194', '21', 'Get access');
INSERT INTO `site_lang` VALUES ('193', '21', 'private photos for ');
INSERT INTO `site_lang` VALUES ('192', '21', 'Get access to');
INSERT INTO `site_lang` VALUES ('191', '21', 'Buy private photos permission');
INSERT INTO `site_lang` VALUES ('190', '21', 'No, i cant show you my private photos');
INSERT INTO `site_lang` VALUES ('189', '21', 'Yes, you can see my private photos');
INSERT INTO `site_lang` VALUES ('188', '21', 'Email already exist, try another');
INSERT INTO `site_lang` VALUES ('187', '21', 'Password too short');
INSERT INTO `site_lang` VALUES ('186', '21', 'Choose city from the autocomplete');
INSERT INTO `site_lang` VALUES ('185', '21', 'Add a valid date');
INSERT INTO `site_lang` VALUES ('184', '21', 'Wrong password');
INSERT INTO `site_lang` VALUES ('183', '21', 'Email dont exist');
INSERT INTO `site_lang` VALUES ('182', '21', 'Please fill all the inputs');
INSERT INTO `site_lang` VALUES ('181', '21', 'Invalid email format');
INSERT INTO `site_lang` VALUES ('180', '21', 'Password recover');
INSERT INTO `site_lang` VALUES ('179', '21', 'Login to my account');
INSERT INTO `site_lang` VALUES ('178', '21', 'If you dont remember your password, click the link below to set a new one:');
INSERT INTO `site_lang` VALUES ('177', '21', 'Hi');
INSERT INTO `site_lang` VALUES ('176', '21', 'No');
INSERT INTO `site_lang` VALUES ('170', '21', 'Buy');
INSERT INTO `site_lang` VALUES ('171', '21', 'Days Premium');
INSERT INTO `site_lang` VALUES ('172', '21', 'persons more like this');
INSERT INTO `site_lang` VALUES ('173', '21', 'like this');
INSERT INTO `site_lang` VALUES ('174', '21', 'Hello, can i have access to your private photos ?');
INSERT INTO `site_lang` VALUES ('175', '21', 'Yes');
INSERT INTO `site_lang` VALUES ('165', '21', 'August');
INSERT INTO `site_lang` VALUES ('166', '21', 'September');
INSERT INTO `site_lang` VALUES ('167', '21', 'October');
INSERT INTO `site_lang` VALUES ('168', '21', 'November');
INSERT INTO `site_lang` VALUES ('169', '21', 'December');
INSERT INTO `site_lang` VALUES ('158', '21', 'January');
INSERT INTO `site_lang` VALUES ('159', '21', 'February');
INSERT INTO `site_lang` VALUES ('160', '21', 'March');
INSERT INTO `site_lang` VALUES ('161', '21', 'April');
INSERT INTO `site_lang` VALUES ('162', '21', 'May');
INSERT INTO `site_lang` VALUES ('163', '21', 'June');
INSERT INTO `site_lang` VALUES ('164', '21', 'July');
INSERT INTO `site_lang` VALUES ('155', '21', 'No popular users near you');
INSERT INTO `site_lang` VALUES ('156', '21', 'You dont have any fans yet');
INSERT INTO `site_lang` VALUES ('157', '21', 'You dont have matches yet');
INSERT INTO `site_lang` VALUES ('150', '21', 'Delete profile');
INSERT INTO `site_lang` VALUES ('151', '21', 'Online now');
INSERT INTO `site_lang` VALUES ('152', '21', 'Verified');
INSERT INTO `site_lang` VALUES ('153', '21', 'Nothing found');
INSERT INTO `site_lang` VALUES ('154', '21', 'people found');
INSERT INTO `site_lang` VALUES ('149', '21', 'After delete your profile, some of your data will be lost without recovery.');
INSERT INTO `site_lang` VALUES ('148', '21', 'Profile desactivation');
INSERT INTO `site_lang` VALUES ('147', '21', 'New password');
INSERT INTO `site_lang` VALUES ('146', '21', 'You can change your current password bellow');
INSERT INTO `site_lang` VALUES ('145', '21', 'Change password');
INSERT INTO `site_lang` VALUES ('144', '21', 'Upgrade to premium account');
INSERT INTO `site_lang` VALUES ('143', '21', 'Add credits');
INSERT INTO `site_lang` VALUES ('142', '21', 'Current credits');
INSERT INTO `site_lang` VALUES ('141', '21', 'Account type');
INSERT INTO `site_lang` VALUES ('140', '21', 'Buy credits for send Gifs and Unblock private photos');
INSERT INTO `site_lang` VALUES ('139', '21', 'You are account is already verified');
INSERT INTO `site_lang` VALUES ('138', '21', 'Connect with Facebook');
INSERT INTO `site_lang` VALUES ('137', '21', 'For verify your account , connect with your facebook account');
INSERT INTO `site_lang` VALUES ('136', '21', 'Verify account');
INSERT INTO `site_lang` VALUES ('135', '21', 'Update profile');
INSERT INTO `site_lang` VALUES ('134', '21', 'Site language');
INSERT INTO `site_lang` VALUES ('133', '21', 'You can edit your profile information bellow');
INSERT INTO `site_lang` VALUES ('132', '21', 'Personal information');
INSERT INTO `site_lang` VALUES ('131', '21', 'Delete');
INSERT INTO `site_lang` VALUES ('130', '21', 'Change password');
INSERT INTO `site_lang` VALUES ('128', '21', 'Credits');
INSERT INTO `site_lang` VALUES ('129', '21', 'Verify');
INSERT INTO `site_lang` VALUES ('126', '21', 'Unblock private photos');
INSERT INTO `site_lang` VALUES ('127', '21', 'Personal');
INSERT INTO `site_lang` VALUES ('108', '21', 'Online now');
INSERT INTO `site_lang` VALUES ('109', '21', 'Show me');
INSERT INTO `site_lang` VALUES ('110', '21', 'Girls');
INSERT INTO `site_lang` VALUES ('111', '21', 'Boys');
INSERT INTO `site_lang` VALUES ('112', '21', 'Both');
INSERT INTO `site_lang` VALUES ('113', '21', 'who are between');
INSERT INTO `site_lang` VALUES ('114', '21', 'in a radius of');
INSERT INTO `site_lang` VALUES ('115', '21', 'World');
INSERT INTO `site_lang` VALUES ('116', '21', 'Most popular users');
INSERT INTO `site_lang` VALUES ('117', '21', 'About ');
INSERT INTO `site_lang` VALUES ('118', '21', 'Personal info');
INSERT INTO `site_lang` VALUES ('119', '21', 'years old');
INSERT INTO `site_lang` VALUES ('120', '21', 'Only boys');
INSERT INTO `site_lang` VALUES ('121', '21', 'Only girls');
INSERT INTO `site_lang` VALUES ('122', '21', 'boys and girls');
INSERT INTO `site_lang` VALUES ('123', '21', 'Credits successfully added to your account');
INSERT INTO `site_lang` VALUES ('124', '21', 'Now you have');
INSERT INTO `site_lang` VALUES ('125', '21', 'Ask permission to');
INSERT INTO `site_lang` VALUES ('107', '21', 'All users');
INSERT INTO `site_lang` VALUES ('106', '21', 'Filter Search');
INSERT INTO `site_lang` VALUES ('105', '21', 'Your matches');
INSERT INTO `site_lang` VALUES ('104', '21', 'Please complete your profile before start in ');
INSERT INTO `site_lang` VALUES ('103', '21', 'Terms of Use');
INSERT INTO `site_lang` VALUES ('102', '21', 'Privacy Policy');
INSERT INTO `site_lang` VALUES ('101', '21', 'Your fans');
INSERT INTO `site_lang` VALUES ('100', '21', 'or wait until tomorrow for continue meeting people');
INSERT INTO `site_lang` VALUES ('99', '21', 'daily conversations');
INSERT INTO `site_lang` VALUES ('98', '21', 'and get up to');
INSERT INTO `site_lang` VALUES ('97', '21', 'Upgrade your account to Premium');
INSERT INTO `site_lang` VALUES ('96', '21', 'or');
INSERT INTO `site_lang` VALUES ('95', '21', 'more daily conversation');
INSERT INTO `site_lang` VALUES ('94', '21', 'Buy');
INSERT INTO `site_lang` VALUES ('87', '21', 'Unblock all private photos');
INSERT INTO `site_lang` VALUES ('88', '21', 'Premium user badge');
INSERT INTO `site_lang` VALUES ('89', '21', 'Write text here');
INSERT INTO `site_lang` VALUES ('90', '21', 'Send');
INSERT INTO `site_lang` VALUES ('91', '21', 'Chat');
INSERT INTO `site_lang` VALUES ('92', '21', 'you have reached the limit of new daily conversations');
INSERT INTO `site_lang` VALUES ('93', '21', 'To continue chatting');
INSERT INTO `site_lang` VALUES ('86', '21', 'Unlimited videocalls');
INSERT INTO `site_lang` VALUES ('85', '21', 'new chats per day');
INSERT INTO `site_lang` VALUES ('84', '21', 'Premium Account Features');
INSERT INTO `site_lang` VALUES ('83', '21', 'Buy credits');
INSERT INTO `site_lang` VALUES ('82', '21', 'Pay with');
INSERT INTO `site_lang` VALUES ('81', '21', 'Pay with');
INSERT INTO `site_lang` VALUES ('80', '21', 'Select payment method');
INSERT INTO `site_lang` VALUES ('79', '21', 'Select credits package');
INSERT INTO `site_lang` VALUES ('78', '21', 'Buy credits / Upgrade account');
INSERT INTO `site_lang` VALUES ('77', '21', 'Send gift');
INSERT INTO `site_lang` VALUES ('76', '21', 'Pick the gift you want to send to ');
INSERT INTO `site_lang` VALUES ('75', '21', 'Send gift to ');
INSERT INTO `site_lang` VALUES ('73', '21', 'Credits');
INSERT INTO `site_lang` VALUES ('74', '21', 'Add photo');
INSERT INTO `site_lang` VALUES ('72', '21', 'Pick the photo you want to show in the Spotlight, cost ');
INSERT INTO `site_lang` VALUES ('71', '21', 'Add yourself to the Spotlight');
INSERT INTO `site_lang` VALUES ('70', '21', 'add photos');
INSERT INTO `site_lang` VALUES ('69', '21', 'Add your photos');
INSERT INTO `site_lang` VALUES ('68', '21', 'Private Photos');
INSERT INTO `site_lang` VALUES ('67', '21', 'Public Photos');
INSERT INTO `site_lang` VALUES ('66', '21', 'All Photos');
INSERT INTO `site_lang` VALUES ('65', '21', 'Manage your photos');
INSERT INTO `site_lang` VALUES ('64', '21', 'Contact');
INSERT INTO `site_lang` VALUES ('63', '21', 'Privacy');
INSERT INTO `site_lang` VALUES ('62', '21', 'Terms');
INSERT INTO `site_lang` VALUES ('61', '21', 'Who to like');
INSERT INTO `site_lang` VALUES ('60', '21', 'New messages');
INSERT INTO `site_lang` VALUES ('59', '21', 'Online now');
INSERT INTO `site_lang` VALUES ('58', '21', 'Conversations');
INSERT INTO `site_lang` VALUES ('57', '21', 'Fans');
INSERT INTO `site_lang` VALUES ('56', '21', 'All');
INSERT INTO `site_lang` VALUES ('55', '21', 'Settings');
INSERT INTO `site_lang` VALUES ('54', '21', 'Manage photos');
INSERT INTO `site_lang` VALUES ('53', '21', 'Fans');
INSERT INTO `site_lang` VALUES ('52', '21', 'Most populars');
INSERT INTO `site_lang` VALUES ('51', '21', 'Matches');
INSERT INTO `site_lang` VALUES ('50', '21', 'Discover');
INSERT INTO `site_lang` VALUES ('49', '21', 'Meet new people');
INSERT INTO `site_lang` VALUES ('48', '21', 'Logout');
INSERT INTO `site_lang` VALUES ('46', '21', 'Profile');
INSERT INTO `site_lang` VALUES ('47', '21', 'Settings');
INSERT INTO `site_lang` VALUES ('45', '21', 'Privacy Policy');
INSERT INTO `site_lang` VALUES ('44', '21', 'and');
INSERT INTO `site_lang` VALUES ('43', '21', 'Terms and Conditions');
INSERT INTO `site_lang` VALUES ('42', '21', 'By continuing, you are confirming that you have read and agree to our');
INSERT INTO `site_lang` VALUES ('41', '21', 'Sign up');
INSERT INTO `site_lang` VALUES ('40', '21', 'Meet boys and girls');
INSERT INTO `site_lang` VALUES ('39', '21', 'Meet boys');
INSERT INTO `site_lang` VALUES ('38', '21', 'Meet girls');
INSERT INTO `site_lang` VALUES ('37', '21', 'Im here to');
INSERT INTO `site_lang` VALUES ('36', '21', 'Female');
INSERT INTO `site_lang` VALUES ('35', '21', 'Male');
INSERT INTO `site_lang` VALUES ('34', '21', 'Gender');
INSERT INTO `site_lang` VALUES ('33', '21', 'Where do you live?');
INSERT INTO `site_lang` VALUES ('32', '21', 'City');
INSERT INTO `site_lang` VALUES ('31', '21', 'Please select');
INSERT INTO `site_lang` VALUES ('30', '21', 'Birthday');
INSERT INTO `site_lang` VALUES ('29', '21', 'Password');
INSERT INTO `site_lang` VALUES ('28', '21', 'Email');
INSERT INTO `site_lang` VALUES ('27', '21', 'Your name or nickname');
INSERT INTO `site_lang` VALUES ('26', '21', 'Name');
INSERT INTO `site_lang` VALUES ('25', '21', 'Join the worlds bestest community for meeting new people!.');
INSERT INTO `site_lang` VALUES ('24', '21', 'Become a member now');
INSERT INTO `site_lang` VALUES ('23', '21', 'Play our popular Discover game and get matched with other users. Its a great way to break the ice and chat to new people.');
INSERT INTO `site_lang` VALUES ('22', '21', 'Matches');
INSERT INTO `site_lang` VALUES ('21', '21', 'We wont show your exact location, but you will be able to find people nearby who like the same things you do.');
INSERT INTO `site_lang` VALUES ('20', '21', 'People nearby');
INSERT INTO `site_lang` VALUES ('18', '21', 'Video Chat');
INSERT INTO `site_lang` VALUES ('19', '21', 'You can make quality videocalls for free to anyone, without limits of call duration, just enjoy seeing the person who is chatting with you');
INSERT INTO `site_lang` VALUES ('16', '21', 'Chat');
INSERT INTO `site_lang` VALUES ('17', '21', 'Powerfull private chat for meet new friends, you can send emoticons and private photos to anyone.');
INSERT INTO `site_lang` VALUES ('15', '21', 'Recover password');
INSERT INTO `site_lang` VALUES ('13', '21', 'Login now');
INSERT INTO `site_lang` VALUES ('14', '21', 'Password recover');
INSERT INTO `site_lang` VALUES ('12', '21', 'do you forget your password?');
INSERT INTO `site_lang` VALUES ('11', '21', 'Your password');
INSERT INTO `site_lang` VALUES ('10', '21', 'Your email');
INSERT INTO `site_lang` VALUES ('9', '21', 'Welcome back');
INSERT INTO `site_lang` VALUES ('7', '21', 'Connect with ');
INSERT INTO `site_lang` VALUES ('8', '21', 'Create your account');
INSERT INTO `site_lang` VALUES ('6', '21', 'SOON AVAILABLE');
INSERT INTO `site_lang` VALUES ('5', '21', 'Soon we will have our phone apps online');
INSERT INTO `site_lang` VALUES ('4', '21', 'Please visit us from your laptop or PC');
INSERT INTO `site_lang` VALUES ('3', '21', 'For now our site works only for Desktop users');
INSERT INTO `site_lang` VALUES ('0', '21', 'meet new people!');
INSERT INTO `site_lang` VALUES ('1', '21', 'Login');
INSERT INTO `site_lang` VALUES ('2', '21', 'Welcome to the fastest growing place to meet new people');
INSERT INTO `site_lang` VALUES ('380', '20', 'Welcome to');
INSERT INTO `site_lang` VALUES ('381', '20', 'calling...');
INSERT INTO `site_lang` VALUES ('382', '20', 'dont like you');
INSERT INTO `site_lang` VALUES ('383', '20', 'must like you for start a videocall');
INSERT INTO `site_lang` VALUES ('384', '20', 'Ok, i understand');
INSERT INTO `site_lang` VALUES ('379', '20', 'Go to');
INSERT INTO `site_lang` VALUES ('378', '20', 'Please save your connection information in a safe place');
INSERT INTO `site_lang` VALUES ('377', '20', 'Password');
INSERT INTO `site_lang` VALUES ('376', '20', 'E-mail');
INSERT INTO `site_lang` VALUES ('375', '20', 'Here are your connection details');
INSERT INTO `site_lang` VALUES ('374', '20', 'Start meeting new people now');
INSERT INTO `site_lang` VALUES ('373', '20', 'More than 1 million people have joined $site_name You probably want to know some of them.');
INSERT INTO `site_lang` VALUES ('372', '20', 'Add photos and complete your profile');
INSERT INTO `site_lang` VALUES ('371', '20', 'Nobody is going to fall in love with a blank page. The more information you get, the more chances to find that special someone!');
INSERT INTO `site_lang` VALUES ('370', '20', 'Meet new people');
INSERT INTO `site_lang` VALUES ('369', '20', 'you can meet people instantly');
INSERT INTO `site_lang` VALUES ('368', '20', 'In');
INSERT INTO `site_lang` VALUES ('367', '20', 'people in your area wants to know you');
INSERT INTO `site_lang` VALUES ('366', '20', 'Newsflash');
INSERT INTO `site_lang` VALUES ('365', '20', 'Verify your account');
INSERT INTO `site_lang` VALUES ('364', '20', 'Now you are a new member of');
INSERT INTO `site_lang` VALUES ('363', '20', 'Here are a few tips');
INSERT INTO `site_lang` VALUES ('362', '20', 'Well done, now you are in');
INSERT INTO `site_lang` VALUES ('361', '20', 'Welcome');
INSERT INTO `site_lang` VALUES ('360', '20', 'Check out the profile');
INSERT INTO `site_lang` VALUES ('359', '20', 'and lives closer to you');
INSERT INTO `site_lang` VALUES ('358', '20', 'is new at');
INSERT INTO `site_lang` VALUES ('357', '20', 'is new and lives closer to you');
INSERT INTO `site_lang` VALUES ('356', '20', 'Have fun!');
INSERT INTO `site_lang` VALUES ('355', '20', 'Respond to');
INSERT INTO `site_lang` VALUES ('354', '20', 'you have a new message from');
INSERT INTO `site_lang` VALUES ('353', '20', 'New message from');
INSERT INTO `site_lang` VALUES ('347', '20', 'Choose a new password');
INSERT INTO `site_lang` VALUES ('348', '20', 'if you forgot your password, click on the link below to get a new');
INSERT INTO `site_lang` VALUES ('349', '20', 'You have a match at');
INSERT INTO `site_lang` VALUES ('350', '20', 'Its a match!');
INSERT INTO `site_lang` VALUES ('351', '20', 'thinks the feeling is mutual');
INSERT INTO `site_lang` VALUES ('352', '20', 'Go and say something to');
INSERT INTO `site_lang` VALUES ('346', '20', 'Unsubscribe');
INSERT INTO `site_lang` VALUES ('345', '20', 'You received this notice because you registered as');
INSERT INTO `site_lang` VALUES ('344', '20', 'Find out if you also like');
INSERT INTO `site_lang` VALUES ('343', '20', 'has seen you in discover and likes. The feeling is mutual?');
INSERT INTO `site_lang` VALUES ('342', '20', 'likes you and wants to chat in');
INSERT INTO `site_lang` VALUES ('340', '20', 'Loading...');
INSERT INTO `site_lang` VALUES ('341', '20', 'We sent you a email with your info, it may take up to 1 min to arrive');
INSERT INTO `site_lang` VALUES ('339', '20', 'of');
INSERT INTO `site_lang` VALUES ('338', '20', 'Photos of ');
INSERT INTO `site_lang` VALUES ('330', '20', 'You need to write your username!');
INSERT INTO `site_lang` VALUES ('331', '20', 'username');
INSERT INTO `site_lang` VALUES ('332', '20', 'days of Premium');
INSERT INTO `site_lang` VALUES ('333', '20', 'Wrong');
INSERT INTO `site_lang` VALUES ('334', '20', 'Spotlight');
INSERT INTO `site_lang` VALUES ('335', '20', 'Service cost');
INSERT INTO `site_lang` VALUES ('336', '20', 'Password successfully changed');
INSERT INTO `site_lang` VALUES ('337', '20', 'is calling you..');
INSERT INTO `site_lang` VALUES ('329', '20', 'Write your instagram username');
INSERT INTO `site_lang` VALUES ('328', '20', 'Press backspace key for smart return to the meeting section.');
INSERT INTO `site_lang` VALUES ('327', '20', 'Are you sure you want to report');
INSERT INTO `site_lang` VALUES ('326', '20', 'Report and block');
INSERT INTO `site_lang` VALUES ('325', '20', 'is blocking you or you blocked him, you cant chat with him sorry');
INSERT INTO `site_lang` VALUES ('324', '20', 'We sended you a email for verify your account');
INSERT INTO `site_lang` VALUES ('323', '20', 'years old and im from');
INSERT INTO `site_lang` VALUES ('322', '20', 'Hi, im');
INSERT INTO `site_lang` VALUES ('321', '20', 'Please add a profile photo');
INSERT INTO `site_lang` VALUES ('320', '20', 'Please verify your account, check your email');
INSERT INTO `site_lang` VALUES ('319', '20', 'ago');
INSERT INTO `site_lang` VALUES ('318', '20', 'seconds');
INSERT INTO `site_lang` VALUES ('317', '20', 'minutes');
INSERT INTO `site_lang` VALUES ('316', '20', 'hours');
INSERT INTO `site_lang` VALUES ('315', '20', 'days');
INSERT INTO `site_lang` VALUES ('314', '20', 'months');
INSERT INTO `site_lang` VALUES ('313', '20', 'years');
INSERT INTO `site_lang` VALUES ('312', '20', 'second');
INSERT INTO `site_lang` VALUES ('310', '20', 'hour');
INSERT INTO `site_lang` VALUES ('311', '20', 'minute');
INSERT INTO `site_lang` VALUES ('309', '20', 'day');
INSERT INTO `site_lang` VALUES ('308', '20', 'month');
INSERT INTO `site_lang` VALUES ('304', '20', 'Cost');
INSERT INTO `site_lang` VALUES ('305', '20', 'Credits for $');
INSERT INTO `site_lang` VALUES ('306', '20', '0 seconds');
INSERT INTO `site_lang` VALUES ('307', '20', 'year');
INSERT INTO `site_lang` VALUES ('303', '20', 'You do not like anyone');
INSERT INTO `site_lang` VALUES ('302', '20', 'visited');
INSERT INTO `site_lang` VALUES ('300', '20', 'AGE');
INSERT INTO `site_lang` VALUES ('301', '20', 'You dont have any visit yet');
INSERT INTO `site_lang` VALUES ('299', '20', 'Dislike');
INSERT INTO `site_lang` VALUES ('298', '20', 'Like');
INSERT INTO `site_lang` VALUES ('297', '20', 'Messages');
INSERT INTO `site_lang` VALUES ('296', '20', 'people liked you, for see them');
INSERT INTO `site_lang` VALUES ('295', '20', 'People i like');
INSERT INTO `site_lang` VALUES ('294', '20', 'Upgrade your account to premium');
INSERT INTO `site_lang` VALUES ('293', '20', 'people visited your profile for see them');
INSERT INTO `site_lang` VALUES ('292', '20', 'Delete');
INSERT INTO `site_lang` VALUES ('291', '20', 'Public photo');
INSERT INTO `site_lang` VALUES ('288', '20', 'get seen by millions');
INSERT INTO `site_lang` VALUES ('290', '20', 'Private photo');
INSERT INTO `site_lang` VALUES ('289', '20', 'Set as profile');
INSERT INTO `site_lang` VALUES ('287', '20', 'Add me here');
INSERT INTO `site_lang` VALUES ('286', '20', 'Visits');
INSERT INTO `site_lang` VALUES ('285', '20', 'Credits');
INSERT INTO `site_lang` VALUES ('284', '20', 'Photos');
INSERT INTO `site_lang` VALUES ('283', '20', 'Add');
INSERT INTO `site_lang` VALUES ('282', '20', 'Add from ');
INSERT INTO `site_lang` VALUES ('281', '20', 'Private photos');
INSERT INTO `site_lang` VALUES ('280', '20', 'Public Photos');
INSERT INTO `site_lang` VALUES ('279', '20', 'No data');
INSERT INTO `site_lang` VALUES ('277', '20', 'Report');
INSERT INTO `site_lang` VALUES ('278', '20', 'Fans');
INSERT INTO `site_lang` VALUES ('276', '20', 'Interests');
INSERT INTO `site_lang` VALUES ('275', '20', 'Please wait');
INSERT INTO `site_lang` VALUES ('274', '20', 'Year');
INSERT INTO `site_lang` VALUES ('273', '20', 'Month');
INSERT INTO `site_lang` VALUES ('272', '20', 'Day');
INSERT INTO `site_lang` VALUES ('271', '20', 'When someone send me a message');
INSERT INTO `site_lang` VALUES ('270', '20', 'When new users near me join in');
INSERT INTO `site_lang` VALUES ('269', '20', 'When i get a match');
INSERT INTO `site_lang` VALUES ('268', '20', 'When someone likes me');
INSERT INTO `site_lang` VALUES ('267', '20', 'None');
INSERT INTO `site_lang` VALUES ('266', '20', 'I own a motorbike');
INSERT INTO `site_lang` VALUES ('265', '20', 'I own a car');
INSERT INTO `site_lang` VALUES ('264', '20', 'Parents car');
INSERT INTO `site_lang` VALUES ('263', '20', 'Transport');
INSERT INTO `site_lang` VALUES ('262', '20', 'Drink');
INSERT INTO `site_lang` VALUES ('261', '20', 'Sometimes');
INSERT INTO `site_lang` VALUES ('260', '20', 'No');
INSERT INTO `site_lang` VALUES ('259', '20', 'Yes');
INSERT INTO `site_lang` VALUES ('258', '20', 'Smoke');
INSERT INTO `site_lang` VALUES ('257', '20', 'Alone');
INSERT INTO `site_lang` VALUES ('256', '20', 'With partner');
INSERT INTO `site_lang` VALUES ('255', '20', 'Student dormitory');
INSERT INTO `site_lang` VALUES ('254', '20', 'With housemate');
INSERT INTO `site_lang` VALUES ('253', '20', 'With parents');
INSERT INTO `site_lang` VALUES ('252', '20', 'Living');
INSERT INTO `site_lang` VALUES ('251', '20', 'Curvy');
INSERT INTO `site_lang` VALUES ('250', '20', 'Heavy set');
INSERT INTO `site_lang` VALUES ('249', '20', 'Athletic');
INSERT INTO `site_lang` VALUES ('248', '20', 'Average');
INSERT INTO `site_lang` VALUES ('247', '20', 'Slim');
INSERT INTO `site_lang` VALUES ('246', '20', 'Body type');
INSERT INTO `site_lang` VALUES ('245', '20', 'Other');
INSERT INTO `site_lang` VALUES ('244', '20', 'Indian');
INSERT INTO `site_lang` VALUES ('243', '20', 'Pacific Islander');
INSERT INTO `site_lang` VALUES ('242', '20', 'Hispanic/latin');
INSERT INTO `site_lang` VALUES ('241', '20', 'Native American');
INSERT INTO `site_lang` VALUES ('240', '20', 'White');
INSERT INTO `site_lang` VALUES ('239', '20', 'Black');
INSERT INTO `site_lang` VALUES ('238', '20', 'Middle Eastern');
INSERT INTO `site_lang` VALUES ('237', '20', 'Asian');
INSERT INTO `site_lang` VALUES ('236', '20', 'Ethnicity');
INSERT INTO `site_lang` VALUES ('235', '20', 'Weight');
INSERT INTO `site_lang` VALUES ('234', '20', 'more than');
INSERT INTO `site_lang` VALUES ('233', '20', 'less than');
INSERT INTO `site_lang` VALUES ('231', '20', 'Bisexual');
INSERT INTO `site_lang` VALUES ('232', '20', 'Height');
INSERT INTO `site_lang` VALUES ('223', '20', 'Relationship');
INSERT INTO `site_lang` VALUES ('224', '20', 'Single');
INSERT INTO `site_lang` VALUES ('225', '20', 'Taken');
INSERT INTO `site_lang` VALUES ('226', '20', 'Open');
INSERT INTO `site_lang` VALUES ('227', '20', 'Sexuality');
INSERT INTO `site_lang` VALUES ('228', '20', 'Gay');
INSERT INTO `site_lang` VALUES ('229', '20', 'Open-minded');
INSERT INTO `site_lang` VALUES ('230', '20', 'Straight');
INSERT INTO `site_lang` VALUES ('213', '20', 'You cant make videocall because you dont have webcam');
INSERT INTO `site_lang` VALUES ('219', '20', 'Basic');
INSERT INTO `site_lang` VALUES ('220', '20', 'UPGRADE');
INSERT INTO `site_lang` VALUES ('221', '20', 'Notifications');
INSERT INTO `site_lang` VALUES ('222', '20', 'Extended info (optional)');
INSERT INTO `site_lang` VALUES ('218', '20', 'until');
INSERT INTO `site_lang` VALUES ('216', '20', 'End call');
INSERT INTO `site_lang` VALUES ('217', '20', 'Wait more');
INSERT INTO `site_lang` VALUES ('215', '20', 'Seems that your friend do not have webcam or he is not available');
INSERT INTO `site_lang` VALUES ('214', '20', 'Too long wait');
INSERT INTO `site_lang` VALUES ('212', '20', 'Impossible to make a call!');
INSERT INTO `site_lang` VALUES ('211', '20', 'Only premium users can make videocalls');
INSERT INTO `site_lang` VALUES ('210', '20', 'You are already in a videocall, you have to end the other call before start another');
INSERT INTO `site_lang` VALUES ('208', '20', 'is offline, try again when your friend is online');
INSERT INTO `site_lang` VALUES ('209', '20', 'Please allow access to your Webcam.');
INSERT INTO `site_lang` VALUES ('202', '20', 'Yes, buy it!');
INSERT INTO `site_lang` VALUES ('203', '20', 'Information updated successfully');
INSERT INTO `site_lang` VALUES ('204', '20', 'Account termination');
INSERT INTO `site_lang` VALUES ('205', '20', 'Your data will be lost without recovery, continue?');
INSERT INTO `site_lang` VALUES ('206', '20', 'Yes, delete it!');
INSERT INTO `site_lang` VALUES ('207', '20', 'is in another videocall , you cant call now');
INSERT INTO `site_lang` VALUES ('201', '20', 'more daily conversation, cost ');
INSERT INTO `site_lang` VALUES ('200', '20', 'Expand daily limitation ');
INSERT INTO `site_lang` VALUES ('199', '20', 'You dont have enought credits for send the gift');
INSERT INTO `site_lang` VALUES ('198', '20', 'Please, select 1 gift');
INSERT INTO `site_lang` VALUES ('197', '20', 'Please, select 1 photo');
INSERT INTO `site_lang` VALUES ('196', '20', 'Please, select a payment method');
INSERT INTO `site_lang` VALUES ('195', '20', 'No thanks');
INSERT INTO `site_lang` VALUES ('194', '20', 'Get access');
INSERT INTO `site_lang` VALUES ('193', '20', 'private photos for ');
INSERT INTO `site_lang` VALUES ('192', '20', 'Get access to');
INSERT INTO `site_lang` VALUES ('191', '20', 'Buy private photos permission');
INSERT INTO `site_lang` VALUES ('190', '20', 'No, i cant show you my private photos');
INSERT INTO `site_lang` VALUES ('180', '20', 'Password recover');
INSERT INTO `site_lang` VALUES ('181', '20', 'Invalid email format');
INSERT INTO `site_lang` VALUES ('182', '20', 'Please fill all the inputs');
INSERT INTO `site_lang` VALUES ('183', '20', 'Email dont exist');
INSERT INTO `site_lang` VALUES ('184', '20', 'Wrong password');
INSERT INTO `site_lang` VALUES ('185', '20', 'Add a valid date');
INSERT INTO `site_lang` VALUES ('186', '20', 'Choose city from the autocomplete');
INSERT INTO `site_lang` VALUES ('187', '20', 'Password too short');
INSERT INTO `site_lang` VALUES ('188', '20', 'Email already exist, try another');
INSERT INTO `site_lang` VALUES ('189', '20', 'Yes, you can see my private photos');
INSERT INTO `site_lang` VALUES ('179', '20', 'Login to my account');
INSERT INTO `site_lang` VALUES ('165', '20', 'August');
INSERT INTO `site_lang` VALUES ('178', '20', 'If you dont remember your password, click the link below to set a new one:');
INSERT INTO `site_lang` VALUES ('177', '20', 'Hi');
INSERT INTO `site_lang` VALUES ('176', '20', 'No');
INSERT INTO `site_lang` VALUES ('175', '20', 'Yes');
INSERT INTO `site_lang` VALUES ('174', '20', 'Hello, can i have access to your private photos ?');
INSERT INTO `site_lang` VALUES ('173', '20', 'like this');
INSERT INTO `site_lang` VALUES ('172', '20', 'persons more like this');
INSERT INTO `site_lang` VALUES ('171', '20', 'Days Premium');
INSERT INTO `site_lang` VALUES ('170', '20', 'Buy');
INSERT INTO `site_lang` VALUES ('169', '20', 'December');
INSERT INTO `site_lang` VALUES ('168', '20', 'November');
INSERT INTO `site_lang` VALUES ('167', '20', 'October');
INSERT INTO `site_lang` VALUES ('166', '20', 'September');
INSERT INTO `site_lang` VALUES ('164', '20', 'July');
INSERT INTO `site_lang` VALUES ('163', '20', 'June');
INSERT INTO `site_lang` VALUES ('162', '20', 'May');
INSERT INTO `site_lang` VALUES ('161', '20', 'April');
INSERT INTO `site_lang` VALUES ('160', '20', 'March');
INSERT INTO `site_lang` VALUES ('158', '20', 'January');
INSERT INTO `site_lang` VALUES ('159', '20', 'February');
INSERT INTO `site_lang` VALUES ('155', '20', 'No popular users near you');
INSERT INTO `site_lang` VALUES ('157', '20', 'You dont have matches yet');
INSERT INTO `site_lang` VALUES ('156', '20', 'You dont have any fans yet');
INSERT INTO `site_lang` VALUES ('154', '20', 'people found');
INSERT INTO `site_lang` VALUES ('153', '20', 'Nothing found');
INSERT INTO `site_lang` VALUES ('152', '20', 'Verified');
INSERT INTO `site_lang` VALUES ('151', '20', 'Online now');
INSERT INTO `site_lang` VALUES ('150', '20', 'Delete profile');
INSERT INTO `site_lang` VALUES ('149', '20', 'After delete your profile, some of your data will be lost without recovery.');
INSERT INTO `site_lang` VALUES ('148', '20', 'Profile desactivation');
INSERT INTO `site_lang` VALUES ('147', '20', 'New password');
INSERT INTO `site_lang` VALUES ('146', '20', 'You can change your current password bellow');
INSERT INTO `site_lang` VALUES ('145', '20', 'Change password');
INSERT INTO `site_lang` VALUES ('144', '20', 'Upgrade to premium account');
INSERT INTO `site_lang` VALUES ('143', '20', 'Add credits');
INSERT INTO `site_lang` VALUES ('142', '20', 'Current credits');
INSERT INTO `site_lang` VALUES ('141', '20', 'Account type');
INSERT INTO `site_lang` VALUES ('140', '20', 'Buy credits for send Gifs and Unblock private photos');
INSERT INTO `site_lang` VALUES ('139', '20', 'You are account is already verified');
INSERT INTO `site_lang` VALUES ('138', '20', 'Connect with Facebook');
INSERT INTO `site_lang` VALUES ('137', '20', 'For verify your account , connect with your facebook account');
INSERT INTO `site_lang` VALUES ('135', '20', 'Update profile');
INSERT INTO `site_lang` VALUES ('136', '20', 'Verify account');
INSERT INTO `site_lang` VALUES ('134', '20', 'Site language');
INSERT INTO `site_lang` VALUES ('133', '20', 'You can edit your profile information bellow');
INSERT INTO `site_lang` VALUES ('132', '20', 'Personal information');
INSERT INTO `site_lang` VALUES ('131', '20', 'Delete');
INSERT INTO `site_lang` VALUES ('130', '20', 'Change password');
INSERT INTO `site_lang` VALUES ('129', '20', 'Verify');
INSERT INTO `site_lang` VALUES ('128', '20', 'Credits');
INSERT INTO `site_lang` VALUES ('127', '20', 'Personal');
INSERT INTO `site_lang` VALUES ('126', '20', 'Unblock private photos');
INSERT INTO `site_lang` VALUES ('125', '20', 'Ask permission to');
INSERT INTO `site_lang` VALUES ('124', '20', 'Now you have');
INSERT INTO `site_lang` VALUES ('123', '20', 'Credits successfully added to your account');
INSERT INTO `site_lang` VALUES ('122', '20', 'boys and girls');
INSERT INTO `site_lang` VALUES ('121', '20', 'Only girls');
INSERT INTO `site_lang` VALUES ('120', '20', 'Only boys');
INSERT INTO `site_lang` VALUES ('119', '20', 'years old');
INSERT INTO `site_lang` VALUES ('118', '20', 'Personal info');
INSERT INTO `site_lang` VALUES ('117', '20', 'About ');
INSERT INTO `site_lang` VALUES ('116', '20', 'Most popular users');
INSERT INTO `site_lang` VALUES ('115', '20', 'World');
INSERT INTO `site_lang` VALUES ('114', '20', 'in a radius of');
INSERT INTO `site_lang` VALUES ('113', '20', 'who are between');
INSERT INTO `site_lang` VALUES ('112', '20', 'Both');
INSERT INTO `site_lang` VALUES ('111', '20', 'Boys');
INSERT INTO `site_lang` VALUES ('110', '20', 'Girls');
INSERT INTO `site_lang` VALUES ('109', '20', 'Show me');
INSERT INTO `site_lang` VALUES ('108', '20', 'Online now');
INSERT INTO `site_lang` VALUES ('107', '20', 'All users');
INSERT INTO `site_lang` VALUES ('106', '20', 'Filter Search');
INSERT INTO `site_lang` VALUES ('105', '20', 'Your matches');
INSERT INTO `site_lang` VALUES ('104', '20', 'Please complete your profile before start in ');
INSERT INTO `site_lang` VALUES ('103', '20', 'Terms of Use');
INSERT INTO `site_lang` VALUES ('102', '20', 'Privacy Policy');
INSERT INTO `site_lang` VALUES ('101', '20', 'Your fans');
INSERT INTO `site_lang` VALUES ('100', '20', 'or wait until tomorrow for continue meeting people');
INSERT INTO `site_lang` VALUES ('99', '20', 'daily conversations');
INSERT INTO `site_lang` VALUES ('98', '20', 'and get up to');
INSERT INTO `site_lang` VALUES ('97', '20', 'Upgrade your account to Premium');
INSERT INTO `site_lang` VALUES ('96', '20', 'or');
INSERT INTO `site_lang` VALUES ('95', '20', 'more daily conversation');
INSERT INTO `site_lang` VALUES ('89', '20', 'Write text here');
INSERT INTO `site_lang` VALUES ('94', '20', 'Buy');
INSERT INTO `site_lang` VALUES ('93', '20', 'To continue chatting');
INSERT INTO `site_lang` VALUES ('92', '20', 'you have reached the limit of new daily conversations');
INSERT INTO `site_lang` VALUES ('90', '20', 'Send');
INSERT INTO `site_lang` VALUES ('91', '20', 'Chat');
INSERT INTO `site_lang` VALUES ('88', '20', 'Premium user badge');
INSERT INTO `site_lang` VALUES ('87', '20', 'Unblock all private photos');
INSERT INTO `site_lang` VALUES ('86', '20', 'Unlimited videocalls');
INSERT INTO `site_lang` VALUES ('85', '20', 'new chats per day');
INSERT INTO `site_lang` VALUES ('83', '20', 'Buy credits');
INSERT INTO `site_lang` VALUES ('84', '20', 'Premium Account Features');
INSERT INTO `site_lang` VALUES ('81', '20', 'Pay with');
INSERT INTO `site_lang` VALUES ('82', '20', 'Pay with');
INSERT INTO `site_lang` VALUES ('80', '20', 'Select payment method');
INSERT INTO `site_lang` VALUES ('79', '20', 'Select credits package');
INSERT INTO `site_lang` VALUES ('77', '20', 'Send gift');
INSERT INTO `site_lang` VALUES ('78', '20', 'Buy credits / Upgrade account');
INSERT INTO `site_lang` VALUES ('68', '20', 'Private Photos');
INSERT INTO `site_lang` VALUES ('69', '20', 'Add your photos');
INSERT INTO `site_lang` VALUES ('70', '20', 'add photos');
INSERT INTO `site_lang` VALUES ('71', '20', 'Add yourself to the Spotlight');
INSERT INTO `site_lang` VALUES ('72', '20', 'Pick the photo you want to show in the Spotlight, cost ');
INSERT INTO `site_lang` VALUES ('73', '20', 'Credits');
INSERT INTO `site_lang` VALUES ('74', '20', 'Add photo');
INSERT INTO `site_lang` VALUES ('75', '20', 'Send gift to ');
INSERT INTO `site_lang` VALUES ('76', '20', 'Pick the gift you want to send to ');
INSERT INTO `site_lang` VALUES ('59', '20', 'Online now');
INSERT INTO `site_lang` VALUES ('60', '20', 'New messages');
INSERT INTO `site_lang` VALUES ('61', '20', 'Who to like');
INSERT INTO `site_lang` VALUES ('62', '20', 'Terms');
INSERT INTO `site_lang` VALUES ('63', '20', 'Privacy');
INSERT INTO `site_lang` VALUES ('64', '20', 'Contact');
INSERT INTO `site_lang` VALUES ('65', '20', 'Manage your photos');
INSERT INTO `site_lang` VALUES ('66', '20', 'All Photos');
INSERT INTO `site_lang` VALUES ('67', '20', 'Public Photos');
INSERT INTO `site_lang` VALUES ('57', '20', 'Fans');
INSERT INTO `site_lang` VALUES ('58', '20', 'Conversations');
INSERT INTO `site_lang` VALUES ('56', '20', 'All');
INSERT INTO `site_lang` VALUES ('55', '20', 'Settings');
INSERT INTO `site_lang` VALUES ('54', '20', 'Manage photos');
INSERT INTO `site_lang` VALUES ('53', '20', 'Fans');
INSERT INTO `site_lang` VALUES ('52', '20', 'Most populars');
INSERT INTO `site_lang` VALUES ('43', '20', 'Terms and Conditions');
INSERT INTO `site_lang` VALUES ('51', '20', 'Matches');
INSERT INTO `site_lang` VALUES ('50', '20', 'Discover');
INSERT INTO `site_lang` VALUES ('49', '20', 'Meet new people');
INSERT INTO `site_lang` VALUES ('48', '20', 'Logout');
INSERT INTO `site_lang` VALUES ('47', '20', 'Settings');
INSERT INTO `site_lang` VALUES ('46', '20', 'Profile');
INSERT INTO `site_lang` VALUES ('45', '20', 'Privacy Policy');
INSERT INTO `site_lang` VALUES ('44', '20', 'and');
INSERT INTO `site_lang` VALUES ('42', '20', 'By continuing, you are confirming that you have read and agree to our');
INSERT INTO `site_lang` VALUES ('41', '20', 'Sign up');
INSERT INTO `site_lang` VALUES ('40', '20', 'Meet boys and girls');
INSERT INTO `site_lang` VALUES ('39', '20', 'Meet boys');
INSERT INTO `site_lang` VALUES ('38', '20', 'Meet girls');
INSERT INTO `site_lang` VALUES ('37', '20', 'Im here to');
INSERT INTO `site_lang` VALUES ('36', '20', 'Female');
INSERT INTO `site_lang` VALUES ('35', '20', 'Male');
INSERT INTO `site_lang` VALUES ('34', '20', 'Gender');
INSERT INTO `site_lang` VALUES ('33', '20', 'Where do you live?');
INSERT INTO `site_lang` VALUES ('32', '20', 'City');
INSERT INTO `site_lang` VALUES ('31', '20', 'Please select');
INSERT INTO `site_lang` VALUES ('30', '20', 'Birthday');
INSERT INTO `site_lang` VALUES ('29', '20', 'Password');
INSERT INTO `site_lang` VALUES ('28', '20', 'Email');
INSERT INTO `site_lang` VALUES ('27', '20', 'Your name or nickname');
INSERT INTO `site_lang` VALUES ('26', '20', 'Name');
INSERT INTO `site_lang` VALUES ('24', '20', 'Become a member now');
INSERT INTO `site_lang` VALUES ('25', '20', 'Join the worlds bestest community for meeting new people!.');
INSERT INTO `site_lang` VALUES ('22', '20', 'Matches');
INSERT INTO `site_lang` VALUES ('23', '20', 'Play our popular Discover game and get matched with other users. Its a great way to break the ice and chat to new people.');
INSERT INTO `site_lang` VALUES ('21', '20', 'We wont show your exact location, but you will be able to find people nearby who like the same things you do.');
INSERT INTO `site_lang` VALUES ('20', '20', 'People nearby');
INSERT INTO `site_lang` VALUES ('18', '20', 'Video Chat');
INSERT INTO `site_lang` VALUES ('19', '20', 'You can make quality videocalls for free to anyone, without limits of call duration, just enjoy seeing the person who is chatting with you');
INSERT INTO `site_lang` VALUES ('17', '20', 'Powerfull private chat for meet new friends, you can send emoticons and private photos to anyone.');
INSERT INTO `site_lang` VALUES ('16', '20', 'Chat');
INSERT INTO `site_lang` VALUES ('15', '20', 'Recover password');
INSERT INTO `site_lang` VALUES ('13', '20', 'Login now');
INSERT INTO `site_lang` VALUES ('14', '20', 'Password recover');
INSERT INTO `site_lang` VALUES ('12', '20', 'do you forget your password?');
INSERT INTO `site_lang` VALUES ('11', '20', 'Your password');
INSERT INTO `site_lang` VALUES ('10', '20', 'Your email');
INSERT INTO `site_lang` VALUES ('9', '20', 'Welcome back');
INSERT INTO `site_lang` VALUES ('8', '20', 'Create your account');
INSERT INTO `site_lang` VALUES ('7', '20', 'Connect with ');
INSERT INTO `site_lang` VALUES ('6', '20', 'SOON AVAILABLE');
INSERT INTO `site_lang` VALUES ('5', '20', 'Soon we will have our phone apps online');
INSERT INTO `site_lang` VALUES ('4', '20', 'Please visit us from your laptop or PC');
INSERT INTO `site_lang` VALUES ('3', '20', 'For now our site works only for Desktop users');
INSERT INTO `site_lang` VALUES ('2', '20', 'Welcome to the fastest growing place to meet new people');
INSERT INTO `site_lang` VALUES ('1', '20', 'Login');
INSERT INTO `site_lang` VALUES ('0', '20', 'meet new people!');
INSERT INTO `site_lang` VALUES ('384', '19', 'Ok, i understand');
INSERT INTO `site_lang` VALUES ('383', '19', 'must like you for start a videocall');
INSERT INTO `site_lang` VALUES ('382', '19', 'dont like you');
INSERT INTO `site_lang` VALUES ('381', '19', 'calling...');
INSERT INTO `site_lang` VALUES ('384', '18', 'Ok, i understand');
INSERT INTO `site_lang` VALUES ('383', '18', 'must like you for start a videocall');
INSERT INTO `site_lang` VALUES ('382', '18', 'dont like you');
INSERT INTO `site_lang` VALUES ('379', '18', 'Go to');
INSERT INTO `site_lang` VALUES ('380', '18', 'Welcome to');
INSERT INTO `site_lang` VALUES ('381', '18', 'calling...');
INSERT INTO `site_lang` VALUES ('378', '18', 'Please save your connection information in a safe place');
INSERT INTO `site_lang` VALUES ('377', '18', 'Password');
INSERT INTO `site_lang` VALUES ('376', '18', 'E-mail');
INSERT INTO `site_lang` VALUES ('375', '18', 'Here are your connection details');
INSERT INTO `site_lang` VALUES ('374', '18', 'Start meeting new people now');
INSERT INTO `site_lang` VALUES ('373', '18', 'More than 1 million people have joined $site_name You probably want to know some of them.');
INSERT INTO `site_lang` VALUES ('372', '18', 'Add photos and complete your profile');
INSERT INTO `site_lang` VALUES ('371', '18', 'Nobody is going to fall in love with a blank page. The more information you get, the more chances to find that special someone!');
INSERT INTO `site_lang` VALUES ('370', '18', 'Meet new people');
INSERT INTO `site_lang` VALUES ('369', '18', 'you can meet people instantly');
INSERT INTO `site_lang` VALUES ('368', '18', 'In');
INSERT INTO `site_lang` VALUES ('367', '18', 'people in your area wants to know you');
INSERT INTO `site_lang` VALUES ('366', '18', 'Newsflash');
INSERT INTO `site_lang` VALUES ('365', '18', 'Verify your account');
INSERT INTO `site_lang` VALUES ('364', '18', 'Now you are a new member of');
INSERT INTO `site_lang` VALUES ('363', '18', 'Here are a few tips');
INSERT INTO `site_lang` VALUES ('362', '18', 'Well done, now you are in');
INSERT INTO `site_lang` VALUES ('361', '18', 'Welcome');
INSERT INTO `site_lang` VALUES ('360', '18', 'Check out the profile');
INSERT INTO `site_lang` VALUES ('358', '18', 'is new at');
INSERT INTO `site_lang` VALUES ('359', '18', 'and lives closer to you');
INSERT INTO `site_lang` VALUES ('357', '18', 'is new and lives closer to you');
INSERT INTO `site_lang` VALUES ('355', '18', 'Respond to');
INSERT INTO `site_lang` VALUES ('356', '18', 'Have fun!');
INSERT INTO `site_lang` VALUES ('354', '18', 'you have a new message from');
INSERT INTO `site_lang` VALUES ('353', '18', 'New message from');
INSERT INTO `site_lang` VALUES ('351', '18', 'thinks the feeling is mutual');
INSERT INTO `site_lang` VALUES ('352', '18', 'Go and say something to');
INSERT INTO `site_lang` VALUES ('349', '18', 'You have a match at');
INSERT INTO `site_lang` VALUES ('350', '18', 'Its a match!');
INSERT INTO `site_lang` VALUES ('348', '18', 'if you forgot your password, click on the link below to get a new');
INSERT INTO `site_lang` VALUES ('347', '18', 'Choose a new password');
INSERT INTO `site_lang` VALUES ('346', '18', 'Unsubscribe');
INSERT INTO `site_lang` VALUES ('345', '18', 'You received this notice because you registered as');
INSERT INTO `site_lang` VALUES ('344', '18', 'Find out if you also like');
INSERT INTO `site_lang` VALUES ('343', '18', 'has seen you in discover and likes. The feeling is mutual?');
INSERT INTO `site_lang` VALUES ('342', '18', 'likes you and wants to chat in');
INSERT INTO `site_lang` VALUES ('341', '18', 'We sent you a email with your info, it may take up to 1 min to arrive');
INSERT INTO `site_lang` VALUES ('340', '18', 'Loading...');
INSERT INTO `site_lang` VALUES ('339', '18', 'of');
INSERT INTO `site_lang` VALUES ('338', '18', 'Photos of ');
INSERT INTO `site_lang` VALUES ('337', '18', 'is calling you..');
INSERT INTO `site_lang` VALUES ('336', '18', 'Password successfully changed');
INSERT INTO `site_lang` VALUES ('335', '18', 'Service cost');
INSERT INTO `site_lang` VALUES ('334', '18', 'Spotlight');
INSERT INTO `site_lang` VALUES ('333', '18', 'Wrong');
INSERT INTO `site_lang` VALUES ('332', '18', 'days of Premium');
INSERT INTO `site_lang` VALUES ('331', '18', 'username');
INSERT INTO `site_lang` VALUES ('330', '18', 'You need to write your username!');
INSERT INTO `site_lang` VALUES ('329', '18', 'Write your instagram username');
INSERT INTO `site_lang` VALUES ('328', '18', 'Press backspace key for smart return to the meeting section.');
INSERT INTO `site_lang` VALUES ('327', '18', 'Are you sure you want to report');
INSERT INTO `site_lang` VALUES ('326', '18', 'Report and block');
INSERT INTO `site_lang` VALUES ('325', '18', 'is blocking you or you blocked him, you cant chat with him sorry');
INSERT INTO `site_lang` VALUES ('324', '18', 'We sended you a email for verify your account');
INSERT INTO `site_lang` VALUES ('323', '18', 'years old and im from');
INSERT INTO `site_lang` VALUES ('321', '18', 'Please add a profile photo');
INSERT INTO `site_lang` VALUES ('322', '18', 'Hi, im');
INSERT INTO `site_lang` VALUES ('314', '18', 'months');
INSERT INTO `site_lang` VALUES ('315', '18', 'days');
INSERT INTO `site_lang` VALUES ('316', '18', 'hours');
INSERT INTO `site_lang` VALUES ('317', '18', 'minutes');
INSERT INTO `site_lang` VALUES ('318', '18', 'seconds');
INSERT INTO `site_lang` VALUES ('319', '18', 'ago');
INSERT INTO `site_lang` VALUES ('320', '18', 'Please verify your account, check your email');
INSERT INTO `site_lang` VALUES ('313', '18', 'years');
INSERT INTO `site_lang` VALUES ('308', '18', 'month');
INSERT INTO `site_lang` VALUES ('309', '18', 'day');
INSERT INTO `site_lang` VALUES ('310', '18', 'hour');
INSERT INTO `site_lang` VALUES ('311', '18', 'minute');
INSERT INTO `site_lang` VALUES ('312', '18', 'second');
INSERT INTO `site_lang` VALUES ('307', '18', 'year');
INSERT INTO `site_lang` VALUES ('303', '18', 'You do not like anyone');
INSERT INTO `site_lang` VALUES ('304', '18', 'Cost');
INSERT INTO `site_lang` VALUES ('305', '18', 'Credits for $');
INSERT INTO `site_lang` VALUES ('306', '18', '0 seconds');
INSERT INTO `site_lang` VALUES ('302', '18', 'visited');
INSERT INTO `site_lang` VALUES ('299', '18', 'Dislike');
INSERT INTO `site_lang` VALUES ('300', '18', 'AGE');
INSERT INTO `site_lang` VALUES ('301', '18', 'You dont have any visit yet');
INSERT INTO `site_lang` VALUES ('298', '18', 'Like');
INSERT INTO `site_lang` VALUES ('297', '18', 'Messages');
INSERT INTO `site_lang` VALUES ('296', '18', 'people liked you, for see them');
INSERT INTO `site_lang` VALUES ('295', '18', 'People i like');
INSERT INTO `site_lang` VALUES ('294', '18', 'Upgrade your account to premium');
INSERT INTO `site_lang` VALUES ('292', '18', 'Delete');
INSERT INTO `site_lang` VALUES ('293', '18', 'people visited your profile for see them');
INSERT INTO `site_lang` VALUES ('291', '18', 'Public photo');
INSERT INTO `site_lang` VALUES ('290', '18', 'Private photo');
INSERT INTO `site_lang` VALUES ('289', '18', 'Set as profile');
INSERT INTO `site_lang` VALUES ('288', '18', 'get seen by millions');
INSERT INTO `site_lang` VALUES ('286', '18', 'Visits');
INSERT INTO `site_lang` VALUES ('287', '18', 'Add me here');
INSERT INTO `site_lang` VALUES ('285', '18', 'Credits');
INSERT INTO `site_lang` VALUES ('284', '18', 'Photos');
INSERT INTO `site_lang` VALUES ('282', '18', 'Add from ');
INSERT INTO `site_lang` VALUES ('283', '18', 'Add');
INSERT INTO `site_lang` VALUES ('281', '18', 'Private photos');
INSERT INTO `site_lang` VALUES ('280', '18', 'Public Photos');
INSERT INTO `site_lang` VALUES ('279', '18', 'No data');
INSERT INTO `site_lang` VALUES ('278', '18', 'Fans');
INSERT INTO `site_lang` VALUES ('277', '18', 'Report');
INSERT INTO `site_lang` VALUES ('275', '18', 'Please wait');
INSERT INTO `site_lang` VALUES ('276', '18', 'Interests');
INSERT INTO `site_lang` VALUES ('274', '18', 'Year');
INSERT INTO `site_lang` VALUES ('273', '18', 'Month');
INSERT INTO `site_lang` VALUES ('272', '18', 'Day');
INSERT INTO `site_lang` VALUES ('271', '18', 'When someone send me a message');
INSERT INTO `site_lang` VALUES ('270', '18', 'When new users near me join in');
INSERT INTO `site_lang` VALUES ('266', '18', 'I own a motorbike');
INSERT INTO `site_lang` VALUES ('267', '18', 'None');
INSERT INTO `site_lang` VALUES ('268', '18', 'When someone likes me');
INSERT INTO `site_lang` VALUES ('269', '18', 'When i get a match');
INSERT INTO `site_lang` VALUES ('265', '18', 'I own a car');
INSERT INTO `site_lang` VALUES ('263', '18', 'Transport');
INSERT INTO `site_lang` VALUES ('264', '18', 'Parents car');
INSERT INTO `site_lang` VALUES ('262', '18', 'Drink');
INSERT INTO `site_lang` VALUES ('258', '18', 'Smoke');
INSERT INTO `site_lang` VALUES ('259', '18', 'Yes');
INSERT INTO `site_lang` VALUES ('260', '18', 'No');
INSERT INTO `site_lang` VALUES ('261', '18', 'Sometimes');
INSERT INTO `site_lang` VALUES ('257', '18', 'Alone');
INSERT INTO `site_lang` VALUES ('256', '18', 'With partner');
INSERT INTO `site_lang` VALUES ('255', '18', 'Student dormitory');
INSERT INTO `site_lang` VALUES ('253', '18', 'With parents');
INSERT INTO `site_lang` VALUES ('254', '18', 'With housemate');
INSERT INTO `site_lang` VALUES ('252', '18', 'Living');
INSERT INTO `site_lang` VALUES ('251', '18', 'Curvy');
INSERT INTO `site_lang` VALUES ('250', '18', 'Heavy set');
INSERT INTO `site_lang` VALUES ('249', '18', 'Athletic');
INSERT INTO `site_lang` VALUES ('248', '18', 'Average');
INSERT INTO `site_lang` VALUES ('247', '18', 'Slim');
INSERT INTO `site_lang` VALUES ('246', '18', 'Body type');
INSERT INTO `site_lang` VALUES ('245', '18', 'Other');
INSERT INTO `site_lang` VALUES ('244', '18', 'Indian');
INSERT INTO `site_lang` VALUES ('243', '18', 'Pacific Islander');
INSERT INTO `site_lang` VALUES ('242', '18', 'Hispanic/latin');
INSERT INTO `site_lang` VALUES ('241', '18', 'Native American');
INSERT INTO `site_lang` VALUES ('240', '18', 'White');
INSERT INTO `site_lang` VALUES ('239', '18', 'Black');
INSERT INTO `site_lang` VALUES ('238', '18', 'Middle Eastern');
INSERT INTO `site_lang` VALUES ('237', '18', 'Asian');
INSERT INTO `site_lang` VALUES ('236', '18', 'Ethnicity');
INSERT INTO `site_lang` VALUES ('235', '18', 'Weight');
INSERT INTO `site_lang` VALUES ('233', '18', 'less than');
INSERT INTO `site_lang` VALUES ('234', '18', 'more than');
INSERT INTO `site_lang` VALUES ('232', '18', 'Height');
INSERT INTO `site_lang` VALUES ('227', '18', 'Sexuality');
INSERT INTO `site_lang` VALUES ('228', '18', 'Gay');
INSERT INTO `site_lang` VALUES ('229', '18', 'Open-minded');
INSERT INTO `site_lang` VALUES ('230', '18', 'Straight');
INSERT INTO `site_lang` VALUES ('231', '18', 'Bisexual');
INSERT INTO `site_lang` VALUES ('226', '18', 'Open');
INSERT INTO `site_lang` VALUES ('225', '18', 'Taken');
INSERT INTO `site_lang` VALUES ('224', '18', 'Single');
INSERT INTO `site_lang` VALUES ('223', '18', 'Relationship');
INSERT INTO `site_lang` VALUES ('222', '18', 'Extended info (optional)');
INSERT INTO `site_lang` VALUES ('221', '18', 'Notifications');
INSERT INTO `site_lang` VALUES ('220', '18', 'UPGRADE');
INSERT INTO `site_lang` VALUES ('219', '18', 'Basic');
INSERT INTO `site_lang` VALUES ('218', '18', 'until');
INSERT INTO `site_lang` VALUES ('217', '18', 'Wait more');
INSERT INTO `site_lang` VALUES ('216', '18', 'End call');
INSERT INTO `site_lang` VALUES ('215', '18', 'Seems that your friend do not have webcam or he is not available');
INSERT INTO `site_lang` VALUES ('214', '18', 'Too long wait');
INSERT INTO `site_lang` VALUES ('213', '18', 'You cant make videocall because you dont have webcam');
INSERT INTO `site_lang` VALUES ('212', '18', 'Impossible to make a call!');
INSERT INTO `site_lang` VALUES ('211', '18', 'Only premium users can make videocalls');
INSERT INTO `site_lang` VALUES ('210', '18', 'You are already in a videocall, you have to end the other call before start another');
INSERT INTO `site_lang` VALUES ('209', '18', 'Please allow access to your Webcam.');
INSERT INTO `site_lang` VALUES ('208', '18', 'is offline, try again when your friend is online');
INSERT INTO `site_lang` VALUES ('207', '18', 'is in another videocall , you cant call now');
INSERT INTO `site_lang` VALUES ('206', '18', 'Yes, delete it!');
INSERT INTO `site_lang` VALUES ('205', '18', 'Your data will be lost without recovery, continue?');
INSERT INTO `site_lang` VALUES ('204', '18', 'Account termination');
INSERT INTO `site_lang` VALUES ('203', '18', 'Information updated successfully');
INSERT INTO `site_lang` VALUES ('202', '18', 'Yes, buy it!');
INSERT INTO `site_lang` VALUES ('201', '18', 'more daily conversation, cost ');
INSERT INTO `site_lang` VALUES ('200', '18', 'Expand daily limitation ');
INSERT INTO `site_lang` VALUES ('199', '18', 'You dont have enought credits for send the gift');
INSERT INTO `site_lang` VALUES ('198', '18', 'Please, select 1 gift');
INSERT INTO `site_lang` VALUES ('197', '18', 'Please, select 1 photo');
INSERT INTO `site_lang` VALUES ('196', '18', 'Please, select a payment method');
INSERT INTO `site_lang` VALUES ('195', '18', 'No thanks');
INSERT INTO `site_lang` VALUES ('194', '18', 'Get access');
INSERT INTO `site_lang` VALUES ('193', '18', 'private photos for ');
INSERT INTO `site_lang` VALUES ('192', '18', 'Get access to');
INSERT INTO `site_lang` VALUES ('191', '18', 'Buy private photos permission');
INSERT INTO `site_lang` VALUES ('190', '18', 'No, i cant show you my private photos');
INSERT INTO `site_lang` VALUES ('189', '18', 'Yes, you can see my private photos');
INSERT INTO `site_lang` VALUES ('188', '18', 'Email already exist, try another');
INSERT INTO `site_lang` VALUES ('187', '18', 'Password too short');
INSERT INTO `site_lang` VALUES ('186', '18', 'Choose city from the autocomplete');
INSERT INTO `site_lang` VALUES ('185', '18', 'Add a valid date');
INSERT INTO `site_lang` VALUES ('184', '18', 'Wrong password');
INSERT INTO `site_lang` VALUES ('183', '18', 'Email dont exist');
INSERT INTO `site_lang` VALUES ('182', '18', 'Please fill all the inputs');
INSERT INTO `site_lang` VALUES ('181', '18', 'Invalid email format');
INSERT INTO `site_lang` VALUES ('180', '18', 'Password recover');
INSERT INTO `site_lang` VALUES ('179', '18', 'Login to my account');
INSERT INTO `site_lang` VALUES ('177', '18', 'Hi');
INSERT INTO `site_lang` VALUES ('178', '18', 'If you dont remember your password, click the link below to set a new one:');
INSERT INTO `site_lang` VALUES ('176', '18', 'No');
INSERT INTO `site_lang` VALUES ('175', '18', 'Yes');
INSERT INTO `site_lang` VALUES ('173', '18', 'like this');
INSERT INTO `site_lang` VALUES ('174', '18', 'Hello, can i have access to your private photos ?');
INSERT INTO `site_lang` VALUES ('171', '18', 'Days Premium');
INSERT INTO `site_lang` VALUES ('172', '18', 'persons more like this');
INSERT INTO `site_lang` VALUES ('167', '18', 'October');
INSERT INTO `site_lang` VALUES ('168', '18', 'November');
INSERT INTO `site_lang` VALUES ('169', '18', 'December');
INSERT INTO `site_lang` VALUES ('170', '18', 'Buy');
INSERT INTO `site_lang` VALUES ('166', '18', 'September');
INSERT INTO `site_lang` VALUES ('163', '18', 'June');
INSERT INTO `site_lang` VALUES ('164', '18', 'July');
INSERT INTO `site_lang` VALUES ('165', '18', 'August');
INSERT INTO `site_lang` VALUES ('160', '18', 'March');
INSERT INTO `site_lang` VALUES ('161', '18', 'April');
INSERT INTO `site_lang` VALUES ('162', '18', 'May');
INSERT INTO `site_lang` VALUES ('159', '18', 'February');
INSERT INTO `site_lang` VALUES ('157', '18', 'You dont have matches yet');
INSERT INTO `site_lang` VALUES ('158', '18', 'January');
INSERT INTO `site_lang` VALUES ('156', '18', 'You dont have any fans yet');
INSERT INTO `site_lang` VALUES ('154', '18', 'people found');
INSERT INTO `site_lang` VALUES ('155', '18', 'No popular users near you');
INSERT INTO `site_lang` VALUES ('151', '18', 'Online now');
INSERT INTO `site_lang` VALUES ('152', '18', 'Verified');
INSERT INTO `site_lang` VALUES ('153', '18', 'Nothing found');
INSERT INTO `site_lang` VALUES ('150', '18', 'Delete profile');
INSERT INTO `site_lang` VALUES ('149', '18', 'After delete your profile, some of your data will be lost without recovery.');
INSERT INTO `site_lang` VALUES ('147', '18', 'New password');
INSERT INTO `site_lang` VALUES ('148', '18', 'Profile desactivation');
INSERT INTO `site_lang` VALUES ('146', '18', 'You can change your current password bellow');
INSERT INTO `site_lang` VALUES ('145', '18', 'Change password');
INSERT INTO `site_lang` VALUES ('144', '18', 'Upgrade to premium account');
INSERT INTO `site_lang` VALUES ('142', '18', 'Current credits');
INSERT INTO `site_lang` VALUES ('143', '18', 'Add credits');
INSERT INTO `site_lang` VALUES ('141', '18', 'Account type');
INSERT INTO `site_lang` VALUES ('140', '18', 'Buy credits for send Gifs and Unblock private photos');
INSERT INTO `site_lang` VALUES ('139', '18', 'You are account is already verified');
INSERT INTO `site_lang` VALUES ('138', '18', 'Connect with Facebook');
INSERT INTO `site_lang` VALUES ('137', '18', 'For verify your account , connect with your facebook account');
INSERT INTO `site_lang` VALUES ('136', '18', 'Verify account');
INSERT INTO `site_lang` VALUES ('135', '18', 'Update profile');
INSERT INTO `site_lang` VALUES ('134', '18', 'Site language');
INSERT INTO `site_lang` VALUES ('133', '18', 'You can edit your profile information bellow');
INSERT INTO `site_lang` VALUES ('132', '18', 'Personal information');
INSERT INTO `site_lang` VALUES ('131', '18', 'Delete');
INSERT INTO `site_lang` VALUES ('130', '18', 'Change password');
INSERT INTO `site_lang` VALUES ('129', '18', 'Verify');
INSERT INTO `site_lang` VALUES ('128', '18', 'Credits');
INSERT INTO `site_lang` VALUES ('127', '18', 'Personal');
INSERT INTO `site_lang` VALUES ('126', '18', 'Unblock private photos');
INSERT INTO `site_lang` VALUES ('125', '18', 'Ask permission to');
INSERT INTO `site_lang` VALUES ('124', '18', 'Now you have');
INSERT INTO `site_lang` VALUES ('123', '18', 'Credits successfully added to your account');
INSERT INTO `site_lang` VALUES ('122', '18', 'boys and girls');
INSERT INTO `site_lang` VALUES ('121', '18', 'Only girls');
INSERT INTO `site_lang` VALUES ('120', '18', 'Only boys');
INSERT INTO `site_lang` VALUES ('119', '18', 'years old');
INSERT INTO `site_lang` VALUES ('118', '18', 'Personal info');
INSERT INTO `site_lang` VALUES ('117', '18', 'About ');
INSERT INTO `site_lang` VALUES ('116', '18', 'Most popular users');
INSERT INTO `site_lang` VALUES ('115', '18', 'World');
INSERT INTO `site_lang` VALUES ('114', '18', 'in a radius of');
INSERT INTO `site_lang` VALUES ('112', '18', 'Both');
INSERT INTO `site_lang` VALUES ('113', '18', 'who are between');
INSERT INTO `site_lang` VALUES ('111', '18', 'Boys');
INSERT INTO `site_lang` VALUES ('110', '18', 'Girls');
INSERT INTO `site_lang` VALUES ('109', '18', 'Show me');
INSERT INTO `site_lang` VALUES ('108', '18', 'Online now');
INSERT INTO `site_lang` VALUES ('107', '18', 'All users');
INSERT INTO `site_lang` VALUES ('104', '18', 'Please complete your profile before start in ');
INSERT INTO `site_lang` VALUES ('105', '18', 'Your matches');
INSERT INTO `site_lang` VALUES ('106', '18', 'Filter Search');
INSERT INTO `site_lang` VALUES ('103', '18', 'Terms of Use');
INSERT INTO `site_lang` VALUES ('101', '18', 'Your fans');
INSERT INTO `site_lang` VALUES ('102', '18', 'Privacy Policy');
INSERT INTO `site_lang` VALUES ('98', '18', 'and get up to');
INSERT INTO `site_lang` VALUES ('100', '18', 'or wait until tomorrow for continue meeting people');
INSERT INTO `site_lang` VALUES ('99', '18', 'daily conversations');
INSERT INTO `site_lang` VALUES ('94', '18', 'Buy');
INSERT INTO `site_lang` VALUES ('95', '18', 'more daily conversation');
INSERT INTO `site_lang` VALUES ('96', '18', 'or');
INSERT INTO `site_lang` VALUES ('97', '18', 'Upgrade your account to Premium');
INSERT INTO `site_lang` VALUES ('93', '18', 'To continue chatting');
INSERT INTO `site_lang` VALUES ('92', '18', 'you have reached the limit of new daily conversations');
INSERT INTO `site_lang` VALUES ('91', '18', 'Chat');
INSERT INTO `site_lang` VALUES ('90', '18', 'Send');
INSERT INTO `site_lang` VALUES ('89', '18', 'Write text here');
INSERT INTO `site_lang` VALUES ('88', '18', 'Premium user badge');
INSERT INTO `site_lang` VALUES ('87', '18', 'Unblock all private photos');
INSERT INTO `site_lang` VALUES ('86', '18', 'Unlimited videocalls');
INSERT INTO `site_lang` VALUES ('85', '18', 'new chats per day');
INSERT INTO `site_lang` VALUES ('84', '18', 'Premium Account Features');
INSERT INTO `site_lang` VALUES ('83', '18', 'Buy credits');
INSERT INTO `site_lang` VALUES ('82', '18', 'Pay with');
INSERT INTO `site_lang` VALUES ('81', '18', 'Pay with');
INSERT INTO `site_lang` VALUES ('79', '18', 'Select credits package');
INSERT INTO `site_lang` VALUES ('80', '18', 'Select payment method');
INSERT INTO `site_lang` VALUES ('78', '18', 'Buy credits / Upgrade account');
INSERT INTO `site_lang` VALUES ('77', '18', 'Send gift');
INSERT INTO `site_lang` VALUES ('76', '18', 'Pick the gift you want to send to ');
INSERT INTO `site_lang` VALUES ('75', '18', 'Send gift to ');
INSERT INTO `site_lang` VALUES ('74', '18', 'Add photo');
INSERT INTO `site_lang` VALUES ('73', '18', 'Credits');
INSERT INTO `site_lang` VALUES ('72', '18', 'Pick the photo you want to show in the Spotlight, cost ');
INSERT INTO `site_lang` VALUES ('71', '18', 'Add yourself to the Spotlight');
INSERT INTO `site_lang` VALUES ('70', '18', 'add photos');
INSERT INTO `site_lang` VALUES ('69', '18', 'Add your photos');
INSERT INTO `site_lang` VALUES ('68', '18', 'Private Photos');
INSERT INTO `site_lang` VALUES ('67', '18', 'Public Photos');
INSERT INTO `site_lang` VALUES ('63', '18', 'Privacy');
INSERT INTO `site_lang` VALUES ('64', '18', 'Contact');
INSERT INTO `site_lang` VALUES ('65', '18', 'Manage your photos');
INSERT INTO `site_lang` VALUES ('66', '18', 'All Photos');
INSERT INTO `site_lang` VALUES ('62', '18', 'Terms');
INSERT INTO `site_lang` VALUES ('61', '18', 'Who to like');
INSERT INTO `site_lang` VALUES ('60', '18', 'New messages');
INSERT INTO `site_lang` VALUES ('57', '18', 'Fans');
INSERT INTO `site_lang` VALUES ('58', '18', 'Conversations');
INSERT INTO `site_lang` VALUES ('59', '18', 'Online now');
INSERT INTO `site_lang` VALUES ('56', '18', 'All');
INSERT INTO `site_lang` VALUES ('53', '18', 'Fans');
INSERT INTO `site_lang` VALUES ('54', '18', 'Manage photos');
INSERT INTO `site_lang` VALUES ('55', '18', 'Settings');
INSERT INTO `site_lang` VALUES ('52', '18', 'Most populars');
INSERT INTO `site_lang` VALUES ('51', '18', 'Matches');
INSERT INTO `site_lang` VALUES ('50', '18', 'Discover');
INSERT INTO `site_lang` VALUES ('49', '18', 'Meet new people');
INSERT INTO `site_lang` VALUES ('46', '18', 'Profile');
INSERT INTO `site_lang` VALUES ('47', '18', 'Settings');
INSERT INTO `site_lang` VALUES ('48', '18', 'Logout');
INSERT INTO `site_lang` VALUES ('45', '18', 'Privacy Policy');
INSERT INTO `site_lang` VALUES ('44', '18', 'and');
INSERT INTO `site_lang` VALUES ('43', '18', 'Terms and Conditions');
INSERT INTO `site_lang` VALUES ('42', '18', 'By continuing, you are confirming that you have read and agree to our');
INSERT INTO `site_lang` VALUES ('41', '18', 'Sign up');
INSERT INTO `site_lang` VALUES ('40', '18', 'Meet boys and girls');
INSERT INTO `site_lang` VALUES ('39', '18', 'Meet boys');
INSERT INTO `site_lang` VALUES ('38', '18', 'Meet girls');
INSERT INTO `site_lang` VALUES ('37', '18', 'Im here to');
INSERT INTO `site_lang` VALUES ('36', '18', 'Female');
INSERT INTO `site_lang` VALUES ('34', '18', 'Gender');
INSERT INTO `site_lang` VALUES ('35', '18', 'Male');
INSERT INTO `site_lang` VALUES ('33', '18', 'Where do you live?');
INSERT INTO `site_lang` VALUES ('31', '18', 'Please select');
INSERT INTO `site_lang` VALUES ('32', '18', 'City');
INSERT INTO `site_lang` VALUES ('30', '18', 'Birthday');
INSERT INTO `site_lang` VALUES ('29', '18', 'Password');
INSERT INTO `site_lang` VALUES ('28', '18', 'Email');
INSERT INTO `site_lang` VALUES ('26', '18', 'Name');
INSERT INTO `site_lang` VALUES ('27', '18', 'Your name or nickname');
INSERT INTO `site_lang` VALUES ('25', '18', 'Join the worlds bestest community for meeting new people!.');
INSERT INTO `site_lang` VALUES ('24', '18', 'Become a member now');
INSERT INTO `site_lang` VALUES ('23', '18', 'Play our popular Discover game and get matched with other users. Its a great way to break the ice and chat to new people.');
INSERT INTO `site_lang` VALUES ('22', '18', 'Matches');
INSERT INTO `site_lang` VALUES ('21', '18', 'We wont show your exact location, but you will be able to find people nearby who like the same things you do.');
INSERT INTO `site_lang` VALUES ('20', '18', 'People nearby');
INSERT INTO `site_lang` VALUES ('19', '18', 'You can make quality videocalls for free to anyone, without limits of call duration, just enjoy seeing the person who is chatting with you');
INSERT INTO `site_lang` VALUES ('18', '18', 'Video Chat');
INSERT INTO `site_lang` VALUES ('17', '18', 'Powerfull private chat for meet new friends, you can send emoticons and private photos to anyone.');
INSERT INTO `site_lang` VALUES ('16', '18', 'Chat');
INSERT INTO `site_lang` VALUES ('15', '18', 'Recover password');
INSERT INTO `site_lang` VALUES ('14', '18', 'Password recover');
INSERT INTO `site_lang` VALUES ('13', '18', 'Login now');
INSERT INTO `site_lang` VALUES ('12', '18', 'do you forget your password?');
INSERT INTO `site_lang` VALUES ('11', '18', 'Your password');
INSERT INTO `site_lang` VALUES ('10', '18', 'Your email');
INSERT INTO `site_lang` VALUES ('9', '18', 'Welcome back');
INSERT INTO `site_lang` VALUES ('8', '18', 'Create your account');
INSERT INTO `site_lang` VALUES ('7', '18', 'Connect with ');
INSERT INTO `site_lang` VALUES ('6', '18', 'SOON AVAILABLE');
INSERT INTO `site_lang` VALUES ('5', '18', 'Soon we will have our phone apps online');
INSERT INTO `site_lang` VALUES ('4', '18', 'Please visit us from your laptop or PC');
INSERT INTO `site_lang` VALUES ('3', '18', 'For now our site works only for Desktop users');
INSERT INTO `site_lang` VALUES ('0', '18', 'meet new people!');
INSERT INTO `site_lang` VALUES ('1', '18', 'Login');
INSERT INTO `site_lang` VALUES ('2', '18', 'Welcome to the fastest growing place to meet new people');
INSERT INTO `site_lang` VALUES ('381', '17', 'calling...');
INSERT INTO `site_lang` VALUES ('382', '17', 'dont like you');
INSERT INTO `site_lang` VALUES ('383', '17', 'must like you for start a videocall');
INSERT INTO `site_lang` VALUES ('384', '17', 'Ok, i understand');
INSERT INTO `site_lang` VALUES ('384', '16', 'Ok, i understand');
INSERT INTO `site_lang` VALUES ('380', '16', 'Welcome to');
INSERT INTO `site_lang` VALUES ('381', '16', 'calling...');
INSERT INTO `site_lang` VALUES ('382', '16', 'dont like you');
INSERT INTO `site_lang` VALUES ('383', '16', 'must like you for start a videocall');
INSERT INTO `site_lang` VALUES ('379', '16', 'Go to');
INSERT INTO `site_lang` VALUES ('375', '16', 'Here are your connection details');
INSERT INTO `site_lang` VALUES ('376', '16', 'E-mail');
INSERT INTO `site_lang` VALUES ('377', '16', 'Password');
INSERT INTO `site_lang` VALUES ('378', '16', 'Please save your connection information in a safe place');
INSERT INTO `site_lang` VALUES ('374', '16', 'Start meeting new people now');
INSERT INTO `site_lang` VALUES ('373', '16', 'More than 1 million people have joined $site_name You probably want to know some of them.');
INSERT INTO `site_lang` VALUES ('372', '16', 'Add photos and complete your profile');
INSERT INTO `site_lang` VALUES ('371', '16', 'Nobody is going to fall in love with a blank page. The more information you get, the more chances to find that special someone!');
INSERT INTO `site_lang` VALUES ('370', '16', 'Meet new people');
INSERT INTO `site_lang` VALUES ('369', '16', 'you can meet people instantly');
INSERT INTO `site_lang` VALUES ('368', '16', 'In');
INSERT INTO `site_lang` VALUES ('367', '16', 'people in your area wants to know you');
INSERT INTO `site_lang` VALUES ('365', '16', 'Verify your account');
INSERT INTO `site_lang` VALUES ('366', '16', 'Newsflash');
INSERT INTO `site_lang` VALUES ('364', '16', 'Now you are a new member of');
INSERT INTO `site_lang` VALUES ('363', '16', 'Here are a few tips');
INSERT INTO `site_lang` VALUES ('361', '16', 'Welcome');
INSERT INTO `site_lang` VALUES ('362', '16', 'Well done, now you are in');
INSERT INTO `site_lang` VALUES ('360', '16', 'Check out the profile');
INSERT INTO `site_lang` VALUES ('359', '16', 'and lives closer to you');
INSERT INTO `site_lang` VALUES ('358', '16', 'is new at');
INSERT INTO `site_lang` VALUES ('357', '16', 'is new and lives closer to you');
INSERT INTO `site_lang` VALUES ('356', '16', 'Have fun!');
INSERT INTO `site_lang` VALUES ('355', '16', 'Respond to');
INSERT INTO `site_lang` VALUES ('354', '16', 'you have a new message from');
INSERT INTO `site_lang` VALUES ('353', '16', 'New message from');
INSERT INTO `site_lang` VALUES ('352', '16', 'Go and say something to');
INSERT INTO `site_lang` VALUES ('350', '16', 'Its a match!');
INSERT INTO `site_lang` VALUES ('351', '16', 'thinks the feeling is mutual');
INSERT INTO `site_lang` VALUES ('349', '16', 'You have a match at');
INSERT INTO `site_lang` VALUES ('348', '16', 'if you forgot your password, click on the link below to get a new');
INSERT INTO `site_lang` VALUES ('347', '16', 'Choose a new password');
INSERT INTO `site_lang` VALUES ('346', '16', 'Unsubscribe');
INSERT INTO `site_lang` VALUES ('344', '16', 'Find out if you also like');
INSERT INTO `site_lang` VALUES ('345', '16', 'You received this notice because you registered as');
INSERT INTO `site_lang` VALUES ('343', '16', 'has seen you in discover and likes. The feeling is mutual?');
INSERT INTO `site_lang` VALUES ('342', '16', 'likes you and wants to chat in');
INSERT INTO `site_lang` VALUES ('341', '16', 'We sent you a email with your info, it may take up to 1 min to arrive');
INSERT INTO `site_lang` VALUES ('340', '16', 'Loading...');
INSERT INTO `site_lang` VALUES ('339', '16', 'of');
INSERT INTO `site_lang` VALUES ('338', '16', 'Photos of ');
INSERT INTO `site_lang` VALUES ('337', '16', 'is calling you..');
INSERT INTO `site_lang` VALUES ('336', '16', 'Password successfully changed');
INSERT INTO `site_lang` VALUES ('335', '16', 'Service cost');
INSERT INTO `site_lang` VALUES ('334', '16', 'Spotlight');
INSERT INTO `site_lang` VALUES ('333', '16', 'Wrong');
INSERT INTO `site_lang` VALUES ('332', '16', 'days of Premium');
INSERT INTO `site_lang` VALUES ('331', '16', 'username');
INSERT INTO `site_lang` VALUES ('330', '16', 'You need to write your username!');
INSERT INTO `site_lang` VALUES ('329', '16', 'Write your instagram username');
INSERT INTO `site_lang` VALUES ('328', '16', 'Press backspace key for smart return to the meeting section.');
INSERT INTO `site_lang` VALUES ('326', '16', 'Report and block');
INSERT INTO `site_lang` VALUES ('327', '16', 'Are you sure you want to report');
INSERT INTO `site_lang` VALUES ('325', '16', 'is blocking you or you blocked him, you cant chat with him sorry');
INSERT INTO `site_lang` VALUES ('324', '16', 'We sended you a email for verify your account');
INSERT INTO `site_lang` VALUES ('323', '16', 'years old and im from');
INSERT INTO `site_lang` VALUES ('318', '16', 'seconds');
INSERT INTO `site_lang` VALUES ('319', '16', 'ago');
INSERT INTO `site_lang` VALUES ('320', '16', 'Please verify your account, check your email');
INSERT INTO `site_lang` VALUES ('321', '16', 'Please add a profile photo');
INSERT INTO `site_lang` VALUES ('322', '16', 'Hi, im');
INSERT INTO `site_lang` VALUES ('317', '16', 'minutes');
INSERT INTO `site_lang` VALUES ('316', '16', 'hours');
INSERT INTO `site_lang` VALUES ('315', '16', 'days');
INSERT INTO `site_lang` VALUES ('314', '16', 'months');
INSERT INTO `site_lang` VALUES ('313', '16', 'years');
INSERT INTO `site_lang` VALUES ('306', '16', '0 seconds');
INSERT INTO `site_lang` VALUES ('307', '16', 'year');
INSERT INTO `site_lang` VALUES ('308', '16', 'month');
INSERT INTO `site_lang` VALUES ('309', '16', 'day');
INSERT INTO `site_lang` VALUES ('310', '16', 'hour');
INSERT INTO `site_lang` VALUES ('311', '16', 'minute');
INSERT INTO `site_lang` VALUES ('312', '16', 'second');
INSERT INTO `site_lang` VALUES ('301', '16', 'You dont have any visit yet');
INSERT INTO `site_lang` VALUES ('305', '16', 'Credits for $');
INSERT INTO `site_lang` VALUES ('304', '16', 'Cost');
INSERT INTO `site_lang` VALUES ('303', '16', 'You do not like anyone');
INSERT INTO `site_lang` VALUES ('302', '16', 'visited');
INSERT INTO `site_lang` VALUES ('300', '16', 'AGE');
INSERT INTO `site_lang` VALUES ('299', '16', 'Dislike');
INSERT INTO `site_lang` VALUES ('298', '16', 'Like');
INSERT INTO `site_lang` VALUES ('296', '16', 'people liked you, for see them');
INSERT INTO `site_lang` VALUES ('297', '16', 'Messages');
INSERT INTO `site_lang` VALUES ('295', '16', 'People i like');
INSERT INTO `site_lang` VALUES ('294', '16', 'Upgrade your account to premium');
INSERT INTO `site_lang` VALUES ('293', '16', 'people visited your profile for see them');
INSERT INTO `site_lang` VALUES ('292', '16', 'Delete');
INSERT INTO `site_lang` VALUES ('291', '16', 'Public photo');
INSERT INTO `site_lang` VALUES ('290', '16', 'Private photo');
INSERT INTO `site_lang` VALUES ('289', '16', 'Set as profile');
INSERT INTO `site_lang` VALUES ('288', '16', 'get seen by millions');
INSERT INTO `site_lang` VALUES ('287', '16', 'Add me here');
INSERT INTO `site_lang` VALUES ('286', '16', 'Visits');
INSERT INTO `site_lang` VALUES ('285', '16', 'Credits');
INSERT INTO `site_lang` VALUES ('284', '16', 'Photos');
INSERT INTO `site_lang` VALUES ('283', '16', 'Add');
INSERT INTO `site_lang` VALUES ('282', '16', 'Add from ');
INSERT INTO `site_lang` VALUES ('281', '16', 'Private photos');
INSERT INTO `site_lang` VALUES ('280', '16', 'Public Photos');
INSERT INTO `site_lang` VALUES ('279', '16', 'No data');
INSERT INTO `site_lang` VALUES ('278', '16', 'Fans');
INSERT INTO `site_lang` VALUES ('277', '16', 'Report');
INSERT INTO `site_lang` VALUES ('276', '16', 'Interests');
INSERT INTO `site_lang` VALUES ('275', '16', 'Please wait');
INSERT INTO `site_lang` VALUES ('274', '16', 'Year');
INSERT INTO `site_lang` VALUES ('273', '16', 'Month');
INSERT INTO `site_lang` VALUES ('272', '16', 'Day');
INSERT INTO `site_lang` VALUES ('271', '16', 'When someone send me a message');
INSERT INTO `site_lang` VALUES ('270', '16', 'When new users near me join in');
INSERT INTO `site_lang` VALUES ('269', '16', 'When i get a match');
INSERT INTO `site_lang` VALUES ('268', '16', 'When someone likes me');
INSERT INTO `site_lang` VALUES ('267', '16', 'None');
INSERT INTO `site_lang` VALUES ('266', '16', 'I own a motorbike');
INSERT INTO `site_lang` VALUES ('265', '16', 'I own a car');
INSERT INTO `site_lang` VALUES ('264', '16', 'Parents car');
INSERT INTO `site_lang` VALUES ('263', '16', 'Transport');
INSERT INTO `site_lang` VALUES ('262', '16', 'Drink');
INSERT INTO `site_lang` VALUES ('261', '16', 'Sometimes');
INSERT INTO `site_lang` VALUES ('260', '16', 'No');
INSERT INTO `site_lang` VALUES ('259', '16', 'Yes');
INSERT INTO `site_lang` VALUES ('258', '16', 'Smoke');
INSERT INTO `site_lang` VALUES ('257', '16', 'Alone');
INSERT INTO `site_lang` VALUES ('256', '16', 'With partner');
INSERT INTO `site_lang` VALUES ('255', '16', 'Student dormitory');
INSERT INTO `site_lang` VALUES ('254', '16', 'With housemate');
INSERT INTO `site_lang` VALUES ('253', '16', 'With parents');
INSERT INTO `site_lang` VALUES ('252', '16', 'Living');
INSERT INTO `site_lang` VALUES ('251', '16', 'Curvy');
INSERT INTO `site_lang` VALUES ('250', '16', 'Heavy set');
INSERT INTO `site_lang` VALUES ('249', '16', 'Athletic');
INSERT INTO `site_lang` VALUES ('248', '16', 'Average');
INSERT INTO `site_lang` VALUES ('243', '16', 'Pacific Islander');
INSERT INTO `site_lang` VALUES ('244', '16', 'Indian');
INSERT INTO `site_lang` VALUES ('245', '16', 'Other');
INSERT INTO `site_lang` VALUES ('246', '16', 'Body type');
INSERT INTO `site_lang` VALUES ('247', '16', 'Slim');
INSERT INTO `site_lang` VALUES ('241', '16', 'Native American');
INSERT INTO `site_lang` VALUES ('242', '16', 'Hispanic/latin');
INSERT INTO `site_lang` VALUES ('239', '16', 'Black');
INSERT INTO `site_lang` VALUES ('240', '16', 'White');
INSERT INTO `site_lang` VALUES ('237', '16', 'Asian');
INSERT INTO `site_lang` VALUES ('238', '16', 'Middle Eastern');
INSERT INTO `site_lang` VALUES ('233', '16', 'less than');
INSERT INTO `site_lang` VALUES ('234', '16', 'more than');
INSERT INTO `site_lang` VALUES ('235', '16', 'Weight');
INSERT INTO `site_lang` VALUES ('236', '16', 'Ethnicity');
INSERT INTO `site_lang` VALUES ('232', '16', 'Height');
INSERT INTO `site_lang` VALUES ('230', '16', 'Straight');
INSERT INTO `site_lang` VALUES ('231', '16', 'Bisexual');
INSERT INTO `site_lang` VALUES ('228', '16', 'Gay');
INSERT INTO `site_lang` VALUES ('229', '16', 'Open-minded');
INSERT INTO `site_lang` VALUES ('227', '16', 'Sexuality');
INSERT INTO `site_lang` VALUES ('225', '16', 'Taken');
INSERT INTO `site_lang` VALUES ('226', '16', 'Open');
INSERT INTO `site_lang` VALUES ('224', '16', 'Single');
INSERT INTO `site_lang` VALUES ('223', '16', 'Relationship');
INSERT INTO `site_lang` VALUES ('222', '16', 'Extended info (optional)');
INSERT INTO `site_lang` VALUES ('221', '16', 'Notifications');
INSERT INTO `site_lang` VALUES ('219', '16', 'Basic');
INSERT INTO `site_lang` VALUES ('220', '16', 'UPGRADE');
INSERT INTO `site_lang` VALUES ('217', '16', 'Wait more');
INSERT INTO `site_lang` VALUES ('218', '16', 'until');
INSERT INTO `site_lang` VALUES ('216', '16', 'End call');
INSERT INTO `site_lang` VALUES ('215', '16', 'Seems that your friend do not have webcam or he is not available');
INSERT INTO `site_lang` VALUES ('214', '16', 'Too long wait');
INSERT INTO `site_lang` VALUES ('213', '16', 'You cant make videocall because you dont have webcam');
INSERT INTO `site_lang` VALUES ('212', '16', 'Impossible to make a call!');
INSERT INTO `site_lang` VALUES ('211', '16', 'Only premium users can make videocalls');
INSERT INTO `site_lang` VALUES ('210', '16', 'You are already in a videocall, you have to end the other call before start another');
INSERT INTO `site_lang` VALUES ('209', '16', 'Please allow access to your Webcam.');
INSERT INTO `site_lang` VALUES ('208', '16', 'is offline, try again when your friend is online');
INSERT INTO `site_lang` VALUES ('207', '16', 'is in another videocall , you cant call now');
INSERT INTO `site_lang` VALUES ('206', '16', 'Yes, delete it!');
INSERT INTO `site_lang` VALUES ('205', '16', 'Your data will be lost without recovery, continue?');
INSERT INTO `site_lang` VALUES ('204', '16', 'Account termination');
INSERT INTO `site_lang` VALUES ('202', '16', 'Yes, buy it!');
INSERT INTO `site_lang` VALUES ('203', '16', 'Information updated successfully');
INSERT INTO `site_lang` VALUES ('201', '16', 'more daily conversation, cost ');
INSERT INTO `site_lang` VALUES ('200', '16', 'Expand daily limitation ');
INSERT INTO `site_lang` VALUES ('199', '16', 'You dont have enought credits for send the gift');
INSERT INTO `site_lang` VALUES ('198', '16', 'Please, select 1 gift');
INSERT INTO `site_lang` VALUES ('197', '16', 'Please, select 1 photo');
INSERT INTO `site_lang` VALUES ('196', '16', 'Please, select a payment method');
INSERT INTO `site_lang` VALUES ('195', '16', 'No thanks');
INSERT INTO `site_lang` VALUES ('194', '16', 'Get access');
INSERT INTO `site_lang` VALUES ('193', '16', 'private photos for ');
INSERT INTO `site_lang` VALUES ('192', '16', 'Get access to');
INSERT INTO `site_lang` VALUES ('191', '16', 'Buy private photos permission');
INSERT INTO `site_lang` VALUES ('190', '16', 'No, i cant show you my private photos');
INSERT INTO `site_lang` VALUES ('189', '16', 'Yes, you can see my private photos');
INSERT INTO `site_lang` VALUES ('187', '16', 'Password too short');
INSERT INTO `site_lang` VALUES ('188', '16', 'Email already exist, try another');
INSERT INTO `site_lang` VALUES ('186', '16', 'Choose city from the autocomplete');
INSERT INTO `site_lang` VALUES ('185', '16', 'Add a valid date');
INSERT INTO `site_lang` VALUES ('184', '16', 'Wrong password');
INSERT INTO `site_lang` VALUES ('183', '16', 'Email dont exist');
INSERT INTO `site_lang` VALUES ('182', '16', 'Please fill all the inputs');
INSERT INTO `site_lang` VALUES ('179', '16', 'Login to my account');
INSERT INTO `site_lang` VALUES ('180', '16', 'Password recover');
INSERT INTO `site_lang` VALUES ('181', '16', 'Invalid email format');
INSERT INTO `site_lang` VALUES ('172', '16', 'persons more like this');
INSERT INTO `site_lang` VALUES ('178', '16', 'If you dont remember your password, click the link below to set a new one:');
INSERT INTO `site_lang` VALUES ('177', '16', 'Hi');
INSERT INTO `site_lang` VALUES ('176', '16', 'No');
INSERT INTO `site_lang` VALUES ('175', '16', 'Yes');
INSERT INTO `site_lang` VALUES ('174', '16', 'Hello, can i have access to your private photos ?');
INSERT INTO `site_lang` VALUES ('173', '16', 'like this');
INSERT INTO `site_lang` VALUES ('170', '16', 'Buy');
INSERT INTO `site_lang` VALUES ('171', '16', 'Days Premium');
INSERT INTO `site_lang` VALUES ('169', '16', 'December');
INSERT INTO `site_lang` VALUES ('168', '16', 'November');
INSERT INTO `site_lang` VALUES ('167', '16', 'October');
INSERT INTO `site_lang` VALUES ('165', '16', 'August');
INSERT INTO `site_lang` VALUES ('166', '16', 'September');
INSERT INTO `site_lang` VALUES ('164', '16', 'July');
INSERT INTO `site_lang` VALUES ('162', '16', 'May');
INSERT INTO `site_lang` VALUES ('163', '16', 'June');
INSERT INTO `site_lang` VALUES ('161', '16', 'April');
INSERT INTO `site_lang` VALUES ('160', '16', 'March');
INSERT INTO `site_lang` VALUES ('158', '16', 'January');
INSERT INTO `site_lang` VALUES ('159', '16', 'February');
INSERT INTO `site_lang` VALUES ('157', '16', 'You dont have matches yet');
INSERT INTO `site_lang` VALUES ('156', '16', 'You dont have any fans yet');
INSERT INTO `site_lang` VALUES ('155', '16', 'No popular users near you');
INSERT INTO `site_lang` VALUES ('154', '16', 'people found');
INSERT INTO `site_lang` VALUES ('153', '16', 'Nothing found');
INSERT INTO `site_lang` VALUES ('152', '16', 'Verified');
INSERT INTO `site_lang` VALUES ('151', '16', 'Online now');
INSERT INTO `site_lang` VALUES ('150', '16', 'Delete profile');
INSERT INTO `site_lang` VALUES ('149', '16', 'After delete your profile, some of your data will be lost without recovery.');
INSERT INTO `site_lang` VALUES ('148', '16', 'Profile desactivation');
INSERT INTO `site_lang` VALUES ('147', '16', 'New password');
INSERT INTO `site_lang` VALUES ('146', '16', 'You can change your current password bellow');
INSERT INTO `site_lang` VALUES ('145', '16', 'Change password');
INSERT INTO `site_lang` VALUES ('144', '16', 'Upgrade to premium account');
INSERT INTO `site_lang` VALUES ('143', '16', 'Add credits');
INSERT INTO `site_lang` VALUES ('142', '16', 'Current credits');
INSERT INTO `site_lang` VALUES ('141', '16', 'Account type');
INSERT INTO `site_lang` VALUES ('138', '16', 'Connect with Facebook');
INSERT INTO `site_lang` VALUES ('139', '16', 'You are account is already verified');
INSERT INTO `site_lang` VALUES ('140', '16', 'Buy credits for send Gifs and Unblock private photos');
INSERT INTO `site_lang` VALUES ('137', '16', 'For verify your account , connect with your facebook account');
INSERT INTO `site_lang` VALUES ('136', '16', 'Verify account');
INSERT INTO `site_lang` VALUES ('134', '16', 'Site language');
INSERT INTO `site_lang` VALUES ('135', '16', 'Update profile');
INSERT INTO `site_lang` VALUES ('133', '16', 'You can edit your profile information bellow');
INSERT INTO `site_lang` VALUES ('132', '16', 'Personal information');
INSERT INTO `site_lang` VALUES ('131', '16', 'Delete');
INSERT INTO `site_lang` VALUES ('130', '16', 'Change password');
INSERT INTO `site_lang` VALUES ('129', '16', 'Verify');
INSERT INTO `site_lang` VALUES ('128', '16', 'Credits');
INSERT INTO `site_lang` VALUES ('126', '16', 'Unblock private photos');
INSERT INTO `site_lang` VALUES ('127', '16', 'Personal');
INSERT INTO `site_lang` VALUES ('125', '16', 'Ask permission to');
INSERT INTO `site_lang` VALUES ('124', '16', 'Now you have');
INSERT INTO `site_lang` VALUES ('123', '16', 'Credits successfully added to your account');
INSERT INTO `site_lang` VALUES ('122', '16', 'boys and girls');
INSERT INTO `site_lang` VALUES ('121', '16', 'Only girls');
INSERT INTO `site_lang` VALUES ('120', '16', 'Only boys');
INSERT INTO `site_lang` VALUES ('119', '16', 'years old');
INSERT INTO `site_lang` VALUES ('117', '16', 'About ');
INSERT INTO `site_lang` VALUES ('118', '16', 'Personal info');
INSERT INTO `site_lang` VALUES ('116', '16', 'Most popular users');
INSERT INTO `site_lang` VALUES ('115', '16', 'World');
INSERT INTO `site_lang` VALUES ('113', '16', 'who are between');
INSERT INTO `site_lang` VALUES ('114', '16', 'in a radius of');
INSERT INTO `site_lang` VALUES ('112', '16', 'Both');
INSERT INTO `site_lang` VALUES ('110', '16', 'Girls');
INSERT INTO `site_lang` VALUES ('111', '16', 'Boys');
INSERT INTO `site_lang` VALUES ('109', '16', 'Show me');
INSERT INTO `site_lang` VALUES ('108', '16', 'Online now');
INSERT INTO `site_lang` VALUES ('107', '16', 'All users');
INSERT INTO `site_lang` VALUES ('106', '16', 'Filter Search');
INSERT INTO `site_lang` VALUES ('105', '16', 'Your matches');
INSERT INTO `site_lang` VALUES ('103', '16', 'Terms of Use');
INSERT INTO `site_lang` VALUES ('104', '16', 'Please complete your profile before start in ');
INSERT INTO `site_lang` VALUES ('102', '16', 'Privacy Policy');
INSERT INTO `site_lang` VALUES ('101', '16', 'Your fans');
INSERT INTO `site_lang` VALUES ('100', '16', 'or wait until tomorrow for continue meeting people');
INSERT INTO `site_lang` VALUES ('99', '16', 'daily conversations');
INSERT INTO `site_lang` VALUES ('98', '16', 'and get up to');
INSERT INTO `site_lang` VALUES ('97', '16', 'Upgrade your account to Premium');
INSERT INTO `site_lang` VALUES ('96', '16', 'or');
INSERT INTO `site_lang` VALUES ('95', '16', 'more daily conversation');
INSERT INTO `site_lang` VALUES ('94', '16', 'Buy');
INSERT INTO `site_lang` VALUES ('93', '16', 'To continue chatting');
INSERT INTO `site_lang` VALUES ('92', '16', 'you have reached the limit of new daily conversations');
INSERT INTO `site_lang` VALUES ('91', '16', 'Chat');
INSERT INTO `site_lang` VALUES ('90', '16', 'Send');
INSERT INTO `site_lang` VALUES ('89', '16', 'Write text here');
INSERT INTO `site_lang` VALUES ('88', '16', 'Premium user badge');
INSERT INTO `site_lang` VALUES ('87', '16', 'Unblock all private photos');
INSERT INTO `site_lang` VALUES ('86', '16', 'Unlimited videocalls');
INSERT INTO `site_lang` VALUES ('85', '16', 'new chats per day');
INSERT INTO `site_lang` VALUES ('84', '16', 'Premium Account Features');
INSERT INTO `site_lang` VALUES ('83', '16', 'Buy credits');
INSERT INTO `site_lang` VALUES ('82', '16', 'Pay with');
INSERT INTO `site_lang` VALUES ('81', '16', 'Pay with');
INSERT INTO `site_lang` VALUES ('80', '16', 'Select payment method');
INSERT INTO `site_lang` VALUES ('79', '16', 'Select credits package');
INSERT INTO `site_lang` VALUES ('78', '16', 'Buy credits / Upgrade account');
INSERT INTO `site_lang` VALUES ('77', '16', 'Send gift');
INSERT INTO `site_lang` VALUES ('76', '16', 'Pick the gift you want to send to ');
INSERT INTO `site_lang` VALUES ('75', '16', 'Send gift to ');
INSERT INTO `site_lang` VALUES ('73', '16', 'Credits');
INSERT INTO `site_lang` VALUES ('74', '16', 'Add photo');
INSERT INTO `site_lang` VALUES ('72', '16', 'Pick the photo you want to show in the Spotlight, cost ');
INSERT INTO `site_lang` VALUES ('70', '16', 'add photos');
INSERT INTO `site_lang` VALUES ('71', '16', 'Add yourself to the Spotlight');
INSERT INTO `site_lang` VALUES ('69', '16', 'Add your photos');
INSERT INTO `site_lang` VALUES ('68', '16', 'Private Photos');
INSERT INTO `site_lang` VALUES ('67', '16', 'Public Photos');
INSERT INTO `site_lang` VALUES ('66', '16', 'All Photos');
INSERT INTO `site_lang` VALUES ('65', '16', 'Manage your photos');
INSERT INTO `site_lang` VALUES ('64', '16', 'Contact');
INSERT INTO `site_lang` VALUES ('63', '16', 'Privacy');
INSERT INTO `site_lang` VALUES ('62', '16', 'Terms');
INSERT INTO `site_lang` VALUES ('60', '16', 'New messages');
INSERT INTO `site_lang` VALUES ('61', '16', 'Who to like');
INSERT INTO `site_lang` VALUES ('56', '16', 'All');
INSERT INTO `site_lang` VALUES ('57', '16', 'Fans');
INSERT INTO `site_lang` VALUES ('58', '16', 'Conversations');
INSERT INTO `site_lang` VALUES ('59', '16', 'Online now');
INSERT INTO `site_lang` VALUES ('55', '16', 'Settings');
INSERT INTO `site_lang` VALUES ('50', '16', 'Discover');
INSERT INTO `site_lang` VALUES ('51', '16', 'Matches');
INSERT INTO `site_lang` VALUES ('52', '16', 'Most populars');
INSERT INTO `site_lang` VALUES ('53', '16', 'Fans');
INSERT INTO `site_lang` VALUES ('54', '16', 'Manage photos');
INSERT INTO `site_lang` VALUES ('45', '16', 'Privacy Policy');
INSERT INTO `site_lang` VALUES ('46', '16', 'Profile');
INSERT INTO `site_lang` VALUES ('47', '16', 'Settings');
INSERT INTO `site_lang` VALUES ('48', '16', 'Logout');
INSERT INTO `site_lang` VALUES ('49', '16', 'Meet new people');
INSERT INTO `site_lang` VALUES ('42', '16', 'By continuing, you are confirming that you have read and agree to our');
INSERT INTO `site_lang` VALUES ('43', '16', 'Terms and Conditions');
INSERT INTO `site_lang` VALUES ('44', '16', 'and');
INSERT INTO `site_lang` VALUES ('41', '16', 'Sign up');
INSERT INTO `site_lang` VALUES ('40', '16', 'Meet boys and girls');
INSERT INTO `site_lang` VALUES ('39', '16', 'Meet boys');
INSERT INTO `site_lang` VALUES ('38', '16', 'Meet girls');
INSERT INTO `site_lang` VALUES ('37', '16', 'Im here to');
INSERT INTO `site_lang` VALUES ('35', '16', 'Male');
INSERT INTO `site_lang` VALUES ('36', '16', 'Female');
INSERT INTO `site_lang` VALUES ('34', '16', 'Gender');
INSERT INTO `site_lang` VALUES ('33', '16', 'Where do you live?');
INSERT INTO `site_lang` VALUES ('32', '16', 'City');
INSERT INTO `site_lang` VALUES ('31', '16', 'Please select');
INSERT INTO `site_lang` VALUES ('30', '16', 'Birthday');
INSERT INTO `site_lang` VALUES ('29', '16', 'Password');
INSERT INTO `site_lang` VALUES ('28', '16', 'Email');
INSERT INTO `site_lang` VALUES ('26', '16', 'Name');
INSERT INTO `site_lang` VALUES ('27', '16', 'Your name or nickname');
INSERT INTO `site_lang` VALUES ('25', '16', 'Join the worlds bestest community for meeting new people!.');
INSERT INTO `site_lang` VALUES ('24', '16', 'Become a member now');
INSERT INTO `site_lang` VALUES ('22', '16', 'Matches');
INSERT INTO `site_lang` VALUES ('23', '16', 'Play our popular Discover game and get matched with other users. Its a great way to break the ice and chat to new people.');
INSERT INTO `site_lang` VALUES ('21', '16', 'We wont show your exact location, but you will be able to find people nearby who like the same things you do.');
INSERT INTO `site_lang` VALUES ('20', '16', 'People nearby');
INSERT INTO `site_lang` VALUES ('18', '16', 'Video Chat');
INSERT INTO `site_lang` VALUES ('19', '16', 'You can make quality videocalls for free to anyone, without limits of call duration, just enjoy seeing the person who is chatting with you');
INSERT INTO `site_lang` VALUES ('17', '16', 'Powerfull private chat for meet new friends, you can send emoticons and private photos to anyone.');
INSERT INTO `site_lang` VALUES ('15', '16', 'Recover password');
INSERT INTO `site_lang` VALUES ('16', '16', 'Chat');
INSERT INTO `site_lang` VALUES ('14', '16', 'Password recover');
INSERT INTO `site_lang` VALUES ('12', '16', 'do you forget your password?');
INSERT INTO `site_lang` VALUES ('13', '16', 'Login now');
INSERT INTO `site_lang` VALUES ('11', '16', 'Your password');
INSERT INTO `site_lang` VALUES ('10', '16', 'Your email');
INSERT INTO `site_lang` VALUES ('9', '16', 'Welcome back');
INSERT INTO `site_lang` VALUES ('8', '16', 'Create your account');
INSERT INTO `site_lang` VALUES ('6', '16', 'SOON AVAILABLE');
INSERT INTO `site_lang` VALUES ('7', '16', 'Connect with ');
INSERT INTO `site_lang` VALUES ('5', '16', 'Soon we will have our phone apps online');
INSERT INTO `site_lang` VALUES ('4', '16', 'Please visit us from your laptop or PC');
INSERT INTO `site_lang` VALUES ('3', '16', 'For now our site works only for Desktop users');
INSERT INTO `site_lang` VALUES ('2', '16', 'Welcome to the fastest growing place to meet new people');
INSERT INTO `site_lang` VALUES ('1', '16', 'Login');
INSERT INTO `site_lang` VALUES ('0', '16', 'meet new people!');
INSERT INTO `site_lang` VALUES ('384', '15', 'Ok, i understand');
INSERT INTO `site_lang` VALUES ('383', '15', 'must like you for start a videocall');
INSERT INTO `site_lang` VALUES ('382', '15', 'dont like you');
INSERT INTO `site_lang` VALUES ('381', '15', 'calling...');
INSERT INTO `site_lang` VALUES ('380', '15', 'Welcome to');
INSERT INTO `site_lang` VALUES ('379', '15', 'Go to');
INSERT INTO `site_lang` VALUES ('378', '15', 'Please save your connection information in a safe place');
INSERT INTO `site_lang` VALUES ('377', '15', 'Password');
INSERT INTO `site_lang` VALUES ('376', '15', 'E-mail');
INSERT INTO `site_lang` VALUES ('375', '15', 'Here are your connection details');
INSERT INTO `site_lang` VALUES ('374', '15', 'Start meeting new people now');
INSERT INTO `site_lang` VALUES ('373', '15', 'More than 1 million people have joined $site_name You probably want to know some of them.');
INSERT INTO `site_lang` VALUES ('372', '15', 'Add photos and complete your profile');
INSERT INTO `site_lang` VALUES ('371', '15', 'Nobody is going to fall in love with a blank page. The more information you get, the more chances to find that special someone!');
INSERT INTO `site_lang` VALUES ('370', '15', 'Meet new people');
INSERT INTO `site_lang` VALUES ('368', '15', 'In');
INSERT INTO `site_lang` VALUES ('369', '15', 'you can meet people instantly');
INSERT INTO `site_lang` VALUES ('367', '15', 'people in your area wants to know you');
INSERT INTO `site_lang` VALUES ('366', '15', 'Newsflash');
INSERT INTO `site_lang` VALUES ('365', '15', 'Verify your account');
INSERT INTO `site_lang` VALUES ('364', '15', 'Now you are a new member of');
INSERT INTO `site_lang` VALUES ('363', '15', 'Here are a few tips');
INSERT INTO `site_lang` VALUES ('362', '15', 'Well done, now you are in');
INSERT INTO `site_lang` VALUES ('361', '15', 'Welcome');
INSERT INTO `site_lang` VALUES ('360', '15', 'Check out the profile');
INSERT INTO `site_lang` VALUES ('359', '15', 'and lives closer to you');
INSERT INTO `site_lang` VALUES ('356', '15', 'Have fun!');
INSERT INTO `site_lang` VALUES ('357', '15', 'is new and lives closer to you');
INSERT INTO `site_lang` VALUES ('358', '15', 'is new at');
INSERT INTO `site_lang` VALUES ('355', '15', 'Respond to');
INSERT INTO `site_lang` VALUES ('354', '15', 'you have a new message from');
INSERT INTO `site_lang` VALUES ('353', '15', 'New message from');
INSERT INTO `site_lang` VALUES ('352', '15', 'Go and say something to');
INSERT INTO `site_lang` VALUES ('351', '15', 'thinks the feeling is mutual');
INSERT INTO `site_lang` VALUES ('350', '15', 'Its a match!');
INSERT INTO `site_lang` VALUES ('349', '15', 'You have a match at');
INSERT INTO `site_lang` VALUES ('348', '15', 'if you forgot your password, click on the link below to get a new');
INSERT INTO `site_lang` VALUES ('347', '15', 'Choose a new password');
INSERT INTO `site_lang` VALUES ('346', '15', 'Unsubscribe');
INSERT INTO `site_lang` VALUES ('345', '15', 'You received this notice because you registered as');
INSERT INTO `site_lang` VALUES ('344', '15', 'Find out if you also like');
INSERT INTO `site_lang` VALUES ('343', '15', 'has seen you in discover and likes. The feeling is mutual?');
INSERT INTO `site_lang` VALUES ('342', '15', 'likes you and wants to chat in');
INSERT INTO `site_lang` VALUES ('341', '15', 'We sent you a email with your info, it may take up to 1 min to arrive');
INSERT INTO `site_lang` VALUES ('340', '15', 'Loading...');
INSERT INTO `site_lang` VALUES ('339', '15', 'of');
INSERT INTO `site_lang` VALUES ('338', '15', 'Photos of ');
INSERT INTO `site_lang` VALUES ('337', '15', 'is calling you..');
INSERT INTO `site_lang` VALUES ('336', '15', 'Password successfully changed');
INSERT INTO `site_lang` VALUES ('335', '15', 'Service cost');
INSERT INTO `site_lang` VALUES ('334', '15', 'Spotlight');
INSERT INTO `site_lang` VALUES ('333', '15', 'Wrong');
INSERT INTO `site_lang` VALUES ('332', '15', 'days of Premium');
INSERT INTO `site_lang` VALUES ('331', '15', 'username');
INSERT INTO `site_lang` VALUES ('330', '15', 'You need to write your username!');
INSERT INTO `site_lang` VALUES ('329', '15', 'Write your instagram username');
INSERT INTO `site_lang` VALUES ('328', '15', 'Press backspace key for smart return to the meeting section.');
INSERT INTO `site_lang` VALUES ('327', '15', 'Are you sure you want to report');
INSERT INTO `site_lang` VALUES ('325', '15', 'is blocking you or you blocked him, you cant chat with him sorry');
INSERT INTO `site_lang` VALUES ('326', '15', 'Report and block');
INSERT INTO `site_lang` VALUES ('324', '15', 'We sended you a email for verify your account');
INSERT INTO `site_lang` VALUES ('323', '15', 'years old and im from');
INSERT INTO `site_lang` VALUES ('322', '15', 'Hi, im');
INSERT INTO `site_lang` VALUES ('321', '15', 'Please add a profile photo');
INSERT INTO `site_lang` VALUES ('320', '15', 'Please verify your account, check your email');
INSERT INTO `site_lang` VALUES ('316', '15', 'hours');
INSERT INTO `site_lang` VALUES ('317', '15', 'minutes');
INSERT INTO `site_lang` VALUES ('318', '15', 'seconds');
INSERT INTO `site_lang` VALUES ('319', '15', 'ago');
INSERT INTO `site_lang` VALUES ('314', '15', 'months');
INSERT INTO `site_lang` VALUES ('315', '15', 'days');
INSERT INTO `site_lang` VALUES ('304', '15', 'Cost');
INSERT INTO `site_lang` VALUES ('305', '15', 'Credits for $');
INSERT INTO `site_lang` VALUES ('306', '15', '0 seconds');
INSERT INTO `site_lang` VALUES ('307', '15', 'year');
INSERT INTO `site_lang` VALUES ('308', '15', 'month');
INSERT INTO `site_lang` VALUES ('309', '15', 'day');
INSERT INTO `site_lang` VALUES ('310', '15', 'hour');
INSERT INTO `site_lang` VALUES ('311', '15', 'minute');
INSERT INTO `site_lang` VALUES ('312', '15', 'second');
INSERT INTO `site_lang` VALUES ('313', '15', 'years');
INSERT INTO `site_lang` VALUES ('303', '15', 'You do not like anyone');
INSERT INTO `site_lang` VALUES ('302', '15', 'visited');
INSERT INTO `site_lang` VALUES ('300', '15', 'AGE');
INSERT INTO `site_lang` VALUES ('301', '15', 'You dont have any visit yet');
INSERT INTO `site_lang` VALUES ('296', '15', 'people liked you, for see them');
INSERT INTO `site_lang` VALUES ('297', '15', 'Messages');
INSERT INTO `site_lang` VALUES ('298', '15', 'Like');
INSERT INTO `site_lang` VALUES ('299', '15', 'Dislike');
INSERT INTO `site_lang` VALUES ('295', '15', 'People i like');
INSERT INTO `site_lang` VALUES ('294', '15', 'Upgrade your account to premium');
INSERT INTO `site_lang` VALUES ('293', '15', 'people visited your profile for see them');
INSERT INTO `site_lang` VALUES ('292', '15', 'Delete');
INSERT INTO `site_lang` VALUES ('291', '15', 'Public photo');
INSERT INTO `site_lang` VALUES ('290', '15', 'Private photo');
INSERT INTO `site_lang` VALUES ('289', '15', 'Set as profile');
INSERT INTO `site_lang` VALUES ('288', '15', 'get seen by millions');
INSERT INTO `site_lang` VALUES ('287', '15', 'Add me here');
INSERT INTO `site_lang` VALUES ('286', '15', 'Visits');
INSERT INTO `site_lang` VALUES ('285', '15', 'Credits');
INSERT INTO `site_lang` VALUES ('283', '15', 'Add');
INSERT INTO `site_lang` VALUES ('284', '15', 'Photos');
INSERT INTO `site_lang` VALUES ('281', '15', 'Private photos');
INSERT INTO `site_lang` VALUES ('282', '15', 'Add from ');
INSERT INTO `site_lang` VALUES ('280', '15', 'Public Photos');
INSERT INTO `site_lang` VALUES ('276', '15', 'Interests');
INSERT INTO `site_lang` VALUES ('277', '15', 'Report');
INSERT INTO `site_lang` VALUES ('278', '15', 'Fans');
INSERT INTO `site_lang` VALUES ('279', '15', 'No data');
INSERT INTO `site_lang` VALUES ('275', '15', 'Please wait');
INSERT INTO `site_lang` VALUES ('273', '15', 'Month');
INSERT INTO `site_lang` VALUES ('274', '15', 'Year');
INSERT INTO `site_lang` VALUES ('272', '15', 'Day');
INSERT INTO `site_lang` VALUES ('271', '15', 'When someone send me a message');
INSERT INTO `site_lang` VALUES ('270', '15', 'When new users near me join in');
INSERT INTO `site_lang` VALUES ('269', '15', 'When i get a match');
INSERT INTO `site_lang` VALUES ('258', '15', 'Smoke');
INSERT INTO `site_lang` VALUES ('259', '15', 'Yes');
INSERT INTO `site_lang` VALUES ('260', '15', 'No');
INSERT INTO `site_lang` VALUES ('261', '15', 'Sometimes');
INSERT INTO `site_lang` VALUES ('262', '15', 'Drink');
INSERT INTO `site_lang` VALUES ('263', '15', 'Transport');
INSERT INTO `site_lang` VALUES ('264', '15', 'Parents car');
INSERT INTO `site_lang` VALUES ('265', '15', 'I own a car');
INSERT INTO `site_lang` VALUES ('266', '15', 'I own a motorbike');
INSERT INTO `site_lang` VALUES ('267', '15', 'None');
INSERT INTO `site_lang` VALUES ('268', '15', 'When someone likes me');
INSERT INTO `site_lang` VALUES ('257', '15', 'Alone');
INSERT INTO `site_lang` VALUES ('256', '15', 'With partner');
INSERT INTO `site_lang` VALUES ('255', '15', 'Student dormitory');
INSERT INTO `site_lang` VALUES ('254', '15', 'With housemate');
INSERT INTO `site_lang` VALUES ('253', '15', 'With parents');
INSERT INTO `site_lang` VALUES ('252', '15', 'Living');
INSERT INTO `site_lang` VALUES ('251', '15', 'Curvy');
INSERT INTO `site_lang` VALUES ('250', '15', 'Heavy set');
INSERT INTO `site_lang` VALUES ('249', '15', 'Athletic');
INSERT INTO `site_lang` VALUES ('248', '15', 'Average');
INSERT INTO `site_lang` VALUES ('247', '15', 'Slim');
INSERT INTO `site_lang` VALUES ('246', '15', 'Body type');
INSERT INTO `site_lang` VALUES ('245', '15', 'Other');
INSERT INTO `site_lang` VALUES ('244', '15', 'Indian');
INSERT INTO `site_lang` VALUES ('243', '15', 'Pacific Islander');
INSERT INTO `site_lang` VALUES ('242', '15', 'Hispanic/latin');
INSERT INTO `site_lang` VALUES ('241', '15', 'Native American');
INSERT INTO `site_lang` VALUES ('240', '15', 'White');
INSERT INTO `site_lang` VALUES ('231', '15', 'Bisexual');
INSERT INTO `site_lang` VALUES ('232', '15', 'Height');
INSERT INTO `site_lang` VALUES ('233', '15', 'less than');
INSERT INTO `site_lang` VALUES ('234', '15', 'more than');
INSERT INTO `site_lang` VALUES ('235', '15', 'Weight');
INSERT INTO `site_lang` VALUES ('236', '15', 'Ethnicity');
INSERT INTO `site_lang` VALUES ('237', '15', 'Asian');
INSERT INTO `site_lang` VALUES ('238', '15', 'Middle Eastern');
INSERT INTO `site_lang` VALUES ('239', '15', 'Black');
INSERT INTO `site_lang` VALUES ('224', '15', 'Single');
INSERT INTO `site_lang` VALUES ('225', '15', 'Taken');
INSERT INTO `site_lang` VALUES ('226', '15', 'Open');
INSERT INTO `site_lang` VALUES ('227', '15', 'Sexuality');
INSERT INTO `site_lang` VALUES ('228', '15', 'Gay');
INSERT INTO `site_lang` VALUES ('229', '15', 'Open-minded');
INSERT INTO `site_lang` VALUES ('230', '15', 'Straight');
INSERT INTO `site_lang` VALUES ('223', '15', 'Relationship');
INSERT INTO `site_lang` VALUES ('216', '15', 'End call');
INSERT INTO `site_lang` VALUES ('217', '15', 'Wait more');
INSERT INTO `site_lang` VALUES ('218', '15', 'until');
INSERT INTO `site_lang` VALUES ('219', '15', 'Basic');
INSERT INTO `site_lang` VALUES ('220', '15', 'UPGRADE');
INSERT INTO `site_lang` VALUES ('221', '15', 'Notifications');
INSERT INTO `site_lang` VALUES ('222', '15', 'Extended info (optional)');
INSERT INTO `site_lang` VALUES ('215', '15', 'Seems that your friend do not have webcam or he is not available');
INSERT INTO `site_lang` VALUES ('214', '15', 'Too long wait');
INSERT INTO `site_lang` VALUES ('213', '15', 'You cant make videocall because you dont have webcam');
INSERT INTO `site_lang` VALUES ('212', '15', 'Impossible to make a call!');
INSERT INTO `site_lang` VALUES ('211', '15', 'Only premium users can make videocalls');
INSERT INTO `site_lang` VALUES ('210', '15', 'You are already in a videocall, you have to end the other call before start another');
INSERT INTO `site_lang` VALUES ('209', '15', 'Please allow access to your Webcam.');
INSERT INTO `site_lang` VALUES ('208', '15', 'is offline, try again when your friend is online');
INSERT INTO `site_lang` VALUES ('207', '15', 'is in another videocall , you cant call now');
INSERT INTO `site_lang` VALUES ('206', '15', 'Yes, delete it!');
INSERT INTO `site_lang` VALUES ('205', '15', 'Your data will be lost without recovery, continue?');
INSERT INTO `site_lang` VALUES ('204', '15', 'Account termination');
INSERT INTO `site_lang` VALUES ('203', '15', 'Information updated successfully');
INSERT INTO `site_lang` VALUES ('202', '15', 'Yes, buy it!');
INSERT INTO `site_lang` VALUES ('201', '15', 'more daily conversation, cost ');
INSERT INTO `site_lang` VALUES ('200', '15', 'Expand daily limitation ');
INSERT INTO `site_lang` VALUES ('199', '15', 'You dont have enought credits for send the gift');
INSERT INTO `site_lang` VALUES ('198', '15', 'Please, select 1 gift');
INSERT INTO `site_lang` VALUES ('197', '15', 'Please, select 1 photo');
INSERT INTO `site_lang` VALUES ('196', '15', 'Please, select a payment method');
INSERT INTO `site_lang` VALUES ('195', '15', 'No thanks');
INSERT INTO `site_lang` VALUES ('194', '15', 'Get access');
INSERT INTO `site_lang` VALUES ('188', '15', 'Email already exist, try another');
INSERT INTO `site_lang` VALUES ('189', '15', 'Yes, you can see my private photos');
INSERT INTO `site_lang` VALUES ('193', '15', 'private photos for ');
INSERT INTO `site_lang` VALUES ('192', '15', 'Get access to');
INSERT INTO `site_lang` VALUES ('191', '15', 'Buy private photos permission');
INSERT INTO `site_lang` VALUES ('190', '15', 'No, i cant show you my private photos');
INSERT INTO `site_lang` VALUES ('180', '15', 'Password recover');
INSERT INTO `site_lang` VALUES ('181', '15', 'Invalid email format');
INSERT INTO `site_lang` VALUES ('182', '15', 'Please fill all the inputs');
INSERT INTO `site_lang` VALUES ('183', '15', 'Email dont exist');
INSERT INTO `site_lang` VALUES ('184', '15', 'Wrong password');
INSERT INTO `site_lang` VALUES ('187', '15', 'Password too short');
INSERT INTO `site_lang` VALUES ('186', '15', 'Choose city from the autocomplete');
INSERT INTO `site_lang` VALUES ('185', '15', 'Add a valid date');
INSERT INTO `site_lang` VALUES ('179', '15', 'Login to my account');
INSERT INTO `site_lang` VALUES ('178', '15', 'If you dont remember your password, click the link below to set a new one:');
INSERT INTO `site_lang` VALUES ('177', '15', 'Hi');
INSERT INTO `site_lang` VALUES ('176', '15', 'No');
INSERT INTO `site_lang` VALUES ('175', '15', 'Yes');
INSERT INTO `site_lang` VALUES ('168', '15', 'November');
INSERT INTO `site_lang` VALUES ('169', '15', 'December');
INSERT INTO `site_lang` VALUES ('170', '15', 'Buy');
INSERT INTO `site_lang` VALUES ('171', '15', 'Days Premium');
INSERT INTO `site_lang` VALUES ('172', '15', 'persons more like this');
INSERT INTO `site_lang` VALUES ('173', '15', 'like this');
INSERT INTO `site_lang` VALUES ('174', '15', 'Hello, can i have access to your private photos ?');
INSERT INTO `site_lang` VALUES ('166', '15', 'September');
INSERT INTO `site_lang` VALUES ('167', '15', 'October');
INSERT INTO `site_lang` VALUES ('165', '15', 'August');
INSERT INTO `site_lang` VALUES ('164', '15', 'July');
INSERT INTO `site_lang` VALUES ('163', '15', 'June');
INSERT INTO `site_lang` VALUES ('162', '15', 'May');
INSERT INTO `site_lang` VALUES ('161', '15', 'April');
INSERT INTO `site_lang` VALUES ('160', '15', 'March');
INSERT INTO `site_lang` VALUES ('159', '15', 'February');
INSERT INTO `site_lang` VALUES ('158', '15', 'January');
INSERT INTO `site_lang` VALUES ('157', '15', 'You dont have matches yet');
INSERT INTO `site_lang` VALUES ('156', '15', 'You dont have any fans yet');
INSERT INTO `site_lang` VALUES ('155', '15', 'No popular users near you');
INSERT INTO `site_lang` VALUES ('154', '15', 'people found');
INSERT INTO `site_lang` VALUES ('153', '15', 'Nothing found');
INSERT INTO `site_lang` VALUES ('152', '15', 'Verified');
INSERT INTO `site_lang` VALUES ('151', '15', 'Online now');
INSERT INTO `site_lang` VALUES ('150', '15', 'Delete profile');
INSERT INTO `site_lang` VALUES ('149', '15', 'After delete your profile, some of your data will be lost without recovery.');
INSERT INTO `site_lang` VALUES ('148', '15', 'Profile desactivation');
INSERT INTO `site_lang` VALUES ('147', '15', 'New password');
INSERT INTO `site_lang` VALUES ('146', '15', 'You can change your current password bellow');
INSERT INTO `site_lang` VALUES ('145', '15', 'Change password');
INSERT INTO `site_lang` VALUES ('144', '15', 'Upgrade to premium account');
INSERT INTO `site_lang` VALUES ('143', '15', 'Add credits');
INSERT INTO `site_lang` VALUES ('141', '15', 'Account type');
INSERT INTO `site_lang` VALUES ('142', '15', 'Current credits');
INSERT INTO `site_lang` VALUES ('140', '15', 'Buy credits for send Gifs and Unblock private photos');
INSERT INTO `site_lang` VALUES ('139', '15', 'You are account is already verified');
INSERT INTO `site_lang` VALUES ('138', '15', 'Connect with Facebook');
INSERT INTO `site_lang` VALUES ('137', '15', 'For verify your account , connect with your facebook account');
INSERT INTO `site_lang` VALUES ('136', '15', 'Verify account');
INSERT INTO `site_lang` VALUES ('135', '15', 'Update profile');
INSERT INTO `site_lang` VALUES ('134', '15', 'Site language');
INSERT INTO `site_lang` VALUES ('133', '15', 'You can edit your profile information bellow');
INSERT INTO `site_lang` VALUES ('132', '15', 'Personal information');
INSERT INTO `site_lang` VALUES ('131', '15', 'Delete');
INSERT INTO `site_lang` VALUES ('127', '15', 'Personal');
INSERT INTO `site_lang` VALUES ('128', '15', 'Credits');
INSERT INTO `site_lang` VALUES ('129', '15', 'Verify');
INSERT INTO `site_lang` VALUES ('130', '15', 'Change password');
INSERT INTO `site_lang` VALUES ('124', '15', 'Now you have');
INSERT INTO `site_lang` VALUES ('125', '15', 'Ask permission to');
INSERT INTO `site_lang` VALUES ('126', '15', 'Unblock private photos');
INSERT INTO `site_lang` VALUES ('123', '15', 'Credits successfully added to your account');
INSERT INTO `site_lang` VALUES ('120', '15', 'Only boys');
INSERT INTO `site_lang` VALUES ('121', '15', 'Only girls');
INSERT INTO `site_lang` VALUES ('122', '15', 'boys and girls');
INSERT INTO `site_lang` VALUES ('119', '15', 'years old');
INSERT INTO `site_lang` VALUES ('113', '15', 'who are between');
INSERT INTO `site_lang` VALUES ('114', '15', 'in a radius of');
INSERT INTO `site_lang` VALUES ('115', '15', 'World');
INSERT INTO `site_lang` VALUES ('116', '15', 'Most popular users');
INSERT INTO `site_lang` VALUES ('117', '15', 'About ');
INSERT INTO `site_lang` VALUES ('118', '15', 'Personal info');
INSERT INTO `site_lang` VALUES ('108', '15', 'Online now');
INSERT INTO `site_lang` VALUES ('109', '15', 'Show me');
INSERT INTO `site_lang` VALUES ('110', '15', 'Girls');
INSERT INTO `site_lang` VALUES ('111', '15', 'Boys');
INSERT INTO `site_lang` VALUES ('112', '15', 'Both');
INSERT INTO `site_lang` VALUES ('107', '15', 'All users');
INSERT INTO `site_lang` VALUES ('106', '15', 'Filter Search');
INSERT INTO `site_lang` VALUES ('105', '15', 'Your matches');
INSERT INTO `site_lang` VALUES ('104', '15', 'Please complete your profile before start in ');
INSERT INTO `site_lang` VALUES ('103', '15', 'Terms of Use');
INSERT INTO `site_lang` VALUES ('102', '15', 'Privacy Policy');
INSERT INTO `site_lang` VALUES ('101', '15', 'Your fans');
INSERT INTO `site_lang` VALUES ('100', '15', 'or wait until tomorrow for continue meeting people');
INSERT INTO `site_lang` VALUES ('99', '15', 'daily conversations');
INSERT INTO `site_lang` VALUES ('98', '15', 'and get up to');
INSERT INTO `site_lang` VALUES ('96', '15', 'or');
INSERT INTO `site_lang` VALUES ('97', '15', 'Upgrade your account to Premium');
INSERT INTO `site_lang` VALUES ('94', '15', 'Buy');
INSERT INTO `site_lang` VALUES ('95', '15', 'more daily conversation');
INSERT INTO `site_lang` VALUES ('93', '15', 'To continue chatting');
INSERT INTO `site_lang` VALUES ('92', '15', 'you have reached the limit of new daily conversations');
INSERT INTO `site_lang` VALUES ('91', '15', 'Chat');
INSERT INTO `site_lang` VALUES ('90', '15', 'Send');
INSERT INTO `site_lang` VALUES ('89', '15', 'Write text here');
INSERT INTO `site_lang` VALUES ('88', '15', 'Premium user badge');
INSERT INTO `site_lang` VALUES ('87', '15', 'Unblock all private photos');
INSERT INTO `site_lang` VALUES ('86', '15', 'Unlimited videocalls');
INSERT INTO `site_lang` VALUES ('85', '15', 'new chats per day');
INSERT INTO `site_lang` VALUES ('84', '15', 'Premium Account Features');
INSERT INTO `site_lang` VALUES ('83', '15', 'Buy credits');
INSERT INTO `site_lang` VALUES ('82', '15', 'Pay with');
INSERT INTO `site_lang` VALUES ('81', '15', 'Pay with');
INSERT INTO `site_lang` VALUES ('79', '15', 'Select credits package');
INSERT INTO `site_lang` VALUES ('80', '15', 'Select payment method');
INSERT INTO `site_lang` VALUES ('78', '15', 'Buy credits / Upgrade account');
INSERT INTO `site_lang` VALUES ('76', '15', 'Pick the gift you want to send to ');
INSERT INTO `site_lang` VALUES ('77', '15', 'Send gift');
INSERT INTO `site_lang` VALUES ('73', '15', 'Credits');
INSERT INTO `site_lang` VALUES ('74', '15', 'Add photo');
INSERT INTO `site_lang` VALUES ('75', '15', 'Send gift to ');
INSERT INTO `site_lang` VALUES ('72', '15', 'Pick the photo you want to show in the Spotlight, cost ');
INSERT INTO `site_lang` VALUES ('70', '15', 'add photos');
INSERT INTO `site_lang` VALUES ('71', '15', 'Add yourself to the Spotlight');
INSERT INTO `site_lang` VALUES ('69', '15', 'Add your photos');
INSERT INTO `site_lang` VALUES ('68', '15', 'Private Photos');
INSERT INTO `site_lang` VALUES ('67', '15', 'Public Photos');
INSERT INTO `site_lang` VALUES ('66', '15', 'All Photos');
INSERT INTO `site_lang` VALUES ('65', '15', 'Manage your photos');
INSERT INTO `site_lang` VALUES ('64', '15', 'Contact');
INSERT INTO `site_lang` VALUES ('63', '15', 'Privacy');
INSERT INTO `site_lang` VALUES ('62', '15', 'Terms');
INSERT INTO `site_lang` VALUES ('61', '15', 'Who to like');
INSERT INTO `site_lang` VALUES ('60', '15', 'New messages');
INSERT INTO `site_lang` VALUES ('59', '15', 'Online now');
INSERT INTO `site_lang` VALUES ('58', '15', 'Conversations');
INSERT INTO `site_lang` VALUES ('57', '15', 'Fans');
INSERT INTO `site_lang` VALUES ('56', '15', 'All');
INSERT INTO `site_lang` VALUES ('55', '15', 'Settings');
INSERT INTO `site_lang` VALUES ('54', '15', 'Manage photos');
INSERT INTO `site_lang` VALUES ('53', '15', 'Fans');
INSERT INTO `site_lang` VALUES ('52', '15', 'Most populars');
INSERT INTO `site_lang` VALUES ('51', '15', 'Matches');
INSERT INTO `site_lang` VALUES ('50', '15', 'Discover');
INSERT INTO `site_lang` VALUES ('49', '15', 'Meet new people');
INSERT INTO `site_lang` VALUES ('48', '15', 'Logout');
INSERT INTO `site_lang` VALUES ('47', '15', 'Settings');
INSERT INTO `site_lang` VALUES ('46', '15', 'Profile');
INSERT INTO `site_lang` VALUES ('45', '15', 'Privacy Policy');
INSERT INTO `site_lang` VALUES ('43', '15', 'Terms and Conditions');
INSERT INTO `site_lang` VALUES ('44', '15', 'and');
INSERT INTO `site_lang` VALUES ('42', '15', 'By continuing, you are confirming that you have read and agree to our');
INSERT INTO `site_lang` VALUES ('41', '15', 'Sign up');
INSERT INTO `site_lang` VALUES ('40', '15', 'Meet boys and girls');
INSERT INTO `site_lang` VALUES ('39', '15', 'Meet boys');
INSERT INTO `site_lang` VALUES ('38', '15', 'Meet girls');
INSERT INTO `site_lang` VALUES ('37', '15', 'Im here to');
INSERT INTO `site_lang` VALUES ('36', '15', 'Female');
INSERT INTO `site_lang` VALUES ('35', '15', 'Male');
INSERT INTO `site_lang` VALUES ('34', '15', 'Gender');
INSERT INTO `site_lang` VALUES ('33', '15', 'Where do you live?');
INSERT INTO `site_lang` VALUES ('32', '15', 'City');
INSERT INTO `site_lang` VALUES ('31', '15', 'Please select');
INSERT INTO `site_lang` VALUES ('30', '15', 'Birthday');
INSERT INTO `site_lang` VALUES ('29', '15', 'Password');
INSERT INTO `site_lang` VALUES ('28', '15', 'Email');
INSERT INTO `site_lang` VALUES ('27', '15', 'Your name or nickname');
INSERT INTO `site_lang` VALUES ('26', '15', 'Name');
INSERT INTO `site_lang` VALUES ('25', '15', 'Join the worlds bestest community for meeting new people!.');
INSERT INTO `site_lang` VALUES ('24', '15', 'Become a member now');
INSERT INTO `site_lang` VALUES ('22', '15', 'Matches');
INSERT INTO `site_lang` VALUES ('23', '15', 'Play our popular Discover game and get matched with other users. Its a great way to break the ice and chat to new people.');
INSERT INTO `site_lang` VALUES ('21', '15', 'We wont show your exact location, but you will be able to find people nearby who like the same things you do.');
INSERT INTO `site_lang` VALUES ('20', '15', 'People nearby');
INSERT INTO `site_lang` VALUES ('19', '15', 'You can make quality videocalls for free to anyone, without limits of call duration, just enjoy seeing the person who is chatting with you');
INSERT INTO `site_lang` VALUES ('18', '15', 'Video Chat');
INSERT INTO `site_lang` VALUES ('17', '15', 'Powerfull private chat for meet new friends, you can send emoticons and private photos to anyone.');
INSERT INTO `site_lang` VALUES ('16', '15', 'Chat');
INSERT INTO `site_lang` VALUES ('15', '15', 'Recover password');
INSERT INTO `site_lang` VALUES ('14', '15', 'Password recover');
INSERT INTO `site_lang` VALUES ('13', '15', 'Login now');
INSERT INTO `site_lang` VALUES ('12', '15', 'do you forget your password?');
INSERT INTO `site_lang` VALUES ('11', '15', 'Your password');
INSERT INTO `site_lang` VALUES ('10', '15', 'Your email');
INSERT INTO `site_lang` VALUES ('9', '15', 'Welcome back');
INSERT INTO `site_lang` VALUES ('8', '15', 'Create your account');
INSERT INTO `site_lang` VALUES ('7', '15', 'Connect with ');
INSERT INTO `site_lang` VALUES ('6', '15', 'SOON AVAILABLE');
INSERT INTO `site_lang` VALUES ('5', '15', 'Soon we will have our phone apps online');
INSERT INTO `site_lang` VALUES ('4', '15', 'Please visit us from your laptop or PC');
INSERT INTO `site_lang` VALUES ('3', '15', 'For now our site works only for Desktop users');
INSERT INTO `site_lang` VALUES ('2', '15', 'Welcome to the fastest growing place to meet new people');
INSERT INTO `site_lang` VALUES ('1', '15', 'Login');
INSERT INTO `site_lang` VALUES ('0', '15', 'meet new people!');
INSERT INTO `site_lang` VALUES ('384', '14', 'Ok, i understand');
INSERT INTO `site_lang` VALUES ('383', '14', 'must like you for start a videocall');
INSERT INTO `site_lang` VALUES ('382', '14', 'dont like you');
INSERT INTO `site_lang` VALUES ('381', '14', 'calling...');
INSERT INTO `site_lang` VALUES ('380', '14', 'Welcome to');
INSERT INTO `site_lang` VALUES ('379', '14', 'Go to');
INSERT INTO `site_lang` VALUES ('378', '14', 'Please save your connection information in a safe place');
INSERT INTO `site_lang` VALUES ('377', '14', 'Password');
INSERT INTO `site_lang` VALUES ('376', '14', 'E-mail');
INSERT INTO `site_lang` VALUES ('375', '14', 'Here are your connection details');
INSERT INTO `site_lang` VALUES ('374', '14', 'Start meeting new people now');
INSERT INTO `site_lang` VALUES ('373', '14', 'More than 1 million people have joined $site_name You probably want to know some of them.');
INSERT INTO `site_lang` VALUES ('372', '14', 'Add photos and complete your profile');
INSERT INTO `site_lang` VALUES ('370', '14', 'Meet new people');
INSERT INTO `site_lang` VALUES ('371', '14', 'Nobody is going to fall in love with a blank page. The more information you get, the more chances to find that special someone!');
INSERT INTO `site_lang` VALUES ('369', '14', 'you can meet people instantly');
INSERT INTO `site_lang` VALUES ('368', '14', 'In');
INSERT INTO `site_lang` VALUES ('366', '14', 'Newsflash');
INSERT INTO `site_lang` VALUES ('367', '14', 'people in your area wants to know you');
INSERT INTO `site_lang` VALUES ('365', '14', 'Verify your account');
INSERT INTO `site_lang` VALUES ('364', '14', 'Now you are a new member of');
INSERT INTO `site_lang` VALUES ('363', '14', 'Here are a few tips');
INSERT INTO `site_lang` VALUES ('362', '14', 'Well done, now you are in');
INSERT INTO `site_lang` VALUES ('361', '14', 'Welcome');
INSERT INTO `site_lang` VALUES ('360', '14', 'Check out the profile');
INSERT INTO `site_lang` VALUES ('359', '14', 'and lives closer to you');
INSERT INTO `site_lang` VALUES ('358', '14', 'is new at');
INSERT INTO `site_lang` VALUES ('357', '14', 'is new and lives closer to you');
INSERT INTO `site_lang` VALUES ('356', '14', 'Have fun!');
INSERT INTO `site_lang` VALUES ('355', '14', 'Respond to');
INSERT INTO `site_lang` VALUES ('354', '14', 'you have a new message from');
INSERT INTO `site_lang` VALUES ('353', '14', 'New message from');
INSERT INTO `site_lang` VALUES ('352', '14', 'Go and say something to');
INSERT INTO `site_lang` VALUES ('351', '14', 'thinks the feeling is mutual');
INSERT INTO `site_lang` VALUES ('350', '14', 'Its a match!');
INSERT INTO `site_lang` VALUES ('349', '14', 'You have a match at');
INSERT INTO `site_lang` VALUES ('344', '14', 'Find out if you also like');
INSERT INTO `site_lang` VALUES ('345', '14', 'You received this notice because you registered as');
INSERT INTO `site_lang` VALUES ('348', '14', 'if you forgot your password, click on the link below to get a new');
INSERT INTO `site_lang` VALUES ('347', '14', 'Choose a new password');
INSERT INTO `site_lang` VALUES ('346', '14', 'Unsubscribe');
INSERT INTO `site_lang` VALUES ('343', '14', 'has seen you in discover and likes. The feeling is mutual?');
INSERT INTO `site_lang` VALUES ('342', '14', 'likes you and wants to chat in');
INSERT INTO `site_lang` VALUES ('341', '14', 'We sent you a email with your info, it may take up to 1 min to arrive');
INSERT INTO `site_lang` VALUES ('340', '14', 'Loading...');
INSERT INTO `site_lang` VALUES ('335', '14', 'Service cost');
INSERT INTO `site_lang` VALUES ('336', '14', 'Password successfully changed');
INSERT INTO `site_lang` VALUES ('337', '14', 'is calling you..');
INSERT INTO `site_lang` VALUES ('338', '14', 'Photos of ');
INSERT INTO `site_lang` VALUES ('339', '14', 'of');
INSERT INTO `site_lang` VALUES ('334', '14', 'Spotlight');
INSERT INTO `site_lang` VALUES ('333', '14', 'Wrong');
INSERT INTO `site_lang` VALUES ('332', '14', 'days of Premium');
INSERT INTO `site_lang` VALUES ('331', '14', 'username');
INSERT INTO `site_lang` VALUES ('330', '14', 'You need to write your username!');
INSERT INTO `site_lang` VALUES ('329', '14', 'Write your instagram username');
INSERT INTO `site_lang` VALUES ('328', '14', 'Press backspace key for smart return to the meeting section.');
INSERT INTO `site_lang` VALUES ('327', '14', 'Are you sure you want to report');
INSERT INTO `site_lang` VALUES ('326', '14', 'Report and block');
INSERT INTO `site_lang` VALUES ('325', '14', 'is blocking you or you blocked him, you cant chat with him sorry');
INSERT INTO `site_lang` VALUES ('324', '14', 'We sended you a email for verify your account');
INSERT INTO `site_lang` VALUES ('323', '14', 'years old and im from');
INSERT INTO `site_lang` VALUES ('321', '14', 'Please add a profile photo');
INSERT INTO `site_lang` VALUES ('322', '14', 'Hi, im');
INSERT INTO `site_lang` VALUES ('313', '14', 'years');
INSERT INTO `site_lang` VALUES ('314', '14', 'months');
INSERT INTO `site_lang` VALUES ('315', '14', 'days');
INSERT INTO `site_lang` VALUES ('316', '14', 'hours');
INSERT INTO `site_lang` VALUES ('317', '14', 'minutes');
INSERT INTO `site_lang` VALUES ('318', '14', 'seconds');
INSERT INTO `site_lang` VALUES ('319', '14', 'ago');
INSERT INTO `site_lang` VALUES ('320', '14', 'Please verify your account, check your email');
INSERT INTO `site_lang` VALUES ('312', '14', 'second');
INSERT INTO `site_lang` VALUES ('309', '14', 'day');
INSERT INTO `site_lang` VALUES ('310', '14', 'hour');
INSERT INTO `site_lang` VALUES ('311', '14', 'minute');
INSERT INTO `site_lang` VALUES ('306', '14', '0 seconds');
INSERT INTO `site_lang` VALUES ('307', '14', 'year');
INSERT INTO `site_lang` VALUES ('308', '14', 'month');
INSERT INTO `site_lang` VALUES ('304', '14', 'Cost');
INSERT INTO `site_lang` VALUES ('305', '14', 'Credits for $');
INSERT INTO `site_lang` VALUES ('303', '14', 'You do not like anyone');
INSERT INTO `site_lang` VALUES ('300', '14', 'AGE');
INSERT INTO `site_lang` VALUES ('301', '14', 'You dont have any visit yet');
INSERT INTO `site_lang` VALUES ('302', '14', 'visited');
INSERT INTO `site_lang` VALUES ('299', '14', 'Dislike');
INSERT INTO `site_lang` VALUES ('298', '14', 'Like');
INSERT INTO `site_lang` VALUES ('297', '14', 'Messages');
INSERT INTO `site_lang` VALUES ('295', '14', 'People i like');
INSERT INTO `site_lang` VALUES ('296', '14', 'people liked you, for see them');
INSERT INTO `site_lang` VALUES ('294', '14', 'Upgrade your account to premium');
INSERT INTO `site_lang` VALUES ('293', '14', 'people visited your profile for see them');
INSERT INTO `site_lang` VALUES ('292', '14', 'Delete');
INSERT INTO `site_lang` VALUES ('291', '14', 'Public photo');
INSERT INTO `site_lang` VALUES ('290', '14', 'Private photo');
INSERT INTO `site_lang` VALUES ('289', '14', 'Set as profile');
INSERT INTO `site_lang` VALUES ('288', '14', 'get seen by millions');
INSERT INTO `site_lang` VALUES ('286', '14', 'Visits');
INSERT INTO `site_lang` VALUES ('287', '14', 'Add me here');
INSERT INTO `site_lang` VALUES ('285', '14', 'Credits');
INSERT INTO `site_lang` VALUES ('284', '14', 'Photos');
INSERT INTO `site_lang` VALUES ('283', '14', 'Add');
INSERT INTO `site_lang` VALUES ('282', '14', 'Add from ');
INSERT INTO `site_lang` VALUES ('281', '14', 'Private photos');
INSERT INTO `site_lang` VALUES ('280', '14', 'Public Photos');
INSERT INTO `site_lang` VALUES ('278', '14', 'Fans');
INSERT INTO `site_lang` VALUES ('279', '14', 'No data');
INSERT INTO `site_lang` VALUES ('277', '14', 'Report');
INSERT INTO `site_lang` VALUES ('276', '14', 'Interests');
INSERT INTO `site_lang` VALUES ('274', '14', 'Year');
INSERT INTO `site_lang` VALUES ('275', '14', 'Please wait');
INSERT INTO `site_lang` VALUES ('273', '14', 'Month');
INSERT INTO `site_lang` VALUES ('272', '14', 'Day');
INSERT INTO `site_lang` VALUES ('271', '14', 'When someone send me a message');
INSERT INTO `site_lang` VALUES ('270', '14', 'When new users near me join in');
INSERT INTO `site_lang` VALUES ('269', '14', 'When i get a match');
INSERT INTO `site_lang` VALUES ('267', '14', 'None');
INSERT INTO `site_lang` VALUES ('268', '14', 'When someone likes me');
INSERT INTO `site_lang` VALUES ('266', '14', 'I own a motorbike');
INSERT INTO `site_lang` VALUES ('265', '14', 'I own a car');
INSERT INTO `site_lang` VALUES ('264', '14', 'Parents car');
INSERT INTO `site_lang` VALUES ('261', '14', 'Sometimes');
INSERT INTO `site_lang` VALUES ('262', '14', 'Drink');
INSERT INTO `site_lang` VALUES ('263', '14', 'Transport');
INSERT INTO `site_lang` VALUES ('260', '14', 'No');
INSERT INTO `site_lang` VALUES ('259', '14', 'Yes');
INSERT INTO `site_lang` VALUES ('257', '14', 'Alone');
INSERT INTO `site_lang` VALUES ('258', '14', 'Smoke');
INSERT INTO `site_lang` VALUES ('256', '14', 'With partner');
INSERT INTO `site_lang` VALUES ('255', '14', 'Student dormitory');
INSERT INTO `site_lang` VALUES ('254', '14', 'With housemate');
INSERT INTO `site_lang` VALUES ('252', '14', 'Living');
INSERT INTO `site_lang` VALUES ('253', '14', 'With parents');
INSERT INTO `site_lang` VALUES ('249', '14', 'Athletic');
INSERT INTO `site_lang` VALUES ('250', '14', 'Heavy set');
INSERT INTO `site_lang` VALUES ('251', '14', 'Curvy');
INSERT INTO `site_lang` VALUES ('248', '14', 'Average');
INSERT INTO `site_lang` VALUES ('247', '14', 'Slim');
INSERT INTO `site_lang` VALUES ('246', '14', 'Body type');
INSERT INTO `site_lang` VALUES ('245', '14', 'Other');
INSERT INTO `site_lang` VALUES ('244', '14', 'Indian');
INSERT INTO `site_lang` VALUES ('243', '14', 'Pacific Islander');
INSERT INTO `site_lang` VALUES ('242', '14', 'Hispanic/latin');
INSERT INTO `site_lang` VALUES ('241', '14', 'Native American');
INSERT INTO `site_lang` VALUES ('240', '14', 'White');
INSERT INTO `site_lang` VALUES ('239', '14', 'Black');
INSERT INTO `site_lang` VALUES ('238', '14', 'Middle Eastern');
INSERT INTO `site_lang` VALUES ('237', '14', 'Asian');
INSERT INTO `site_lang` VALUES ('235', '14', 'Weight');
INSERT INTO `site_lang` VALUES ('236', '14', 'Ethnicity');
INSERT INTO `site_lang` VALUES ('234', '14', 'more than');
INSERT INTO `site_lang` VALUES ('232', '14', 'Height');
INSERT INTO `site_lang` VALUES ('233', '14', 'less than');
INSERT INTO `site_lang` VALUES ('230', '14', 'Straight');
INSERT INTO `site_lang` VALUES ('231', '14', 'Bisexual');
INSERT INTO `site_lang` VALUES ('229', '14', 'Open-minded');
INSERT INTO `site_lang` VALUES ('226', '14', 'Open');
INSERT INTO `site_lang` VALUES ('227', '14', 'Sexuality');
INSERT INTO `site_lang` VALUES ('228', '14', 'Gay');
INSERT INTO `site_lang` VALUES ('224', '14', 'Single');
INSERT INTO `site_lang` VALUES ('225', '14', 'Taken');
INSERT INTO `site_lang` VALUES ('223', '14', 'Relationship');
INSERT INTO `site_lang` VALUES ('222', '14', 'Extended info (optional)');
INSERT INTO `site_lang` VALUES ('221', '14', 'Notifications');
INSERT INTO `site_lang` VALUES ('218', '14', 'until');
INSERT INTO `site_lang` VALUES ('219', '14', 'Basic');
INSERT INTO `site_lang` VALUES ('220', '14', 'UPGRADE');
INSERT INTO `site_lang` VALUES ('217', '14', 'Wait more');
INSERT INTO `site_lang` VALUES ('216', '14', 'End call');
INSERT INTO `site_lang` VALUES ('215', '14', 'Seems that your friend do not have webcam or he is not available');
INSERT INTO `site_lang` VALUES ('214', '14', 'Too long wait');
INSERT INTO `site_lang` VALUES ('213', '14', 'You cant make videocall because you dont have webcam');
INSERT INTO `site_lang` VALUES ('212', '14', 'Impossible to make a call!');
INSERT INTO `site_lang` VALUES ('211', '14', 'Only premium users can make videocalls');
INSERT INTO `site_lang` VALUES ('210', '14', 'You are already in a videocall, you have to end the other call before start another');
INSERT INTO `site_lang` VALUES ('209', '14', 'Please allow access to your Webcam.');
INSERT INTO `site_lang` VALUES ('208', '14', 'is offline, try again when your friend is online');
INSERT INTO `site_lang` VALUES ('207', '14', 'is in another videocall , you cant call now');
INSERT INTO `site_lang` VALUES ('206', '14', 'Yes, delete it!');
INSERT INTO `site_lang` VALUES ('205', '14', 'Your data will be lost without recovery, continue?');
INSERT INTO `site_lang` VALUES ('204', '14', 'Account termination');
INSERT INTO `site_lang` VALUES ('203', '14', 'Information updated successfully');
INSERT INTO `site_lang` VALUES ('202', '14', 'Yes, buy it!');
INSERT INTO `site_lang` VALUES ('201', '14', 'more daily conversation, cost ');
INSERT INTO `site_lang` VALUES ('200', '14', 'Expand daily limitation ');
INSERT INTO `site_lang` VALUES ('198', '14', 'Please, select 1 gift');
INSERT INTO `site_lang` VALUES ('199', '14', 'You dont have enought credits for send the gift');
INSERT INTO `site_lang` VALUES ('197', '14', 'Please, select 1 photo');
INSERT INTO `site_lang` VALUES ('193', '14', 'private photos for ');
INSERT INTO `site_lang` VALUES ('194', '14', 'Get access');
INSERT INTO `site_lang` VALUES ('195', '14', 'No thanks');
INSERT INTO `site_lang` VALUES ('196', '14', 'Please, select a payment method');
INSERT INTO `site_lang` VALUES ('192', '14', 'Get access to');
INSERT INTO `site_lang` VALUES ('189', '14', 'Yes, you can see my private photos');
INSERT INTO `site_lang` VALUES ('190', '14', 'No, i cant show you my private photos');
INSERT INTO `site_lang` VALUES ('191', '14', 'Buy private photos permission');
INSERT INTO `site_lang` VALUES ('188', '14', 'Email already exist, try another');
INSERT INTO `site_lang` VALUES ('183', '14', 'Email dont exist');
INSERT INTO `site_lang` VALUES ('184', '14', 'Wrong password');
INSERT INTO `site_lang` VALUES ('185', '14', 'Add a valid date');
INSERT INTO `site_lang` VALUES ('186', '14', 'Choose city from the autocomplete');
INSERT INTO `site_lang` VALUES ('187', '14', 'Password too short');
INSERT INTO `site_lang` VALUES ('180', '14', 'Password recover');
INSERT INTO `site_lang` VALUES ('181', '14', 'Invalid email format');
INSERT INTO `site_lang` VALUES ('182', '14', 'Please fill all the inputs');
INSERT INTO `site_lang` VALUES ('179', '14', 'Login to my account');
INSERT INTO `site_lang` VALUES ('177', '14', 'Hi');
INSERT INTO `site_lang` VALUES ('178', '14', 'If you dont remember your password, click the link below to set a new one:');
INSERT INTO `site_lang` VALUES ('175', '14', 'Yes');
INSERT INTO `site_lang` VALUES ('176', '14', 'No');
INSERT INTO `site_lang` VALUES ('174', '14', 'Hello, can i have access to your private photos ?');
INSERT INTO `site_lang` VALUES ('173', '14', 'like this');
INSERT INTO `site_lang` VALUES ('172', '14', 'persons more like this');
INSERT INTO `site_lang` VALUES ('171', '14', 'Days Premium');
INSERT INTO `site_lang` VALUES ('170', '14', 'Buy');
INSERT INTO `site_lang` VALUES ('168', '14', 'November');
INSERT INTO `site_lang` VALUES ('169', '14', 'December');
INSERT INTO `site_lang` VALUES ('166', '14', 'September');
INSERT INTO `site_lang` VALUES ('167', '14', 'October');
INSERT INTO `site_lang` VALUES ('163', '14', 'June');
INSERT INTO `site_lang` VALUES ('164', '14', 'July');
INSERT INTO `site_lang` VALUES ('165', '14', 'August');
INSERT INTO `site_lang` VALUES ('162', '14', 'May');
INSERT INTO `site_lang` VALUES ('159', '14', 'February');
INSERT INTO `site_lang` VALUES ('160', '14', 'March');
INSERT INTO `site_lang` VALUES ('161', '14', 'April');
INSERT INTO `site_lang` VALUES ('158', '14', 'January');
INSERT INTO `site_lang` VALUES ('157', '14', 'You dont have matches yet');
INSERT INTO `site_lang` VALUES ('156', '14', 'You dont have any fans yet');
INSERT INTO `site_lang` VALUES ('155', '14', 'No popular users near you');
INSERT INTO `site_lang` VALUES ('154', '14', 'people found');
INSERT INTO `site_lang` VALUES ('153', '14', 'Nothing found');
INSERT INTO `site_lang` VALUES ('152', '14', 'Verified');
INSERT INTO `site_lang` VALUES ('151', '14', 'Online now');
INSERT INTO `site_lang` VALUES ('150', '14', 'Delete profile');
INSERT INTO `site_lang` VALUES ('147', '14', 'New password');
INSERT INTO `site_lang` VALUES ('148', '14', 'Profile desactivation');
INSERT INTO `site_lang` VALUES ('149', '14', 'After delete your profile, some of your data will be lost without recovery.');
INSERT INTO `site_lang` VALUES ('145', '14', 'Change password');
INSERT INTO `site_lang` VALUES ('142', '14', 'Current credits');
INSERT INTO `site_lang` VALUES ('146', '14', 'You can change your current password bellow');
INSERT INTO `site_lang` VALUES ('143', '14', 'Add credits');
INSERT INTO `site_lang` VALUES ('144', '14', 'Upgrade to premium account');
INSERT INTO `site_lang` VALUES ('141', '14', 'Account type');
INSERT INTO `site_lang` VALUES ('140', '14', 'Buy credits for send Gifs and Unblock private photos');
INSERT INTO `site_lang` VALUES ('139', '14', 'You are account is already verified');
INSERT INTO `site_lang` VALUES ('138', '14', 'Connect with Facebook');
INSERT INTO `site_lang` VALUES ('137', '14', 'For verify your account , connect with your facebook account');
INSERT INTO `site_lang` VALUES ('136', '14', 'Verify account');
INSERT INTO `site_lang` VALUES ('135', '14', 'Update profile');
INSERT INTO `site_lang` VALUES ('134', '14', 'Site language');
INSERT INTO `site_lang` VALUES ('133', '14', 'You can edit your profile information bellow');
INSERT INTO `site_lang` VALUES ('132', '14', 'Personal information');
INSERT INTO `site_lang` VALUES ('131', '14', 'Delete');
INSERT INTO `site_lang` VALUES ('130', '14', 'Change password');
INSERT INTO `site_lang` VALUES ('128', '14', 'Credits');
INSERT INTO `site_lang` VALUES ('129', '14', 'Verify');
INSERT INTO `site_lang` VALUES ('127', '14', 'Personal');
INSERT INTO `site_lang` VALUES ('126', '14', 'Unblock private photos');
INSERT INTO `site_lang` VALUES ('125', '14', 'Ask permission to');
INSERT INTO `site_lang` VALUES ('124', '14', 'Now you have');
INSERT INTO `site_lang` VALUES ('123', '14', 'Credits successfully added to your account');
INSERT INTO `site_lang` VALUES ('121', '14', 'Only girls');
INSERT INTO `site_lang` VALUES ('122', '14', 'boys and girls');
INSERT INTO `site_lang` VALUES ('119', '14', 'years old');
INSERT INTO `site_lang` VALUES ('120', '14', 'Only boys');
INSERT INTO `site_lang` VALUES ('118', '14', 'Personal info');
INSERT INTO `site_lang` VALUES ('115', '14', 'World');
INSERT INTO `site_lang` VALUES ('116', '14', 'Most popular users');
INSERT INTO `site_lang` VALUES ('117', '14', 'About ');
INSERT INTO `site_lang` VALUES ('114', '14', 'in a radius of');
INSERT INTO `site_lang` VALUES ('113', '14', 'who are between');
INSERT INTO `site_lang` VALUES ('112', '14', 'Both');
INSERT INTO `site_lang` VALUES ('111', '14', 'Boys');
INSERT INTO `site_lang` VALUES ('110', '14', 'Girls');
INSERT INTO `site_lang` VALUES ('109', '14', 'Show me');
INSERT INTO `site_lang` VALUES ('108', '14', 'Online now');
INSERT INTO `site_lang` VALUES ('107', '14', 'All users');
INSERT INTO `site_lang` VALUES ('106', '14', 'Filter Search');
INSERT INTO `site_lang` VALUES ('105', '14', 'Your matches');
INSERT INTO `site_lang` VALUES ('104', '14', 'Please complete your profile before start in ');
INSERT INTO `site_lang` VALUES ('103', '14', 'Terms of Use');
INSERT INTO `site_lang` VALUES ('102', '14', 'Privacy Policy');
INSERT INTO `site_lang` VALUES ('101', '14', 'Your fans');
INSERT INTO `site_lang` VALUES ('99', '14', 'daily conversations');
INSERT INTO `site_lang` VALUES ('100', '14', 'or wait until tomorrow for continue meeting people');
INSERT INTO `site_lang` VALUES ('98', '14', 'and get up to');
INSERT INTO `site_lang` VALUES ('97', '14', 'Upgrade your account to Premium');
INSERT INTO `site_lang` VALUES ('95', '14', 'more daily conversation');
INSERT INTO `site_lang` VALUES ('96', '14', 'or');
INSERT INTO `site_lang` VALUES ('94', '14', 'Buy');
INSERT INTO `site_lang` VALUES ('93', '14', 'To continue chatting');
INSERT INTO `site_lang` VALUES ('92', '14', 'you have reached the limit of new daily conversations');
INSERT INTO `site_lang` VALUES ('91', '14', 'Chat');
INSERT INTO `site_lang` VALUES ('90', '14', 'Send');
INSERT INTO `site_lang` VALUES ('89', '14', 'Write text here');
INSERT INTO `site_lang` VALUES ('88', '14', 'Premium user badge');
INSERT INTO `site_lang` VALUES ('87', '14', 'Unblock all private photos');
INSERT INTO `site_lang` VALUES ('86', '14', 'Unlimited videocalls');
INSERT INTO `site_lang` VALUES ('85', '14', 'new chats per day');
INSERT INTO `site_lang` VALUES ('84', '14', 'Premium Account Features');
INSERT INTO `site_lang` VALUES ('83', '14', 'Buy credits');
INSERT INTO `site_lang` VALUES ('82', '14', 'Pay with');
INSERT INTO `site_lang` VALUES ('81', '14', 'Pay with');
INSERT INTO `site_lang` VALUES ('80', '14', 'Select payment method');
INSERT INTO `site_lang` VALUES ('79', '14', 'Select credits package');
INSERT INTO `site_lang` VALUES ('78', '14', 'Buy credits / Upgrade account');
INSERT INTO `site_lang` VALUES ('77', '14', 'Send gift');
INSERT INTO `site_lang` VALUES ('76', '14', 'Pick the gift you want to send to ');
INSERT INTO `site_lang` VALUES ('75', '14', 'Send gift to ');
INSERT INTO `site_lang` VALUES ('74', '14', 'Add photo');
INSERT INTO `site_lang` VALUES ('73', '14', 'Credits');
INSERT INTO `site_lang` VALUES ('72', '14', 'Pick the photo you want to show in the Spotlight, cost ');
INSERT INTO `site_lang` VALUES ('71', '14', 'Add yourself to the Spotlight');
INSERT INTO `site_lang` VALUES ('70', '14', 'add photos');
INSERT INTO `site_lang` VALUES ('69', '14', 'Add your photos');
INSERT INTO `site_lang` VALUES ('68', '14', 'Private Photos');
INSERT INTO `site_lang` VALUES ('67', '14', 'Public Photos');
INSERT INTO `site_lang` VALUES ('66', '14', 'All Photos');
INSERT INTO `site_lang` VALUES ('65', '14', 'Manage your photos');
INSERT INTO `site_lang` VALUES ('64', '14', 'Contact');
INSERT INTO `site_lang` VALUES ('63', '14', 'Privacy');
INSERT INTO `site_lang` VALUES ('62', '14', 'Terms');
INSERT INTO `site_lang` VALUES ('61', '14', 'Who to like');
INSERT INTO `site_lang` VALUES ('60', '14', 'New messages');
INSERT INTO `site_lang` VALUES ('59', '14', 'Online now');
INSERT INTO `site_lang` VALUES ('58', '14', 'Conversations');
INSERT INTO `site_lang` VALUES ('57', '14', 'Fans');
INSERT INTO `site_lang` VALUES ('56', '14', 'All');
INSERT INTO `site_lang` VALUES ('55', '14', 'Settings');
INSERT INTO `site_lang` VALUES ('52', '14', 'Most populars');
INSERT INTO `site_lang` VALUES ('53', '14', 'Fans');
INSERT INTO `site_lang` VALUES ('54', '14', 'Manage photos');
INSERT INTO `site_lang` VALUES ('50', '14', 'Discover');
INSERT INTO `site_lang` VALUES ('51', '14', 'Matches');
INSERT INTO `site_lang` VALUES ('49', '14', 'Meet new people');
INSERT INTO `site_lang` VALUES ('48', '14', 'Logout');
INSERT INTO `site_lang` VALUES ('45', '14', 'Privacy Policy');
INSERT INTO `site_lang` VALUES ('46', '14', 'Profile');
INSERT INTO `site_lang` VALUES ('47', '14', 'Settings');
INSERT INTO `site_lang` VALUES ('43', '14', 'Terms and Conditions');
INSERT INTO `site_lang` VALUES ('44', '14', 'and');
INSERT INTO `site_lang` VALUES ('41', '14', 'Sign up');
INSERT INTO `site_lang` VALUES ('42', '14', 'By continuing, you are confirming that you have read and agree to our');
INSERT INTO `site_lang` VALUES ('39', '14', 'Meet boys');
INSERT INTO `site_lang` VALUES ('40', '14', 'Meet boys and girls');
INSERT INTO `site_lang` VALUES ('38', '14', 'Meet girls');
INSERT INTO `site_lang` VALUES ('36', '14', 'Female');
INSERT INTO `site_lang` VALUES ('37', '14', 'Im here to');
INSERT INTO `site_lang` VALUES ('35', '14', 'Male');
INSERT INTO `site_lang` VALUES ('34', '14', 'Gender');
INSERT INTO `site_lang` VALUES ('33', '14', 'Where do you live?');
INSERT INTO `site_lang` VALUES ('32', '14', 'City');
INSERT INTO `site_lang` VALUES ('31', '14', 'Please select');
INSERT INTO `site_lang` VALUES ('29', '14', 'Password');
INSERT INTO `site_lang` VALUES ('30', '14', 'Birthday');
INSERT INTO `site_lang` VALUES ('28', '14', 'Email');
INSERT INTO `site_lang` VALUES ('27', '14', 'Your name or nickname');
INSERT INTO `site_lang` VALUES ('26', '14', 'Name');
INSERT INTO `site_lang` VALUES ('25', '14', 'Join the worlds bestest community for meeting new people!.');
INSERT INTO `site_lang` VALUES ('24', '14', 'Become a member now');
INSERT INTO `site_lang` VALUES ('22', '14', 'Matches');
INSERT INTO `site_lang` VALUES ('23', '14', 'Play our popular Discover game and get matched with other users. Its a great way to break the ice and chat to new people.');
INSERT INTO `site_lang` VALUES ('21', '14', 'We wont show your exact location, but you will be able to find people nearby who like the same things you do.');
INSERT INTO `site_lang` VALUES ('20', '14', 'People nearby');
INSERT INTO `site_lang` VALUES ('19', '14', 'You can make quality videocalls for free to anyone, without limits of call duration, just enjoy seeing the person who is chatting with you');
INSERT INTO `site_lang` VALUES ('18', '14', 'Video Chat');
INSERT INTO `site_lang` VALUES ('17', '14', 'Powerfull private chat for meet new friends, you can send emoticons and private photos to anyone.');
INSERT INTO `site_lang` VALUES ('16', '14', 'Chat');
INSERT INTO `site_lang` VALUES ('15', '14', 'Recover password');
INSERT INTO `site_lang` VALUES ('14', '14', 'Password recover');
INSERT INTO `site_lang` VALUES ('13', '14', 'Login now');
INSERT INTO `site_lang` VALUES ('10', '14', 'Your email');
INSERT INTO `site_lang` VALUES ('11', '14', 'Your password');
INSERT INTO `site_lang` VALUES ('12', '14', 'do you forget your password?');
INSERT INTO `site_lang` VALUES ('9', '14', 'Welcome back');
INSERT INTO `site_lang` VALUES ('8', '14', 'Create your account');
INSERT INTO `site_lang` VALUES ('7', '14', 'Connect with ');
INSERT INTO `site_lang` VALUES ('6', '14', 'SOON AVAILABLE');
INSERT INTO `site_lang` VALUES ('5', '14', 'Soon we will have our phone apps online');
INSERT INTO `site_lang` VALUES ('4', '14', 'Please visit us from your laptop or PC');
INSERT INTO `site_lang` VALUES ('3', '14', 'For now our site works only for Desktop users');
INSERT INTO `site_lang` VALUES ('2', '14', 'Welcome to the fastest growing place to meet new people');
INSERT INTO `site_lang` VALUES ('1', '14', 'Login');
INSERT INTO `site_lang` VALUES ('0', '14', 'meet new people!');
INSERT INTO `site_lang` VALUES ('384', '12', 'Ok, i understand');
INSERT INTO `site_lang` VALUES ('383', '12', 'must like you for start a videocall');
INSERT INTO `site_lang` VALUES ('382', '12', 'dont like you');
INSERT INTO `site_lang` VALUES ('381', '12', 'calling...');
INSERT INTO `site_lang` VALUES ('379', '12', 'Go to');
INSERT INTO `site_lang` VALUES ('380', '12', 'Welcome to');
INSERT INTO `site_lang` VALUES ('378', '12', 'Please save your connection information in a safe place');
INSERT INTO `site_lang` VALUES ('377', '12', 'Password');
INSERT INTO `site_lang` VALUES ('376', '12', 'E-mail');
INSERT INTO `site_lang` VALUES ('375', '12', 'Here are your connection details');
INSERT INTO `site_lang` VALUES ('374', '12', 'Start meeting new people now');
INSERT INTO `site_lang` VALUES ('373', '12', 'More than 1 million people have joined $site_name You probably want to know some of them.');
INSERT INTO `site_lang` VALUES ('372', '12', 'Add photos and complete your profile');
INSERT INTO `site_lang` VALUES ('371', '12', 'Nobody is going to fall in love with a blank page. The more information you get, the more chances to find that special someone!');
INSERT INTO `site_lang` VALUES ('367', '12', 'people in your area wants to know you');
INSERT INTO `site_lang` VALUES ('368', '12', 'In');
INSERT INTO `site_lang` VALUES ('369', '12', 'you can meet people instantly');
INSERT INTO `site_lang` VALUES ('370', '12', 'Meet new people');
INSERT INTO `site_lang` VALUES ('366', '12', 'Newsflash');
INSERT INTO `site_lang` VALUES ('365', '12', 'Verify your account');
INSERT INTO `site_lang` VALUES ('363', '12', 'Here are a few tips');
INSERT INTO `site_lang` VALUES ('364', '12', 'Now you are a new member of');
INSERT INTO `site_lang` VALUES ('362', '12', 'Well done, now you are in');
INSERT INTO `site_lang` VALUES ('361', '12', 'Welcome');
INSERT INTO `site_lang` VALUES ('360', '12', 'Check out the profile');
INSERT INTO `site_lang` VALUES ('359', '12', 'and lives closer to you');
INSERT INTO `site_lang` VALUES ('357', '12', 'is new and lives closer to you');
INSERT INTO `site_lang` VALUES ('358', '12', 'is new at');
INSERT INTO `site_lang` VALUES ('356', '12', 'Have fun!');
INSERT INTO `site_lang` VALUES ('355', '12', 'Respond to');
INSERT INTO `site_lang` VALUES ('354', '12', 'you have a new message from');
INSERT INTO `site_lang` VALUES ('353', '12', 'New message from');
INSERT INTO `site_lang` VALUES ('352', '12', 'Go and say something to');
INSERT INTO `site_lang` VALUES ('351', '12', 'thinks the feeling is mutual');
INSERT INTO `site_lang` VALUES ('350', '12', 'Its a match!');
INSERT INTO `site_lang` VALUES ('349', '12', 'You have a match at');
INSERT INTO `site_lang` VALUES ('348', '12', 'if you forgot your password, click on the link below to get a new');
INSERT INTO `site_lang` VALUES ('347', '12', 'Choose a new password');
INSERT INTO `site_lang` VALUES ('346', '12', 'Unsubscribe');
INSERT INTO `site_lang` VALUES ('345', '12', 'You received this notice because you registered as');
INSERT INTO `site_lang` VALUES ('344', '12', 'Find out if you also like');
INSERT INTO `site_lang` VALUES ('343', '12', 'has seen you in discover and likes. The feeling is mutual?');
INSERT INTO `site_lang` VALUES ('342', '12', 'likes you and wants to chat in');
INSERT INTO `site_lang` VALUES ('341', '12', 'We sent you a email with your info, it may take up to 1 min to arrive');
INSERT INTO `site_lang` VALUES ('340', '12', 'Loading...');
INSERT INTO `site_lang` VALUES ('339', '12', 'of');
INSERT INTO `site_lang` VALUES ('338', '12', 'Photos of ');
INSERT INTO `site_lang` VALUES ('337', '12', 'is calling you..');
INSERT INTO `site_lang` VALUES ('335', '12', 'Service cost');
INSERT INTO `site_lang` VALUES ('336', '12', 'Password successfully changed');
INSERT INTO `site_lang` VALUES ('334', '12', 'Spotlight');
INSERT INTO `site_lang` VALUES ('333', '12', 'Wrong');
INSERT INTO `site_lang` VALUES ('332', '12', 'days of Premium');
INSERT INTO `site_lang` VALUES ('331', '12', 'username');
INSERT INTO `site_lang` VALUES ('330', '12', 'You need to write your username!');
INSERT INTO `site_lang` VALUES ('329', '12', 'Write your instagram username');
INSERT INTO `site_lang` VALUES ('328', '12', 'Press backspace key for smart return to the meeting section.');
INSERT INTO `site_lang` VALUES ('320', '12', 'Please verify your account, check your email');
INSERT INTO `site_lang` VALUES ('327', '12', 'Are you sure you want to report');
INSERT INTO `site_lang` VALUES ('326', '12', 'Report and block');
INSERT INTO `site_lang` VALUES ('325', '12', 'is blocking you or you blocked him, you cant chat with him sorry');
INSERT INTO `site_lang` VALUES ('324', '12', 'We sended you a email for verify your account');
INSERT INTO `site_lang` VALUES ('323', '12', 'years old and im from');
INSERT INTO `site_lang` VALUES ('322', '12', 'Hi, im');
INSERT INTO `site_lang` VALUES ('321', '12', 'Please add a profile photo');
INSERT INTO `site_lang` VALUES ('310', '12', 'hour');
INSERT INTO `site_lang` VALUES ('311', '12', 'minute');
INSERT INTO `site_lang` VALUES ('312', '12', 'second');
INSERT INTO `site_lang` VALUES ('313', '12', 'years');
INSERT INTO `site_lang` VALUES ('314', '12', 'months');
INSERT INTO `site_lang` VALUES ('315', '12', 'days');
INSERT INTO `site_lang` VALUES ('316', '12', 'hours');
INSERT INTO `site_lang` VALUES ('317', '12', 'minutes');
INSERT INTO `site_lang` VALUES ('318', '12', 'seconds');
INSERT INTO `site_lang` VALUES ('319', '12', 'ago');
INSERT INTO `site_lang` VALUES ('309', '12', 'day');
INSERT INTO `site_lang` VALUES ('308', '12', 'month');
INSERT INTO `site_lang` VALUES ('307', '12', 'year');
INSERT INTO `site_lang` VALUES ('306', '12', '0 seconds');
INSERT INTO `site_lang` VALUES ('305', '12', 'Credits for $');
INSERT INTO `site_lang` VALUES ('304', '12', 'Cost');
INSERT INTO `site_lang` VALUES ('303', '12', 'You do not like anyone');
INSERT INTO `site_lang` VALUES ('302', '12', 'visited');
INSERT INTO `site_lang` VALUES ('301', '12', 'You dont have any visit yet');
INSERT INTO `site_lang` VALUES ('300', '12', 'AGE');
INSERT INTO `site_lang` VALUES ('299', '12', 'Dislike');
INSERT INTO `site_lang` VALUES ('298', '12', 'Like');
INSERT INTO `site_lang` VALUES ('297', '12', 'Messages');
INSERT INTO `site_lang` VALUES ('296', '12', 'people liked you, for see them');
INSERT INTO `site_lang` VALUES ('295', '12', 'People i like');
INSERT INTO `site_lang` VALUES ('294', '12', 'Upgrade your account to premium');
INSERT INTO `site_lang` VALUES ('293', '12', 'people visited your profile for see them');
INSERT INTO `site_lang` VALUES ('292', '12', 'Delete');
INSERT INTO `site_lang` VALUES ('291', '12', 'Public photo');
INSERT INTO `site_lang` VALUES ('290', '12', 'Private photo');
INSERT INTO `site_lang` VALUES ('289', '12', 'Set as profile');
INSERT INTO `site_lang` VALUES ('288', '12', 'get seen by millions');
INSERT INTO `site_lang` VALUES ('287', '12', 'Add me here');
INSERT INTO `site_lang` VALUES ('285', '12', 'Credits');
INSERT INTO `site_lang` VALUES ('286', '12', 'Visits');
INSERT INTO `site_lang` VALUES ('284', '12', 'Photos');
INSERT INTO `site_lang` VALUES ('283', '12', 'Add');
INSERT INTO `site_lang` VALUES ('282', '12', 'Add from ');
INSERT INTO `site_lang` VALUES ('281', '12', 'Private photos');
INSERT INTO `site_lang` VALUES ('280', '12', 'Public Photos');
INSERT INTO `site_lang` VALUES ('279', '12', 'No data');
INSERT INTO `site_lang` VALUES ('278', '12', 'Fans');
INSERT INTO `site_lang` VALUES ('277', '12', 'Report');
INSERT INTO `site_lang` VALUES ('276', '12', 'Interests');
INSERT INTO `site_lang` VALUES ('275', '12', 'Please wait');
INSERT INTO `site_lang` VALUES ('274', '12', 'Year');
INSERT INTO `site_lang` VALUES ('273', '12', 'Month');
INSERT INTO `site_lang` VALUES ('272', '12', 'Day');
INSERT INTO `site_lang` VALUES ('271', '12', 'When someone send me a message');
INSERT INTO `site_lang` VALUES ('270', '12', 'When new users near me join in');
INSERT INTO `site_lang` VALUES ('269', '12', 'When i get a match');
INSERT INTO `site_lang` VALUES ('266', '12', 'I own a motorbike');
INSERT INTO `site_lang` VALUES ('267', '12', 'None');
INSERT INTO `site_lang` VALUES ('268', '12', 'When someone likes me');
INSERT INTO `site_lang` VALUES ('262', '12', 'Drink');
INSERT INTO `site_lang` VALUES ('263', '12', 'Transport');
INSERT INTO `site_lang` VALUES ('264', '12', 'Parents car');
INSERT INTO `site_lang` VALUES ('265', '12', 'I own a car');
INSERT INTO `site_lang` VALUES ('261', '12', 'Sometimes');
INSERT INTO `site_lang` VALUES ('257', '12', 'Alone');
INSERT INTO `site_lang` VALUES ('258', '12', 'Smoke');
INSERT INTO `site_lang` VALUES ('259', '12', 'Yes');
INSERT INTO `site_lang` VALUES ('260', '12', 'No');
INSERT INTO `site_lang` VALUES ('256', '12', 'With partner');
INSERT INTO `site_lang` VALUES ('252', '12', 'Living');
INSERT INTO `site_lang` VALUES ('253', '12', 'With parents');
INSERT INTO `site_lang` VALUES ('254', '12', 'With housemate');
INSERT INTO `site_lang` VALUES ('255', '12', 'Student dormitory');
INSERT INTO `site_lang` VALUES ('248', '12', 'Average');
INSERT INTO `site_lang` VALUES ('249', '12', 'Athletic');
INSERT INTO `site_lang` VALUES ('250', '12', 'Heavy set');
INSERT INTO `site_lang` VALUES ('251', '12', 'Curvy');
INSERT INTO `site_lang` VALUES ('247', '12', 'Slim');
INSERT INTO `site_lang` VALUES ('246', '12', 'Body type');
INSERT INTO `site_lang` VALUES ('245', '12', 'Other');
INSERT INTO `site_lang` VALUES ('244', '12', 'Indian');
INSERT INTO `site_lang` VALUES ('234', '12', 'more than');
INSERT INTO `site_lang` VALUES ('235', '12', 'Weight');
INSERT INTO `site_lang` VALUES ('236', '12', 'Ethnicity');
INSERT INTO `site_lang` VALUES ('237', '12', 'Asian');
INSERT INTO `site_lang` VALUES ('238', '12', 'Middle Eastern');
INSERT INTO `site_lang` VALUES ('239', '12', 'Black');
INSERT INTO `site_lang` VALUES ('240', '12', 'White');
INSERT INTO `site_lang` VALUES ('241', '12', 'Native American');
INSERT INTO `site_lang` VALUES ('242', '12', 'Hispanic/latin');
INSERT INTO `site_lang` VALUES ('243', '12', 'Pacific Islander');
INSERT INTO `site_lang` VALUES ('233', '12', 'less than');
INSERT INTO `site_lang` VALUES ('231', '12', 'Bisexual');
INSERT INTO `site_lang` VALUES ('232', '12', 'Height');
INSERT INTO `site_lang` VALUES ('230', '12', 'Straight');
INSERT INTO `site_lang` VALUES ('229', '12', 'Open-minded');
INSERT INTO `site_lang` VALUES ('228', '12', 'Gay');
INSERT INTO `site_lang` VALUES ('226', '12', 'Open');
INSERT INTO `site_lang` VALUES ('227', '12', 'Sexuality');
INSERT INTO `site_lang` VALUES ('225', '12', 'Taken');
INSERT INTO `site_lang` VALUES ('224', '12', 'Single');
INSERT INTO `site_lang` VALUES ('223', '12', 'Relationship');
INSERT INTO `site_lang` VALUES ('222', '12', 'Extended info (optional)');
INSERT INTO `site_lang` VALUES ('220', '12', 'UPGRADE');
INSERT INTO `site_lang` VALUES ('221', '12', 'Notifications');
INSERT INTO `site_lang` VALUES ('219', '12', 'Basic');
INSERT INTO `site_lang` VALUES ('218', '12', 'until');
INSERT INTO `site_lang` VALUES ('217', '12', 'Wait more');
INSERT INTO `site_lang` VALUES ('216', '12', 'End call');
INSERT INTO `site_lang` VALUES ('214', '12', 'Too long wait');
INSERT INTO `site_lang` VALUES ('215', '12', 'Seems that your friend do not have webcam or he is not available');
INSERT INTO `site_lang` VALUES ('212', '12', 'Impossible to make a call!');
INSERT INTO `site_lang` VALUES ('213', '12', 'You cant make videocall because you dont have webcam');
INSERT INTO `site_lang` VALUES ('211', '12', 'Only premium users can make videocalls');
INSERT INTO `site_lang` VALUES ('210', '12', 'You are already in a videocall, you have to end the other call before start another');
INSERT INTO `site_lang` VALUES ('209', '12', 'Please allow access to your Webcam.');
INSERT INTO `site_lang` VALUES ('208', '12', 'is offline, try again when your friend is online');
INSERT INTO `site_lang` VALUES ('207', '12', 'is in another videocall , you cant call now');
INSERT INTO `site_lang` VALUES ('206', '12', 'Yes, delete it!');
INSERT INTO `site_lang` VALUES ('205', '12', 'Your data will be lost without recovery, continue?');
INSERT INTO `site_lang` VALUES ('204', '12', 'Account termination');
INSERT INTO `site_lang` VALUES ('203', '12', 'Information updated successfully');
INSERT INTO `site_lang` VALUES ('202', '12', 'Yes, buy it!');
INSERT INTO `site_lang` VALUES ('201', '12', 'more daily conversation, cost ');
INSERT INTO `site_lang` VALUES ('200', '12', 'Expand daily limitation ');
INSERT INTO `site_lang` VALUES ('199', '12', 'You dont have enought credits for send the gift');
INSERT INTO `site_lang` VALUES ('198', '12', 'Please, select 1 gift');
INSERT INTO `site_lang` VALUES ('197', '12', 'Please, select 1 photo');
INSERT INTO `site_lang` VALUES ('196', '12', 'Please, select a payment method');
INSERT INTO `site_lang` VALUES ('195', '12', 'No thanks');
INSERT INTO `site_lang` VALUES ('194', '12', 'Get access');
INSERT INTO `site_lang` VALUES ('193', '12', 'private photos for ');
INSERT INTO `site_lang` VALUES ('192', '12', 'Get access to');
INSERT INTO `site_lang` VALUES ('187', '12', 'Password too short');
INSERT INTO `site_lang` VALUES ('188', '12', 'Email already exist, try another');
INSERT INTO `site_lang` VALUES ('191', '12', 'Buy private photos permission');
INSERT INTO `site_lang` VALUES ('190', '12', 'No, i cant show you my private photos');
INSERT INTO `site_lang` VALUES ('189', '12', 'Yes, you can see my private photos');
INSERT INTO `site_lang` VALUES ('186', '12', 'Choose city from the autocomplete');
INSERT INTO `site_lang` VALUES ('185', '12', 'Add a valid date');
INSERT INTO `site_lang` VALUES ('184', '12', 'Wrong password');
INSERT INTO `site_lang` VALUES ('183', '12', 'Email dont exist');
INSERT INTO `site_lang` VALUES ('182', '12', 'Please fill all the inputs');
INSERT INTO `site_lang` VALUES ('181', '12', 'Invalid email format');
INSERT INTO `site_lang` VALUES ('180', '12', 'Password recover');
INSERT INTO `site_lang` VALUES ('179', '12', 'Login to my account');
INSERT INTO `site_lang` VALUES ('178', '12', 'If you dont remember your password, click the link below to set a new one:');
INSERT INTO `site_lang` VALUES ('177', '12', 'Hi');
INSERT INTO `site_lang` VALUES ('175', '12', 'Yes');
INSERT INTO `site_lang` VALUES ('176', '12', 'No');
INSERT INTO `site_lang` VALUES ('174', '12', 'Hello, can i have access to your private photos ?');
INSERT INTO `site_lang` VALUES ('173', '12', 'like this');
INSERT INTO `site_lang` VALUES ('172', '12', 'persons more like this');
INSERT INTO `site_lang` VALUES ('171', '12', 'Days Premium');
INSERT INTO `site_lang` VALUES ('170', '12', 'Buy');
INSERT INTO `site_lang` VALUES ('169', '12', 'December');
INSERT INTO `site_lang` VALUES ('168', '12', 'November');
INSERT INTO `site_lang` VALUES ('167', '12', 'October');
INSERT INTO `site_lang` VALUES ('166', '12', 'September');
INSERT INTO `site_lang` VALUES ('165', '12', 'August');
INSERT INTO `site_lang` VALUES ('164', '12', 'July');
INSERT INTO `site_lang` VALUES ('163', '12', 'June');
INSERT INTO `site_lang` VALUES ('162', '12', 'May');
INSERT INTO `site_lang` VALUES ('161', '12', 'April');
INSERT INTO `site_lang` VALUES ('160', '12', 'March');
INSERT INTO `site_lang` VALUES ('159', '12', 'February');
INSERT INTO `site_lang` VALUES ('158', '12', 'January');
INSERT INTO `site_lang` VALUES ('157', '12', 'You dont have matches yet');
INSERT INTO `site_lang` VALUES ('156', '12', 'You dont have any fans yet');
INSERT INTO `site_lang` VALUES ('155', '12', 'No popular users near you');
INSERT INTO `site_lang` VALUES ('154', '12', 'people found');
INSERT INTO `site_lang` VALUES ('153', '12', 'Nothing found');
INSERT INTO `site_lang` VALUES ('152', '12', 'Verified');
INSERT INTO `site_lang` VALUES ('151', '12', 'Online now');
INSERT INTO `site_lang` VALUES ('150', '12', 'Delete profile');
INSERT INTO `site_lang` VALUES ('149', '12', 'After delete your profile, some of your data will be lost without recovery.');
INSERT INTO `site_lang` VALUES ('148', '12', 'Profile desactivation');
INSERT INTO `site_lang` VALUES ('147', '12', 'New password');
INSERT INTO `site_lang` VALUES ('146', '12', 'You can change your current password bellow');
INSERT INTO `site_lang` VALUES ('145', '12', 'Change password');
INSERT INTO `site_lang` VALUES ('144', '12', 'Upgrade to premium account');
INSERT INTO `site_lang` VALUES ('143', '12', 'Add credits');
INSERT INTO `site_lang` VALUES ('142', '12', 'Current credits');
INSERT INTO `site_lang` VALUES ('141', '12', 'Account type');
INSERT INTO `site_lang` VALUES ('140', '12', 'Buy credits for send Gifs and Unblock private photos');
INSERT INTO `site_lang` VALUES ('139', '12', 'You are account is already verified');
INSERT INTO `site_lang` VALUES ('138', '12', 'Connect with Facebook');
INSERT INTO `site_lang` VALUES ('137', '12', 'For verify your account , connect with your facebook account');
INSERT INTO `site_lang` VALUES ('136', '12', 'Verify account');
INSERT INTO `site_lang` VALUES ('135', '12', 'Update profile');
INSERT INTO `site_lang` VALUES ('134', '12', 'Site language');
INSERT INTO `site_lang` VALUES ('133', '12', 'You can edit your profile information bellow');
INSERT INTO `site_lang` VALUES ('132', '12', 'Personal information');
INSERT INTO `site_lang` VALUES ('131', '12', 'Delete');
INSERT INTO `site_lang` VALUES ('130', '12', 'Change password');
INSERT INTO `site_lang` VALUES ('129', '12', 'Verify');
INSERT INTO `site_lang` VALUES ('128', '12', 'Credits');
INSERT INTO `site_lang` VALUES ('127', '12', 'Personal');
INSERT INTO `site_lang` VALUES ('126', '12', 'Unblock private photos');
INSERT INTO `site_lang` VALUES ('125', '12', 'Ask permission to');
INSERT INTO `site_lang` VALUES ('124', '12', 'Now you have');
INSERT INTO `site_lang` VALUES ('123', '12', 'Credits successfully added to your account');
INSERT INTO `site_lang` VALUES ('122', '12', 'boys and girls');
INSERT INTO `site_lang` VALUES ('121', '12', 'Only girls');
INSERT INTO `site_lang` VALUES ('119', '12', 'years old');
INSERT INTO `site_lang` VALUES ('120', '12', 'Only boys');
INSERT INTO `site_lang` VALUES ('111', '12', 'Boys');
INSERT INTO `site_lang` VALUES ('112', '12', 'Both');
INSERT INTO `site_lang` VALUES ('113', '12', 'who are between');
INSERT INTO `site_lang` VALUES ('114', '12', 'in a radius of');
INSERT INTO `site_lang` VALUES ('115', '12', 'World');
INSERT INTO `site_lang` VALUES ('116', '12', 'Most popular users');
INSERT INTO `site_lang` VALUES ('117', '12', 'About ');
INSERT INTO `site_lang` VALUES ('118', '12', 'Personal info');
INSERT INTO `site_lang` VALUES ('108', '12', 'Online now');
INSERT INTO `site_lang` VALUES ('109', '12', 'Show me');
INSERT INTO `site_lang` VALUES ('110', '12', 'Girls');
INSERT INTO `site_lang` VALUES ('106', '12', 'Filter Search');
INSERT INTO `site_lang` VALUES ('107', '12', 'All users');
INSERT INTO `site_lang` VALUES ('105', '12', 'Your matches');
INSERT INTO `site_lang` VALUES ('104', '12', 'Please complete your profile before start in ');
INSERT INTO `site_lang` VALUES ('103', '12', 'Terms of Use');
INSERT INTO `site_lang` VALUES ('101', '12', 'Your fans');
INSERT INTO `site_lang` VALUES ('102', '12', 'Privacy Policy');
INSERT INTO `site_lang` VALUES ('99', '12', 'daily conversations');
INSERT INTO `site_lang` VALUES ('100', '12', 'or wait until tomorrow for continue meeting people');
INSERT INTO `site_lang` VALUES ('98', '12', 'and get up to');
INSERT INTO `site_lang` VALUES ('96', '12', 'or');
INSERT INTO `site_lang` VALUES ('97', '12', 'Upgrade your account to Premium');
INSERT INTO `site_lang` VALUES ('94', '12', 'Buy');
INSERT INTO `site_lang` VALUES ('95', '12', 'more daily conversation');
INSERT INTO `site_lang` VALUES ('93', '12', 'To continue chatting');
INSERT INTO `site_lang` VALUES ('92', '12', 'you have reached the limit of new daily conversations');
INSERT INTO `site_lang` VALUES ('90', '12', 'Send');
INSERT INTO `site_lang` VALUES ('91', '12', 'Chat');
INSERT INTO `site_lang` VALUES ('89', '12', 'Write text here');
INSERT INTO `site_lang` VALUES ('88', '12', 'Premium user badge');
INSERT INTO `site_lang` VALUES ('87', '12', 'Unblock all private photos');
INSERT INTO `site_lang` VALUES ('86', '12', 'Unlimited videocalls');
INSERT INTO `site_lang` VALUES ('84', '12', 'Premium Account Features');
INSERT INTO `site_lang` VALUES ('85', '12', 'new chats per day');
INSERT INTO `site_lang` VALUES ('82', '12', 'Pay with');
INSERT INTO `site_lang` VALUES ('83', '12', 'Buy credits');
INSERT INTO `site_lang` VALUES ('81', '12', 'Pay with');
INSERT INTO `site_lang` VALUES ('80', '12', 'Select payment method');
INSERT INTO `site_lang` VALUES ('79', '12', 'Select credits package');
INSERT INTO `site_lang` VALUES ('77', '12', 'Send gift');
INSERT INTO `site_lang` VALUES ('78', '12', 'Buy credits / Upgrade account');
INSERT INTO `site_lang` VALUES ('76', '12', 'Pick the gift you want to send to ');
INSERT INTO `site_lang` VALUES ('75', '12', 'Send gift to ');
INSERT INTO `site_lang` VALUES ('74', '12', 'Add photo');
INSERT INTO `site_lang` VALUES ('73', '12', 'Credits');
INSERT INTO `site_lang` VALUES ('71', '12', 'Add yourself to the Spotlight');
INSERT INTO `site_lang` VALUES ('72', '12', 'Pick the photo you want to show in the Spotlight, cost ');
INSERT INTO `site_lang` VALUES ('70', '12', 'add photos');
INSERT INTO `site_lang` VALUES ('69', '12', 'Add your photos');
INSERT INTO `site_lang` VALUES ('68', '12', 'Private Photos');
INSERT INTO `site_lang` VALUES ('67', '12', 'Public Photos');
INSERT INTO `site_lang` VALUES ('66', '12', 'All Photos');
INSERT INTO `site_lang` VALUES ('65', '12', 'Manage your photos');
INSERT INTO `site_lang` VALUES ('64', '12', 'Contact');
INSERT INTO `site_lang` VALUES ('63', '12', 'Privacy');
INSERT INTO `site_lang` VALUES ('62', '12', 'Terms');
INSERT INTO `site_lang` VALUES ('61', '12', 'Who to like');
INSERT INTO `site_lang` VALUES ('60', '12', 'New messages');
INSERT INTO `site_lang` VALUES ('59', '12', 'Online now');
INSERT INTO `site_lang` VALUES ('58', '12', 'Conversations');
INSERT INTO `site_lang` VALUES ('57', '12', 'Fans');
INSERT INTO `site_lang` VALUES ('56', '12', 'All');
INSERT INTO `site_lang` VALUES ('55', '12', 'Settings');
INSERT INTO `site_lang` VALUES ('53', '12', 'Fans');
INSERT INTO `site_lang` VALUES ('54', '12', 'Manage photos');
INSERT INTO `site_lang` VALUES ('51', '12', 'Matches');
INSERT INTO `site_lang` VALUES ('52', '12', 'Most populars');
INSERT INTO `site_lang` VALUES ('50', '12', 'Discover');
INSERT INTO `site_lang` VALUES ('49', '12', 'Meet new people');
INSERT INTO `site_lang` VALUES ('48', '12', 'Logout');
INSERT INTO `site_lang` VALUES ('47', '12', 'Settings');
INSERT INTO `site_lang` VALUES ('46', '12', 'Profile');
INSERT INTO `site_lang` VALUES ('45', '12', 'Privacy Policy');
INSERT INTO `site_lang` VALUES ('44', '12', 'and');
INSERT INTO `site_lang` VALUES ('43', '12', 'Terms and Conditions');
INSERT INTO `site_lang` VALUES ('42', '12', 'By continuing, you are confirming that you have read and agree to our');
INSERT INTO `site_lang` VALUES ('41', '12', 'Sign up');
INSERT INTO `site_lang` VALUES ('40', '12', 'Meet boys and girls');
INSERT INTO `site_lang` VALUES ('39', '12', 'Meet boys');
INSERT INTO `site_lang` VALUES ('38', '12', 'Meet girls');
INSERT INTO `site_lang` VALUES ('37', '12', 'Im here to');
INSERT INTO `site_lang` VALUES ('32', '12', 'City');
INSERT INTO `site_lang` VALUES ('33', '12', 'Where do you live?');
INSERT INTO `site_lang` VALUES ('34', '12', 'Gender');
INSERT INTO `site_lang` VALUES ('35', '12', 'Male');
INSERT INTO `site_lang` VALUES ('36', '12', 'Female');
INSERT INTO `site_lang` VALUES ('31', '12', 'Please select');
INSERT INTO `site_lang` VALUES ('30', '12', 'Birthday');
INSERT INTO `site_lang` VALUES ('27', '12', 'Your name or nickname');
INSERT INTO `site_lang` VALUES ('28', '12', 'Email');
INSERT INTO `site_lang` VALUES ('29', '12', 'Password');
INSERT INTO `site_lang` VALUES ('26', '12', 'Name');
INSERT INTO `site_lang` VALUES ('25', '12', 'Join the worlds bestest community for meeting new people!.');
INSERT INTO `site_lang` VALUES ('24', '12', 'Become a member now');
INSERT INTO `site_lang` VALUES ('23', '12', 'Play our popular Discover game and get matched with other users. Its a great way to break the ice and chat to new people.');
INSERT INTO `site_lang` VALUES ('22', '12', 'Matches');
INSERT INTO `site_lang` VALUES ('21', '12', 'We wont show your exact location, but you will be able to find people nearby who like the same things you do.');
INSERT INTO `site_lang` VALUES ('20', '12', 'People nearby');
INSERT INTO `site_lang` VALUES ('19', '12', 'You can make quality videocalls for free to anyone, without limits of call duration, just enjoy seeing the person who is chatting with you');
INSERT INTO `site_lang` VALUES ('18', '12', 'Video Chat');
INSERT INTO `site_lang` VALUES ('17', '12', 'Powerfull private chat for meet new friends, you can send emoticons and private photos to anyone.');
INSERT INTO `site_lang` VALUES ('16', '12', 'Chat');
INSERT INTO `site_lang` VALUES ('15', '12', 'Recover password');
INSERT INTO `site_lang` VALUES ('14', '12', 'Password recover');
INSERT INTO `site_lang` VALUES ('13', '12', 'Login now');
INSERT INTO `site_lang` VALUES ('12', '12', 'do you forget your password?');
INSERT INTO `site_lang` VALUES ('11', '12', 'Your password');
INSERT INTO `site_lang` VALUES ('10', '12', 'Your email');
INSERT INTO `site_lang` VALUES ('9', '12', 'Welcome back');
INSERT INTO `site_lang` VALUES ('8', '12', 'Create your account');
INSERT INTO `site_lang` VALUES ('7', '12', 'Connect with ');
INSERT INTO `site_lang` VALUES ('6', '12', 'SOON AVAILABLE');
INSERT INTO `site_lang` VALUES ('5', '12', 'Soon we will have our phone apps online');
INSERT INTO `site_lang` VALUES ('4', '12', 'Please visit us from your laptop or PC');
INSERT INTO `site_lang` VALUES ('1', '12', 'Login');
INSERT INTO `site_lang` VALUES ('3', '12', 'For now our site works only for Desktop users');
INSERT INTO `site_lang` VALUES ('2', '12', 'Welcome to the fastest growing place to meet new people');
INSERT INTO `site_lang` VALUES ('0', '12', 'meet new people!');
INSERT INTO `site_lang` VALUES ('383', '10', 'must like you for start a videocall');
INSERT INTO `site_lang` VALUES ('384', '10', 'Ok, i understand');
INSERT INTO `site_lang` VALUES ('382', '10', 'dont like you');
INSERT INTO `site_lang` VALUES ('381', '10', 'calling...');
INSERT INTO `site_lang` VALUES ('380', '10', 'Welcome to');
INSERT INTO `site_lang` VALUES ('379', '10', 'Go to');
INSERT INTO `site_lang` VALUES ('378', '10', 'Please save your connection information in a safe place');
INSERT INTO `site_lang` VALUES ('376', '10', 'E-mail');
INSERT INTO `site_lang` VALUES ('377', '10', 'Password');
INSERT INTO `site_lang` VALUES ('375', '10', 'Here are your connection details');
INSERT INTO `site_lang` VALUES ('374', '10', 'Start meeting new people now');
INSERT INTO `site_lang` VALUES ('373', '10', 'More than 1 million people have joined $site_name You probably want to know some of them.');
INSERT INTO `site_lang` VALUES ('372', '10', 'Add photos and complete your profile');
INSERT INTO `site_lang` VALUES ('370', '10', 'Meet new people');
INSERT INTO `site_lang` VALUES ('371', '10', 'Nobody is going to fall in love with a blank page. The more information you get, the more chances to find that special someone!');
INSERT INTO `site_lang` VALUES ('366', '10', 'Newsflash');
INSERT INTO `site_lang` VALUES ('367', '10', 'people in your area wants to know you');
INSERT INTO `site_lang` VALUES ('368', '10', 'In');
INSERT INTO `site_lang` VALUES ('369', '10', 'you can meet people instantly');
INSERT INTO `site_lang` VALUES ('363', '10', 'Here are a few tips');
INSERT INTO `site_lang` VALUES ('365', '10', 'Verify your account');
INSERT INTO `site_lang` VALUES ('364', '10', 'Now you are a new member of');
INSERT INTO `site_lang` VALUES ('362', '10', 'Well done, now you are in');
INSERT INTO `site_lang` VALUES ('361', '10', 'Welcome');
INSERT INTO `site_lang` VALUES ('360', '10', 'Check out the profile');
INSERT INTO `site_lang` VALUES ('359', '10', 'and lives closer to you');
INSERT INTO `site_lang` VALUES ('358', '10', 'is new at');
INSERT INTO `site_lang` VALUES ('357', '10', 'is new and lives closer to you');
INSERT INTO `site_lang` VALUES ('356', '10', 'Have fun!');
INSERT INTO `site_lang` VALUES ('355', '10', 'Respond to');
INSERT INTO `site_lang` VALUES ('354', '10', 'you have a new message from');
INSERT INTO `site_lang` VALUES ('353', '10', 'New message from');
INSERT INTO `site_lang` VALUES ('352', '10', 'Go and say something to');
INSERT INTO `site_lang` VALUES ('351', '10', 'thinks the feeling is mutual');
INSERT INTO `site_lang` VALUES ('350', '10', 'Its a match!');
INSERT INTO `site_lang` VALUES ('349', '10', 'You have a match at');
INSERT INTO `site_lang` VALUES ('348', '10', 'if you forgot your password, click on the link below to get a new');
INSERT INTO `site_lang` VALUES ('347', '10', 'Choose a new password');
INSERT INTO `site_lang` VALUES ('346', '10', 'Unsubscribe');
INSERT INTO `site_lang` VALUES ('345', '10', 'You received this notice because you registered as');
INSERT INTO `site_lang` VALUES ('344', '10', 'Find out if you also like');
INSERT INTO `site_lang` VALUES ('343', '10', 'has seen you in discover and likes. The feeling is mutual?');
INSERT INTO `site_lang` VALUES ('342', '10', 'likes you and wants to chat in');
INSERT INTO `site_lang` VALUES ('341', '10', 'We sent you a email with your info, it may take up to 1 min to arrive');
INSERT INTO `site_lang` VALUES ('340', '10', 'Loading...');
INSERT INTO `site_lang` VALUES ('339', '10', 'of');
INSERT INTO `site_lang` VALUES ('338', '10', 'Photos of ');
INSERT INTO `site_lang` VALUES ('337', '10', 'is calling you..');
INSERT INTO `site_lang` VALUES ('334', '10', 'Spotlight');
INSERT INTO `site_lang` VALUES ('335', '10', 'Service cost');
INSERT INTO `site_lang` VALUES ('336', '10', 'Password successfully changed');
INSERT INTO `site_lang` VALUES ('333', '10', 'Wrong');
INSERT INTO `site_lang` VALUES ('330', '10', 'You need to write your username!');
INSERT INTO `site_lang` VALUES ('331', '10', 'username');
INSERT INTO `site_lang` VALUES ('332', '10', 'days of Premium');
INSERT INTO `site_lang` VALUES ('329', '10', 'Write your instagram username');
INSERT INTO `site_lang` VALUES ('326', '10', 'Report and block');
INSERT INTO `site_lang` VALUES ('327', '10', 'Are you sure you want to report');
INSERT INTO `site_lang` VALUES ('328', '10', 'Press backspace key for smart return to the meeting section.');
INSERT INTO `site_lang` VALUES ('322', '10', 'Hi, im');
INSERT INTO `site_lang` VALUES ('323', '10', 'years old and im from');
INSERT INTO `site_lang` VALUES ('324', '10', 'We sended you a email for verify your account');
INSERT INTO `site_lang` VALUES ('325', '10', 'is blocking you or you blocked him, you cant chat with him sorry');
INSERT INTO `site_lang` VALUES ('321', '10', 'Please add a profile photo');
INSERT INTO `site_lang` VALUES ('317', '10', 'minutes');
INSERT INTO `site_lang` VALUES ('318', '10', 'seconds');
INSERT INTO `site_lang` VALUES ('319', '10', 'ago');
INSERT INTO `site_lang` VALUES ('320', '10', 'Please verify your account, check your email');
INSERT INTO `site_lang` VALUES ('316', '10', 'hours');
INSERT INTO `site_lang` VALUES ('315', '10', 'days');
INSERT INTO `site_lang` VALUES ('314', '10', 'months');
INSERT INTO `site_lang` VALUES ('313', '10', 'years');
INSERT INTO `site_lang` VALUES ('312', '10', 'second');
INSERT INTO `site_lang` VALUES ('311', '10', 'minute');
INSERT INTO `site_lang` VALUES ('310', '10', 'hour');
INSERT INTO `site_lang` VALUES ('309', '10', 'day');
INSERT INTO `site_lang` VALUES ('308', '10', 'month');
INSERT INTO `site_lang` VALUES ('307', '10', 'year');
INSERT INTO `site_lang` VALUES ('306', '10', '0 seconds');
INSERT INTO `site_lang` VALUES ('304', '10', 'Cost');
INSERT INTO `site_lang` VALUES ('305', '10', 'Credits for $');
INSERT INTO `site_lang` VALUES ('302', '10', 'visited');
INSERT INTO `site_lang` VALUES ('303', '10', 'You do not like anyone');
INSERT INTO `site_lang` VALUES ('301', '10', 'You dont have any visit yet');
INSERT INTO `site_lang` VALUES ('298', '10', 'Like');
INSERT INTO `site_lang` VALUES ('299', '10', 'Dislike');
INSERT INTO `site_lang` VALUES ('300', '10', 'AGE');
INSERT INTO `site_lang` VALUES ('297', '10', 'Messages');
INSERT INTO `site_lang` VALUES ('296', '10', 'people liked you, for see them');
INSERT INTO `site_lang` VALUES ('295', '10', 'People i like');
INSERT INTO `site_lang` VALUES ('294', '10', 'Upgrade your account to premium');
INSERT INTO `site_lang` VALUES ('293', '10', 'people visited your profile for see them');
INSERT INTO `site_lang` VALUES ('292', '10', 'Delete');
INSERT INTO `site_lang` VALUES ('291', '10', 'Public photo');
INSERT INTO `site_lang` VALUES ('289', '10', 'Set as profile');
INSERT INTO `site_lang` VALUES ('290', '10', 'Private photo');
INSERT INTO `site_lang` VALUES ('288', '10', 'get seen by millions');
INSERT INTO `site_lang` VALUES ('286', '10', 'Visits');
INSERT INTO `site_lang` VALUES ('287', '10', 'Add me here');
INSERT INTO `site_lang` VALUES ('284', '10', 'Photos');
INSERT INTO `site_lang` VALUES ('285', '10', 'Credits');
INSERT INTO `site_lang` VALUES ('283', '10', 'Add');
INSERT INTO `site_lang` VALUES ('281', '10', 'Private photos');
INSERT INTO `site_lang` VALUES ('282', '10', 'Add from ');
INSERT INTO `site_lang` VALUES ('279', '10', 'No data');
INSERT INTO `site_lang` VALUES ('280', '10', 'Public Photos');
INSERT INTO `site_lang` VALUES ('278', '10', 'Fans');
INSERT INTO `site_lang` VALUES ('277', '10', 'Report');
INSERT INTO `site_lang` VALUES ('276', '10', 'Interests');
INSERT INTO `site_lang` VALUES ('274', '10', 'Year');
INSERT INTO `site_lang` VALUES ('275', '10', 'Please wait');
INSERT INTO `site_lang` VALUES ('273', '10', 'Month');
INSERT INTO `site_lang` VALUES ('272', '10', 'Day');
INSERT INTO `site_lang` VALUES ('271', '10', 'When someone send me a message');
INSERT INTO `site_lang` VALUES ('270', '10', 'When new users near me join in');
INSERT INTO `site_lang` VALUES ('269', '10', 'When i get a match');
INSERT INTO `site_lang` VALUES ('268', '10', 'When someone likes me');
INSERT INTO `site_lang` VALUES ('266', '10', 'I own a motorbike');
INSERT INTO `site_lang` VALUES ('267', '10', 'None');
INSERT INTO `site_lang` VALUES ('265', '10', 'I own a car');
INSERT INTO `site_lang` VALUES ('264', '10', 'Parents car');
INSERT INTO `site_lang` VALUES ('263', '10', 'Transport');
INSERT INTO `site_lang` VALUES ('262', '10', 'Drink');
INSERT INTO `site_lang` VALUES ('260', '10', 'No');
INSERT INTO `site_lang` VALUES ('261', '10', 'Sometimes');
INSERT INTO `site_lang` VALUES ('259', '10', 'Yes');
INSERT INTO `site_lang` VALUES ('258', '10', 'Smoke');
INSERT INTO `site_lang` VALUES ('257', '10', 'Alone');
INSERT INTO `site_lang` VALUES ('256', '10', 'With partner');
INSERT INTO `site_lang` VALUES ('255', '10', 'Student dormitory');
INSERT INTO `site_lang` VALUES ('254', '10', 'With housemate');
INSERT INTO `site_lang` VALUES ('253', '10', 'With parents');
INSERT INTO `site_lang` VALUES ('250', '10', 'Heavy set');
INSERT INTO `site_lang` VALUES ('251', '10', 'Curvy');
INSERT INTO `site_lang` VALUES ('252', '10', 'Living');
INSERT INTO `site_lang` VALUES ('249', '10', 'Athletic');
INSERT INTO `site_lang` VALUES ('248', '10', 'Average');
INSERT INTO `site_lang` VALUES ('247', '10', 'Slim');
INSERT INTO `site_lang` VALUES ('246', '10', 'Body type');
INSERT INTO `site_lang` VALUES ('245', '10', 'Other');
INSERT INTO `site_lang` VALUES ('244', '10', 'Indian');
INSERT INTO `site_lang` VALUES ('243', '10', 'Pacific Islander');
INSERT INTO `site_lang` VALUES ('242', '10', 'Hispanic/latin');
INSERT INTO `site_lang` VALUES ('241', '10', 'Native American');
INSERT INTO `site_lang` VALUES ('240', '10', 'White');
INSERT INTO `site_lang` VALUES ('239', '10', 'Black');
INSERT INTO `site_lang` VALUES ('238', '10', 'Middle Eastern');
INSERT INTO `site_lang` VALUES ('237', '10', 'Asian');
INSERT INTO `site_lang` VALUES ('236', '10', 'Ethnicity');
INSERT INTO `site_lang` VALUES ('235', '10', 'Weight');
INSERT INTO `site_lang` VALUES ('234', '10', 'more than');
INSERT INTO `site_lang` VALUES ('232', '10', 'Height');
INSERT INTO `site_lang` VALUES ('233', '10', 'less than');
INSERT INTO `site_lang` VALUES ('231', '10', 'Bisexual');
INSERT INTO `site_lang` VALUES ('230', '10', 'Straight');
INSERT INTO `site_lang` VALUES ('229', '10', 'Open-minded');
INSERT INTO `site_lang` VALUES ('228', '10', 'Gay');
INSERT INTO `site_lang` VALUES ('226', '10', 'Open');
INSERT INTO `site_lang` VALUES ('227', '10', 'Sexuality');
INSERT INTO `site_lang` VALUES ('224', '10', 'Single');
INSERT INTO `site_lang` VALUES ('225', '10', 'Taken');
INSERT INTO `site_lang` VALUES ('223', '10', 'Relationship');
INSERT INTO `site_lang` VALUES ('222', '10', 'Extended info (optional)');
INSERT INTO `site_lang` VALUES ('221', '10', 'Notifications');
INSERT INTO `site_lang` VALUES ('220', '10', 'UPGRADE');
INSERT INTO `site_lang` VALUES ('219', '10', 'Basic');
INSERT INTO `site_lang` VALUES ('218', '10', 'until');
INSERT INTO `site_lang` VALUES ('217', '10', 'Wait more');
INSERT INTO `site_lang` VALUES ('216', '10', 'End call');
INSERT INTO `site_lang` VALUES ('215', '10', 'Seems that your friend do not have webcam or he is not available');
INSERT INTO `site_lang` VALUES ('214', '10', 'Too long wait');
INSERT INTO `site_lang` VALUES ('213', '10', 'You cant make videocall because you dont have webcam');
INSERT INTO `site_lang` VALUES ('212', '10', 'Impossible to make a call!');
INSERT INTO `site_lang` VALUES ('211', '10', 'Only premium users can make videocalls');
INSERT INTO `site_lang` VALUES ('210', '10', 'You are already in a videocall, you have to end the other call before start another');
INSERT INTO `site_lang` VALUES ('209', '10', 'Please allow access to your Webcam.');
INSERT INTO `site_lang` VALUES ('208', '10', 'is offline, try again when your friend is online');
INSERT INTO `site_lang` VALUES ('207', '10', 'is in another videocall , you cant call now');
INSERT INTO `site_lang` VALUES ('206', '10', 'Yes, delete it!');
INSERT INTO `site_lang` VALUES ('205', '10', 'Your data will be lost without recovery, continue?');
INSERT INTO `site_lang` VALUES ('204', '10', 'Account termination');
INSERT INTO `site_lang` VALUES ('203', '10', 'Information updated successfully');
INSERT INTO `site_lang` VALUES ('202', '10', 'Yes, buy it!');
INSERT INTO `site_lang` VALUES ('201', '10', 'more daily conversation, cost ');
INSERT INTO `site_lang` VALUES ('200', '10', 'Expand daily limitation ');
INSERT INTO `site_lang` VALUES ('199', '10', 'You dont have enought credits for send the gift');
INSERT INTO `site_lang` VALUES ('198', '10', 'Please, select 1 gift');
INSERT INTO `site_lang` VALUES ('197', '10', 'Please, select 1 photo');
INSERT INTO `site_lang` VALUES ('196', '10', 'Please, select a payment method');
INSERT INTO `site_lang` VALUES ('195', '10', 'No thanks');
INSERT INTO `site_lang` VALUES ('194', '10', 'Get access');
INSERT INTO `site_lang` VALUES ('193', '10', 'private photos for ');
INSERT INTO `site_lang` VALUES ('192', '10', 'Get access to');
INSERT INTO `site_lang` VALUES ('191', '10', 'Buy private photos permission');
INSERT INTO `site_lang` VALUES ('190', '10', 'No, i cant show you my private photos');
INSERT INTO `site_lang` VALUES ('179', '10', 'Login to my account');
INSERT INTO `site_lang` VALUES ('180', '10', 'Password recover');
INSERT INTO `site_lang` VALUES ('181', '10', 'Invalid email format');
INSERT INTO `site_lang` VALUES ('182', '10', 'Please fill all the inputs');
INSERT INTO `site_lang` VALUES ('183', '10', 'Email dont exist');
INSERT INTO `site_lang` VALUES ('184', '10', 'Wrong password');
INSERT INTO `site_lang` VALUES ('185', '10', 'Add a valid date');
INSERT INTO `site_lang` VALUES ('186', '10', 'Choose city from the autocomplete');
INSERT INTO `site_lang` VALUES ('187', '10', 'Password too short');
INSERT INTO `site_lang` VALUES ('188', '10', 'Email already exist, try another');
INSERT INTO `site_lang` VALUES ('189', '10', 'Yes, you can see my private photos');
INSERT INTO `site_lang` VALUES ('178', '10', 'If you dont remember your password, click the link below to set a new one:');
INSERT INTO `site_lang` VALUES ('177', '10', 'Hi');
INSERT INTO `site_lang` VALUES ('175', '10', 'Yes');
INSERT INTO `site_lang` VALUES ('176', '10', 'No');
INSERT INTO `site_lang` VALUES ('173', '10', 'like this');
INSERT INTO `site_lang` VALUES ('174', '10', 'Hello, can i have access to your private photos ?');
INSERT INTO `site_lang` VALUES ('172', '10', 'persons more like this');
INSERT INTO `site_lang` VALUES ('171', '10', 'Days Premium');
INSERT INTO `site_lang` VALUES ('161', '10', 'April');
INSERT INTO `site_lang` VALUES ('162', '10', 'May');
INSERT INTO `site_lang` VALUES ('163', '10', 'June');
INSERT INTO `site_lang` VALUES ('164', '10', 'July');
INSERT INTO `site_lang` VALUES ('165', '10', 'August');
INSERT INTO `site_lang` VALUES ('166', '10', 'September');
INSERT INTO `site_lang` VALUES ('167', '10', 'October');
INSERT INTO `site_lang` VALUES ('168', '10', 'November');
INSERT INTO `site_lang` VALUES ('169', '10', 'December');
INSERT INTO `site_lang` VALUES ('170', '10', 'Buy');
INSERT INTO `site_lang` VALUES ('160', '10', 'March');
INSERT INTO `site_lang` VALUES ('159', '10', 'February');
INSERT INTO `site_lang` VALUES ('158', '10', 'January');
INSERT INTO `site_lang` VALUES ('155', '10', 'No popular users near you');
INSERT INTO `site_lang` VALUES ('156', '10', 'You dont have any fans yet');
INSERT INTO `site_lang` VALUES ('157', '10', 'You dont have matches yet');
INSERT INTO `site_lang` VALUES ('152', '10', 'Verified');
INSERT INTO `site_lang` VALUES ('153', '10', 'Nothing found');
INSERT INTO `site_lang` VALUES ('154', '10', 'people found');
INSERT INTO `site_lang` VALUES ('151', '10', 'Online now');
INSERT INTO `site_lang` VALUES ('149', '10', 'After delete your profile, some of your data will be lost without recovery.');
INSERT INTO `site_lang` VALUES ('150', '10', 'Delete profile');
INSERT INTO `site_lang` VALUES ('148', '10', 'Profile desactivation');
INSERT INTO `site_lang` VALUES ('146', '10', 'You can change your current password bellow');
INSERT INTO `site_lang` VALUES ('147', '10', 'New password');
INSERT INTO `site_lang` VALUES ('145', '10', 'Change password');
INSERT INTO `site_lang` VALUES ('144', '10', 'Upgrade to premium account');
INSERT INTO `site_lang` VALUES ('143', '10', 'Add credits');
INSERT INTO `site_lang` VALUES ('142', '10', 'Current credits');
INSERT INTO `site_lang` VALUES ('140', '10', 'Buy credits for send Gifs and Unblock private photos');
INSERT INTO `site_lang` VALUES ('141', '10', 'Account type');
INSERT INTO `site_lang` VALUES ('139', '10', 'You are account is already verified');
INSERT INTO `site_lang` VALUES ('138', '10', 'Connect with Facebook');
INSERT INTO `site_lang` VALUES ('136', '10', 'Verify account');
INSERT INTO `site_lang` VALUES ('137', '10', 'For verify your account , connect with your facebook account');
INSERT INTO `site_lang` VALUES ('135', '10', 'Update profile');
INSERT INTO `site_lang` VALUES ('134', '10', 'Site language');
INSERT INTO `site_lang` VALUES ('133', '10', 'You can edit your profile information bellow');
INSERT INTO `site_lang` VALUES ('132', '10', 'Personal information');
INSERT INTO `site_lang` VALUES ('131', '10', 'Delete');
INSERT INTO `site_lang` VALUES ('130', '10', 'Change password');
INSERT INTO `site_lang` VALUES ('129', '10', 'Verify');
INSERT INTO `site_lang` VALUES ('128', '10', 'Credits');
INSERT INTO `site_lang` VALUES ('127', '10', 'Personal');
INSERT INTO `site_lang` VALUES ('126', '10', 'Unblock private photos');
INSERT INTO `site_lang` VALUES ('124', '10', 'Now you have');
INSERT INTO `site_lang` VALUES ('125', '10', 'Ask permission to');
INSERT INTO `site_lang` VALUES ('123', '10', 'Credits successfully added to your account');
INSERT INTO `site_lang` VALUES ('122', '10', 'boys and girls');
INSERT INTO `site_lang` VALUES ('121', '10', 'Only girls');
INSERT INTO `site_lang` VALUES ('120', '10', 'Only boys');
INSERT INTO `site_lang` VALUES ('116', '10', 'Most popular users');
INSERT INTO `site_lang` VALUES ('117', '10', 'About ');
INSERT INTO `site_lang` VALUES ('118', '10', 'Personal info');
INSERT INTO `site_lang` VALUES ('119', '10', 'years old');
INSERT INTO `site_lang` VALUES ('115', '10', 'World');
INSERT INTO `site_lang` VALUES ('113', '10', 'who are between');
INSERT INTO `site_lang` VALUES ('114', '10', 'in a radius of');
INSERT INTO `site_lang` VALUES ('112', '10', 'Both');
INSERT INTO `site_lang` VALUES ('111', '10', 'Boys');
INSERT INTO `site_lang` VALUES ('109', '10', 'Show me');
INSERT INTO `site_lang` VALUES ('110', '10', 'Girls');
INSERT INTO `site_lang` VALUES ('106', '10', 'Filter Search');
INSERT INTO `site_lang` VALUES ('107', '10', 'All users');
INSERT INTO `site_lang` VALUES ('108', '10', 'Online now');
INSERT INTO `site_lang` VALUES ('101', '10', 'Your fans');
INSERT INTO `site_lang` VALUES ('102', '10', 'Privacy Policy');
INSERT INTO `site_lang` VALUES ('103', '10', 'Terms of Use');
INSERT INTO `site_lang` VALUES ('104', '10', 'Please complete your profile before start in ');
INSERT INTO `site_lang` VALUES ('105', '10', 'Your matches');
INSERT INTO `site_lang` VALUES ('100', '10', 'or wait until tomorrow for continue meeting people');
INSERT INTO `site_lang` VALUES ('99', '10', 'daily conversations');
INSERT INTO `site_lang` VALUES ('98', '10', 'and get up to');
INSERT INTO `site_lang` VALUES ('96', '10', 'or');
INSERT INTO `site_lang` VALUES ('97', '10', 'Upgrade your account to Premium');
INSERT INTO `site_lang` VALUES ('95', '10', 'more daily conversation');
INSERT INTO `site_lang` VALUES ('94', '10', 'Buy');
INSERT INTO `site_lang` VALUES ('93', '10', 'To continue chatting');
INSERT INTO `site_lang` VALUES ('92', '10', 'you have reached the limit of new daily conversations');
INSERT INTO `site_lang` VALUES ('91', '10', 'Chat');
INSERT INTO `site_lang` VALUES ('90', '10', 'Send');
INSERT INTO `site_lang` VALUES ('89', '10', 'Write text here');
INSERT INTO `site_lang` VALUES ('88', '10', 'Premium user badge');
INSERT INTO `site_lang` VALUES ('87', '10', 'Unblock all private photos');
INSERT INTO `site_lang` VALUES ('86', '10', 'Unlimited videocalls');
INSERT INTO `site_lang` VALUES ('85', '10', 'new chats per day');
INSERT INTO `site_lang` VALUES ('84', '10', 'Premium Account Features');
INSERT INTO `site_lang` VALUES ('83', '10', 'Buy credits');
INSERT INTO `site_lang` VALUES ('82', '10', 'Pay with');
INSERT INTO `site_lang` VALUES ('81', '10', 'Pay with');
INSERT INTO `site_lang` VALUES ('80', '10', 'Select payment method');
INSERT INTO `site_lang` VALUES ('79', '10', 'Select credits package');
INSERT INTO `site_lang` VALUES ('78', '10', 'Buy credits / Upgrade account');
INSERT INTO `site_lang` VALUES ('77', '10', 'Send gift');
INSERT INTO `site_lang` VALUES ('76', '10', 'Pick the gift you want to send to ');
INSERT INTO `site_lang` VALUES ('75', '10', 'Send gift to ');
INSERT INTO `site_lang` VALUES ('74', '10', 'Add photo');
INSERT INTO `site_lang` VALUES ('73', '10', 'Credits');
INSERT INTO `site_lang` VALUES ('72', '10', 'Pick the photo you want to show in the Spotlight, cost ');
INSERT INTO `site_lang` VALUES ('71', '10', 'Add yourself to the Spotlight');
INSERT INTO `site_lang` VALUES ('70', '10', 'add photos');
INSERT INTO `site_lang` VALUES ('69', '10', 'Add your photos');
INSERT INTO `site_lang` VALUES ('66', '10', 'All Photos');
INSERT INTO `site_lang` VALUES ('67', '10', 'Public Photos');
INSERT INTO `site_lang` VALUES ('68', '10', 'Private Photos');
INSERT INTO `site_lang` VALUES ('65', '10', 'Manage your photos');
INSERT INTO `site_lang` VALUES ('64', '10', 'Contact');
INSERT INTO `site_lang` VALUES ('63', '10', 'Privacy');
INSERT INTO `site_lang` VALUES ('62', '10', 'Terms');
INSERT INTO `site_lang` VALUES ('61', '10', 'Who to like');
INSERT INTO `site_lang` VALUES ('60', '10', 'New messages');
INSERT INTO `site_lang` VALUES ('58', '10', 'Conversations');
INSERT INTO `site_lang` VALUES ('59', '10', 'Online now');
INSERT INTO `site_lang` VALUES ('57', '10', 'Fans');
INSERT INTO `site_lang` VALUES ('56', '10', 'All');
INSERT INTO `site_lang` VALUES ('55', '10', 'Settings');
INSERT INTO `site_lang` VALUES ('54', '10', 'Manage photos');
INSERT INTO `site_lang` VALUES ('53', '10', 'Fans');
INSERT INTO `site_lang` VALUES ('52', '10', 'Most populars');
INSERT INTO `site_lang` VALUES ('51', '10', 'Matches');
INSERT INTO `site_lang` VALUES ('50', '10', 'Discover');
INSERT INTO `site_lang` VALUES ('49', '10', 'Meet new people');
INSERT INTO `site_lang` VALUES ('48', '10', 'Logout');
INSERT INTO `site_lang` VALUES ('47', '10', 'Settings');
INSERT INTO `site_lang` VALUES ('46', '10', 'Profile');
INSERT INTO `site_lang` VALUES ('44', '10', 'and');
INSERT INTO `site_lang` VALUES ('45', '10', 'Privacy Policy');
INSERT INTO `site_lang` VALUES ('43', '10', 'Terms and Conditions');
INSERT INTO `site_lang` VALUES ('42', '10', 'By continuing, you are confirming that you have read and agree to our');
INSERT INTO `site_lang` VALUES ('41', '10', 'Sign up');
INSERT INTO `site_lang` VALUES ('40', '10', 'Meet boys and girls');
INSERT INTO `site_lang` VALUES ('39', '10', 'Meet boys');
INSERT INTO `site_lang` VALUES ('37', '10', 'Im here to');
INSERT INTO `site_lang` VALUES ('38', '10', 'Meet girls');
INSERT INTO `site_lang` VALUES ('36', '10', 'Female');
INSERT INTO `site_lang` VALUES ('34', '10', 'Gender');
INSERT INTO `site_lang` VALUES ('35', '10', 'Male');
INSERT INTO `site_lang` VALUES ('33', '10', 'Where do you live?');
INSERT INTO `site_lang` VALUES ('32', '10', 'City');
INSERT INTO `site_lang` VALUES ('31', '10', 'Please select');
INSERT INTO `site_lang` VALUES ('29', '10', 'Password');
INSERT INTO `site_lang` VALUES ('30', '10', 'Birthday');
INSERT INTO `site_lang` VALUES ('28', '10', 'Email');
INSERT INTO `site_lang` VALUES ('27', '10', 'Your name or nickname');
INSERT INTO `site_lang` VALUES ('26', '10', 'Name');
INSERT INTO `site_lang` VALUES ('25', '10', 'Join the worlds bestest community for meeting new people!.');
INSERT INTO `site_lang` VALUES ('24', '10', 'Become a member now');
INSERT INTO `site_lang` VALUES ('23', '10', 'Play our popular Discover game and get matched with other users. Its a great way to break the ice and chat to new people.');
INSERT INTO `site_lang` VALUES ('22', '10', 'Matches');
INSERT INTO `site_lang` VALUES ('21', '10', 'We wont show your exact location, but you will be able to find people nearby who like the same things you do.');
INSERT INTO `site_lang` VALUES ('20', '10', 'People nearby');
INSERT INTO `site_lang` VALUES ('19', '10', 'You can make quality videocalls for free to anyone, without limits of call duration, just enjoy seeing the person who is chatting with you');
INSERT INTO `site_lang` VALUES ('18', '10', 'Video Chat');
INSERT INTO `site_lang` VALUES ('17', '10', 'Powerfull private chat for meet new friends, you can send emoticons and private photos to anyone.');
INSERT INTO `site_lang` VALUES ('16', '10', 'Chat');
INSERT INTO `site_lang` VALUES ('15', '10', 'Recover password');
INSERT INTO `site_lang` VALUES ('14', '10', 'Password recover');
INSERT INTO `site_lang` VALUES ('13', '10', 'Login now');
INSERT INTO `site_lang` VALUES ('12', '10', 'do you forget your password?');
INSERT INTO `site_lang` VALUES ('11', '10', 'Your password');
INSERT INTO `site_lang` VALUES ('10', '10', 'Your email');
INSERT INTO `site_lang` VALUES ('9', '10', 'Welcome back');
INSERT INTO `site_lang` VALUES ('8', '10', 'Create your account');
INSERT INTO `site_lang` VALUES ('7', '10', 'Connect with ');
INSERT INTO `site_lang` VALUES ('6', '10', 'SOON AVAILABLE');
INSERT INTO `site_lang` VALUES ('5', '10', 'Soon we will have our phone apps online');
INSERT INTO `site_lang` VALUES ('4', '10', 'Please visit us from your laptop or PC');
INSERT INTO `site_lang` VALUES ('0', '10', 'meet new people!');
INSERT INTO `site_lang` VALUES ('1', '10', 'Login');
INSERT INTO `site_lang` VALUES ('2', '10', 'Welcome to the fastest growing place to meet new people');
INSERT INTO `site_lang` VALUES ('3', '10', 'For now our site works only for Desktop users');
INSERT INTO `site_lang` VALUES ('384', '9', 'Ok, i understand');
INSERT INTO `site_lang` VALUES ('376', '9', 'E-mail');
INSERT INTO `site_lang` VALUES ('377', '9', 'Password');
INSERT INTO `site_lang` VALUES ('378', '9', 'Please save your connection information in a safe place');
INSERT INTO `site_lang` VALUES ('379', '9', 'Go to');
INSERT INTO `site_lang` VALUES ('380', '9', 'Welcome to');
INSERT INTO `site_lang` VALUES ('381', '9', 'calling...');
INSERT INTO `site_lang` VALUES ('382', '9', 'dont like you');
INSERT INTO `site_lang` VALUES ('383', '9', 'must like you for start a videocall');
INSERT INTO `site_lang` VALUES ('375', '9', 'Here are your connection details');
INSERT INTO `site_lang` VALUES ('374', '9', 'Start meeting new people now');
INSERT INTO `site_lang` VALUES ('373', '9', 'More than 1 million people have joined $site_name You probably want to know some of them.');
INSERT INTO `site_lang` VALUES ('372', '9', 'Add photos and complete your profile');
INSERT INTO `site_lang` VALUES ('371', '9', 'Nobody is going to fall in love with a blank page. The more information you get, the more chances to find that special someone!');
INSERT INTO `site_lang` VALUES ('370', '9', 'Meet new people');
INSERT INTO `site_lang` VALUES ('369', '9', 'you can meet people instantly');
INSERT INTO `site_lang` VALUES ('368', '9', 'In');
INSERT INTO `site_lang` VALUES ('366', '9', 'Newsflash');
INSERT INTO `site_lang` VALUES ('367', '9', 'people in your area wants to know you');
INSERT INTO `site_lang` VALUES ('365', '9', 'Verify your account');
INSERT INTO `site_lang` VALUES ('363', '9', 'Here are a few tips');
INSERT INTO `site_lang` VALUES ('364', '9', 'Now you are a new member of');
INSERT INTO `site_lang` VALUES ('361', '9', 'Welcome');
INSERT INTO `site_lang` VALUES ('362', '9', 'Well done, now you are in');
INSERT INTO `site_lang` VALUES ('360', '9', 'Check out the profile');
INSERT INTO `site_lang` VALUES ('359', '9', 'and lives closer to you');
INSERT INTO `site_lang` VALUES ('358', '9', 'is new at');
INSERT INTO `site_lang` VALUES ('357', '9', 'is new and lives closer to you');
INSERT INTO `site_lang` VALUES ('356', '9', 'Have fun!');
INSERT INTO `site_lang` VALUES ('355', '9', 'Respond to');
INSERT INTO `site_lang` VALUES ('354', '9', 'you have a new message from');
INSERT INTO `site_lang` VALUES ('352', '9', 'Go and say something to');
INSERT INTO `site_lang` VALUES ('353', '9', 'New message from');
INSERT INTO `site_lang` VALUES ('351', '9', 'thinks the feeling is mutual');
INSERT INTO `site_lang` VALUES ('350', '9', 'Its a match!');
INSERT INTO `site_lang` VALUES ('349', '9', 'You have a match at');
INSERT INTO `site_lang` VALUES ('348', '9', 'if you forgot your password, click on the link below to get a new');
INSERT INTO `site_lang` VALUES ('347', '9', 'Choose a new password');
INSERT INTO `site_lang` VALUES ('346', '9', 'Unsubscribe');
INSERT INTO `site_lang` VALUES ('343', '9', 'has seen you in discover and likes. The feeling is mutual?');
INSERT INTO `site_lang` VALUES ('345', '9', 'You received this notice because you registered as');
INSERT INTO `site_lang` VALUES ('344', '9', 'Find out if you also like');
INSERT INTO `site_lang` VALUES ('342', '9', 'likes you and wants to chat in');
INSERT INTO `site_lang` VALUES ('338', '9', 'Photos of ');
INSERT INTO `site_lang` VALUES ('339', '9', 'of');
INSERT INTO `site_lang` VALUES ('340', '9', 'Loading...');
INSERT INTO `site_lang` VALUES ('341', '9', 'We sent you a email with your info, it may take up to 1 min to arrive');
INSERT INTO `site_lang` VALUES ('337', '9', 'is calling you..');
INSERT INTO `site_lang` VALUES ('336', '9', 'Password successfully changed');
INSERT INTO `site_lang` VALUES ('335', '9', 'Service cost');
INSERT INTO `site_lang` VALUES ('334', '9', 'Spotlight');
INSERT INTO `site_lang` VALUES ('333', '9', 'Wrong');
INSERT INTO `site_lang` VALUES ('332', '9', 'days of Premium');
INSERT INTO `site_lang` VALUES ('331', '9', 'username');
INSERT INTO `site_lang` VALUES ('330', '9', 'You need to write your username!');
INSERT INTO `site_lang` VALUES ('329', '9', 'Write your instagram username');
INSERT INTO `site_lang` VALUES ('328', '9', 'Press backspace key for smart return to the meeting section.');
INSERT INTO `site_lang` VALUES ('327', '9', 'Are you sure you want to report');
INSERT INTO `site_lang` VALUES ('326', '9', 'Report and block');
INSERT INTO `site_lang` VALUES ('325', '9', 'is blocking you or you blocked him, you cant chat with him sorry');
INSERT INTO `site_lang` VALUES ('324', '9', 'We sended you a email for verify your account');
INSERT INTO `site_lang` VALUES ('323', '9', 'years old and im from');
INSERT INTO `site_lang` VALUES ('321', '9', 'Please add a profile photo');
INSERT INTO `site_lang` VALUES ('322', '9', 'Hi, im');
INSERT INTO `site_lang` VALUES ('319', '9', 'ago');
INSERT INTO `site_lang` VALUES ('320', '9', 'Please verify your account, check your email');
INSERT INTO `site_lang` VALUES ('318', '9', 'seconds');
INSERT INTO `site_lang` VALUES ('317', '9', 'minutes');
INSERT INTO `site_lang` VALUES ('316', '9', 'hours');
INSERT INTO `site_lang` VALUES ('315', '9', 'days');
INSERT INTO `site_lang` VALUES ('314', '9', 'months');
INSERT INTO `site_lang` VALUES ('313', '9', 'years');
INSERT INTO `site_lang` VALUES ('312', '9', 'second');
INSERT INTO `site_lang` VALUES ('311', '9', 'minute');
INSERT INTO `site_lang` VALUES ('310', '9', 'hour');
INSERT INTO `site_lang` VALUES ('309', '9', 'day');
INSERT INTO `site_lang` VALUES ('308', '9', 'month');
INSERT INTO `site_lang` VALUES ('307', '9', 'year');
INSERT INTO `site_lang` VALUES ('306', '9', '0 seconds');
INSERT INTO `site_lang` VALUES ('305', '9', 'Credits for $');
INSERT INTO `site_lang` VALUES ('304', '9', 'Cost');
INSERT INTO `site_lang` VALUES ('303', '9', 'You do not like anyone');
INSERT INTO `site_lang` VALUES ('302', '9', 'visited');
INSERT INTO `site_lang` VALUES ('301', '9', 'You dont have any visit yet');
INSERT INTO `site_lang` VALUES ('300', '9', 'AGE');
INSERT INTO `site_lang` VALUES ('299', '9', 'Dislike');
INSERT INTO `site_lang` VALUES ('298', '9', 'Like');
INSERT INTO `site_lang` VALUES ('297', '9', 'Messages');
INSERT INTO `site_lang` VALUES ('296', '9', 'people liked you, for see them');
INSERT INTO `site_lang` VALUES ('295', '9', 'People i like');
INSERT INTO `site_lang` VALUES ('294', '9', 'Upgrade your account to premium');
INSERT INTO `site_lang` VALUES ('293', '9', 'people visited your profile for see them');
INSERT INTO `site_lang` VALUES ('292', '9', 'Delete');
INSERT INTO `site_lang` VALUES ('291', '9', 'Public photo');
INSERT INTO `site_lang` VALUES ('290', '9', 'Private photo');
INSERT INTO `site_lang` VALUES ('289', '9', 'Set as profile');
INSERT INTO `site_lang` VALUES ('288', '9', 'get seen by millions');
INSERT INTO `site_lang` VALUES ('287', '9', 'Add me here');
INSERT INTO `site_lang` VALUES ('286', '9', 'Visits');
INSERT INTO `site_lang` VALUES ('285', '9', 'Credits');
INSERT INTO `site_lang` VALUES ('284', '9', 'Photos');
INSERT INTO `site_lang` VALUES ('283', '9', 'Add');
INSERT INTO `site_lang` VALUES ('282', '9', 'Add from ');
INSERT INTO `site_lang` VALUES ('281', '9', 'Private photos');
INSERT INTO `site_lang` VALUES ('280', '9', 'Public Photos');
INSERT INTO `site_lang` VALUES ('279', '9', 'No data');
INSERT INTO `site_lang` VALUES ('278', '9', 'Fans');
INSERT INTO `site_lang` VALUES ('277', '9', 'Report');
INSERT INTO `site_lang` VALUES ('276', '9', 'Interests');
INSERT INTO `site_lang` VALUES ('275', '9', 'Please wait');
INSERT INTO `site_lang` VALUES ('274', '9', 'Year');
INSERT INTO `site_lang` VALUES ('273', '9', 'Month');
INSERT INTO `site_lang` VALUES ('272', '9', 'Day');
INSERT INTO `site_lang` VALUES ('271', '9', 'When someone send me a message');
INSERT INTO `site_lang` VALUES ('270', '9', 'When new users near me join in');
INSERT INTO `site_lang` VALUES ('269', '9', 'When i get a match');
INSERT INTO `site_lang` VALUES ('268', '9', 'When someone likes me');
INSERT INTO `site_lang` VALUES ('267', '9', 'None');
INSERT INTO `site_lang` VALUES ('266', '9', 'I own a motorbike');
INSERT INTO `site_lang` VALUES ('265', '9', 'I own a car');
INSERT INTO `site_lang` VALUES ('264', '9', 'Parents car');
INSERT INTO `site_lang` VALUES ('263', '9', 'Transport');
INSERT INTO `site_lang` VALUES ('262', '9', 'Drink');
INSERT INTO `site_lang` VALUES ('261', '9', 'Sometimes');
INSERT INTO `site_lang` VALUES ('260', '9', 'No');
INSERT INTO `site_lang` VALUES ('259', '9', 'Yes');
INSERT INTO `site_lang` VALUES ('258', '9', 'Smoke');
INSERT INTO `site_lang` VALUES ('257', '9', 'Alone');
INSERT INTO `site_lang` VALUES ('256', '9', 'With partner');
INSERT INTO `site_lang` VALUES ('255', '9', 'Student dormitory');
INSERT INTO `site_lang` VALUES ('254', '9', 'With housemate');
INSERT INTO `site_lang` VALUES ('253', '9', 'With parents');
INSERT INTO `site_lang` VALUES ('252', '9', 'Living');
INSERT INTO `site_lang` VALUES ('251', '9', 'Curvy');
INSERT INTO `site_lang` VALUES ('250', '9', 'Heavy set');
INSERT INTO `site_lang` VALUES ('249', '9', 'Athletic');
INSERT INTO `site_lang` VALUES ('248', '9', 'Average');
INSERT INTO `site_lang` VALUES ('247', '9', 'Slim');
INSERT INTO `site_lang` VALUES ('245', '9', 'Other');
INSERT INTO `site_lang` VALUES ('246', '9', 'Body type');
INSERT INTO `site_lang` VALUES ('244', '9', 'Indian');
INSERT INTO `site_lang` VALUES ('242', '9', 'Hispanic/latin');
INSERT INTO `site_lang` VALUES ('243', '9', 'Pacific Islander');
INSERT INTO `site_lang` VALUES ('241', '9', 'Native American');
INSERT INTO `site_lang` VALUES ('239', '9', 'Black');
INSERT INTO `site_lang` VALUES ('240', '9', 'White');
INSERT INTO `site_lang` VALUES ('237', '9', 'Asian');
INSERT INTO `site_lang` VALUES ('238', '9', 'Middle Eastern');
INSERT INTO `site_lang` VALUES ('226', '9', 'Open');
INSERT INTO `site_lang` VALUES ('227', '9', 'Sexuality');
INSERT INTO `site_lang` VALUES ('228', '9', 'Gay');
INSERT INTO `site_lang` VALUES ('229', '9', 'Open-minded');
INSERT INTO `site_lang` VALUES ('230', '9', 'Straight');
INSERT INTO `site_lang` VALUES ('231', '9', 'Bisexual');
INSERT INTO `site_lang` VALUES ('232', '9', 'Height');
INSERT INTO `site_lang` VALUES ('233', '9', 'less than');
INSERT INTO `site_lang` VALUES ('234', '9', 'more than');
INSERT INTO `site_lang` VALUES ('235', '9', 'Weight');
INSERT INTO `site_lang` VALUES ('236', '9', 'Ethnicity');
INSERT INTO `site_lang` VALUES ('225', '9', 'Taken');
INSERT INTO `site_lang` VALUES ('221', '9', 'Notifications');
INSERT INTO `site_lang` VALUES ('222', '9', 'Extended info (optional)');
INSERT INTO `site_lang` VALUES ('223', '9', 'Relationship');
INSERT INTO `site_lang` VALUES ('224', '9', 'Single');
INSERT INTO `site_lang` VALUES ('220', '9', 'UPGRADE');
INSERT INTO `site_lang` VALUES ('218', '9', 'until');
INSERT INTO `site_lang` VALUES ('219', '9', 'Basic');
INSERT INTO `site_lang` VALUES ('217', '9', 'Wait more');
INSERT INTO `site_lang` VALUES ('216', '9', 'End call');
INSERT INTO `site_lang` VALUES ('214', '9', 'Too long wait');
INSERT INTO `site_lang` VALUES ('215', '9', 'Seems that your friend do not have webcam or he is not available');
INSERT INTO `site_lang` VALUES ('213', '9', 'You cant make videocall because you dont have webcam');
INSERT INTO `site_lang` VALUES ('212', '9', 'Impossible to make a call!');
INSERT INTO `site_lang` VALUES ('211', '9', 'Only premium users can make videocalls');
INSERT INTO `site_lang` VALUES ('210', '9', 'You are already in a videocall, you have to end the other call before start another');
INSERT INTO `site_lang` VALUES ('209', '9', 'Please allow access to your Webcam.');
INSERT INTO `site_lang` VALUES ('208', '9', 'is offline, try again when your friend is online');
INSERT INTO `site_lang` VALUES ('207', '9', 'is in another videocall , you cant call now');
INSERT INTO `site_lang` VALUES ('206', '9', 'Yes, delete it!');
INSERT INTO `site_lang` VALUES ('204', '9', 'Account termination');
INSERT INTO `site_lang` VALUES ('205', '9', 'Your data will be lost without recovery, continue?');
INSERT INTO `site_lang` VALUES ('203', '9', 'Information updated successfully');
INSERT INTO `site_lang` VALUES ('202', '9', 'Yes, buy it!');
INSERT INTO `site_lang` VALUES ('201', '9', 'more daily conversation, cost ');
INSERT INTO `site_lang` VALUES ('200', '9', 'Expand daily limitation ');
INSERT INTO `site_lang` VALUES ('199', '9', 'You dont have enought credits for send the gift');
INSERT INTO `site_lang` VALUES ('198', '9', 'Please, select 1 gift');
INSERT INTO `site_lang` VALUES ('197', '9', 'Please, select 1 photo');
INSERT INTO `site_lang` VALUES ('196', '9', 'Please, select a payment method');
INSERT INTO `site_lang` VALUES ('195', '9', 'No thanks');
INSERT INTO `site_lang` VALUES ('194', '9', 'Get access');
INSERT INTO `site_lang` VALUES ('193', '9', 'private photos for ');
INSERT INTO `site_lang` VALUES ('192', '9', 'Get access to');
INSERT INTO `site_lang` VALUES ('191', '9', 'Buy private photos permission');
INSERT INTO `site_lang` VALUES ('190', '9', 'No, i cant show you my private photos');
INSERT INTO `site_lang` VALUES ('189', '9', 'Yes, you can see my private photos');
INSERT INTO `site_lang` VALUES ('188', '9', 'Email already exist, try another');
INSERT INTO `site_lang` VALUES ('187', '9', 'Password too short');
INSERT INTO `site_lang` VALUES ('186', '9', 'Choose city from the autocomplete');
INSERT INTO `site_lang` VALUES ('185', '9', 'Add a valid date');
INSERT INTO `site_lang` VALUES ('184', '9', 'Wrong password');
INSERT INTO `site_lang` VALUES ('183', '9', 'Email dont exist');
INSERT INTO `site_lang` VALUES ('182', '9', 'Please fill all the inputs');
INSERT INTO `site_lang` VALUES ('181', '9', 'Invalid email format');
INSERT INTO `site_lang` VALUES ('179', '9', 'Login to my account');
INSERT INTO `site_lang` VALUES ('180', '9', 'Password recover');
INSERT INTO `site_lang` VALUES ('178', '9', 'If you dont remember your password, click the link below to set a new one:');
INSERT INTO `site_lang` VALUES ('177', '9', 'Hi');
INSERT INTO `site_lang` VALUES ('175', '9', 'Yes');
INSERT INTO `site_lang` VALUES ('176', '9', 'No');
INSERT INTO `site_lang` VALUES ('174', '9', 'Hello, can i have access to your private photos ?');
INSERT INTO `site_lang` VALUES ('173', '9', 'like this');
INSERT INTO `site_lang` VALUES ('172', '9', 'persons more like this');
INSERT INTO `site_lang` VALUES ('170', '9', 'Buy');
INSERT INTO `site_lang` VALUES ('171', '9', 'Days Premium');
INSERT INTO `site_lang` VALUES ('168', '9', 'November');
INSERT INTO `site_lang` VALUES ('169', '9', 'December');
INSERT INTO `site_lang` VALUES ('167', '9', 'October');
INSERT INTO `site_lang` VALUES ('164', '9', 'July');
INSERT INTO `site_lang` VALUES ('165', '9', 'August');
INSERT INTO `site_lang` VALUES ('166', '9', 'September');
INSERT INTO `site_lang` VALUES ('163', '9', 'June');
INSERT INTO `site_lang` VALUES ('162', '9', 'May');
INSERT INTO `site_lang` VALUES ('161', '9', 'April');
INSERT INTO `site_lang` VALUES ('158', '9', 'January');
INSERT INTO `site_lang` VALUES ('159', '9', 'February');
INSERT INTO `site_lang` VALUES ('160', '9', 'March');
INSERT INTO `site_lang` VALUES ('157', '9', 'You dont have matches yet');
INSERT INTO `site_lang` VALUES ('156', '9', 'You dont have any fans yet');
INSERT INTO `site_lang` VALUES ('155', '9', 'No popular users near you');
INSERT INTO `site_lang` VALUES ('154', '9', 'people found');
INSERT INTO `site_lang` VALUES ('153', '9', 'Nothing found');
INSERT INTO `site_lang` VALUES ('152', '9', 'Verified');
INSERT INTO `site_lang` VALUES ('151', '9', 'Online now');
INSERT INTO `site_lang` VALUES ('150', '9', 'Delete profile');
INSERT INTO `site_lang` VALUES ('149', '9', 'After delete your profile, some of your data will be lost without recovery.');
INSERT INTO `site_lang` VALUES ('148', '9', 'Profile desactivation');
INSERT INTO `site_lang` VALUES ('147', '9', 'New password');
INSERT INTO `site_lang` VALUES ('146', '9', 'You can change your current password bellow');
INSERT INTO `site_lang` VALUES ('145', '9', 'Change password');
INSERT INTO `site_lang` VALUES ('144', '9', 'Upgrade to premium account');
INSERT INTO `site_lang` VALUES ('143', '9', 'Add credits');
INSERT INTO `site_lang` VALUES ('142', '9', 'Current credits');
INSERT INTO `site_lang` VALUES ('141', '9', 'Account type');
INSERT INTO `site_lang` VALUES ('140', '9', 'Buy credits for send Gifs and Unblock private photos');
INSERT INTO `site_lang` VALUES ('139', '9', 'You are account is already verified');
INSERT INTO `site_lang` VALUES ('138', '9', 'Connect with Facebook');
INSERT INTO `site_lang` VALUES ('137', '9', 'For verify your account , connect with your facebook account');
INSERT INTO `site_lang` VALUES ('136', '9', 'Verify account');
INSERT INTO `site_lang` VALUES ('135', '9', 'Update profile');
INSERT INTO `site_lang` VALUES ('133', '9', 'You can edit your profile information bellow');
INSERT INTO `site_lang` VALUES ('134', '9', 'Site language');
INSERT INTO `site_lang` VALUES ('132', '9', 'Personal information');
INSERT INTO `site_lang` VALUES ('131', '9', 'Delete');
INSERT INTO `site_lang` VALUES ('128', '9', 'Credits');
INSERT INTO `site_lang` VALUES ('129', '9', 'Verify');
INSERT INTO `site_lang` VALUES ('130', '9', 'Change password');
INSERT INTO `site_lang` VALUES ('127', '9', 'Personal');
INSERT INTO `site_lang` VALUES ('126', '9', 'Unblock private photos');
INSERT INTO `site_lang` VALUES ('125', '9', 'Ask permission to');
INSERT INTO `site_lang` VALUES ('123', '9', 'Credits successfully added to your account');
INSERT INTO `site_lang` VALUES ('124', '9', 'Now you have');
INSERT INTO `site_lang` VALUES ('122', '9', 'boys and girls');
INSERT INTO `site_lang` VALUES ('121', '9', 'Only girls');
INSERT INTO `site_lang` VALUES ('120', '9', 'Only boys');
INSERT INTO `site_lang` VALUES ('119', '9', 'years old');
INSERT INTO `site_lang` VALUES ('118', '9', 'Personal info');
INSERT INTO `site_lang` VALUES ('117', '9', 'About ');
INSERT INTO `site_lang` VALUES ('115', '9', 'World');
INSERT INTO `site_lang` VALUES ('116', '9', 'Most popular users');
INSERT INTO `site_lang` VALUES ('114', '9', 'in a radius of');
INSERT INTO `site_lang` VALUES ('112', '9', 'Both');
INSERT INTO `site_lang` VALUES ('113', '9', 'who are between');
INSERT INTO `site_lang` VALUES ('111', '9', 'Boys');
INSERT INTO `site_lang` VALUES ('110', '9', 'Girls');
INSERT INTO `site_lang` VALUES ('109', '9', 'Show me');
INSERT INTO `site_lang` VALUES ('108', '9', 'Online now');
INSERT INTO `site_lang` VALUES ('107', '9', 'All users');
INSERT INTO `site_lang` VALUES ('106', '9', 'Filter Search');
INSERT INTO `site_lang` VALUES ('105', '9', 'Your matches');
INSERT INTO `site_lang` VALUES ('104', '9', 'Please complete your profile before start in ');
INSERT INTO `site_lang` VALUES ('101', '9', 'Your fans');
INSERT INTO `site_lang` VALUES ('102', '9', 'Privacy Policy');
INSERT INTO `site_lang` VALUES ('103', '9', 'Terms of Use');
INSERT INTO `site_lang` VALUES ('100', '9', 'or wait until tomorrow for continue meeting people');
INSERT INTO `site_lang` VALUES ('99', '9', 'daily conversations');
INSERT INTO `site_lang` VALUES ('98', '9', 'and get up to');
INSERT INTO `site_lang` VALUES ('97', '9', 'Upgrade your account to Premium');
INSERT INTO `site_lang` VALUES ('96', '9', 'or');
INSERT INTO `site_lang` VALUES ('95', '9', 'more daily conversation');
INSERT INTO `site_lang` VALUES ('94', '9', 'Buy');
INSERT INTO `site_lang` VALUES ('93', '9', 'To continue chatting');
INSERT INTO `site_lang` VALUES ('92', '9', 'you have reached the limit of new daily conversations');
INSERT INTO `site_lang` VALUES ('91', '9', 'Chat');
INSERT INTO `site_lang` VALUES ('90', '9', 'Send');
INSERT INTO `site_lang` VALUES ('89', '9', 'Write text here');
INSERT INTO `site_lang` VALUES ('88', '9', 'Premium user badge');
INSERT INTO `site_lang` VALUES ('87', '9', 'Unblock all private photos');
INSERT INTO `site_lang` VALUES ('86', '9', 'Unlimited videocalls');
INSERT INTO `site_lang` VALUES ('85', '9', 'new chats per day');
INSERT INTO `site_lang` VALUES ('84', '9', 'Premium Account Features');
INSERT INTO `site_lang` VALUES ('83', '9', 'Buy credits');
INSERT INTO `site_lang` VALUES ('82', '9', 'Pay with');
INSERT INTO `site_lang` VALUES ('81', '9', 'Pay with');
INSERT INTO `site_lang` VALUES ('80', '9', 'Select payment method');
INSERT INTO `site_lang` VALUES ('79', '9', 'Select credits package');
INSERT INTO `site_lang` VALUES ('78', '9', 'Buy credits / Upgrade account');
INSERT INTO `site_lang` VALUES ('77', '9', 'Send gift');
INSERT INTO `site_lang` VALUES ('76', '9', 'Pick the gift you want to send to ');
INSERT INTO `site_lang` VALUES ('75', '9', 'Send gift to ');
INSERT INTO `site_lang` VALUES ('74', '9', 'Add photo');
INSERT INTO `site_lang` VALUES ('73', '9', 'Credits');
INSERT INTO `site_lang` VALUES ('72', '9', 'Pick the photo you want to show in the Spotlight, cost ');
INSERT INTO `site_lang` VALUES ('71', '9', 'Add yourself to the Spotlight');
INSERT INTO `site_lang` VALUES ('70', '9', 'add photos');
INSERT INTO `site_lang` VALUES ('69', '9', 'Add your photos');
INSERT INTO `site_lang` VALUES ('68', '9', 'Private Photos');
INSERT INTO `site_lang` VALUES ('66', '9', 'All Photos');
INSERT INTO `site_lang` VALUES ('67', '9', 'Public Photos');
INSERT INTO `site_lang` VALUES ('65', '9', 'Manage your photos');
INSERT INTO `site_lang` VALUES ('64', '9', 'Contact');
INSERT INTO `site_lang` VALUES ('63', '9', 'Privacy');
INSERT INTO `site_lang` VALUES ('62', '9', 'Terms');
INSERT INTO `site_lang` VALUES ('60', '9', 'New messages');
INSERT INTO `site_lang` VALUES ('61', '9', 'Who to like');
INSERT INTO `site_lang` VALUES ('59', '9', 'Online now');
INSERT INTO `site_lang` VALUES ('55', '9', 'Settings');
INSERT INTO `site_lang` VALUES ('56', '9', 'All');
INSERT INTO `site_lang` VALUES ('57', '9', 'Fans');
INSERT INTO `site_lang` VALUES ('58', '9', 'Conversations');
INSERT INTO `site_lang` VALUES ('52', '9', 'Most populars');
INSERT INTO `site_lang` VALUES ('53', '9', 'Fans');
INSERT INTO `site_lang` VALUES ('54', '9', 'Manage photos');
INSERT INTO `site_lang` VALUES ('51', '9', 'Matches');
INSERT INTO `site_lang` VALUES ('50', '9', 'Discover');
INSERT INTO `site_lang` VALUES ('46', '9', 'Profile');
INSERT INTO `site_lang` VALUES ('47', '9', 'Settings');
INSERT INTO `site_lang` VALUES ('48', '9', 'Logout');
INSERT INTO `site_lang` VALUES ('49', '9', 'Meet new people');
INSERT INTO `site_lang` VALUES ('45', '9', 'Privacy Policy');
INSERT INTO `site_lang` VALUES ('44', '9', 'and');
INSERT INTO `site_lang` VALUES ('43', '9', 'Terms and Conditions');
INSERT INTO `site_lang` VALUES ('42', '9', 'By continuing, you are confirming that you have read and agree to our');
INSERT INTO `site_lang` VALUES ('41', '9', 'Sign up');
INSERT INTO `site_lang` VALUES ('40', '9', 'Meet boys and girls');
INSERT INTO `site_lang` VALUES ('39', '9', 'Meet boys');
INSERT INTO `site_lang` VALUES ('38', '9', 'Meet girls');
INSERT INTO `site_lang` VALUES ('37', '9', 'Im here to');
INSERT INTO `site_lang` VALUES ('36', '9', 'Female');
INSERT INTO `site_lang` VALUES ('35', '9', 'Male');
INSERT INTO `site_lang` VALUES ('34', '9', 'Gender');
INSERT INTO `site_lang` VALUES ('32', '9', 'City');
INSERT INTO `site_lang` VALUES ('33', '9', 'Where do you live?');
INSERT INTO `site_lang` VALUES ('30', '9', 'Birthday');
INSERT INTO `site_lang` VALUES ('31', '9', 'Please select');
INSERT INTO `site_lang` VALUES ('28', '9', 'Email');
INSERT INTO `site_lang` VALUES ('29', '9', 'Password');
INSERT INTO `site_lang` VALUES ('26', '9', 'Name');
INSERT INTO `site_lang` VALUES ('27', '9', 'Your name or nickname');
INSERT INTO `site_lang` VALUES ('25', '9', 'Join the worlds bestest community for meeting new people!.');
INSERT INTO `site_lang` VALUES ('24', '9', 'Become a member now');
INSERT INTO `site_lang` VALUES ('23', '9', 'Play our popular Discover game and get matched with other users. Its a great way to break the ice and chat to new people.');
INSERT INTO `site_lang` VALUES ('22', '9', 'Matches');
INSERT INTO `site_lang` VALUES ('20', '9', 'People nearby');
INSERT INTO `site_lang` VALUES ('21', '9', 'We wont show your exact location, but you will be able to find people nearby who like the same things you do.');
INSERT INTO `site_lang` VALUES ('18', '9', 'Video Chat');
INSERT INTO `site_lang` VALUES ('19', '9', 'You can make quality videocalls for free to anyone, without limits of call duration, just enjoy seeing the person who is chatting with you');
INSERT INTO `site_lang` VALUES ('17', '9', 'Powerfull private chat for meet new friends, you can send emoticons and private photos to anyone.');
INSERT INTO `site_lang` VALUES ('16', '9', 'Chat');
INSERT INTO `site_lang` VALUES ('15', '9', 'Recover password');
INSERT INTO `site_lang` VALUES ('13', '9', 'Login now');
INSERT INTO `site_lang` VALUES ('14', '9', 'Password recover');
INSERT INTO `site_lang` VALUES ('12', '9', 'do you forget your password?');
INSERT INTO `site_lang` VALUES ('11', '9', 'Your password');
INSERT INTO `site_lang` VALUES ('10', '9', 'Your email');
INSERT INTO `site_lang` VALUES ('9', '9', 'Welcome back');
INSERT INTO `site_lang` VALUES ('8', '9', 'Create your account');
INSERT INTO `site_lang` VALUES ('7', '9', 'Connect with ');
INSERT INTO `site_lang` VALUES ('6', '9', 'SOON AVAILABLE');
INSERT INTO `site_lang` VALUES ('5', '9', 'Soon we will have our phone apps online');
INSERT INTO `site_lang` VALUES ('4', '9', 'Please visit us from your laptop or PC');
INSERT INTO `site_lang` VALUES ('3', '9', 'For now our site works only for Desktop users');
INSERT INTO `site_lang` VALUES ('2', '9', 'Welcome to the fastest growing place to meet new people');
INSERT INTO `site_lang` VALUES ('1', '9', 'Login');
INSERT INTO `site_lang` VALUES ('0', '9', 'meet new people!');
INSERT INTO `site_lang` VALUES ('384', '8', 'Ok, i understand');
INSERT INTO `site_lang` VALUES ('383', '8', 'must like you for start a videocall');
INSERT INTO `site_lang` VALUES ('382', '8', 'dont like you');
INSERT INTO `site_lang` VALUES ('381', '8', 'calling...');
INSERT INTO `site_lang` VALUES ('379', '8', 'Go to');
INSERT INTO `site_lang` VALUES ('380', '8', 'Welcome to');
INSERT INTO `site_lang` VALUES ('378', '8', 'Please save your connection information in a safe place');
INSERT INTO `site_lang` VALUES ('377', '8', 'Password');
INSERT INTO `site_lang` VALUES ('376', '8', 'E-mail');
INSERT INTO `site_lang` VALUES ('375', '8', 'Here are your connection details');
INSERT INTO `site_lang` VALUES ('374', '8', 'Start meeting new people now');
INSERT INTO `site_lang` VALUES ('373', '8', 'More than 1 million people have joined $site_name You probably want to know some of them.');
INSERT INTO `site_lang` VALUES ('372', '8', 'Add photos and complete your profile');
INSERT INTO `site_lang` VALUES ('371', '8', 'Nobody is going to fall in love with a blank page. The more information you get, the more chances to find that special someone!');
INSERT INTO `site_lang` VALUES ('370', '8', 'Meet new people');
INSERT INTO `site_lang` VALUES ('369', '8', 'you can meet people instantly');
INSERT INTO `site_lang` VALUES ('368', '8', 'In');
INSERT INTO `site_lang` VALUES ('365', '8', 'Verify your account');
INSERT INTO `site_lang` VALUES ('366', '8', 'Newsflash');
INSERT INTO `site_lang` VALUES ('367', '8', 'people in your area wants to know you');
INSERT INTO `site_lang` VALUES ('363', '8', 'Here are a few tips');
INSERT INTO `site_lang` VALUES ('364', '8', 'Now you are a new member of');
INSERT INTO `site_lang` VALUES ('362', '8', 'Well done, now you are in');
INSERT INTO `site_lang` VALUES ('361', '8', 'Welcome');
INSERT INTO `site_lang` VALUES ('360', '8', 'Check out the profile');
INSERT INTO `site_lang` VALUES ('359', '8', 'and lives closer to you');
INSERT INTO `site_lang` VALUES ('358', '8', 'is new at');
INSERT INTO `site_lang` VALUES ('357', '8', 'is new and lives closer to you');
INSERT INTO `site_lang` VALUES ('356', '8', 'Have fun!');
INSERT INTO `site_lang` VALUES ('355', '8', 'Respond to');
INSERT INTO `site_lang` VALUES ('354', '8', 'you have a new message from');
INSERT INTO `site_lang` VALUES ('353', '8', 'New message from');
INSERT INTO `site_lang` VALUES ('352', '8', 'Go and say something to');
INSERT INTO `site_lang` VALUES ('351', '8', 'thinks the feeling is mutual');
INSERT INTO `site_lang` VALUES ('350', '8', 'Its a match!');
INSERT INTO `site_lang` VALUES ('349', '8', 'You have a match at');
INSERT INTO `site_lang` VALUES ('348', '8', 'if you forgot your password, click on the link below to get a new');
INSERT INTO `site_lang` VALUES ('347', '8', 'Choose a new password');
INSERT INTO `site_lang` VALUES ('346', '8', 'Unsubscribe');
INSERT INTO `site_lang` VALUES ('345', '8', 'You received this notice because you registered as');
INSERT INTO `site_lang` VALUES ('344', '8', 'Find out if you also like');
INSERT INTO `site_lang` VALUES ('343', '8', 'has seen you in discover and likes. The feeling is mutual?');
INSERT INTO `site_lang` VALUES ('342', '8', 'likes you and wants to chat in');
INSERT INTO `site_lang` VALUES ('341', '8', 'We sent you a email with your info, it may take up to 1 min to arrive');
INSERT INTO `site_lang` VALUES ('340', '8', 'Loading...');
INSERT INTO `site_lang` VALUES ('339', '8', 'of');
INSERT INTO `site_lang` VALUES ('338', '8', 'Photos of ');
INSERT INTO `site_lang` VALUES ('337', '8', 'is calling you..');
INSERT INTO `site_lang` VALUES ('336', '8', 'Password successfully changed');
INSERT INTO `site_lang` VALUES ('335', '8', 'Service cost');
INSERT INTO `site_lang` VALUES ('334', '8', 'Spotlight');
INSERT INTO `site_lang` VALUES ('331', '8', 'username');
INSERT INTO `site_lang` VALUES ('332', '8', 'days of Premium');
INSERT INTO `site_lang` VALUES ('333', '8', 'Wrong');
INSERT INTO `site_lang` VALUES ('330', '8', 'You need to write your username!');
INSERT INTO `site_lang` VALUES ('329', '8', 'Write your instagram username');
INSERT INTO `site_lang` VALUES ('326', '8', 'Report and block');
INSERT INTO `site_lang` VALUES ('327', '8', 'Are you sure you want to report');
INSERT INTO `site_lang` VALUES ('328', '8', 'Press backspace key for smart return to the meeting section.');
INSERT INTO `site_lang` VALUES ('325', '8', 'is blocking you or you blocked him, you cant chat with him sorry');
INSERT INTO `site_lang` VALUES ('323', '8', 'years old and im from');
INSERT INTO `site_lang` VALUES ('324', '8', 'We sended you a email for verify your account');
INSERT INTO `site_lang` VALUES ('321', '8', 'Please add a profile photo');
INSERT INTO `site_lang` VALUES ('322', '8', 'Hi, im');
INSERT INTO `site_lang` VALUES ('319', '8', 'ago');
INSERT INTO `site_lang` VALUES ('320', '8', 'Please verify your account, check your email');
INSERT INTO `site_lang` VALUES ('317', '8', 'minutes');
INSERT INTO `site_lang` VALUES ('318', '8', 'seconds');
INSERT INTO `site_lang` VALUES ('313', '8', 'years');
INSERT INTO `site_lang` VALUES ('314', '8', 'months');
INSERT INTO `site_lang` VALUES ('315', '8', 'days');
INSERT INTO `site_lang` VALUES ('316', '8', 'hours');
INSERT INTO `site_lang` VALUES ('312', '8', 'second');
INSERT INTO `site_lang` VALUES ('310', '8', 'hour');
INSERT INTO `site_lang` VALUES ('311', '8', 'minute');
INSERT INTO `site_lang` VALUES ('307', '8', 'year');
INSERT INTO `site_lang` VALUES ('308', '8', 'month');
INSERT INTO `site_lang` VALUES ('309', '8', 'day');
INSERT INTO `site_lang` VALUES ('304', '8', 'Cost');
INSERT INTO `site_lang` VALUES ('305', '8', 'Credits for $');
INSERT INTO `site_lang` VALUES ('306', '8', '0 seconds');
INSERT INTO `site_lang` VALUES ('303', '8', 'You do not like anyone');
INSERT INTO `site_lang` VALUES ('302', '8', 'visited');
INSERT INTO `site_lang` VALUES ('301', '8', 'You dont have any visit yet');
INSERT INTO `site_lang` VALUES ('297', '8', 'Messages');
INSERT INTO `site_lang` VALUES ('298', '8', 'Like');
INSERT INTO `site_lang` VALUES ('299', '8', 'Dislike');
INSERT INTO `site_lang` VALUES ('300', '8', 'AGE');
INSERT INTO `site_lang` VALUES ('296', '8', 'people liked you, for see them');
INSERT INTO `site_lang` VALUES ('295', '8', 'People i like');
INSERT INTO `site_lang` VALUES ('294', '8', 'Upgrade your account to premium');
INSERT INTO `site_lang` VALUES ('293', '8', 'people visited your profile for see them');
INSERT INTO `site_lang` VALUES ('292', '8', 'Delete');
INSERT INTO `site_lang` VALUES ('291', '8', 'Public photo');
INSERT INTO `site_lang` VALUES ('289', '8', 'Set as profile');
INSERT INTO `site_lang` VALUES ('290', '8', 'Private photo');
INSERT INTO `site_lang` VALUES ('288', '8', 'get seen by millions');
INSERT INTO `site_lang` VALUES ('287', '8', 'Add me here');
INSERT INTO `site_lang` VALUES ('286', '8', 'Visits');
INSERT INTO `site_lang` VALUES ('282', '8', 'Add from ');
INSERT INTO `site_lang` VALUES ('283', '8', 'Add');
INSERT INTO `site_lang` VALUES ('284', '8', 'Photos');
INSERT INTO `site_lang` VALUES ('285', '8', 'Credits');
INSERT INTO `site_lang` VALUES ('281', '8', 'Private photos');
INSERT INTO `site_lang` VALUES ('280', '8', 'Public Photos');
INSERT INTO `site_lang` VALUES ('279', '8', 'No data');
INSERT INTO `site_lang` VALUES ('278', '8', 'Fans');
INSERT INTO `site_lang` VALUES ('270', '8', 'When new users near me join in');
INSERT INTO `site_lang` VALUES ('277', '8', 'Report');
INSERT INTO `site_lang` VALUES ('276', '8', 'Interests');
INSERT INTO `site_lang` VALUES ('275', '8', 'Please wait');
INSERT INTO `site_lang` VALUES ('271', '8', 'When someone send me a message');
INSERT INTO `site_lang` VALUES ('274', '8', 'Year');
INSERT INTO `site_lang` VALUES ('273', '8', 'Month');
INSERT INTO `site_lang` VALUES ('272', '8', 'Day');
INSERT INTO `site_lang` VALUES ('267', '8', 'None');
INSERT INTO `site_lang` VALUES ('268', '8', 'When someone likes me');
INSERT INTO `site_lang` VALUES ('269', '8', 'When i get a match');
INSERT INTO `site_lang` VALUES ('266', '8', 'I own a motorbike');
INSERT INTO `site_lang` VALUES ('265', '8', 'I own a car');
INSERT INTO `site_lang` VALUES ('264', '8', 'Parents car');
INSERT INTO `site_lang` VALUES ('263', '8', 'Transport');
INSERT INTO `site_lang` VALUES ('262', '8', 'Drink');
INSERT INTO `site_lang` VALUES ('261', '8', 'Sometimes');
INSERT INTO `site_lang` VALUES ('260', '8', 'No');
INSERT INTO `site_lang` VALUES ('259', '8', 'Yes');
INSERT INTO `site_lang` VALUES ('257', '8', 'Alone');
INSERT INTO `site_lang` VALUES ('258', '8', 'Smoke');
INSERT INTO `site_lang` VALUES ('256', '8', 'With partner');
INSERT INTO `site_lang` VALUES ('255', '8', 'Student dormitory');
INSERT INTO `site_lang` VALUES ('253', '8', 'With parents');
INSERT INTO `site_lang` VALUES ('254', '8', 'With housemate');
INSERT INTO `site_lang` VALUES ('252', '8', 'Living');
INSERT INTO `site_lang` VALUES ('251', '8', 'Curvy');
INSERT INTO `site_lang` VALUES ('248', '8', 'Average');
INSERT INTO `site_lang` VALUES ('249', '8', 'Athletic');
INSERT INTO `site_lang` VALUES ('250', '8', 'Heavy set');
INSERT INTO `site_lang` VALUES ('247', '8', 'Slim');
INSERT INTO `site_lang` VALUES ('246', '8', 'Body type');
INSERT INTO `site_lang` VALUES ('243', '8', 'Pacific Islander');
INSERT INTO `site_lang` VALUES ('244', '8', 'Indian');
INSERT INTO `site_lang` VALUES ('245', '8', 'Other');
INSERT INTO `site_lang` VALUES ('242', '8', 'Hispanic/latin');
INSERT INTO `site_lang` VALUES ('241', '8', 'Native American');
INSERT INTO `site_lang` VALUES ('240', '8', 'White');
INSERT INTO `site_lang` VALUES ('239', '8', 'Black');
INSERT INTO `site_lang` VALUES ('238', '8', 'Middle Eastern');
INSERT INTO `site_lang` VALUES ('236', '8', 'Ethnicity');
INSERT INTO `site_lang` VALUES ('237', '8', 'Asian');
INSERT INTO `site_lang` VALUES ('234', '8', 'more than');
INSERT INTO `site_lang` VALUES ('235', '8', 'Weight');
INSERT INTO `site_lang` VALUES ('233', '8', 'less than');
INSERT INTO `site_lang` VALUES ('230', '8', 'Straight');
INSERT INTO `site_lang` VALUES ('231', '8', 'Bisexual');
INSERT INTO `site_lang` VALUES ('232', '8', 'Height');
INSERT INTO `site_lang` VALUES ('229', '8', 'Open-minded');
INSERT INTO `site_lang` VALUES ('228', '8', 'Gay');
INSERT INTO `site_lang` VALUES ('227', '8', 'Sexuality');
INSERT INTO `site_lang` VALUES ('225', '8', 'Taken');
INSERT INTO `site_lang` VALUES ('226', '8', 'Open');
INSERT INTO `site_lang` VALUES ('224', '8', 'Single');
INSERT INTO `site_lang` VALUES ('223', '8', 'Relationship');
INSERT INTO `site_lang` VALUES ('222', '8', 'Extended info (optional)');
INSERT INTO `site_lang` VALUES ('221', '8', 'Notifications');
INSERT INTO `site_lang` VALUES ('220', '8', 'UPGRADE');
INSERT INTO `site_lang` VALUES ('219', '8', 'Basic');
INSERT INTO `site_lang` VALUES ('218', '8', 'until');
INSERT INTO `site_lang` VALUES ('217', '8', 'Wait more');
INSERT INTO `site_lang` VALUES ('216', '8', 'End call');
INSERT INTO `site_lang` VALUES ('215', '8', 'Seems that your friend do not have webcam or he is not available');
INSERT INTO `site_lang` VALUES ('214', '8', 'Too long wait');
INSERT INTO `site_lang` VALUES ('213', '8', 'You cant make videocall because you dont have webcam');
INSERT INTO `site_lang` VALUES ('212', '8', 'Impossible to make a call!');
INSERT INTO `site_lang` VALUES ('211', '8', 'Only premium users can make videocalls');
INSERT INTO `site_lang` VALUES ('209', '8', 'Please allow access to your Webcam.');
INSERT INTO `site_lang` VALUES ('210', '8', 'You are already in a videocall, you have to end the other call before start another');
INSERT INTO `site_lang` VALUES ('208', '8', 'is offline, try again when your friend is online');
INSERT INTO `site_lang` VALUES ('207', '8', 'is in another videocall , you cant call now');
INSERT INTO `site_lang` VALUES ('206', '8', 'Yes, delete it!');
INSERT INTO `site_lang` VALUES ('205', '8', 'Your data will be lost without recovery, continue?');
INSERT INTO `site_lang` VALUES ('203', '8', 'Information updated successfully');
INSERT INTO `site_lang` VALUES ('204', '8', 'Account termination');
INSERT INTO `site_lang` VALUES ('202', '8', 'Yes, buy it!');
INSERT INTO `site_lang` VALUES ('201', '8', 'more daily conversation, cost ');
INSERT INTO `site_lang` VALUES ('200', '8', 'Expand daily limitation ');
INSERT INTO `site_lang` VALUES ('198', '8', 'Please, select 1 gift');
INSERT INTO `site_lang` VALUES ('199', '8', 'You dont have enought credits for send the gift');
INSERT INTO `site_lang` VALUES ('197', '8', 'Please, select 1 photo');
INSERT INTO `site_lang` VALUES ('195', '8', 'No thanks');
INSERT INTO `site_lang` VALUES ('196', '8', 'Please, select a payment method');
INSERT INTO `site_lang` VALUES ('194', '8', 'Get access');
INSERT INTO `site_lang` VALUES ('193', '8', 'private photos for ');
INSERT INTO `site_lang` VALUES ('192', '8', 'Get access to');
INSERT INTO `site_lang` VALUES ('191', '8', 'Buy private photos permission');
INSERT INTO `site_lang` VALUES ('190', '8', 'No, i cant show you my private photos');
INSERT INTO `site_lang` VALUES ('189', '8', 'Yes, you can see my private photos');
INSERT INTO `site_lang` VALUES ('188', '8', 'Email already exist, try another');
INSERT INTO `site_lang` VALUES ('187', '8', 'Password too short');
INSERT INTO `site_lang` VALUES ('184', '8', 'Wrong password');
INSERT INTO `site_lang` VALUES ('185', '8', 'Add a valid date');
INSERT INTO `site_lang` VALUES ('186', '8', 'Choose city from the autocomplete');
INSERT INTO `site_lang` VALUES ('183', '8', 'Email dont exist');
INSERT INTO `site_lang` VALUES ('182', '8', 'Please fill all the inputs');
INSERT INTO `site_lang` VALUES ('181', '8', 'Invalid email format');
INSERT INTO `site_lang` VALUES ('180', '8', 'Password recover');
INSERT INTO `site_lang` VALUES ('179', '8', 'Login to my account');
INSERT INTO `site_lang` VALUES ('178', '8', 'If you dont remember your password, click the link below to set a new one:');
INSERT INTO `site_lang` VALUES ('176', '8', 'No');
INSERT INTO `site_lang` VALUES ('177', '8', 'Hi');
INSERT INTO `site_lang` VALUES ('175', '8', 'Yes');
INSERT INTO `site_lang` VALUES ('174', '8', 'Hello, can i have access to your private photos ?');
INSERT INTO `site_lang` VALUES ('171', '8', 'Days Premium');
INSERT INTO `site_lang` VALUES ('172', '8', 'persons more like this');
INSERT INTO `site_lang` VALUES ('173', '8', 'like this');
INSERT INTO `site_lang` VALUES ('169', '8', 'December');
INSERT INTO `site_lang` VALUES ('170', '8', 'Buy');
INSERT INTO `site_lang` VALUES ('168', '8', 'November');
INSERT INTO `site_lang` VALUES ('167', '8', 'October');
INSERT INTO `site_lang` VALUES ('166', '8', 'September');
INSERT INTO `site_lang` VALUES ('165', '8', 'August');
INSERT INTO `site_lang` VALUES ('163', '8', 'June');
INSERT INTO `site_lang` VALUES ('164', '8', 'July');
INSERT INTO `site_lang` VALUES ('162', '8', 'May');
INSERT INTO `site_lang` VALUES ('161', '8', 'April');
INSERT INTO `site_lang` VALUES ('160', '8', 'March');
INSERT INTO `site_lang` VALUES ('159', '8', 'February');
INSERT INTO `site_lang` VALUES ('158', '8', 'January');
INSERT INTO `site_lang` VALUES ('157', '8', 'You dont have matches yet');
INSERT INTO `site_lang` VALUES ('156', '8', 'You dont have any fans yet');
INSERT INTO `site_lang` VALUES ('155', '8', 'No popular users near you');
INSERT INTO `site_lang` VALUES ('154', '8', 'people found');
INSERT INTO `site_lang` VALUES ('153', '8', 'Nothing found');
INSERT INTO `site_lang` VALUES ('152', '8', 'Verified');
INSERT INTO `site_lang` VALUES ('151', '8', 'Online now');
INSERT INTO `site_lang` VALUES ('150', '8', 'Delete profile');
INSERT INTO `site_lang` VALUES ('149', '8', 'After delete your profile, some of your data will be lost without recovery.');
INSERT INTO `site_lang` VALUES ('148', '8', 'Profile desactivation');
INSERT INTO `site_lang` VALUES ('147', '8', 'New password');
INSERT INTO `site_lang` VALUES ('146', '8', 'You can change your current password bellow');
INSERT INTO `site_lang` VALUES ('145', '8', 'Change password');
INSERT INTO `site_lang` VALUES ('144', '8', 'Upgrade to premium account');
INSERT INTO `site_lang` VALUES ('143', '8', 'Add credits');
INSERT INTO `site_lang` VALUES ('142', '8', 'Current credits');
INSERT INTO `site_lang` VALUES ('141', '8', 'Account type');
INSERT INTO `site_lang` VALUES ('140', '8', 'Buy credits for send Gifs and Unblock private photos');
INSERT INTO `site_lang` VALUES ('139', '8', 'You are account is already verified');
INSERT INTO `site_lang` VALUES ('138', '8', 'Connect with Facebook');
INSERT INTO `site_lang` VALUES ('137', '8', 'For verify your account , connect with your facebook account');
INSERT INTO `site_lang` VALUES ('136', '8', 'Verify account');
INSERT INTO `site_lang` VALUES ('135', '8', 'Update profile');
INSERT INTO `site_lang` VALUES ('134', '8', 'Site language');
INSERT INTO `site_lang` VALUES ('133', '8', 'You can edit your profile information bellow');
INSERT INTO `site_lang` VALUES ('131', '8', 'Delete');
INSERT INTO `site_lang` VALUES ('132', '8', 'Personal information');
INSERT INTO `site_lang` VALUES ('129', '8', 'Verify');
INSERT INTO `site_lang` VALUES ('130', '8', 'Change password');
INSERT INTO `site_lang` VALUES ('124', '8', 'Now you have');
INSERT INTO `site_lang` VALUES ('125', '8', 'Ask permission to');
INSERT INTO `site_lang` VALUES ('126', '8', 'Unblock private photos');
INSERT INTO `site_lang` VALUES ('127', '8', 'Personal');
INSERT INTO `site_lang` VALUES ('128', '8', 'Credits');
INSERT INTO `site_lang` VALUES ('123', '8', 'Credits successfully added to your account');
INSERT INTO `site_lang` VALUES ('121', '8', 'Only girls');
INSERT INTO `site_lang` VALUES ('122', '8', 'boys and girls');
INSERT INTO `site_lang` VALUES ('118', '8', 'Personal info');
INSERT INTO `site_lang` VALUES ('119', '8', 'years old');
INSERT INTO `site_lang` VALUES ('120', '8', 'Only boys');
INSERT INTO `site_lang` VALUES ('114', '8', 'in a radius of');
INSERT INTO `site_lang` VALUES ('115', '8', 'World');
INSERT INTO `site_lang` VALUES ('116', '8', 'Most popular users');
INSERT INTO `site_lang` VALUES ('117', '8', 'About ');
INSERT INTO `site_lang` VALUES ('113', '8', 'who are between');
INSERT INTO `site_lang` VALUES ('112', '8', 'Both');
INSERT INTO `site_lang` VALUES ('111', '8', 'Boys');
INSERT INTO `site_lang` VALUES ('110', '8', 'Girls');
INSERT INTO `site_lang` VALUES ('109', '8', 'Show me');
INSERT INTO `site_lang` VALUES ('108', '8', 'Online now');
INSERT INTO `site_lang` VALUES ('107', '8', 'All users');
INSERT INTO `site_lang` VALUES ('106', '8', 'Filter Search');
INSERT INTO `site_lang` VALUES ('105', '8', 'Your matches');
INSERT INTO `site_lang` VALUES ('101', '8', 'Your fans');
INSERT INTO `site_lang` VALUES ('102', '8', 'Privacy Policy');
INSERT INTO `site_lang` VALUES ('103', '8', 'Terms of Use');
INSERT INTO `site_lang` VALUES ('104', '8', 'Please complete your profile before start in ');
INSERT INTO `site_lang` VALUES ('100', '8', 'or wait until tomorrow for continue meeting people');
INSERT INTO `site_lang` VALUES ('98', '8', 'and get up to');
INSERT INTO `site_lang` VALUES ('99', '8', 'daily conversations');
INSERT INTO `site_lang` VALUES ('96', '8', 'or');
INSERT INTO `site_lang` VALUES ('97', '8', 'Upgrade your account to Premium');
INSERT INTO `site_lang` VALUES ('95', '8', 'more daily conversation');
INSERT INTO `site_lang` VALUES ('94', '8', 'Buy');
INSERT INTO `site_lang` VALUES ('93', '8', 'To continue chatting');
INSERT INTO `site_lang` VALUES ('92', '8', 'you have reached the limit of new daily conversations');
INSERT INTO `site_lang` VALUES ('91', '8', 'Chat');
INSERT INTO `site_lang` VALUES ('90', '8', 'Send');
INSERT INTO `site_lang` VALUES ('89', '8', 'Write text here');
INSERT INTO `site_lang` VALUES ('88', '8', 'Premium user badge');
INSERT INTO `site_lang` VALUES ('87', '8', 'Unblock all private photos');
INSERT INTO `site_lang` VALUES ('84', '8', 'Premium Account Features');
INSERT INTO `site_lang` VALUES ('85', '8', 'new chats per day');
INSERT INTO `site_lang` VALUES ('86', '8', 'Unlimited videocalls');
INSERT INTO `site_lang` VALUES ('81', '8', 'Pay with');
INSERT INTO `site_lang` VALUES ('82', '8', 'Pay with');
INSERT INTO `site_lang` VALUES ('83', '8', 'Buy credits');
INSERT INTO `site_lang` VALUES ('80', '8', 'Select payment method');
INSERT INTO `site_lang` VALUES ('79', '8', 'Select credits package');
INSERT INTO `site_lang` VALUES ('78', '8', 'Buy credits / Upgrade account');
INSERT INTO `site_lang` VALUES ('75', '8', 'Send gift to ');
INSERT INTO `site_lang` VALUES ('76', '8', 'Pick the gift you want to send to ');
INSERT INTO `site_lang` VALUES ('77', '8', 'Send gift');
INSERT INTO `site_lang` VALUES ('74', '8', 'Add photo');
INSERT INTO `site_lang` VALUES ('73', '8', 'Credits');
INSERT INTO `site_lang` VALUES ('72', '8', 'Pick the photo you want to show in the Spotlight, cost ');
INSERT INTO `site_lang` VALUES ('71', '8', 'Add yourself to the Spotlight');
INSERT INTO `site_lang` VALUES ('70', '8', 'add photos');
INSERT INTO `site_lang` VALUES ('69', '8', 'Add your photos');
INSERT INTO `site_lang` VALUES ('68', '8', 'Private Photos');
INSERT INTO `site_lang` VALUES ('67', '8', 'Public Photos');
INSERT INTO `site_lang` VALUES ('66', '8', 'All Photos');
INSERT INTO `site_lang` VALUES ('65', '8', 'Manage your photos');
INSERT INTO `site_lang` VALUES ('64', '8', 'Contact');
INSERT INTO `site_lang` VALUES ('63', '8', 'Privacy');
INSERT INTO `site_lang` VALUES ('62', '8', 'Terms');
INSERT INTO `site_lang` VALUES ('60', '8', 'New messages');
INSERT INTO `site_lang` VALUES ('61', '8', 'Who to like');
INSERT INTO `site_lang` VALUES ('59', '8', 'Online now');
INSERT INTO `site_lang` VALUES ('58', '8', 'Conversations');
INSERT INTO `site_lang` VALUES ('57', '8', 'Fans');
INSERT INTO `site_lang` VALUES ('56', '8', 'All');
INSERT INTO `site_lang` VALUES ('55', '8', 'Settings');
INSERT INTO `site_lang` VALUES ('54', '8', 'Manage photos');
INSERT INTO `site_lang` VALUES ('53', '8', 'Fans');
INSERT INTO `site_lang` VALUES ('51', '8', 'Matches');
INSERT INTO `site_lang` VALUES ('52', '8', 'Most populars');
INSERT INTO `site_lang` VALUES ('45', '8', 'Privacy Policy');
INSERT INTO `site_lang` VALUES ('46', '8', 'Profile');
INSERT INTO `site_lang` VALUES ('47', '8', 'Settings');
INSERT INTO `site_lang` VALUES ('48', '8', 'Logout');
INSERT INTO `site_lang` VALUES ('49', '8', 'Meet new people');
INSERT INTO `site_lang` VALUES ('50', '8', 'Discover');
INSERT INTO `site_lang` VALUES ('44', '8', 'and');
INSERT INTO `site_lang` VALUES ('43', '8', 'Terms and Conditions');
INSERT INTO `site_lang` VALUES ('42', '8', 'By continuing, you are confirming that you have read and agree to our');
INSERT INTO `site_lang` VALUES ('41', '8', 'Sign up');
INSERT INTO `site_lang` VALUES ('40', '8', 'Meet boys and girls');
INSERT INTO `site_lang` VALUES ('39', '8', 'Meet boys');
INSERT INTO `site_lang` VALUES ('38', '8', 'Meet girls');
INSERT INTO `site_lang` VALUES ('37', '8', 'Im here to');
INSERT INTO `site_lang` VALUES ('36', '8', 'Female');
INSERT INTO `site_lang` VALUES ('35', '8', 'Male');
INSERT INTO `site_lang` VALUES ('34', '8', 'Gender');
INSERT INTO `site_lang` VALUES ('33', '8', 'Where do you live?');
INSERT INTO `site_lang` VALUES ('32', '8', 'City');
INSERT INTO `site_lang` VALUES ('31', '8', 'Please select');
INSERT INTO `site_lang` VALUES ('30', '8', 'Birthday');
INSERT INTO `site_lang` VALUES ('29', '8', 'Password');
INSERT INTO `site_lang` VALUES ('28', '8', 'Email');
INSERT INTO `site_lang` VALUES ('27', '8', 'Your name or nickname');
INSERT INTO `site_lang` VALUES ('26', '8', 'Name');
INSERT INTO `site_lang` VALUES ('25', '8', 'Join the worlds bestest community for meeting new people!.');
INSERT INTO `site_lang` VALUES ('24', '8', 'Become a member now');
INSERT INTO `site_lang` VALUES ('23', '8', 'Play our popular Discover game and get matched with other users. Its a great way to break the ice and chat to new people.');
INSERT INTO `site_lang` VALUES ('22', '8', 'Matches');
INSERT INTO `site_lang` VALUES ('21', '8', 'We wont show your exact location, but you will be able to find people nearby who like the same things you do.');
INSERT INTO `site_lang` VALUES ('20', '8', 'People nearby');
INSERT INTO `site_lang` VALUES ('19', '8', 'You can make quality videocalls for free to anyone, without limits of call duration, just enjoy seeing the person who is chatting with you');
INSERT INTO `site_lang` VALUES ('18', '8', 'Video Chat');
INSERT INTO `site_lang` VALUES ('17', '8', 'Powerfull private chat for meet new friends, you can send emoticons and private photos to anyone.');
INSERT INTO `site_lang` VALUES ('16', '8', 'Chat');
INSERT INTO `site_lang` VALUES ('15', '8', 'Recover password');
INSERT INTO `site_lang` VALUES ('14', '8', 'Password recover');
INSERT INTO `site_lang` VALUES ('13', '8', 'Login now');
INSERT INTO `site_lang` VALUES ('12', '8', 'do you forget your password?');
INSERT INTO `site_lang` VALUES ('11', '8', 'Your password');
INSERT INTO `site_lang` VALUES ('10', '8', 'Your email');
INSERT INTO `site_lang` VALUES ('9', '8', 'Welcome back');
INSERT INTO `site_lang` VALUES ('8', '8', 'Create your account');
INSERT INTO `site_lang` VALUES ('7', '8', 'Connect with ');
INSERT INTO `site_lang` VALUES ('6', '8', 'SOON AVAILABLE');
INSERT INTO `site_lang` VALUES ('5', '8', 'Soon we will have our phone apps online');
INSERT INTO `site_lang` VALUES ('4', '8', 'Please visit us from your laptop or PC');
INSERT INTO `site_lang` VALUES ('3', '8', 'For now our site works only for Desktop users');
INSERT INTO `site_lang` VALUES ('2', '8', 'Welcome to the fastest growing place to meet new people');
INSERT INTO `site_lang` VALUES ('1', '8', 'Login');
INSERT INTO `site_lang` VALUES ('0', '8', 'meet new people!');
INSERT INTO `site_lang` VALUES ('384', '7', 'Ok, i understand');
INSERT INTO `site_lang` VALUES ('383', '7', 'must like you for start a videocall');
INSERT INTO `site_lang` VALUES ('382', '7', 'dont like you');
INSERT INTO `site_lang` VALUES ('381', '7', 'calling...');
INSERT INTO `site_lang` VALUES ('380', '7', 'Welcome to');
INSERT INTO `site_lang` VALUES ('379', '7', 'Go to');
INSERT INTO `site_lang` VALUES ('378', '7', 'Please save your connection information in a safe place');
INSERT INTO `site_lang` VALUES ('376', '7', 'E-mail');
INSERT INTO `site_lang` VALUES ('377', '7', 'Password');
INSERT INTO `site_lang` VALUES ('375', '7', 'Here are your connection details');
INSERT INTO `site_lang` VALUES ('374', '7', 'Start meeting new people now');
INSERT INTO `site_lang` VALUES ('372', '7', 'Add photos and complete your profile');
INSERT INTO `site_lang` VALUES ('373', '7', 'More than 1 million people have joined $site_name You probably want to know some of them.');
INSERT INTO `site_lang` VALUES ('371', '7', 'Nobody is going to fall in love with a blank page. The more information you get, the more chances to find that special someone!');
INSERT INTO `site_lang` VALUES ('370', '7', 'Meet new people');
INSERT INTO `site_lang` VALUES ('368', '7', 'In');
INSERT INTO `site_lang` VALUES ('369', '7', 'you can meet people instantly');
INSERT INTO `site_lang` VALUES ('367', '7', 'people in your area wants to know you');
INSERT INTO `site_lang` VALUES ('366', '7', 'Newsflash');
INSERT INTO `site_lang` VALUES ('365', '7', 'Verify your account');
INSERT INTO `site_lang` VALUES ('358', '7', 'is new at');
INSERT INTO `site_lang` VALUES ('359', '7', 'and lives closer to you');
INSERT INTO `site_lang` VALUES ('360', '7', 'Check out the profile');
INSERT INTO `site_lang` VALUES ('361', '7', 'Welcome');
INSERT INTO `site_lang` VALUES ('362', '7', 'Well done, now you are in');
INSERT INTO `site_lang` VALUES ('363', '7', 'Here are a few tips');
INSERT INTO `site_lang` VALUES ('364', '7', 'Now you are a new member of');
INSERT INTO `site_lang` VALUES ('357', '7', 'is new and lives closer to you');
INSERT INTO `site_lang` VALUES ('353', '7', 'New message from');
INSERT INTO `site_lang` VALUES ('354', '7', 'you have a new message from');
INSERT INTO `site_lang` VALUES ('355', '7', 'Respond to');
INSERT INTO `site_lang` VALUES ('356', '7', 'Have fun!');
INSERT INTO `site_lang` VALUES ('352', '7', 'Go and say something to');
INSERT INTO `site_lang` VALUES ('351', '7', 'thinks the feeling is mutual');
INSERT INTO `site_lang` VALUES ('350', '7', 'Its a match!');
INSERT INTO `site_lang` VALUES ('349', '7', 'You have a match at');
INSERT INTO `site_lang` VALUES ('347', '7', 'Choose a new password');
INSERT INTO `site_lang` VALUES ('348', '7', 'if you forgot your password, click on the link below to get a new');
INSERT INTO `site_lang` VALUES ('346', '7', 'Unsubscribe');
INSERT INTO `site_lang` VALUES ('345', '7', 'You received this notice because you registered as');
INSERT INTO `site_lang` VALUES ('344', '7', 'Find out if you also like');
INSERT INTO `site_lang` VALUES ('343', '7', 'has seen you in discover and likes. The feeling is mutual?');
INSERT INTO `site_lang` VALUES ('342', '7', 'likes you and wants to chat in');
INSERT INTO `site_lang` VALUES ('341', '7', 'We sent you a email with your info, it may take up to 1 min to arrive');
INSERT INTO `site_lang` VALUES ('340', '7', 'Loading...');
INSERT INTO `site_lang` VALUES ('339', '7', 'of');
INSERT INTO `site_lang` VALUES ('338', '7', 'Photos of ');
INSERT INTO `site_lang` VALUES ('337', '7', 'is calling you..');
INSERT INTO `site_lang` VALUES ('336', '7', 'Password successfully changed');
INSERT INTO `site_lang` VALUES ('335', '7', 'Service cost');
INSERT INTO `site_lang` VALUES ('334', '7', 'Spotlight');
INSERT INTO `site_lang` VALUES ('333', '7', 'Wrong');
INSERT INTO `site_lang` VALUES ('332', '7', 'days of Premium');
INSERT INTO `site_lang` VALUES ('331', '7', 'username');
INSERT INTO `site_lang` VALUES ('330', '7', 'You need to write your username!');
INSERT INTO `site_lang` VALUES ('329', '7', 'Write your instagram username');
INSERT INTO `site_lang` VALUES ('328', '7', 'Press backspace key for smart return to the meeting section.');
INSERT INTO `site_lang` VALUES ('327', '7', 'Are you sure you want to report');
INSERT INTO `site_lang` VALUES ('326', '7', 'Report and block');
INSERT INTO `site_lang` VALUES ('325', '7', 'is blocking you or you blocked him, you cant chat with him sorry');
INSERT INTO `site_lang` VALUES ('324', '7', 'We sended you a email for verify your account');
INSERT INTO `site_lang` VALUES ('323', '7', 'years old and im from');
INSERT INTO `site_lang` VALUES ('321', '7', 'Please add a profile photo');
INSERT INTO `site_lang` VALUES ('322', '7', 'Hi, im');
INSERT INTO `site_lang` VALUES ('320', '7', 'Please verify your account, check your email');
INSERT INTO `site_lang` VALUES ('319', '7', 'ago');
INSERT INTO `site_lang` VALUES ('317', '7', 'minutes');
INSERT INTO `site_lang` VALUES ('318', '7', 'seconds');
INSERT INTO `site_lang` VALUES ('316', '7', 'hours');
INSERT INTO `site_lang` VALUES ('314', '7', 'months');
INSERT INTO `site_lang` VALUES ('315', '7', 'days');
INSERT INTO `site_lang` VALUES ('313', '7', 'years');
INSERT INTO `site_lang` VALUES ('312', '7', 'second');
INSERT INTO `site_lang` VALUES ('311', '7', 'minute');
INSERT INTO `site_lang` VALUES ('309', '7', 'day');
INSERT INTO `site_lang` VALUES ('310', '7', 'hour');
INSERT INTO `site_lang` VALUES ('308', '7', 'month');
INSERT INTO `site_lang` VALUES ('307', '7', 'year');
INSERT INTO `site_lang` VALUES ('305', '7', 'Credits for $');
INSERT INTO `site_lang` VALUES ('306', '7', '0 seconds');
INSERT INTO `site_lang` VALUES ('304', '7', 'Cost');
INSERT INTO `site_lang` VALUES ('303', '7', 'You do not like anyone');
INSERT INTO `site_lang` VALUES ('302', '7', 'visited');
INSERT INTO `site_lang` VALUES ('300', '7', 'AGE');
INSERT INTO `site_lang` VALUES ('301', '7', 'You dont have any visit yet');
INSERT INTO `site_lang` VALUES ('298', '7', 'Like');
INSERT INTO `site_lang` VALUES ('299', '7', 'Dislike');
INSERT INTO `site_lang` VALUES ('297', '7', 'Messages');
INSERT INTO `site_lang` VALUES ('296', '7', 'people liked you, for see them');
INSERT INTO `site_lang` VALUES ('295', '7', 'People i like');
INSERT INTO `site_lang` VALUES ('294', '7', 'Upgrade your account to premium');
INSERT INTO `site_lang` VALUES ('293', '7', 'people visited your profile for see them');
INSERT INTO `site_lang` VALUES ('292', '7', 'Delete');
INSERT INTO `site_lang` VALUES ('290', '7', 'Private photo');
INSERT INTO `site_lang` VALUES ('291', '7', 'Public photo');
INSERT INTO `site_lang` VALUES ('289', '7', 'Set as profile');
INSERT INTO `site_lang` VALUES ('288', '7', 'get seen by millions');
INSERT INTO `site_lang` VALUES ('287', '7', 'Add me here');
INSERT INTO `site_lang` VALUES ('286', '7', 'Visits');
INSERT INTO `site_lang` VALUES ('285', '7', 'Credits');
INSERT INTO `site_lang` VALUES ('284', '7', 'Photos');
INSERT INTO `site_lang` VALUES ('283', '7', 'Add');
INSERT INTO `site_lang` VALUES ('282', '7', 'Add from ');
INSERT INTO `site_lang` VALUES ('281', '7', 'Private photos');
INSERT INTO `site_lang` VALUES ('280', '7', 'Public Photos');
INSERT INTO `site_lang` VALUES ('279', '7', 'No data');
INSERT INTO `site_lang` VALUES ('278', '7', 'Fans');
INSERT INTO `site_lang` VALUES ('277', '7', 'Report');
INSERT INTO `site_lang` VALUES ('276', '7', 'Interests');
INSERT INTO `site_lang` VALUES ('274', '7', 'Year');
INSERT INTO `site_lang` VALUES ('275', '7', 'Please wait');
INSERT INTO `site_lang` VALUES ('273', '7', 'Month');
INSERT INTO `site_lang` VALUES ('272', '7', 'Day');
INSERT INTO `site_lang` VALUES ('270', '7', 'When new users near me join in');
INSERT INTO `site_lang` VALUES ('271', '7', 'When someone send me a message');
INSERT INTO `site_lang` VALUES ('269', '7', 'When i get a match');
INSERT INTO `site_lang` VALUES ('268', '7', 'When someone likes me');
INSERT INTO `site_lang` VALUES ('265', '7', 'I own a car');
INSERT INTO `site_lang` VALUES ('266', '7', 'I own a motorbike');
INSERT INTO `site_lang` VALUES ('267', '7', 'None');
INSERT INTO `site_lang` VALUES ('264', '7', 'Parents car');
INSERT INTO `site_lang` VALUES ('263', '7', 'Transport');
INSERT INTO `site_lang` VALUES ('260', '7', 'No');
INSERT INTO `site_lang` VALUES ('261', '7', 'Sometimes');
INSERT INTO `site_lang` VALUES ('262', '7', 'Drink');
INSERT INTO `site_lang` VALUES ('259', '7', 'Yes');
INSERT INTO `site_lang` VALUES ('258', '7', 'Smoke');
INSERT INTO `site_lang` VALUES ('254', '7', 'With housemate');
INSERT INTO `site_lang` VALUES ('255', '7', 'Student dormitory');
INSERT INTO `site_lang` VALUES ('256', '7', 'With partner');
INSERT INTO `site_lang` VALUES ('257', '7', 'Alone');
INSERT INTO `site_lang` VALUES ('253', '7', 'With parents');
INSERT INTO `site_lang` VALUES ('252', '7', 'Living');
INSERT INTO `site_lang` VALUES ('251', '7', 'Curvy');
INSERT INTO `site_lang` VALUES ('250', '7', 'Heavy set');
INSERT INTO `site_lang` VALUES ('249', '7', 'Athletic');
INSERT INTO `site_lang` VALUES ('248', '7', 'Average');
INSERT INTO `site_lang` VALUES ('247', '7', 'Slim');
INSERT INTO `site_lang` VALUES ('246', '7', 'Body type');
INSERT INTO `site_lang` VALUES ('245', '7', 'Other');
INSERT INTO `site_lang` VALUES ('244', '7', 'Indian');
INSERT INTO `site_lang` VALUES ('242', '7', 'Hispanic/latin');
INSERT INTO `site_lang` VALUES ('243', '7', 'Pacific Islander');
INSERT INTO `site_lang` VALUES ('240', '7', 'White');
INSERT INTO `site_lang` VALUES ('241', '7', 'Native American');
INSERT INTO `site_lang` VALUES ('239', '7', 'Black');
INSERT INTO `site_lang` VALUES ('237', '7', 'Asian');
INSERT INTO `site_lang` VALUES ('238', '7', 'Middle Eastern');
INSERT INTO `site_lang` VALUES ('236', '7', 'Ethnicity');
INSERT INTO `site_lang` VALUES ('235', '7', 'Weight');
INSERT INTO `site_lang` VALUES ('234', '7', 'more than');
INSERT INTO `site_lang` VALUES ('233', '7', 'less than');
INSERT INTO `site_lang` VALUES ('230', '7', 'Straight');
INSERT INTO `site_lang` VALUES ('231', '7', 'Bisexual');
INSERT INTO `site_lang` VALUES ('232', '7', 'Height');
INSERT INTO `site_lang` VALUES ('229', '7', 'Open-minded');
INSERT INTO `site_lang` VALUES ('228', '7', 'Gay');
INSERT INTO `site_lang` VALUES ('226', '7', 'Open');
INSERT INTO `site_lang` VALUES ('227', '7', 'Sexuality');
INSERT INTO `site_lang` VALUES ('225', '7', 'Taken');
INSERT INTO `site_lang` VALUES ('224', '7', 'Single');
INSERT INTO `site_lang` VALUES ('223', '7', 'Relationship');
INSERT INTO `site_lang` VALUES ('222', '7', 'Extended info (optional)');
INSERT INTO `site_lang` VALUES ('221', '7', 'Notifications');
INSERT INTO `site_lang` VALUES ('220', '7', 'UPGRADE');
INSERT INTO `site_lang` VALUES ('219', '7', 'Basic');
INSERT INTO `site_lang` VALUES ('218', '7', 'until');
INSERT INTO `site_lang` VALUES ('217', '7', 'Wait more');
INSERT INTO `site_lang` VALUES ('216', '7', 'End call');
INSERT INTO `site_lang` VALUES ('215', '7', 'Seems that your friend do not have webcam or he is not available');
INSERT INTO `site_lang` VALUES ('214', '7', 'Too long wait');
INSERT INTO `site_lang` VALUES ('213', '7', 'You cant make videocall because you dont have webcam');
INSERT INTO `site_lang` VALUES ('212', '7', 'Impossible to make a call!');
INSERT INTO `site_lang` VALUES ('211', '7', 'Only premium users can make videocalls');
INSERT INTO `site_lang` VALUES ('210', '7', 'You are already in a videocall, you have to end the other call before start another');
INSERT INTO `site_lang` VALUES ('209', '7', 'Please allow access to your Webcam.');
INSERT INTO `site_lang` VALUES ('208', '7', 'is offline, try again when your friend is online');
INSERT INTO `site_lang` VALUES ('207', '7', 'is in another videocall , you cant call now');
INSERT INTO `site_lang` VALUES ('206', '7', 'Yes, delete it!');
INSERT INTO `site_lang` VALUES ('205', '7', 'Your data will be lost without recovery, continue?');
INSERT INTO `site_lang` VALUES ('204', '7', 'Account termination');
INSERT INTO `site_lang` VALUES ('203', '7', 'Information updated successfully');
INSERT INTO `site_lang` VALUES ('202', '7', 'Yes, buy it!');
INSERT INTO `site_lang` VALUES ('201', '7', 'more daily conversation, cost ');
INSERT INTO `site_lang` VALUES ('200', '7', 'Expand daily limitation ');
INSERT INTO `site_lang` VALUES ('199', '7', 'You dont have enought credits for send the gift');
INSERT INTO `site_lang` VALUES ('197', '7', 'Please, select 1 photo');
INSERT INTO `site_lang` VALUES ('198', '7', 'Please, select 1 gift');
INSERT INTO `site_lang` VALUES ('195', '7', 'No thanks');
INSERT INTO `site_lang` VALUES ('196', '7', 'Please, select a payment method');
INSERT INTO `site_lang` VALUES ('191', '7', 'Buy private photos permission');
INSERT INTO `site_lang` VALUES ('192', '7', 'Get access to');
INSERT INTO `site_lang` VALUES ('193', '7', 'private photos for ');
INSERT INTO `site_lang` VALUES ('194', '7', 'Get access');
INSERT INTO `site_lang` VALUES ('190', '7', 'No, i cant show you my private photos');
INSERT INTO `site_lang` VALUES ('184', '7', 'Wrong password');
INSERT INTO `site_lang` VALUES ('185', '7', 'Add a valid date');
INSERT INTO `site_lang` VALUES ('186', '7', 'Choose city from the autocomplete');
INSERT INTO `site_lang` VALUES ('187', '7', 'Password too short');
INSERT INTO `site_lang` VALUES ('188', '7', 'Email already exist, try another');
INSERT INTO `site_lang` VALUES ('178', '7', 'If you dont remember your password, click the link below to set a new one:');
INSERT INTO `site_lang` VALUES ('189', '7', 'Yes, you can see my private photos');
INSERT INTO `site_lang` VALUES ('183', '7', 'Email dont exist');
INSERT INTO `site_lang` VALUES ('182', '7', 'Please fill all the inputs');
INSERT INTO `site_lang` VALUES ('181', '7', 'Invalid email format');
INSERT INTO `site_lang` VALUES ('180', '7', 'Password recover');
INSERT INTO `site_lang` VALUES ('179', '7', 'Login to my account');
INSERT INTO `site_lang` VALUES ('177', '7', 'Hi');
INSERT INTO `site_lang` VALUES ('176', '7', 'No');
INSERT INTO `site_lang` VALUES ('175', '7', 'Yes');
INSERT INTO `site_lang` VALUES ('174', '7', 'Hello, can i have access to your private photos ?');
INSERT INTO `site_lang` VALUES ('173', '7', 'like this');
INSERT INTO `site_lang` VALUES ('169', '7', 'December');
INSERT INTO `site_lang` VALUES ('170', '7', 'Buy');
INSERT INTO `site_lang` VALUES ('171', '7', 'Days Premium');
INSERT INTO `site_lang` VALUES ('172', '7', 'persons more like this');
INSERT INTO `site_lang` VALUES ('165', '7', 'August');
INSERT INTO `site_lang` VALUES ('166', '7', 'September');
INSERT INTO `site_lang` VALUES ('167', '7', 'October');
INSERT INTO `site_lang` VALUES ('168', '7', 'November');
INSERT INTO `site_lang` VALUES ('164', '7', 'July');
INSERT INTO `site_lang` VALUES ('163', '7', 'June');
INSERT INTO `site_lang` VALUES ('162', '7', 'May');
INSERT INTO `site_lang` VALUES ('161', '7', 'April');
INSERT INTO `site_lang` VALUES ('160', '7', 'March');
INSERT INTO `site_lang` VALUES ('158', '7', 'January');
INSERT INTO `site_lang` VALUES ('159', '7', 'February');
INSERT INTO `site_lang` VALUES ('157', '7', 'You dont have matches yet');
INSERT INTO `site_lang` VALUES ('156', '7', 'You dont have any fans yet');
INSERT INTO `site_lang` VALUES ('155', '7', 'No popular users near you');
INSERT INTO `site_lang` VALUES ('153', '7', 'Nothing found');
INSERT INTO `site_lang` VALUES ('154', '7', 'people found');
INSERT INTO `site_lang` VALUES ('152', '7', 'Verified');
INSERT INTO `site_lang` VALUES ('151', '7', 'Online now');
INSERT INTO `site_lang` VALUES ('150', '7', 'Delete profile');
INSERT INTO `site_lang` VALUES ('149', '7', 'After delete your profile, some of your data will be lost without recovery.');
INSERT INTO `site_lang` VALUES ('147', '7', 'New password');
INSERT INTO `site_lang` VALUES ('148', '7', 'Profile desactivation');
INSERT INTO `site_lang` VALUES ('137', '7', 'For verify your account , connect with your facebook account');
INSERT INTO `site_lang` VALUES ('146', '7', 'You can change your current password bellow');
INSERT INTO `site_lang` VALUES ('145', '7', 'Change password');
INSERT INTO `site_lang` VALUES ('144', '7', 'Upgrade to premium account');
INSERT INTO `site_lang` VALUES ('143', '7', 'Add credits');
INSERT INTO `site_lang` VALUES ('142', '7', 'Current credits');
INSERT INTO `site_lang` VALUES ('141', '7', 'Account type');
INSERT INTO `site_lang` VALUES ('140', '7', 'Buy credits for send Gifs and Unblock private photos');
INSERT INTO `site_lang` VALUES ('139', '7', 'You are account is already verified');
INSERT INTO `site_lang` VALUES ('138', '7', 'Connect with Facebook');
INSERT INTO `site_lang` VALUES ('136', '7', 'Verify account');
INSERT INTO `site_lang` VALUES ('135', '7', 'Update profile');
INSERT INTO `site_lang` VALUES ('134', '7', 'Site language');
INSERT INTO `site_lang` VALUES ('133', '7', 'You can edit your profile information bellow');
INSERT INTO `site_lang` VALUES ('132', '7', 'Personal information');
INSERT INTO `site_lang` VALUES ('131', '7', 'Delete');
INSERT INTO `site_lang` VALUES ('130', '7', 'Change password');
INSERT INTO `site_lang` VALUES ('129', '7', 'Verify');
INSERT INTO `site_lang` VALUES ('128', '7', 'Credits');
INSERT INTO `site_lang` VALUES ('127', '7', 'Personal');
INSERT INTO `site_lang` VALUES ('126', '7', 'Unblock private photos');
INSERT INTO `site_lang` VALUES ('125', '7', 'Ask permission to');
INSERT INTO `site_lang` VALUES ('124', '7', 'Now you have');
INSERT INTO `site_lang` VALUES ('123', '7', 'Credits successfully added to your account');
INSERT INTO `site_lang` VALUES ('122', '7', 'boys and girls');
INSERT INTO `site_lang` VALUES ('121', '7', 'Only girls');
INSERT INTO `site_lang` VALUES ('120', '7', 'Only boys');
INSERT INTO `site_lang` VALUES ('119', '7', 'years old');
INSERT INTO `site_lang` VALUES ('118', '7', 'Personal info');
INSERT INTO `site_lang` VALUES ('117', '7', 'About ');
INSERT INTO `site_lang` VALUES ('116', '7', 'Most popular users');
INSERT INTO `site_lang` VALUES ('115', '7', 'World');
INSERT INTO `site_lang` VALUES ('114', '7', 'in a radius of');
INSERT INTO `site_lang` VALUES ('112', '7', 'Both');
INSERT INTO `site_lang` VALUES ('113', '7', 'who are between');
INSERT INTO `site_lang` VALUES ('111', '7', 'Boys');
INSERT INTO `site_lang` VALUES ('110', '7', 'Girls');
INSERT INTO `site_lang` VALUES ('109', '7', 'Show me');
INSERT INTO `site_lang` VALUES ('108', '7', 'Online now');
INSERT INTO `site_lang` VALUES ('107', '7', 'All users');
INSERT INTO `site_lang` VALUES ('106', '7', 'Filter Search');
INSERT INTO `site_lang` VALUES ('105', '7', 'Your matches');
INSERT INTO `site_lang` VALUES ('104', '7', 'Please complete your profile before start in ');
INSERT INTO `site_lang` VALUES ('103', '7', 'Terms of Use');
INSERT INTO `site_lang` VALUES ('102', '7', 'Privacy Policy');
INSERT INTO `site_lang` VALUES ('101', '7', 'Your fans');
INSERT INTO `site_lang` VALUES ('100', '7', 'or wait until tomorrow for continue meeting people');
INSERT INTO `site_lang` VALUES ('99', '7', 'daily conversations');
INSERT INTO `site_lang` VALUES ('98', '7', 'and get up to');
INSERT INTO `site_lang` VALUES ('97', '7', 'Upgrade your account to Premium');
INSERT INTO `site_lang` VALUES ('96', '7', 'or');
INSERT INTO `site_lang` VALUES ('95', '7', 'more daily conversation');
INSERT INTO `site_lang` VALUES ('94', '7', 'Buy');
INSERT INTO `site_lang` VALUES ('93', '7', 'To continue chatting');
INSERT INTO `site_lang` VALUES ('92', '7', 'you have reached the limit of new daily conversations');
INSERT INTO `site_lang` VALUES ('91', '7', 'Chat');
INSERT INTO `site_lang` VALUES ('90', '7', 'Send');
INSERT INTO `site_lang` VALUES ('89', '7', 'Write text here');
INSERT INTO `site_lang` VALUES ('88', '7', 'Premium user badge');
INSERT INTO `site_lang` VALUES ('87', '7', 'Unblock all private photos');
INSERT INTO `site_lang` VALUES ('86', '7', 'Unlimited videocalls');
INSERT INTO `site_lang` VALUES ('85', '7', 'new chats per day');
INSERT INTO `site_lang` VALUES ('84', '7', 'Premium Account Features');
INSERT INTO `site_lang` VALUES ('83', '7', 'Buy credits');
INSERT INTO `site_lang` VALUES ('82', '7', 'Pay with');
INSERT INTO `site_lang` VALUES ('81', '7', 'Pay with');
INSERT INTO `site_lang` VALUES ('80', '7', 'Select payment method');
INSERT INTO `site_lang` VALUES ('79', '7', 'Select credits package');
INSERT INTO `site_lang` VALUES ('78', '7', 'Buy credits / Upgrade account');
INSERT INTO `site_lang` VALUES ('77', '7', 'Send gift');
INSERT INTO `site_lang` VALUES ('76', '7', 'Pick the gift you want to send to ');
INSERT INTO `site_lang` VALUES ('75', '7', 'Send gift to ');
INSERT INTO `site_lang` VALUES ('74', '7', 'Add photo');
INSERT INTO `site_lang` VALUES ('73', '7', 'Credits');
INSERT INTO `site_lang` VALUES ('72', '7', 'Pick the photo you want to show in the Spotlight, cost ');
INSERT INTO `site_lang` VALUES ('71', '7', 'Add yourself to the Spotlight');
INSERT INTO `site_lang` VALUES ('70', '7', 'add photos');
INSERT INTO `site_lang` VALUES ('69', '7', 'Add your photos');
INSERT INTO `site_lang` VALUES ('68', '7', 'Private Photos');
INSERT INTO `site_lang` VALUES ('67', '7', 'Public Photos');
INSERT INTO `site_lang` VALUES ('66', '7', 'All Photos');
INSERT INTO `site_lang` VALUES ('65', '7', 'Manage your photos');
INSERT INTO `site_lang` VALUES ('64', '7', 'Contact');
INSERT INTO `site_lang` VALUES ('63', '7', 'Privacy');
INSERT INTO `site_lang` VALUES ('62', '7', 'Terms');
INSERT INTO `site_lang` VALUES ('61', '7', 'Who to like');
INSERT INTO `site_lang` VALUES ('60', '7', 'New messages');
INSERT INTO `site_lang` VALUES ('59', '7', 'Online now');
INSERT INTO `site_lang` VALUES ('58', '7', 'Conversations');
INSERT INTO `site_lang` VALUES ('56', '7', 'All');
INSERT INTO `site_lang` VALUES ('57', '7', 'Fans');
INSERT INTO `site_lang` VALUES ('55', '7', 'Settings');
INSERT INTO `site_lang` VALUES ('54', '7', 'Manage photos');
INSERT INTO `site_lang` VALUES ('53', '7', 'Fans');
INSERT INTO `site_lang` VALUES ('52', '7', 'Most populars');
INSERT INTO `site_lang` VALUES ('51', '7', 'Matches');
INSERT INTO `site_lang` VALUES ('50', '7', 'Discover');
INSERT INTO `site_lang` VALUES ('49', '7', 'Meet new people');
INSERT INTO `site_lang` VALUES ('47', '7', 'Settings');
INSERT INTO `site_lang` VALUES ('48', '7', 'Logout');
INSERT INTO `site_lang` VALUES ('43', '7', 'Terms and Conditions');
INSERT INTO `site_lang` VALUES ('44', '7', 'and');
INSERT INTO `site_lang` VALUES ('45', '7', 'Privacy Policy');
INSERT INTO `site_lang` VALUES ('46', '7', 'Profile');
INSERT INTO `site_lang` VALUES ('42', '7', 'By continuing, you are confirming that you have read and agree to our');
INSERT INTO `site_lang` VALUES ('41', '7', 'Sign up');
INSERT INTO `site_lang` VALUES ('39', '7', 'Meet boys');
INSERT INTO `site_lang` VALUES ('40', '7', 'Meet boys and girls');
INSERT INTO `site_lang` VALUES ('29', '7', 'Password');
INSERT INTO `site_lang` VALUES ('30', '7', 'Birthday');
INSERT INTO `site_lang` VALUES ('31', '7', 'Please select');
INSERT INTO `site_lang` VALUES ('32', '7', 'City');
INSERT INTO `site_lang` VALUES ('33', '7', 'Where do you live?');
INSERT INTO `site_lang` VALUES ('34', '7', 'Gender');
INSERT INTO `site_lang` VALUES ('35', '7', 'Male');
INSERT INTO `site_lang` VALUES ('36', '7', 'Female');
INSERT INTO `site_lang` VALUES ('37', '7', 'Im here to');
INSERT INTO `site_lang` VALUES ('38', '7', 'Meet girls');
INSERT INTO `site_lang` VALUES ('28', '7', 'Email');
INSERT INTO `site_lang` VALUES ('27', '7', 'Your name or nickname');
INSERT INTO `site_lang` VALUES ('26', '7', 'Name');
INSERT INTO `site_lang` VALUES ('25', '7', 'Join the worlds bestest community for meeting new people!.');
INSERT INTO `site_lang` VALUES ('22', '7', 'Matches');
INSERT INTO `site_lang` VALUES ('23', '7', 'Play our popular Discover game and get matched with other users. Its a great way to break the ice and chat to new people.');
INSERT INTO `site_lang` VALUES ('24', '7', 'Become a member now');
INSERT INTO `site_lang` VALUES ('20', '7', 'People nearby');
INSERT INTO `site_lang` VALUES ('21', '7', 'We wont show your exact location, but you will be able to find people nearby who like the same things you do.');
INSERT INTO `site_lang` VALUES ('19', '7', 'You can make quality videocalls for free to anyone, without limits of call duration, just enjoy seeing the person who is chatting with you');
INSERT INTO `site_lang` VALUES ('18', '7', 'Video Chat');
INSERT INTO `site_lang` VALUES ('17', '7', 'Powerfull private chat for meet new friends, you can send emoticons and private photos to anyone.');
INSERT INTO `site_lang` VALUES ('16', '7', 'Chat');
INSERT INTO `site_lang` VALUES ('15', '7', 'Recover password');
INSERT INTO `site_lang` VALUES ('14', '7', 'Password recover');
INSERT INTO `site_lang` VALUES ('13', '7', 'Login now');
INSERT INTO `site_lang` VALUES ('12', '7', 'do you forget your password?');
INSERT INTO `site_lang` VALUES ('10', '7', 'Your email');
INSERT INTO `site_lang` VALUES ('11', '7', 'Your password');
INSERT INTO `site_lang` VALUES ('9', '7', 'Welcome back');
INSERT INTO `site_lang` VALUES ('8', '7', 'Create your account');
INSERT INTO `site_lang` VALUES ('7', '7', 'Connect with ');
INSERT INTO `site_lang` VALUES ('6', '7', 'SOON AVAILABLE');
INSERT INTO `site_lang` VALUES ('5', '7', 'Soon we will have our phone apps online');
INSERT INTO `site_lang` VALUES ('4', '7', 'Please visit us from your laptop or PC');
INSERT INTO `site_lang` VALUES ('3', '7', 'For now our site works only for Desktop users');
INSERT INTO `site_lang` VALUES ('2', '7', 'Welcome to the fastest growing place to meet new people');
INSERT INTO `site_lang` VALUES ('1', '7', 'Login');
INSERT INTO `site_lang` VALUES ('0', '7', 'meet new people!');
INSERT INTO `site_lang` VALUES ('384', '6', 'Ok, i understand');
INSERT INTO `site_lang` VALUES ('383', '6', 'must like you for start a videocall');
INSERT INTO `site_lang` VALUES ('380', '6', 'Welcome to');
INSERT INTO `site_lang` VALUES ('381', '6', 'calling...');
INSERT INTO `site_lang` VALUES ('382', '6', 'dont like you');
INSERT INTO `site_lang` VALUES ('379', '6', 'Go to');
INSERT INTO `site_lang` VALUES ('378', '6', 'Please save your connection information in a safe place');
INSERT INTO `site_lang` VALUES ('376', '6', 'E-mail');
INSERT INTO `site_lang` VALUES ('377', '6', 'Password');
INSERT INTO `site_lang` VALUES ('375', '6', 'Here are your connection details');
INSERT INTO `site_lang` VALUES ('374', '6', 'Start meeting new people now');
INSERT INTO `site_lang` VALUES ('373', '6', 'More than 1 million people have joined $site_name You probably want to know some of them.');
INSERT INTO `site_lang` VALUES ('372', '6', 'Add photos and complete your profile');
INSERT INTO `site_lang` VALUES ('371', '6', 'Nobody is going to fall in love with a blank page. The more information you get, the more chances to find that special someone!');
INSERT INTO `site_lang` VALUES ('370', '6', 'Meet new people');
INSERT INTO `site_lang` VALUES ('369', '6', 'you can meet people instantly');
INSERT INTO `site_lang` VALUES ('368', '6', 'In');
INSERT INTO `site_lang` VALUES ('367', '6', 'people in your area wants to know you');
INSERT INTO `site_lang` VALUES ('365', '6', 'Verify your account');
INSERT INTO `site_lang` VALUES ('366', '6', 'Newsflash');
INSERT INTO `site_lang` VALUES ('364', '6', 'Now you are a new member of');
INSERT INTO `site_lang` VALUES ('363', '6', 'Here are a few tips');
INSERT INTO `site_lang` VALUES ('361', '6', 'Welcome');
INSERT INTO `site_lang` VALUES ('362', '6', 'Well done, now you are in');
INSERT INTO `site_lang` VALUES ('360', '6', 'Check out the profile');
INSERT INTO `site_lang` VALUES ('359', '6', 'and lives closer to you');
INSERT INTO `site_lang` VALUES ('358', '6', 'is new at');
INSERT INTO `site_lang` VALUES ('356', '6', 'Have fun!');
INSERT INTO `site_lang` VALUES ('357', '6', 'is new and lives closer to you');
INSERT INTO `site_lang` VALUES ('355', '6', 'Respond to');
INSERT INTO `site_lang` VALUES ('354', '6', 'you have a new message from');
INSERT INTO `site_lang` VALUES ('353', '6', 'New message from');
INSERT INTO `site_lang` VALUES ('352', '6', 'Go and say something to');
INSERT INTO `site_lang` VALUES ('350', '6', 'Its a match!');
INSERT INTO `site_lang` VALUES ('351', '6', 'thinks the feeling is mutual');
INSERT INTO `site_lang` VALUES ('349', '6', 'You have a match at');
INSERT INTO `site_lang` VALUES ('348', '6', 'if you forgot your password, click on the link below to get a new');
INSERT INTO `site_lang` VALUES ('347', '6', 'Choose a new password');
INSERT INTO `site_lang` VALUES ('346', '6', 'Unsubscribe');
INSERT INTO `site_lang` VALUES ('345', '6', 'You received this notice because you registered as');
INSERT INTO `site_lang` VALUES ('344', '6', 'Find out if you also like');
INSERT INTO `site_lang` VALUES ('343', '6', 'has seen you in discover and likes. The feeling is mutual?');
INSERT INTO `site_lang` VALUES ('342', '6', 'likes you and wants to chat in');
INSERT INTO `site_lang` VALUES ('341', '6', 'We sent you a email with your info, it may take up to 1 min to arrive');
INSERT INTO `site_lang` VALUES ('340', '6', 'Loading...');
INSERT INTO `site_lang` VALUES ('339', '6', 'of');
INSERT INTO `site_lang` VALUES ('338', '6', 'Photos of ');
INSERT INTO `site_lang` VALUES ('337', '6', 'is calling you..');
INSERT INTO `site_lang` VALUES ('336', '6', 'Password successfully changed');
INSERT INTO `site_lang` VALUES ('335', '6', 'Service cost');
INSERT INTO `site_lang` VALUES ('334', '6', 'Spotlight');
INSERT INTO `site_lang` VALUES ('331', '6', 'username');
INSERT INTO `site_lang` VALUES ('332', '6', 'days of Premium');
INSERT INTO `site_lang` VALUES ('333', '6', 'Wrong');
INSERT INTO `site_lang` VALUES ('330', '6', 'You need to write your username!');
INSERT INTO `site_lang` VALUES ('329', '6', 'Write your instagram username');
INSERT INTO `site_lang` VALUES ('328', '6', 'Press backspace key for smart return to the meeting section.');
INSERT INTO `site_lang` VALUES ('327', '6', 'Are you sure you want to report');
INSERT INTO `site_lang` VALUES ('326', '6', 'Report and block');
INSERT INTO `site_lang` VALUES ('325', '6', 'is blocking you or you blocked him, you cant chat with him sorry');
INSERT INTO `site_lang` VALUES ('324', '6', 'We sended you a email for verify your account');
INSERT INTO `site_lang` VALUES ('322', '6', 'Hi, im');
INSERT INTO `site_lang` VALUES ('323', '6', 'years old and im from');
INSERT INTO `site_lang` VALUES ('321', '6', 'Please add a profile photo');
INSERT INTO `site_lang` VALUES ('320', '6', 'Please verify your account, check your email');
INSERT INTO `site_lang` VALUES ('319', '6', 'ago');
INSERT INTO `site_lang` VALUES ('317', '6', 'minutes');
INSERT INTO `site_lang` VALUES ('318', '6', 'seconds');
INSERT INTO `site_lang` VALUES ('306', '6', '0 seconds');
INSERT INTO `site_lang` VALUES ('307', '6', 'year');
INSERT INTO `site_lang` VALUES ('308', '6', 'month');
INSERT INTO `site_lang` VALUES ('309', '6', 'day');
INSERT INTO `site_lang` VALUES ('310', '6', 'hour');
INSERT INTO `site_lang` VALUES ('311', '6', 'minute');
INSERT INTO `site_lang` VALUES ('312', '6', 'second');
INSERT INTO `site_lang` VALUES ('313', '6', 'years');
INSERT INTO `site_lang` VALUES ('314', '6', 'months');
INSERT INTO `site_lang` VALUES ('315', '6', 'days');
INSERT INTO `site_lang` VALUES ('316', '6', 'hours');
INSERT INTO `site_lang` VALUES ('304', '6', 'Cost');
INSERT INTO `site_lang` VALUES ('305', '6', 'Credits for $');
INSERT INTO `site_lang` VALUES ('303', '6', 'You do not like anyone');
INSERT INTO `site_lang` VALUES ('302', '6', 'visited');
INSERT INTO `site_lang` VALUES ('301', '6', 'You dont have any visit yet');
INSERT INTO `site_lang` VALUES ('300', '6', 'AGE');
INSERT INTO `site_lang` VALUES ('298', '6', 'Like');
INSERT INTO `site_lang` VALUES ('299', '6', 'Dislike');
INSERT INTO `site_lang` VALUES ('297', '6', 'Messages');
INSERT INTO `site_lang` VALUES ('296', '6', 'people liked you, for see them');
INSERT INTO `site_lang` VALUES ('295', '6', 'People i like');
INSERT INTO `site_lang` VALUES ('294', '6', 'Upgrade your account to premium');
INSERT INTO `site_lang` VALUES ('293', '6', 'people visited your profile for see them');
INSERT INTO `site_lang` VALUES ('292', '6', 'Delete');
INSERT INTO `site_lang` VALUES ('291', '6', 'Public photo');
INSERT INTO `site_lang` VALUES ('290', '6', 'Private photo');
INSERT INTO `site_lang` VALUES ('289', '6', 'Set as profile');
INSERT INTO `site_lang` VALUES ('288', '6', 'get seen by millions');
INSERT INTO `site_lang` VALUES ('287', '6', 'Add me here');
INSERT INTO `site_lang` VALUES ('286', '6', 'Visits');
INSERT INTO `site_lang` VALUES ('285', '6', 'Credits');
INSERT INTO `site_lang` VALUES ('284', '6', 'Photos');
INSERT INTO `site_lang` VALUES ('283', '6', 'Add');
INSERT INTO `site_lang` VALUES ('282', '6', 'Add from ');
INSERT INTO `site_lang` VALUES ('281', '6', 'Private photos');
INSERT INTO `site_lang` VALUES ('280', '6', 'Public Photos');
INSERT INTO `site_lang` VALUES ('279', '6', 'No data');
INSERT INTO `site_lang` VALUES ('278', '6', 'Fans');
INSERT INTO `site_lang` VALUES ('277', '6', 'Report');
INSERT INTO `site_lang` VALUES ('276', '6', 'Interests');
INSERT INTO `site_lang` VALUES ('275', '6', 'Please wait');
INSERT INTO `site_lang` VALUES ('274', '6', 'Year');
INSERT INTO `site_lang` VALUES ('273', '6', 'Month');
INSERT INTO `site_lang` VALUES ('272', '6', 'Day');
INSERT INTO `site_lang` VALUES ('271', '6', 'When someone send me a message');
INSERT INTO `site_lang` VALUES ('270', '6', 'When new users near me join in');
INSERT INTO `site_lang` VALUES ('269', '6', 'When i get a match');
INSERT INTO `site_lang` VALUES ('268', '6', 'When someone likes me');
INSERT INTO `site_lang` VALUES ('267', '6', 'None');
INSERT INTO `site_lang` VALUES ('266', '6', 'I own a motorbike');
INSERT INTO `site_lang` VALUES ('265', '6', 'I own a car');
INSERT INTO `site_lang` VALUES ('264', '6', 'Parents car');
INSERT INTO `site_lang` VALUES ('263', '6', 'Transport');
INSERT INTO `site_lang` VALUES ('262', '6', 'Drink');
INSERT INTO `site_lang` VALUES ('261', '6', 'Sometimes');
INSERT INTO `site_lang` VALUES ('260', '6', 'No');
INSERT INTO `site_lang` VALUES ('259', '6', 'Yes');
INSERT INTO `site_lang` VALUES ('258', '6', 'Smoke');
INSERT INTO `site_lang` VALUES ('257', '6', 'Alone');
INSERT INTO `site_lang` VALUES ('256', '6', 'With partner');
INSERT INTO `site_lang` VALUES ('255', '6', 'Student dormitory');
INSERT INTO `site_lang` VALUES ('254', '6', 'With housemate');
INSERT INTO `site_lang` VALUES ('252', '6', 'Living');
INSERT INTO `site_lang` VALUES ('253', '6', 'With parents');
INSERT INTO `site_lang` VALUES ('245', '6', 'Other');
INSERT INTO `site_lang` VALUES ('246', '6', 'Body type');
INSERT INTO `site_lang` VALUES ('247', '6', 'Slim');
INSERT INTO `site_lang` VALUES ('248', '6', 'Average');
INSERT INTO `site_lang` VALUES ('249', '6', 'Athletic');
INSERT INTO `site_lang` VALUES ('250', '6', 'Heavy set');
INSERT INTO `site_lang` VALUES ('251', '6', 'Curvy');
INSERT INTO `site_lang` VALUES ('244', '6', 'Indian');
INSERT INTO `site_lang` VALUES ('229', '6', 'Open-minded');
INSERT INTO `site_lang` VALUES ('230', '6', 'Straight');
INSERT INTO `site_lang` VALUES ('231', '6', 'Bisexual');
INSERT INTO `site_lang` VALUES ('232', '6', 'Height');
INSERT INTO `site_lang` VALUES ('233', '6', 'less than');
INSERT INTO `site_lang` VALUES ('234', '6', 'more than');
INSERT INTO `site_lang` VALUES ('235', '6', 'Weight');
INSERT INTO `site_lang` VALUES ('236', '6', 'Ethnicity');
INSERT INTO `site_lang` VALUES ('237', '6', 'Asian');
INSERT INTO `site_lang` VALUES ('238', '6', 'Middle Eastern');
INSERT INTO `site_lang` VALUES ('239', '6', 'Black');
INSERT INTO `site_lang` VALUES ('240', '6', 'White');
INSERT INTO `site_lang` VALUES ('241', '6', 'Native American');
INSERT INTO `site_lang` VALUES ('242', '6', 'Hispanic/latin');
INSERT INTO `site_lang` VALUES ('243', '6', 'Pacific Islander');
INSERT INTO `site_lang` VALUES ('224', '6', 'Single');
INSERT INTO `site_lang` VALUES ('225', '6', 'Taken');
INSERT INTO `site_lang` VALUES ('226', '6', 'Open');
INSERT INTO `site_lang` VALUES ('227', '6', 'Sexuality');
INSERT INTO `site_lang` VALUES ('228', '6', 'Gay');
INSERT INTO `site_lang` VALUES ('223', '6', 'Relationship');
INSERT INTO `site_lang` VALUES ('222', '6', 'Extended info (optional)');
INSERT INTO `site_lang` VALUES ('221', '6', 'Notifications');
INSERT INTO `site_lang` VALUES ('220', '6', 'UPGRADE');
INSERT INTO `site_lang` VALUES ('219', '6', 'Basic');
INSERT INTO `site_lang` VALUES ('218', '6', 'until');
INSERT INTO `site_lang` VALUES ('216', '6', 'End call');
INSERT INTO `site_lang` VALUES ('217', '6', 'Wait more');
INSERT INTO `site_lang` VALUES ('215', '6', 'Seems that your friend do not have webcam or he is not available');
INSERT INTO `site_lang` VALUES ('214', '6', 'Too long wait');
INSERT INTO `site_lang` VALUES ('213', '6', 'You cant make videocall because you dont have webcam');
INSERT INTO `site_lang` VALUES ('212', '6', 'Impossible to make a call!');
INSERT INTO `site_lang` VALUES ('211', '6', 'Only premium users can make videocalls');
INSERT INTO `site_lang` VALUES ('210', '6', 'You are already in a videocall, you have to end the other call before start another');
INSERT INTO `site_lang` VALUES ('209', '6', 'Please allow access to your Webcam.');
INSERT INTO `site_lang` VALUES ('208', '6', 'is offline, try again when your friend is online');
INSERT INTO `site_lang` VALUES ('207', '6', 'is in another videocall , you cant call now');
INSERT INTO `site_lang` VALUES ('206', '6', 'Yes, delete it!');
INSERT INTO `site_lang` VALUES ('205', '6', 'Your data will be lost without recovery, continue?');
INSERT INTO `site_lang` VALUES ('204', '6', 'Account termination');
INSERT INTO `site_lang` VALUES ('202', '6', 'Yes, buy it!');
INSERT INTO `site_lang` VALUES ('203', '6', 'Information updated successfully');
INSERT INTO `site_lang` VALUES ('201', '6', 'more daily conversation, cost ');
INSERT INTO `site_lang` VALUES ('199', '6', 'You dont have enought credits for send the gift');
INSERT INTO `site_lang` VALUES ('200', '6', 'Expand daily limitation ');
INSERT INTO `site_lang` VALUES ('198', '6', 'Please, select 1 gift');
INSERT INTO `site_lang` VALUES ('197', '6', 'Please, select 1 photo');
INSERT INTO `site_lang` VALUES ('196', '6', 'Please, select a payment method');
INSERT INTO `site_lang` VALUES ('195', '6', 'No thanks');
INSERT INTO `site_lang` VALUES ('194', '6', 'Get access');
INSERT INTO `site_lang` VALUES ('193', '6', 'private photos for ');
INSERT INTO `site_lang` VALUES ('192', '6', 'Get access to');
INSERT INTO `site_lang` VALUES ('191', '6', 'Buy private photos permission');
INSERT INTO `site_lang` VALUES ('190', '6', 'No, i cant show you my private photos');
INSERT INTO `site_lang` VALUES ('189', '6', 'Yes, you can see my private photos');
INSERT INTO `site_lang` VALUES ('188', '6', 'Email already exist, try another');
INSERT INTO `site_lang` VALUES ('187', '6', 'Password too short');
INSERT INTO `site_lang` VALUES ('186', '6', 'Choose city from the autocomplete');
INSERT INTO `site_lang` VALUES ('185', '6', 'Add a valid date');
INSERT INTO `site_lang` VALUES ('184', '6', 'Wrong password');
INSERT INTO `site_lang` VALUES ('183', '6', 'Email dont exist');
INSERT INTO `site_lang` VALUES ('182', '6', 'Please fill all the inputs');
INSERT INTO `site_lang` VALUES ('181', '6', 'Invalid email format');
INSERT INTO `site_lang` VALUES ('180', '6', 'Password recover');
INSERT INTO `site_lang` VALUES ('179', '6', 'Login to my account');
INSERT INTO `site_lang` VALUES ('177', '6', 'Hi');
INSERT INTO `site_lang` VALUES ('178', '6', 'If you dont remember your password, click the link below to set a new one:');
INSERT INTO `site_lang` VALUES ('176', '6', 'No');
INSERT INTO `site_lang` VALUES ('175', '6', 'Yes');
INSERT INTO `site_lang` VALUES ('174', '6', 'Hello, can i have access to your private photos ?');
INSERT INTO `site_lang` VALUES ('173', '6', 'like this');
INSERT INTO `site_lang` VALUES ('172', '6', 'persons more like this');
INSERT INTO `site_lang` VALUES ('171', '6', 'Days Premium');
INSERT INTO `site_lang` VALUES ('170', '6', 'Buy');
INSERT INTO `site_lang` VALUES ('169', '6', 'December');
INSERT INTO `site_lang` VALUES ('168', '6', 'November');
INSERT INTO `site_lang` VALUES ('167', '6', 'October');
INSERT INTO `site_lang` VALUES ('166', '6', 'September');
INSERT INTO `site_lang` VALUES ('165', '6', 'August');
INSERT INTO `site_lang` VALUES ('164', '6', 'July');
INSERT INTO `site_lang` VALUES ('163', '6', 'June');
INSERT INTO `site_lang` VALUES ('162', '6', 'May');
INSERT INTO `site_lang` VALUES ('161', '6', 'April');
INSERT INTO `site_lang` VALUES ('160', '6', 'March');
INSERT INTO `site_lang` VALUES ('159', '6', 'February');
INSERT INTO `site_lang` VALUES ('158', '6', 'January');
INSERT INTO `site_lang` VALUES ('157', '6', 'You dont have matches yet');
INSERT INTO `site_lang` VALUES ('156', '6', 'You dont have any fans yet');
INSERT INTO `site_lang` VALUES ('155', '6', 'No popular users near you');
INSERT INTO `site_lang` VALUES ('154', '6', 'people found');
INSERT INTO `site_lang` VALUES ('153', '6', 'Nothing found');
INSERT INTO `site_lang` VALUES ('152', '6', 'Verified');
INSERT INTO `site_lang` VALUES ('151', '6', 'Online now');
INSERT INTO `site_lang` VALUES ('150', '6', 'Delete profile');
INSERT INTO `site_lang` VALUES ('149', '6', 'After delete your profile, some of your data will be lost without recovery.');
INSERT INTO `site_lang` VALUES ('148', '6', 'Profile desactivation');
INSERT INTO `site_lang` VALUES ('147', '6', 'New password');
INSERT INTO `site_lang` VALUES ('146', '6', 'You can change your current password bellow');
INSERT INTO `site_lang` VALUES ('145', '6', 'Change password');
INSERT INTO `site_lang` VALUES ('144', '6', 'Upgrade to premium account');
INSERT INTO `site_lang` VALUES ('143', '6', 'Add credits');
INSERT INTO `site_lang` VALUES ('142', '6', 'Current credits');
INSERT INTO `site_lang` VALUES ('141', '6', 'Account type');
INSERT INTO `site_lang` VALUES ('140', '6', 'Buy credits for send Gifs and Unblock private photos');
INSERT INTO `site_lang` VALUES ('139', '6', 'You are account is already verified');
INSERT INTO `site_lang` VALUES ('138', '6', 'Connect with Facebook');
INSERT INTO `site_lang` VALUES ('137', '6', 'For verify your account , connect with your facebook account');
INSERT INTO `site_lang` VALUES ('136', '6', 'Verify account');
INSERT INTO `site_lang` VALUES ('135', '6', 'Update profile');
INSERT INTO `site_lang` VALUES ('134', '6', 'Site language');
INSERT INTO `site_lang` VALUES ('133', '6', 'You can edit your profile information bellow');
INSERT INTO `site_lang` VALUES ('132', '6', 'Personal information');
INSERT INTO `site_lang` VALUES ('131', '6', 'Delete');
INSERT INTO `site_lang` VALUES ('130', '6', 'Change password');
INSERT INTO `site_lang` VALUES ('129', '6', 'Verify');
INSERT INTO `site_lang` VALUES ('128', '6', 'Credits');
INSERT INTO `site_lang` VALUES ('127', '6', 'Personal');
INSERT INTO `site_lang` VALUES ('126', '6', 'Unblock private photos');
INSERT INTO `site_lang` VALUES ('125', '6', 'Ask permission to');
INSERT INTO `site_lang` VALUES ('124', '6', 'Now you have');
INSERT INTO `site_lang` VALUES ('123', '6', 'Credits successfully added to your account');
INSERT INTO `site_lang` VALUES ('122', '6', 'boys and girls');
INSERT INTO `site_lang` VALUES ('121', '6', 'Only girls');
INSERT INTO `site_lang` VALUES ('117', '6', 'About ');
INSERT INTO `site_lang` VALUES ('118', '6', 'Personal info');
INSERT INTO `site_lang` VALUES ('119', '6', 'years old');
INSERT INTO `site_lang` VALUES ('120', '6', 'Only boys');
INSERT INTO `site_lang` VALUES ('116', '6', 'Most popular users');
INSERT INTO `site_lang` VALUES ('115', '6', 'World');
INSERT INTO `site_lang` VALUES ('114', '6', 'in a radius of');
INSERT INTO `site_lang` VALUES ('113', '6', 'who are between');
INSERT INTO `site_lang` VALUES ('112', '6', 'Both');
INSERT INTO `site_lang` VALUES ('111', '6', 'Boys');
INSERT INTO `site_lang` VALUES ('108', '6', 'Online now');
INSERT INTO `site_lang` VALUES ('109', '6', 'Show me');
INSERT INTO `site_lang` VALUES ('110', '6', 'Girls');
INSERT INTO `site_lang` VALUES ('107', '6', 'All users');
INSERT INTO `site_lang` VALUES ('103', '6', 'Terms of Use');
INSERT INTO `site_lang` VALUES ('104', '6', 'Please complete your profile before start in ');
INSERT INTO `site_lang` VALUES ('105', '6', 'Your matches');
INSERT INTO `site_lang` VALUES ('106', '6', 'Filter Search');
INSERT INTO `site_lang` VALUES ('100', '6', 'or wait until tomorrow for continue meeting people');
INSERT INTO `site_lang` VALUES ('101', '6', 'Your fans');
INSERT INTO `site_lang` VALUES ('102', '6', 'Privacy Policy');
INSERT INTO `site_lang` VALUES ('98', '6', 'and get up to');
INSERT INTO `site_lang` VALUES ('99', '6', 'daily conversations');
INSERT INTO `site_lang` VALUES ('96', '6', 'or');
INSERT INTO `site_lang` VALUES ('97', '6', 'Upgrade your account to Premium');
INSERT INTO `site_lang` VALUES ('94', '6', 'Buy');
INSERT INTO `site_lang` VALUES ('95', '6', 'more daily conversation');
INSERT INTO `site_lang` VALUES ('91', '6', 'Chat');
INSERT INTO `site_lang` VALUES ('92', '6', 'you have reached the limit of new daily conversations');
INSERT INTO `site_lang` VALUES ('93', '6', 'To continue chatting');
INSERT INTO `site_lang` VALUES ('89', '6', 'Write text here');
INSERT INTO `site_lang` VALUES ('90', '6', 'Send');
INSERT INTO `site_lang` VALUES ('88', '6', 'Premium user badge');
INSERT INTO `site_lang` VALUES ('87', '6', 'Unblock all private photos');
INSERT INTO `site_lang` VALUES ('86', '6', 'Unlimited videocalls');
INSERT INTO `site_lang` VALUES ('84', '6', 'Premium Account Features');
INSERT INTO `site_lang` VALUES ('85', '6', 'new chats per day');
INSERT INTO `site_lang` VALUES ('83', '6', 'Buy credits');
INSERT INTO `site_lang` VALUES ('81', '6', 'Pay with');
INSERT INTO `site_lang` VALUES ('82', '6', 'Pay with');
INSERT INTO `site_lang` VALUES ('80', '6', 'Select payment method');
INSERT INTO `site_lang` VALUES ('79', '6', 'Select credits package');
INSERT INTO `site_lang` VALUES ('78', '6', 'Buy credits / Upgrade account');
INSERT INTO `site_lang` VALUES ('77', '6', 'Send gift');
INSERT INTO `site_lang` VALUES ('75', '6', 'Send gift to ');
INSERT INTO `site_lang` VALUES ('76', '6', 'Pick the gift you want to send to ');
INSERT INTO `site_lang` VALUES ('74', '6', 'Add photo');
INSERT INTO `site_lang` VALUES ('73', '6', 'Credits');
INSERT INTO `site_lang` VALUES ('72', '6', 'Pick the photo you want to show in the Spotlight, cost ');
INSERT INTO `site_lang` VALUES ('71', '6', 'Add yourself to the Spotlight');
INSERT INTO `site_lang` VALUES ('70', '6', 'add photos');
INSERT INTO `site_lang` VALUES ('69', '6', 'Add your photos');
INSERT INTO `site_lang` VALUES ('68', '6', 'Private Photos');
INSERT INTO `site_lang` VALUES ('67', '6', 'Public Photos');
INSERT INTO `site_lang` VALUES ('66', '6', 'All Photos');
INSERT INTO `site_lang` VALUES ('65', '6', 'Manage your photos');
INSERT INTO `site_lang` VALUES ('64', '6', 'Contact');
INSERT INTO `site_lang` VALUES ('63', '6', 'Privacy');
INSERT INTO `site_lang` VALUES ('60', '6', 'New messages');
INSERT INTO `site_lang` VALUES ('61', '6', 'Who to like');
INSERT INTO `site_lang` VALUES ('62', '6', 'Terms');
INSERT INTO `site_lang` VALUES ('59', '6', 'Online now');
INSERT INTO `site_lang` VALUES ('57', '6', 'Fans');
INSERT INTO `site_lang` VALUES ('58', '6', 'Conversations');
INSERT INTO `site_lang` VALUES ('56', '6', 'All');
INSERT INTO `site_lang` VALUES ('55', '6', 'Settings');
INSERT INTO `site_lang` VALUES ('54', '6', 'Manage photos');
INSERT INTO `site_lang` VALUES ('53', '6', 'Fans');
INSERT INTO `site_lang` VALUES ('52', '6', 'Most populars');
INSERT INTO `site_lang` VALUES ('51', '6', 'Matches');
INSERT INTO `site_lang` VALUES ('50', '6', 'Discover');
INSERT INTO `site_lang` VALUES ('49', '6', 'Meet new people');
INSERT INTO `site_lang` VALUES ('48', '6', 'Logout');
INSERT INTO `site_lang` VALUES ('47', '6', 'Settings');
INSERT INTO `site_lang` VALUES ('46', '6', 'Profile');
INSERT INTO `site_lang` VALUES ('45', '6', 'Privacy Policy');
INSERT INTO `site_lang` VALUES ('44', '6', 'and');
INSERT INTO `site_lang` VALUES ('43', '6', 'Terms and Conditions');
INSERT INTO `site_lang` VALUES ('42', '6', 'By continuing, you are confirming that you have read and agree to our');
INSERT INTO `site_lang` VALUES ('41', '6', 'Sign up');
INSERT INTO `site_lang` VALUES ('40', '6', 'Meet boys and girls');
INSERT INTO `site_lang` VALUES ('39', '6', 'Meet boys');
INSERT INTO `site_lang` VALUES ('38', '6', 'Meet girls');
INSERT INTO `site_lang` VALUES ('37', '6', 'Im here to');
INSERT INTO `site_lang` VALUES ('36', '6', 'Female');
INSERT INTO `site_lang` VALUES ('32', '6', 'City');
INSERT INTO `site_lang` VALUES ('33', '6', 'Where do you live?');
INSERT INTO `site_lang` VALUES ('34', '6', 'Gender');
INSERT INTO `site_lang` VALUES ('35', '6', 'Male');
INSERT INTO `site_lang` VALUES ('31', '6', 'Please select');
INSERT INTO `site_lang` VALUES ('30', '6', 'Birthday');
INSERT INTO `site_lang` VALUES ('27', '6', 'Your name or nickname');
INSERT INTO `site_lang` VALUES ('28', '6', 'Email');
INSERT INTO `site_lang` VALUES ('29', '6', 'Password');
INSERT INTO `site_lang` VALUES ('26', '6', 'Name');
INSERT INTO `site_lang` VALUES ('25', '6', 'Join the worlds bestest community for meeting new people!.');
INSERT INTO `site_lang` VALUES ('24', '6', 'Become a member now');
INSERT INTO `site_lang` VALUES ('23', '6', 'Play our popular Discover game and get matched with other users. Its a great way to break the ice and chat to new people.');
INSERT INTO `site_lang` VALUES ('22', '6', 'Matches');
INSERT INTO `site_lang` VALUES ('21', '6', 'We wont show your exact location, but you will be able to find people nearby who like the same things you do.');
INSERT INTO `site_lang` VALUES ('20', '6', 'People nearby');
INSERT INTO `site_lang` VALUES ('19', '6', 'You can make quality videocalls for free to anyone, without limits of call duration, just enjoy seeing the person who is chatting with you');
INSERT INTO `site_lang` VALUES ('18', '6', 'Video Chat');
INSERT INTO `site_lang` VALUES ('17', '6', 'Powerfull private chat for meet new friends, you can send emoticons and private photos to anyone.');
INSERT INTO `site_lang` VALUES ('16', '6', 'Chat');
INSERT INTO `site_lang` VALUES ('15', '6', 'Recover password');
INSERT INTO `site_lang` VALUES ('14', '6', 'Password recover');
INSERT INTO `site_lang` VALUES ('13', '6', 'Login now');
INSERT INTO `site_lang` VALUES ('11', '6', 'Your password');
INSERT INTO `site_lang` VALUES ('12', '6', 'do you forget your password?');
INSERT INTO `site_lang` VALUES ('10', '6', 'Your email');
INSERT INTO `site_lang` VALUES ('9', '6', 'Welcome back');
INSERT INTO `site_lang` VALUES ('8', '6', 'Create your account');
INSERT INTO `site_lang` VALUES ('7', '6', 'Connect with ');
INSERT INTO `site_lang` VALUES ('6', '6', 'SOON AVAILABLE');
INSERT INTO `site_lang` VALUES ('5', '6', 'Soon we will have our phone apps online');
INSERT INTO `site_lang` VALUES ('4', '6', 'Please visit us from your laptop or PC');
INSERT INTO `site_lang` VALUES ('3', '6', 'For now our site works only for Desktop users');
INSERT INTO `site_lang` VALUES ('2', '6', 'Welcome to the fastest growing place to meet new people');
INSERT INTO `site_lang` VALUES ('1', '6', 'Login');
INSERT INTO `site_lang` VALUES ('0', '6', 'meet new people!');
INSERT INTO `site_lang` VALUES ('384', '5', 'Ok, i understand');
INSERT INTO `site_lang` VALUES ('383', '5', 'must like you for start a videocall');
INSERT INTO `site_lang` VALUES ('382', '5', 'dont like you');
INSERT INTO `site_lang` VALUES ('381', '5', 'calling...');
INSERT INTO `site_lang` VALUES ('380', '5', 'Welcome to');
INSERT INTO `site_lang` VALUES ('376', '5', 'E-mail');
INSERT INTO `site_lang` VALUES ('377', '5', 'Password');
INSERT INTO `site_lang` VALUES ('378', '5', 'Please save your connection information in a safe place');
INSERT INTO `site_lang` VALUES ('379', '5', 'Go to');
INSERT INTO `site_lang` VALUES ('375', '5', 'Here are your connection details');
INSERT INTO `site_lang` VALUES ('374', '5', 'Start meeting new people now');
INSERT INTO `site_lang` VALUES ('372', '5', 'Add photos and complete your profile');
INSERT INTO `site_lang` VALUES ('373', '5', 'More than 1 million people have joined $site_name You probably want to know some of them.');
INSERT INTO `site_lang` VALUES ('371', '5', 'Nobody is going to fall in love with a blank page. The more information you get, the more chances to find that special someone!');
INSERT INTO `site_lang` VALUES ('370', '5', 'Meet new people');
INSERT INTO `site_lang` VALUES ('368', '5', 'In');
INSERT INTO `site_lang` VALUES ('369', '5', 'you can meet people instantly');
INSERT INTO `site_lang` VALUES ('367', '5', 'people in your area wants to know you');
INSERT INTO `site_lang` VALUES ('366', '5', 'Newsflash');
INSERT INTO `site_lang` VALUES ('365', '5', 'Verify your account');
INSERT INTO `site_lang` VALUES ('364', '5', 'Now you are a new member of');
INSERT INTO `site_lang` VALUES ('363', '5', 'Here are a few tips');
INSERT INTO `site_lang` VALUES ('362', '5', 'Well done, now you are in');
INSERT INTO `site_lang` VALUES ('361', '5', 'Welcome');
INSERT INTO `site_lang` VALUES ('360', '5', 'Check out the profile');
INSERT INTO `site_lang` VALUES ('359', '5', 'and lives closer to you');
INSERT INTO `site_lang` VALUES ('358', '5', 'is new at');
INSERT INTO `site_lang` VALUES ('354', '5', 'you have a new message from');
INSERT INTO `site_lang` VALUES ('355', '5', 'Respond to');
INSERT INTO `site_lang` VALUES ('356', '5', 'Have fun!');
INSERT INTO `site_lang` VALUES ('357', '5', 'is new and lives closer to you');
INSERT INTO `site_lang` VALUES ('353', '5', 'New message from');
INSERT INTO `site_lang` VALUES ('352', '5', 'Go and say something to');
INSERT INTO `site_lang` VALUES ('351', '5', 'thinks the feeling is mutual');
INSERT INTO `site_lang` VALUES ('350', '5', 'Its a match!');
INSERT INTO `site_lang` VALUES ('349', '5', 'You have a match at');
INSERT INTO `site_lang` VALUES ('348', '5', 'if you forgot your password, click on the link below to get a new');
INSERT INTO `site_lang` VALUES ('347', '5', 'Choose a new password');
INSERT INTO `site_lang` VALUES ('346', '5', 'Unsubscribe');
INSERT INTO `site_lang` VALUES ('345', '5', 'You received this notice because you registered as');
INSERT INTO `site_lang` VALUES ('344', '5', 'Find out if you also like');
INSERT INTO `site_lang` VALUES ('343', '5', 'has seen you in discover and likes. The feeling is mutual?');
INSERT INTO `site_lang` VALUES ('342', '5', 'likes you and wants to chat in');
INSERT INTO `site_lang` VALUES ('341', '5', 'We sent you a email with your info, it may take up to 1 min to arrive');
INSERT INTO `site_lang` VALUES ('340', '5', 'Loading...');
INSERT INTO `site_lang` VALUES ('339', '5', 'of');
INSERT INTO `site_lang` VALUES ('338', '5', 'Photos of ');
INSERT INTO `site_lang` VALUES ('337', '5', 'is calling you..');
INSERT INTO `site_lang` VALUES ('336', '5', 'Password successfully changed');
INSERT INTO `site_lang` VALUES ('335', '5', 'Service cost');
INSERT INTO `site_lang` VALUES ('334', '5', 'Spotlight');
INSERT INTO `site_lang` VALUES ('333', '5', 'Wrong');
INSERT INTO `site_lang` VALUES ('332', '5', 'days of Premium');
INSERT INTO `site_lang` VALUES ('331', '5', 'username');
INSERT INTO `site_lang` VALUES ('330', '5', 'You need to write your username!');
INSERT INTO `site_lang` VALUES ('329', '5', 'Write your instagram username');
INSERT INTO `site_lang` VALUES ('328', '5', 'Press backspace key for smart return to the meeting section.');
INSERT INTO `site_lang` VALUES ('327', '5', 'Are you sure you want to report');
INSERT INTO `site_lang` VALUES ('326', '5', 'Report and block');
INSERT INTO `site_lang` VALUES ('325', '5', 'is blocking you or you blocked him, you cant chat with him sorry');
INSERT INTO `site_lang` VALUES ('324', '5', 'We sended you a email for verify your account');
INSERT INTO `site_lang` VALUES ('323', '5', 'years old and im from');
INSERT INTO `site_lang` VALUES ('322', '5', 'Hi, im');
INSERT INTO `site_lang` VALUES ('310', '5', 'hour');
INSERT INTO `site_lang` VALUES ('311', '5', 'minute');
INSERT INTO `site_lang` VALUES ('312', '5', 'second');
INSERT INTO `site_lang` VALUES ('313', '5', 'years');
INSERT INTO `site_lang` VALUES ('314', '5', 'months');
INSERT INTO `site_lang` VALUES ('315', '5', 'days');
INSERT INTO `site_lang` VALUES ('316', '5', 'hours');
INSERT INTO `site_lang` VALUES ('317', '5', 'minutes');
INSERT INTO `site_lang` VALUES ('318', '5', 'seconds');
INSERT INTO `site_lang` VALUES ('319', '5', 'ago');
INSERT INTO `site_lang` VALUES ('320', '5', 'Please verify your account, check your email');
INSERT INTO `site_lang` VALUES ('321', '5', 'Please add a profile photo');
INSERT INTO `site_lang` VALUES ('309', '5', 'day');
INSERT INTO `site_lang` VALUES ('308', '5', 'month');
INSERT INTO `site_lang` VALUES ('307', '5', 'year');
INSERT INTO `site_lang` VALUES ('306', '5', '0 seconds');
INSERT INTO `site_lang` VALUES ('303', '5', 'You do not like anyone');
INSERT INTO `site_lang` VALUES ('304', '5', 'Cost');
INSERT INTO `site_lang` VALUES ('305', '5', 'Credits for $');
INSERT INTO `site_lang` VALUES ('302', '5', 'visited');
INSERT INTO `site_lang` VALUES ('298', '5', 'Like');
INSERT INTO `site_lang` VALUES ('299', '5', 'Dislike');
INSERT INTO `site_lang` VALUES ('300', '5', 'AGE');
INSERT INTO `site_lang` VALUES ('301', '5', 'You dont have any visit yet');
INSERT INTO `site_lang` VALUES ('297', '5', 'Messages');
INSERT INTO `site_lang` VALUES ('295', '5', 'People i like');
INSERT INTO `site_lang` VALUES ('296', '5', 'people liked you, for see them');
INSERT INTO `site_lang` VALUES ('294', '5', 'Upgrade your account to premium');
INSERT INTO `site_lang` VALUES ('293', '5', 'people visited your profile for see them');
INSERT INTO `site_lang` VALUES ('292', '5', 'Delete');
INSERT INTO `site_lang` VALUES ('291', '5', 'Public photo');
INSERT INTO `site_lang` VALUES ('290', '5', 'Private photo');
INSERT INTO `site_lang` VALUES ('289', '5', 'Set as profile');
INSERT INTO `site_lang` VALUES ('288', '5', 'get seen by millions');
INSERT INTO `site_lang` VALUES ('274', '5', 'Year');
INSERT INTO `site_lang` VALUES ('275', '5', 'Please wait');
INSERT INTO `site_lang` VALUES ('276', '5', 'Interests');
INSERT INTO `site_lang` VALUES ('277', '5', 'Report');
INSERT INTO `site_lang` VALUES ('278', '5', 'Fans');
INSERT INTO `site_lang` VALUES ('279', '5', 'No data');
INSERT INTO `site_lang` VALUES ('280', '5', 'Public Photos');
INSERT INTO `site_lang` VALUES ('281', '5', 'Private photos');
INSERT INTO `site_lang` VALUES ('282', '5', 'Add from ');
INSERT INTO `site_lang` VALUES ('283', '5', 'Add');
INSERT INTO `site_lang` VALUES ('284', '5', 'Photos');
INSERT INTO `site_lang` VALUES ('285', '5', 'Credits');
INSERT INTO `site_lang` VALUES ('286', '5', 'Visits');
INSERT INTO `site_lang` VALUES ('287', '5', 'Add me here');
INSERT INTO `site_lang` VALUES ('272', '5', 'Day');
INSERT INTO `site_lang` VALUES ('273', '5', 'Month');
INSERT INTO `site_lang` VALUES ('267', '5', 'None');
INSERT INTO `site_lang` VALUES ('268', '5', 'When someone likes me');
INSERT INTO `site_lang` VALUES ('269', '5', 'When i get a match');
INSERT INTO `site_lang` VALUES ('270', '5', 'When new users near me join in');
INSERT INTO `site_lang` VALUES ('271', '5', 'When someone send me a message');
INSERT INTO `site_lang` VALUES ('265', '5', 'I own a car');
INSERT INTO `site_lang` VALUES ('266', '5', 'I own a motorbike');
INSERT INTO `site_lang` VALUES ('263', '5', 'Transport');
INSERT INTO `site_lang` VALUES ('264', '5', 'Parents car');
INSERT INTO `site_lang` VALUES ('262', '5', 'Drink');
INSERT INTO `site_lang` VALUES ('259', '5', 'Yes');
INSERT INTO `site_lang` VALUES ('260', '5', 'No');
INSERT INTO `site_lang` VALUES ('261', '5', 'Sometimes');
INSERT INTO `site_lang` VALUES ('257', '5', 'Alone');
INSERT INTO `site_lang` VALUES ('258', '5', 'Smoke');
INSERT INTO `site_lang` VALUES ('256', '5', 'With partner');
INSERT INTO `site_lang` VALUES ('255', '5', 'Student dormitory');
INSERT INTO `site_lang` VALUES ('254', '5', 'With housemate');
INSERT INTO `site_lang` VALUES ('253', '5', 'With parents');
INSERT INTO `site_lang` VALUES ('252', '5', 'Living');
INSERT INTO `site_lang` VALUES ('251', '5', 'Curvy');
INSERT INTO `site_lang` VALUES ('250', '5', 'Heavy set');
INSERT INTO `site_lang` VALUES ('249', '5', 'Athletic');
INSERT INTO `site_lang` VALUES ('248', '5', 'Average');
INSERT INTO `site_lang` VALUES ('247', '5', 'Slim');
INSERT INTO `site_lang` VALUES ('246', '5', 'Body type');
INSERT INTO `site_lang` VALUES ('245', '5', 'Other');
INSERT INTO `site_lang` VALUES ('244', '5', 'Indian');
INSERT INTO `site_lang` VALUES ('243', '5', 'Pacific Islander');
INSERT INTO `site_lang` VALUES ('242', '5', 'Hispanic/latin');
INSERT INTO `site_lang` VALUES ('241', '5', 'Native American');
INSERT INTO `site_lang` VALUES ('240', '5', 'White');
INSERT INTO `site_lang` VALUES ('238', '5', 'Middle Eastern');
INSERT INTO `site_lang` VALUES ('239', '5', 'Black');
INSERT INTO `site_lang` VALUES ('237', '5', 'Asian');
INSERT INTO `site_lang` VALUES ('236', '5', 'Ethnicity');
INSERT INTO `site_lang` VALUES ('235', '5', 'Weight');
INSERT INTO `site_lang` VALUES ('234', '5', 'more than');
INSERT INTO `site_lang` VALUES ('231', '5', 'Bisexual');
INSERT INTO `site_lang` VALUES ('232', '5', 'Height');
INSERT INTO `site_lang` VALUES ('233', '5', 'less than');
INSERT INTO `site_lang` VALUES ('230', '5', 'Straight');
INSERT INTO `site_lang` VALUES ('227', '5', 'Sexuality');
INSERT INTO `site_lang` VALUES ('228', '5', 'Gay');
INSERT INTO `site_lang` VALUES ('229', '5', 'Open-minded');
INSERT INTO `site_lang` VALUES ('226', '5', 'Open');
INSERT INTO `site_lang` VALUES ('225', '5', 'Taken');
INSERT INTO `site_lang` VALUES ('224', '5', 'Single');
INSERT INTO `site_lang` VALUES ('223', '5', 'Relationship');
INSERT INTO `site_lang` VALUES ('222', '5', 'Extended info (optional)');
INSERT INTO `site_lang` VALUES ('221', '5', 'Notifications');
INSERT INTO `site_lang` VALUES ('220', '5', 'UPGRADE');
INSERT INTO `site_lang` VALUES ('219', '5', 'Basic');
INSERT INTO `site_lang` VALUES ('218', '5', 'until');
INSERT INTO `site_lang` VALUES ('217', '5', 'Wait more');
INSERT INTO `site_lang` VALUES ('216', '5', 'End call');
INSERT INTO `site_lang` VALUES ('215', '5', 'Seems that your friend do not have webcam or he is not available');
INSERT INTO `site_lang` VALUES ('214', '5', 'Too long wait');
INSERT INTO `site_lang` VALUES ('213', '5', 'You cant make videocall because you dont have webcam');
INSERT INTO `site_lang` VALUES ('212', '5', 'Impossible to make a call!');
INSERT INTO `site_lang` VALUES ('211', '5', 'Only premium users can make videocalls');
INSERT INTO `site_lang` VALUES ('210', '5', 'You are already in a videocall, you have to end the other call before start another');
INSERT INTO `site_lang` VALUES ('209', '5', 'Please allow access to your Webcam.');
INSERT INTO `site_lang` VALUES ('208', '5', 'is offline, try again when your friend is online');
INSERT INTO `site_lang` VALUES ('207', '5', 'is in another videocall , you cant call now');
INSERT INTO `site_lang` VALUES ('206', '5', 'Yes, delete it!');
INSERT INTO `site_lang` VALUES ('205', '5', 'Your data will be lost without recovery, continue?');
INSERT INTO `site_lang` VALUES ('204', '5', 'Account termination');
INSERT INTO `site_lang` VALUES ('203', '5', 'Information updated successfully');
INSERT INTO `site_lang` VALUES ('202', '5', 'Yes, buy it!');
INSERT INTO `site_lang` VALUES ('201', '5', 'more daily conversation, cost ');
INSERT INTO `site_lang` VALUES ('200', '5', 'Expand daily limitation ');
INSERT INTO `site_lang` VALUES ('199', '5', 'You dont have enought credits for send the gift');
INSERT INTO `site_lang` VALUES ('198', '5', 'Please, select 1 gift');
INSERT INTO `site_lang` VALUES ('197', '5', 'Please, select 1 photo');
INSERT INTO `site_lang` VALUES ('196', '5', 'Please, select a payment method');
INSERT INTO `site_lang` VALUES ('195', '5', 'No thanks');
INSERT INTO `site_lang` VALUES ('194', '5', 'Get access');
INSERT INTO `site_lang` VALUES ('193', '5', 'private photos for ');
INSERT INTO `site_lang` VALUES ('192', '5', 'Get access to');
INSERT INTO `site_lang` VALUES ('191', '5', 'Buy private photos permission');
INSERT INTO `site_lang` VALUES ('190', '5', 'No, i cant show you my private photos');
INSERT INTO `site_lang` VALUES ('189', '5', 'Yes, you can see my private photos');
INSERT INTO `site_lang` VALUES ('188', '5', 'Email already exist, try another');
INSERT INTO `site_lang` VALUES ('187', '5', 'Password too short');
INSERT INTO `site_lang` VALUES ('186', '5', 'Choose city from the autocomplete');
INSERT INTO `site_lang` VALUES ('185', '5', 'Add a valid date');
INSERT INTO `site_lang` VALUES ('184', '5', 'Wrong password');
INSERT INTO `site_lang` VALUES ('183', '5', 'Email dont exist');
INSERT INTO `site_lang` VALUES ('182', '5', 'Please fill all the inputs');
INSERT INTO `site_lang` VALUES ('181', '5', 'Invalid email format');
INSERT INTO `site_lang` VALUES ('180', '5', 'Password recover');
INSERT INTO `site_lang` VALUES ('179', '5', 'Login to my account');
INSERT INTO `site_lang` VALUES ('178', '5', 'If you dont remember your password, click the link below to set a new one:');
INSERT INTO `site_lang` VALUES ('177', '5', 'Hi');
INSERT INTO `site_lang` VALUES ('176', '5', 'No');
INSERT INTO `site_lang` VALUES ('175', '5', 'Yes');
INSERT INTO `site_lang` VALUES ('174', '5', 'Hello, can i have access to your private photos ?');
INSERT INTO `site_lang` VALUES ('173', '5', 'like this');
INSERT INTO `site_lang` VALUES ('170', '5', 'Buy');
INSERT INTO `site_lang` VALUES ('171', '5', 'Days Premium');
INSERT INTO `site_lang` VALUES ('172', '5', 'persons more like this');
INSERT INTO `site_lang` VALUES ('169', '5', 'December');
INSERT INTO `site_lang` VALUES ('168', '5', 'November');
INSERT INTO `site_lang` VALUES ('166', '5', 'September');
INSERT INTO `site_lang` VALUES ('167', '5', 'October');
INSERT INTO `site_lang` VALUES ('165', '5', 'August');
INSERT INTO `site_lang` VALUES ('163', '5', 'June');
INSERT INTO `site_lang` VALUES ('164', '5', 'July');
INSERT INTO `site_lang` VALUES ('158', '5', 'January');
INSERT INTO `site_lang` VALUES ('159', '5', 'February');
INSERT INTO `site_lang` VALUES ('160', '5', 'March');
INSERT INTO `site_lang` VALUES ('161', '5', 'April');
INSERT INTO `site_lang` VALUES ('162', '5', 'May');
INSERT INTO `site_lang` VALUES ('155', '5', 'No popular users near you');
INSERT INTO `site_lang` VALUES ('157', '5', 'You dont have matches yet');
INSERT INTO `site_lang` VALUES ('156', '5', 'You dont have any fans yet');
INSERT INTO `site_lang` VALUES ('150', '5', 'Delete profile');
INSERT INTO `site_lang` VALUES ('151', '5', 'Online now');
INSERT INTO `site_lang` VALUES ('152', '5', 'Verified');
INSERT INTO `site_lang` VALUES ('153', '5', 'Nothing found');
INSERT INTO `site_lang` VALUES ('154', '5', 'people found');
INSERT INTO `site_lang` VALUES ('149', '5', 'After delete your profile, some of your data will be lost without recovery.');
INSERT INTO `site_lang` VALUES ('148', '5', 'Profile desactivation');
INSERT INTO `site_lang` VALUES ('147', '5', 'New password');
INSERT INTO `site_lang` VALUES ('146', '5', 'You can change your current password bellow');
INSERT INTO `site_lang` VALUES ('145', '5', 'Change password');
INSERT INTO `site_lang` VALUES ('144', '5', 'Upgrade to premium account');
INSERT INTO `site_lang` VALUES ('143', '5', 'Add credits');
INSERT INTO `site_lang` VALUES ('142', '5', 'Current credits');
INSERT INTO `site_lang` VALUES ('141', '5', 'Account type');
INSERT INTO `site_lang` VALUES ('139', '5', 'You are account is already verified');
INSERT INTO `site_lang` VALUES ('140', '5', 'Buy credits for send Gifs and Unblock private photos');
INSERT INTO `site_lang` VALUES ('138', '5', 'Connect with Facebook');
INSERT INTO `site_lang` VALUES ('137', '5', 'For verify your account , connect with your facebook account');
INSERT INTO `site_lang` VALUES ('136', '5', 'Verify account');
INSERT INTO `site_lang` VALUES ('135', '5', 'Update profile');
INSERT INTO `site_lang` VALUES ('134', '5', 'Site language');
INSERT INTO `site_lang` VALUES ('133', '5', 'You can edit your profile information bellow');
INSERT INTO `site_lang` VALUES ('132', '5', 'Personal information');
INSERT INTO `site_lang` VALUES ('127', '5', 'Personal');
INSERT INTO `site_lang` VALUES ('128', '5', 'Credits');
INSERT INTO `site_lang` VALUES ('129', '5', 'Verify');
INSERT INTO `site_lang` VALUES ('130', '5', 'Change password');
INSERT INTO `site_lang` VALUES ('131', '5', 'Delete');
INSERT INTO `site_lang` VALUES ('126', '5', 'Unblock private photos');
INSERT INTO `site_lang` VALUES ('124', '5', 'Now you have');
INSERT INTO `site_lang` VALUES ('125', '5', 'Ask permission to');
INSERT INTO `site_lang` VALUES ('123', '5', 'Credits successfully added to your account');
INSERT INTO `site_lang` VALUES ('122', '5', 'boys and girls');
INSERT INTO `site_lang` VALUES ('121', '5', 'Only girls');
INSERT INTO `site_lang` VALUES ('120', '5', 'Only boys');
INSERT INTO `site_lang` VALUES ('119', '5', 'years old');
INSERT INTO `site_lang` VALUES ('118', '5', 'Personal info');
INSERT INTO `site_lang` VALUES ('117', '5', 'About ');
INSERT INTO `site_lang` VALUES ('116', '5', 'Most popular users');
INSERT INTO `site_lang` VALUES ('115', '5', 'World');
INSERT INTO `site_lang` VALUES ('114', '5', 'in a radius of');
INSERT INTO `site_lang` VALUES ('113', '5', 'who are between');
INSERT INTO `site_lang` VALUES ('112', '5', 'Both');
INSERT INTO `site_lang` VALUES ('111', '5', 'Boys');
INSERT INTO `site_lang` VALUES ('110', '5', 'Girls');
INSERT INTO `site_lang` VALUES ('109', '5', 'Show me');
INSERT INTO `site_lang` VALUES ('108', '5', 'Online now');
INSERT INTO `site_lang` VALUES ('107', '5', 'All users');
INSERT INTO `site_lang` VALUES ('106', '5', 'Filter Search');
INSERT INTO `site_lang` VALUES ('105', '5', 'Your matches');
INSERT INTO `site_lang` VALUES ('104', '5', 'Please complete your profile before start in ');
INSERT INTO `site_lang` VALUES ('102', '5', 'Privacy Policy');
INSERT INTO `site_lang` VALUES ('103', '5', 'Terms of Use');
INSERT INTO `site_lang` VALUES ('101', '5', 'Your fans');
INSERT INTO `site_lang` VALUES ('100', '5', 'or wait until tomorrow for continue meeting people');
INSERT INTO `site_lang` VALUES ('98', '5', 'and get up to');
INSERT INTO `site_lang` VALUES ('99', '5', 'daily conversations');
INSERT INTO `site_lang` VALUES ('97', '5', 'Upgrade your account to Premium');
INSERT INTO `site_lang` VALUES ('96', '5', 'or');
INSERT INTO `site_lang` VALUES ('94', '5', 'Buy');
INSERT INTO `site_lang` VALUES ('95', '5', 'more daily conversation');
INSERT INTO `site_lang` VALUES ('93', '5', 'To continue chatting');
INSERT INTO `site_lang` VALUES ('90', '5', 'Send');
INSERT INTO `site_lang` VALUES ('91', '5', 'Chat');
INSERT INTO `site_lang` VALUES ('92', '5', 'you have reached the limit of new daily conversations');
INSERT INTO `site_lang` VALUES ('89', '5', 'Write text here');
INSERT INTO `site_lang` VALUES ('88', '5', 'Premium user badge');
INSERT INTO `site_lang` VALUES ('80', '5', 'Select payment method');
INSERT INTO `site_lang` VALUES ('81', '5', 'Pay with');
INSERT INTO `site_lang` VALUES ('82', '5', 'Pay with');
INSERT INTO `site_lang` VALUES ('83', '5', 'Buy credits');
INSERT INTO `site_lang` VALUES ('84', '5', 'Premium Account Features');
INSERT INTO `site_lang` VALUES ('85', '5', 'new chats per day');
INSERT INTO `site_lang` VALUES ('86', '5', 'Unlimited videocalls');
INSERT INTO `site_lang` VALUES ('87', '5', 'Unblock all private photos');
INSERT INTO `site_lang` VALUES ('79', '5', 'Select credits package');
INSERT INTO `site_lang` VALUES ('78', '5', 'Buy credits / Upgrade account');
INSERT INTO `site_lang` VALUES ('77', '5', 'Send gift');
INSERT INTO `site_lang` VALUES ('76', '5', 'Pick the gift you want to send to ');
INSERT INTO `site_lang` VALUES ('75', '5', 'Send gift to ');
INSERT INTO `site_lang` VALUES ('73', '5', 'Credits');
INSERT INTO `site_lang` VALUES ('74', '5', 'Add photo');
INSERT INTO `site_lang` VALUES ('72', '5', 'Pick the photo you want to show in the Spotlight, cost ');
INSERT INTO `site_lang` VALUES ('71', '5', 'Add yourself to the Spotlight');
INSERT INTO `site_lang` VALUES ('70', '5', 'add photos');
INSERT INTO `site_lang` VALUES ('69', '5', 'Add your photos');
INSERT INTO `site_lang` VALUES ('68', '5', 'Private Photos');
INSERT INTO `site_lang` VALUES ('67', '5', 'Public Photos');
INSERT INTO `site_lang` VALUES ('66', '5', 'All Photos');
INSERT INTO `site_lang` VALUES ('65', '5', 'Manage your photos');
INSERT INTO `site_lang` VALUES ('64', '5', 'Contact');
INSERT INTO `site_lang` VALUES ('63', '5', 'Privacy');
INSERT INTO `site_lang` VALUES ('62', '5', 'Terms');
INSERT INTO `site_lang` VALUES ('61', '5', 'Who to like');
INSERT INTO `site_lang` VALUES ('60', '5', 'New messages');
INSERT INTO `site_lang` VALUES ('59', '5', 'Online now');
INSERT INTO `site_lang` VALUES ('57', '5', 'Fans');
INSERT INTO `site_lang` VALUES ('58', '5', 'Conversations');
INSERT INTO `site_lang` VALUES ('56', '5', 'All');
INSERT INTO `site_lang` VALUES ('55', '5', 'Settings');
INSERT INTO `site_lang` VALUES ('48', '5', 'Logout');
INSERT INTO `site_lang` VALUES ('49', '5', 'Meet new people');
INSERT INTO `site_lang` VALUES ('50', '5', 'Discover');
INSERT INTO `site_lang` VALUES ('51', '5', 'Matches');
INSERT INTO `site_lang` VALUES ('52', '5', 'Most populars');
INSERT INTO `site_lang` VALUES ('53', '5', 'Fans');
INSERT INTO `site_lang` VALUES ('54', '5', 'Manage photos');
INSERT INTO `site_lang` VALUES ('47', '5', 'Settings');
INSERT INTO `site_lang` VALUES ('46', '5', 'Profile');
INSERT INTO `site_lang` VALUES ('45', '5', 'Privacy Policy');
INSERT INTO `site_lang` VALUES ('44', '5', 'and');
INSERT INTO `site_lang` VALUES ('43', '5', 'Terms and Conditions');
INSERT INTO `site_lang` VALUES ('42', '5', 'By continuing, you are confirming that you have read and agree to our');
INSERT INTO `site_lang` VALUES ('41', '5', 'Sign up');
INSERT INTO `site_lang` VALUES ('40', '5', 'Meet boys and girls');
INSERT INTO `site_lang` VALUES ('39', '5', 'Meet boys');
INSERT INTO `site_lang` VALUES ('38', '5', 'Meet girls');
INSERT INTO `site_lang` VALUES ('32', '5', 'City');
INSERT INTO `site_lang` VALUES ('33', '5', 'Where do you live?');
INSERT INTO `site_lang` VALUES ('34', '5', 'Gender');
INSERT INTO `site_lang` VALUES ('35', '5', 'Male');
INSERT INTO `site_lang` VALUES ('36', '5', 'Female');
INSERT INTO `site_lang` VALUES ('37', '5', 'Im here to');
INSERT INTO `site_lang` VALUES ('31', '5', 'Please select');
INSERT INTO `site_lang` VALUES ('30', '5', 'Birthday');
INSERT INTO `site_lang` VALUES ('29', '5', 'Password');
INSERT INTO `site_lang` VALUES ('28', '5', 'Email');
INSERT INTO `site_lang` VALUES ('27', '5', 'Your name or nickname');
INSERT INTO `site_lang` VALUES ('26', '5', 'Name');
INSERT INTO `site_lang` VALUES ('25', '5', 'Join the worlds bestest community for meeting new people!.');
INSERT INTO `site_lang` VALUES ('24', '5', 'Become a member now');
INSERT INTO `site_lang` VALUES ('23', '5', 'Play our popular Discover game and get matched with other users. Its a great way to break the ice and chat to new people.');
INSERT INTO `site_lang` VALUES ('22', '5', 'Matches');
INSERT INTO `site_lang` VALUES ('21', '5', 'We wont show your exact location, but you will be able to find people nearby who like the same things you do.');
INSERT INTO `site_lang` VALUES ('20', '5', 'People nearby');
INSERT INTO `site_lang` VALUES ('19', '5', 'You can make quality videocalls for free to anyone, without limits of call duration, just enjoy seeing the person who is chatting with you');
INSERT INTO `site_lang` VALUES ('18', '5', 'Video Chat');
INSERT INTO `site_lang` VALUES ('16', '5', 'Chat');
INSERT INTO `site_lang` VALUES ('17', '5', 'Powerfull private chat for meet new friends, you can send emoticons and private photos to anyone.');
INSERT INTO `site_lang` VALUES ('15', '5', 'Recover password');
INSERT INTO `site_lang` VALUES ('14', '5', 'Password recover');
INSERT INTO `site_lang` VALUES ('13', '5', 'Login now');
INSERT INTO `site_lang` VALUES ('12', '5', 'do you forget your password?');
INSERT INTO `site_lang` VALUES ('11', '5', 'Your password');
INSERT INTO `site_lang` VALUES ('10', '5', 'Your email');
INSERT INTO `site_lang` VALUES ('9', '5', 'Welcome back');
INSERT INTO `site_lang` VALUES ('8', '5', 'Create your account');
INSERT INTO `site_lang` VALUES ('7', '5', 'Connect with ');
INSERT INTO `site_lang` VALUES ('6', '5', 'SOON AVAILABLE');
INSERT INTO `site_lang` VALUES ('5', '5', 'Soon we will have our phone apps online');
INSERT INTO `site_lang` VALUES ('4', '5', 'Please visit us from your laptop or PC');
INSERT INTO `site_lang` VALUES ('3', '5', 'For now our site works only for Desktop users');
INSERT INTO `site_lang` VALUES ('2', '5', 'Welcome to the fastest growing place to meet new people');
INSERT INTO `site_lang` VALUES ('1', '5', 'Login');
INSERT INTO `site_lang` VALUES ('0', '5', 'meet new people!');
INSERT INTO `site_lang` VALUES ('384', '4', 'Ok, i understand');
INSERT INTO `site_lang` VALUES ('383', '4', 'must like you for start a videocall');
INSERT INTO `site_lang` VALUES ('382', '4', 'dont like you');
INSERT INTO `site_lang` VALUES ('381', '4', 'calling...');
INSERT INTO `site_lang` VALUES ('380', '4', 'Welcome to');
INSERT INTO `site_lang` VALUES ('379', '4', 'Go to');
INSERT INTO `site_lang` VALUES ('378', '4', 'Please save your connection information in a safe place');
INSERT INTO `site_lang` VALUES ('377', '4', 'Password');
INSERT INTO `site_lang` VALUES ('376', '4', 'E-mail');
INSERT INTO `site_lang` VALUES ('375', '4', 'Here are your connection details');
INSERT INTO `site_lang` VALUES ('372', '4', 'Add photos and complete your profile');
INSERT INTO `site_lang` VALUES ('373', '4', 'More than 1 million people have joined $site_name You probably want to know some of them.');
INSERT INTO `site_lang` VALUES ('374', '4', 'Start meeting new people now');
INSERT INTO `site_lang` VALUES ('363', '4', 'Here are a few tips');
INSERT INTO `site_lang` VALUES ('364', '4', 'Now you are a new member of');
INSERT INTO `site_lang` VALUES ('365', '4', 'Verify your account');
INSERT INTO `site_lang` VALUES ('366', '4', 'Newsflash');
INSERT INTO `site_lang` VALUES ('367', '4', 'people in your area wants to know you');
INSERT INTO `site_lang` VALUES ('368', '4', 'In');
INSERT INTO `site_lang` VALUES ('369', '4', 'you can meet people instantly');
INSERT INTO `site_lang` VALUES ('370', '4', 'Meet new people');
INSERT INTO `site_lang` VALUES ('371', '4', 'Nobody is going to fall in love with a blank page. The more information you get, the more chances to find that special someone!');
INSERT INTO `site_lang` VALUES ('362', '4', 'Well done, now you are in');
INSERT INTO `site_lang` VALUES ('361', '4', 'Welcome');
INSERT INTO `site_lang` VALUES ('360', '4', 'Check out the profile');
INSERT INTO `site_lang` VALUES ('359', '4', 'and lives closer to you');
INSERT INTO `site_lang` VALUES ('358', '4', 'is new at');
INSERT INTO `site_lang` VALUES ('357', '4', 'is new and lives closer to you');
INSERT INTO `site_lang` VALUES ('356', '4', 'Have fun!');
INSERT INTO `site_lang` VALUES ('355', '4', 'Respond to');
INSERT INTO `site_lang` VALUES ('354', '4', 'you have a new message from');
INSERT INTO `site_lang` VALUES ('353', '4', 'New message from');
INSERT INTO `site_lang` VALUES ('352', '4', 'Go and say something to');
INSERT INTO `site_lang` VALUES ('351', '4', 'thinks the feeling is mutual');
INSERT INTO `site_lang` VALUES ('349', '4', 'You have a match at');
INSERT INTO `site_lang` VALUES ('350', '4', 'Its a match!');
INSERT INTO `site_lang` VALUES ('348', '4', 'if you forgot your password, click on the link below to get a new');
INSERT INTO `site_lang` VALUES ('347', '4', 'Choose a new password');
INSERT INTO `site_lang` VALUES ('346', '4', 'Unsubscribe');
INSERT INTO `site_lang` VALUES ('345', '4', 'You received this notice because you registered as');
INSERT INTO `site_lang` VALUES ('344', '4', 'Find out if you also like');
INSERT INTO `site_lang` VALUES ('343', '4', 'has seen you in discover and likes. The feeling is mutual?');
INSERT INTO `site_lang` VALUES ('342', '4', 'likes you and wants to chat in');
INSERT INTO `site_lang` VALUES ('341', '4', 'We sent you a email with your info, it may take up to 1 min to arrive');
INSERT INTO `site_lang` VALUES ('339', '4', 'of');
INSERT INTO `site_lang` VALUES ('340', '4', 'Loading...');
INSERT INTO `site_lang` VALUES ('337', '4', 'is calling you..');
INSERT INTO `site_lang` VALUES ('338', '4', 'Photos of ');
INSERT INTO `site_lang` VALUES ('336', '4', 'Password successfully changed');
INSERT INTO `site_lang` VALUES ('335', '4', 'Service cost');
INSERT INTO `site_lang` VALUES ('331', '4', 'username');
INSERT INTO `site_lang` VALUES ('332', '4', 'days of Premium');
INSERT INTO `site_lang` VALUES ('333', '4', 'Wrong');
INSERT INTO `site_lang` VALUES ('334', '4', 'Spotlight');
INSERT INTO `site_lang` VALUES ('328', '4', 'Press backspace key for smart return to the meeting section.');
INSERT INTO `site_lang` VALUES ('330', '4', 'You need to write your username!');
INSERT INTO `site_lang` VALUES ('329', '4', 'Write your instagram username');
INSERT INTO `site_lang` VALUES ('327', '4', 'Are you sure you want to report');
INSERT INTO `site_lang` VALUES ('326', '4', 'Report and block');
INSERT INTO `site_lang` VALUES ('325', '4', 'is blocking you or you blocked him, you cant chat with him sorry');
INSERT INTO `site_lang` VALUES ('324', '4', 'We sended you a email for verify your account');
INSERT INTO `site_lang` VALUES ('323', '4', 'years old and im from');
INSERT INTO `site_lang` VALUES ('322', '4', 'Hi, im');
INSERT INTO `site_lang` VALUES ('321', '4', 'Please add a profile photo');
INSERT INTO `site_lang` VALUES ('319', '4', 'ago');
INSERT INTO `site_lang` VALUES ('320', '4', 'Please verify your account, check your email');
INSERT INTO `site_lang` VALUES ('318', '4', 'seconds');
INSERT INTO `site_lang` VALUES ('317', '4', 'minutes');
INSERT INTO `site_lang` VALUES ('316', '4', 'hours');
INSERT INTO `site_lang` VALUES ('314', '4', 'months');
INSERT INTO `site_lang` VALUES ('315', '4', 'days');
INSERT INTO `site_lang` VALUES ('313', '4', 'years');
INSERT INTO `site_lang` VALUES ('312', '4', 'second');
INSERT INTO `site_lang` VALUES ('311', '4', 'minute');
INSERT INTO `site_lang` VALUES ('310', '4', 'hour');
INSERT INTO `site_lang` VALUES ('309', '4', 'day');
INSERT INTO `site_lang` VALUES ('305', '4', 'Credits for $');
INSERT INTO `site_lang` VALUES ('306', '4', '0 seconds');
INSERT INTO `site_lang` VALUES ('307', '4', 'year');
INSERT INTO `site_lang` VALUES ('308', '4', 'month');
INSERT INTO `site_lang` VALUES ('304', '4', 'Cost');
INSERT INTO `site_lang` VALUES ('303', '4', 'You do not like anyone');
INSERT INTO `site_lang` VALUES ('302', '4', 'visited');
INSERT INTO `site_lang` VALUES ('301', '4', 'You dont have any visit yet');
INSERT INTO `site_lang` VALUES ('300', '4', 'AGE');
INSERT INTO `site_lang` VALUES ('298', '4', 'Like');
INSERT INTO `site_lang` VALUES ('299', '4', 'Dislike');
INSERT INTO `site_lang` VALUES ('297', '4', 'Messages');
INSERT INTO `site_lang` VALUES ('296', '4', 'people liked you, for see them');
INSERT INTO `site_lang` VALUES ('295', '4', 'People i like');
INSERT INTO `site_lang` VALUES ('294', '4', 'Upgrade your account to premium');
INSERT INTO `site_lang` VALUES ('293', '4', 'people visited your profile for see them');
INSERT INTO `site_lang` VALUES ('292', '4', 'Delete');
INSERT INTO `site_lang` VALUES ('291', '4', 'Public photo');
INSERT INTO `site_lang` VALUES ('290', '4', 'Private photo');
INSERT INTO `site_lang` VALUES ('289', '4', 'Set as profile');
INSERT INTO `site_lang` VALUES ('288', '4', 'get seen by millions');
INSERT INTO `site_lang` VALUES ('287', '4', 'Add me here');
INSERT INTO `site_lang` VALUES ('286', '4', 'Visits');
INSERT INTO `site_lang` VALUES ('283', '4', 'Add');
INSERT INTO `site_lang` VALUES ('284', '4', 'Photos');
INSERT INTO `site_lang` VALUES ('285', '4', 'Credits');
INSERT INTO `site_lang` VALUES ('282', '4', 'Add from ');
INSERT INTO `site_lang` VALUES ('281', '4', 'Private photos');
INSERT INTO `site_lang` VALUES ('280', '4', 'Public Photos');
INSERT INTO `site_lang` VALUES ('279', '4', 'No data');
INSERT INTO `site_lang` VALUES ('278', '4', 'Fans');
INSERT INTO `site_lang` VALUES ('277', '4', 'Report');
INSERT INTO `site_lang` VALUES ('276', '4', 'Interests');
INSERT INTO `site_lang` VALUES ('275', '4', 'Please wait');
INSERT INTO `site_lang` VALUES ('274', '4', 'Year');
INSERT INTO `site_lang` VALUES ('273', '4', 'Month');
INSERT INTO `site_lang` VALUES ('272', '4', 'Day');
INSERT INTO `site_lang` VALUES ('271', '4', 'When someone send me a message');
INSERT INTO `site_lang` VALUES ('270', '4', 'When new users near me join in');
INSERT INTO `site_lang` VALUES ('269', '4', 'When i get a match');
INSERT INTO `site_lang` VALUES ('268', '4', 'When someone likes me');
INSERT INTO `site_lang` VALUES ('267', '4', 'None');
INSERT INTO `site_lang` VALUES ('266', '4', 'I own a motorbike');
INSERT INTO `site_lang` VALUES ('265', '4', 'I own a car');
INSERT INTO `site_lang` VALUES ('264', '4', 'Parents car');
INSERT INTO `site_lang` VALUES ('263', '4', 'Transport');
INSERT INTO `site_lang` VALUES ('262', '4', 'Drink');
INSERT INTO `site_lang` VALUES ('261', '4', 'Sometimes');
INSERT INTO `site_lang` VALUES ('260', '4', 'No');
INSERT INTO `site_lang` VALUES ('259', '4', 'Yes');
INSERT INTO `site_lang` VALUES ('258', '4', 'Smoke');
INSERT INTO `site_lang` VALUES ('257', '4', 'Alone');
INSERT INTO `site_lang` VALUES ('256', '4', 'With partner');
INSERT INTO `site_lang` VALUES ('255', '4', 'Student dormitory');
INSERT INTO `site_lang` VALUES ('254', '4', 'With housemate');
INSERT INTO `site_lang` VALUES ('253', '4', 'With parents');
INSERT INTO `site_lang` VALUES ('252', '4', 'Living');
INSERT INTO `site_lang` VALUES ('251', '4', 'Curvy');
INSERT INTO `site_lang` VALUES ('250', '4', 'Heavy set');
INSERT INTO `site_lang` VALUES ('249', '4', 'Athletic');
INSERT INTO `site_lang` VALUES ('248', '4', 'Average');
INSERT INTO `site_lang` VALUES ('247', '4', 'Slim');
INSERT INTO `site_lang` VALUES ('246', '4', 'Body type');
INSERT INTO `site_lang` VALUES ('245', '4', 'Other');
INSERT INTO `site_lang` VALUES ('244', '4', 'Indian');
INSERT INTO `site_lang` VALUES ('242', '4', 'Hispanic/latin');
INSERT INTO `site_lang` VALUES ('243', '4', 'Pacific Islander');
INSERT INTO `site_lang` VALUES ('241', '4', 'Native American');
INSERT INTO `site_lang` VALUES ('240', '4', 'White');
INSERT INTO `site_lang` VALUES ('239', '4', 'Black');
INSERT INTO `site_lang` VALUES ('238', '4', 'Middle Eastern');
INSERT INTO `site_lang` VALUES ('237', '4', 'Asian');
INSERT INTO `site_lang` VALUES ('236', '4', 'Ethnicity');
INSERT INTO `site_lang` VALUES ('235', '4', 'Weight');
INSERT INTO `site_lang` VALUES ('234', '4', 'more than');
INSERT INTO `site_lang` VALUES ('232', '4', 'Height');
INSERT INTO `site_lang` VALUES ('233', '4', 'less than');
INSERT INTO `site_lang` VALUES ('231', '4', 'Bisexual');
INSERT INTO `site_lang` VALUES ('230', '4', 'Straight');
INSERT INTO `site_lang` VALUES ('229', '4', 'Open-minded');
INSERT INTO `site_lang` VALUES ('228', '4', 'Gay');
INSERT INTO `site_lang` VALUES ('227', '4', 'Sexuality');
INSERT INTO `site_lang` VALUES ('225', '4', 'Taken');
INSERT INTO `site_lang` VALUES ('226', '4', 'Open');
INSERT INTO `site_lang` VALUES ('224', '4', 'Single');
INSERT INTO `site_lang` VALUES ('221', '4', 'Notifications');
INSERT INTO `site_lang` VALUES ('222', '4', 'Extended info (optional)');
INSERT INTO `site_lang` VALUES ('223', '4', 'Relationship');
INSERT INTO `site_lang` VALUES ('219', '4', 'Basic');
INSERT INTO `site_lang` VALUES ('220', '4', 'UPGRADE');
INSERT INTO `site_lang` VALUES ('216', '4', 'End call');
INSERT INTO `site_lang` VALUES ('217', '4', 'Wait more');
INSERT INTO `site_lang` VALUES ('218', '4', 'until');
INSERT INTO `site_lang` VALUES ('214', '4', 'Too long wait');
INSERT INTO `site_lang` VALUES ('215', '4', 'Seems that your friend do not have webcam or he is not available');
INSERT INTO `site_lang` VALUES ('213', '4', 'You cant make videocall because you dont have webcam');
INSERT INTO `site_lang` VALUES ('212', '4', 'Impossible to make a call!');
INSERT INTO `site_lang` VALUES ('211', '4', 'Only premium users can make videocalls');
INSERT INTO `site_lang` VALUES ('210', '4', 'You are already in a videocall, you have to end the other call before start another');
INSERT INTO `site_lang` VALUES ('209', '4', 'Please allow access to your Webcam.');
INSERT INTO `site_lang` VALUES ('208', '4', 'is offline, try again when your friend is online');
INSERT INTO `site_lang` VALUES ('206', '4', 'Yes, delete it!');
INSERT INTO `site_lang` VALUES ('207', '4', 'is in another videocall , you cant call now');
INSERT INTO `site_lang` VALUES ('205', '4', 'Your data will be lost without recovery, continue?');
INSERT INTO `site_lang` VALUES ('204', '4', 'Account termination');
INSERT INTO `site_lang` VALUES ('203', '4', 'Information updated successfully');
INSERT INTO `site_lang` VALUES ('202', '4', 'Yes, buy it!');
INSERT INTO `site_lang` VALUES ('201', '4', 'more daily conversation, cost ');
INSERT INTO `site_lang` VALUES ('200', '4', 'Expand daily limitation ');
INSERT INTO `site_lang` VALUES ('197', '4', 'Please, select 1 photo');
INSERT INTO `site_lang` VALUES ('198', '4', 'Please, select 1 gift');
INSERT INTO `site_lang` VALUES ('199', '4', 'You dont have enought credits for send the gift');
INSERT INTO `site_lang` VALUES ('195', '4', 'No thanks');
INSERT INTO `site_lang` VALUES ('196', '4', 'Please, select a payment method');
INSERT INTO `site_lang` VALUES ('194', '4', 'Get access');
INSERT INTO `site_lang` VALUES ('193', '4', 'private photos for ');
INSERT INTO `site_lang` VALUES ('192', '4', 'Get access to');
INSERT INTO `site_lang` VALUES ('191', '4', 'Buy private photos permission');
INSERT INTO `site_lang` VALUES ('190', '4', 'No, i cant show you my private photos');
INSERT INTO `site_lang` VALUES ('189', '4', 'Yes, you can see my private photos');
INSERT INTO `site_lang` VALUES ('188', '4', 'Email already exist, try another');
INSERT INTO `site_lang` VALUES ('187', '4', 'Password too short');
INSERT INTO `site_lang` VALUES ('186', '4', 'Choose city from the autocomplete');
INSERT INTO `site_lang` VALUES ('183', '4', 'Email dont exist');
INSERT INTO `site_lang` VALUES ('184', '4', 'Wrong password');
INSERT INTO `site_lang` VALUES ('185', '4', 'Add a valid date');
INSERT INTO `site_lang` VALUES ('182', '4', 'Please fill all the inputs');
INSERT INTO `site_lang` VALUES ('181', '4', 'Invalid email format');
INSERT INTO `site_lang` VALUES ('180', '4', 'Password recover');
INSERT INTO `site_lang` VALUES ('179', '4', 'Login to my account');
INSERT INTO `site_lang` VALUES ('178', '4', 'If you dont remember your password, click the link below to set a new one:');
INSERT INTO `site_lang` VALUES ('177', '4', 'Hi');
INSERT INTO `site_lang` VALUES ('176', '4', 'No');
INSERT INTO `site_lang` VALUES ('175', '4', 'Yes');
INSERT INTO `site_lang` VALUES ('174', '4', 'Hello, can i have access to your private photos ?');
INSERT INTO `site_lang` VALUES ('173', '4', 'like this');
INSERT INTO `site_lang` VALUES ('172', '4', 'persons more like this');
INSERT INTO `site_lang` VALUES ('171', '4', 'Days Premium');
INSERT INTO `site_lang` VALUES ('170', '4', 'Buy');
INSERT INTO `site_lang` VALUES ('169', '4', 'December');
INSERT INTO `site_lang` VALUES ('167', '4', 'October');
INSERT INTO `site_lang` VALUES ('168', '4', 'November');
INSERT INTO `site_lang` VALUES ('166', '4', 'September');
INSERT INTO `site_lang` VALUES ('165', '4', 'August');
INSERT INTO `site_lang` VALUES ('163', '4', 'June');
INSERT INTO `site_lang` VALUES ('164', '4', 'July');
INSERT INTO `site_lang` VALUES ('161', '4', 'April');
INSERT INTO `site_lang` VALUES ('162', '4', 'May');
INSERT INTO `site_lang` VALUES ('160', '4', 'March');
INSERT INTO `site_lang` VALUES ('159', '4', 'February');
INSERT INTO `site_lang` VALUES ('158', '4', 'January');
INSERT INTO `site_lang` VALUES ('157', '4', 'You dont have matches yet');
INSERT INTO `site_lang` VALUES ('155', '4', 'No popular users near you');
INSERT INTO `site_lang` VALUES ('156', '4', 'You dont have any fans yet');
INSERT INTO `site_lang` VALUES ('154', '4', 'people found');
INSERT INTO `site_lang` VALUES ('151', '4', 'Online now');
INSERT INTO `site_lang` VALUES ('152', '4', 'Verified');
INSERT INTO `site_lang` VALUES ('153', '4', 'Nothing found');
INSERT INTO `site_lang` VALUES ('150', '4', 'Delete profile');
INSERT INTO `site_lang` VALUES ('149', '4', 'After delete your profile, some of your data will be lost without recovery.');
INSERT INTO `site_lang` VALUES ('147', '4', 'New password');
INSERT INTO `site_lang` VALUES ('148', '4', 'Profile desactivation');
INSERT INTO `site_lang` VALUES ('146', '4', 'You can change your current password bellow');
INSERT INTO `site_lang` VALUES ('145', '4', 'Change password');
INSERT INTO `site_lang` VALUES ('143', '4', 'Add credits');
INSERT INTO `site_lang` VALUES ('144', '4', 'Upgrade to premium account');
INSERT INTO `site_lang` VALUES ('142', '4', 'Current credits');
INSERT INTO `site_lang` VALUES ('141', '4', 'Account type');
INSERT INTO `site_lang` VALUES ('138', '4', 'Connect with Facebook');
INSERT INTO `site_lang` VALUES ('139', '4', 'You are account is already verified');
INSERT INTO `site_lang` VALUES ('140', '4', 'Buy credits for send Gifs and Unblock private photos');
INSERT INTO `site_lang` VALUES ('137', '4', 'For verify your account , connect with your facebook account');
INSERT INTO `site_lang` VALUES ('136', '4', 'Verify account');
INSERT INTO `site_lang` VALUES ('135', '4', 'Update profile');
INSERT INTO `site_lang` VALUES ('132', '4', 'Personal information');
INSERT INTO `site_lang` VALUES ('133', '4', 'You can edit your profile information bellow');
INSERT INTO `site_lang` VALUES ('134', '4', 'Site language');
INSERT INTO `site_lang` VALUES ('131', '4', 'Delete');
INSERT INTO `site_lang` VALUES ('130', '4', 'Change password');
INSERT INTO `site_lang` VALUES ('128', '4', 'Credits');
INSERT INTO `site_lang` VALUES ('129', '4', 'Verify');
INSERT INTO `site_lang` VALUES ('127', '4', 'Personal');
INSERT INTO `site_lang` VALUES ('126', '4', 'Unblock private photos');
INSERT INTO `site_lang` VALUES ('125', '4', 'Ask permission to');
INSERT INTO `site_lang` VALUES ('124', '4', 'Now you have');
INSERT INTO `site_lang` VALUES ('123', '4', 'Credits successfully added to your account');
INSERT INTO `site_lang` VALUES ('122', '4', 'boys and girls');
INSERT INTO `site_lang` VALUES ('121', '4', 'Only girls');
INSERT INTO `site_lang` VALUES ('120', '4', 'Only boys');
INSERT INTO `site_lang` VALUES ('119', '4', 'years old');
INSERT INTO `site_lang` VALUES ('118', '4', 'Personal info');
INSERT INTO `site_lang` VALUES ('117', '4', 'About ');
INSERT INTO `site_lang` VALUES ('116', '4', 'Most popular users');
INSERT INTO `site_lang` VALUES ('115', '4', 'World');
INSERT INTO `site_lang` VALUES ('112', '4', 'Both');
INSERT INTO `site_lang` VALUES ('113', '4', 'who are between');
INSERT INTO `site_lang` VALUES ('114', '4', 'in a radius of');
INSERT INTO `site_lang` VALUES ('111', '4', 'Boys');
INSERT INTO `site_lang` VALUES ('110', '4', 'Girls');
INSERT INTO `site_lang` VALUES ('109', '4', 'Show me');
INSERT INTO `site_lang` VALUES ('107', '4', 'All users');
INSERT INTO `site_lang` VALUES ('108', '4', 'Online now');
INSERT INTO `site_lang` VALUES ('105', '4', 'Your matches');
INSERT INTO `site_lang` VALUES ('106', '4', 'Filter Search');
INSERT INTO `site_lang` VALUES ('104', '4', 'Please complete your profile before start in ');
INSERT INTO `site_lang` VALUES ('103', '4', 'Terms of Use');
INSERT INTO `site_lang` VALUES ('102', '4', 'Privacy Policy');
INSERT INTO `site_lang` VALUES ('101', '4', 'Your fans');
INSERT INTO `site_lang` VALUES ('99', '4', 'daily conversations');
INSERT INTO `site_lang` VALUES ('100', '4', 'or wait until tomorrow for continue meeting people');
INSERT INTO `site_lang` VALUES ('98', '4', 'and get up to');
INSERT INTO `site_lang` VALUES ('96', '4', 'or');
INSERT INTO `site_lang` VALUES ('97', '4', 'Upgrade your account to Premium');
INSERT INTO `site_lang` VALUES ('94', '4', 'Buy');
INSERT INTO `site_lang` VALUES ('95', '4', 'more daily conversation');
INSERT INTO `site_lang` VALUES ('93', '4', 'To continue chatting');
INSERT INTO `site_lang` VALUES ('92', '4', 'you have reached the limit of new daily conversations');
INSERT INTO `site_lang` VALUES ('91', '4', 'Chat');
INSERT INTO `site_lang` VALUES ('90', '4', 'Send');
INSERT INTO `site_lang` VALUES ('89', '4', 'Write text here');
INSERT INTO `site_lang` VALUES ('88', '4', 'Premium user badge');
INSERT INTO `site_lang` VALUES ('87', '4', 'Unblock all private photos');
INSERT INTO `site_lang` VALUES ('86', '4', 'Unlimited videocalls');
INSERT INTO `site_lang` VALUES ('85', '4', 'new chats per day');
INSERT INTO `site_lang` VALUES ('84', '4', 'Premium Account Features');
INSERT INTO `site_lang` VALUES ('83', '4', 'Buy credits');
INSERT INTO `site_lang` VALUES ('81', '4', 'Pay with');
INSERT INTO `site_lang` VALUES ('82', '4', 'Pay with');
INSERT INTO `site_lang` VALUES ('79', '4', 'Select credits package');
INSERT INTO `site_lang` VALUES ('80', '4', 'Select payment method');
INSERT INTO `site_lang` VALUES ('78', '4', 'Buy credits / Upgrade account');
INSERT INTO `site_lang` VALUES ('77', '4', 'Send gift');
INSERT INTO `site_lang` VALUES ('76', '4', 'Pick the gift you want to send to ');
INSERT INTO `site_lang` VALUES ('75', '4', 'Send gift to ');
INSERT INTO `site_lang` VALUES ('74', '4', 'Add photo');
INSERT INTO `site_lang` VALUES ('73', '4', 'Credits');
INSERT INTO `site_lang` VALUES ('72', '4', 'Pick the photo you want to show in the Spotlight, cost ');
INSERT INTO `site_lang` VALUES ('71', '4', 'Add yourself to the Spotlight');
INSERT INTO `site_lang` VALUES ('70', '4', 'add photos');
INSERT INTO `site_lang` VALUES ('69', '4', 'Add your photos');
INSERT INTO `site_lang` VALUES ('68', '4', 'Private Photos');
INSERT INTO `site_lang` VALUES ('67', '4', 'Public Photos');
INSERT INTO `site_lang` VALUES ('66', '4', 'All Photos');
INSERT INTO `site_lang` VALUES ('65', '4', 'Manage your photos');
INSERT INTO `site_lang` VALUES ('64', '4', 'Contact');
INSERT INTO `site_lang` VALUES ('63', '4', 'Privacy');
INSERT INTO `site_lang` VALUES ('62', '4', 'Terms');
INSERT INTO `site_lang` VALUES ('61', '4', 'Who to like');
INSERT INTO `site_lang` VALUES ('60', '4', 'New messages');
INSERT INTO `site_lang` VALUES ('59', '4', 'Online now');
INSERT INTO `site_lang` VALUES ('58', '4', 'Conversations');
INSERT INTO `site_lang` VALUES ('57', '4', 'Fans');
INSERT INTO `site_lang` VALUES ('56', '4', 'All');
INSERT INTO `site_lang` VALUES ('55', '4', 'Settings');
INSERT INTO `site_lang` VALUES ('54', '4', 'Manage photos');
INSERT INTO `site_lang` VALUES ('53', '4', 'Fans');
INSERT INTO `site_lang` VALUES ('52', '4', 'Most populars');
INSERT INTO `site_lang` VALUES ('51', '4', 'Matches');
INSERT INTO `site_lang` VALUES ('50', '4', 'Discover');
INSERT INTO `site_lang` VALUES ('49', '4', 'Meet new people');
INSERT INTO `site_lang` VALUES ('48', '4', 'Logout');
INSERT INTO `site_lang` VALUES ('47', '4', 'Settings');
INSERT INTO `site_lang` VALUES ('46', '4', 'Profile');
INSERT INTO `site_lang` VALUES ('45', '4', 'Privacy Policy');
INSERT INTO `site_lang` VALUES ('44', '4', 'and');
INSERT INTO `site_lang` VALUES ('43', '4', 'Terms and Conditions');
INSERT INTO `site_lang` VALUES ('41', '4', 'Sign up');
INSERT INTO `site_lang` VALUES ('42', '4', 'By continuing, you are confirming that you have read and agree to our');
INSERT INTO `site_lang` VALUES ('34', '4', 'Gender');
INSERT INTO `site_lang` VALUES ('35', '4', 'Male');
INSERT INTO `site_lang` VALUES ('36', '4', 'Female');
INSERT INTO `site_lang` VALUES ('37', '4', 'Im here to');
INSERT INTO `site_lang` VALUES ('38', '4', 'Meet girls');
INSERT INTO `site_lang` VALUES ('39', '4', 'Meet boys');
INSERT INTO `site_lang` VALUES ('40', '4', 'Meet boys and girls');
INSERT INTO `site_lang` VALUES ('33', '4', 'Where do you live?');
INSERT INTO `site_lang` VALUES ('28', '4', 'Email');
INSERT INTO `site_lang` VALUES ('29', '4', 'Password');
INSERT INTO `site_lang` VALUES ('30', '4', 'Birthday');
INSERT INTO `site_lang` VALUES ('31', '4', 'Please select');
INSERT INTO `site_lang` VALUES ('32', '4', 'City');
INSERT INTO `site_lang` VALUES ('27', '4', 'Your name or nickname');
INSERT INTO `site_lang` VALUES ('24', '4', 'Become a member now');
INSERT INTO `site_lang` VALUES ('25', '4', 'Join the worlds bestest community for meeting new people!.');
INSERT INTO `site_lang` VALUES ('26', '4', 'Name');
INSERT INTO `site_lang` VALUES ('22', '4', 'Matches');
INSERT INTO `site_lang` VALUES ('23', '4', 'Play our popular Discover game and get matched with other users. Its a great way to break the ice and chat to new people.');
INSERT INTO `site_lang` VALUES ('21', '4', 'We wont show your exact location, but you will be able to find people nearby who like the same things you do.');
INSERT INTO `site_lang` VALUES ('20', '4', 'People nearby');
INSERT INTO `site_lang` VALUES ('19', '4', 'You can make quality videocalls for free to anyone, without limits of call duration, just enjoy seeing the person who is chatting with you');
INSERT INTO `site_lang` VALUES ('18', '4', 'Video Chat');
INSERT INTO `site_lang` VALUES ('16', '4', 'Chat');
INSERT INTO `site_lang` VALUES ('17', '4', 'Powerfull private chat for meet new friends, you can send emoticons and private photos to anyone.');
INSERT INTO `site_lang` VALUES ('14', '4', 'Password recover');
INSERT INTO `site_lang` VALUES ('15', '4', 'Recover password');
INSERT INTO `site_lang` VALUES ('13', '4', 'Login now');
INSERT INTO `site_lang` VALUES ('11', '4', 'Your password');
INSERT INTO `site_lang` VALUES ('12', '4', 'do you forget your password?');
INSERT INTO `site_lang` VALUES ('10', '4', 'Your email');
INSERT INTO `site_lang` VALUES ('9', '4', 'Welcome back');
INSERT INTO `site_lang` VALUES ('8', '4', 'Create your account');
INSERT INTO `site_lang` VALUES ('7', '4', 'Connect with ');
INSERT INTO `site_lang` VALUES ('6', '4', 'SOON AVAILABLE');
INSERT INTO `site_lang` VALUES ('5', '4', 'Soon we will have our phone apps online');
INSERT INTO `site_lang` VALUES ('4', '4', 'Please visit us from your laptop or PC');
INSERT INTO `site_lang` VALUES ('1', '4', 'Login');
INSERT INTO `site_lang` VALUES ('2', '4', 'Welcome to the fastest growing place to meet new people');
INSERT INTO `site_lang` VALUES ('3', '4', 'For now our site works only for Desktop users');
INSERT INTO `site_lang` VALUES ('384', '3', 'Ok, i understand');
INSERT INTO `site_lang` VALUES ('0', '4', 'meet new people!');
INSERT INTO `site_lang` VALUES ('383', '3', 'must like you for start a videocall');
INSERT INTO `site_lang` VALUES ('382', '3', 'dont like you');
INSERT INTO `site_lang` VALUES ('379', '3', 'Go to');
INSERT INTO `site_lang` VALUES ('380', '3', 'Welcome to');
INSERT INTO `site_lang` VALUES ('381', '3', 'calling...');
INSERT INTO `site_lang` VALUES ('378', '3', 'Please save your connection information in a safe place');
INSERT INTO `site_lang` VALUES ('377', '3', 'Password');
INSERT INTO `site_lang` VALUES ('376', '3', 'E-mail');
INSERT INTO `site_lang` VALUES ('375', '3', 'Here are your connection details');
INSERT INTO `site_lang` VALUES ('374', '3', 'Start meeting new people now');
INSERT INTO `site_lang` VALUES ('373', '3', 'More than 1 million people have joined $site_name You probably want to know some of them.');
INSERT INTO `site_lang` VALUES ('372', '3', 'Add photos and complete your profile');
INSERT INTO `site_lang` VALUES ('371', '3', 'Nobody is going to fall in love with a blank page. The more information you get, the more chances to find that special someone!');
INSERT INTO `site_lang` VALUES ('370', '3', 'Meet new people');
INSERT INTO `site_lang` VALUES ('369', '3', 'you can meet people instantly');
INSERT INTO `site_lang` VALUES ('368', '3', 'In');
INSERT INTO `site_lang` VALUES ('367', '3', 'people in your area wants to know you');
INSERT INTO `site_lang` VALUES ('366', '3', 'Newsflash');
INSERT INTO `site_lang` VALUES ('365', '3', 'Verify your account');
INSERT INTO `site_lang` VALUES ('363', '3', 'Here are a few tips');
INSERT INTO `site_lang` VALUES ('364', '3', 'Now you are a new member of');
INSERT INTO `site_lang` VALUES ('361', '3', 'Welcome');
INSERT INTO `site_lang` VALUES ('362', '3', 'Well done, now you are in');
INSERT INTO `site_lang` VALUES ('360', '3', 'Check out the profile');
INSERT INTO `site_lang` VALUES ('359', '3', 'and lives closer to you');
INSERT INTO `site_lang` VALUES ('358', '3', 'is new at');
INSERT INTO `site_lang` VALUES ('356', '3', 'Have fun!');
INSERT INTO `site_lang` VALUES ('357', '3', 'is new and lives closer to you');
INSERT INTO `site_lang` VALUES ('355', '3', 'Respond to');
INSERT INTO `site_lang` VALUES ('354', '3', 'you have a new message from');
INSERT INTO `site_lang` VALUES ('353', '3', 'New message from');
INSERT INTO `site_lang` VALUES ('352', '3', 'Go and say something to');
INSERT INTO `site_lang` VALUES ('351', '3', 'thinks the feeling is mutual');
INSERT INTO `site_lang` VALUES ('350', '3', 'Its a match!');
INSERT INTO `site_lang` VALUES ('349', '3', 'You have a match at');
INSERT INTO `site_lang` VALUES ('348', '3', 'if you forgot your password, click on the link below to get a new');
INSERT INTO `site_lang` VALUES ('347', '3', 'Choose a new password');
INSERT INTO `site_lang` VALUES ('346', '3', 'Unsubscribe');
INSERT INTO `site_lang` VALUES ('344', '3', 'Find out if you also like');
INSERT INTO `site_lang` VALUES ('345', '3', 'You received this notice because you registered as');
INSERT INTO `site_lang` VALUES ('343', '3', 'has seen you in discover and likes. The feeling is mutual?');
INSERT INTO `site_lang` VALUES ('342', '3', 'likes you and wants to chat in');
INSERT INTO `site_lang` VALUES ('341', '3', 'We sent you a email with your info, it may take up to 1 min to arrive');
INSERT INTO `site_lang` VALUES ('340', '3', 'Loading...');
INSERT INTO `site_lang` VALUES ('339', '3', 'of');
INSERT INTO `site_lang` VALUES ('338', '3', 'Photos of ');
INSERT INTO `site_lang` VALUES ('337', '3', 'is calling you..');
INSERT INTO `site_lang` VALUES ('336', '3', 'Password successfully changed');
INSERT INTO `site_lang` VALUES ('335', '3', 'Service cost');
INSERT INTO `site_lang` VALUES ('334', '3', 'Spotlight');
INSERT INTO `site_lang` VALUES ('333', '3', 'Wrong');
INSERT INTO `site_lang` VALUES ('331', '3', 'username');
INSERT INTO `site_lang` VALUES ('332', '3', 'days of Premium');
INSERT INTO `site_lang` VALUES ('330', '3', 'You need to write your username!');
INSERT INTO `site_lang` VALUES ('329', '3', 'Write your instagram username');
INSERT INTO `site_lang` VALUES ('328', '3', 'Press backspace key for smart return to the meeting section.');
INSERT INTO `site_lang` VALUES ('327', '3', 'Are you sure you want to report');
INSERT INTO `site_lang` VALUES ('326', '3', 'Report and block');
INSERT INTO `site_lang` VALUES ('325', '3', 'is blocking you or you blocked him, you cant chat with him sorry');
INSERT INTO `site_lang` VALUES ('324', '3', 'We sended you a email for verify your account');
INSERT INTO `site_lang` VALUES ('323', '3', 'years old and im from');
INSERT INTO `site_lang` VALUES ('322', '3', 'Hi, im');
INSERT INTO `site_lang` VALUES ('321', '3', 'Please add a profile photo');
INSERT INTO `site_lang` VALUES ('320', '3', 'Please verify your account, check your email');
INSERT INTO `site_lang` VALUES ('319', '3', 'ago');
INSERT INTO `site_lang` VALUES ('318', '3', 'seconds');
INSERT INTO `site_lang` VALUES ('317', '3', 'minutes');
INSERT INTO `site_lang` VALUES ('316', '3', 'hours');
INSERT INTO `site_lang` VALUES ('315', '3', 'days');
INSERT INTO `site_lang` VALUES ('314', '3', 'months');
INSERT INTO `site_lang` VALUES ('313', '3', 'years');
INSERT INTO `site_lang` VALUES ('312', '3', 'second');
INSERT INTO `site_lang` VALUES ('311', '3', 'minute');
INSERT INTO `site_lang` VALUES ('310', '3', 'hour');
INSERT INTO `site_lang` VALUES ('308', '3', 'month');
INSERT INTO `site_lang` VALUES ('309', '3', 'day');
INSERT INTO `site_lang` VALUES ('307', '3', 'year');
INSERT INTO `site_lang` VALUES ('306', '3', '0 seconds');
INSERT INTO `site_lang` VALUES ('305', '3', 'Credits for $');
INSERT INTO `site_lang` VALUES ('304', '3', 'Cost');
INSERT INTO `site_lang` VALUES ('301', '3', 'You dont have any visit yet');
INSERT INTO `site_lang` VALUES ('302', '3', 'visited');
INSERT INTO `site_lang` VALUES ('303', '3', 'You do not like anyone');
INSERT INTO `site_lang` VALUES ('300', '3', 'AGE');
INSERT INTO `site_lang` VALUES ('297', '3', 'Messages');
INSERT INTO `site_lang` VALUES ('298', '3', 'Like');
INSERT INTO `site_lang` VALUES ('299', '3', 'Dislike');
INSERT INTO `site_lang` VALUES ('295', '3', 'People i like');
INSERT INTO `site_lang` VALUES ('296', '3', 'people liked you, for see them');
INSERT INTO `site_lang` VALUES ('292', '3', 'Delete');
INSERT INTO `site_lang` VALUES ('293', '3', 'people visited your profile for see them');
INSERT INTO `site_lang` VALUES ('294', '3', 'Upgrade your account to premium');
INSERT INTO `site_lang` VALUES ('290', '3', 'Private photo');
INSERT INTO `site_lang` VALUES ('291', '3', 'Public photo');
INSERT INTO `site_lang` VALUES ('289', '3', 'Set as profile');
INSERT INTO `site_lang` VALUES ('287', '3', 'Add me here');
INSERT INTO `site_lang` VALUES ('288', '3', 'get seen by millions');
INSERT INTO `site_lang` VALUES ('286', '3', 'Visits');
INSERT INTO `site_lang` VALUES ('283', '3', 'Add');
INSERT INTO `site_lang` VALUES ('284', '3', 'Photos');
INSERT INTO `site_lang` VALUES ('285', '3', 'Credits');
INSERT INTO `site_lang` VALUES ('282', '3', 'Add from ');
INSERT INTO `site_lang` VALUES ('280', '3', 'Public Photos');
INSERT INTO `site_lang` VALUES ('281', '3', 'Private photos');
INSERT INTO `site_lang` VALUES ('279', '3', 'No data');
INSERT INTO `site_lang` VALUES ('277', '3', 'Report');
INSERT INTO `site_lang` VALUES ('278', '3', 'Fans');
INSERT INTO `site_lang` VALUES ('273', '3', 'Month');
INSERT INTO `site_lang` VALUES ('274', '3', 'Year');
INSERT INTO `site_lang` VALUES ('275', '3', 'Please wait');
INSERT INTO `site_lang` VALUES ('276', '3', 'Interests');
INSERT INTO `site_lang` VALUES ('272', '3', 'Day');
INSERT INTO `site_lang` VALUES ('271', '3', 'When someone send me a message');
INSERT INTO `site_lang` VALUES ('270', '3', 'When new users near me join in');
INSERT INTO `site_lang` VALUES ('269', '3', 'When i get a match');
INSERT INTO `site_lang` VALUES ('268', '3', 'When someone likes me');
INSERT INTO `site_lang` VALUES ('267', '3', 'None');
INSERT INTO `site_lang` VALUES ('266', '3', 'I own a motorbike');
INSERT INTO `site_lang` VALUES ('264', '3', 'Parents car');
INSERT INTO `site_lang` VALUES ('265', '3', 'I own a car');
INSERT INTO `site_lang` VALUES ('263', '3', 'Transport');
INSERT INTO `site_lang` VALUES ('262', '3', 'Drink');
INSERT INTO `site_lang` VALUES ('260', '3', 'No');
INSERT INTO `site_lang` VALUES ('261', '3', 'Sometimes');
INSERT INTO `site_lang` VALUES ('256', '3', 'With partner');
INSERT INTO `site_lang` VALUES ('257', '3', 'Alone');
INSERT INTO `site_lang` VALUES ('258', '3', 'Smoke');
INSERT INTO `site_lang` VALUES ('259', '3', 'Yes');
INSERT INTO `site_lang` VALUES ('255', '3', 'Student dormitory');
INSERT INTO `site_lang` VALUES ('254', '3', 'With housemate');
INSERT INTO `site_lang` VALUES ('252', '3', 'Living');
INSERT INTO `site_lang` VALUES ('253', '3', 'With parents');
INSERT INTO `site_lang` VALUES ('251', '3', 'Curvy');
INSERT INTO `site_lang` VALUES ('250', '3', 'Heavy set');
INSERT INTO `site_lang` VALUES ('249', '3', 'Athletic');
INSERT INTO `site_lang` VALUES ('248', '3', 'Average');
INSERT INTO `site_lang` VALUES ('247', '3', 'Slim');
INSERT INTO `site_lang` VALUES ('245', '3', 'Other');
INSERT INTO `site_lang` VALUES ('246', '3', 'Body type');
INSERT INTO `site_lang` VALUES ('244', '3', 'Indian');
INSERT INTO `site_lang` VALUES ('243', '3', 'Pacific Islander');
INSERT INTO `site_lang` VALUES ('242', '3', 'Hispanic/latin');
INSERT INTO `site_lang` VALUES ('241', '3', 'Native American');
INSERT INTO `site_lang` VALUES ('240', '3', 'White');
INSERT INTO `site_lang` VALUES ('239', '3', 'Black');
INSERT INTO `site_lang` VALUES ('238', '3', 'Middle Eastern');
INSERT INTO `site_lang` VALUES ('237', '3', 'Asian');
INSERT INTO `site_lang` VALUES ('236', '3', 'Ethnicity');
INSERT INTO `site_lang` VALUES ('235', '3', 'Weight');
INSERT INTO `site_lang` VALUES ('234', '3', 'more than');
INSERT INTO `site_lang` VALUES ('233', '3', 'less than');
INSERT INTO `site_lang` VALUES ('232', '3', 'Height');
INSERT INTO `site_lang` VALUES ('231', '3', 'Bisexual');
INSERT INTO `site_lang` VALUES ('228', '3', 'Gay');
INSERT INTO `site_lang` VALUES ('229', '3', 'Open-minded');
INSERT INTO `site_lang` VALUES ('230', '3', 'Straight');
INSERT INTO `site_lang` VALUES ('227', '3', 'Sexuality');
INSERT INTO `site_lang` VALUES ('225', '3', 'Taken');
INSERT INTO `site_lang` VALUES ('226', '3', 'Open');
INSERT INTO `site_lang` VALUES ('224', '3', 'Single');
INSERT INTO `site_lang` VALUES ('223', '3', 'Relationship');
INSERT INTO `site_lang` VALUES ('222', '3', 'Extended info (optional)');
INSERT INTO `site_lang` VALUES ('221', '3', 'Notifications');
INSERT INTO `site_lang` VALUES ('218', '3', 'until');
INSERT INTO `site_lang` VALUES ('219', '3', 'Basic');
INSERT INTO `site_lang` VALUES ('220', '3', 'UPGRADE');
INSERT INTO `site_lang` VALUES ('217', '3', 'Wait more');
INSERT INTO `site_lang` VALUES ('215', '3', 'Seems that your friend do not have webcam or he is not available');
INSERT INTO `site_lang` VALUES ('216', '3', 'End call');
INSERT INTO `site_lang` VALUES ('214', '3', 'Too long wait');
INSERT INTO `site_lang` VALUES ('213', '3', 'You cant make videocall because you dont have webcam');
INSERT INTO `site_lang` VALUES ('212', '3', 'Impossible to make a call!');
INSERT INTO `site_lang` VALUES ('211', '3', 'Only premium users can make videocalls');
INSERT INTO `site_lang` VALUES ('210', '3', 'You are already in a videocall, you have to end the other call before start another');
INSERT INTO `site_lang` VALUES ('209', '3', 'Please allow access to your Webcam.');
INSERT INTO `site_lang` VALUES ('208', '3', 'is offline, try again when your friend is online');
INSERT INTO `site_lang` VALUES ('207', '3', 'is in another videocall , you cant call now');
INSERT INTO `site_lang` VALUES ('206', '3', 'Yes, delete it!');
INSERT INTO `site_lang` VALUES ('205', '3', 'Your data will be lost without recovery, continue?');
INSERT INTO `site_lang` VALUES ('204', '3', 'Account termination');
INSERT INTO `site_lang` VALUES ('203', '3', 'Information updated successfully');
INSERT INTO `site_lang` VALUES ('202', '3', 'Yes, buy it!');
INSERT INTO `site_lang` VALUES ('201', '3', 'more daily conversation, cost ');
INSERT INTO `site_lang` VALUES ('200', '3', 'Expand daily limitation ');
INSERT INTO `site_lang` VALUES ('199', '3', 'You dont have enought credits for send the gift');
INSERT INTO `site_lang` VALUES ('198', '3', 'Please, select 1 gift');
INSERT INTO `site_lang` VALUES ('197', '3', 'Please, select 1 photo');
INSERT INTO `site_lang` VALUES ('196', '3', 'Please, select a payment method');
INSERT INTO `site_lang` VALUES ('195', '3', 'No thanks');
INSERT INTO `site_lang` VALUES ('194', '3', 'Get access');
INSERT INTO `site_lang` VALUES ('193', '3', 'private photos for ');
INSERT INTO `site_lang` VALUES ('192', '3', 'Get access to');
INSERT INTO `site_lang` VALUES ('191', '3', 'Buy private photos permission');
INSERT INTO `site_lang` VALUES ('190', '3', 'No, i cant show you my private photos');
INSERT INTO `site_lang` VALUES ('189', '3', 'Yes, you can see my private photos');
INSERT INTO `site_lang` VALUES ('188', '3', 'Email already exist, try another');
INSERT INTO `site_lang` VALUES ('187', '3', 'Password too short');
INSERT INTO `site_lang` VALUES ('186', '3', 'Choose city from the autocomplete');
INSERT INTO `site_lang` VALUES ('185', '3', 'Add a valid date');
INSERT INTO `site_lang` VALUES ('184', '3', 'Wrong password');
INSERT INTO `site_lang` VALUES ('182', '3', 'Please fill all the inputs');
INSERT INTO `site_lang` VALUES ('183', '3', 'Email dont exist');
INSERT INTO `site_lang` VALUES ('181', '3', 'Invalid email format');
INSERT INTO `site_lang` VALUES ('180', '3', 'Password recover');
INSERT INTO `site_lang` VALUES ('179', '3', 'Login to my account');
INSERT INTO `site_lang` VALUES ('178', '3', 'If you dont remember your password, click the link below to set a new one:');
INSERT INTO `site_lang` VALUES ('177', '3', 'Hi');
INSERT INTO `site_lang` VALUES ('176', '3', 'No');
INSERT INTO `site_lang` VALUES ('175', '3', 'Yes');
INSERT INTO `site_lang` VALUES ('174', '3', 'Hello, can i have access to your private photos ?');
INSERT INTO `site_lang` VALUES ('173', '3', 'like this');
INSERT INTO `site_lang` VALUES ('171', '3', 'Days Premium');
INSERT INTO `site_lang` VALUES ('172', '3', 'persons more like this');
INSERT INTO `site_lang` VALUES ('170', '3', 'Buy');
INSERT INTO `site_lang` VALUES ('169', '3', 'December');
INSERT INTO `site_lang` VALUES ('168', '3', 'November');
INSERT INTO `site_lang` VALUES ('167', '3', 'October');
INSERT INTO `site_lang` VALUES ('166', '3', 'September');
INSERT INTO `site_lang` VALUES ('165', '3', 'August');
INSERT INTO `site_lang` VALUES ('164', '3', 'July');
INSERT INTO `site_lang` VALUES ('163', '3', 'June');
INSERT INTO `site_lang` VALUES ('162', '3', 'May');
INSERT INTO `site_lang` VALUES ('161', '3', 'April');
INSERT INTO `site_lang` VALUES ('160', '3', 'March');
INSERT INTO `site_lang` VALUES ('159', '3', 'February');
INSERT INTO `site_lang` VALUES ('158', '3', 'January');
INSERT INTO `site_lang` VALUES ('157', '3', 'You dont have matches yet');
INSERT INTO `site_lang` VALUES ('156', '3', 'You dont have any fans yet');
INSERT INTO `site_lang` VALUES ('155', '3', 'No popular users near you');
INSERT INTO `site_lang` VALUES ('154', '3', 'people found');
INSERT INTO `site_lang` VALUES ('153', '3', 'Nothing found');
INSERT INTO `site_lang` VALUES ('152', '3', 'Verified');
INSERT INTO `site_lang` VALUES ('151', '3', 'Online now');
INSERT INTO `site_lang` VALUES ('150', '3', 'Delete profile');
INSERT INTO `site_lang` VALUES ('149', '3', 'After delete your profile, some of your data will be lost without recovery.');
INSERT INTO `site_lang` VALUES ('147', '3', 'New password');
INSERT INTO `site_lang` VALUES ('148', '3', 'Profile desactivation');
INSERT INTO `site_lang` VALUES ('146', '3', 'You can change your current password bellow');
INSERT INTO `site_lang` VALUES ('145', '3', 'Change password');
INSERT INTO `site_lang` VALUES ('144', '3', 'Upgrade to premium account');
INSERT INTO `site_lang` VALUES ('143', '3', 'Add credits');
INSERT INTO `site_lang` VALUES ('142', '3', 'Current credits');
INSERT INTO `site_lang` VALUES ('141', '3', 'Account type');
INSERT INTO `site_lang` VALUES ('140', '3', 'Buy credits for send Gifs and Unblock private photos');
INSERT INTO `site_lang` VALUES ('139', '3', 'You are account is already verified');
INSERT INTO `site_lang` VALUES ('138', '3', 'Connect with Facebook');
INSERT INTO `site_lang` VALUES ('137', '3', 'For verify your account , connect with your facebook account');
INSERT INTO `site_lang` VALUES ('136', '3', 'Verify account');
INSERT INTO `site_lang` VALUES ('135', '3', 'Update profile');
INSERT INTO `site_lang` VALUES ('134', '3', 'Site language');
INSERT INTO `site_lang` VALUES ('133', '3', 'You can edit your profile information bellow');
INSERT INTO `site_lang` VALUES ('132', '3', 'Personal information');
INSERT INTO `site_lang` VALUES ('131', '3', 'Delete');
INSERT INTO `site_lang` VALUES ('130', '3', 'Change password');
INSERT INTO `site_lang` VALUES ('128', '3', 'Credits');
INSERT INTO `site_lang` VALUES ('129', '3', 'Verify');
INSERT INTO `site_lang` VALUES ('127', '3', 'Personal');
INSERT INTO `site_lang` VALUES ('126', '3', 'Unblock private photos');
INSERT INTO `site_lang` VALUES ('125', '3', 'Ask permission to');
INSERT INTO `site_lang` VALUES ('124', '3', 'Now you have');
INSERT INTO `site_lang` VALUES ('123', '3', 'Credits successfully added to your account');
INSERT INTO `site_lang` VALUES ('122', '3', 'boys and girls');
INSERT INTO `site_lang` VALUES ('121', '3', 'Only girls');
INSERT INTO `site_lang` VALUES ('120', '3', 'Only boys');
INSERT INTO `site_lang` VALUES ('119', '3', 'years old');
INSERT INTO `site_lang` VALUES ('118', '3', 'Personal info');
INSERT INTO `site_lang` VALUES ('117', '3', 'About ');
INSERT INTO `site_lang` VALUES ('116', '3', 'Most popular users');
INSERT INTO `site_lang` VALUES ('115', '3', 'World');
INSERT INTO `site_lang` VALUES ('114', '3', 'in a radius of');
INSERT INTO `site_lang` VALUES ('113', '3', 'who are between');
INSERT INTO `site_lang` VALUES ('105', '3', 'Your matches');
INSERT INTO `site_lang` VALUES ('106', '3', 'Filter Search');
INSERT INTO `site_lang` VALUES ('109', '3', 'Show me');
INSERT INTO `site_lang` VALUES ('110', '3', 'Girls');
INSERT INTO `site_lang` VALUES ('111', '3', 'Boys');
INSERT INTO `site_lang` VALUES ('112', '3', 'Both');
INSERT INTO `site_lang` VALUES ('108', '3', 'Online now');
INSERT INTO `site_lang` VALUES ('107', '3', 'All users');
INSERT INTO `site_lang` VALUES ('101', '3', 'Your fans');
INSERT INTO `site_lang` VALUES ('102', '3', 'Privacy Policy');
INSERT INTO `site_lang` VALUES ('103', '3', 'Terms of Use');
INSERT INTO `site_lang` VALUES ('104', '3', 'Please complete your profile before start in ');
INSERT INTO `site_lang` VALUES ('100', '3', 'or wait until tomorrow for continue meeting people');
INSERT INTO `site_lang` VALUES ('97', '3', 'Upgrade your account to Premium');
INSERT INTO `site_lang` VALUES ('98', '3', 'and get up to');
INSERT INTO `site_lang` VALUES ('99', '3', 'daily conversations');
INSERT INTO `site_lang` VALUES ('96', '3', 'or');
INSERT INTO `site_lang` VALUES ('95', '3', 'more daily conversation');
INSERT INTO `site_lang` VALUES ('94', '3', 'Buy');
INSERT INTO `site_lang` VALUES ('93', '3', 'To continue chatting');
INSERT INTO `site_lang` VALUES ('92', '3', 'you have reached the limit of new daily conversations');
INSERT INTO `site_lang` VALUES ('91', '3', 'Chat');
INSERT INTO `site_lang` VALUES ('90', '3', 'Send');
INSERT INTO `site_lang` VALUES ('89', '3', 'Write text here');
INSERT INTO `site_lang` VALUES ('88', '3', 'Premium user badge');
INSERT INTO `site_lang` VALUES ('87', '3', 'Unblock all private photos');
INSERT INTO `site_lang` VALUES ('86', '3', 'Unlimited videocalls');
INSERT INTO `site_lang` VALUES ('85', '3', 'new chats per day');
INSERT INTO `site_lang` VALUES ('83', '3', 'Buy credits');
INSERT INTO `site_lang` VALUES ('84', '3', 'Premium Account Features');
INSERT INTO `site_lang` VALUES ('82', '3', 'Pay with');
INSERT INTO `site_lang` VALUES ('81', '3', 'Pay with');
INSERT INTO `site_lang` VALUES ('80', '3', 'Select payment method');
INSERT INTO `site_lang` VALUES ('79', '3', 'Select credits package');
INSERT INTO `site_lang` VALUES ('78', '3', 'Buy credits / Upgrade account');
INSERT INTO `site_lang` VALUES ('77', '3', 'Send gift');
INSERT INTO `site_lang` VALUES ('76', '3', 'Pick the gift you want to send to ');
INSERT INTO `site_lang` VALUES ('73', '3', 'Credits');
INSERT INTO `site_lang` VALUES ('74', '3', 'Add photo');
INSERT INTO `site_lang` VALUES ('75', '3', 'Send gift to ');
INSERT INTO `site_lang` VALUES ('70', '3', 'add photos');
INSERT INTO `site_lang` VALUES ('71', '3', 'Add yourself to the Spotlight');
INSERT INTO `site_lang` VALUES ('72', '3', 'Pick the photo you want to show in the Spotlight, cost ');
INSERT INTO `site_lang` VALUES ('67', '3', 'Public Photos');
INSERT INTO `site_lang` VALUES ('68', '3', 'Private Photos');
INSERT INTO `site_lang` VALUES ('69', '3', 'Add your photos');
INSERT INTO `site_lang` VALUES ('63', '3', 'Privacy');
INSERT INTO `site_lang` VALUES ('64', '3', 'Contact');
INSERT INTO `site_lang` VALUES ('65', '3', 'Manage your photos');
INSERT INTO `site_lang` VALUES ('66', '3', 'All Photos');
INSERT INTO `site_lang` VALUES ('62', '3', 'Terms');
INSERT INTO `site_lang` VALUES ('61', '3', 'Who to like');
INSERT INTO `site_lang` VALUES ('59', '3', 'Online now');
INSERT INTO `site_lang` VALUES ('60', '3', 'New messages');
INSERT INTO `site_lang` VALUES ('58', '3', 'Conversations');
INSERT INTO `site_lang` VALUES ('57', '3', 'Fans');
INSERT INTO `site_lang` VALUES ('56', '3', 'All');
INSERT INTO `site_lang` VALUES ('55', '3', 'Settings');
INSERT INTO `site_lang` VALUES ('54', '3', 'Manage photos');
INSERT INTO `site_lang` VALUES ('53', '3', 'Fans');
INSERT INTO `site_lang` VALUES ('52', '3', 'Most populars');
INSERT INTO `site_lang` VALUES ('51', '3', 'Matches');
INSERT INTO `site_lang` VALUES ('50', '3', 'Discover');
INSERT INTO `site_lang` VALUES ('49', '3', 'Meet new people');
INSERT INTO `site_lang` VALUES ('48', '3', 'Logout');
INSERT INTO `site_lang` VALUES ('47', '3', 'Settings');
INSERT INTO `site_lang` VALUES ('46', '3', 'Profile');
INSERT INTO `site_lang` VALUES ('45', '3', 'Privacy Policy');
INSERT INTO `site_lang` VALUES ('44', '3', 'and');
INSERT INTO `site_lang` VALUES ('43', '3', 'Terms and Conditions');
INSERT INTO `site_lang` VALUES ('42', '3', 'By continuing, you are confirming that you have read and agree to our');
INSERT INTO `site_lang` VALUES ('41', '3', 'Sign up');
INSERT INTO `site_lang` VALUES ('40', '3', 'Meet boys and girls');
INSERT INTO `site_lang` VALUES ('39', '3', 'Meet boys');
INSERT INTO `site_lang` VALUES ('38', '3', 'Meet girls');
INSERT INTO `site_lang` VALUES ('37', '3', 'Im here to');
INSERT INTO `site_lang` VALUES ('36', '3', 'Female');
INSERT INTO `site_lang` VALUES ('35', '3', 'Male');
INSERT INTO `site_lang` VALUES ('34', '3', 'Gender');
INSERT INTO `site_lang` VALUES ('32', '3', 'City');
INSERT INTO `site_lang` VALUES ('33', '3', 'Where do you live?');
INSERT INTO `site_lang` VALUES ('31', '3', 'Please select');
INSERT INTO `site_lang` VALUES ('30', '3', 'Birthday');
INSERT INTO `site_lang` VALUES ('29', '3', 'Password');
INSERT INTO `site_lang` VALUES ('28', '3', 'Email');
INSERT INTO `site_lang` VALUES ('27', '3', 'Your name or nickname');
INSERT INTO `site_lang` VALUES ('26', '3', 'Name');
INSERT INTO `site_lang` VALUES ('25', '3', 'Join the worlds bestest community for meeting new people!.');
INSERT INTO `site_lang` VALUES ('24', '3', 'Become a member now');
INSERT INTO `site_lang` VALUES ('23', '3', 'Play our popular Discover game and get matched with other users. Its a great way to break the ice and chat to new people.');
INSERT INTO `site_lang` VALUES ('22', '3', 'Matches');
INSERT INTO `site_lang` VALUES ('21', '3', 'We wont show your exact location, but you will be able to find people nearby who like the same things you do.');
INSERT INTO `site_lang` VALUES ('20', '3', 'People nearby');
INSERT INTO `site_lang` VALUES ('19', '3', 'You can make quality videocalls for free to anyone, without limits of call duration, just enjoy seeing the person who is chatting with you');
INSERT INTO `site_lang` VALUES ('18', '3', 'Video Chat');
INSERT INTO `site_lang` VALUES ('17', '3', 'Powerfull private chat for meet new friends, you can send emoticons and private photos to anyone.');
INSERT INTO `site_lang` VALUES ('16', '3', 'Chat');
INSERT INTO `site_lang` VALUES ('15', '3', 'Recover password');
INSERT INTO `site_lang` VALUES ('14', '3', 'Password recover');
INSERT INTO `site_lang` VALUES ('13', '3', 'Login now');
INSERT INTO `site_lang` VALUES ('12', '3', 'do you forget your password?');
INSERT INTO `site_lang` VALUES ('11', '3', 'Your password');
INSERT INTO `site_lang` VALUES ('10', '3', 'Your email');
INSERT INTO `site_lang` VALUES ('9', '3', 'Welcome back');
INSERT INTO `site_lang` VALUES ('8', '3', 'Create your account');
INSERT INTO `site_lang` VALUES ('7', '3', 'Connect with ');
INSERT INTO `site_lang` VALUES ('6', '3', 'SOON AVAILABLE');
INSERT INTO `site_lang` VALUES ('5', '3', 'Soon we will have our phone apps online');
INSERT INTO `site_lang` VALUES ('4', '3', 'Please visit us from your laptop or PC');
INSERT INTO `site_lang` VALUES ('3', '3', 'For now our site works only for Desktop users');
INSERT INTO `site_lang` VALUES ('2', '3', 'Welcome to the fastest growing place to meet new people');
INSERT INTO `site_lang` VALUES ('1', '3', 'Login');
INSERT INTO `site_lang` VALUES ('0', '3', 'meet new people!');
INSERT INTO `site_lang` VALUES ('384', '37', 'Ok, eu entendo');
INSERT INTO `site_lang` VALUES ('381', '37', 'chamando ...');
INSERT INTO `site_lang` VALUES ('378', '37', 'Por favor, salve suas informaÃ§Ãµes de conexÃ£o em um lugar seguro');
INSERT INTO `site_lang` VALUES ('383', '37', 'deve gostar de vocÃª para iniciar uma videochamada');
INSERT INTO `site_lang` VALUES ('382', '37', 'nÃ£o gosto de vocÃª');
INSERT INTO `site_lang` VALUES ('380', '37', 'Bem-vindo ao');
INSERT INTO `site_lang` VALUES ('379', '37', 'Vamos para');
INSERT INTO `site_lang` VALUES ('377', '37', 'Senha');
INSERT INTO `site_lang` VALUES ('376', '37', 'O email');
INSERT INTO `site_lang` VALUES ('375', '37', 'Aqui estÃ£o os detalhes da ligaÃ§Ã£o');
INSERT INTO `site_lang` VALUES ('374', '37', 'Comece conhecer novas pessoas agora');
INSERT INTO `site_lang` VALUES ('373', '37', 'Mais de 1 milhÃ£o de pessoas se juntaram $ site_name VocÃª provavelmente quer saber alguns deles.');
INSERT INTO `site_lang` VALUES ('372', '37', 'Adicione fotos e complete o seu perfil');
INSERT INTO `site_lang` VALUES ('371', '37', 'NinguÃ©m vai se apaixonar por uma pÃ¡gina em branco . Quanto mais informaÃ§Ãµes vocÃª tem , mais chances de encontrar aquele alguÃ©m especial!');
INSERT INTO `site_lang` VALUES ('370', '37', 'ConheÃ§a novas pessoas');
INSERT INTO `site_lang` VALUES ('369', '37', 'vocÃª pode conhecer pessoas instantaneamente');
INSERT INTO `site_lang` VALUES ('368', '37', 'Dentro');
INSERT INTO `site_lang` VALUES ('367', '37', 'pessoas em sua Ã¡rea quer conhecÃª-lo');
INSERT INTO `site_lang` VALUES ('366', '37', 'Noticias');
INSERT INTO `site_lang` VALUES ('365', '37', 'Verifique sua conta');
INSERT INTO `site_lang` VALUES ('364', '37', 'Agora vocÃª Ã© um novo membro da');
INSERT INTO `site_lang` VALUES ('363', '37', 'Aqui estao algumas dicas');
INSERT INTO `site_lang` VALUES ('362', '37', 'Bem feito, agora vocÃª estÃ¡ em');
INSERT INTO `site_lang` VALUES ('361', '37', 'Bem vinda');
INSERT INTO `site_lang` VALUES ('360', '37', 'Confira o perfil');
INSERT INTO `site_lang` VALUES ('359', '37', 'e vive mais perto de vocÃª');
INSERT INTO `site_lang` VALUES ('358', '37', 'Ã© novo no');
INSERT INTO `site_lang` VALUES ('357', '37', 'Ã© novo e vive mais perto de vocÃª');
INSERT INTO `site_lang` VALUES ('356', '37', 'Diverta-se!');
INSERT INTO `site_lang` VALUES ('354', '37', 'VocÃª tem uma nova mensagem de');
INSERT INTO `site_lang` VALUES ('355', '37', 'responder a');
INSERT INTO `site_lang` VALUES ('353', '37', 'Nova mensagem de');
INSERT INTO `site_lang` VALUES ('352', '37', 'Vai dizer algo para');
INSERT INTO `site_lang` VALUES ('351', '37', 'acha que o sentimento Ã© mÃºtuo');
INSERT INTO `site_lang` VALUES ('350', '37', 'Ã‰ uma combinaÃ§Ã£o!');
INSERT INTO `site_lang` VALUES ('349', '37', 'VocÃª tem uma partida em');
INSERT INTO `site_lang` VALUES ('348', '37', 'Se vocÃª esqueceu sua senha , clique no link abaixo para obter um novo');
INSERT INTO `site_lang` VALUES ('347', '37', 'Escolha uma nova senha');
INSERT INTO `site_lang` VALUES ('346', '37', 'Cancelar subscriÃ§Ã£o');
INSERT INTO `site_lang` VALUES ('344', '37', 'Descubra se vocÃª tambÃ©m gosta');
INSERT INTO `site_lang` VALUES ('345', '37', 'VocÃª recebeu este aviso porque vocÃª registrado como');
INSERT INTO `site_lang` VALUES ('342', '37', 'gosta de vocÃª e quer conversar em');
INSERT INTO `site_lang` VALUES ('343', '37', 'viu -lo em descobrir e gosta . O sentimento Ã© mÃºtuo?');
INSERT INTO `site_lang` VALUES ('341', '37', 'Enviamos um e-mail com sua informaÃ§Ã£o , pode demorar atÃ© 1 minuto para chegar');
INSERT INTO `site_lang` VALUES ('332', '37', 'dias de Premium');
INSERT INTO `site_lang` VALUES ('333', '37', 'Errado');
INSERT INTO `site_lang` VALUES ('334', '37', 'holofote');
INSERT INTO `site_lang` VALUES ('335', '37', 'O custo do serviÃ§o');
INSERT INTO `site_lang` VALUES ('336', '37', 'Senha mudada com sucesso');
INSERT INTO `site_lang` VALUES ('337', '37', 'estÃ¡ chamando vocÃª ..');
INSERT INTO `site_lang` VALUES ('338', '37', 'Fotos de');
INSERT INTO `site_lang` VALUES ('339', '37', 'do');
INSERT INTO `site_lang` VALUES ('340', '37', 'Carregando...');
INSERT INTO `site_lang` VALUES ('331', '37', 'nome de usuÃ¡rio');
INSERT INTO `site_lang` VALUES ('330', '37', 'VocÃª precisa escrever seu nome de usuÃ¡rio !');
INSERT INTO `site_lang` VALUES ('329', '37', 'Escrever seu nome de usuÃ¡rio instagram');
INSERT INTO `site_lang` VALUES ('328', '37', 'Pressione a tecla de retrocesso para o retorno inteligente para reuniÃ£o da secÃ§Ã£o .');
INSERT INTO `site_lang` VALUES ('327', '37', 'Tem certeza de que quer denunciar');
INSERT INTO `site_lang` VALUES ('326', '37', 'RelatÃ³rio e bloco');
INSERT INTO `site_lang` VALUES ('325', '37', 'estÃ¡ bloqueando vocÃª ou vocÃª bloqueou -lo, vocÃª nÃ£o pode conversar com ele pena');
INSERT INTO `site_lang` VALUES ('317', '37', 'minutos');
INSERT INTO `site_lang` VALUES ('318', '37', 'segundos');
INSERT INTO `site_lang` VALUES ('319', '37', 'atrÃ¡s');
INSERT INTO `site_lang` VALUES ('320', '37', 'Por favor, confirme sua conta , verifique seu e-mail');
INSERT INTO `site_lang` VALUES ('324', '37', 'NÃ³s sended um e-mail para verificar sua conta');
INSERT INTO `site_lang` VALUES ('323', '37', 'anos de idade e im de');
INSERT INTO `site_lang` VALUES ('322', '37', 'Oi eu sou');
INSERT INTO `site_lang` VALUES ('321', '37', 'Por favor, adicione uma foto de perfil');
INSERT INTO `site_lang` VALUES ('316', '37', 'horas');
INSERT INTO `site_lang` VALUES ('315', '37', 'dias');
INSERT INTO `site_lang` VALUES ('309', '37', 'dia');
INSERT INTO `site_lang` VALUES ('310', '37', 'hora');
INSERT INTO `site_lang` VALUES ('311', '37', 'minuto');
INSERT INTO `site_lang` VALUES ('312', '37', 'segundo');
INSERT INTO `site_lang` VALUES ('313', '37', 'anos');
INSERT INTO `site_lang` VALUES ('314', '37', 'meses');
INSERT INTO `site_lang` VALUES ('308', '37', 'mÃªs');
INSERT INTO `site_lang` VALUES ('307', '37', 'ano');
INSERT INTO `site_lang` VALUES ('306', '37', '0 segundos');
INSERT INTO `site_lang` VALUES ('305', '37', 'CrÃ©ditos por R $');
INSERT INTO `site_lang` VALUES ('304', '37', 'Custo');
INSERT INTO `site_lang` VALUES ('303', '37', 'VocÃª nÃ£o gosta de ninguÃ©m');
INSERT INTO `site_lang` VALUES ('302', '37', 'visitado');
INSERT INTO `site_lang` VALUES ('301', '37', 'VocÃª nÃ£o tem qualquer visita ainda');
INSERT INTO `site_lang` VALUES ('300', '37', 'IDADE');
INSERT INTO `site_lang` VALUES ('299', '37', 'Antipatia');
INSERT INTO `site_lang` VALUES ('298', '37', 'Gostar');
INSERT INTO `site_lang` VALUES ('297', '37', 'Mensagens');
INSERT INTO `site_lang` VALUES ('296', '37', 'As pessoas gostaram de vocÃª , para vÃª-los');
INSERT INTO `site_lang` VALUES ('295', '37', 'Pessoas que eu gosto');
INSERT INTO `site_lang` VALUES ('294', '37', 'Atualizar sua conta para prÃ©mio');
INSERT INTO `site_lang` VALUES ('293', '37', 'pessoas visitaram seu perfil para vÃª-los');
INSERT INTO `site_lang` VALUES ('291', '37', 'Foto pÃºblica');
INSERT INTO `site_lang` VALUES ('292', '37', 'Excluir');
INSERT INTO `site_lang` VALUES ('290', '37', 'Foto privada');
INSERT INTO `site_lang` VALUES ('288', '37', 'Obter visto por milhÃµes');
INSERT INTO `site_lang` VALUES ('289', '37', 'Definir como perfil');
INSERT INTO `site_lang` VALUES ('287', '37', 'Adiciona-me aqui');
INSERT INTO `site_lang` VALUES ('286', '37', 'Visitas');
INSERT INTO `site_lang` VALUES ('285', '37', 'CrÃ©ditos');
INSERT INTO `site_lang` VALUES ('283', '37', 'Adicionar');
INSERT INTO `site_lang` VALUES ('284', '37', 'Fotos');
INSERT INTO `site_lang` VALUES ('276', '37', 'interesses');
INSERT INTO `site_lang` VALUES ('277', '37', 'RelatÃ³rio');
INSERT INTO `site_lang` VALUES ('278', '37', 'Fans');
INSERT INTO `site_lang` VALUES ('279', '37', 'NÃ£o existem dados');
INSERT INTO `site_lang` VALUES ('280', '37', 'Fotos pÃºblicas');
INSERT INTO `site_lang` VALUES ('281', '37', 'Fotos privadas');
INSERT INTO `site_lang` VALUES ('282', '37', 'Adicione a partir de');
INSERT INTO `site_lang` VALUES ('275', '37', 'Por favor, espere');
INSERT INTO `site_lang` VALUES ('274', '37', 'Ano');
INSERT INTO `site_lang` VALUES ('273', '37', 'MÃªs');
INSERT INTO `site_lang` VALUES ('272', '37', 'Dia');
INSERT INTO `site_lang` VALUES ('271', '37', 'Quando alguÃ©m me enviar uma mensagem');
INSERT INTO `site_lang` VALUES ('270', '37', 'Quando novos usuÃ¡rios perto de se juntar a mim na');
INSERT INTO `site_lang` VALUES ('269', '37', 'Quando eu comeÃ§ar uma partida');
INSERT INTO `site_lang` VALUES ('268', '37', 'Quando alguÃ©m gosta de mim');
INSERT INTO `site_lang` VALUES ('267', '37', 'Nenhum');
INSERT INTO `site_lang` VALUES ('266', '37', 'Eu possuo uma moto');
INSERT INTO `site_lang` VALUES ('264', '37', 'Carro pais');
INSERT INTO `site_lang` VALUES ('265', '37', 'Eu possuo um carro');
INSERT INTO `site_lang` VALUES ('263', '37', 'Transporte');
INSERT INTO `site_lang` VALUES ('262', '37', 'Beber');
INSERT INTO `site_lang` VALUES ('261', '37', 'As vez');
INSERT INTO `site_lang` VALUES ('259', '37', 'Sim');
INSERT INTO `site_lang` VALUES ('260', '37', 'NÃ£o');
INSERT INTO `site_lang` VALUES ('258', '37', 'FumaÃ§a');
INSERT INTO `site_lang` VALUES ('257', '37', 'Sozinho');
INSERT INTO `site_lang` VALUES ('255', '37', 'DormitÃ³rio estudantil');
INSERT INTO `site_lang` VALUES ('256', '37', 'com o parceiro');
INSERT INTO `site_lang` VALUES ('254', '37', 'Com housemate');
INSERT INTO `site_lang` VALUES ('253', '37', 'Com os pais');
INSERT INTO `site_lang` VALUES ('252', '37', 'Vivo em');
INSERT INTO `site_lang` VALUES ('251', '37', 'Gordura');
INSERT INTO `site_lang` VALUES ('250', '37', 'SÃ©rie pesada');
INSERT INTO `site_lang` VALUES ('249', '37', 'AtlÃ©tico');
INSERT INTO `site_lang` VALUES ('248', '37', 'MÃ©dia');
INSERT INTO `site_lang` VALUES ('247', '37', 'Fino');
INSERT INTO `site_lang` VALUES ('246', '37', 'Tipo de corpo');
INSERT INTO `site_lang` VALUES ('245', '37', 'De outros');
INSERT INTO `site_lang` VALUES ('244', '37', 'Indiano');
INSERT INTO `site_lang` VALUES ('243', '37', 'Ilhas do PacÃ­fico');
INSERT INTO `site_lang` VALUES ('242', '37', 'HispÃ¢nico / Latino');
INSERT INTO `site_lang` VALUES ('241', '37', 'Americano nativo');
INSERT INTO `site_lang` VALUES ('240', '37', 'Branco');
INSERT INTO `site_lang` VALUES ('239', '37', 'Preto');
INSERT INTO `site_lang` VALUES ('238', '37', 'Oriente MÃ©dio');
INSERT INTO `site_lang` VALUES ('237', '37', 'AsiÃ¡tico');
INSERT INTO `site_lang` VALUES ('236', '37', 'Etnia');
INSERT INTO `site_lang` VALUES ('235', '37', 'Peso');
INSERT INTO `site_lang` VALUES ('234', '37', 'mais que');
INSERT INTO `site_lang` VALUES ('233', '37', 'menos que');
INSERT INTO `site_lang` VALUES ('232', '37', 'Altura');
INSERT INTO `site_lang` VALUES ('231', '37', 'Bissexual');
INSERT INTO `site_lang` VALUES ('230', '37', 'Direto');
INSERT INTO `site_lang` VALUES ('229', '37', 'Mente aberta');
INSERT INTO `site_lang` VALUES ('228', '37', 'Homossexual');
INSERT INTO `site_lang` VALUES ('227', '37', 'Sexualidade');
INSERT INTO `site_lang` VALUES ('224', '37', 'Solteiro');
INSERT INTO `site_lang` VALUES ('225', '37', 'Tomado');
INSERT INTO `site_lang` VALUES ('226', '37', 'Aberto');
INSERT INTO `site_lang` VALUES ('223', '37', 'RelaÃ§Ã£o');
INSERT INTO `site_lang` VALUES ('222', '37', 'InformaÃ§Ã£o ExtensÃ£o (opcional)');
INSERT INTO `site_lang` VALUES ('221', '37', 'NotificaÃ§Ãµes');
INSERT INTO `site_lang` VALUES ('220', '37', 'ATUALIZAÃ‡ÃƒO');
INSERT INTO `site_lang` VALUES ('219', '37', 'BÃ¡sico');
INSERT INTO `site_lang` VALUES ('218', '37', 'AtÃ©');
INSERT INTO `site_lang` VALUES ('217', '37', 'Esperar mais');
INSERT INTO `site_lang` VALUES ('216', '37', 'Terminar chamada');
INSERT INTO `site_lang` VALUES ('215', '37', 'Parece que o seu amigo nÃ£o tem webcam ou ele nÃ£o estÃ¡ disponÃ­vel');
INSERT INTO `site_lang` VALUES ('214', '37', 'Muito longa espera');
INSERT INTO `site_lang` VALUES ('213', '37', 'VocÃª nÃ£o pode fazer videocall porque vocÃª nÃ£o tem de webcam');
INSERT INTO `site_lang` VALUES ('209', '37', 'Por favor, permita o acesso Ã  sua webcam.');
INSERT INTO `site_lang` VALUES ('210', '37', 'VocÃª jÃ¡ estÃ¡ em um videocall , vocÃª tem que acabar com a outra chamada antes de iniciar outra');
INSERT INTO `site_lang` VALUES ('211', '37', 'Somente usuÃ¡rios premium pode fazer videochamadas');
INSERT INTO `site_lang` VALUES ('212', '37', 'ImpossÃ­vel fazer uma chamada!');
INSERT INTO `site_lang` VALUES ('208', '37', 'estÃ¡ offline , tente novamente quando o seu amigo estÃ¡ on-line');
INSERT INTO `site_lang` VALUES ('205', '37', 'Os seus dados serÃ£o perdidos sem recuperaÃ§Ã£o, continuar?');
INSERT INTO `site_lang` VALUES ('206', '37', 'Sim, excluÃ­-lo !');
INSERT INTO `site_lang` VALUES ('207', '37', 'estÃ¡ em outro videocall , vocÃª nÃ£o pode chamar agora');
INSERT INTO `site_lang` VALUES ('204', '37', 'Encerramento da conta');
INSERT INTO `site_lang` VALUES ('202', '37', 'Sim, comprÃ¡-lo!');
INSERT INTO `site_lang` VALUES ('203', '37', 'InformaÃ§Ã£o atualizada com sucesso');
INSERT INTO `site_lang` VALUES ('201', '37', 'mais conversaÃ§Ã£o diÃ¡ria , o custo');
INSERT INTO `site_lang` VALUES ('199', '37', 'VocÃª nÃ£o tem crÃ©ditos suficientes que para enviar o presente');
INSERT INTO `site_lang` VALUES ('200', '37', 'Expandir limitaÃ§Ã£o diÃ¡ria');
INSERT INTO `site_lang` VALUES ('198', '37', 'Por favor , selecione 1 presente');
INSERT INTO `site_lang` VALUES ('197', '37', 'Por favor , selecione uma foto');
INSERT INTO `site_lang` VALUES ('196', '37', 'Por favor , selecione um mÃ©todo de pagamento');
INSERT INTO `site_lang` VALUES ('195', '37', 'NÃ£o, obrigado');
INSERT INTO `site_lang` VALUES ('194', '37', 'Conseguir acesso');
INSERT INTO `site_lang` VALUES ('193', '37', 'fotos privadas para');
INSERT INTO `site_lang` VALUES ('192', '37', 'Tenha acesso a');
INSERT INTO `site_lang` VALUES ('191', '37', 'Compre fotos permissÃ£o privada');
INSERT INTO `site_lang` VALUES ('190', '37', 'NÃ£o, eu nÃ£o posso mostrar-lhe as minhas fotos privadas');
INSERT INTO `site_lang` VALUES ('188', '37', 'E-mail jÃ¡ existe, tente outro');
INSERT INTO `site_lang` VALUES ('189', '37', 'Sim, vocÃª pode ver as minhas fotos privadas');
INSERT INTO `site_lang` VALUES ('183', '37', 'Email nÃ£o existo');
INSERT INTO `site_lang` VALUES ('184', '37', 'Senha incorreta');
INSERT INTO `site_lang` VALUES ('185', '37', 'Adicionar uma data vÃ¡lida');
INSERT INTO `site_lang` VALUES ('186', '37', 'Escolha a cidade a partir do preenchimento automÃ¡tico');
INSERT INTO `site_lang` VALUES ('187', '37', 'Senha muito curta');
INSERT INTO `site_lang` VALUES ('182', '37', 'Por favor, preencha todos os inputs');
INSERT INTO `site_lang` VALUES ('181', '37', 'Formato de email invÃ¡lido');
INSERT INTO `site_lang` VALUES ('180', '37', 'Recuperar Senha');
INSERT INTO `site_lang` VALUES ('179', '37', 'Entre para a minha conta');
INSERT INTO `site_lang` VALUES ('178', '37', 'Se vocÃª nÃ£o lembra da sua senha , clique no link abaixo para definir uma nova:');
INSERT INTO `site_lang` VALUES ('177', '37', 'Oi');
INSERT INTO `site_lang` VALUES ('176', '37', 'NÃ£o');
INSERT INTO `site_lang` VALUES ('175', '37', 'Sim');
INSERT INTO `site_lang` VALUES ('174', '37', 'OlÃ¡, eu posso ter acesso a suas fotos privadas ?');
INSERT INTO `site_lang` VALUES ('173', '37', 'como isso');
INSERT INTO `site_lang` VALUES ('172', '37', 'mais pessoas como este');
INSERT INTO `site_lang` VALUES ('170', '37', 'Comprar');
INSERT INTO `site_lang` VALUES ('171', '37', 'Dias premium');
INSERT INTO `site_lang` VALUES ('169', '37', 'Dezembro');
INSERT INTO `site_lang` VALUES ('167', '37', 'Outubro');
INSERT INTO `site_lang` VALUES ('168', '37', 'Novembro');
INSERT INTO `site_lang` VALUES ('165', '37', 'Agosto');
INSERT INTO `site_lang` VALUES ('166', '37', 'Setembro');
INSERT INTO `site_lang` VALUES ('164', '37', 'Julho');
INSERT INTO `site_lang` VALUES ('162', '37', 'Pode');
INSERT INTO `site_lang` VALUES ('163', '37', 'Junho');
INSERT INTO `site_lang` VALUES ('161', '37', 'Abril');
INSERT INTO `site_lang` VALUES ('160', '37', 'Marcha');
INSERT INTO `site_lang` VALUES ('159', '37', 'Fevereiro');
INSERT INTO `site_lang` VALUES ('158', '37', 'Janeiro');
INSERT INTO `site_lang` VALUES ('157', '37', 'VocÃª nÃ£o tem jogos ainda');
INSERT INTO `site_lang` VALUES ('156', '37', 'VocÃª nÃ£o tem fÃ£s');
INSERT INTO `site_lang` VALUES ('155', '37', 'Nenhum membro populares perto de vocÃª');
INSERT INTO `site_lang` VALUES ('154', '37', 'pessoas acharam');
INSERT INTO `site_lang` VALUES ('153', '37', 'Nada encontrado');
INSERT INTO `site_lang` VALUES ('152', '37', 'Verificado');
INSERT INTO `site_lang` VALUES ('151', '37', 'Online agora');
INSERT INTO `site_lang` VALUES ('150', '37', 'Excluir perfil');
INSERT INTO `site_lang` VALUES ('149', '37', 'Depois de excluir o seu perfil , alguns de seus dados serÃ£o perdidos sem recuperaÃ§Ã£o .');
INSERT INTO `site_lang` VALUES ('148', '37', 'DesactivaÃ§Ã£o perfil');
INSERT INTO `site_lang` VALUES ('147', '37', 'Nova senha');
INSERT INTO `site_lang` VALUES ('146', '37', 'VocÃª pode mudar sua senha atual abaixo');
INSERT INTO `site_lang` VALUES ('145', '37', 'Mudar senha');
INSERT INTO `site_lang` VALUES ('144', '37', 'Upgrade para conta premium');
INSERT INTO `site_lang` VALUES ('143', '37', 'Adicionar crÃ©ditos');
INSERT INTO `site_lang` VALUES ('142', '37', 'CrÃ©ditos atuais');
INSERT INTO `site_lang` VALUES ('141', '37', 'Tipo de conta');
INSERT INTO `site_lang` VALUES ('140', '37', 'Comprar crÃ©ditos para enviar Gifs e Desbloquear fotos privadas');
INSERT INTO `site_lang` VALUES ('139', '37', 'EstÃ¡ conta jÃ¡ foi verificada');
INSERT INTO `site_lang` VALUES ('138', '37', 'Conectar com o Facebook');
INSERT INTO `site_lang` VALUES ('137', '37', 'Para verificar sua conta , se conectar com sua conta do Facebook');
INSERT INTO `site_lang` VALUES ('136', '37', 'Verificar conta');
INSERT INTO `site_lang` VALUES ('135', '37', 'Atualizar perfil');
INSERT INTO `site_lang` VALUES ('134', '37', 'Idioma do site');
INSERT INTO `site_lang` VALUES ('133', '37', 'VocÃª pode editar as informaÃ§Ãµes do perfil abaixo');
INSERT INTO `site_lang` VALUES ('132', '37', 'InformaÃ§Ã£o pessoal');
INSERT INTO `site_lang` VALUES ('131', '37', 'Excluir');
INSERT INTO `site_lang` VALUES ('130', '37', 'Mudar senha');
INSERT INTO `site_lang` VALUES ('129', '37', 'Verificar');
INSERT INTO `site_lang` VALUES ('128', '37', 'crÃ©ditos');
INSERT INTO `site_lang` VALUES ('127', '37', 'Pessoal');
INSERT INTO `site_lang` VALUES ('126', '37', 'Desbloquear fotos privadas');
INSERT INTO `site_lang` VALUES ('125', '37', 'PeÃ§a permissÃ£o para');
INSERT INTO `site_lang` VALUES ('124', '37', 'Agora vocÃª tem');
INSERT INTO `site_lang` VALUES ('123', '37', 'CrÃ©ditos adicionado com sucesso Ã  sua conta');
INSERT INTO `site_lang` VALUES ('122', '37', 'meninos e meninas');
INSERT INTO `site_lang` VALUES ('121', '37', 'Somente meninas');
INSERT INTO `site_lang` VALUES ('120', '37', 'SÃ³ rapazes');
INSERT INTO `site_lang` VALUES ('119', '37', 'anos');
INSERT INTO `site_lang` VALUES ('118', '37', 'InformaÃ§Ã£o pessoal');
INSERT INTO `site_lang` VALUES ('117', '37', 'Sobre');
INSERT INTO `site_lang` VALUES ('116', '37', 'A maioria dos usuÃ¡rios populares');
INSERT INTO `site_lang` VALUES ('115', '37', 'Mundo');
INSERT INTO `site_lang` VALUES ('114', '37', 'num raio de');
INSERT INTO `site_lang` VALUES ('113', '37', 'que estÃ£o entre');
INSERT INTO `site_lang` VALUES ('112', '37', 'Ambos');
INSERT INTO `site_lang` VALUES ('111', '37', 'Meninos');
INSERT INTO `site_lang` VALUES ('110', '37', 'Meninas');
INSERT INTO `site_lang` VALUES ('109', '37', 'Mostre-me');
INSERT INTO `site_lang` VALUES ('108', '37', 'Online agora');
INSERT INTO `site_lang` VALUES ('107', '37', 'Todos os usuÃ¡rios');
INSERT INTO `site_lang` VALUES ('106', '37', 'Filtro de pesquisa');
INSERT INTO `site_lang` VALUES ('105', '37', 'suas partidas');
INSERT INTO `site_lang` VALUES ('104', '37', 'Por favor, complete seu perfil antes do inÃ­cio em');
INSERT INTO `site_lang` VALUES ('103', '37', 'Termos de uso');
INSERT INTO `site_lang` VALUES ('102', '37', 'PolÃ­tica de Privacidade');
INSERT INTO `site_lang` VALUES ('101', '37', 'Seus fans');
INSERT INTO `site_lang` VALUES ('100', '37', 'ou esperar atÃ© amanhÃ£ para continuar a atender as pessoas');
INSERT INTO `site_lang` VALUES ('99', '37', 'conversas diÃ¡rias');
INSERT INTO `site_lang` VALUES ('98', '37', 'e chegar atÃ© a');
INSERT INTO `site_lang` VALUES ('97', '37', 'Atualizar sua conta para premium');
INSERT INTO `site_lang` VALUES ('96', '37', 'ou');
INSERT INTO `site_lang` VALUES ('95', '37', 'mais conversaÃ§Ã£o diÃ¡ria');
INSERT INTO `site_lang` VALUES ('94', '37', 'Comprar');
INSERT INTO `site_lang` VALUES ('93', '37', 'Para continuar conversando');
INSERT INTO `site_lang` VALUES ('92', '37', 'de ter atingido o limite de novas conversas diÃ¡rias');
INSERT INTO `site_lang` VALUES ('91', '37', 'Chat');
INSERT INTO `site_lang` VALUES ('90', '37', 'Enviar');
INSERT INTO `site_lang` VALUES ('89', '37', 'Escrever o texto aqui');
INSERT INTO `site_lang` VALUES ('88', '37', 'Badge usuÃ¡rio premium');
INSERT INTO `site_lang` VALUES ('87', '37', 'Desbloquear todas as fotos privadas');
INSERT INTO `site_lang` VALUES ('86', '37', 'VÃ­deochamadas ilimitadas');
INSERT INTO `site_lang` VALUES ('85', '37', 'novos chats por dia');
INSERT INTO `site_lang` VALUES ('84', '37', 'Recursos da conta premium');
INSERT INTO `site_lang` VALUES ('83', '37', 'Comprar crÃ©ditos');
INSERT INTO `site_lang` VALUES ('82', '37', 'Pagar com');
INSERT INTO `site_lang` VALUES ('81', '37', 'Pagar com');
INSERT INTO `site_lang` VALUES ('80', '37', 'Selecione o mÃ©todo de pagamento');
INSERT INTO `site_lang` VALUES ('79', '37', 'Pacote selecione crÃ©ditos');
INSERT INTO `site_lang` VALUES ('78', '37', 'Comprar crÃ©ditos / Upgrade conta');
INSERT INTO `site_lang` VALUES ('77', '37', 'Enviar presente');
INSERT INTO `site_lang` VALUES ('76', '37', 'Escolha o presente que vocÃª deseja enviar para');
INSERT INTO `site_lang` VALUES ('67', '37', 'Fotos pÃºblicas');
INSERT INTO `site_lang` VALUES ('68', '37', 'Fotos privadas');
INSERT INTO `site_lang` VALUES ('69', '37', 'Adicione suas fotos');
INSERT INTO `site_lang` VALUES ('70', '37', 'adicionar fotos');
INSERT INTO `site_lang` VALUES ('71', '37', 'Adicione-se ao Spotlight');
INSERT INTO `site_lang` VALUES ('72', '37', 'Escolha a foto que vocÃª quer mostrar em destaque , o custo');
INSERT INTO `site_lang` VALUES ('73', '37', 'CrÃ©ditos');
INSERT INTO `site_lang` VALUES ('74', '37', 'Adicione a foto');
INSERT INTO `site_lang` VALUES ('75', '37', 'Envie um presente para');
INSERT INTO `site_lang` VALUES ('65', '37', 'Gerencie suas fotos');
INSERT INTO `site_lang` VALUES ('66', '37', 'Todas as fotos');
INSERT INTO `site_lang` VALUES ('63', '37', 'Privacidade');
INSERT INTO `site_lang` VALUES ('64', '37', 'Contato');
INSERT INTO `site_lang` VALUES ('62', '37', 'CondiÃ§Ãµes');
INSERT INTO `site_lang` VALUES ('61', '37', 'Quem gostar');
INSERT INTO `site_lang` VALUES ('59', '37', 'Online agora');
INSERT INTO `site_lang` VALUES ('60', '37', 'Novas mensagens');
INSERT INTO `site_lang` VALUES ('58', '37', 'ConversaÃ§Ãµes');
INSERT INTO `site_lang` VALUES ('56', '37', 'Todos');
INSERT INTO `site_lang` VALUES ('57', '37', 'Fans');
INSERT INTO `site_lang` VALUES ('55', '37', 'ConfiguraÃ§Ãµes');
INSERT INTO `site_lang` VALUES ('53', '37', 'Fans');
INSERT INTO `site_lang` VALUES ('54', '37', 'Gerir fotografias');
INSERT INTO `site_lang` VALUES ('51', '37', 'Partidas');
INSERT INTO `site_lang` VALUES ('52', '37', 'A maioria dos populars');
INSERT INTO `site_lang` VALUES ('49', '37', 'ConheÃ§a novas pessoas');
INSERT INTO `site_lang` VALUES ('50', '37', 'Descobrir');
INSERT INTO `site_lang` VALUES ('47', '37', 'ConfiguraÃ§Ãµes');
INSERT INTO `site_lang` VALUES ('48', '37', 'Sair');
INSERT INTO `site_lang` VALUES ('46', '37', 'Perfil');
INSERT INTO `site_lang` VALUES ('45', '37', 'PolÃ­tica de Privacidade');
INSERT INTO `site_lang` VALUES ('44', '37', 'e');
INSERT INTO `site_lang` VALUES ('384', '2', 'Ok, entiendo');
INSERT INTO `site_lang` VALUES ('383', '1', 'must like you for start a videocall');
INSERT INTO `site_lang` VALUES ('381', '2', 'llamando...');
INSERT INTO `site_lang` VALUES ('383', '2', 'tiene que gustar de ti para poder empezar una videollamda');
INSERT INTO `site_lang` VALUES ('384', '1', 'Ok, i understand');
INSERT INTO `site_lang` VALUES ('25', '37', 'Junte-se aos mundos comunidade bestest para conhecer novas pessoas !.');
INSERT INTO `site_lang` VALUES ('20', '37', 'Pessoas prÃ³ximas');
INSERT INTO `site_lang` VALUES ('19', '37', 'VocÃª pode fazer videochamadas qualidade para livre para qualquer pessoa, sem limite de duraÃ§Ã£o da chamada , basta gostar de ver a pessoa que estÃ¡ conversando com vocÃª');
INSERT INTO `site_lang` VALUES ('379', '43', 'GÃ¥ till');
INSERT INTO `site_lang` VALUES ('380', '43', 'VÃ¤lkommen till');
INSERT INTO `site_lang` VALUES ('378', '43', 'Spara din anslutningsinformation pÃ¥ en sÃ¤ker plats');
INSERT INTO `site_lang` VALUES ('377', '43', 'LÃ¶senord');
INSERT INTO `site_lang` VALUES ('376', '43', 'E-mail');
INSERT INTO `site_lang` VALUES ('375', '43', 'HÃ¤r Ã¤r din anslutningsinformation');
INSERT INTO `site_lang` VALUES ('374', '43', 'BÃ¶rja trÃ¤ffa nya mÃ¤nniskor nu');
INSERT INTO `site_lang` VALUES ('373', '43', 'Mer Ã¤n 1 miljon mÃ¤nniskor har anslutit sig till $ SITE_NAME Du vill fÃ¶rmodligen kÃ¤nna nÃ¥gra av dem .');
INSERT INTO `site_lang` VALUES ('372', '43', 'LÃ¤gg till foton och slutfÃ¶ra din profil');
INSERT INTO `site_lang` VALUES ('371', '43', 'Ingen kommer att bli kÃ¤r i en tom sida . Ju mer information du fÃ¥r, desto fler chanser att hitta den dÃ¤r speciella nÃ¥gon !');
INSERT INTO `site_lang` VALUES ('370', '43', 'TrÃ¤ffa nya mÃ¤nniskor');
INSERT INTO `site_lang` VALUES ('369', '43', 'du kan trÃ¤ffa mÃ¤nniskor omedelbart');
INSERT INTO `site_lang` VALUES ('368', '43', 'I');
INSERT INTO `site_lang` VALUES ('366', '43', 'nyttmeddelande');
INSERT INTO `site_lang` VALUES ('367', '43', 'mÃ¤nniskor i ditt omrÃ¥de vill lÃ¤ra kÃ¤nna dig');
INSERT INTO `site_lang` VALUES ('365', '43', 'Verifiera ditt konto');
INSERT INTO `site_lang` VALUES ('364', '43', 'Nu Ã¤r du en ny medlem av');
INSERT INTO `site_lang` VALUES ('362', '43', 'Bra gjort , nu Ã¤r du i');
INSERT INTO `site_lang` VALUES ('363', '43', 'HÃ¤r Ã¤r nÃ¥gra tips');
INSERT INTO `site_lang` VALUES ('361', '43', 'VÃ¤lkommen');
INSERT INTO `site_lang` VALUES ('360', '43', 'Kolla in profil');
INSERT INTO `site_lang` VALUES ('359', '43', 'och bor nÃ¤rmare dig');
INSERT INTO `site_lang` VALUES ('357', '43', 'Ã¤r ny och bor nÃ¤rmare dig');
INSERT INTO `site_lang` VALUES ('358', '43', 'Ã¤r ny pÃ¥');
INSERT INTO `site_lang` VALUES ('356', '43', 'Ha sÃ¥ kul!');
INSERT INTO `site_lang` VALUES ('355', '43', 'Svara till');
INSERT INTO `site_lang` VALUES ('354', '43', 'du har ett nytt meddelande frÃ¥n');
INSERT INTO `site_lang` VALUES ('353', '43', 'Nytt meddelande frÃ¥n');
INSERT INTO `site_lang` VALUES ('352', '43', 'GÃ¥ och sÃ¤ga nÃ¥got till');
INSERT INTO `site_lang` VALUES ('351', '43', 'tror att kÃ¤nslan Ã¤r Ã¶msesidig');
INSERT INTO `site_lang` VALUES ('350', '43', 'Det Ã¤r en match!');
INSERT INTO `site_lang` VALUES ('349', '43', 'Du har en match pÃ¥');
INSERT INTO `site_lang` VALUES ('348', '43', 'Om du har glÃ¶mt ditt lÃ¶senord , klicka pÃ¥ lÃ¤nken nedan fÃ¶r att fÃ¥ en ny');
INSERT INTO `site_lang` VALUES ('347', '43', 'VÃ¤lj ett nytt lÃ¶senord');
INSERT INTO `site_lang` VALUES ('346', '43', 'Avsluta prenumeration');
INSERT INTO `site_lang` VALUES ('345', '43', 'Du har fÃ¥tt detta meddelande eftersom du Ã¤r registrerad som');
INSERT INTO `site_lang` VALUES ('344', '43', 'Ta reda pÃ¥ om du ocksÃ¥');
INSERT INTO `site_lang` VALUES ('343', '43', 'har sett dig i att upptÃ¤cka och gillar . KÃ¤nslan Ã¤r Ã¶msesidig?');
INSERT INTO `site_lang` VALUES ('342', '43', 'gillar dig och vill prata i');
INSERT INTO `site_lang` VALUES ('380', '27', 'Benvenuti');
INSERT INTO `site_lang` VALUES ('379', '27', 'Andare');
INSERT INTO `site_lang` VALUES ('378', '27', 'Si prega di salvare le informazioni di accesso in un luogo sicuro');
INSERT INTO `site_lang` VALUES ('377', '27', 'Password');
INSERT INTO `site_lang` VALUES ('375', '27', 'Ecco i dettagli della tua connessione');
INSERT INTO `site_lang` VALUES ('376', '27', 'E-mail');
INSERT INTO `site_lang` VALUES ('341', '13', 'Wij sturen u een e-mail met uw info , kan het tot 1 minuut aan te komen');
INSERT INTO `site_lang` VALUES ('338', '13', 'Foto&#039;s van');
INSERT INTO `site_lang` VALUES ('339', '13', 'van');
INSERT INTO `site_lang` VALUES ('340', '13', 'Loading ...');
INSERT INTO `site_lang` VALUES ('337', '13', 'belt u ..');
INSERT INTO `site_lang` VALUES ('336', '13', 'Wachtwoord succesvol veranderd');
INSERT INTO `site_lang` VALUES ('335', '13', 'Diensttijd');
INSERT INTO `site_lang` VALUES ('334', '13', 'Spotlight');
INSERT INTO `site_lang` VALUES ('332', '13', 'dagen van Premium');
INSERT INTO `site_lang` VALUES ('330', '13', 'U moet uw gebruikersnaam schrijven !');
INSERT INTO `site_lang` VALUES ('333', '13', 'Fout');
INSERT INTO `site_lang` VALUES ('331', '13', 'gebruikersnaam');
INSERT INTO `site_lang` VALUES ('329', '13', 'Schrijf je Instagram gebruikersnaam');
INSERT INTO `site_lang` VALUES ('327', '13', 'Weet u zeker dat u wilt melden');
INSERT INTO `site_lang` VALUES ('328', '13', 'Druk op backspace-toets voor slimme terugkeer naar de afdelingsvergadering .');
INSERT INTO `site_lang` VALUES ('326', '13', 'Verslag en blok');
INSERT INTO `site_lang` VALUES ('325', '13', 'blokkeert u of u hem geblokkeerd , je kan chatten met hem spijt');
INSERT INTO `site_lang` VALUES ('324', '13', 'We stuurde u een e-mail te controleren uw account');
INSERT INTO `site_lang` VALUES ('323', '13', 'jaar oud en im uit');
INSERT INTO `site_lang` VALUES ('322', '13', 'Hoi ik ben');
INSERT INTO `site_lang` VALUES ('321', '13', 'Voeg dan een profielfoto');
INSERT INTO `site_lang` VALUES ('320', '13', 'Controleer uw account , controleert u uw e-mail');
INSERT INTO `site_lang` VALUES ('318', '13', 'seconden');
INSERT INTO `site_lang` VALUES ('319', '13', 'ago');
INSERT INTO `site_lang` VALUES ('317', '13', 'notulen');
INSERT INTO `site_lang` VALUES ('315', '13', 'dagen');
INSERT INTO `site_lang` VALUES ('316', '13', 'uur');
INSERT INTO `site_lang` VALUES ('314', '13', 'maanden');
INSERT INTO `site_lang` VALUES ('312', '13', 'tweede');
INSERT INTO `site_lang` VALUES ('313', '13', 'jaar');
INSERT INTO `site_lang` VALUES ('311', '13', 'minuut');
INSERT INTO `site_lang` VALUES ('310', '13', 'uur');
INSERT INTO `site_lang` VALUES ('309', '13', 'dag');
INSERT INTO `site_lang` VALUES ('306', '13', '0 seconden');
INSERT INTO `site_lang` VALUES ('307', '13', 'jaar');
INSERT INTO `site_lang` VALUES ('308', '13', 'maand');
INSERT INTO `site_lang` VALUES ('304', '13', 'Kosten');
INSERT INTO `site_lang` VALUES ('305', '13', 'Credits voor $');
INSERT INTO `site_lang` VALUES ('303', '13', 'Je houdt niet van iedereen');
INSERT INTO `site_lang` VALUES ('302', '13', 'bezocht');
INSERT INTO `site_lang` VALUES ('301', '13', 'U moet niet nog geen bezoek');
INSERT INTO `site_lang` VALUES ('300', '13', 'LEEFTIJD');
INSERT INTO `site_lang` VALUES ('298', '13', 'Als');
INSERT INTO `site_lang` VALUES ('299', '13', 'Afkeer');
INSERT INTO `site_lang` VALUES ('297', '13', 'Berichten');
INSERT INTO `site_lang` VALUES ('296', '13', 'mensen vonden je , voor hen zien');
INSERT INTO `site_lang` VALUES ('295', '13', 'Mensen die ik graag');
INSERT INTO `site_lang` VALUES ('294', '13', 'Upgrade uw account om premium');
INSERT INTO `site_lang` VALUES ('292', '13', 'Verwijder');
INSERT INTO `site_lang` VALUES ('293', '13', 'mensen bezochten uw profiel voor hen zien');
INSERT INTO `site_lang` VALUES ('291', '13', 'Openbare foto');
INSERT INTO `site_lang` VALUES ('290', '13', 'PrivÃ©- foto');
INSERT INTO `site_lang` VALUES ('289', '13', 'Instellen als profielfoto');
INSERT INTO `site_lang` VALUES ('286', '13', 'Bezoeken');
INSERT INTO `site_lang` VALUES ('287', '13', 'Voeg me hier toe');
INSERT INTO `site_lang` VALUES ('288', '13', 'word gezien door miljoenen');
INSERT INTO `site_lang` VALUES ('285', '13', 'Credits');
INSERT INTO `site_lang` VALUES ('284', '13', 'Foto&#039;s');
INSERT INTO `site_lang` VALUES ('283', '13', 'Toevoegen');
INSERT INTO `site_lang` VALUES ('282', '13', 'toevoegen uit');
INSERT INTO `site_lang` VALUES ('281', '13', 'PrivÃ©- foto&#039;s');
INSERT INTO `site_lang` VALUES ('280', '13', 'Openbare foto&#039;s');
INSERT INTO `site_lang` VALUES ('279', '13', 'Geen gegevens');
INSERT INTO `site_lang` VALUES ('278', '13', 'Fans');
INSERT INTO `site_lang` VALUES ('277', '13', 'Rapport');
INSERT INTO `site_lang` VALUES ('276', '13', 'Interesses');
INSERT INTO `site_lang` VALUES ('275', '13', 'Even geduld aub');
INSERT INTO `site_lang` VALUES ('274', '13', 'Jaar');
INSERT INTO `site_lang` VALUES ('273', '13', 'Maand');
INSERT INTO `site_lang` VALUES ('272', '13', 'Dag');
INSERT INTO `site_lang` VALUES ('271', '13', 'Als iemand me een bericht verzenden');
INSERT INTO `site_lang` VALUES ('270', '13', 'Wanneer nieuwe gebruikers bij mij mee');
INSERT INTO `site_lang` VALUES ('269', '13', 'Wanneer ik een match');
INSERT INTO `site_lang` VALUES ('268', '13', 'Als iemand houdt van me');
INSERT INTO `site_lang` VALUES ('267', '13', 'Geen');
INSERT INTO `site_lang` VALUES ('266', '13', 'Ik ben eigenaar van een motor');
INSERT INTO `site_lang` VALUES ('265', '13', 'Ik heb een auto');
INSERT INTO `site_lang` VALUES ('264', '13', 'ouders auto');
INSERT INTO `site_lang` VALUES ('263', '13', 'Vervoer');
INSERT INTO `site_lang` VALUES ('255', '13', 'Studenten slaapzaal');
INSERT INTO `site_lang` VALUES ('256', '13', 'Met partner');
INSERT INTO `site_lang` VALUES ('257', '13', 'Alleen');
INSERT INTO `site_lang` VALUES ('258', '13', 'Rook');
INSERT INTO `site_lang` VALUES ('259', '13', 'Ja');
INSERT INTO `site_lang` VALUES ('260', '13', 'Nee');
INSERT INTO `site_lang` VALUES ('261', '13', 'Soms');
INSERT INTO `site_lang` VALUES ('262', '13', 'Drinken');
INSERT INTO `site_lang` VALUES ('254', '13', 'Met pWith housematearents');
INSERT INTO `site_lang` VALUES ('250', '13', 'Zware set');
INSERT INTO `site_lang` VALUES ('251', '13', 'Curvy');
INSERT INTO `site_lang` VALUES ('252', '13', 'Leven');
INSERT INTO `site_lang` VALUES ('253', '13', 'Met ouders');
INSERT INTO `site_lang` VALUES ('243', '13', 'Pacific Islander');
INSERT INTO `site_lang` VALUES ('244', '13', 'Indiaas');
INSERT INTO `site_lang` VALUES ('245', '13', 'anders');
INSERT INTO `site_lang` VALUES ('246', '13', 'Lichaamstype');
INSERT INTO `site_lang` VALUES ('247', '13', 'Slank');
INSERT INTO `site_lang` VALUES ('248', '13', 'Gemiddelde');
INSERT INTO `site_lang` VALUES ('249', '13', 'Atletisch');
INSERT INTO `site_lang` VALUES ('239', '13', 'Zwart');
INSERT INTO `site_lang` VALUES ('240', '13', 'Wit');
INSERT INTO `site_lang` VALUES ('241', '13', 'Indiaan');
INSERT INTO `site_lang` VALUES ('242', '13', 'Hispanic / latin');
INSERT INTO `site_lang` VALUES ('237', '13', 'Aziatisch');
INSERT INTO `site_lang` VALUES ('238', '13', 'Midden Oosten');
INSERT INTO `site_lang` VALUES ('224', '13', 'Single');
INSERT INTO `site_lang` VALUES ('225', '13', 'Ingenomen');
INSERT INTO `site_lang` VALUES ('226', '13', 'Open');
INSERT INTO `site_lang` VALUES ('227', '13', 'Seksualiteit');
INSERT INTO `site_lang` VALUES ('228', '13', 'homoseksueel');
INSERT INTO `site_lang` VALUES ('229', '13', 'Ruimdenkende');
INSERT INTO `site_lang` VALUES ('230', '13', 'Rechtdoor');
INSERT INTO `site_lang` VALUES ('231', '13', 'Bisexual');
INSERT INTO `site_lang` VALUES ('232', '13', 'Hoogte');
INSERT INTO `site_lang` VALUES ('233', '13', 'minder dan');
INSERT INTO `site_lang` VALUES ('234', '13', 'meer dan');
INSERT INTO `site_lang` VALUES ('235', '13', 'Gewicht');
INSERT INTO `site_lang` VALUES ('236', '13', 'Afkomst');
INSERT INTO `site_lang` VALUES ('223', '13', 'Verwantschap');
INSERT INTO `site_lang` VALUES ('222', '13', 'Uitgebreide info ( optioneel)');
INSERT INTO `site_lang` VALUES ('221', '13', 'Meldingen');
INSERT INTO `site_lang` VALUES ('220', '13', 'UPGRADE');
INSERT INTO `site_lang` VALUES ('219', '13', 'Basis');
INSERT INTO `site_lang` VALUES ('218', '13', 'tot');
INSERT INTO `site_lang` VALUES ('217', '13', 'Wacht meer');
INSERT INTO `site_lang` VALUES ('216', '13', 'Ophangen');
INSERT INTO `site_lang` VALUES ('214', '13', 'Te lang wachten');
INSERT INTO `site_lang` VALUES ('215', '13', 'Het lijkt erop dat je vriend geen webcam hebt of hij is niet beschikbaar');
INSERT INTO `site_lang` VALUES ('213', '13', 'You cant videocall te maken, omdat je niet hoeft webcam');
INSERT INTO `site_lang` VALUES ('212', '13', 'Onmogelijk om te bellen !');
INSERT INTO `site_lang` VALUES ('207', '13', 'is in een ander videocall , je kan nu een beroep');
INSERT INTO `site_lang` VALUES ('208', '13', 'is offline , probeer het opnieuw wanneer je vriend is online');
INSERT INTO `site_lang` VALUES ('211', '13', 'Alleen premium gebruikers kunnen videobellen');
INSERT INTO `site_lang` VALUES ('210', '13', 'Je bent al in een videocall , moet u het andere gesprek te beÃ«indigen voordat een andere start');
INSERT INTO `site_lang` VALUES ('209', '13', 'Houd rekening met de toegang tot uw webcam .');
INSERT INTO `site_lang` VALUES ('206', '13', 'Ja, verwijder het!');
INSERT INTO `site_lang` VALUES ('205', '13', 'Uw gegevens worden verloren zonder herstel, voort te zetten ?');
INSERT INTO `site_lang` VALUES ('204', '13', 'beÃ«indiging van het account');
INSERT INTO `site_lang` VALUES ('203', '13', 'Informatie bijgewerkt');
INSERT INTO `site_lang` VALUES ('202', '13', 'Ja, kopen!');
INSERT INTO `site_lang` VALUES ('201', '13', 'meer dagelijkse gesprek, kosten');
INSERT INTO `site_lang` VALUES ('200', '13', 'Expand dagelijkse beperking');
INSERT INTO `site_lang` VALUES ('199', '13', 'Je hoeft niet genoeg credits voor verzenden van de gift');
INSERT INTO `site_lang` VALUES ('198', '13', 'Alstublieft, selecteer 1 gift');
INSERT INTO `site_lang` VALUES ('197', '13', 'Alstublieft, selecteer 1 foto');
INSERT INTO `site_lang` VALUES ('192', '13', 'Krijg toegang tot');
INSERT INTO `site_lang` VALUES ('196', '13', 'Alstublieft, selecteer een betaalmethode');
INSERT INTO `site_lang` VALUES ('195', '13', 'Nee, dank u wel');
INSERT INTO `site_lang` VALUES ('194', '13', 'Toegang krijgen');
INSERT INTO `site_lang` VALUES ('193', '13', 'privÃ©foto&#039;s voor');
INSERT INTO `site_lang` VALUES ('191', '13', 'Koop privÃ©foto&#039;s toestemming');
INSERT INTO `site_lang` VALUES ('190', '13', 'Nee, ik kan je laten zien mijn privÃ©- foto&#039;s');
INSERT INTO `site_lang` VALUES ('189', '13', 'Ja, je kunt mijn privÃ©- foto&#039;s te zien');
INSERT INTO `site_lang` VALUES ('188', '13', 'E-mail al bestaan â€‹â€‹, probeer dan een andere');
INSERT INTO `site_lang` VALUES ('187', '13', 'Wachtwoord te kort');
INSERT INTO `site_lang` VALUES ('186', '13', 'Kies stad uit de autocomplete');
INSERT INTO `site_lang` VALUES ('185', '13', 'Voeg een geldige datum');
INSERT INTO `site_lang` VALUES ('184', '13', 'Verkeerd wachtwoord');
INSERT INTO `site_lang` VALUES ('183', '13', 'E-mail besta');
INSERT INTO `site_lang` VALUES ('182', '13', 'Vul alle ingangen');
INSERT INTO `site_lang` VALUES ('181', '13', 'Ongeldige email formaat');
INSERT INTO `site_lang` VALUES ('180', '13', 'Wachtwoord herstellen');
INSERT INTO `site_lang` VALUES ('179', '13', 'Inloggen op mijn account');
INSERT INTO `site_lang` VALUES ('178', '13', 'Als u niet vergeet niet uw wachtwoord , klik op de link hieronder om een â€‹â€‹nieuwe set :');
INSERT INTO `site_lang` VALUES ('177', '13', 'Hoi');
INSERT INTO `site_lang` VALUES ('176', '13', 'Nee');
INSERT INTO `site_lang` VALUES ('175', '13', 'Ja');
INSERT INTO `site_lang` VALUES ('174', '13', 'Hallo, kan ik toegang hebben tot uw persoonlijke foto&#039;s?');
INSERT INTO `site_lang` VALUES ('173', '13', 'Soortgelijk');
INSERT INTO `site_lang` VALUES ('172', '13', 'Personen meer zoals deze');
INSERT INTO `site_lang` VALUES ('171', '13', 'Dagen Premium');
INSERT INTO `site_lang` VALUES ('170', '13', 'Kopen');
INSERT INTO `site_lang` VALUES ('169', '13', 'December');
INSERT INTO `site_lang` VALUES ('168', '13', 'November');
INSERT INTO `site_lang` VALUES ('167', '13', 'Oktober');
INSERT INTO `site_lang` VALUES ('166', '13', 'September');
INSERT INTO `site_lang` VALUES ('165', '13', 'Augustus');
INSERT INTO `site_lang` VALUES ('164', '13', 'Juli-');
INSERT INTO `site_lang` VALUES ('163', '13', 'Juni-');
INSERT INTO `site_lang` VALUES ('162', '13', 'Mei');
INSERT INTO `site_lang` VALUES ('161', '13', 'April');
INSERT INTO `site_lang` VALUES ('160', '13', 'Maart');
INSERT INTO `site_lang` VALUES ('159', '13', 'Februari');
INSERT INTO `site_lang` VALUES ('158', '13', 'Januari-');
INSERT INTO `site_lang` VALUES ('157', '13', 'U moet niet nog wedstrijden');
INSERT INTO `site_lang` VALUES ('155', '13', 'Geen populaire gebruikers in uw buurt');
INSERT INTO `site_lang` VALUES ('156', '13', 'U moet niet nog geen fans');
INSERT INTO `site_lang` VALUES ('154', '13', 'Mensen gevonden');
INSERT INTO `site_lang` VALUES ('153', '13', 'Niets gevonden');
INSERT INTO `site_lang` VALUES ('152', '13', 'Geverifieerd');
INSERT INTO `site_lang` VALUES ('151', '13', 'Nu online');
INSERT INTO `site_lang` VALUES ('150', '13', 'Verwijder profiel');
INSERT INTO `site_lang` VALUES ('149', '13', 'Nadat je profiel verwijdert, zal een deel van uw gegevens verloren gaan zonder herstel .');
INSERT INTO `site_lang` VALUES ('148', '13', 'Profiel desactivering');
INSERT INTO `site_lang` VALUES ('147', '13', 'Nieuw paswoord');
INSERT INTO `site_lang` VALUES ('146', '13', 'U kunt uw huidige wachtwoord te wijzigen blaten');
INSERT INTO `site_lang` VALUES ('145', '13', 'Verander wachtwoord');
INSERT INTO `site_lang` VALUES ('144', '13', 'Upgrade naar premium account');
INSERT INTO `site_lang` VALUES ('143', '13', 'Credits toevoegen');
INSERT INTO `site_lang` VALUES ('142', '13', 'Huidige credits');
INSERT INTO `site_lang` VALUES ('141', '13', 'Account type');
INSERT INTO `site_lang` VALUES ('140', '13', 'Koop credits voor send Gif en deblokkeren privÃ©foto&#039;s');
INSERT INTO `site_lang` VALUES ('139', '13', 'U bent account is al geverifieerd');
INSERT INTO `site_lang` VALUES ('138', '13', 'Verbinden met Facebook');
INSERT INTO `site_lang` VALUES ('137', '13', 'Voor controleren van uw account , te verbinden met je Facebook -account');
INSERT INTO `site_lang` VALUES ('136', '13', 'Account verifiÃ«ren');
INSERT INTO `site_lang` VALUES ('135', '13', 'Profiel bijwerken');
INSERT INTO `site_lang` VALUES ('134', '13', 'Site taal');
INSERT INTO `site_lang` VALUES ('133', '13', 'U kunt uw profiel informatie hieronder te bewerken');
INSERT INTO `site_lang` VALUES ('132', '13', 'Persoonlijke informatie');
INSERT INTO `site_lang` VALUES ('131', '13', 'Verwijder');
INSERT INTO `site_lang` VALUES ('130', '13', 'Verander wachtwoord');
INSERT INTO `site_lang` VALUES ('129', '13', 'VerifiÃ«ren');
INSERT INTO `site_lang` VALUES ('128', '13', 'Credits');
INSERT INTO `site_lang` VALUES ('127', '13', 'Persoonlijk');
INSERT INTO `site_lang` VALUES ('126', '13', 'Deblokkeren privÃ©foto&#039;s');
INSERT INTO `site_lang` VALUES ('125', '13', 'Vraag toestemming om');
INSERT INTO `site_lang` VALUES ('124', '13', 'Nu heb je');
INSERT INTO `site_lang` VALUES ('118', '13', 'Persoonlijke informatie');
INSERT INTO `site_lang` VALUES ('119', '13', 'Jaar oud');
INSERT INTO `site_lang` VALUES ('120', '13', 'Alleen jongens');
INSERT INTO `site_lang` VALUES ('121', '13', 'Alleen meisjes');
INSERT INTO `site_lang` VALUES ('122', '13', 'jongens en meisjes');
INSERT INTO `site_lang` VALUES ('123', '13', 'Credits succesvol toegevoegd aan uw account');
INSERT INTO `site_lang` VALUES ('112', '13', 'Beide');
INSERT INTO `site_lang` VALUES ('113', '13', 'die tussen');
INSERT INTO `site_lang` VALUES ('114', '13', 'in een straal van');
INSERT INTO `site_lang` VALUES ('115', '13', 'Wereld');
INSERT INTO `site_lang` VALUES ('116', '13', 'Meest populaire gebruikers');
INSERT INTO `site_lang` VALUES ('117', '13', 'Over');
INSERT INTO `site_lang` VALUES ('108', '13', 'Nu online');
INSERT INTO `site_lang` VALUES ('109', '13', 'Laat het me zien');
INSERT INTO `site_lang` VALUES ('110', '13', 'Meisjes');
INSERT INTO `site_lang` VALUES ('111', '13', 'Jongens');
INSERT INTO `site_lang` VALUES ('107', '13', 'Alle gebruikers');
INSERT INTO `site_lang` VALUES ('105', '13', 'je wedstrijden');
INSERT INTO `site_lang` VALUES ('106', '13', 'Filter Zoeken');
INSERT INTO `site_lang` VALUES ('101', '13', 'Je fans');
INSERT INTO `site_lang` VALUES ('102', '13', 'Privacybeleid');
INSERT INTO `site_lang` VALUES ('103', '13', 'Gebruiksvoorwaarden');
INSERT INTO `site_lang` VALUES ('104', '13', 'Gelieve uw profiel voltooien voordat start in');
INSERT INTO `site_lang` VALUES ('97', '13', 'Upgrade uw account Premium');
INSERT INTO `site_lang` VALUES ('98', '13', 'en krijg tot');
INSERT INTO `site_lang` VALUES ('99', '13', 'dagelijkse gesprekken');
INSERT INTO `site_lang` VALUES ('100', '13', 'of wachten tot morgen voor het blijven voldoen aan de mensen');
INSERT INTO `site_lang` VALUES ('96', '13', 'of');
INSERT INTO `site_lang` VALUES ('95', '13', 'meer dagelijkse conversatie');
INSERT INTO `site_lang` VALUES ('94', '13', 'Kopen');
INSERT INTO `site_lang` VALUES ('93', '13', 'Om door te gaan chatten');
INSERT INTO `site_lang` VALUES ('91', '13', 'Chat');
INSERT INTO `site_lang` VALUES ('92', '13', 'u de limiet van de nieuwe dagelijkse gesprekken hebben bereikt');
INSERT INTO `site_lang` VALUES ('90', '13', 'Sturen');
INSERT INTO `site_lang` VALUES ('89', '13', 'Schrijf tekst hier');
INSERT INTO `site_lang` VALUES ('87', '13', 'Deblokkeren alle particuliere foto&#039;s');
INSERT INTO `site_lang` VALUES ('88', '13', 'Premium gebruiker badge');
INSERT INTO `site_lang` VALUES ('86', '13', 'onbeperkt videobellen');
INSERT INTO `site_lang` VALUES ('83', '13', 'Koop credits');
INSERT INTO `site_lang` VALUES ('84', '13', 'Premium Account Features');
INSERT INTO `site_lang` VALUES ('85', '13', 'nieuwe chats per dag');
INSERT INTO `site_lang` VALUES ('82', '13', 'Betaal met');
INSERT INTO `site_lang` VALUES ('81', '13', 'Betaal');
INSERT INTO `site_lang` VALUES ('80', '13', 'Selecteer betaalmethode');
INSERT INTO `site_lang` VALUES ('79', '13', 'Selecteer credits pakket');
INSERT INTO `site_lang` VALUES ('78', '13', 'Koop kredieten / Upgrade -account');
INSERT INTO `site_lang` VALUES ('77', '13', 'Stuur cadeau');
INSERT INTO `site_lang` VALUES ('76', '13', 'Pluk het geschenk dat u wilt verzenden naar');
INSERT INTO `site_lang` VALUES ('75', '13', 'Stuur geschenk aan');
INSERT INTO `site_lang` VALUES ('74', '13', 'Voeg foto toe');
INSERT INTO `site_lang` VALUES ('73', '13', 'Credits');
INSERT INTO `site_lang` VALUES ('72', '13', 'Kies de foto die u wilt zien in de Spotlight , kosten');
INSERT INTO `site_lang` VALUES ('71', '13', 'Voeg je toe aan de Spotlight');
INSERT INTO `site_lang` VALUES ('70', '13', 'Voeg foto&#039;s toe');
INSERT INTO `site_lang` VALUES ('69', '13', 'Voeg uw foto&#039;s');
INSERT INTO `site_lang` VALUES ('68', '13', 'PrivÃ©-foto&#039;s');
INSERT INTO `site_lang` VALUES ('67', '13', 'Openbare foto&#039;s');
INSERT INTO `site_lang` VALUES ('66', '13', 'Alle foto&#039;s');
INSERT INTO `site_lang` VALUES ('65', '13', 'Beheer');
INSERT INTO `site_lang` VALUES ('64', '13', 'Contact');
INSERT INTO `site_lang` VALUES ('63', '13', 'Privacy');
INSERT INTO `site_lang` VALUES ('62', '13', 'Voorwaarden');
INSERT INTO `site_lang` VALUES ('61', '13', 'Wie te willen');
INSERT INTO `site_lang` VALUES ('60', '13', 'Nieuwe berichten');
INSERT INTO `site_lang` VALUES ('59', '13', 'Nu online');
INSERT INTO `site_lang` VALUES ('58', '13', 'Conversaties');
INSERT INTO `site_lang` VALUES ('57', '13', 'Fans');
INSERT INTO `site_lang` VALUES ('55', '13', 'Instellingen');
INSERT INTO `site_lang` VALUES ('56', '13', 'Alle');
INSERT INTO `site_lang` VALUES ('53', '13', 'Fans');
INSERT INTO `site_lang` VALUES ('54', '13', 'foto&#039;s beheren');
INSERT INTO `site_lang` VALUES ('52', '13', 'De meeste populars');
INSERT INTO `site_lang` VALUES ('51', '13', 'lucifers');
INSERT INTO `site_lang` VALUES ('50', '13', 'Ontdekken');
INSERT INTO `site_lang` VALUES ('49', '13', 'Nieuwe mensen ontmoeten');
INSERT INTO `site_lang` VALUES ('48', '13', 'Uitloggen');
INSERT INTO `site_lang` VALUES ('47', '13', 'Instellingen');
INSERT INTO `site_lang` VALUES ('43', '13', 'Voorwaarden');
INSERT INTO `site_lang` VALUES ('44', '13', 'en');
INSERT INTO `site_lang` VALUES ('45', '13', 'Privacybeleid');
INSERT INTO `site_lang` VALUES ('46', '13', 'Profiel');
INSERT INTO `site_lang` VALUES ('41', '13', 'Aanmelden');
INSERT INTO `site_lang` VALUES ('42', '13', 'Door verder te gaan, bevestigt u dat u hebt gelezen en akkoord gaat met onze');
INSERT INTO `site_lang` VALUES ('38', '13', 'Maak kennis met meisjes');
INSERT INTO `site_lang` VALUES ('39', '13', 'Maak kennis met jongens');
INSERT INTO `site_lang` VALUES ('40', '13', 'Maak kennis met jongens en meisjes');
INSERT INTO `site_lang` VALUES ('37', '13', 'Ik ben hier om te');
INSERT INTO `site_lang` VALUES ('36', '13', 'Vrouw');
INSERT INTO `site_lang` VALUES ('34', '13', 'Geslacht');
INSERT INTO `site_lang` VALUES ('35', '13', 'Mannetje');
INSERT INTO `site_lang` VALUES ('29', '13', 'Wachtwoord');
INSERT INTO `site_lang` VALUES ('30', '13', 'Verjaardag');
INSERT INTO `site_lang` VALUES ('31', '13', 'Maak uw keuze');
INSERT INTO `site_lang` VALUES ('32', '13', 'Stad');
INSERT INTO `site_lang` VALUES ('33', '13', 'Waar woon je?');
INSERT INTO `site_lang` VALUES ('28', '13', 'Email');
INSERT INTO `site_lang` VALUES ('27', '13', 'Uw naam of nickname');
INSERT INTO `site_lang` VALUES ('26', '13', 'Naam');
INSERT INTO `site_lang` VALUES ('25', '13', 'Word lid van de werelden bestest community voor het ontmoeten van nieuwe mensen !.');
INSERT INTO `site_lang` VALUES ('24', '13', 'Word nu lid');
INSERT INTO `site_lang` VALUES ('23', '13', 'Speel onze populaire Ontdek spel en krijgen afgestemd met andere gebruikers . Het is een geweldige manier om het ijs te breken en een praatje met nieuwe mensen.');
INSERT INTO `site_lang` VALUES ('22', '13', 'Lucifers');
INSERT INTO `site_lang` VALUES ('21', '13', 'We zullen hier niet uw exacte locatie laten zien, maar je kunt mensen in de buurt die graag dezelfde dingen die je doet vinden.');
INSERT INTO `site_lang` VALUES ('20', '13', 'Mensen in de buurt');
INSERT INTO `site_lang` VALUES ('19', '13', 'U kunt de kwaliteit videobellen gratis voor iedereen te maken , zonder beperkingen van de duur van het gesprek , gewoon genieten van het zien van de persoon die met u kan chatten');
INSERT INTO `site_lang` VALUES ('18', '13', 'Video Chat');
INSERT INTO `site_lang` VALUES ('17', '13', 'Krachtige privÃ© chat nieuwe vrienden te ontmoeten , kunt u emoticons en privÃ©foto&#039;s sturen naar iedereen .');
INSERT INTO `site_lang` VALUES ('16', '13', 'Chat');
INSERT INTO `site_lang` VALUES ('15', '13', 'wachtwoord vergeten?');
INSERT INTO `site_lang` VALUES ('14', '13', 'Wachtwoord herstellen');
INSERT INTO `site_lang` VALUES ('13', '13', 'Log nu in');
INSERT INTO `site_lang` VALUES ('12', '13', 'denk je vergeten?');
INSERT INTO `site_lang` VALUES ('11', '13', 'Je wachtwoord');
INSERT INTO `site_lang` VALUES ('10', '13', 'Jouw email');
INSERT INTO `site_lang` VALUES ('6', '13', 'BINNENKORT BESCHIKBAAR');
INSERT INTO `site_lang` VALUES ('9', '13', 'Welkom terug');
INSERT INTO `site_lang` VALUES ('8', '13', 'Maak een account aan');
INSERT INTO `site_lang` VALUES ('7', '13', 'Verbonden met');
INSERT INTO `site_lang` VALUES ('5', '13', 'Binnenkort zullen we onze telefoon apps online hebben');
INSERT INTO `site_lang` VALUES ('4', '13', 'Bezoek ons â€‹â€‹van uw laptop of pc');
INSERT INTO `site_lang` VALUES ('3', '13', 'Voor nu werkt onze site alleen voor desktop gebruikers');
INSERT INTO `site_lang` VALUES ('2', '13', 'Welkom bij de snelst groeiende plek om nieuwe mensen te ontmoeten');
INSERT INTO `site_lang` VALUES ('1', '13', 'Log in');
INSERT INTO `site_lang` VALUES ('0', '13', 'nieuwe mensen ontmoeten!');
INSERT INTO `site_lang` VALUES ('374', '27', 'Inizia ora di incontrare nuove persone');
INSERT INTO `site_lang` VALUES ('373', '27', 'PiÃ¹ di 1 milione di persone si sono unite $ site_name Probabilmente si desidera conoscere alcuni di loro .');
INSERT INTO `site_lang` VALUES ('372', '27', 'Aggiungere foto e completare il tuo profilo');
INSERT INTO `site_lang` VALUES ('371', '27', 'Nessuno sta andando a cadere in amore con una pagina vuota . Quanto piÃ¹ si ottiene , piÃ¹ possibilitÃ  di trovare una persona speciale !');
INSERT INTO `site_lang` VALUES ('370', '27', 'Incontrare nuove persone');
INSERT INTO `site_lang` VALUES ('368', '27', 'In');
INSERT INTO `site_lang` VALUES ('369', '27', 'vous pouvez rencontrer des gens instantanÃ©ment');
INSERT INTO `site_lang` VALUES ('367', '27', 'persone nella vostra zona vuole sapere voi');
INSERT INTO `site_lang` VALUES ('366', '27', 'Nouvelavis');
INSERT INTO `site_lang` VALUES ('382', '1', 'dont like you');
INSERT INTO `site_lang` VALUES ('365', '27', 'Controlla il tuo account');
INSERT INTO `site_lang` VALUES ('363', '27', 'Ecco alcuni consigli');
INSERT INTO `site_lang` VALUES ('364', '27', 'Ora sei un nuovo membro');
INSERT INTO `site_lang` VALUES ('361', '27', 'Benvenuto');
INSERT INTO `site_lang` VALUES ('362', '27', 'Ben fatto , ora ci si trova in');
INSERT INTO `site_lang` VALUES ('360', '27', 'Vedi profilo');
INSERT INTO `site_lang` VALUES ('354', '27', 'si dispone di un nuovo messaggio');
INSERT INTO `site_lang` VALUES ('381', '1', 'calling...');
INSERT INTO `site_lang` VALUES ('359', '27', 'e vive vicino a te');
INSERT INTO `site_lang` VALUES ('358', '27', 'Ã¨ nuovo a');
INSERT INTO `site_lang` VALUES ('356', '27', 'Buon divertimento !');
INSERT INTO `site_lang` VALUES ('357', '27', 'Ã¨ nuovo e vive vicino a te');
INSERT INTO `site_lang` VALUES ('355', '27', 'Risposta');
INSERT INTO `site_lang` VALUES ('353', '27', 'Nuovo post');
INSERT INTO `site_lang` VALUES ('352', '27', 'Vai dire qualcosa');
INSERT INTO `site_lang` VALUES ('351', '27', 'credo che il sentimento Ã¨ reciproco');
INSERT INTO `site_lang` VALUES ('350', '27', 'E &#039;un gioco !');
INSERT INTO `site_lang` VALUES ('349', '27', 'Si deve corrispondere');
INSERT INTO `site_lang` VALUES ('348', '27', 'Se hai dimenticato la password , clicca sul link qui sotto per ottenere un nuovo');
INSERT INTO `site_lang` VALUES ('347', '27', 'Scegliere una nuova password');
INSERT INTO `site_lang` VALUES ('346', '27', 'Unsubscribe');
INSERT INTO `site_lang` VALUES ('345', '27', 'Hai ricevuto questo avviso perchÃ© ti sei registrato come');
INSERT INTO `site_lang` VALUES ('344', '27', 'Scopri se vi piace troppo');
INSERT INTO `site_lang` VALUES ('382', '2', 'no gusta de ti');
INSERT INTO `site_lang` VALUES ('343', '27', 'avete visto per scoprire e amore . Il sentimento Ã¨ reciproco ?');
INSERT INTO `site_lang` VALUES ('342', '27', 'si ama e vuole chattare');
INSERT INTO `site_lang` VALUES ('380', '19', 'Willkommen zu');
INSERT INTO `site_lang` VALUES ('379', '19', 'Gehe zu');
INSERT INTO `site_lang` VALUES ('378', '19', 'Bitte speichern Sie die Verbindungsinformationen an einem sicheren Ort');
INSERT INTO `site_lang` VALUES ('377', '19', 'Passwort');
INSERT INTO `site_lang` VALUES ('376', '19', 'E-mail');
INSERT INTO `site_lang` VALUES ('375', '19', 'Hier sind Ihre Verbindungsdetails');
INSERT INTO `site_lang` VALUES ('374', '19', 'Neue Leute treffen jetzt');
INSERT INTO `site_lang` VALUES ('373', '19', 'Mehr als 1 Million Menschen haben $ site_name beigetreten Sie haben wahrscheinlich einige von ihnen wissen wollen.');
INSERT INTO `site_lang` VALUES ('372', '19', 'Fotos hinzufÃ¼gen und runden Ihr Profil ab');
INSERT INTO `site_lang` VALUES ('371', '19', 'Niemand wird in der Liebe mit einer leeren Seite zu fallen. Je mehr Informationen Sie bekommen , desto mehr Chancen , dass jemand besondere zu finden !');
INSERT INTO `site_lang` VALUES ('370', '19', 'Neue Leute kennen lernen');
INSERT INTO `site_lang` VALUES ('369', '19', 'Sie kÃ¶nnen die Menschen sofort treffen');
INSERT INTO `site_lang` VALUES ('368', '19', 'Im');
INSERT INTO `site_lang` VALUES ('367', '19', 'Menschen in Ihrer Umgebung mÃ¶chte, dass Sie wissen,');
INSERT INTO `site_lang` VALUES ('366', '19', 'Newsflash');
INSERT INTO `site_lang` VALUES ('365', '19', 'ÃœberprÃ¼fen Sie Ihr Konto');
INSERT INTO `site_lang` VALUES ('364', '19', 'Jetzt sind Sie ein neues Mitglied');
INSERT INTO `site_lang` VALUES ('363', '19', 'Hier sind ein paar Tipps');
INSERT INTO `site_lang` VALUES ('362', '19', 'Gut gemacht, jetzt sind Sie in');
INSERT INTO `site_lang` VALUES ('361', '19', 'Herzlich willkommen');
INSERT INTO `site_lang` VALUES ('360', '19', 'Schauen Sie sich das Profil');
INSERT INTO `site_lang` VALUES ('358', '19', 'ist neu bei');
INSERT INTO `site_lang` VALUES ('359', '19', 'und lebt Ihnen nÃ¤her');
INSERT INTO `site_lang` VALUES ('357', '19', 'ist neu und lebt Ihnen nÃ¤her');
INSERT INTO `site_lang` VALUES ('356', '19', 'Habe SpaÃŸ!');
INSERT INTO `site_lang` VALUES ('355', '19', 'Antworten auf');
INSERT INTO `site_lang` VALUES ('354', '19', 'Sie haben eine neue Nachricht aus');
INSERT INTO `site_lang` VALUES ('353', '19', 'Neue Nachricht von');
INSERT INTO `site_lang` VALUES ('352', '19', 'Gehen Sie und sagen , etwas zu');
INSERT INTO `site_lang` VALUES ('351', '19', 'denkt das GefÃ¼hl der gegenseitigen');
INSERT INTO `site_lang` VALUES ('350', '19', 'Es ist ein Spiel!');
INSERT INTO `site_lang` VALUES ('349', '19', 'Sie haben ein Spiel an');
INSERT INTO `site_lang` VALUES ('348', '19', 'Wenn Sie Ihr Passwort vergessen haben , klicken Sie unten auf den Link, um ein neues zu erhalten');
INSERT INTO `site_lang` VALUES ('347', '19', 'WÃ¤hle ein neues Passwort');
INSERT INTO `site_lang` VALUES ('346', '19', 'Abmelden');
INSERT INTO `site_lang` VALUES ('345', '19', 'Sie erhalten diese Mitteilung , weil Sie als GroÃŸ');
INSERT INTO `site_lang` VALUES ('344', '19', 'Finden Sie heraus, wenn Sie auch gerne');
INSERT INTO `site_lang` VALUES ('343', '19', 'hat man gesehen in entdecken und mag. Das GefÃ¼hl beruht auf Gegenseitigkeit?');
INSERT INTO `site_lang` VALUES ('342', '19', 'mag dich und will in chatten');
INSERT INTO `site_lang` VALUES ('380', '45', 'HoÅŸgeldiniz');
INSERT INTO `site_lang` VALUES ('379', '45', 'git');
INSERT INTO `site_lang` VALUES ('378', '45', 'gÃ¼venli bir yerde baÄŸlantÄ± bilgileri kaydetmek LÃ¼tfen');
INSERT INTO `site_lang` VALUES ('377', '45', 'Parola');
INSERT INTO `site_lang` VALUES ('376', '45', 'E-mail');
INSERT INTO `site_lang` VALUES ('375', '45', 'Ä°ÅŸte baÄŸlantÄ± ayrÄ±ntÄ±lardÄ±r');
INSERT INTO `site_lang` VALUES ('374', '45', 'Åžimdi yeni insanlarla tanÄ±ÅŸmak baÅŸla');
INSERT INTO `site_lang` VALUES ('373', '45', '1 milyondan fazla kiÅŸi Muhtemelen bazÄ±larÄ± bilmek istiyorum $ SITE_NAME katÄ±ldÄ± .');
INSERT INTO `site_lang` VALUES ('372', '45', 'fotoÄŸraf eklemek ve profilinizi tamamlayÄ±n');
INSERT INTO `site_lang` VALUES ('371', '45', 'Kimse boÅŸ bir sayfa aÅŸÄ±k oluyor . AlacaÄŸÄ±nÄ±z daha fazla bilgi , daha fazla ÅŸansÄ± o Ã¶zel birini bulmak iÃ§in !');
INSERT INTO `site_lang` VALUES ('370', '45', 'Yeni insanlarla tanÄ±ÅŸmak');
INSERT INTO `site_lang` VALUES ('369', '45', 'anÄ±nda insanlarla tanÄ±ÅŸmak');
INSERT INTO `site_lang` VALUES ('368', '45', 'Ä°Ã§inde');
INSERT INTO `site_lang` VALUES ('367', '45', 'BÃ¶lgenizdeki insanlarÄ±n sizi tanÄ±mak istiyor');
INSERT INTO `site_lang` VALUES ('366', '45', 'FlaÅŸ Haber');
INSERT INTO `site_lang` VALUES ('365', '45', 'HesabÄ±nÄ±zÄ± doÄŸrulayÄ±n');
INSERT INTO `site_lang` VALUES ('360', '45', 'profili gÃ¶z atÄ±n');
INSERT INTO `site_lang` VALUES ('361', '45', 'HoÅŸgeldiniz');
INSERT INTO `site_lang` VALUES ('362', '45', 'Aferin , ÅŸimdi iÃ§inde bulunduÄŸunuz');
INSERT INTO `site_lang` VALUES ('363', '45', 'Ä°ÅŸte birkaÃ§ ipucu');
INSERT INTO `site_lang` VALUES ('364', '45', 'Åžimdi yeni bir Ã¼yesisiniz');
INSERT INTO `site_lang` VALUES ('359', '45', 've size daha yakÄ±n yaÅŸayan');
INSERT INTO `site_lang` VALUES ('358', '45', 'En yeni');
INSERT INTO `site_lang` VALUES ('355', '45', 'Cevap ver');
INSERT INTO `site_lang` VALUES ('356', '45', 'Ä°yi eÄŸlenceler!');
INSERT INTO `site_lang` VALUES ('357', '45', 'yeni ve size daha yakÄ±n yaÅŸayan');
INSERT INTO `site_lang` VALUES ('354', '45', 'EÄŸer yeni bir mesaj gelen var');
INSERT INTO `site_lang` VALUES ('352', '45', 'Git ve bir ÅŸey sÃ¶ylemek');
INSERT INTO `site_lang` VALUES ('353', '45', 'Yeni mesaj');
INSERT INTO `site_lang` VALUES ('350', '45', 'Onun bir maÃ§ !');
INSERT INTO `site_lang` VALUES ('351', '45', 'duygu karÅŸÄ±lÄ±klÄ± olduÄŸunu dÃ¼ÅŸÃ¼nÃ¼yor');
INSERT INTO `site_lang` VALUES ('349', '45', 'Bir maÃ§ da var');
INSERT INTO `site_lang` VALUES ('348', '45', 'EÄŸer ÅŸifrenizi unuttuysanÄ±z , altÄ±nda yeni bir almak iÃ§in linke tÄ±klayÄ±n');
INSERT INTO `site_lang` VALUES ('346', '45', 'AboneliÄŸi iptal');
INSERT INTO `site_lang` VALUES ('347', '45', 'Yeni bir ÅŸifre seÃ§in');
INSERT INTO `site_lang` VALUES ('345', '45', 'EÄŸer kayÄ±tlÄ± Ã§Ã¼nkÃ¼ bu uyarÄ± aldÄ±');
INSERT INTO `site_lang` VALUES ('344', '45', 'AyrÄ±ca isterseniz Ã¶ÄŸrenin');
INSERT INTO `site_lang` VALUES ('342', '45', 'seni seviyor ve sohbet etmek istiyor');
INSERT INTO `site_lang` VALUES ('343', '45', 'keÅŸfetmek ve seviyor seni gÃ¶rdÃ¼ . Duygu karÅŸÄ±lÄ±klÄ±?');
INSERT INTO `site_lang` VALUES ('43', '37', 'Termos e CondiÃ§Ãµes');
INSERT INTO `site_lang` VALUES ('41', '37', 'Inscrever-se');
INSERT INTO `site_lang` VALUES ('42', '37', 'Ao continuar , vocÃª estÃ¡ confirmando que leu e concorda com a nossa');
INSERT INTO `site_lang` VALUES ('40', '37', 'Meninos e meninas se encontram');
INSERT INTO `site_lang` VALUES ('39', '37', 'Rapazes encontram');
INSERT INTO `site_lang` VALUES ('36', '37', 'FÃªmea');
INSERT INTO `site_lang` VALUES ('37', '37', 'Eu estou aqui para');
INSERT INTO `site_lang` VALUES ('38', '37', 'ConheÃ§a as meninas');
INSERT INTO `site_lang` VALUES ('32', '37', 'Cidade');
INSERT INTO `site_lang` VALUES ('33', '37', 'Onde vocÃª mora?');
INSERT INTO `site_lang` VALUES ('34', '37', 'GÃªnero');
INSERT INTO `site_lang` VALUES ('35', '37', 'Masculino');
INSERT INTO `site_lang` VALUES ('29', '37', 'Senha');
INSERT INTO `site_lang` VALUES ('30', '37', 'AniversÃ¡rio');
INSERT INTO `site_lang` VALUES ('31', '37', 'Por favor selecione');
INSERT INTO `site_lang` VALUES ('26', '37', 'Nome');
INSERT INTO `site_lang` VALUES ('27', '37', 'Seu nome ou apelido');
INSERT INTO `site_lang` VALUES ('28', '37', 'O email');
INSERT INTO `site_lang` VALUES ('24', '37', 'Tornar-se membro');
INSERT INTO `site_lang` VALUES ('21', '37', 'NÃ³s rotina mostrar sua localizaÃ§Ã£o exata , mas vocÃª serÃ¡ capaz de encontrar pessoas prÃ³ximas que gostam das mesmas coisas que vocÃª .');
INSERT INTO `site_lang` VALUES ('23', '37', 'Jogar o nosso jogo popular Discover e se combinado com outros usuÃ¡rios. Seu uma grande maneira de quebrar o gelo e conversar com novas pessoas.');
INSERT INTO `site_lang` VALUES ('22', '37', 'Partidas');
INSERT INTO `site_lang` VALUES ('9', '37', 'Bem vindo de volta');
INSERT INTO `site_lang` VALUES ('10', '37', 'Seu email');
INSERT INTO `site_lang` VALUES ('11', '37', 'Sua senha');
INSERT INTO `site_lang` VALUES ('12', '37', 'vocÃª esqueceu sua senha?');
INSERT INTO `site_lang` VALUES ('13', '37', 'Conecte-se agora');
INSERT INTO `site_lang` VALUES ('14', '37', 'Recuperar Senha');
INSERT INTO `site_lang` VALUES ('15', '37', 'Senha recuperada');
INSERT INTO `site_lang` VALUES ('16', '37', 'Chat');
INSERT INTO `site_lang` VALUES ('17', '37', 'chat privado poderoso para conhecer novos amigos , vocÃª pode enviar emoticons e fotos privadas para ninguÃ©m.');
INSERT INTO `site_lang` VALUES ('18', '37', 'Video Chat');
INSERT INTO `site_lang` VALUES ('8', '37', 'Crie sua conta');
INSERT INTO `site_lang` VALUES ('6', '37', 'DisponÃ­vel em breve');
INSERT INTO `site_lang` VALUES ('7', '37', 'Conectar com');
INSERT INTO `site_lang` VALUES ('5', '37', 'Em breve teremos nossos aplicativos de telefone on-line');
INSERT INTO `site_lang` VALUES ('4', '37', 'Por favor, visite-nos de seu laptop ou PC');
INSERT INTO `site_lang` VALUES ('3', '37', 'Por agora o nosso site funciona apenas para usuÃ¡rios de desktop');
INSERT INTO `site_lang` VALUES ('1', '37', 'Entrar');
INSERT INTO `site_lang` VALUES ('2', '37', 'Bem-vindo Ã  mais rÃ¡pida lugar crescente para conhecer novas pessoas');
INSERT INTO `site_lang` VALUES ('379', '17', 'Aller Ã ');
INSERT INTO `site_lang` VALUES ('380', '17', 'Bienvenue Ã ');
INSERT INTO `site_lang` VALUES ('0', '37', 'ConheÃ§a novas pessoas!');
INSERT INTO `site_lang` VALUES ('378', '17', 'S&#039;il vous plaÃ®t enregistrer vos informations de connexion dans un endroit sÃ»r');
INSERT INTO `site_lang` VALUES ('376', '17', 'E-mail');
INSERT INTO `site_lang` VALUES ('377', '17', 'Mot de passe');
INSERT INTO `site_lang` VALUES ('375', '17', 'Voici les dÃ©tails de votre connexion');
INSERT INTO `site_lang` VALUES ('374', '17', 'Commencez maintenant rencontrer de nouvelles personnes');
INSERT INTO `site_lang` VALUES ('372', '17', 'Ajouter des photos et complÃ©ter votre profil');
INSERT INTO `site_lang` VALUES ('373', '17', 'Plus de 1 million de personnes ont rejoint $ site_name Vous voulez probablement savoir certains d&#039;entre eux .');
INSERT INTO `site_lang` VALUES ('370', '17', 'Rencontrer de nouvelles personnes');
INSERT INTO `site_lang` VALUES ('371', '17', 'Personne ne va tomber en amour avec une page blanche . Plus vous obtenez , plus les chances de trouver quelqu&#039;un de spÃ©cial !');
INSERT INTO `site_lang` VALUES ('369', '17', 'vous pouvez rencontrer des gens instantanÃ©ment');
INSERT INTO `site_lang` VALUES ('368', '17', 'Dans');
INSERT INTO `site_lang` VALUES ('367', '17', 'les gens dans votre rÃ©gion veut vous connaÃ®tre');
INSERT INTO `site_lang` VALUES ('366', '17', 'Newsflash');
INSERT INTO `site_lang` VALUES ('365', '17', 'VÃ©rifiez votre compte');
INSERT INTO `site_lang` VALUES ('364', '17', 'Maintenant, vous Ãªtes un nouveau membre');
INSERT INTO `site_lang` VALUES ('363', '17', 'Voici quelques conseils');
INSERT INTO `site_lang` VALUES ('362', '17', 'Eh bien fait , maintenant vous Ãªtes dans');
INSERT INTO `site_lang` VALUES ('361', '17', 'Bienvenue');
INSERT INTO `site_lang` VALUES ('360', '17', 'Consultez le profil');
INSERT INTO `site_lang` VALUES ('359', '17', 'et vit prÃ¨s de chez vous');
INSERT INTO `site_lang` VALUES ('358', '17', 'est nouveau au');
INSERT INTO `site_lang` VALUES ('357', '17', 'est nouveau et vit prÃ¨s de chez vous');
INSERT INTO `site_lang` VALUES ('356', '17', 'S&#039;amuser!');
INSERT INTO `site_lang` VALUES ('355', '17', 'RÃ©pondre Ã ');
INSERT INTO `site_lang` VALUES ('354', '17', 'vous avez un nouveau message');
INSERT INTO `site_lang` VALUES ('353', '17', 'Nouveau message');
INSERT INTO `site_lang` VALUES ('352', '17', 'Allez dire quelque chose');
INSERT INTO `site_lang` VALUES ('351', '17', 'pense que le sentiment est mutuel');
INSERT INTO `site_lang` VALUES ('350', '17', 'Son un match !');
INSERT INTO `site_lang` VALUES ('349', '17', 'Vous avez un match Ã ');
INSERT INTO `site_lang` VALUES ('348', '17', 'si vous avez oubliÃ© votre mot de passe , cliquez sur le lien ci-dessous pour obtenir un nouveau');
INSERT INTO `site_lang` VALUES ('347', '17', 'Choisissez un nouveau mot de passe');
INSERT INTO `site_lang` VALUES ('346', '17', 'Se dÃ©sabonner');
INSERT INTO `site_lang` VALUES ('345', '17', 'Vous avez reÃ§u cet avis parce que vous vous Ãªtes inscrit comme');
INSERT INTO `site_lang` VALUES ('344', '17', 'DÃ©couvrez si vous aimez aussi');
INSERT INTO `site_lang` VALUES ('343', '17', 'vous a vu Ã  dÃ©couvrir et aime . Le sentiment est mutuel?');
INSERT INTO `site_lang` VALUES ('342', '17', 'vous aime et veut discuter en');
INSERT INTO `site_lang` VALUES ('380', '2', 'Bienvenido a');
INSERT INTO `site_lang` VALUES ('379', '2', 'Ir a');
INSERT INTO `site_lang` VALUES ('378', '2', 'Por favor, guarde la informaciÃ³n de conexiÃ³n en un lugar seguro');
INSERT INTO `site_lang` VALUES ('376', '2', 'E-mail');
INSERT INTO `site_lang` VALUES ('377', '2', 'ContraseÃ±a');
INSERT INTO `site_lang` VALUES ('375', '2', 'AquÃ­ estÃ¡n los detalles de conexiÃ³n');
INSERT INTO `site_lang` VALUES ('374', '2', 'Empezar a conocer gente nueva ahora');
INSERT INTO `site_lang` VALUES ('373', '2', 'MÃ¡s de 1 millÃ³n de personas se han unido $site_name Usted probablemente querrÃ¡ saber algunos de ellos .');
INSERT INTO `site_lang` VALUES ('372', '2', 'AÃ±adir fotos y completar su perfil');
INSERT INTO `site_lang` VALUES ('371', '2', 'Nadie va a caer en amor con una pÃ¡gina en blanco . Cuanta mÃ¡s informaciÃ³n se obtiene , mÃ¡s posibilidades de encontrar esa persona especial !');
INSERT INTO `site_lang` VALUES ('370', '2', 'Conocer gente nueva');
INSERT INTO `site_lang` VALUES ('369', '2', 'puedes conocer gente inmediatamente');
INSERT INTO `site_lang` VALUES ('368', '2', 'En');
INSERT INTO `site_lang` VALUES ('367', '2', 'personas en su Ã¡rea que puede conocer');
INSERT INTO `site_lang` VALUES ('366', '2', 'Noticia de Ãºltima hora');
INSERT INTO `site_lang` VALUES ('365', '2', 'Verifica tu cuenta');
INSERT INTO `site_lang` VALUES ('364', '2', 'Ahora usted es un nuevo miembro de');
INSERT INTO `site_lang` VALUES ('363', '2', 'AquÃ­ hay algunos consejos');
INSERT INTO `site_lang` VALUES ('361', '2', 'Bienvenido');
INSERT INTO `site_lang` VALUES ('362', '2', 'Bien hecho , ahora estÃ¡ en el');
INSERT INTO `site_lang` VALUES ('360', '2', 'Salida del perfil');
INSERT INTO `site_lang` VALUES ('359', '2', 'y vive mÃ¡s cerca de usted');
INSERT INTO `site_lang` VALUES ('357', '2', 'es nuevo y vive mÃ¡s cerca de usted');
INSERT INTO `site_lang` VALUES ('358', '2', 'es nuevo en');
INSERT INTO `site_lang` VALUES ('356', '2', 'Â¡Que te diviertas!');
INSERT INTO `site_lang` VALUES ('355', '2', 'Responder a');
INSERT INTO `site_lang` VALUES ('354', '2', 'Tiene un nuevo mensaje de');
INSERT INTO `site_lang` VALUES ('353', '2', 'Nuevo mensaje de');
INSERT INTO `site_lang` VALUES ('351', '2', 'cree que el sentimiento es mutuo');
INSERT INTO `site_lang` VALUES ('352', '2', 'Ve y di algo para');
INSERT INTO `site_lang` VALUES ('350', '2', 'Es una coincidencia!');
INSERT INTO `site_lang` VALUES ('349', '2', 'Usted tiene una coincidencia en el');
INSERT INTO `site_lang` VALUES ('348', '2', 'si ha olvidado su contraseÃ±a, haga clic en el enlace de abajo para obtener un nuevo');
INSERT INTO `site_lang` VALUES ('342', '2', 'gusta de ti y le gustaria chatear contigo en');
INSERT INTO `site_lang` VALUES ('380', '1', 'Welcome to');
INSERT INTO `site_lang` VALUES ('378', '1', 'Please save your connection information in a safe place');
INSERT INTO `site_lang` VALUES ('379', '1', 'Go to');
INSERT INTO `site_lang` VALUES ('377', '1', 'Password');
INSERT INTO `site_lang` VALUES ('376', '1', 'E-mail');
INSERT INTO `site_lang` VALUES ('375', '1', 'Here are your connection details');
INSERT INTO `site_lang` VALUES ('374', '1', 'Start meeting new people now');
INSERT INTO `site_lang` VALUES ('373', '1', 'More than 1 million people have joined $site_name You probably want to know some of them.');
INSERT INTO `site_lang` VALUES ('372', '1', 'Add photos and complete your profile');
INSERT INTO `site_lang` VALUES ('371', '1', 'Nobody is going to fall in love with a blank page. The more information you get, the more chances to find that special someone!');
INSERT INTO `site_lang` VALUES ('370', '1', 'Meet new people');
INSERT INTO `site_lang` VALUES ('369', '1', 'you can meet people instantly');
INSERT INTO `site_lang` VALUES ('368', '1', 'In');
INSERT INTO `site_lang` VALUES ('367', '1', 'people in your area wants to know you');
INSERT INTO `site_lang` VALUES ('366', '1', 'Newsflash');
INSERT INTO `site_lang` VALUES ('363', '1', 'Here are a few tips');
INSERT INTO `site_lang` VALUES ('364', '1', 'Now you are a new member of');
INSERT INTO `site_lang` VALUES ('365', '1', 'Verify your account');
INSERT INTO `site_lang` VALUES ('362', '1', 'Well done, now you are in');
INSERT INTO `site_lang` VALUES ('356', '1', 'Have fun!');
INSERT INTO `site_lang` VALUES ('357', '1', 'is new and lives closer to you');
INSERT INTO `site_lang` VALUES ('358', '1', 'is new at');
INSERT INTO `site_lang` VALUES ('359', '1', 'and lives closer to you');
INSERT INTO `site_lang` VALUES ('360', '1', 'Check out the profile');
INSERT INTO `site_lang` VALUES ('361', '1', 'Welcome');
INSERT INTO `site_lang` VALUES ('355', '1', 'Respond to');
INSERT INTO `site_lang` VALUES ('350', '1', 'Its a match!');
INSERT INTO `site_lang` VALUES ('351', '1', 'thinks the feeling is mutual');
INSERT INTO `site_lang` VALUES ('352', '1', 'Go and say something to');
INSERT INTO `site_lang` VALUES ('353', '1', 'New message from');
INSERT INTO `site_lang` VALUES ('354', '1', 'you have a new message from');
INSERT INTO `site_lang` VALUES ('349', '1', 'You have a match at');
INSERT INTO `site_lang` VALUES ('348', '1', 'if you forgot your password, click on the link below to get a new');
INSERT INTO `site_lang` VALUES ('347', '2', 'Elija una contraseÃ±a nueva');
INSERT INTO `site_lang` VALUES ('343', '2', 'se ha visto en descubrir y gustos . Â¿El sentimiento es mutuo?');
INSERT INTO `site_lang` VALUES ('344', '2', 'Averiguar si tambiÃ©n te gusta');
INSERT INTO `site_lang` VALUES ('345', '2', 'Ha recibido este email porque usted estas registrado como');
INSERT INTO `site_lang` VALUES ('347', '1', 'Choose a new password');
INSERT INTO `site_lang` VALUES ('346', '2', 'Darse de baja');
INSERT INTO `site_lang` VALUES ('346', '1', 'Unsubscribe');
INSERT INTO `site_lang` VALUES ('345', '1', 'You received this notice because you registered as');
INSERT INTO `site_lang` VALUES ('344', '1', 'Find out if you also like');
INSERT INTO `site_lang` VALUES ('343', '1', 'has seen you in discover and likes. The feeling is mutual?');
INSERT INTO `site_lang` VALUES ('342', '1', 'likes you and wants to chat in');
INSERT INTO `site_lang` VALUES ('341', '43', 'Vi har skickat ett e-postmeddelande med din info , kan det ta upp till en minut att komma fram');
INSERT INTO `site_lang` VALUES ('340', '43', 'LÃ¤ser in...');
INSERT INTO `site_lang` VALUES ('339', '43', 'av');
INSERT INTO `site_lang` VALUES ('338', '43', 'Bilder frÃ¥n');
INSERT INTO `site_lang` VALUES ('337', '43', 'ringer dig ..');
INSERT INTO `site_lang` VALUES ('336', '43', 'LÃ¶senord har Ã¤ndrats');
INSERT INTO `site_lang` VALUES ('335', '43', 'TjÃ¤nstekostnad');
INSERT INTO `site_lang` VALUES ('334', '43', 'StrÃ¥lkastare');
INSERT INTO `site_lang` VALUES ('333', '43', 'Fel');
INSERT INTO `site_lang` VALUES ('332', '43', 'dagar Premium');
INSERT INTO `site_lang` VALUES ('331', '43', 'anvÃ¤ndarnamn');
INSERT INTO `site_lang` VALUES ('330', '43', 'Du mÃ¥ste skriva ditt anvÃ¤ndarnamn !');
INSERT INTO `site_lang` VALUES ('329', '43', 'Skriv instagram anvÃ¤ndarnamn');
INSERT INTO `site_lang` VALUES ('328', '43', 'Tryck Backsteg fÃ¶r smart Ã¥tergÃ¥ng till sektionsmÃ¶tet .');
INSERT INTO `site_lang` VALUES ('327', '43', 'Ã„r du sÃ¤ker pÃ¥ att du vill rapportera');
INSERT INTO `site_lang` VALUES ('326', '43', 'Rapport och blockera');
INSERT INTO `site_lang` VALUES ('325', '43', 'blockerar dig eller du blockerat honom , kan inte du chatta med honom ledsen');
INSERT INTO `site_lang` VALUES ('324', '43', 'Vi sended du en e-post fÃ¶r att bekrÃ¤fta ditt konto');
INSERT INTO `site_lang` VALUES ('323', '43', 'Ã¥r gammal och im frÃ¥n');
INSERT INTO `site_lang` VALUES ('322', '43', 'Hej jag Ã¤r');
INSERT INTO `site_lang` VALUES ('321', '43', 'LÃ¤gg till en profilbild');
INSERT INTO `site_lang` VALUES ('319', '43', 'sedan');
INSERT INTO `site_lang` VALUES ('320', '43', 'VÃ¤nligen bekrÃ¤fta ditt konto , kolla din e-mail');
INSERT INTO `site_lang` VALUES ('318', '43', 'sekunder');
INSERT INTO `site_lang` VALUES ('313', '43', 'Ã¥rs');
INSERT INTO `site_lang` VALUES ('314', '43', 'mÃ¥nader');
INSERT INTO `site_lang` VALUES ('315', '43', 'dagar');
INSERT INTO `site_lang` VALUES ('316', '43', 'timmar');
INSERT INTO `site_lang` VALUES ('317', '43', 'minuter');
INSERT INTO `site_lang` VALUES ('306', '43', '0 sekunder');
INSERT INTO `site_lang` VALUES ('307', '43', 'Ã¥r');
INSERT INTO `site_lang` VALUES ('308', '43', 'mÃ¥nad');
INSERT INTO `site_lang` VALUES ('309', '43', 'dag');
INSERT INTO `site_lang` VALUES ('310', '43', 'Timme');
INSERT INTO `site_lang` VALUES ('311', '43', 'minut');
INSERT INTO `site_lang` VALUES ('312', '43', 'Andra');
INSERT INTO `site_lang` VALUES ('304', '43', 'Kosta');
INSERT INTO `site_lang` VALUES ('305', '43', 'Krediter fÃ¶r $');
INSERT INTO `site_lang` VALUES ('297', '43', 'Meddelanden');
INSERT INTO `site_lang` VALUES ('298', '43', 'Tycka om');
INSERT INTO `site_lang` VALUES ('299', '43', 'Motvilja');
INSERT INTO `site_lang` VALUES ('300', '43', 'Ã…LDER');
INSERT INTO `site_lang` VALUES ('301', '43', 'Du inte har nÃ¥gon besÃ¶k Ã¤nnu');
INSERT INTO `site_lang` VALUES ('302', '43', 'besÃ¶kta');
INSERT INTO `site_lang` VALUES ('303', '43', 'Du tycker inte om nÃ¥gon');
INSERT INTO `site_lang` VALUES ('296', '43', 'folk gillade dig , fÃ¶r se dem');
INSERT INTO `site_lang` VALUES ('295', '43', 'MÃ¤nniskor jag gillar');
INSERT INTO `site_lang` VALUES ('294', '43', 'Uppgradera ditt konto till premium');
INSERT INTO `site_lang` VALUES ('293', '43', 'personer besÃ¶kte din profil fÃ¶r se dem');
INSERT INTO `site_lang` VALUES ('292', '43', 'Radera');
INSERT INTO `site_lang` VALUES ('291', '43', 'Offentlig bild');
INSERT INTO `site_lang` VALUES ('290', '43', 'privat foto');
INSERT INTO `site_lang` VALUES ('289', '43', 'Ange som profil');
INSERT INTO `site_lang` VALUES ('286', '43', 'BesÃ¶k');
INSERT INTO `site_lang` VALUES ('287', '43', 'LÃ¤gg till mig hÃ¤r');
INSERT INTO `site_lang` VALUES ('288', '43', 'fÃ¥r ses av miljoner');
INSERT INTO `site_lang` VALUES ('285', '43', 'Krediter');
INSERT INTO `site_lang` VALUES ('283', '43', 'LÃ¤gg till');
INSERT INTO `site_lang` VALUES ('284', '43', 'Foton');
INSERT INTO `site_lang` VALUES ('281', '43', 'Privata bilder');
INSERT INTO `site_lang` VALUES ('282', '43', 'LÃ¤gg till frÃ¥n');
INSERT INTO `site_lang` VALUES ('280', '43', 'Publika foton');
INSERT INTO `site_lang` VALUES ('279', '43', 'Inga data');
INSERT INTO `site_lang` VALUES ('278', '43', 'Fans');
INSERT INTO `site_lang` VALUES ('277', '43', 'Rapportera');
INSERT INTO `site_lang` VALUES ('276', '43', 'Intressen');
INSERT INTO `site_lang` VALUES ('274', '43', 'Ã…r');
INSERT INTO `site_lang` VALUES ('275', '43', 'VÃ¤nta');
INSERT INTO `site_lang` VALUES ('273', '43', 'Month');
INSERT INTO `site_lang` VALUES ('272', '43', 'Dag');
INSERT INTO `site_lang` VALUES ('271', '43', 'NÃ¤r nÃ¥gon skickar ett meddelande till mig');
INSERT INTO `site_lang` VALUES ('269', '43', 'NÃ¤r jag fÃ¥r en match');
INSERT INTO `site_lang` VALUES ('270', '43', 'NÃ¤r nya anvÃ¤ndare i nÃ¤rheten av mig delta i');
INSERT INTO `site_lang` VALUES ('268', '43', 'NÃ¤r nÃ¥gon tycker om mig');
INSERT INTO `site_lang` VALUES ('266', '43', 'Jag Ã¤ger en motorcykel');
INSERT INTO `site_lang` VALUES ('267', '43', 'Ingen');
INSERT INTO `site_lang` VALUES ('264', '43', 'fÃ¶rÃ¤ldrar bil');
INSERT INTO `site_lang` VALUES ('265', '43', 'Jag Ã¤ger en bil');
INSERT INTO `site_lang` VALUES ('263', '43', 'Transport');
INSERT INTO `site_lang` VALUES ('261', '43', 'Ibland');
INSERT INTO `site_lang` VALUES ('262', '43', 'Dryck');
INSERT INTO `site_lang` VALUES ('259', '43', 'Ja');
INSERT INTO `site_lang` VALUES ('260', '43', 'Nej');
INSERT INTO `site_lang` VALUES ('258', '43', 'RÃ¶k');
INSERT INTO `site_lang` VALUES ('257', '43', 'Ensam');
INSERT INTO `site_lang` VALUES ('256', '43', 'Med partner');
INSERT INTO `site_lang` VALUES ('255', '43', 'Studentbostad');
INSERT INTO `site_lang` VALUES ('254', '43', 'Med housemate');
INSERT INTO `site_lang` VALUES ('253', '43', 'Med fÃ¶rÃ¤ldrar');
INSERT INTO `site_lang` VALUES ('252', '43', 'Levande');
INSERT INTO `site_lang` VALUES ('251', '43', 'Kurvig');
INSERT INTO `site_lang` VALUES ('250', '43', 'Tung uppsÃ¤ttning');
INSERT INTO `site_lang` VALUES ('249', '43', 'Atletisk');
INSERT INTO `site_lang` VALUES ('248', '43', 'Genomsnitt');
INSERT INTO `site_lang` VALUES ('247', '43', 'Smal');
INSERT INTO `site_lang` VALUES ('246', '43', 'Kroppstyp');
INSERT INTO `site_lang` VALUES ('245', '43', 'Andra');
INSERT INTO `site_lang` VALUES ('244', '43', 'Indisk');
INSERT INTO `site_lang` VALUES ('243', '43', 'StillahavsomrÃ¥det');
INSERT INTO `site_lang` VALUES ('242', '43', 'Spansk / latin');
INSERT INTO `site_lang` VALUES ('241', '43', 'Indian');
INSERT INTO `site_lang` VALUES ('240', '43', 'Vit');
INSERT INTO `site_lang` VALUES ('239', '43', 'Svart');
INSERT INTO `site_lang` VALUES ('238', '43', 'MellanÃ¶stern');
INSERT INTO `site_lang` VALUES ('237', '43', 'Asiatisk');
INSERT INTO `site_lang` VALUES ('236', '43', 'Etnicitet');
INSERT INTO `site_lang` VALUES ('235', '43', 'Vikt');
INSERT INTO `site_lang` VALUES ('234', '43', 'mer Ã¤n');
INSERT INTO `site_lang` VALUES ('233', '43', 'mindre Ã¤n');
INSERT INTO `site_lang` VALUES ('232', '43', 'HÃ¶jd');
INSERT INTO `site_lang` VALUES ('231', '43', 'Bisexuell');
INSERT INTO `site_lang` VALUES ('230', '43', 'Rakt');
INSERT INTO `site_lang` VALUES ('229', '43', 'Ã–ppensinnad');
INSERT INTO `site_lang` VALUES ('228', '43', 'Gay');
INSERT INTO `site_lang` VALUES ('227', '43', 'Sexualitet');
INSERT INTO `site_lang` VALUES ('226', '43', 'Ã–ppen');
INSERT INTO `site_lang` VALUES ('225', '43', 'Tagen');
INSERT INTO `site_lang` VALUES ('224', '43', 'Enda');
INSERT INTO `site_lang` VALUES ('223', '43', 'Relation');
INSERT INTO `site_lang` VALUES ('222', '43', 'UtÃ¶kad information ( tillval )');
INSERT INTO `site_lang` VALUES ('221', '43', 'Aviseringar');
INSERT INTO `site_lang` VALUES ('220', '43', 'UPGRADE');
INSERT INTO `site_lang` VALUES ('219', '43', 'GrundlÃ¤ggande');
INSERT INTO `site_lang` VALUES ('218', '43', 'tills');
INSERT INTO `site_lang` VALUES ('217', '43', 'vÃ¤nta mer');
INSERT INTO `site_lang` VALUES ('216', '43', 'Avsluta samtal');
INSERT INTO `site_lang` VALUES ('215', '43', 'Verkar som din vÃ¤n inte har webbkamera eller han inte Ã¤r tillgÃ¤nglig');
INSERT INTO `site_lang` VALUES ('214', '43', 'AlltfÃ¶r lÃ¥ng vÃ¤ntan');
INSERT INTO `site_lang` VALUES ('213', '43', 'Du kan inte gÃ¶ra videocall eftersom du inte har webbkameran');
INSERT INTO `site_lang` VALUES ('212', '43', 'OmÃ¶jligt att ringa !');
INSERT INTO `site_lang` VALUES ('211', '43', 'Endast premiumanvÃ¤ndarekan gÃ¶ra videosamtal');
INSERT INTO `site_lang` VALUES ('210', '43', 'Du Ã¤r redan i en videocall , mÃ¥ste du avsluta det andra samtalet innan starta en annan');
INSERT INTO `site_lang` VALUES ('209', '43', 'VÃ¤nligen ge tillgÃ¥ng till din webbkamera .');
INSERT INTO `site_lang` VALUES ('208', '43', 'Ã¤r uppkopplad , fÃ¶rsÃ¶k igen nÃ¤r din vÃ¤n Ã¤r inte uppkopplad');
INSERT INTO `site_lang` VALUES ('207', '43', 'Ã¤r i en annan videocall , du kan inte ringa nu');
INSERT INTO `site_lang` VALUES ('206', '43', 'Ja , ta bort det !');
INSERT INTO `site_lang` VALUES ('205', '43', 'Dina data kommer att fÃ¶rloras utan Ã¥tervinning , fortsÃ¤tta?');
INSERT INTO `site_lang` VALUES ('204', '43', 'Kontot stÃ¤ngs');
INSERT INTO `site_lang` VALUES ('203', '43', 'Information uppdaterats');
INSERT INTO `site_lang` VALUES ('202', '43', 'Ja , kÃ¶p den !');
INSERT INTO `site_lang` VALUES ('201', '43', 'mer dagliga samtal , kostnad');
INSERT INTO `site_lang` VALUES ('200', '43', 'Expandera daglig begrÃ¤nsning');
INSERT INTO `site_lang` VALUES ('199', '43', 'Du har inte tillrÃ¤ckligt mÃ¥nga poÃ¤ng fÃ¶r att skicka gÃ¥van');
INSERT INTO `site_lang` VALUES ('198', '43', 'VÃ¤nligen , vÃ¤lj en gÃ¥va');
INSERT INTO `site_lang` VALUES ('197', '43', 'VÃ¤nligen , vÃ¤lj ett foto');
INSERT INTO `site_lang` VALUES ('196', '43', 'VÃ¤nligen , vÃ¤lj en betalningsmetod');
INSERT INTO `site_lang` VALUES ('195', '43', 'Nej tack');
INSERT INTO `site_lang` VALUES ('194', '43', 'FÃ¥ tillgÃ¥ng till');
INSERT INTO `site_lang` VALUES ('193', '43', 'privata foton fÃ¶r');
INSERT INTO `site_lang` VALUES ('192', '43', 'FÃ¥ tillgÃ¥ng till');
INSERT INTO `site_lang` VALUES ('191', '43', 'KÃ¶p privata bilder tillstÃ¥nd');
INSERT INTO `site_lang` VALUES ('190', '43', 'Nej, jag kan inte visa mina privata bilder');
INSERT INTO `site_lang` VALUES ('189', '43', 'Ja , kan du se mina privata bilder');
INSERT INTO `site_lang` VALUES ('188', '43', 'E-mail redan finns, prova en annan');
INSERT INTO `site_lang` VALUES ('187', '43', 'LÃ¶senord fÃ¶r kort');
INSERT INTO `site_lang` VALUES ('186', '43', 'VÃ¤lj stad frÃ¥n Komplettera automatiskt');
INSERT INTO `site_lang` VALUES ('185', '43', 'LÃ¤gg ett giltigt datum');
INSERT INTO `site_lang` VALUES ('184', '43', 'Fel lÃ¶senord');
INSERT INTO `site_lang` VALUES ('183', '43', 'E-mail existerar inte');
INSERT INTO `site_lang` VALUES ('182', '43', 'Fyll i alla ingÃ¥ngarna');
INSERT INTO `site_lang` VALUES ('181', '43', 'Ogiltig e-postformat');
INSERT INTO `site_lang` VALUES ('180', '43', 'LÃ¶senord Ã¥terhÃ¤mta  sig');
INSERT INTO `site_lang` VALUES ('179', '43', 'Logga in pÃ¥ mitt konto');
INSERT INTO `site_lang` VALUES ('178', '43', 'Om du inte kommer ihÃ¥g ditt lÃ¶senord , klicka pÃ¥ lÃ¤nken nedan fÃ¶r att stÃ¤lla in en ny :');
INSERT INTO `site_lang` VALUES ('177', '43', 'Hej');
INSERT INTO `site_lang` VALUES ('176', '43', 'Nej');
INSERT INTO `site_lang` VALUES ('175', '43', 'Ja');
INSERT INTO `site_lang` VALUES ('173', '43', 'sÃ¥ hÃ¤r');
INSERT INTO `site_lang` VALUES ('174', '43', 'Hej, kan jag fÃ¥ tillgÃ¥ng till dina privata bilder ?');
INSERT INTO `site_lang` VALUES ('170', '43', 'KÃ¶pa');
INSERT INTO `site_lang` VALUES ('171', '43', 'Dagar Premium');
INSERT INTO `site_lang` VALUES ('172', '43', 'personer mer gillar detta');
INSERT INTO `site_lang` VALUES ('169', '43', 'December');
INSERT INTO `site_lang` VALUES ('167', '43', 'Oktober');
INSERT INTO `site_lang` VALUES ('168', '43', 'November');
INSERT INTO `site_lang` VALUES ('164', '43', 'Juli');
INSERT INTO `site_lang` VALUES ('165', '43', 'Augusti');
INSERT INTO `site_lang` VALUES ('166', '43', 'September');
INSERT INTO `site_lang` VALUES ('162', '43', 'Maj');
INSERT INTO `site_lang` VALUES ('163', '43', 'Juni');
INSERT INTO `site_lang` VALUES ('160', '43', 'Mars');
INSERT INTO `site_lang` VALUES ('161', '43', 'April');
INSERT INTO `site_lang` VALUES ('159', '43', 'Februari');
INSERT INTO `site_lang` VALUES ('157', '43', 'Du inte har matcher Ã¤nnu');
INSERT INTO `site_lang` VALUES ('158', '43', 'Januari');
INSERT INTO `site_lang` VALUES ('156', '43', 'Du inte har nÃ¥gra fans Ã¤nnu');
INSERT INTO `site_lang` VALUES ('155', '43', 'Inga populÃ¤ra anvÃ¤ndare nÃ¤ra dig');
INSERT INTO `site_lang` VALUES ('154', '43', 'personer tyckte att det');
INSERT INTO `site_lang` VALUES ('152', '43', 'Verifierade');
INSERT INTO `site_lang` VALUES ('153', '43', 'Inget hittat');
INSERT INTO `site_lang` VALUES ('151', '43', 'Online nu');
INSERT INTO `site_lang` VALUES ('150', '43', 'Ta bort profil');
INSERT INTO `site_lang` VALUES ('148', '43', 'Profil desactivation');
INSERT INTO `site_lang` VALUES ('149', '43', 'Efter bort din profil , kommer en del av dina data fÃ¶rloras utan Ã¥tervinning .');
INSERT INTO `site_lang` VALUES ('145', '43', 'Byt lÃ¶senord');
INSERT INTO `site_lang` VALUES ('146', '43', 'Du kan Ã¤ndra ditt nuvarande lÃ¶senord nedan');
INSERT INTO `site_lang` VALUES ('147', '43', 'Nytt lÃ¶senord');
INSERT INTO `site_lang` VALUES ('140', '43', 'KÃ¶pa krediter fÃ¶r skicka Gif och Avblockera privata bilder');
INSERT INTO `site_lang` VALUES ('144', '43', 'Uppgradera till premium-konto');
INSERT INTO `site_lang` VALUES ('143', '43', 'LÃ¤gg krediter');
INSERT INTO `site_lang` VALUES ('142', '43', 'Aktuella krediter');
INSERT INTO `site_lang` VALUES ('141', '43', 'AnvÃ¤ndartyp');
INSERT INTO `site_lang` VALUES ('135', '43', 'Uppdatera profil');
INSERT INTO `site_lang` VALUES ('136', '43', 'Verifiera konto');
INSERT INTO `site_lang` VALUES ('137', '43', 'FÃ¶r kontrollera ditt konto kan du ansluta med ditt Facebook-konto');
INSERT INTO `site_lang` VALUES ('139', '43', 'Du konto redan har verifierats');
INSERT INTO `site_lang` VALUES ('138', '43', 'Anslut till Facebook');
INSERT INTO `site_lang` VALUES ('134', '43', 'Site sprÃ¥k');
INSERT INTO `site_lang` VALUES ('133', '43', 'Du kan redigera din profilinformation nedan');
INSERT INTO `site_lang` VALUES ('132', '43', 'Personlig information');
INSERT INTO `site_lang` VALUES ('131', '43', 'Delete');
INSERT INTO `site_lang` VALUES ('130', '43', 'Byt lÃ¶senord');
INSERT INTO `site_lang` VALUES ('129', '43', 'Kontrollera');
INSERT INTO `site_lang` VALUES ('127', '43', 'Personlig');
INSERT INTO `site_lang` VALUES ('128', '43', 'krediter');
INSERT INTO `site_lang` VALUES ('126', '43', 'Avblockera privata bilder');
INSERT INTO `site_lang` VALUES ('125', '43', 'Be om tillÃ¥telse till');
INSERT INTO `site_lang` VALUES ('124', '43', 'Nu har du');
INSERT INTO `site_lang` VALUES ('123', '43', 'Krediter har lagts till i ditt konto');
INSERT INTO `site_lang` VALUES ('122', '43', 'pojkar och flickor');
INSERT INTO `site_lang` VALUES ('121', '43', 'Bara tjejer');
INSERT INTO `site_lang` VALUES ('120', '43', 'endast pojkar');
INSERT INTO `site_lang` VALUES ('119', '43', 'Ã¥r gammal');
INSERT INTO `site_lang` VALUES ('118', '43', 'Personlig information');
INSERT INTO `site_lang` VALUES ('117', '43', 'Handla om');
INSERT INTO `site_lang` VALUES ('116', '43', 'Mest populÃ¤ra anvÃ¤ndare');
INSERT INTO `site_lang` VALUES ('115', '43', 'VÃ¤rld');
INSERT INTO `site_lang` VALUES ('114', '43', 'inom en radie av');
INSERT INTO `site_lang` VALUES ('112', '43', 'BÃ¥da');
INSERT INTO `site_lang` VALUES ('113', '43', 'som Ã¤r mellan');
INSERT INTO `site_lang` VALUES ('111', '43', 'pojkar');
INSERT INTO `site_lang` VALUES ('109', '43', 'Visa mig');
INSERT INTO `site_lang` VALUES ('110', '43', 'Flickor');
INSERT INTO `site_lang` VALUES ('107', '43', 'Alla anvÃ¤ndare');
INSERT INTO `site_lang` VALUES ('108', '43', 'Online nu');
INSERT INTO `site_lang` VALUES ('106', '43', 'Filter SÃ¶k');
INSERT INTO `site_lang` VALUES ('105', '43', 'dina trÃ¤ffar');
INSERT INTO `site_lang` VALUES ('101', '43', 'Din fans');
INSERT INTO `site_lang` VALUES ('102', '43', 'Integritetspolicy');
INSERT INTO `site_lang` VALUES ('103', '43', 'Termer av anvÃ¤ndare');
INSERT INTO `site_lang` VALUES ('104', '43', 'Fyll din profil innan start i');
INSERT INTO `site_lang` VALUES ('100', '43', 'eller vÃ¤nta tills i morgon fÃ¶r att fortsÃ¤tta att trÃ¤ffa mÃ¤nniskor');
INSERT INTO `site_lang` VALUES ('98', '43', 'och fÃ¥ upp till');
INSERT INTO `site_lang` VALUES ('99', '43', 'dagliga samtal');
INSERT INTO `site_lang` VALUES ('97', '43', 'Uppgradera ditt konto till Premium');
INSERT INTO `site_lang` VALUES ('96', '43', 'eller');
INSERT INTO `site_lang` VALUES ('95', '43', 'mer daglig konversation');
INSERT INTO `site_lang` VALUES ('94', '43', 'KÃ¶pa');
INSERT INTO `site_lang` VALUES ('93', '43', 'Att fortsÃ¤tta chatta');
INSERT INTO `site_lang` VALUES ('92', '43', 'du har nÃ¥tt grÃ¤nsen fÃ¶r nya dagliga samtal');
INSERT INTO `site_lang` VALUES ('91', '43', 'Chat');
INSERT INTO `site_lang` VALUES ('89', '43', 'Skriv text hÃ¤r');
INSERT INTO `site_lang` VALUES ('90', '43', 'Skicka');
INSERT INTO `site_lang` VALUES ('88', '43', 'Premie anvÃ¤ndare badge');
INSERT INTO `site_lang` VALUES ('87', '43', 'Avblockera alla privata bilder');
INSERT INTO `site_lang` VALUES ('86', '43', 'ObegrÃ¤nsade videosamtal');
INSERT INTO `site_lang` VALUES ('85', '43', 'nya chatt per dag');
INSERT INTO `site_lang` VALUES ('84', '43', 'Premium Kontofunktioner');
INSERT INTO `site_lang` VALUES ('82', '43', 'Betala med');
INSERT INTO `site_lang` VALUES ('83', '43', 'KÃ¶p krediter');
INSERT INTO `site_lang` VALUES ('81', '43', 'Betala med');
INSERT INTO `site_lang` VALUES ('80', '43', 'VÃ¤lj betalningsmetod');
INSERT INTO `site_lang` VALUES ('79', '43', 'VÃ¤ljer krediter paket');
INSERT INTO `site_lang` VALUES ('78', '43', 'KÃ¶pa krediter / Uppgradera konto');
INSERT INTO `site_lang` VALUES ('77', '43', 'Skicka gÃ¥va');
INSERT INTO `site_lang` VALUES ('76', '43', 'VÃ¤lj den gÃ¥va du vill skicka till');
INSERT INTO `site_lang` VALUES ('75', '43', 'Skicka present till');
INSERT INTO `site_lang` VALUES ('74', '43', 'LÃ¤gg till foto');
INSERT INTO `site_lang` VALUES ('73', '43', 'Krediter');
INSERT INTO `site_lang` VALUES ('72', '43', 'VÃ¤lj det foto som du vill visa i Spotlight , kostnad');
INSERT INTO `site_lang` VALUES ('71', '43', 'LÃ¤gg dig till Spotlight');
INSERT INTO `site_lang` VALUES ('70', '43', 'lÃ¤gga till foton');
INSERT INTO `site_lang` VALUES ('69', '43', 'LÃ¤gg till dina bilder');
INSERT INTO `site_lang` VALUES ('68', '43', 'privata bilder');
INSERT INTO `site_lang` VALUES ('67', '43', 'Publika foton');
INSERT INTO `site_lang` VALUES ('66', '43', 'Alla foton');
INSERT INTO `site_lang` VALUES ('65', '43', 'Hantera dina bilder');
INSERT INTO `site_lang` VALUES ('64', '43', 'Kontakta');
INSERT INTO `site_lang` VALUES ('63', '43', 'Privatliv');
INSERT INTO `site_lang` VALUES ('62', '43', 'Villkor');
INSERT INTO `site_lang` VALUES ('61', '43', 'Vem att gilla');
INSERT INTO `site_lang` VALUES ('60', '43', 'Nya meddelanden');
INSERT INTO `site_lang` VALUES ('59', '43', 'Online nu');
INSERT INTO `site_lang` VALUES ('58', '43', 'Konversationer');
INSERT INTO `site_lang` VALUES ('56', '43', 'Alla');
INSERT INTO `site_lang` VALUES ('57', '43', 'Fans');
INSERT INTO `site_lang` VALUES ('55', '43', 'instÃ¤llningar');
INSERT INTO `site_lang` VALUES ('53', '43', 'Fans');
INSERT INTO `site_lang` VALUES ('54', '43', 'Hantera foton');
INSERT INTO `site_lang` VALUES ('52', '43', 'Flesta populars');
INSERT INTO `site_lang` VALUES ('51', '43', 'TÃ¤ndstickor');
INSERT INTO `site_lang` VALUES ('50', '43', 'Discover');
INSERT INTO `site_lang` VALUES ('49', '43', 'TrÃ¤ffa nya mÃ¤nniskor');
INSERT INTO `site_lang` VALUES ('48', '43', 'Logga ut');
INSERT INTO `site_lang` VALUES ('47', '43', 'InstÃ¤llningar');
INSERT INTO `site_lang` VALUES ('46', '43', 'Profil');
INSERT INTO `site_lang` VALUES ('44', '43', 'och');
INSERT INTO `site_lang` VALUES ('45', '43', 'Integritetspolicy');
INSERT INTO `site_lang` VALUES ('43', '43', 'Villkor');
INSERT INTO `site_lang` VALUES ('42', '43', 'Genom att fortsÃ¤tta , bekrÃ¤ftar du att du har lÃ¤st och samtycker till vÃ¥r');
INSERT INTO `site_lang` VALUES ('40', '43', 'MÃ¶t pojkar och flickor');
INSERT INTO `site_lang` VALUES ('41', '43', 'Registrera dig');
INSERT INTO `site_lang` VALUES ('39', '43', 'MÃ¶t pojkar');
INSERT INTO `site_lang` VALUES ('38', '43', 'TrÃ¤ffa tjejer');
INSERT INTO `site_lang` VALUES ('37', '43', 'Im hÃ¤r');
INSERT INTO `site_lang` VALUES ('36', '43', 'Kvinna');
INSERT INTO `site_lang` VALUES ('35', '43', 'Manlig');
INSERT INTO `site_lang` VALUES ('34', '43', 'KÃ¶n');
INSERT INTO `site_lang` VALUES ('32', '43', 'Stad');
INSERT INTO `site_lang` VALUES ('33', '43', 'Var bor du?');
INSERT INTO `site_lang` VALUES ('31', '43', 'VÃ¤nligen vÃ¤lj');
INSERT INTO `site_lang` VALUES ('30', '43', 'FÃ¶delsedag');
INSERT INTO `site_lang` VALUES ('29', '43', 'LÃ¶senord');
INSERT INTO `site_lang` VALUES ('28', '43', 'Email');
INSERT INTO `site_lang` VALUES ('26', '43', 'Namn');
INSERT INTO `site_lang` VALUES ('27', '43', 'Ditt namn eller smeknamn .');
INSERT INTO `site_lang` VALUES ('25', '43', 'GÃ¥ med i vÃ¤rldens bestest community fÃ¶r att trÃ¤ffa nya mÃ¤nniskor !.');
INSERT INTO `site_lang` VALUES ('24', '43', 'Bli medlem nu');
INSERT INTO `site_lang` VALUES ('23', '43', 'Spela vÃ¥r populÃ¤ra UpptÃ¤ck spel och fÃ¥ matchas med andra anvÃ¤ndare . Dess ett bra sÃ¤tt att bryta isen och chatta med nya mÃ¤nniskor .');
INSERT INTO `site_lang` VALUES ('22', '43', 'TÃ¤ndstickor');
INSERT INTO `site_lang` VALUES ('21', '43', 'Vi kommer inte visa din exakta position , men du kommer att kunna hitta personer i nÃ¤rheten som gillar samma saker du gÃ¶r .');
INSERT INTO `site_lang` VALUES ('20', '43', 'Folk i nÃ¤rheten');
INSERT INTO `site_lang` VALUES ('19', '43', 'Du kan gÃ¶ra kvalitetsvideosamtal gratis till vem som helst , utan grÃ¤nserna fÃ¶r samtalslÃ¤ngd , bara njuta av att se den person som chattar med dig');
INSERT INTO `site_lang` VALUES ('18', '43', 'Video Chat');
INSERT INTO `site_lang` VALUES ('17', '43', 'Kraftfull privat chatt fÃ¶r trÃ¤ffa nya vÃ¤nner , kan du skicka kÃ¤nsloikoner och privata bilder till nÃ¥gon.');
INSERT INTO `site_lang` VALUES ('16', '43', 'Chat');
INSERT INTO `site_lang` VALUES ('15', '43', 'Ã…terstÃ¤lla lÃ¶senord');
INSERT INTO `site_lang` VALUES ('14', '43', 'lÃ¶senord Ã¥terhÃ¤mta  sig');
INSERT INTO `site_lang` VALUES ('13', '43', 'Logga in nu');
INSERT INTO `site_lang` VALUES ('12', '43', 'ni glÃ¶mt lÃ¶senordet ?');
INSERT INTO `site_lang` VALUES ('11', '43', 'Ditt lÃ¶senord');
INSERT INTO `site_lang` VALUES ('10', '43', 'Din email');
INSERT INTO `site_lang` VALUES ('9', '43', 'VÃ¤lkommen tillbaka');
INSERT INTO `site_lang` VALUES ('8', '43', 'Skapa ditt konto');
INSERT INTO `site_lang` VALUES ('7', '43', 'Ansluta till');
INSERT INTO `site_lang` VALUES ('6', '43', 'SNART TILLGÃ„NGLIG');
INSERT INTO `site_lang` VALUES ('5', '43', 'Snart kommer vi att ha vÃ¥ra telefon apps pÃ¥ nÃ¤tet');
INSERT INTO `site_lang` VALUES ('4', '43', 'BesÃ¶k oss frÃ¥n din bÃ¤rbara dator eller PC');
INSERT INTO `site_lang` VALUES ('3', '43', 'FÃ¶r nu vÃ¥r webbplats fungerar bara fÃ¶r skrivbordsanvÃ¤ndare');
INSERT INTO `site_lang` VALUES ('2', '43', 'VÃ¤lkommen till den snabbast vÃ¤xande stÃ¤lle att trÃ¤ffa nya mÃ¤nniskor');
INSERT INTO `site_lang` VALUES ('1', '43', 'Logga in');
INSERT INTO `site_lang` VALUES ('0', '43', 'trÃ¤ffa nya mÃ¤nniskor!');
INSERT INTO `site_lang` VALUES ('339', '1', 'of');
INSERT INTO `site_lang` VALUES ('337', '1', 'is calling you..');
INSERT INTO `site_lang` VALUES ('338', '1', 'Photos of ');
INSERT INTO `site_lang` VALUES ('336', '1', 'Password successfully changed');
INSERT INTO `site_lang` VALUES ('331', '1', 'username');
INSERT INTO `site_lang` VALUES ('332', '1', 'days of Premium');
INSERT INTO `site_lang` VALUES ('333', '1', 'Wrong');
INSERT INTO `site_lang` VALUES ('334', '1', 'Spotlight');
INSERT INTO `site_lang` VALUES ('335', '1', 'Service cost');
INSERT INTO `site_lang` VALUES ('323', '1', 'years old and im from');
INSERT INTO `site_lang` VALUES ('324', '1', 'We sended you a email for verify your account');
INSERT INTO `site_lang` VALUES ('325', '1', 'is blocking you or you blocked him, you cant chat with him sorry');
INSERT INTO `site_lang` VALUES ('326', '1', 'Report and block');
INSERT INTO `site_lang` VALUES ('327', '1', 'Are you sure you want to report');
INSERT INTO `site_lang` VALUES ('328', '1', 'Press backspace key for smart return to the meeting section.');
INSERT INTO `site_lang` VALUES ('329', '1', 'Write your instagram username');
INSERT INTO `site_lang` VALUES ('330', '1', 'You need to write your username!');
INSERT INTO `site_lang` VALUES ('321', '1', 'Please add a profile photo');
INSERT INTO `site_lang` VALUES ('322', '1', 'Hi, im');
INSERT INTO `site_lang` VALUES ('320', '1', 'Please verify your account, check your email');
INSERT INTO `site_lang` VALUES ('317', '1', 'minutes');
INSERT INTO `site_lang` VALUES ('318', '1', 'seconds');
INSERT INTO `site_lang` VALUES ('319', '1', 'ago');
INSERT INTO `site_lang` VALUES ('315', '1', 'days');
INSERT INTO `site_lang` VALUES ('316', '1', 'hours');
INSERT INTO `site_lang` VALUES ('313', '1', 'years');
INSERT INTO `site_lang` VALUES ('314', '1', 'months');
INSERT INTO `site_lang` VALUES ('308', '1', 'month');
INSERT INTO `site_lang` VALUES ('309', '1', 'day');
INSERT INTO `site_lang` VALUES ('310', '1', 'hour');
INSERT INTO `site_lang` VALUES ('311', '1', 'minute');
INSERT INTO `site_lang` VALUES ('312', '1', 'second');
INSERT INTO `site_lang` VALUES ('305', '1', 'Credits for $');
INSERT INTO `site_lang` VALUES ('306', '1', '0 seconds');
INSERT INTO `site_lang` VALUES ('307', '1', 'year');
INSERT INTO `site_lang` VALUES ('301', '1', 'You dont have any visit yet');
INSERT INTO `site_lang` VALUES ('302', '1', 'visited');
INSERT INTO `site_lang` VALUES ('303', '1', 'You do not like anyone');
INSERT INTO `site_lang` VALUES ('304', '1', 'Cost');
INSERT INTO `site_lang` VALUES ('299', '1', 'Dislike');
INSERT INTO `site_lang` VALUES ('300', '1', 'AGE');
INSERT INTO `site_lang` VALUES ('297', '1', 'Messages');
INSERT INTO `site_lang` VALUES ('298', '1', 'Like');
INSERT INTO `site_lang` VALUES ('293', '1', 'people visited your profile for see them');
INSERT INTO `site_lang` VALUES ('294', '1', 'Upgrade your account to premium');
INSERT INTO `site_lang` VALUES ('295', '1', 'People i like');
INSERT INTO `site_lang` VALUES ('296', '1', 'people liked you, for see them');
INSERT INTO `site_lang` VALUES ('290', '1', 'Private photo');
INSERT INTO `site_lang` VALUES ('291', '1', 'Public photo');
INSERT INTO `site_lang` VALUES ('292', '1', 'Delete');
INSERT INTO `site_lang` VALUES ('283', '1', 'Add');
INSERT INTO `site_lang` VALUES ('284', '1', 'Photos');
INSERT INTO `site_lang` VALUES ('285', '1', 'Credits');
INSERT INTO `site_lang` VALUES ('286', '1', 'Visits');
INSERT INTO `site_lang` VALUES ('287', '1', 'Add me here');
INSERT INTO `site_lang` VALUES ('288', '1', 'get seen by millions');
INSERT INTO `site_lang` VALUES ('289', '1', 'Set as profile');
INSERT INTO `site_lang` VALUES ('281', '1', 'Private photos');
INSERT INTO `site_lang` VALUES ('282', '1', 'Add from ');
INSERT INTO `site_lang` VALUES ('273', '1', 'Month');
INSERT INTO `site_lang` VALUES ('274', '1', 'Year');
INSERT INTO `site_lang` VALUES ('275', '1', 'Please wait');
INSERT INTO `site_lang` VALUES ('276', '1', 'Interests');
INSERT INTO `site_lang` VALUES ('277', '1', 'Report');
INSERT INTO `site_lang` VALUES ('278', '1', 'Fans');
INSERT INTO `site_lang` VALUES ('279', '1', 'No data');
INSERT INTO `site_lang` VALUES ('280', '1', 'Public Photos');
INSERT INTO `site_lang` VALUES ('265', '1', 'I own a car');
INSERT INTO `site_lang` VALUES ('266', '1', 'I own a motorbike');
INSERT INTO `site_lang` VALUES ('267', '1', 'None');
INSERT INTO `site_lang` VALUES ('268', '1', 'When someone likes me');
INSERT INTO `site_lang` VALUES ('269', '1', 'When i get a match');
INSERT INTO `site_lang` VALUES ('270', '1', 'When new users near me join in');
INSERT INTO `site_lang` VALUES ('271', '1', 'When someone send me a message');
INSERT INTO `site_lang` VALUES ('272', '1', 'Day');
INSERT INTO `site_lang` VALUES ('261', '1', 'Sometimes');
INSERT INTO `site_lang` VALUES ('262', '1', 'Drink');
INSERT INTO `site_lang` VALUES ('263', '1', 'Transport');
INSERT INTO `site_lang` VALUES ('264', '1', 'Parents car');
INSERT INTO `site_lang` VALUES ('250', '1', 'Heavy set');
INSERT INTO `site_lang` VALUES ('251', '1', 'Curvy');
INSERT INTO `site_lang` VALUES ('252', '1', 'Living');
INSERT INTO `site_lang` VALUES ('253', '1', 'With parents');
INSERT INTO `site_lang` VALUES ('254', '1', 'With housemate');
INSERT INTO `site_lang` VALUES ('255', '1', 'Student dormitory');
INSERT INTO `site_lang` VALUES ('256', '1', 'With partner');
INSERT INTO `site_lang` VALUES ('257', '1', 'Alone');
INSERT INTO `site_lang` VALUES ('258', '1', 'Smoke');
INSERT INTO `site_lang` VALUES ('259', '1', 'Yes');
INSERT INTO `site_lang` VALUES ('260', '1', 'No');
INSERT INTO `site_lang` VALUES ('244', '1', 'Indian');
INSERT INTO `site_lang` VALUES ('245', '1', 'Other');
INSERT INTO `site_lang` VALUES ('246', '1', 'Body type');
INSERT INTO `site_lang` VALUES ('247', '1', 'Slim');
INSERT INTO `site_lang` VALUES ('248', '1', 'Average');
INSERT INTO `site_lang` VALUES ('249', '1', 'Athletic');
INSERT INTO `site_lang` VALUES ('241', '1', 'Native American');
INSERT INTO `site_lang` VALUES ('242', '1', 'Hispanic/latin');
INSERT INTO `site_lang` VALUES ('243', '1', 'Pacific Islander');
INSERT INTO `site_lang` VALUES ('232', '1', 'Height');
INSERT INTO `site_lang` VALUES ('233', '1', 'less than');
INSERT INTO `site_lang` VALUES ('234', '1', 'more than');
INSERT INTO `site_lang` VALUES ('235', '1', 'Weight');
INSERT INTO `site_lang` VALUES ('236', '1', 'Ethnicity');
INSERT INTO `site_lang` VALUES ('237', '1', 'Asian');
INSERT INTO `site_lang` VALUES ('238', '1', 'Middle Eastern');
INSERT INTO `site_lang` VALUES ('239', '1', 'Black');
INSERT INTO `site_lang` VALUES ('240', '1', 'White');
INSERT INTO `site_lang` VALUES ('230', '1', 'Straight');
INSERT INTO `site_lang` VALUES ('231', '1', 'Bisexual');
INSERT INTO `site_lang` VALUES ('221', '1', 'Notifications');
INSERT INTO `site_lang` VALUES ('222', '1', 'Extended info (optional)');
INSERT INTO `site_lang` VALUES ('223', '1', 'Relationship');
INSERT INTO `site_lang` VALUES ('224', '1', 'Single');
INSERT INTO `site_lang` VALUES ('225', '1', 'Taken');
INSERT INTO `site_lang` VALUES ('226', '1', 'Open');
INSERT INTO `site_lang` VALUES ('227', '1', 'Sexuality');
INSERT INTO `site_lang` VALUES ('228', '1', 'Gay');
INSERT INTO `site_lang` VALUES ('229', '1', 'Open-minded');
INSERT INTO `site_lang` VALUES ('220', '1', 'UPGRADE');
INSERT INTO `site_lang` VALUES ('218', '1', 'until');
INSERT INTO `site_lang` VALUES ('219', '1', 'Basic');
INSERT INTO `site_lang` VALUES ('341', '27', 'Ti abbiamo inviato un e-mail con le tue informazioni , si puÃ² richiedere fino a 1 minuto per arrivare');
INSERT INTO `site_lang` VALUES ('340', '27', 'Caricamento in corso...');
INSERT INTO `site_lang` VALUES ('339', '27', 'di');
INSERT INTO `site_lang` VALUES ('338', '27', 'Foto di');
INSERT INTO `site_lang` VALUES ('337', '27', 'sta chiamando te ..');
INSERT INTO `site_lang` VALUES ('336', '27', 'Password cambiata con successo');
INSERT INTO `site_lang` VALUES ('335', '27', 'Costo del servizio');
INSERT INTO `site_lang` VALUES ('333', '27', 'Sbagliato');
INSERT INTO `site_lang` VALUES ('334', '27', 'Riflettore');
INSERT INTO `site_lang` VALUES ('332', '27', 'giorni di Premium');
INSERT INTO `site_lang` VALUES ('330', '27', 'Hai bisogno di scrivere il proprio nome utente !');
INSERT INTO `site_lang` VALUES ('331', '27', 'Nome utente');
INSERT INTO `site_lang` VALUES ('329', '27', 'Scrivi il tuo nome utente instagram');
INSERT INTO `site_lang` VALUES ('328', '27', 'Premere il tasto backspace per il ritorno intelligente alla sezione riunione.');
INSERT INTO `site_lang` VALUES ('327', '27', 'Sei certo di voler segnalare');
INSERT INTO `site_lang` VALUES ('326', '27', 'Relazione e blocco');
INSERT INTO `site_lang` VALUES ('325', '27', 'sta bloccando voi o lui bloccato , non puoi chattare con lui dispiace');
INSERT INTO `site_lang` VALUES ('324', '27', 'Vi inviÃ² una e-mail per verificare il tuo account');
INSERT INTO `site_lang` VALUES ('323', '27', 'anni e im da');
INSERT INTO `site_lang` VALUES ('322', '27', 'Ciao sono');
INSERT INTO `site_lang` VALUES ('321', '27', 'Si prega di aggiungere una foto del profilo');
INSERT INTO `site_lang` VALUES ('320', '27', 'Si prega di verificare il tuo account , controllare la posta elettronica');
INSERT INTO `site_lang` VALUES ('319', '27', 'fa');
INSERT INTO `site_lang` VALUES ('318', '27', 'secondi');
INSERT INTO `site_lang` VALUES ('317', '27', 'minuti');
INSERT INTO `site_lang` VALUES ('316', '27', 'ore');
INSERT INTO `site_lang` VALUES ('315', '27', 'giorni');
INSERT INTO `site_lang` VALUES ('314', '27', 'mesi');
INSERT INTO `site_lang` VALUES ('313', '27', 'anni');
INSERT INTO `site_lang` VALUES ('312', '27', 'secondo');
INSERT INTO `site_lang` VALUES ('311', '27', 'minuto');
INSERT INTO `site_lang` VALUES ('310', '27', 'ora');
INSERT INTO `site_lang` VALUES ('309', '27', 'giorno');
INSERT INTO `site_lang` VALUES ('308', '27', 'mese');
INSERT INTO `site_lang` VALUES ('307', '27', 'anno');
INSERT INTO `site_lang` VALUES ('306', '27', '0 secondi');
INSERT INTO `site_lang` VALUES ('305', '27', 'Crediti per $');
INSERT INTO `site_lang` VALUES ('304', '27', 'Costo');
INSERT INTO `site_lang` VALUES ('303', '27', 'Non ti piace a nessuno');
INSERT INTO `site_lang` VALUES ('302', '27', 'visitato');
INSERT INTO `site_lang` VALUES ('301', '27', 'Tu non abbia alcuna visita ancora');
INSERT INTO `site_lang` VALUES ('300', '27', 'ETÃ€');
INSERT INTO `site_lang` VALUES ('299', '27', 'Avversione');
INSERT INTO `site_lang` VALUES ('298', '27', 'Piace');
INSERT INTO `site_lang` VALUES ('297', '27', 'Messaggi');
INSERT INTO `site_lang` VALUES ('296', '27', 'la gente ti Ã¨ piaciuto , per vederli');
INSERT INTO `site_lang` VALUES ('295', '27', 'Persone che mi piacciono');
INSERT INTO `site_lang` VALUES ('294', '27', 'Aggiorna il tuo account per premio');
INSERT INTO `site_lang` VALUES ('293', '27', 'persone hanno visitato il tuo profilo per vederli');
INSERT INTO `site_lang` VALUES ('292', '27', 'Cancellare');
INSERT INTO `site_lang` VALUES ('291', '27', 'foto Pubbliche');
INSERT INTO `site_lang` VALUES ('290', '27', 'Foto private');
INSERT INTO `site_lang` VALUES ('289', '27', 'Imposta come profiloDÃ©couvrez si vous aimez aussi');
INSERT INTO `site_lang` VALUES ('288', '27', 'ottenere visto da milioni');
INSERT INTO `site_lang` VALUES ('287', '27', 'Aggiungimi qui');
INSERT INTO `site_lang` VALUES ('286', '27', 'Visite');
INSERT INTO `site_lang` VALUES ('285', '27', 'Crediti');
INSERT INTO `site_lang` VALUES ('284', '27', 'Fotografie');
INSERT INTO `site_lang` VALUES ('283', '27', 'Aggiungere');
INSERT INTO `site_lang` VALUES ('282', '27', 'Aggiungi da');
INSERT INTO `site_lang` VALUES ('281', '27', 'Foto private');
INSERT INTO `site_lang` VALUES ('280', '27', 'Foto pubbliche');
INSERT INTO `site_lang` VALUES ('279', '27', 'Nessun dato');
INSERT INTO `site_lang` VALUES ('277', '27', 'Rapporto');
INSERT INTO `site_lang` VALUES ('278', '27', 'Fans');
INSERT INTO `site_lang` VALUES ('276', '27', 'Interessi');
INSERT INTO `site_lang` VALUES ('275', '27', 'Attendere prego');
INSERT INTO `site_lang` VALUES ('274', '27', 'Anno');
INSERT INTO `site_lang` VALUES ('273', '27', 'Mese');
INSERT INTO `site_lang` VALUES ('272', '27', 'Giorno');
INSERT INTO `site_lang` VALUES ('271', '27', 'Quando qualcuno mi invia un messaggio');
INSERT INTO `site_lang` VALUES ('270', '27', 'Quando i nuovi utenti vicino a me si uniscono');
INSERT INTO `site_lang` VALUES ('269', '27', 'Quando ottengo un match');
INSERT INTO `site_lang` VALUES ('268', '27', 'Quando qualcuno mi ama');
INSERT INTO `site_lang` VALUES ('267', '27', 'Nessuna');
INSERT INTO `site_lang` VALUES ('266', '27', 'I Possiedo una moto');
INSERT INTO `site_lang` VALUES ('265', '27', 'Possiedo una macchina');
INSERT INTO `site_lang` VALUES ('264', '27', 'auto genitori');
INSERT INTO `site_lang` VALUES ('263', '27', 'Trasporto');
INSERT INTO `site_lang` VALUES ('262', '27', 'Bere');
INSERT INTO `site_lang` VALUES ('261', '27', 'A volte');
INSERT INTO `site_lang` VALUES ('260', '27', 'No');
INSERT INTO `site_lang` VALUES ('259', '27', 'sÃ¬');
INSERT INTO `site_lang` VALUES ('258', '27', 'Fumo');
INSERT INTO `site_lang` VALUES ('257', '27', 'Da solo');
INSERT INTO `site_lang` VALUES ('256', '27', 'con partner');
INSERT INTO `site_lang` VALUES ('255', '27', 'dormitorio degli studenti');
INSERT INTO `site_lang` VALUES ('254', '27', 'con coinquilino');
INSERT INTO `site_lang` VALUES ('253', '27', 'Con i genitori');
INSERT INTO `site_lang` VALUES ('252', '27', 'Vita');
INSERT INTO `site_lang` VALUES ('251', '27', 'Formosa');
INSERT INTO `site_lang` VALUES ('250', '27', 'pesante dell&#039;insieme');
INSERT INTO `site_lang` VALUES ('249', '27', 'Atletico');
INSERT INTO `site_lang` VALUES ('248', '27', 'Media');
INSERT INTO `site_lang` VALUES ('247', '27', 'Sottile');
INSERT INTO `site_lang` VALUES ('246', '27', 'Tipo di corpo');
INSERT INTO `site_lang` VALUES ('245', '27', 'Altro');
INSERT INTO `site_lang` VALUES ('243', '27', 'Abitante delle isole del Pacifico');
INSERT INTO `site_lang` VALUES ('244', '27', 'Indiano');
INSERT INTO `site_lang` VALUES ('242', '27', 'Spagnolo / Latin');
INSERT INTO `site_lang` VALUES ('241', '27', 'Nativo americano');
INSERT INTO `site_lang` VALUES ('239', '27', 'Nero');
INSERT INTO `site_lang` VALUES ('240', '27', 'Bianca');
INSERT INTO `site_lang` VALUES ('238', '27', 'Medio orientale');
INSERT INTO `site_lang` VALUES ('237', '27', 'Asiatico');
INSERT INTO `site_lang` VALUES ('236', '27', 'Razza');
INSERT INTO `site_lang` VALUES ('235', '27', 'Peso');
INSERT INTO `site_lang` VALUES ('234', '27', 'piÃ¹ di');
INSERT INTO `site_lang` VALUES ('233', '27', 'meno di');
INSERT INTO `site_lang` VALUES ('232', '27', 'Altezza');
INSERT INTO `site_lang` VALUES ('231', '27', 'Bisessuale');
INSERT INTO `site_lang` VALUES ('229', '27', 'Di larghe vedute');
INSERT INTO `site_lang` VALUES ('230', '27', 'Dritto');
INSERT INTO `site_lang` VALUES ('228', '27', 'Gay');
INSERT INTO `site_lang` VALUES ('227', '27', 'SessualitÃ ');
INSERT INTO `site_lang` VALUES ('226', '27', 'aperto');
INSERT INTO `site_lang` VALUES ('225', '27', 'Prese');
INSERT INTO `site_lang` VALUES ('224', '27', 'Dingolo');
INSERT INTO `site_lang` VALUES ('223', '27', 'Relazione');
INSERT INTO `site_lang` VALUES ('222', '27', 'Informazioni estesa ( opzionale )');
INSERT INTO `site_lang` VALUES ('221', '27', 'Notifiche');
INSERT INTO `site_lang` VALUES ('220', '27', 'UPGRADE');
INSERT INTO `site_lang` VALUES ('219', '27', 'Di base');
INSERT INTO `site_lang` VALUES ('218', '27', 'fino a');
INSERT INTO `site_lang` VALUES ('217', '27', 'attendere piÃ¹');
INSERT INTO `site_lang` VALUES ('216', '27', 'Fine chiamata');
INSERT INTO `site_lang` VALUES ('215', '27', 'Sembra che il tuo amico non hanno webcam o non Ã¨ disponibile');
INSERT INTO `site_lang` VALUES ('214', '27', 'aspettare troppo a lungo');
INSERT INTO `site_lang` VALUES ('213', '27', 'Non puoi fare videocall perchÃ© non avete webcam');
INSERT INTO `site_lang` VALUES ('212', '27', 'Impossibile effettuare una chiamata !');
INSERT INTO `site_lang` VALUES ('211', '27', 'Solo gli utenti premium possono effettuare videochiamate');
INSERT INTO `site_lang` VALUES ('210', '27', 'Sei giÃ  in una videochiamata , Ã¨ necessario terminare la chiamata prima di altri iniziare un altro');
INSERT INTO `site_lang` VALUES ('209', '27', 'Si prega di consentire l&#039;accesso alla webcam .');
INSERT INTO `site_lang` VALUES ('208', '27', 'non Ã¨ in linea , provare di nuovo quando il tuo amico Ã¨ in linea');
INSERT INTO `site_lang` VALUES ('207', '27', 'Ã¨ in un altro videocall , non puoi chiamare ora');
INSERT INTO `site_lang` VALUES ('206', '27', 'eliminarlo');
INSERT INTO `site_lang` VALUES ('205', '27', 'I suoi dati saranno persi senza recupero , continuano ?');
INSERT INTO `site_lang` VALUES ('204', '27', 'chiusura dell&#039;account');
INSERT INTO `site_lang` VALUES ('203', '27', 'Informazioni aggiornate con successo');
INSERT INTO `site_lang` VALUES ('202', '27', 'SÃ¬ , comprarlo!');
INSERT INTO `site_lang` VALUES ('201', '27', 'piÃ¹ conversazione quotidiana , costo');
INSERT INTO `site_lang` VALUES ('200', '27', 'Expand limite giornaliero');
INSERT INTO `site_lang` VALUES ('199', '27', 'Non avete crediti abbastanza per inviare il regalo');
INSERT INTO `site_lang` VALUES ('198', '27', 'Si prega di selezionare 1 regalo');
INSERT INTO `site_lang` VALUES ('197', '27', 'Si prega di selezionare 1 foto');
INSERT INTO `site_lang` VALUES ('196', '27', 'Si prega di selezionare un metodo di pagamento');
INSERT INTO `site_lang` VALUES ('194', '27', 'Avere accesso');
INSERT INTO `site_lang` VALUES ('195', '27', 'No grazie');
INSERT INTO `site_lang` VALUES ('193', '27', 'foto private per');
INSERT INTO `site_lang` VALUES ('192', '27', 'Ottenere l&#039;accesso a');
INSERT INTO `site_lang` VALUES ('191', '27', 'Acquista foto permessi privato');
INSERT INTO `site_lang` VALUES ('190', '27', 'No , non posso vedere io le mie foto private');
INSERT INTO `site_lang` VALUES ('189', '27', 'SÃ¬ , puoi vedere le mie foto private');
INSERT INTO `site_lang` VALUES ('188', '27', 'Email giÃ  esistente , provare con un altro');
INSERT INTO `site_lang` VALUES ('187', '27', 'Password troppo corta');
INSERT INTO `site_lang` VALUES ('186', '27', 'Scegli cittÃ  dal completamento automatico');
INSERT INTO `site_lang` VALUES ('185', '27', 'Aggiungere una data valida');
INSERT INTO `site_lang` VALUES ('184', '27', 'Password errata');
INSERT INTO `site_lang` VALUES ('183', '27', 'Email dont esistono');
INSERT INTO `site_lang` VALUES ('182', '27', 'Si prega di riempire tutti gli ingressi');
INSERT INTO `site_lang` VALUES ('181', '27', 'formato email non valido');
INSERT INTO `site_lang` VALUES ('180', '27', 'password recuperare');
INSERT INTO `site_lang` VALUES ('179', '27', 'Login per il mio conto');
INSERT INTO `site_lang` VALUES ('178', '27', 'Se non ricordi la password, clicca sul link qui sotto per impostare una nuova:');
INSERT INTO `site_lang` VALUES ('177', '27', 'Ciao');
INSERT INTO `site_lang` VALUES ('176', '27', 'No');
INSERT INTO `site_lang` VALUES ('175', '27', 'sÃ¬');
INSERT INTO `site_lang` VALUES ('174', '27', 'Ciao , posso avere accesso alle foto private ?');
INSERT INTO `site_lang` VALUES ('173', '27', 'come questo');
INSERT INTO `site_lang` VALUES ('172', '27', 'piÃ¹ persone come questo');
INSERT INTO `site_lang` VALUES ('171', '27', 'giorni Premium');
INSERT INTO `site_lang` VALUES ('170', '27', 'Acquistare');
INSERT INTO `site_lang` VALUES ('169', '27', 'Dicembre');
INSERT INTO `site_lang` VALUES ('168', '27', 'Novembre');
INSERT INTO `site_lang` VALUES ('167', '27', 'Ottobre');
INSERT INTO `site_lang` VALUES ('166', '27', 'Settembre');
INSERT INTO `site_lang` VALUES ('165', '27', 'Agosto');
INSERT INTO `site_lang` VALUES ('164', '27', 'Luglio');
INSERT INTO `site_lang` VALUES ('163', '27', 'Giugno');
INSERT INTO `site_lang` VALUES ('162', '27', 'PuÃ²');
INSERT INTO `site_lang` VALUES ('161', '27', 'Aprile');
INSERT INTO `site_lang` VALUES ('160', '27', 'Marzo');
INSERT INTO `site_lang` VALUES ('159', '27', 'Febbraio');
INSERT INTO `site_lang` VALUES ('158', '27', 'Gennaio');
INSERT INTO `site_lang` VALUES ('157', '27', 'Non avete ancora le partite');
INSERT INTO `site_lang` VALUES ('156', '27', 'Non avete ancora nessun fan');
INSERT INTO `site_lang` VALUES ('155', '27', 'Nessun utente famose vicino a te');
INSERT INTO `site_lang` VALUES ('154', '27', 'persone pensano');
INSERT INTO `site_lang` VALUES ('153', '27', 'Non abbiamo trovato nulla');
INSERT INTO `site_lang` VALUES ('152', '27', 'verificata');
INSERT INTO `site_lang` VALUES ('151', '27', 'Online adesso');
INSERT INTO `site_lang` VALUES ('150', '27', 'Elimina profilo');
INSERT INTO `site_lang` VALUES ('149', '27', 'Dopo eliminare il tuo profilo , alcuni dei vostri dati saranno persi senza recupero');
INSERT INTO `site_lang` VALUES ('148', '27', 'DISINSERIMENTO Profilo');
INSERT INTO `site_lang` VALUES ('147', '27', 'Nuova password');
INSERT INTO `site_lang` VALUES ('146', '27', 'Ãˆ possibile modificare la password attuale muggito');
INSERT INTO `site_lang` VALUES ('145', '27', 'Cambia la password');
INSERT INTO `site_lang` VALUES ('144', '27', 'Aggiornamento a account premium');
INSERT INTO `site_lang` VALUES ('143', '27', 'Aggiungere crediti');
INSERT INTO `site_lang` VALUES ('142', '27', 'Crediti correnti');
INSERT INTO `site_lang` VALUES ('141', '27', 'Tipo di account');
INSERT INTO `site_lang` VALUES ('140', '27', 'Comprare crediti per inviare Gif e sbloccare foto private');
INSERT INTO `site_lang` VALUES ('139', '27', 'Stai account Ã¨ giÃ  verificato');
INSERT INTO `site_lang` VALUES ('138', '27', 'Connettiti con facebook');
INSERT INTO `site_lang` VALUES ('137', '27', 'Per verificare il tuo account , connettersi con il tuo account facebook');
INSERT INTO `site_lang` VALUES ('136', '27', 'Verifica Account');
INSERT INTO `site_lang` VALUES ('135', '27', 'Aggiorna il profilo');
INSERT INTO `site_lang` VALUES ('134', '27', 'la lingua del sito');
INSERT INTO `site_lang` VALUES ('133', '27', 'Ãˆ possibile modificare le informazioni del profilo muggito');
INSERT INTO `site_lang` VALUES ('132', '27', 'Informazione personale');
INSERT INTO `site_lang` VALUES ('131', '27', 'Cancellare');
INSERT INTO `site_lang` VALUES ('130', '27', 'Cambia la password');
INSERT INTO `site_lang` VALUES ('129', '27', 'âœ“ Verifica');
INSERT INTO `site_lang` VALUES ('128', '27', 'Crediti');
INSERT INTO `site_lang` VALUES ('127', '27', 'Personale');
INSERT INTO `site_lang` VALUES ('126', '27', 'Sblocca foto private');
INSERT INTO `site_lang` VALUES ('125', '27', 'Chiedi il permesso di');
INSERT INTO `site_lang` VALUES ('124', '27', 'Ora avete');
INSERT INTO `site_lang` VALUES ('123', '27', 'Credits aggiunto con successo al tuo account');
INSERT INTO `site_lang` VALUES ('122', '27', 'ragazzi e ragazze');
INSERT INTO `site_lang` VALUES ('121', '27', 'Solo ragazze');
INSERT INTO `site_lang` VALUES ('120', '27', 'Solo ragazzi');
INSERT INTO `site_lang` VALUES ('119', '27', 'Anni');
INSERT INTO `site_lang` VALUES ('118', '27', 'Informazioni personali');
INSERT INTO `site_lang` VALUES ('117', '27', 'Di');
INSERT INTO `site_lang` VALUES ('116', '27', 'La maggior parte degli utenti popolari');
INSERT INTO `site_lang` VALUES ('115', '27', 'Mondo');
INSERT INTO `site_lang` VALUES ('114', '27', 'in un raggio di');
INSERT INTO `site_lang` VALUES ('113', '27', 'che sono tra i');
INSERT INTO `site_lang` VALUES ('112', '27', 'Entrambi');
INSERT INTO `site_lang` VALUES ('111', '27', 'Ragazzi');
INSERT INTO `site_lang` VALUES ('108', '27', 'Online adesso');
INSERT INTO `site_lang` VALUES ('109', '27', 'Fammi vedere');
INSERT INTO `site_lang` VALUES ('110', '27', 'Ragazze');
INSERT INTO `site_lang` VALUES ('107', '27', 'Tutti gli utenti');
INSERT INTO `site_lang` VALUES ('104', '27', 'Si prega di compilare il proprio profilo prima di iniziare a');
INSERT INTO `site_lang` VALUES ('105', '27', 'Le partite');
INSERT INTO `site_lang` VALUES ('106', '27', 'Filtro di ricerca');
INSERT INTO `site_lang` VALUES ('103', '27', 'Condizioni d&#039;uso');
INSERT INTO `site_lang` VALUES ('101', '27', 'I tuoi fan');
INSERT INTO `site_lang` VALUES ('102', '27', 'politica sulla riservatezza');
INSERT INTO `site_lang` VALUES ('98', '27', 'e arrivare fino a');
INSERT INTO `site_lang` VALUES ('99', '27', 'conversazioni quotidiane');
INSERT INTO `site_lang` VALUES ('100', '27', 'o aspettare fino a domani per continuare a soddisfare le persone');
INSERT INTO `site_lang` VALUES ('96', '27', 'o');
INSERT INTO `site_lang` VALUES ('97', '27', 'Aggiorna il tuo account per Premium');
INSERT INTO `site_lang` VALUES ('95', '27', 'piÃ¹ conversazione quotidiana');
INSERT INTO `site_lang` VALUES ('94', '27', 'Acquistare');
INSERT INTO `site_lang` VALUES ('93', '27', 'Per continuare a chattare');
INSERT INTO `site_lang` VALUES ('92', '27', 'si Ã¨ raggiunto il limite di nuove conversazioni quotidiane');
INSERT INTO `site_lang` VALUES ('91', '27', 'Chat');
INSERT INTO `site_lang` VALUES ('90', '27', 'Inviare');
INSERT INTO `site_lang` VALUES ('89', '27', 'Scrivi qui il testo');
INSERT INTO `site_lang` VALUES ('88', '27', 'distintivo utente Premium');
INSERT INTO `site_lang` VALUES ('87', '27', 'Sblocca tutte le foto private');
INSERT INTO `site_lang` VALUES ('86', '27', 'videochiamate illimitati');
INSERT INTO `site_lang` VALUES ('85', '27', 'nuove chat al giorno');
INSERT INTO `site_lang` VALUES ('84', '27', 'Caratteristiche Premium Account');
INSERT INTO `site_lang` VALUES ('83', '27', 'Acquista crediti');
INSERT INTO `site_lang` VALUES ('82', '27', 'Paga con');
INSERT INTO `site_lang` VALUES ('81', '27', 'Paga con');
INSERT INTO `site_lang` VALUES ('80', '27', 'Scegli il metodo di pagamento');
INSERT INTO `site_lang` VALUES ('79', '27', 'pacchetto Selezionare crediti');
INSERT INTO `site_lang` VALUES ('78', '27', 'Comprare crediti / Aggiornamento conto');
INSERT INTO `site_lang` VALUES ('77', '27', 'Invia REGALO');
INSERT INTO `site_lang` VALUES ('76', '27', 'Scegli il regalo che si desidera inviare a');
INSERT INTO `site_lang` VALUES ('75', '27', 'Regala ad');
INSERT INTO `site_lang` VALUES ('74', '27', 'Aggiungi foto');
INSERT INTO `site_lang` VALUES ('73', '27', 'Crediti');
INSERT INTO `site_lang` VALUES ('72', '27', 'Scegliere la foto che si desidera visualizzare sotto i riflettori, costo');
INSERT INTO `site_lang` VALUES ('71', '27', 'Aggiungere se stessi al primo piano');
INSERT INTO `site_lang` VALUES ('70', '27', 'Aggiungi foto');
INSERT INTO `site_lang` VALUES ('69', '27', 'Aggiungi le tue foto');
INSERT INTO `site_lang` VALUES ('68', '27', 'Foto privato');
INSERT INTO `site_lang` VALUES ('67', '27', 'Foto pubbliche');
INSERT INTO `site_lang` VALUES ('66', '27', 'tutte le foto');
INSERT INTO `site_lang` VALUES ('65', '27', 'Gestisci le tue foto');
INSERT INTO `site_lang` VALUES ('64', '27', 'Contatto');
INSERT INTO `site_lang` VALUES ('63', '27', 'Vita privata');
INSERT INTO `site_lang` VALUES ('62', '27', 'condizioni');
INSERT INTO `site_lang` VALUES ('61', '27', 'A chi piace');
INSERT INTO `site_lang` VALUES ('60', '27', 'I nuovi messaggi');
INSERT INTO `site_lang` VALUES ('59', '27', 'Online adesso');
INSERT INTO `site_lang` VALUES ('58', '27', 'Conversazioni');
INSERT INTO `site_lang` VALUES ('56', '27', 'Tutti');
INSERT INTO `site_lang` VALUES ('57', '27', 'Fans');
INSERT INTO `site_lang` VALUES ('55', '27', 'Impostazioni');
INSERT INTO `site_lang` VALUES ('54', '27', 'Gestire le foto');
INSERT INTO `site_lang` VALUES ('53', '27', 'Fans');
INSERT INTO `site_lang` VALUES ('52', '27', 'La maggior parte dei populars');
INSERT INTO `site_lang` VALUES ('51', '27', 'Fiammiferi');
INSERT INTO `site_lang` VALUES ('50', '27', 'Scoprire');
INSERT INTO `site_lang` VALUES ('49', '27', 'Incontrare nuove persone');
INSERT INTO `site_lang` VALUES ('48', '27', 'Disconnettersi');
INSERT INTO `site_lang` VALUES ('47', '27', 'impostazioni');
INSERT INTO `site_lang` VALUES ('46', '27', 'Profilo');
INSERT INTO `site_lang` VALUES ('45', '27', 'Politica sulla riservatezza');
INSERT INTO `site_lang` VALUES ('44', '27', 'e');
INSERT INTO `site_lang` VALUES ('43', '27', 'Termini e condizioni');
INSERT INTO `site_lang` VALUES ('42', '27', 'Continuando , si conferma di aver letto e accettato i');
INSERT INTO `site_lang` VALUES ('41', '27', 'Registrazione');
INSERT INTO `site_lang` VALUES ('40', '27', 'Incontra i ragazzi e le ragazze');
INSERT INTO `site_lang` VALUES ('39', '27', 'Incontra i ragazzi');
INSERT INTO `site_lang` VALUES ('38', '27', 'Incontra ragazze');
INSERT INTO `site_lang` VALUES ('37', '27', 'Sono qui per');
INSERT INTO `site_lang` VALUES ('36', '27', 'Femmina');
INSERT INTO `site_lang` VALUES ('35', '27', 'Maschio');
INSERT INTO `site_lang` VALUES ('34', '27', 'Genere');
INSERT INTO `site_lang` VALUES ('33', '27', 'Dove vivi?');
INSERT INTO `site_lang` VALUES ('32', '27', 'CittÃ ');
INSERT INTO `site_lang` VALUES ('31', '27', 'seleziona');
INSERT INTO `site_lang` VALUES ('30', '27', 'Compleanno');
INSERT INTO `site_lang` VALUES ('29', '27', 'parola d&#039;ordine');
INSERT INTO `site_lang` VALUES ('28', '27', 'Email');
INSERT INTO `site_lang` VALUES ('27', '27', 'Il tuo nome o nickname');
INSERT INTO `site_lang` VALUES ('26', '27', 'Nome');
INSERT INTO `site_lang` VALUES ('25', '27', 'Unire i mondi comunitÃ  bestest per incontrare nuove persone !.');
INSERT INTO `site_lang` VALUES ('24', '27', 'Diventa un membro ora');
INSERT INTO `site_lang` VALUES ('23', '27', 'Gioca nostro popolare Scopri gioco e ottenere abbinato con altri utenti . Il suo un ottimo modo per rompere il ghiaccio e chattare con persone nuove .');
INSERT INTO `site_lang` VALUES ('22', '27', 'Fiammiferi');
INSERT INTO `site_lang` VALUES ('21', '27', 'Ci voleva mostrare la posizione esatta , ma si sarÃ  in grado di trovare le persone vicine che amano le stesse cose che fate .');
INSERT INTO `site_lang` VALUES ('20', '27', 'Persone nelle vicinanze');
INSERT INTO `site_lang` VALUES ('19', '27', 'Ãˆ possibile effettuare videochiamate di qualitÃ  gratuitamente a chiunque , senza limiti di durata della chiamata , solo godere vedendo la persona che sta chattando con te');
INSERT INTO `site_lang` VALUES ('18', '27', 'Video Chat');
INSERT INTO `site_lang` VALUES ('17', '27', 'Potente chat privata per incontrare nuovi amici , Ã¨ possibile inviare emoticons e foto private a chiunque .');
INSERT INTO `site_lang` VALUES ('16', '27', 'Chat');
INSERT INTO `site_lang` VALUES ('15', '27', 'Recover password');
INSERT INTO `site_lang` VALUES ('14', '27', 'password recuperare');
INSERT INTO `site_lang` VALUES ('13', '27', 'Accedi ora');
INSERT INTO `site_lang` VALUES ('12', '27', 'Non si dimentica la password ?');
INSERT INTO `site_lang` VALUES ('11', '27', 'La tua password');
INSERT INTO `site_lang` VALUES ('10', '27', 'Benvenuto emailback');
INSERT INTO `site_lang` VALUES ('9', '27', 'Ben tornato');
INSERT INTO `site_lang` VALUES ('8', '27', 'Crea il tuo account');
INSERT INTO `site_lang` VALUES ('7', '27', 'Connesso con');
INSERT INTO `site_lang` VALUES ('6', '27', 'PRESTO DISPONIBILI');
INSERT INTO `site_lang` VALUES ('5', '27', 'Presto avremo le nostre applicazioni di telefonia on-line');
INSERT INTO `site_lang` VALUES ('4', '27', 'Si prega di visitare dal proprio computer portatile o PC');
INSERT INTO `site_lang` VALUES ('3', '27', 'Per ora il nostro sito funziona solo per gli utenti desktop');
INSERT INTO `site_lang` VALUES ('2', '27', 'Benvenuti nel posto piÃ¹ rapida crescita per incontrare nuove persone');
INSERT INTO `site_lang` VALUES ('1', '27', 'Accesso');
INSERT INTO `site_lang` VALUES ('0', '27', 'incontrare nuove persone!');
INSERT INTO `site_lang` VALUES ('341', '45', 'Size bilgi iÃ§eren bir e-posta gÃ¶nderdi , gelmesi 1 dakikaya kadar sÃ¼rebilir');
INSERT INTO `site_lang` VALUES ('340', '45', 'YÃ¼kleniyor...');
INSERT INTO `site_lang` VALUES ('338', '45', 'FotoÄŸraflar of');
INSERT INTO `site_lang` VALUES ('339', '45', '-Ä±n');
INSERT INTO `site_lang` VALUES ('337', '45', 'sizi Ã§aÄŸÄ±rÄ±yor ..');
INSERT INTO `site_lang` VALUES ('336', '45', 'Åžifre baÅŸarÄ±yla deÄŸiÅŸtirildi');
INSERT INTO `site_lang` VALUES ('334', '45', 'Spot');
INSERT INTO `site_lang` VALUES ('335', '45', 'Hizmet maliyeti');
INSERT INTO `site_lang` VALUES ('333', '45', 'YanlÄ±ÅŸ');
INSERT INTO `site_lang` VALUES ('332', '45', 'Premium gÃ¼n');
INSERT INTO `site_lang` VALUES ('331', '45', 'kullanÄ±cÄ± adÄ±');
INSERT INTO `site_lang` VALUES ('330', '45', 'KullanÄ±cÄ± adÄ±nÄ±zÄ± yazmak gerekir !');
INSERT INTO `site_lang` VALUES ('329', '45', 'Senin instagram kullanÄ±cÄ± adÄ±nÄ±zÄ± yazÄ±n');
INSERT INTO `site_lang` VALUES ('328', '45', 'ToplantÄ± bÃ¶lÃ¼mÃ¼ne akÄ±llÄ± dÃ¶nÃ¼ÅŸ iÃ§in geri tuÅŸuna basÄ±n tuÅŸuna basÄ±n.');
INSERT INTO `site_lang` VALUES ('327', '45', 'EÄŸer rapor etmek istediÄŸinizden emin misiniz');
INSERT INTO `site_lang` VALUES ('326', '45', 'Rapor ve blok');
INSERT INTO `site_lang` VALUES ('325', '45', 'Sizi bloke veya onu bloke , Ã¼zgÃ¼nÃ¼m onunla sohbet edemez');
INSERT INTO `site_lang` VALUES ('324', '45', 'HesabÄ±nÄ±zÄ± doÄŸrulamak iÃ§in size bir e-posta gÃ¶nderildi,');
INSERT INTO `site_lang` VALUES ('323', '45', 'yaÅŸÄ±nda ve im dan');
INSERT INTO `site_lang` VALUES ('322', '45', 'Merhaba ben');
INSERT INTO `site_lang` VALUES ('321', '45', 'Bir profil fotoÄŸrafÄ± ekleyin');
INSERT INTO `site_lang` VALUES ('318', '45', 'saniye');
INSERT INTO `site_lang` VALUES ('319', '45', 'evvel');
INSERT INTO `site_lang` VALUES ('320', '45', 'HesabÄ±nÄ±zÄ± doÄŸrulamak e-postanÄ±zÄ± kontrol edin');
INSERT INTO `site_lang` VALUES ('317', '45', 'dakikas');
INSERT INTO `site_lang` VALUES ('313', '45', 'yÄ±l');
INSERT INTO `site_lang` VALUES ('314', '45', 'ays');
INSERT INTO `site_lang` VALUES ('315', '45', 'gÃ¼nler');
INSERT INTO `site_lang` VALUES ('316', '45', 'saatler');
INSERT INTO `site_lang` VALUES ('312', '45', 'ikinci');
INSERT INTO `site_lang` VALUES ('309', '45', 'gÃ¼n');
INSERT INTO `site_lang` VALUES ('310', '45', 'saat');
INSERT INTO `site_lang` VALUES ('311', '45', 'dakika');
INSERT INTO `site_lang` VALUES ('308', '45', 'ay');
INSERT INTO `site_lang` VALUES ('305', '45', '$ IÃ§in krediler');
INSERT INTO `site_lang` VALUES ('306', '45', '0 saniye');
INSERT INTO `site_lang` VALUES ('307', '45', 'sene');
INSERT INTO `site_lang` VALUES ('304', '45', 'masraf');
INSERT INTO `site_lang` VALUES ('302', '45', 'ziyaret');
INSERT INTO `site_lang` VALUES ('303', '45', 'Sen kimseyi sevmiyorum');
INSERT INTO `site_lang` VALUES ('301', '45', 'HenÃ¼z herhangi bir ziyaret var yok');
INSERT INTO `site_lang` VALUES ('300', '45', 'YAÅž');
INSERT INTO `site_lang` VALUES ('299', '45', 'beÄŸenmeme');
INSERT INTO `site_lang` VALUES ('298', '45', 'Sevmek');
INSERT INTO `site_lang` VALUES ('297', '45', 'Mesajlar');
INSERT INTO `site_lang` VALUES ('296', '45', 'onlarÄ± gÃ¶rmek iÃ§in insanlar , seni sevdim');
INSERT INTO `site_lang` VALUES ('295', '45', 'Ä°nsanlar i gibi');
INSERT INTO `site_lang` VALUES ('294', '45', 'prim hesabÄ±nÄ±zÄ± yÃ¼kseltin');
INSERT INTO `site_lang` VALUES ('293', '45', 'insanlar onlarÄ± gÃ¶rmek iÃ§in profilinizi ziyaret');
INSERT INTO `site_lang` VALUES ('292', '45', 'kazÄ±mak');
INSERT INTO `site_lang` VALUES ('291', '45', 'kamu fotoÄŸraf');
INSERT INTO `site_lang` VALUES ('290', '45', 'Ã¶zel fotoÄŸraf');
INSERT INTO `site_lang` VALUES ('289', '45', 'profil olarak ayarla');
INSERT INTO `site_lang` VALUES ('288', '45', 'milyonlarca insan tarafÄ±ndan gÃ¶rÃ¼len olsun');
INSERT INTO `site_lang` VALUES ('287', '45', 'Beni buraya ekle');
INSERT INTO `site_lang` VALUES ('286', '45', 'ziyaretler');
INSERT INTO `site_lang` VALUES ('285', '45', 'Kredi');
INSERT INTO `site_lang` VALUES ('284', '45', 'FotoÄŸraflar');
INSERT INTO `site_lang` VALUES ('283', '45', 'Eklemek');
INSERT INTO `site_lang` VALUES ('282', '45', 'dan ekle');
INSERT INTO `site_lang` VALUES ('281', '45', 'Ã¶zel fotoÄŸraflar');
INSERT INTO `site_lang` VALUES ('280', '45', 'kamu Resimleri');
INSERT INTO `site_lang` VALUES ('279', '45', 'Veri yok');
INSERT INTO `site_lang` VALUES ('278', '45', 'Hayran');
INSERT INTO `site_lang` VALUES ('277', '45', 'Rapor');
INSERT INTO `site_lang` VALUES ('276', '45', 'Ä°lgi');
INSERT INTO `site_lang` VALUES ('275', '45', 'LÃ¼tfen bekle');
INSERT INTO `site_lang` VALUES ('274', '45', 'YÄ±l');
INSERT INTO `site_lang` VALUES ('273', '45', 'Ay');
INSERT INTO `site_lang` VALUES ('272', '45', 'GÃ¼n');
INSERT INTO `site_lang` VALUES ('271', '45', 'Birisi bana bir mesaj gÃ¶nderdiÄŸinizde');
INSERT INTO `site_lang` VALUES ('270', '45', 'Bana yakÄ±n yeni kullanÄ±cÄ±lar katÄ±lmak zaman');
INSERT INTO `site_lang` VALUES ('269', '45', 'Ben bir maÃ§ olsun');
INSERT INTO `site_lang` VALUES ('268', '45', 'Ne zaman birisi bana seviyor');
INSERT INTO `site_lang` VALUES ('267', '45', 'HiÃ§');
INSERT INTO `site_lang` VALUES ('266', '45', 'Ben bir motosiklet sahibi');
INSERT INTO `site_lang` VALUES ('265', '45', 'Ben bir araba sahibi');
INSERT INTO `site_lang` VALUES ('264', '45', 'ebeveynler araba');
INSERT INTO `site_lang` VALUES ('263', '45', 'taÅŸÄ±ma');
INSERT INTO `site_lang` VALUES ('262', '45', 'Ä°Ã§ki');
INSERT INTO `site_lang` VALUES ('261', '45', 'Bazen');
INSERT INTO `site_lang` VALUES ('260', '45', 'HayÄ±r');
INSERT INTO `site_lang` VALUES ('259', '45', 'Evet');
INSERT INTO `site_lang` VALUES ('258', '45', 'Duman');
INSERT INTO `site_lang` VALUES ('257', '45', 'YalnÄ±z');
INSERT INTO `site_lang` VALUES ('256', '45', 'EÅŸimle');
INSERT INTO `site_lang` VALUES ('255', '45', 'Ã–ÄŸrenci yurdu');
INSERT INTO `site_lang` VALUES ('254', '45', 'ev arkadaÅŸÄ± ile');
INSERT INTO `site_lang` VALUES ('253', '45', 'Ebeveynlerle');
INSERT INTO `site_lang` VALUES ('252', '45', 'yaÅŸam');
INSERT INTO `site_lang` VALUES ('251', '45', 'dÃ¼zgÃ¼n vÃ¼cutlu');
INSERT INTO `site_lang` VALUES ('250', '45', 'aÄŸÄ±r seti');
INSERT INTO `site_lang` VALUES ('249', '45', 'Atletik');
INSERT INTO `site_lang` VALUES ('247', '45', 'Ä°nce');
INSERT INTO `site_lang` VALUES ('248', '45', 'Ortalama');
INSERT INTO `site_lang` VALUES ('246', '45', 'VÃ¼cut tipi');
INSERT INTO `site_lang` VALUES ('245', '45', 'DiÄŸer');
INSERT INTO `site_lang` VALUES ('244', '45', 'Hint');
INSERT INTO `site_lang` VALUES ('243', '45', 'Pasifik adalÄ±');
INSERT INTO `site_lang` VALUES ('242', '45', 'latin / Hispanik');
INSERT INTO `site_lang` VALUES ('241', '45', 'Yerli Amerikan');
INSERT INTO `site_lang` VALUES ('240', '45', 'Beyaz');
INSERT INTO `site_lang` VALUES ('239', '45', 'Zenci');
INSERT INTO `site_lang` VALUES ('238', '45', 'Orta DoÄŸu');
INSERT INTO `site_lang` VALUES ('237', '45', 'Asya');
INSERT INTO `site_lang` VALUES ('236', '45', 'Etnik kÃ¶ken');
INSERT INTO `site_lang` VALUES ('235', '45', 'AÄŸÄ±rlÄ±k');
INSERT INTO `site_lang` VALUES ('234', '45', 'daha fazla');
INSERT INTO `site_lang` VALUES ('233', '45', 'daha az');
INSERT INTO `site_lang` VALUES ('232', '45', 'YÃ¼kseklik');
INSERT INTO `site_lang` VALUES ('231', '45', 'BiseksÃ¼el');
INSERT INTO `site_lang` VALUES ('230', '45', 'DÃ¼z');
INSERT INTO `site_lang` VALUES ('229', '45', 'AÃ§Ä±k fikirli');
INSERT INTO `site_lang` VALUES ('228', '45', 'eÅŸcinsel');
INSERT INTO `site_lang` VALUES ('227', '45', 'Cinsellik');
INSERT INTO `site_lang` VALUES ('226', '45', 'AÃ§Ä±k');
INSERT INTO `site_lang` VALUES ('225', '45', 'AlÄ±nan');
INSERT INTO `site_lang` VALUES ('224', '45', 'Tek');
INSERT INTO `site_lang` VALUES ('223', '45', 'iliÅŸki');
INSERT INTO `site_lang` VALUES ('222', '45', 'GeniÅŸletilmiÅŸ bilgi (isteÄŸe baÄŸlÄ±)');
INSERT INTO `site_lang` VALUES ('221', '45', 'Bildirimler');
INSERT INTO `site_lang` VALUES ('220', '45', 'YÃœKSELTME');
INSERT INTO `site_lang` VALUES ('219', '45', 'Basit');
INSERT INTO `site_lang` VALUES ('218', '45', 'kadar');
INSERT INTO `site_lang` VALUES ('217', '45', 'Bekle daha');
INSERT INTO `site_lang` VALUES ('216', '45', 'Son Arama');
INSERT INTO `site_lang` VALUES ('215', '45', 'ArkadaÅŸÄ±nÄ±z kamerasÄ± yok gibi gÃ¶rÃ¼nÃ¼yor ya da mevcut deÄŸildir');
INSERT INTO `site_lang` VALUES ('214', '45', 'Ã‡ok uzun sÃ¼re beklemek');
INSERT INTO `site_lang` VALUES ('213', '45', 'EÄŸer web kamerasÄ± zorunda deÄŸilsin Ã§Ã¼nkÃ¼ video gÃ¶rÃ¼ÅŸmesi yapmak olamaz');
INSERT INTO `site_lang` VALUES ('212', '45', 'Bir Ã§aÄŸrÄ± yapmak mÃ¼mkÃ¼n !');
INSERT INTO `site_lang` VALUES ('211', '45', 'Sadece prim kullanÄ±cÄ±lar videocalls yapabilirsiniz');
INSERT INTO `site_lang` VALUES ('210', '45', 'Bir videocall zaten , daha Ã¶nce baÅŸka bir baÅŸlangÄ±Ã§ â€‹â€‹diÄŸer aramayÄ± sonlandÄ±rmak zorunda');
INSERT INTO `site_lang` VALUES ('209', '45', 'Webcam eriÅŸime izin verin .');
INSERT INTO `site_lang` VALUES ('208', '45', 'ArkadaÅŸÄ±nÄ±z Ã§evrimiÃ§i olduÄŸunda , yine Ã§evrimdÄ±ÅŸÄ± deneyin');
INSERT INTO `site_lang` VALUES ('207', '45', 'BaÅŸka videocall olduÄŸunu , ÅŸimdi Ã§aÄŸrÄ± yapamazsÄ±nÄ±z');
INSERT INTO `site_lang` VALUES ('206', '45', 'Evet , bunu silin !');
INSERT INTO `site_lang` VALUES ('205', '45', 'Sizin veri kurtarma olmadan kaybolur , devam ?');
INSERT INTO `site_lang` VALUES ('204', '45', 'hesap sonlandÄ±rma');
INSERT INTO `site_lang` VALUES ('203', '45', 'Bilgi baÅŸarÄ±yla gÃ¼ncellendi');
INSERT INTO `site_lang` VALUES ('202', '45', 'Evet , onu satÄ±n !');
INSERT INTO `site_lang` VALUES ('201', '45', 'daha fazla gÃ¼nlÃ¼k konuÅŸma , maliyet');
INSERT INTO `site_lang` VALUES ('200', '45', 'GÃ¼nlÃ¼k sÄ±nÄ±rlama Expand');
INSERT INTO `site_lang` VALUES ('199', '45', 'Sen hediye gÃ¶ndermek iÃ§in enought krediniz yok');
INSERT INTO `site_lang` VALUES ('198', '45', '1 hediye seÃ§iniz');
INSERT INTO `site_lang` VALUES ('197', '45', '1 fotoÄŸraf seÃ§iniz');
INSERT INTO `site_lang` VALUES ('196', '45', 'Bir Ã¶deme yÃ¶ntemi seÃ§iniz');
INSERT INTO `site_lang` VALUES ('195', '45', 'HayÄ±r teÅŸekkÃ¼rler');
INSERT INTO `site_lang` VALUES ('194', '45', 'EriÅŸim Al');
INSERT INTO `site_lang` VALUES ('193', '45', 'Ã¶zel fotoÄŸraflar');
INSERT INTO `site_lang` VALUES ('192', '45', 'eriÅŸin');
INSERT INTO `site_lang` VALUES ('191', '45', 'Ã¶zel fotoÄŸraflar izin Buy');
INSERT INTO `site_lang` VALUES ('190', '45', 'HayÄ±r , sana benim Ã¶zel fotoÄŸraflarÄ± gÃ¶stermek olamaz');
INSERT INTO `site_lang` VALUES ('189', '45', 'Evet, benim Ã¶zel fotoÄŸraflarÄ± gÃ¶rebilirsiniz');
INSERT INTO `site_lang` VALUES ('188', '45', 'E-posta zaten mevcut , baÅŸka bir deneyin');
INSERT INTO `site_lang` VALUES ('187', '45', 'Åžifre Ã§ok kÄ±sa');
INSERT INTO `site_lang` VALUES ('186', '45', 'otomatik tamamlama ÅŸehri seÃ§in');
INSERT INTO `site_lang` VALUES ('185', '45', 'GeÃ§erli bir tarih ekleyin');
INSERT INTO `site_lang` VALUES ('184', '45', 'YanlÄ±ÅŸ ÅŸifre');
INSERT INTO `site_lang` VALUES ('183', '45', 'E-posta var daha dont');
INSERT INTO `site_lang` VALUES ('182', '45', 'tÃ¼m giriÅŸleri doldurunuz');
INSERT INTO `site_lang` VALUES ('181', '45', 'GeÃ§ersiz e-posta formatÄ±');
INSERT INTO `site_lang` VALUES ('180', '45', 'Åžifre kurtarma');
INSERT INTO `site_lang` VALUES ('179', '45', 'HesabÄ±ma oturum');
INSERT INTO `site_lang` VALUES ('178', '45', 'Åžifrenizi hatÄ±rlamÄ±yorsanÄ±z YÃ¼klÃ¼ deÄŸilse, yeni bir tane ayarlamak iÃ§in aÅŸaÄŸÄ±daki linki tÄ±klayÄ±n :');
INSERT INTO `site_lang` VALUES ('176', '45', 'HayÄ±r!');
INSERT INTO `site_lang` VALUES ('177', '45', 'Merhaba');
INSERT INTO `site_lang` VALUES ('175', '45', 'Evet');
INSERT INTO `site_lang` VALUES ('174', '45', 'Merhaba, ben Ã¶zel fotoÄŸraflara eriÅŸebilir ?');
INSERT INTO `site_lang` VALUES ('173', '45', 'bunun gibi');
INSERT INTO `site_lang` VALUES ('172', '45', 'Bunun gibi daha fazla kiÅŸi');
INSERT INTO `site_lang` VALUES ('171', '45', 'gÃ¼n Prim');
INSERT INTO `site_lang` VALUES ('170', '45', 'satÄ±n almak');
INSERT INTO `site_lang` VALUES ('169', '45', 'AralÄ±k');
INSERT INTO `site_lang` VALUES ('168', '45', 'KasÄ±m');
INSERT INTO `site_lang` VALUES ('167', '45', 'Ekim');
INSERT INTO `site_lang` VALUES ('166', '45', 'EylÃ¼l');
INSERT INTO `site_lang` VALUES ('165', '45', 'AÄŸustos');
INSERT INTO `site_lang` VALUES ('164', '45', 'Temmuz');
INSERT INTO `site_lang` VALUES ('163', '45', 'Haziran');
INSERT INTO `site_lang` VALUES ('162', '45', 'MayÄ±s ayÄ±');
INSERT INTO `site_lang` VALUES ('161', '45', 'Nisan');
INSERT INTO `site_lang` VALUES ('160', '45', 'Mart');
INSERT INTO `site_lang` VALUES ('159', '45', 'Åžubat');
INSERT INTO `site_lang` VALUES ('158', '45', 'Ocak ayÄ±');
INSERT INTO `site_lang` VALUES ('157', '45', 'HenÃ¼z maÃ§larÄ± zorunda deÄŸilsin');
INSERT INTO `site_lang` VALUES ('156', '45', 'Sen henÃ¼z bir hayranÄ± yok');
INSERT INTO `site_lang` VALUES ('155', '45', 'Size en yakÄ±n HiÃ§bir popÃ¼ler kullanÄ±cÄ±lar');
INSERT INTO `site_lang` VALUES ('154', '45', 'kiÅŸi');
INSERT INTO `site_lang` VALUES ('153', '45', 'HiÃ§birÅŸey BulunamadÄ±');
INSERT INTO `site_lang` VALUES ('152', '45', 'DoÄŸrulamak');
INSERT INTO `site_lang` VALUES ('151', '45', 'Åžu an Ã§evrim iÃ§i');
INSERT INTO `site_lang` VALUES ('150', '45', 'Profili sil');
INSERT INTO `site_lang` VALUES ('149', '45', 'Sonra profilinizi silin bazÄ± verilerin toparlanma olmaksÄ±zÄ±n kaybolur.');
INSERT INTO `site_lang` VALUES ('148', '45', 'Profil aktivasyon durmasÄ±nÄ±n');
INSERT INTO `site_lang` VALUES ('147', '45', 'Yeni Åžifre');
INSERT INTO `site_lang` VALUES ('146', '45', 'BulunduÄŸunuz ÅŸifre feryat deÄŸiÅŸtirebilirsiniz');
INSERT INTO `site_lang` VALUES ('145', '45', 'Åžifre deÄŸiÅŸtir');
INSERT INTO `site_lang` VALUES ('144', '45', 'Premium hesaba YÃ¼kseltme');
INSERT INTO `site_lang` VALUES ('143', '45', 'Kredi eklemek');
INSERT INTO `site_lang` VALUES ('142', '45', 'GÃ¼ncel kredisi');
INSERT INTO `site_lang` VALUES ('141', '45', 'Hesap tipi');
INSERT INTO `site_lang` VALUES ('140', '45', 'send Gif&#039;ler iÃ§in kredi satÄ±n almak ve Ã¶zel fotoÄŸraflarÄ± Engeli');
INSERT INTO `site_lang` VALUES ('139', '45', 'Hesap zaten doÄŸrulanmÄ±ÅŸ olan');
INSERT INTO `site_lang` VALUES ('138', '45', 'Facebook ile BaÄŸlan');
INSERT INTO `site_lang` VALUES ('137', '45', 'HesabÄ±nÄ±zÄ± doÄŸrulamak iÃ§in, facebook hesabÄ± ile baÄŸlantÄ±');
INSERT INTO `site_lang` VALUES ('136', '45', 'HesabÄ± DoÄŸrula');
INSERT INTO `site_lang` VALUES ('135', '45', 'Profili gÃ¼ncelle');
INSERT INTO `site_lang` VALUES ('134', '45', 'Site dili');
INSERT INTO `site_lang` VALUES ('133', '45', 'Sen feryat profil bilgilerinizi dÃ¼zenleyebilirsiniz');
INSERT INTO `site_lang` VALUES ('132', '45', 'KiÅŸisel bilgi');
INSERT INTO `site_lang` VALUES ('131', '45', 'KazÄ±mak');
INSERT INTO `site_lang` VALUES ('130', '45', 'Åžifre deÄŸiÅŸtir');
INSERT INTO `site_lang` VALUES ('129', '45', 'doÄŸrulamak');
INSERT INTO `site_lang` VALUES ('128', '45', 'Kredi');
INSERT INTO `site_lang` VALUES ('127', '45', 'KiÅŸisel');
INSERT INTO `site_lang` VALUES ('126', '45', 'Ã–zel fotoÄŸraflarÄ± engelini kaldÄ±rmak');
INSERT INTO `site_lang` VALUES ('125', '45', 'IÃ§in izin isteyin');
INSERT INTO `site_lang` VALUES ('124', '45', 'Åžimdi var');
INSERT INTO `site_lang` VALUES ('123', '45', 'Kredi baÅŸarÄ±yla hesabÄ±nÄ±za eklendi');
INSERT INTO `site_lang` VALUES ('122', '45', 'erkek ve kÄ±zlar');
INSERT INTO `site_lang` VALUES ('121', '45', 'Sadece kÄ±zlar');
INSERT INTO `site_lang` VALUES ('120', '45', 'sadece Ã§ocuklar');
INSERT INTO `site_lang` VALUES ('119', '45', 'yaÅŸÄ±nda');
INSERT INTO `site_lang` VALUES ('117', '45', 'ilgili');
INSERT INTO `site_lang` VALUES ('118', '45', 'KiÅŸisel bilgi');
INSERT INTO `site_lang` VALUES ('116', '45', 'En popÃ¼ler kullanÄ±cÄ±lar');
INSERT INTO `site_lang` VALUES ('115', '45', 'DÃ¼nya');
INSERT INTO `site_lang` VALUES ('113', '45', 'arasÄ±nda kim');
INSERT INTO `site_lang` VALUES ('114', '45', 'bir yarÄ±Ã§ap iÃ§inde');
INSERT INTO `site_lang` VALUES ('112', '45', 'Her ikisi de');
INSERT INTO `site_lang` VALUES ('111', '45', 'Erkekler');
INSERT INTO `site_lang` VALUES ('110', '45', 'KÄ±zlar');
INSERT INTO `site_lang` VALUES ('109', '45', 'GÃ¶ster bana');
INSERT INTO `site_lang` VALUES ('108', '45', 'Åžu an Ã§evrim iÃ§i');
INSERT INTO `site_lang` VALUES ('107', '45', 'TÃ¼m kullanÄ±cÄ±lar');
INSERT INTO `site_lang` VALUES ('106', '45', 'filtre Arama');
INSERT INTO `site_lang` VALUES ('105', '45', 'sizin maÃ§lar');
INSERT INTO `site_lang` VALUES ('103', '45', 'KullanÄ±m ÅžartlarÄ±');
INSERT INTO `site_lang` VALUES ('104', '45', 'iÃ§inde baÅŸlamadan Ã¶nce profilinizi doldurunuz');
INSERT INTO `site_lang` VALUES ('102', '45', 'Gizlilik PolitikasÄ±');
INSERT INTO `site_lang` VALUES ('101', '45', 'Senin fans');
INSERT INTO `site_lang` VALUES ('100', '45', 'insanlarla tanÄ±ÅŸmak devam veya yarÄ±na kadar bekleyin');
INSERT INTO `site_lang` VALUES ('99', '45', 'gÃ¼nlÃ¼k konuÅŸmalarÄ±');
INSERT INTO `site_lang` VALUES ('98', '45', 've kalk');
INSERT INTO `site_lang` VALUES ('97', '45', 'Premium hesabÄ±nÄ±zÄ± yÃ¼kseltin');
INSERT INTO `site_lang` VALUES ('96', '45', 'veya');
INSERT INTO `site_lang` VALUES ('95', '45', 'daha fazla gÃ¼nlÃ¼k konuÅŸma');
INSERT INTO `site_lang` VALUES ('94', '45', 'satÄ±n almak');
INSERT INTO `site_lang` VALUES ('93', '45', 'sohbet devam etmek iÃ§in');
INSERT INTO `site_lang` VALUES ('92', '45', 'Yeni gÃ¼nlÃ¼k konuÅŸmalarÄ± sÄ±nÄ±rÄ±na ulaÅŸtÄ±nÄ±z');
INSERT INTO `site_lang` VALUES ('89', '45', 'metni buraya yazÄ±n');
INSERT INTO `site_lang` VALUES ('90', '45', 'gÃ¶ndermek');
INSERT INTO `site_lang` VALUES ('91', '45', 'Sohbet');
INSERT INTO `site_lang` VALUES ('88', '45', 'Prim kullanÄ±cÄ± rozeti');
INSERT INTO `site_lang` VALUES ('86', '45', 'sÄ±nÄ±rsÄ±z videocalls');
INSERT INTO `site_lang` VALUES ('87', '45', 'TÃ¼m Ã¶zel fotoÄŸraflarÄ± engelini kaldÄ±rmak');
INSERT INTO `site_lang` VALUES ('85', '45', 'GÃ¼nde yeni sohbetler');
INSERT INTO `site_lang` VALUES ('82', '45', 'Ä°le Ã¶demek');
INSERT INTO `site_lang` VALUES ('83', '45', 'kredi satÄ±n');
INSERT INTO `site_lang` VALUES ('84', '45', 'Premium Hesap Ã–zellikleri');
INSERT INTO `site_lang` VALUES ('81', '45', 'Ä°le Ã¶demek');
INSERT INTO `site_lang` VALUES ('80', '45', 'Ã–deme tÃ¼rÃ¼nÃ¼ seÃ§in');
INSERT INTO `site_lang` VALUES ('79', '45', 'SeÃ§ kredi paketi');
INSERT INTO `site_lang` VALUES ('78', '45', 'hesap YÃ¼kseltme / kredi satÄ±n');
INSERT INTO `site_lang` VALUES ('77', '45', 'Hediye gÃ¶nder');
INSERT INTO `site_lang` VALUES ('76', '45', 'EÄŸer gÃ¶ndermek istediÄŸiniz hediye almak');
INSERT INTO `site_lang` VALUES ('75', '45', 'hediye gÃ¶nder');
INSERT INTO `site_lang` VALUES ('74', '45', 'FotoÄŸraf ekle');
INSERT INTO `site_lang` VALUES ('73', '45', 'Credits');
INSERT INTO `site_lang` VALUES ('72', '45', 'EÄŸer Spotlight , maliyet gÃ¶stermek istediÄŸiniz fotoÄŸrafÄ± seÃ§in');
INSERT INTO `site_lang` VALUES ('71', '45', 'Spotlight Kendinizi ekle');
INSERT INTO `site_lang` VALUES ('70', '45', 'fotoÄŸraf ekle');
INSERT INTO `site_lang` VALUES ('69', '45', 'FotoÄŸraflarÄ±nÄ±zÄ± ekle');
INSERT INTO `site_lang` VALUES ('68', '45', 'Ã¶zel Resimler');
INSERT INTO `site_lang` VALUES ('67', '45', 'kamu Resimleri');
INSERT INTO `site_lang` VALUES ('66', '45', 'TÃ¼m Resimler');
INSERT INTO `site_lang` VALUES ('65', '45', 'FotoÄŸraflarÄ±nÄ±zÄ± yÃ¶netin');
INSERT INTO `site_lang` VALUES ('64', '45', 'Temas');
INSERT INTO `site_lang` VALUES ('63', '45', 'Gizlilik');
INSERT INTO `site_lang` VALUES ('62', '45', 'ÅŸartlar');
INSERT INTO `site_lang` VALUES ('61', '45', 'Kim sevmeye');
INSERT INTO `site_lang` VALUES ('60', '45', 'yeni mesajlar');
INSERT INTO `site_lang` VALUES ('59', '45', 'Åžu an Ã§evrim iÃ§i');
INSERT INTO `site_lang` VALUES ('58', '45', 'KonuÅŸmalar');
INSERT INTO `site_lang` VALUES ('57', '45', 'Fans');
INSERT INTO `site_lang` VALUES ('56', '45', 'Hep');
INSERT INTO `site_lang` VALUES ('55', '45', 'Ayarlar');
INSERT INTO `site_lang` VALUES ('54', '45', 'fotoÄŸraflarÄ± yÃ¶netmek');
INSERT INTO `site_lang` VALUES ('53', '45', 'Fans');
INSERT INTO `site_lang` VALUES ('52', '45', 'Ã§oÄŸu Populars');
INSERT INTO `site_lang` VALUES ('50', '45', 'keÅŸfetmek');
INSERT INTO `site_lang` VALUES ('51', '45', 'MaÃ§lar');
INSERT INTO `site_lang` VALUES ('49', '45', 'Yeni insanlarla tanÄ±ÅŸmak');
INSERT INTO `site_lang` VALUES ('48', '45', 'Ã‡Ä±kÄ±ÅŸ Yap');
INSERT INTO `site_lang` VALUES ('47', '45', 'Ayarlar');
INSERT INTO `site_lang` VALUES ('46', '45', 'Profil');
INSERT INTO `site_lang` VALUES ('45', '45', 'Gizlilik PolitikasÄ±');
INSERT INTO `site_lang` VALUES ('44', '45', 've');
INSERT INTO `site_lang` VALUES ('43', '45', 'Åžartlar ve koÅŸullar');
INSERT INTO `site_lang` VALUES ('42', '45', 'Devam ederek , okumak ve kabul ettiÄŸinizi onaylÄ±yorsunuz bizim');
INSERT INTO `site_lang` VALUES ('41', '45', 'Kaydol');
INSERT INTO `site_lang` VALUES ('40', '45', 'TanÄ±ÅŸma erkek ve kÄ±zlar');
INSERT INTO `site_lang` VALUES ('39', '45', 'TanÄ±ÅŸma Ã§ocuklar');
INSERT INTO `site_lang` VALUES ('38', '45', 'TanÄ±ÅŸma kÄ±zlar');
INSERT INTO `site_lang` VALUES ('36', '45', 'KadÄ±n');
INSERT INTO `site_lang` VALUES ('37', '45', 'Bende buradayÄ±m');
INSERT INTO `site_lang` VALUES ('35', '45', 'Erkek');
INSERT INTO `site_lang` VALUES ('34', '45', 'Cinsiyet');
INSERT INTO `site_lang` VALUES ('33', '45', 'Nerede yaÅŸÄ±yorsun?');
INSERT INTO `site_lang` VALUES ('32', '45', 'Åžehir');
INSERT INTO `site_lang` VALUES ('31', '45', 'LÃ¼tfen seÃ§in');
INSERT INTO `site_lang` VALUES ('30', '45', 'DoÄŸum gÃ¼nÃ¼');
INSERT INTO `site_lang` VALUES ('29', '45', 'Parola');
INSERT INTO `site_lang` VALUES ('28', '45', 'E-posta');
INSERT INTO `site_lang` VALUES ('27', '45', 'AdÄ±nÄ±z veya takma');
INSERT INTO `site_lang` VALUES ('26', '45', 'Isim');
INSERT INTO `site_lang` VALUES ('25', '45', 'Yeni insanlarla tanÄ±ÅŸmak iÃ§in dÃ¼nyalar bestest topluluÄŸa katÄ±lÄ±n !.');
INSERT INTO `site_lang` VALUES ('24', '45', 'Ãœye ÅŸimdi ol');
INSERT INTO `site_lang` VALUES ('23', '45', 'Bizim popÃ¼ler keÅŸfedin oyun ve diÄŸer kullanÄ±cÄ±lar ile eÅŸleÅŸti olsun . Onun harika bir yoldur buz kÄ±rmak ve yeni insanlarla sohbet etmek .');
INSERT INTO `site_lang` VALUES ('22', '45', 'MaÃ§lar');
INSERT INTO `site_lang` VALUES ('21', '45', 'Biz tam yerini gÃ¶stermek alÄ±ÅŸkanlÄ±k , ama sen aynÄ± ÅŸeyleri gibi yakÄ±n insanlarÄ± bulmak mÃ¼mkÃ¼n olacak .');
INSERT INTO `site_lang` VALUES ('20', '45', 'Insanlar yakÄ±n');
INSERT INTO `site_lang` VALUES ('19', '45', 'Sadece sizinle sohbet eden kiÅŸinin gÃ¶rme keyfine , Ã§aÄŸrÄ± sÃ¼resi sÄ±nÄ±rÄ± olmadan herkes iÃ§in Ã¼cretsiz kaliteli videocalls yapabilirsiniz');
INSERT INTO `site_lang` VALUES ('18', '45', 'GÃ¶rÃ¼ntÃ¼lÃ¼ Sohbet');
INSERT INTO `site_lang` VALUES ('17', '45', 'karÅŸÄ±lamak , yeni arkadaÅŸlar GÃ¼Ã§lÃ¼ Ã¶zel sohbet , kimseye ifadeleri ve Ã¶zel fotoÄŸraf gÃ¶nderebilirsiniz.');
INSERT INTO `site_lang` VALUES ('16', '45', 'Sohbet');
INSERT INTO `site_lang` VALUES ('15', '45', 'Åžifre kurtarma');
INSERT INTO `site_lang` VALUES ('14', '45', 'Åžifre kurtarma');
INSERT INTO `site_lang` VALUES ('13', '45', 'Åžimdi giriÅŸ yap');
INSERT INTO `site_lang` VALUES ('12', '45', 'EÄŸer ÅŸifrenizi unuttuysanÄ±z mÄ±?');
INSERT INTO `site_lang` VALUES ('11', '45', 'Åžifreniz');
INSERT INTO `site_lang` VALUES ('10', '45', 'E-posta adresiniz');
INSERT INTO `site_lang` VALUES ('9', '45', 'Tekrar hoÅŸgeldiniz');
INSERT INTO `site_lang` VALUES ('8', '45', 'HesabÄ±nÄ± oluÅŸtur');
INSERT INTO `site_lang` VALUES ('6', '45', 'YAKINDA HAZIR');
INSERT INTO `site_lang` VALUES ('7', '45', 'Ä°le baÄŸlantÄ±');
INSERT INTO `site_lang` VALUES ('5', '45', 'YakÄ±nda online bizim telefon uygulamalarÄ± olacak');
INSERT INTO `site_lang` VALUES ('4', '45', 'dizÃ¼stÃ¼ veya PC bizi ziyaret edin');
INSERT INTO `site_lang` VALUES ('3', '45', 'Åžimdilik sitemiz MasaÃ¼stÃ¼ kullanÄ±cÄ±larÄ± iÃ§in Ã§alÄ±ÅŸÄ±r');
INSERT INTO `site_lang` VALUES ('2', '45', 'Yeni insanlarla tanÄ±ÅŸmak iÃ§in en hÄ±zlÄ± bÃ¼yÃ¼yen yere hoÅŸ geldiniz');
INSERT INTO `site_lang` VALUES ('1', '45', 'GiriÅŸ');
INSERT INTO `site_lang` VALUES ('0', '45', 'yeni insanlarla tanÄ±ÅŸmak!');
INSERT INTO `site_lang` VALUES ('341', '19', 'Wir senden Ihnen eine E-Mail mit Ihrem Info , kann es bis zu 1 Minute dauern, bis ankommen');
INSERT INTO `site_lang` VALUES ('340', '19', 'Laden...');
INSERT INTO `site_lang` VALUES ('339', '19', 'von');
INSERT INTO `site_lang` VALUES ('338', '19', 'Fotos von');
INSERT INTO `site_lang` VALUES ('337', '19', 'ruft Sie ..');
INSERT INTO `site_lang` VALUES ('336', '19', 'Passwort erfolgreich geÃ¤ndert');
INSERT INTO `site_lang` VALUES ('335', '19', 'Service- Kosten');
INSERT INTO `site_lang` VALUES ('334', '19', 'Scheinwerfer');
INSERT INTO `site_lang` VALUES ('333', '19', 'Falsch');
INSERT INTO `site_lang` VALUES ('332', '19', 'Tage von Premium');
INSERT INTO `site_lang` VALUES ('331', '19', 'benutzername');
INSERT INTO `site_lang` VALUES ('330', '19', 'Sie mÃ¼ssen Ihren Benutzernamen zu schreiben !');
INSERT INTO `site_lang` VALUES ('329', '19', 'Schreiben Sie Ihren Benutzernamen instagram');
INSERT INTO `site_lang` VALUES ('328', '19', 'DrÃ¼cken Sie RÃ¼cktaste fÃ¼r intelligente RÃ¼ckkehr zu dem Treffen Abschnitt .');
INSERT INTO `site_lang` VALUES ('327', '19', 'Sind Sie sicher, dass Sie berichten');
INSERT INTO `site_lang` VALUES ('326', '19', 'Bericht und Block');
INSERT INTO `site_lang` VALUES ('325', '19', 'wird Sie blockieren oder Sie blockiert ihn , man kann mit ihm chatten leid');
INSERT INTO `site_lang` VALUES ('324', '19', 'Wir sended Sie eine E-Mail fÃ¼r Ihr Konto zu Ã¼berprÃ¼fen');
INSERT INTO `site_lang` VALUES ('323', '19', 'Jahre alt und im von');
INSERT INTO `site_lang` VALUES ('322', '19', 'Hallo ich bin');
INSERT INTO `site_lang` VALUES ('321', '19', 'Bitte fÃ¼gen Sie ein neues Profil-Foto');
INSERT INTO `site_lang` VALUES ('320', '19', 'Bitte Ã¼berprÃ¼fen Sie Ihr Konto , Ã¼berprÃ¼fen Sie Ihre E-Mail');
INSERT INTO `site_lang` VALUES ('319', '19', 'vor');
INSERT INTO `site_lang` VALUES ('318', '19', 'Sekunden');
INSERT INTO `site_lang` VALUES ('317', '19', 'Protokoll');
INSERT INTO `site_lang` VALUES ('316', '19', 'Std');
INSERT INTO `site_lang` VALUES ('315', '19', 'Tage');
INSERT INTO `site_lang` VALUES ('313', '19', 'Jahre');
INSERT INTO `site_lang` VALUES ('314', '19', 'Monate');
INSERT INTO `site_lang` VALUES ('312', '19', 'zweite');
INSERT INTO `site_lang` VALUES ('311', '19', 'Minute');
INSERT INTO `site_lang` VALUES ('309', '19', 'Tag');
INSERT INTO `site_lang` VALUES ('310', '19', 'Stunde');
INSERT INTO `site_lang` VALUES ('308', '19', 'Monat');
INSERT INTO `site_lang` VALUES ('307', '19', 'Jahr');
INSERT INTO `site_lang` VALUES ('306', '19', '0 Sekunden');
INSERT INTO `site_lang` VALUES ('305', '19', 'Credits fÃ¼r $');
INSERT INTO `site_lang` VALUES ('304', '19', 'Kosten');
INSERT INTO `site_lang` VALUES ('303', '19', 'Sie mÃ¶gen es nicht, dass jemand');
INSERT INTO `site_lang` VALUES ('302', '19', 'besucht');
INSERT INTO `site_lang` VALUES ('301', '19', 'Sie mÃ¼ssen nicht jeden Besuch haben noch');
INSERT INTO `site_lang` VALUES ('300', '19', 'ALTER');
INSERT INTO `site_lang` VALUES ('299', '19', 'Nicht gefallen');
INSERT INTO `site_lang` VALUES ('297', '19', 'Nachrichten');
INSERT INTO `site_lang` VALUES ('298', '19', 'MÃ¶gen');
INSERT INTO `site_lang` VALUES ('296', '19', 'Die Leute lieben sie, fÃ¼r sie zu sehen');
INSERT INTO `site_lang` VALUES ('295', '19', 'Menschen Ich mag');
INSERT INTO `site_lang` VALUES ('294', '19', 'Aktualisieren Sie Ihr Konto auf Premium');
INSERT INTO `site_lang` VALUES ('293', '19', 'Menschen besucht Ihr Profil fÃ¼r sie sehen');
INSERT INTO `site_lang` VALUES ('292', '19', 'LÃ¶schen');
INSERT INTO `site_lang` VALUES ('291', '19', 'Ã–ffentliches Foto');
INSERT INTO `site_lang` VALUES ('290', '19', 'Privat Foto');
INSERT INTO `site_lang` VALUES ('289', '19', 'Als Profil');
INSERT INTO `site_lang` VALUES ('287', '19', 'FÃ¼ge mich hier hinzu');
INSERT INTO `site_lang` VALUES ('288', '19', 'lassen Sie sich von Millionen gesehen');
INSERT INTO `site_lang` VALUES ('286', '19', 'Besuche');
INSERT INTO `site_lang` VALUES ('282', '19', 'hinzufÃ¼gen von');
INSERT INTO `site_lang` VALUES ('283', '19', 'HinzufÃ¼gen');
INSERT INTO `site_lang` VALUES ('284', '19', 'Fotos');
INSERT INTO `site_lang` VALUES ('285', '19', 'Credits');
INSERT INTO `site_lang` VALUES ('281', '19', 'Private Fotos');
INSERT INTO `site_lang` VALUES ('278', '19', 'Fans');
INSERT INTO `site_lang` VALUES ('279', '19', 'Keine Daten');
INSERT INTO `site_lang` VALUES ('280', '19', 'Ã–ffentliche Fotos');
INSERT INTO `site_lang` VALUES ('277', '19', 'Bericht');
INSERT INTO `site_lang` VALUES ('274', '19', 'Jahr');
INSERT INTO `site_lang` VALUES ('275', '19', 'Warten Sie mal');
INSERT INTO `site_lang` VALUES ('276', '19', 'Interessen');
INSERT INTO `site_lang` VALUES ('273', '19', 'Monat');
INSERT INTO `site_lang` VALUES ('272', '19', 'Tag');
INSERT INTO `site_lang` VALUES ('271', '19', 'Wenn mir jemand eine Nachricht senden');
INSERT INTO `site_lang` VALUES ('270', '19', 'Wenn neue Benutzer in der NÃ¤he von mir mitmachen');
INSERT INTO `site_lang` VALUES ('269', '19', 'Wenn ich ein Spiel');
INSERT INTO `site_lang` VALUES ('268', '19', 'Wenn jemand mag mich');
INSERT INTO `site_lang` VALUES ('267', '19', 'Keiner');
INSERT INTO `site_lang` VALUES ('266', '19', 'Ich besitze ein Motorrad');
INSERT INTO `site_lang` VALUES ('265', '19', 'Ich besitze ein Auto');
INSERT INTO `site_lang` VALUES ('264', '19', 'Eltern Auto');
INSERT INTO `site_lang` VALUES ('263', '19', 'Transport');
INSERT INTO `site_lang` VALUES ('262', '19', 'GetrÃ¤nk');
INSERT INTO `site_lang` VALUES ('261', '19', 'Manchmal');
INSERT INTO `site_lang` VALUES ('260', '19', 'No');
INSERT INTO `site_lang` VALUES ('259', '19', 'Yes');
INSERT INTO `site_lang` VALUES ('258', '19', 'Rauch');
INSERT INTO `site_lang` VALUES ('257', '19', 'Allein');
INSERT INTO `site_lang` VALUES ('256', '19', 'Mit Partner');
INSERT INTO `site_lang` VALUES ('255', '19', 'Studentenwohnheim');
INSERT INTO `site_lang` VALUES ('254', '19', 'Mit Mitbewohners');
INSERT INTO `site_lang` VALUES ('253', '19', 'Mit Eltern');
INSERT INTO `site_lang` VALUES ('252', '19', 'Leben');
INSERT INTO `site_lang` VALUES ('251', '19', 'Kurvenreich');
INSERT INTO `site_lang` VALUES ('250', '19', 'Schwere Reihe');
INSERT INTO `site_lang` VALUES ('249', '19', 'Sportlich');
INSERT INTO `site_lang` VALUES ('248', '19', 'Durchschnittlich');
INSERT INTO `site_lang` VALUES ('247', '19', 'Schlank');
INSERT INTO `site_lang` VALUES ('246', '19', 'KÃ¶rpertyp');
INSERT INTO `site_lang` VALUES ('245', '19', 'Andere');
INSERT INTO `site_lang` VALUES ('244', '19', 'Indisch');
INSERT INTO `site_lang` VALUES ('243', '19', 'Pazifische Inselbewohner');
INSERT INTO `site_lang` VALUES ('242', '19', 'Spanisch / Latin');
INSERT INTO `site_lang` VALUES ('241', '19', 'Amerikanischer Ureinwohner');
INSERT INTO `site_lang` VALUES ('240', '19', 'WeiÃŸ');
INSERT INTO `site_lang` VALUES ('239', '19', 'Schwarz');
INSERT INTO `site_lang` VALUES ('237', '19', 'Asiatisch');
INSERT INTO `site_lang` VALUES ('238', '19', 'Naher Osten');
INSERT INTO `site_lang` VALUES ('236', '19', 'EthnizitÃ¤t');
INSERT INTO `site_lang` VALUES ('235', '19', 'Gewicht');
INSERT INTO `site_lang` VALUES ('234', '19', 'mehr als');
INSERT INTO `site_lang` VALUES ('233', '19', 'Weniger als');
INSERT INTO `site_lang` VALUES ('232', '19', 'HÃ¶he');
INSERT INTO `site_lang` VALUES ('231', '19', 'Bisexuell');
INSERT INTO `site_lang` VALUES ('230', '19', 'Gerade');
INSERT INTO `site_lang` VALUES ('229', '19', 'Offen');
INSERT INTO `site_lang` VALUES ('228', '19', 'Homosexuell');
INSERT INTO `site_lang` VALUES ('227', '19', 'SexualitÃ¤t');
INSERT INTO `site_lang` VALUES ('226', '19', 'Ã–ffnen');
INSERT INTO `site_lang` VALUES ('225', '19', 'Genommen');
INSERT INTO `site_lang` VALUES ('224', '19', 'Single');
INSERT INTO `site_lang` VALUES ('223', '19', 'Beziehung');
INSERT INTO `site_lang` VALUES ('222', '19', 'Erweiterte Informationen (optional)');
INSERT INTO `site_lang` VALUES ('221', '19', 'Benachrichtigungen');
INSERT INTO `site_lang` VALUES ('220', '19', 'AKTUALISIERUNG');
INSERT INTO `site_lang` VALUES ('219', '19', 'Basic');
INSERT INTO `site_lang` VALUES ('218', '19', 'bis');
INSERT INTO `site_lang` VALUES ('217', '19', 'Warten mehr');
INSERT INTO `site_lang` VALUES ('216', '19', 'Anruf beenden');
INSERT INTO `site_lang` VALUES ('215', '19', 'Es scheint , dass Ihr Freund Webcam nicht haben oder er ist nicht verfÃ¼gbar');
INSERT INTO `site_lang` VALUES ('214', '19', 'Zu lange Warte');
INSERT INTO `site_lang` VALUES ('213', '19', 'Sie kann Videocall , weil Sie Webcam nicht haben');
INSERT INTO `site_lang` VALUES ('212', '19', 'UnmÃ¶glich , um einen Anruf zu machen!');
INSERT INTO `site_lang` VALUES ('211', '19', 'Nur Premium Benutzer Videotelefonaten machen');
INSERT INTO `site_lang` VALUES ('210', '19', 'Sie befinden sich bereits in einem Videocall , kÃ¶nnen Sie den anderen Anruf , bevor eine andere beginnen zu beenden mÃ¼ssen');
INSERT INTO `site_lang` VALUES ('209', '19', 'Bitte erlauben Sie den Zugriff auf Ihre Webcam .');
INSERT INTO `site_lang` VALUES ('208', '19', 'wieder offline ist, versuchen , wenn Ihr Freund ist online');
INSERT INTO `site_lang` VALUES ('207', '19', 'jetzt in einem anderen Videocall ist , kann nicht Sie rufen');
INSERT INTO `site_lang` VALUES ('206', '19', 'Ja, lÃ¶schen !');
INSERT INTO `site_lang` VALUES ('205', '19', 'Ihre Daten werden ohne RÃ¼ckgewinnung verloren , weiter ?');
INSERT INTO `site_lang` VALUES ('204', '19', 'KÃ¼ndigung des Kontos');
INSERT INTO `site_lang` VALUES ('203', '19', 'Aktualisierte Informationen erhalten Sie erfolgreich');
INSERT INTO `site_lang` VALUES ('202', '19', 'Ja , es zu kaufen !');
INSERT INTO `site_lang` VALUES ('201', '19', 'mehr tÃ¤gliche Unterhaltung , Kosten');
INSERT INTO `site_lang` VALUES ('200', '19', 'Erweitern Sie tÃ¤glich EinschrÃ¤nkung');
INSERT INTO `site_lang` VALUES ('199', '19', 'Sie mÃ¼ssen nicht fÃ¼r senden das Geschenk genug Credits haben');
INSERT INTO `site_lang` VALUES ('198', '19', 'Bitte wÃ¤hlen Sie ein Geschenk');
INSERT INTO `site_lang` VALUES ('197', '19', 'Bitte wÃ¤hlen Sie ein Foto');
INSERT INTO `site_lang` VALUES ('196', '19', 'Bitte Zahlungsart wÃ¤hlen');
INSERT INTO `site_lang` VALUES ('195', '19', 'Nein Danke');
INSERT INTO `site_lang` VALUES ('194', '19', 'Zugang erhalten');
INSERT INTO `site_lang` VALUES ('193', '19', 'Private Fotos fÃ¼r');
INSERT INTO `site_lang` VALUES ('192', '19', 'Erhalten Sie Zugang zu');
INSERT INTO `site_lang` VALUES ('191', '19', 'Kaufen Sie private Fotos Erlaubnis');
INSERT INTO `site_lang` VALUES ('190', '19', 'Nein, ich kann Ihnen zeigen, meine privaten Fotos');
INSERT INTO `site_lang` VALUES ('189', '19', 'Ja, Sie kÃ¶nnen meine privaten Fotos zu sehen');
INSERT INTO `site_lang` VALUES ('188', '19', 'E-Mail bereits vorhanden sind , versuchen Sie ein anderes');
INSERT INTO `site_lang` VALUES ('187', '19', 'Passwort zu kurz');
INSERT INTO `site_lang` VALUES ('186', '19', 'WÃ¤hlen Sie die Stadt aus der Auto-VervollstÃ¤ndigen');
INSERT INTO `site_lang` VALUES ('185', '19', 'FÃ¼gen Sie ein gÃ¼ltiges Datum');
INSERT INTO `site_lang` VALUES ('184', '19', 'Falsches Passwort');
INSERT INTO `site_lang` VALUES ('183', '19', 'E-Mail nicht existieren');
INSERT INTO `site_lang` VALUES ('182', '19', 'Bitte fÃ¼llen Sie alle EingÃ¤nge');
INSERT INTO `site_lang` VALUES ('181', '19', 'ungÃ¼ltiges Email-Format');
INSERT INTO `site_lang` VALUES ('180', '19', 'Passwort wiederherstellen');
INSERT INTO `site_lang` VALUES ('179', '19', 'In Mein Konto');
INSERT INTO `site_lang` VALUES ('178', '19', 'Wenn Sie Ihr Passwort nicht erinnern , klicken Sie auf den Link unten um ein neues zu setzen :');
INSERT INTO `site_lang` VALUES ('177', '19', 'Hallo');
INSERT INTO `site_lang` VALUES ('176', '19', 'No');
INSERT INTO `site_lang` VALUES ('175', '19', 'Yes');
INSERT INTO `site_lang` VALUES ('174', '19', 'Hallo , ich kann Zugriff auf Ihre privaten Fotos ?');
INSERT INTO `site_lang` VALUES ('173', '19', 'So was');
INSERT INTO `site_lang` VALUES ('172', '19', 'Personen wie diese mehr');
INSERT INTO `site_lang` VALUES ('171', '19', 'Tage Premium');
INSERT INTO `site_lang` VALUES ('170', '19', 'Kaufen');
INSERT INTO `site_lang` VALUES ('169', '19', 'Dezember');
INSERT INTO `site_lang` VALUES ('168', '19', 'November');
INSERT INTO `site_lang` VALUES ('167', '19', 'Oktober');
INSERT INTO `site_lang` VALUES ('166', '19', 'September');
INSERT INTO `site_lang` VALUES ('165', '19', 'August');
INSERT INTO `site_lang` VALUES ('164', '19', 'Juli');
INSERT INTO `site_lang` VALUES ('163', '19', 'Juni');
INSERT INTO `site_lang` VALUES ('162', '19', 'Kann');
INSERT INTO `site_lang` VALUES ('161', '19', 'April');
INSERT INTO `site_lang` VALUES ('160', '19', 'MÃ¤rz');
INSERT INTO `site_lang` VALUES ('159', '19', 'Februar');
INSERT INTO `site_lang` VALUES ('158', '19', 'Januar');
INSERT INTO `site_lang` VALUES ('157', '19', 'Sie mÃ¼ssen nicht Matches noch');
INSERT INTO `site_lang` VALUES ('156', '19', 'Sie mÃ¼ssen nicht alle Fans haben noch');
INSERT INTO `site_lang` VALUES ('155', '19', 'Keine populÃ¤ren Benutzer in Ihrer NÃ¤he');
INSERT INTO `site_lang` VALUES ('154', '19', 'Menschen gefunden');
INSERT INTO `site_lang` VALUES ('153', '19', 'Nichts gefunden');
INSERT INTO `site_lang` VALUES ('152', '19', 'Verifizierte');
INSERT INTO `site_lang` VALUES ('151', '19', 'Jetzt online');
INSERT INTO `site_lang` VALUES ('150', '19', 'Profil lÃ¶schen');
INSERT INTO `site_lang` VALUES ('149', '19', 'Nachdem Sie Ihr Profil lÃ¶schen, werden einige Ihrer Daten ohne Wiederherstellung verloren.');
INSERT INTO `site_lang` VALUES ('148', '19', 'Profil Desaktivierung');
INSERT INTO `site_lang` VALUES ('147', '19', 'Neues Kennwort');
INSERT INTO `site_lang` VALUES ('146', '19', 'Sie kÃ¶nnen Ihr aktuelles Passwort unten Ã¤ndern');
INSERT INTO `site_lang` VALUES ('145', '19', 'Passwort Ã¤ndern');
INSERT INTO `site_lang` VALUES ('144', '19', 'Upgrade auf Premium-Account');
INSERT INTO `site_lang` VALUES ('143', '19', 'In Credits');
INSERT INTO `site_lang` VALUES ('142', '19', 'Aktuelle Kredite');
INSERT INTO `site_lang` VALUES ('141', '19', 'Konto Typ');
INSERT INTO `site_lang` VALUES ('140', '19', 'Kaufen Sie Credits fÃ¼r Sende Gifs und blocken private Fotos');
INSERT INTO `site_lang` VALUES ('139', '19', 'Sie ist Konto bereits Ã¼berprÃ¼ft');
INSERT INTO `site_lang` VALUES ('138', '19', 'Mit Facebook verbinden');
INSERT INTO `site_lang` VALUES ('137', '19', 'FÃ¼r Ihr Konto zu Ã¼berprÃ¼fen , verbinden Sie mit Ihrem Facebook - Konto');
INSERT INTO `site_lang` VALUES ('136', '19', 'Konto Ã¼berprÃ¼fen');
INSERT INTO `site_lang` VALUES ('135', '19', 'Profil aktualisieren');
INSERT INTO `site_lang` VALUES ('134', '19', 'Seitensprache');
INSERT INTO `site_lang` VALUES ('133', '19', 'Sie kÃ¶nnen Ihre Profilinformationen bearbeiten unten');
INSERT INTO `site_lang` VALUES ('132', '19', 'Personal information');
INSERT INTO `site_lang` VALUES ('131', '19', 'LÃ¶schen');
INSERT INTO `site_lang` VALUES ('130', '19', 'Passwort Ã¤ndern');
INSERT INTO `site_lang` VALUES ('129', '19', 'ÃœberprÃ¼fen');
INSERT INTO `site_lang` VALUES ('128', '19', 'Credits');
INSERT INTO `site_lang` VALUES ('127', '19', 'PersÃ¶nlich');
INSERT INTO `site_lang` VALUES ('126', '19', 'Entsper private Fotos');
INSERT INTO `site_lang` VALUES ('125', '19', 'Fragen Sie um Erlaubnis zu');
INSERT INTO `site_lang` VALUES ('124', '19', 'Jetzt hast du');
INSERT INTO `site_lang` VALUES ('123', '19', 'Credits hinzugefÃ¼gt erfolgreich auf Ihr Konto');
INSERT INTO `site_lang` VALUES ('122', '19', 'Jungen und MÃ¤dchen');
INSERT INTO `site_lang` VALUES ('121', '19', 'Nur MÃ¤dchen');
INSERT INTO `site_lang` VALUES ('120', '19', 'Nur Jungen');
INSERT INTO `site_lang` VALUES ('119', '19', 'Jahre alt');
INSERT INTO `site_lang` VALUES ('118', '19', 'PersÃ¶nliche Informationen');
INSERT INTO `site_lang` VALUES ('117', '19', 'Etwa');
INSERT INTO `site_lang` VALUES ('116', '19', 'Die beliebtesten Benutzer');
INSERT INTO `site_lang` VALUES ('115', '19', 'Welt');
INSERT INTO `site_lang` VALUES ('114', '19', 'in einem Umkreis von');
INSERT INTO `site_lang` VALUES ('113', '19', 'die zwischen');
INSERT INTO `site_lang` VALUES ('112', '19', 'Beide');
INSERT INTO `site_lang` VALUES ('111', '19', 'Jungen');
INSERT INTO `site_lang` VALUES ('110', '19', 'MÃ¤dchen');
INSERT INTO `site_lang` VALUES ('109', '19', 'Zeig es mir');
INSERT INTO `site_lang` VALUES ('108', '19', 'Jetzt online');
INSERT INTO `site_lang` VALUES ('107', '19', 'Alle Nutzer');
INSERT INTO `site_lang` VALUES ('106', '19', 'Filter Suche');
INSERT INTO `site_lang` VALUES ('105', '19', 'Ihre Begegnungen');
INSERT INTO `site_lang` VALUES ('104', '19', 'Bitte fÃ¼llen Sie Ihr Profil vor dem Start in');
INSERT INTO `site_lang` VALUES ('103', '19', 'Nutzungsbedingungen');
INSERT INTO `site_lang` VALUES ('102', '19', 'Datenschutz-Bestimmungen');
INSERT INTO `site_lang` VALUES ('101', '19', 'Deine Fans');
INSERT INTO `site_lang` VALUES ('100', '19', 'oder bis morgen warten auf Leute zu treffen weiter');
INSERT INTO `site_lang` VALUES ('99', '19', 'tÃ¤gliche GesprÃ¤che');
INSERT INTO `site_lang` VALUES ('98', '19', 'und bis zu');
INSERT INTO `site_lang` VALUES ('97', '19', 'Aktualisieren Sie Ihr Konto auf Premium');
INSERT INTO `site_lang` VALUES ('96', '19', 'oder');
INSERT INTO `site_lang` VALUES ('95', '19', 'mehr tÃ¤gliche GesprÃ¤ch');
INSERT INTO `site_lang` VALUES ('94', '19', 'Kaufen');
INSERT INTO `site_lang` VALUES ('93', '19', 'Um weiterhin im Chat');
INSERT INTO `site_lang` VALUES ('92', '19', 'Sie haben das Limit von neuen tÃ¤glichen GesprÃ¤chen erreicht');
INSERT INTO `site_lang` VALUES ('90', '19', 'Senden');
INSERT INTO `site_lang` VALUES ('91', '19', 'Chat');
INSERT INTO `site_lang` VALUES ('89', '19', 'Schreiben Sie Text hier');
INSERT INTO `site_lang` VALUES ('88', '19', 'Premium-User Abzeichen');
INSERT INTO `site_lang` VALUES ('87', '19', 'Freigeben Sie alle privaten Fotos');
INSERT INTO `site_lang` VALUES ('86', '19', 'unbegrenzte Videotelefonaten');
INSERT INTO `site_lang` VALUES ('85', '19', 'neue Chats pro Tag');
INSERT INTO `site_lang` VALUES ('84', '19', 'Premium-Account Funktionen');
INSERT INTO `site_lang` VALUES ('83', '19', 'Kaufen Credits');
INSERT INTO `site_lang` VALUES ('82', '19', 'Bezahlen mit');
INSERT INTO `site_lang` VALUES ('81', '19', 'Bezahlen mit');
INSERT INTO `site_lang` VALUES ('80', '19', 'Zahlungsmethode auswÃ¤hlen');
INSERT INTO `site_lang` VALUES ('79', '19', 'WÃ¤hlen Sie Credits -Paket');
INSERT INTO `site_lang` VALUES ('78', '19', 'Guthaben kaufen / Upgrade- Konto');
INSERT INTO `site_lang` VALUES ('77', '19', 'Senden Geschenk');
INSERT INTO `site_lang` VALUES ('76', '19', 'WÃ¤hlen Sie das Geschenk, das Sie senden mÃ¶chten');
INSERT INTO `site_lang` VALUES ('75', '19', 'Senden Geschenk');
INSERT INTO `site_lang` VALUES ('74', '19', 'Foto hinzufÃ¼gen');
INSERT INTO `site_lang` VALUES ('73', '19', 'Credits');
INSERT INTO `site_lang` VALUES ('72', '19', 'WÃ¤hlen Sie das gewÃ¼nschte Foto im Rampenlicht, Kosten zu zeigen,');
INSERT INTO `site_lang` VALUES ('71', '19', 'FÃ¼gen Sie sich selbst ins Rampenlicht');
INSERT INTO `site_lang` VALUES ('70', '19', 'Fotos hinzufÃ¼gen');
INSERT INTO `site_lang` VALUES ('69', '19', 'FÃ¼gen Sie Ihre Fotos');
INSERT INTO `site_lang` VALUES ('68', '19', 'Private Fotos');
INSERT INTO `site_lang` VALUES ('66', '19', 'Alle Fotos');
INSERT INTO `site_lang` VALUES ('67', '19', 'Ã–ffentliche Fotos');
INSERT INTO `site_lang` VALUES ('65', '19', 'Verwalten Sie Ihre Fotos');
INSERT INTO `site_lang` VALUES ('61', '19', 'Wer mag');
INSERT INTO `site_lang` VALUES ('62', '19', 'Bedingungen');
INSERT INTO `site_lang` VALUES ('63', '19', 'PrivatsphÃ¤re');
INSERT INTO `site_lang` VALUES ('64', '19', 'Kontakt');
INSERT INTO `site_lang` VALUES ('60', '19', 'Neue Nachrichten');
INSERT INTO `site_lang` VALUES ('57', '19', 'Fans');
INSERT INTO `site_lang` VALUES ('58', '19', 'GesprÃ¤che');
INSERT INTO `site_lang` VALUES ('59', '19', 'Jetzt online');
INSERT INTO `site_lang` VALUES ('56', '19', 'Alle');
INSERT INTO `site_lang` VALUES ('53', '19', 'Fans');
INSERT INTO `site_lang` VALUES ('54', '19', 'Fotos verwalten');
INSERT INTO `site_lang` VALUES ('55', '19', 'Einstellungen');
INSERT INTO `site_lang` VALUES ('52', '19', 'Die meisten populars');
INSERT INTO `site_lang` VALUES ('51', '19', 'StreichhÃ¶lzer');
INSERT INTO `site_lang` VALUES ('50', '19', 'Entdecken');
INSERT INTO `site_lang` VALUES ('49', '19', 'Neue Leute kennen lernen');
INSERT INTO `site_lang` VALUES ('48', '19', 'Ausloggen');
INSERT INTO `site_lang` VALUES ('47', '19', 'Einstellungen');
INSERT INTO `site_lang` VALUES ('46', '19', 'Profil');
INSERT INTO `site_lang` VALUES ('45', '19', 'Datenschutz-Bestimmungen');
INSERT INTO `site_lang` VALUES ('44', '19', 'und');
INSERT INTO `site_lang` VALUES ('43', '19', 'GeschÃ¤ftsbedingungen');
INSERT INTO `site_lang` VALUES ('42', '19', 'Durch Fortsetzen bestÃ¤tigen Sie, dass Sie gelesen haben und akzeptieren unsere');
INSERT INTO `site_lang` VALUES ('41', '19', 'Anmelden');
INSERT INTO `site_lang` VALUES ('40', '19', 'Treffen Jungen und MÃ¤dchen');
INSERT INTO `site_lang` VALUES ('39', '19', 'Treffen Jungen');
INSERT INTO `site_lang` VALUES ('38', '19', 'Treffen MÃ¤dchen');
INSERT INTO `site_lang` VALUES ('37', '19', 'Ich bin auch hier');
INSERT INTO `site_lang` VALUES ('36', '19', 'Weiblich');
INSERT INTO `site_lang` VALUES ('35', '19', 'MÃ¤nnlich');
INSERT INTO `site_lang` VALUES ('34', '19', 'Geschlecht');
INSERT INTO `site_lang` VALUES ('33', '19', 'Wo wohnen Sie?');
INSERT INTO `site_lang` VALUES ('32', '19', 'Stadt');
INSERT INTO `site_lang` VALUES ('31', '19', 'Bitte auswÃ¤hlen');
INSERT INTO `site_lang` VALUES ('30', '19', 'Geburtstag');
INSERT INTO `site_lang` VALUES ('29', '19', 'Passwort');
INSERT INTO `site_lang` VALUES ('28', '19', 'Email');
INSERT INTO `site_lang` VALUES ('27', '19', 'Ihren Namen oder Spitznamen');
INSERT INTO `site_lang` VALUES ('26', '19', 'Name');
INSERT INTO `site_lang` VALUES ('25', '19', 'SchlieÃŸen Sie sich der WeltBestest Gemeinschaft fÃ¼r neue Leute zu treffen !.');
INSERT INTO `site_lang` VALUES ('24', '19', 'Werden Sie jetzt Mitglied');
INSERT INTO `site_lang` VALUES ('23', '19', 'Spielen Sie unser beliebtes Discover Spiel und erhalten mit anderen Nutzern abgestimmt. Es ist eine groÃŸartige MÃ¶glichkeit, um das Eis und Chat , um neue Leute zu brechen.');
INSERT INTO `site_lang` VALUES ('22', '19', 'StreichhÃ¶lzer');
INSERT INTO `site_lang` VALUES ('21', '19', 'Wir werden nicht Ihre genaue Position zeigen , aber Sie werden in der Lage Menschen in der NÃ¤he zu finden, der die gleichen Dinge wie Sie.');
INSERT INTO `site_lang` VALUES ('20', '19', 'Leute in der NÃ¤he');
INSERT INTO `site_lang` VALUES ('19', '19', 'Sie kÃ¶nnen kostenlos auf jeder QualitÃ¤t Videokonferenzen machen , ohne Grenzen der GesprÃ¤chsdauer , genieÃŸen Sie einfach die Person zu sehen , die mit Ihnen im Chat');
INSERT INTO `site_lang` VALUES ('18', '19', 'Video-Chat');
INSERT INTO `site_lang` VALUES ('17', '19', 'LeistungsfÃ¤higer privaten Chat fÃ¼r treffen neue Freunde , kÃ¶nnen Sie Emoticons und private Fotos an jeden senden .');
INSERT INTO `site_lang` VALUES ('16', '19', 'Chat');
INSERT INTO `site_lang` VALUES ('15', '19', 'Passwort wiederherstellen');
INSERT INTO `site_lang` VALUES ('14', '19', 'Passwort wiederherstellen');
INSERT INTO `site_lang` VALUES ('13', '19', 'Jetzt einloggen');
INSERT INTO `site_lang` VALUES ('12', '19', 'haben Sie Ihr Passwort vergessen?');
INSERT INTO `site_lang` VALUES ('11', '19', 'Ihr Passwort');
INSERT INTO `site_lang` VALUES ('10', '19', 'Deine e-Mail');
INSERT INTO `site_lang` VALUES ('9', '19', 'Willkommen zurÃ¼ck');
INSERT INTO `site_lang` VALUES ('8', '19', 'Erstelle deinen Account');
INSERT INTO `site_lang` VALUES ('7', '19', 'Verbinden mit');
INSERT INTO `site_lang` VALUES ('6', '19', 'in KÃ¼rze verfÃ¼gbar');
INSERT INTO `site_lang` VALUES ('5', '19', 'Bald werden wir unsere Telefon -Apps haben Online');
INSERT INTO `site_lang` VALUES ('4', '19', 'Bitte besuchen Sie uns von Ihrem Laptop oder PC');
INSERT INTO `site_lang` VALUES ('3', '19', 'Vorerst arbeitet unsere Website nur fÃ¼r Desktop-Benutzer');
INSERT INTO `site_lang` VALUES ('2', '19', 'Willkommen zu den am schnellsten wachsenden Ort, um neue Leute zu treffen');
INSERT INTO `site_lang` VALUES ('1', '19', 'Anmeldung');
INSERT INTO `site_lang` VALUES ('0', '19', 'neue Leute kennen lernen!');
INSERT INTO `site_lang` VALUES ('341', '17', 'que hcupa verga');
INSERT INTO `site_lang` VALUES ('341', '2', 'Te enviamos un correo electronico con tu informacion, este proceso podria tardar unos minutos');
INSERT INTO `site_lang` VALUES ('341', '1', 'We sent you a email with your info, it may take up to 1 min to arrive');
INSERT INTO `site_lang` VALUES ('340', '17', 'Chupalin..');
INSERT INTO `site_lang` VALUES ('340', '2', 'Cargando..');
INSERT INTO `site_lang` VALUES ('339', '17', 'de');
INSERT INTO `site_lang` VALUES ('338', '17', 'Photos');
INSERT INTO `site_lang` VALUES ('337', '17', 'Il appelle ...');
INSERT INTO `site_lang` VALUES ('336', '17', 'Mot de passe changÃ© avec succÃ¨s');
INSERT INTO `site_lang` VALUES ('335', '17', 'CoÃ»t des services');
INSERT INTO `site_lang` VALUES ('334', '17', 'Avant');
INSERT INTO `site_lang` VALUES ('333', '17', 'Incorrect');
INSERT INTO `site_lang` VALUES ('332', '17', 'Jours premium');
INSERT INTO `site_lang` VALUES ('331', '17', 'Utilisateur');
INSERT INTO `site_lang` VALUES ('330', '17', 'Vous devez Ã©crire votre nom d&#039;utilisateur !');
INSERT INTO `site_lang` VALUES ('329', '17', 'Entrez votre nom d&#039;utilisateur Instagram');
INSERT INTO `site_lang` VALUES ('328', '17', 'Appuyez sur la barre d&#039;espace pour revenir Ã  la section de rencontres.');
INSERT INTO `site_lang` VALUES ('327', '17', 'Bien sÃ»r, vous voulez signaler ?');
INSERT INTO `site_lang` VALUES ('326', '17', 'Rapport et Block');
INSERT INTO `site_lang` VALUES ('325', '17', 'Votre lui / bloquÃ© vous ou il / elle vous a bloquÃ© , vous ne pouvez pas discuter avec lui / elle , dÃ©solÃ©');
INSERT INTO `site_lang` VALUES ('324', '17', 'Nous avons envoyÃ© un courriel pour vÃ©rifier votre compte');
INSERT INTO `site_lang` VALUES ('323', '17', 'ans et je suis de');
INSERT INTO `site_lang` VALUES ('321', '17', 'S&#039;il vous plaÃ®t ajouter une photo de profil');
INSERT INTO `site_lang` VALUES ('322', '17', 'Salut je suis');
INSERT INTO `site_lang` VALUES ('320', '17', 'S&#039;il vous plaÃ®t vÃ©rifier votre compte , nous avons envoyÃ© un e-mail Ã  votre email');
INSERT INTO `site_lang` VALUES ('319', '17', 'il y a');
INSERT INTO `site_lang` VALUES ('317', '17', 'minutes');
INSERT INTO `site_lang` VALUES ('318', '17', 'secondes');
INSERT INTO `site_lang` VALUES ('316', '17', 'heures');
INSERT INTO `site_lang` VALUES ('315', '17', 'JournÃ©es');
INSERT INTO `site_lang` VALUES ('314', '17', 'Moises');
INSERT INTO `site_lang` VALUES ('313', '17', 'ans');
INSERT INTO `site_lang` VALUES ('312', '17', 'deuxiÃ¨me');
INSERT INTO `site_lang` VALUES ('311', '17', 'minute');
INSERT INTO `site_lang` VALUES ('310', '17', 'heur');
INSERT INTO `site_lang` VALUES ('309', '17', 'Jour');
INSERT INTO `site_lang` VALUES ('308', '17', 'Mois');
INSERT INTO `site_lang` VALUES ('307', '17', 'annÃ©e');
INSERT INTO `site_lang` VALUES ('306', '17', '0   secondes');
INSERT INTO `site_lang` VALUES ('340', '1', 'Loading...');
INSERT INTO `site_lang` VALUES ('305', '17', 'CrÃ©dits $');
INSERT INTO `site_lang` VALUES ('304', '17', 'CoÃ»t');
INSERT INTO `site_lang` VALUES ('303', '17', 'Vous ne l&#039;aimez quelqu&#039;un');
INSERT INTO `site_lang` VALUES ('302', '17', 'il a visitÃ©');
INSERT INTO `site_lang` VALUES ('301', '17', 'Vous n&#039;avez pas encore visites');
INSERT INTO `site_lang` VALUES ('300', '17', 'AGE');
INSERT INTO `site_lang` VALUES ('299', '17', 'Je n&#039;aime pas');
INSERT INTO `site_lang` VALUES ('298', '17', 'Je aime bien');
INSERT INTO `site_lang` VALUES ('297', '17', 'Messages');
INSERT INTO `site_lang` VALUES ('296', '17', 'Voir les gens qui vous aiment');
INSERT INTO `site_lang` VALUES ('295', '17', 'Les gens que j&#039;aime');
INSERT INTO `site_lang` VALUES ('294', '17', 'AmÃ©liorez votre compte premium');
INSERT INTO `site_lang` VALUES ('293', '17', 'Les personnes qui ont visitÃ© votre profil pour voir');
INSERT INTO `site_lang` VALUES ('292', '17', 'Supprimer');
INSERT INTO `site_lang` VALUES ('291', '17', 'Photo Poster');
INSERT INTO `site_lang` VALUES ('290', '17', 'Photos privÃ©es');
INSERT INTO `site_lang` VALUES ('289', '17', 'Set profil');
INSERT INTO `site_lang` VALUES ('287', '17', 'Ajoutez-moi ici');
INSERT INTO `site_lang` VALUES ('288', '17', 'Il est vu par des millions');
INSERT INTO `site_lang` VALUES ('286', '17', 'Visites');
INSERT INTO `site_lang` VALUES ('285', '17', 'CrÃ©dits');
INSERT INTO `site_lang` VALUES ('284', '17', 'Photos');
INSERT INTO `site_lang` VALUES ('283', '17', 'Ajouter');
INSERT INTO `site_lang` VALUES ('282', '17', 'Ajouter Ã  partir');
INSERT INTO `site_lang` VALUES ('281', '17', 'Photos privÃ©es');
INSERT INTO `site_lang` VALUES ('279', '17', 'Aucune donnÃ©e');
INSERT INTO `site_lang` VALUES ('280', '17', 'Photos publiques');
INSERT INTO `site_lang` VALUES ('276', '17', 'IntÃ©rÃªts');
INSERT INTO `site_lang` VALUES ('277', '17', 'Rapport');
INSERT INTO `site_lang` VALUES ('278', '17', 'Fans');
INSERT INTO `site_lang` VALUES ('275', '17', 'S&#039;il vous plaÃ®t attendre');
INSERT INTO `site_lang` VALUES ('274', '17', 'AnnÃ©e');
INSERT INTO `site_lang` VALUES ('272', '17', 'Jour');
INSERT INTO `site_lang` VALUES ('273', '17', 'Mois');
INSERT INTO `site_lang` VALUES ('271', '17', 'Quand quelqu&#039;un me envoie un message');
INSERT INTO `site_lang` VALUES ('270', '17', 'Lorsque de nouveaux utilisateurs vivent prÃ¨s de moi');
INSERT INTO `site_lang` VALUES ('269', '17', 'Quand je reÃ§ois un match');
INSERT INTO `site_lang` VALUES ('267', '17', 'Aucun');
INSERT INTO `site_lang` VALUES ('268', '17', 'Quand quelqu&#039;un me plaÃ®t');
INSERT INTO `site_lang` VALUES ('266', '17', 'Je suis propriÃ©taire d&#039; une moto');
INSERT INTO `site_lang` VALUES ('265', '17', 'Je suis propriÃ©taire d&#039; une voiture');
INSERT INTO `site_lang` VALUES ('264', '17', 'PÃ¨re / MÃ¨re avec la voiture');
INSERT INTO `site_lang` VALUES ('263', '17', 'Transport');
INSERT INTO `site_lang` VALUES ('262', '17', 'Boire');
INSERT INTO `site_lang` VALUES ('261', '17', 'Parfois');
INSERT INTO `site_lang` VALUES ('260', '17', 'Pas');
INSERT INTO `site_lang` VALUES ('259', '17', 'Si');
INSERT INTO `site_lang` VALUES ('258', '17', 'Je fume');
INSERT INTO `site_lang` VALUES ('257', '17', 'Seulement');
INSERT INTO `site_lang` VALUES ('256', '17', 'Avec son partenaire');
INSERT INTO `site_lang` VALUES ('255', '17', 'RÃ©sidence pour Ã©tudiants');
INSERT INTO `site_lang` VALUES ('254', '17', 'Avec colocataire');
INSERT INTO `site_lang` VALUES ('253', '17', 'Avec le PÃ¨re / MÃ¨re');
INSERT INTO `site_lang` VALUES ('251', '17', 'Gros');
INSERT INTO `site_lang` VALUES ('252', '17', 'Vie');
INSERT INTO `site_lang` VALUES ('250', '17', 'Corpulent');
INSERT INTO `site_lang` VALUES ('248', '17', 'Moyenne');
INSERT INTO `site_lang` VALUES ('249', '17', 'Atletico');
INSERT INTO `site_lang` VALUES ('246', '17', 'Type de carrosserie');
INSERT INTO `site_lang` VALUES ('247', '17', 'Mince');
INSERT INTO `site_lang` VALUES ('245', '17', 'Autre / s');
INSERT INTO `site_lang` VALUES ('244', '17', 'Indien');
INSERT INTO `site_lang` VALUES ('243', '17', 'Iles du Pacifique');
INSERT INTO `site_lang` VALUES ('242', '17', 'Hispanique / Latino');
INSERT INTO `site_lang` VALUES ('241', '17', 'Natif amÃ©ricain');
INSERT INTO `site_lang` VALUES ('240', '17', 'Blanc');
INSERT INTO `site_lang` VALUES ('239', '17', 'Noir');
INSERT INTO `site_lang` VALUES ('238', '17', 'Moyen Orient');
INSERT INTO `site_lang` VALUES ('237', '17', 'Asie');
INSERT INTO `site_lang` VALUES ('236', '17', 'Ethnique');
INSERT INTO `site_lang` VALUES ('235', '17', 'Poids');
INSERT INTO `site_lang` VALUES ('234', '17', 'plus de');
INSERT INTO `site_lang` VALUES ('233', '17', 'moins que');
INSERT INTO `site_lang` VALUES ('232', '17', 'Hauteur');
INSERT INTO `site_lang` VALUES ('231', '17', 'Bisexuels');
INSERT INTO `site_lang` VALUES ('230', '17', 'HÃ©tÃ©rosexuel');
INSERT INTO `site_lang` VALUES ('229', '17', 'Esprit ouvert');
INSERT INTO `site_lang` VALUES ('228', '17', 'Gay');
INSERT INTO `site_lang` VALUES ('227', '17', 'SexualitÃ©');
INSERT INTO `site_lang` VALUES ('226', '17', 'Ouvert');
INSERT INTO `site_lang` VALUES ('225', '17', 'MariÃ©');
INSERT INTO `site_lang` VALUES ('222', '17', 'Informations Ã©tendues (facultatif )');
INSERT INTO `site_lang` VALUES ('224', '17', 'Seulement');
INSERT INTO `site_lang` VALUES ('223', '17', 'Rapports');
INSERT INTO `site_lang` VALUES ('218', '17', 'En haut');
INSERT INTO `site_lang` VALUES ('219', '17', 'Basico');
INSERT INTO `site_lang` VALUES ('220', '17', 'AMÃ‰LIORER');
INSERT INTO `site_lang` VALUES ('221', '17', 'Notifications');
INSERT INTO `site_lang` VALUES ('217', '17', 'Attendre plus');
INSERT INTO `site_lang` VALUES ('216', '17', 'Raccrocher');
INSERT INTO `site_lang` VALUES ('215', '17', 'Il semble que votre ami n&#039;a pas webcam ou indisponible');
INSERT INTO `site_lang` VALUES ('214', '17', 'L&#039;attente Ã©tait trop longue');
INSERT INTO `site_lang` VALUES ('213', '17', 'Vous ne pouvez pas faire des appels vidÃ©o , parce que vous ne disposez pas d&#039;une webcam');
INSERT INTO `site_lang` VALUES ('212', '17', 'Impossible de faire un appel !');
INSERT INTO `site_lang` VALUES ('211', '17', 'Seuls les utilisateurs premium peuvent faire des appels vidÃ©o');
INSERT INTO `site_lang` VALUES ('210', '17', 'Vous Ãªtes dÃ©jÃ  dans un appel vidÃ©o , vous devez arrÃªter l&#039;autre appel avant de commencer une autre');
INSERT INTO `site_lang` VALUES ('209', '17', 'S&#039;il vous plaÃ®t permettre l&#039;accÃ¨s Ã  votre webcam .');
INSERT INTO `site_lang` VALUES ('208', '17', 'est dÃ©connectÃ© , essayer Ã  nouveau lorsque votre ami est en ligne');
INSERT INTO `site_lang` VALUES ('207', '17', 'Ce dans un autre appel vidÃ©o , vous ne pouvez pas appeler');
INSERT INTO `site_lang` VALUES ('206', '17', 'Si , Supprimer !');
INSERT INTO `site_lang` VALUES ('205', '17', 'Vos donnÃ©es seront perdues sans rÃ©cupÃ©ration , vous voulez continuer ?');
INSERT INTO `site_lang` VALUES ('204', '17', 'Conditions de compte');
INSERT INTO `site_lang` VALUES ('203', '17', 'Informations correctement mis Ã  jour');
INSERT INTO `site_lang` VALUES ('202', '17', 'Oui , acheter ce !');
INSERT INTO `site_lang` VALUES ('201', '17', 'Pour plus de conversations quotidiennes , le coÃ»t');
INSERT INTO `site_lang` VALUES ('200', '17', 'DÃ©velopper la limite quotidienne');
INSERT INTO `site_lang` VALUES ('199', '17', 'Vous n&#039;avez pas assez de crÃ©dits pour envoyer le cadeau');
INSERT INTO `site_lang` VALUES ('198', '17', 'S&#039;il vous plaÃ®t choisir 1 cadeau');
INSERT INTO `site_lang` VALUES ('196', '17', 'S&#039;il vous plaÃ®t sÃ©lectionner un mode de paiement');
INSERT INTO `site_lang` VALUES ('197', '17', 'S&#039;il vous plaÃ®t sÃ©lectionner une photo');
INSERT INTO `site_lang` VALUES ('195', '17', 'Non merci');
INSERT INTO `site_lang` VALUES ('193', '17', 'Photos privÃ©es pour');
INSERT INTO `site_lang` VALUES ('194', '17', 'AccÃ¨s');
INSERT INTO `site_lang` VALUES ('192', '17', 'AccÃ¨s');
INSERT INTO `site_lang` VALUES ('191', '17', 'Acheter des permis Ã  des photos privÃ©es');
INSERT INTO `site_lang` VALUES ('190', '17', 'Non, je ne peux pas vous montrer mes photos privÃ©es');
INSERT INTO `site_lang` VALUES ('189', '17', 'Oui , vous pouvez voir mes photos privÃ©es');
INSERT INTO `site_lang` VALUES ('187', '17', 'Mot de passe trop court');
INSERT INTO `site_lang` VALUES ('188', '17', 'Email existe dÃ©jÃ  , essayez une autre');
INSERT INTO `site_lang` VALUES ('186', '17', 'Choisissez autocomplete');
INSERT INTO `site_lang` VALUES ('185', '17', 'Ajouter une date valide');
INSERT INTO `site_lang` VALUES ('183', '17', 'Cet e-mail n&#039;existe pas');
INSERT INTO `site_lang` VALUES ('184', '17', 'Mot de passe incorrect');
INSERT INTO `site_lang` VALUES ('182', '17', 'S&#039;il vous plaÃ®t remplir toutes les options');
INSERT INTO `site_lang` VALUES ('181', '17', 'S&#039;il vous plaÃ®t entrer un format e-mail valide');
INSERT INTO `site_lang` VALUES ('180', '17', 'RÃ©cupÃ©rer mot de passe');
INSERT INTO `site_lang` VALUES ('179', '17', 'AccÃ©der Ã  mon compte');
INSERT INTO `site_lang` VALUES ('178', '17', 'Si vous ne vous souvenez pas de votre mot de passe, cliquez sur le lien ci-dessous pour dÃ©finir un nouveau');
INSERT INTO `site_lang` VALUES ('177', '17', 'Salut');
INSERT INTO `site_lang` VALUES ('176', '17', 'Pas');
INSERT INTO `site_lang` VALUES ('175', '17', 'Si');
INSERT INTO `site_lang` VALUES ('174', '17', 'Bonjour, Puis-je avoir accÃ¨s Ã  vos photos privÃ©es ?');
INSERT INTO `site_lang` VALUES ('173', '17', 'J&#039;aime Ã§a');
INSERT INTO `site_lang` VALUES ('171', '17', 'Jours premium');
INSERT INTO `site_lang` VALUES ('172', '17', 'autres personnes aiment Ã§a');
INSERT INTO `site_lang` VALUES ('170', '17', 'Acheter');
INSERT INTO `site_lang` VALUES ('169', '17', 'DÃ©cembre');
INSERT INTO `site_lang` VALUES ('166', '17', 'Septembre');
INSERT INTO `site_lang` VALUES ('167', '17', 'Octobre');
INSERT INTO `site_lang` VALUES ('168', '17', 'Novembre');
INSERT INTO `site_lang` VALUES ('165', '17', 'AoÃ»t');
INSERT INTO `site_lang` VALUES ('163', '17', 'Juin');
INSERT INTO `site_lang` VALUES ('164', '17', 'Juillet');
INSERT INTO `site_lang` VALUES ('162', '17', 'Mai');
INSERT INTO `site_lang` VALUES ('160', '17', 'Mars');
INSERT INTO `site_lang` VALUES ('161', '17', 'Avril');
INSERT INTO `site_lang` VALUES ('159', '17', 'FÃ©vrier');
INSERT INTO `site_lang` VALUES ('158', '17', 'Janvier');
INSERT INTO `site_lang` VALUES ('156', '17', 'Vous n&#039;avez pas encore les fans');
INSERT INTO `site_lang` VALUES ('157', '17', 'Vous n&#039;avez pas encore matchs');
INSERT INTO `site_lang` VALUES ('155', '17', 'Aucun utilisateur populaires prÃ¨s de chez vous');
INSERT INTO `site_lang` VALUES ('154', '17', 'Personnes ont trouvÃ©');
INSERT INTO `site_lang` VALUES ('152', '17', 'VÃ©rifiÃ©');
INSERT INTO `site_lang` VALUES ('153', '17', 'Aucun rÃ©sultat');
INSERT INTO `site_lang` VALUES ('151', '17', 'Actuellement en ligne');
INSERT INTO `site_lang` VALUES ('150', '17', 'Supprimer le profil');
INSERT INTO `site_lang` VALUES ('149', '17', 'AprÃ¨s avoir retirÃ© le profil , certaines de vos donnÃ©es seront perdues sans rÃ©cupÃ©ration');
INSERT INTO `site_lang` VALUES ('148', '17', 'Profil Eteint');
INSERT INTO `site_lang` VALUES ('146', '17', 'Vous pouvez modifier votre mot de passe actuel ci-dessous');
INSERT INTO `site_lang` VALUES ('147', '17', 'Nouveau mot de passe');
INSERT INTO `site_lang` VALUES ('145', '17', 'Changer le mot de passe');
INSERT INTO `site_lang` VALUES ('144', '17', 'Mise Ã  niveau Ã  la prime');
INSERT INTO `site_lang` VALUES ('143', '17', 'Ajouter des crÃ©dits');
INSERT INTO `site_lang` VALUES ('142', '17', 'CrÃ©dit actuel');
INSERT INTO `site_lang` VALUES ('141', '17', 'Type de compte');
INSERT INTO `site_lang` VALUES ('140', '17', 'Achetez des crÃ©dits pour envoyer des cadeaux et des photos privÃ©es DÃ©verrouillage');
INSERT INTO `site_lang` VALUES ('139', '17', 'Votre compte est dÃ©jÃ  vÃ©rifiÃ©e');
INSERT INTO `site_lang` VALUES ('138', '17', 'Connectez-vous avec Facebook');
INSERT INTO `site_lang` VALUES ('137', '17', 'Pour vÃ©rifier votre compte , connectez-vous avec votre compte Facebook');
INSERT INTO `site_lang` VALUES ('136', '17', 'Votre compte Ã©tÃ© vÃ©rifiÃ©e');
INSERT INTO `site_lang` VALUES ('135', '17', 'Mettre Ã  jour');
INSERT INTO `site_lang` VALUES ('134', '17', 'Langue');
INSERT INTO `site_lang` VALUES ('132', '17', 'Information personnelle');
INSERT INTO `site_lang` VALUES ('133', '17', 'Vous pouvez modifier vos informations de profil ci-dessous');
INSERT INTO `site_lang` VALUES ('131', '17', 'Supprimer');
INSERT INTO `site_lang` VALUES ('130', '17', 'SÃ©curitÃ©');
INSERT INTO `site_lang` VALUES ('128', '17', 'CrÃ©dits');
INSERT INTO `site_lang` VALUES ('129', '17', 'VÃ©rifier');
INSERT INTO `site_lang` VALUES ('127', '17', 'Personnel');
INSERT INTO `site_lang` VALUES ('125', '17', 'Demandez la permission de');
INSERT INTO `site_lang` VALUES ('126', '17', 'DÃ©bloquez photos privÃ©es');
INSERT INTO `site_lang` VALUES ('124', '17', 'Maintenant, vous avez');
INSERT INTO `site_lang` VALUES ('123', '17', 'Les crÃ©dits ont Ã©tÃ© ajoutÃ©s correctement');
INSERT INTO `site_lang` VALUES ('122', '17', 'Hommes et femmes');
INSERT INTO `site_lang` VALUES ('120', '17', 'seuls les hommes');
INSERT INTO `site_lang` VALUES ('121', '17', 'Seulement les femmes');
INSERT INTO `site_lang` VALUES ('119', '17', 'Ton Ã¢ge');
INSERT INTO `site_lang` VALUES ('118', '17', 'Information personnelle');
INSERT INTO `site_lang` VALUES ('114', '17', 'dans une radio');
INSERT INTO `site_lang` VALUES ('115', '17', 'Monde');
INSERT INTO `site_lang` VALUES ('116', '17', 'La plupart des utilisateurs populaires');
INSERT INTO `site_lang` VALUES ('117', '17', 'Ã€ propos de');
INSERT INTO `site_lang` VALUES ('113', '17', 'Ceux entre');
INSERT INTO `site_lang` VALUES ('112', '17', 'Les deux');
INSERT INTO `site_lang` VALUES ('110', '17', 'Femmes');
INSERT INTO `site_lang` VALUES ('111', '17', 'Hommes');
INSERT INTO `site_lang` VALUES ('109', '17', 'Montrez-moi');
INSERT INTO `site_lang` VALUES ('108', '17', 'Actuellement en ligne');
INSERT INTO `site_lang` VALUES ('107', '17', 'Tous les utilisateurs');
INSERT INTO `site_lang` VALUES ('106', '17', 'Filtre de recherche');
INSERT INTO `site_lang` VALUES ('105', '17', 'Vos correspondances');
INSERT INTO `site_lang` VALUES ('104', '17', 'S&#039;il vous plaÃ®t complÃ©ter votre profil avant');
INSERT INTO `site_lang` VALUES ('103', '17', 'Conditions d&#039;utilisation');
INSERT INTO `site_lang` VALUES ('101', '17', 'Votre fans');
INSERT INTO `site_lang` VALUES ('102', '17', 'Politique de confidentialitÃ©');
INSERT INTO `site_lang` VALUES ('100', '17', 'Ou attendre demain pour continuer Ã  entendre les gens');
INSERT INTO `site_lang` VALUES ('99', '17', 'conversations quotidiennes');
INSERT INTO `site_lang` VALUES ('98', '17', 'et de se lever');
INSERT INTO `site_lang` VALUES ('97', '17', 'AmÃ©liorez votre compte Ã  Premium');
INSERT INTO `site_lang` VALUES ('96', '17', 'ou');
INSERT INTO `site_lang` VALUES ('95', '17', 'Plus de conversations par jour');
INSERT INTO `site_lang` VALUES ('94', '17', 'Acheter');
INSERT INTO `site_lang` VALUES ('93', '17', 'Pour continuer Ã  chatter');
INSERT INTO `site_lang` VALUES ('92', '17', 'Vous avez atteint la limite de nouvelles conversations quotidiennes');
INSERT INTO `site_lang` VALUES ('91', '17', 'Chat');
INSERT INTO `site_lang` VALUES ('89', '17', 'Entrez le texte ici');
INSERT INTO `site_lang` VALUES ('90', '17', 'Envoyer');
INSERT INTO `site_lang` VALUES ('88', '17', 'Utilisateur Premium logo');
INSERT INTO `site_lang` VALUES ('87', '17', 'DÃ©bloquez toutes les photos privÃ©es');
INSERT INTO `site_lang` VALUES ('85', '17', 'Nouveaux chats par jour');
INSERT INTO `site_lang` VALUES ('86', '17', 'Appels vidÃ©o illimitÃ©s');
INSERT INTO `site_lang` VALUES ('84', '17', 'CaractÃ©ristiques premium');
INSERT INTO `site_lang` VALUES ('83', '17', 'Acheter des CrÃ©dits');
INSERT INTO `site_lang` VALUES ('82', '17', 'Payer avec');
INSERT INTO `site_lang` VALUES ('81', '17', 'Payer avec');
INSERT INTO `site_lang` VALUES ('80', '17', 'SÃ©lectionnez la mÃ©thode de paiement');
INSERT INTO `site_lang` VALUES ('79', '17', 'SÃ©lectionnez le pack de crÃ©dit');
INSERT INTO `site_lang` VALUES ('78', '17', 'Acheter des crÃ©dits / AmÃ©liorez votre compte');
INSERT INTO `site_lang` VALUES ('77', '17', 'Envoyer des cadeaux');
INSERT INTO `site_lang` VALUES ('76', '17', 'Choisissez le cadeau que vous voulez envoyer');
INSERT INTO `site_lang` VALUES ('75', '17', 'Envoyer un cadeau');
INSERT INTO `site_lang` VALUES ('73', '17', 'CrÃ©dits');
INSERT INTO `site_lang` VALUES ('74', '17', 'Ajouter une photo');
INSERT INTO `site_lang` VALUES ('72', '17', 'Choisissez la photo que vous souhaitez afficher sur votre couverture');
INSERT INTO `site_lang` VALUES ('70', '17', 'Ajouter photo');
INSERT INTO `site_lang` VALUES ('71', '17', 'AjoutÃ© aux couvertures');
INSERT INTO `site_lang` VALUES ('69', '17', 'Ajoutez votre photo');
INSERT INTO `site_lang` VALUES ('68', '17', 'Photos privÃ©es');
INSERT INTO `site_lang` VALUES ('67', '17', 'Photos publiques');
INSERT INTO `site_lang` VALUES ('66', '17', 'Toutes les photos');
INSERT INTO `site_lang` VALUES ('65', '17', 'GÃ©rez vos photos');
INSERT INTO `site_lang` VALUES ('64', '17', 'Contacts');
INSERT INTO `site_lang` VALUES ('61', '17', 'Suggestions');
INSERT INTO `site_lang` VALUES ('62', '17', 'Termes');
INSERT INTO `site_lang` VALUES ('63', '17', 'ConfidentialitÃ©');
INSERT INTO `site_lang` VALUES ('60', '17', 'Nouveaux messages');
INSERT INTO `site_lang` VALUES ('59', '17', 'Actuellement en ligne');
INSERT INTO `site_lang` VALUES ('58', '17', 'Conversaciones');
INSERT INTO `site_lang` VALUES ('55', '17', 'RÃ©glages');
INSERT INTO `site_lang` VALUES ('56', '17', 'Tous');
INSERT INTO `site_lang` VALUES ('57', '17', 'Fans');
INSERT INTO `site_lang` VALUES ('54', '17', 'GÃ©rer les photos');
INSERT INTO `site_lang` VALUES ('53', '17', 'Fans');
INSERT INTO `site_lang` VALUES ('52', '17', 'Les plus populaires');
INSERT INTO `site_lang` VALUES ('51', '17', 'CoÃ¯ncidences');
INSERT INTO `site_lang` VALUES ('50', '17', 'DÃ©couvrir');
INSERT INTO `site_lang` VALUES ('49', '17', 'Rencontrer de nouvelles personnes');
INSERT INTO `site_lang` VALUES ('48', '17', 'Fermer la session');
INSERT INTO `site_lang` VALUES ('47', '17', 'RÃ©glages');
INSERT INTO `site_lang` VALUES ('46', '17', 'Profil');
INSERT INTO `site_lang` VALUES ('45', '17', 'Politique de confidentialitÃ©');
INSERT INTO `site_lang` VALUES ('44', '17', 'et');
INSERT INTO `site_lang` VALUES ('1', '17', 'Commencer la session');
INSERT INTO `site_lang` VALUES ('43', '17', 'Termes et conditions');
INSERT INTO `site_lang` VALUES ('42', '17', 'En continuant, vous confirmez que vous avez lu et acceptÃ© notre');
INSERT INTO `site_lang` VALUES ('41', '17', 'Signer');
INSERT INTO `site_lang` VALUES ('40', '17', 'Rencontrez des hommes et des femmes');
INSERT INTO `site_lang` VALUES ('39', '17', 'GarÃ§ons rencontrent');
INSERT INTO `site_lang` VALUES ('38', '17', 'Filles rencontrent');
INSERT INTO `site_lang` VALUES ('37', '17', 'Je suis pour');
INSERT INTO `site_lang` VALUES ('36', '17', 'Femme');
INSERT INTO `site_lang` VALUES ('35', '17', 'Masculin');
INSERT INTO `site_lang` VALUES ('34', '17', 'Sexe');
INSERT INTO `site_lang` VALUES ('33', '17', 'OÃ¹ vis tu?');
INSERT INTO `site_lang` VALUES ('32', '17', 'Ville');
INSERT INTO `site_lang` VALUES ('31', '17', 'S&#039;il vous plaÃ®t sÃ©lectionnez');
INSERT INTO `site_lang` VALUES ('30', '17', 'Anniversaire');
INSERT INTO `site_lang` VALUES ('29', '17', 'Mot de passe');
INSERT INTO `site_lang` VALUES ('26', '17', 'Nom');
INSERT INTO `site_lang` VALUES ('27', '17', 'Votre nom ou pseudo');
INSERT INTO `site_lang` VALUES ('28', '17', 'Email');
INSERT INTO `site_lang` VALUES ('24', '17', 'Devenir membre maintenant');
INSERT INTO `site_lang` VALUES ('25', '17', 'Je me joins Ã  la meilleure communautÃ© pour rencontrer de nouvelles personnes');
INSERT INTO `site_lang` VALUES ('22', '17', 'CoÃ¯ncidences');
INSERT INTO `site_lang` VALUES ('23', '17', 'Profitez de notre jeu populaire de la dÃ©couverte, il est un excellent moyen de briser la glace et discuter avec de nouvelles personnes');
INSERT INTO `site_lang` VALUES ('20', '17', 'Personnes proches');
INSERT INTO `site_lang` VALUES ('21', '17', 'Nous ne montrons l&#039;emplacement exact , mais vous serez en mesure de trouver des personnes Ã  proximitÃ© qui ont vos intÃ©rÃªts');
INSERT INTO `site_lang` VALUES ('19', '17', 'Vous pouvez faire des appels vidÃ©o de qualitÃ© gratuitement Ã  toute personne , durÃ©e illimitÃ©e de l&#039;appel , profitez juste de voir la personne qui vous parle');
INSERT INTO `site_lang` VALUES ('18', '17', 'Video Chat');
INSERT INTO `site_lang` VALUES ('17', '17', 'Chat privÃ© puissant pour rencontrer de nouveaux amis , vous pouvez envoyer des Ã©moticÃ´nes et des photos privÃ©es Ã  personne.');
INSERT INTO `site_lang` VALUES ('16', '17', 'Chat');
INSERT INTO `site_lang` VALUES ('15', '17', 'RÃ©cupÃ©rer le mot de passe');
INSERT INTO `site_lang` VALUES ('14', '17', 'RÃ©cupÃ©rer le mot de passe');
INSERT INTO `site_lang` VALUES ('13', '17', 'Connectez-vous maintenant');
INSERT INTO `site_lang` VALUES ('12', '17', 'Vous avez oubliÃ© votre mot de passe?');
INSERT INTO `site_lang` VALUES ('10', '17', 'Ton adresse mail');
INSERT INTO `site_lang` VALUES ('11', '17', 'Ta  mot de passe');
INSERT INTO `site_lang` VALUES ('9', '17', 'Bienvenue Ã  nouveau');
INSERT INTO `site_lang` VALUES ('8', '17', 'CrÃ©er votre compte');
INSERT INTO `site_lang` VALUES ('7', '17', 'Se connecter avec');
INSERT INTO `site_lang` VALUES ('6', '17', 'BIENTÃ”T DISPONIBLE');
INSERT INTO `site_lang` VALUES ('5', '17', 'BientÃ´t, nous aurons nos demandes de ligne tÃ©lÃ©phonique');
INSERT INTO `site_lang` VALUES ('4', '17', 'S&#039;il vous plaÃ®t vÃ©rifier de votre ordinateur portable ou PC');
INSERT INTO `site_lang` VALUES ('3', '17', 'Pour l&#039;instant notre site ne fonctionne que pour les utilisateurs de Windows');
INSERT INTO `site_lang` VALUES ('339', '2', 'de');
INSERT INTO `site_lang` VALUES ('338', '2', 'Fotos de');
INSERT INTO `site_lang` VALUES ('337', '2', 'Te esta llamando...');
INSERT INTO `site_lang` VALUES ('336', '2', 'ContraseÃ±a cambiada correctamente');
INSERT INTO `site_lang` VALUES ('335', '2', 'Coste de los servicios');
INSERT INTO `site_lang` VALUES ('334', '2', 'Portada');
INSERT INTO `site_lang` VALUES ('333', '2', 'Incorrecto');
INSERT INTO `site_lang` VALUES ('332', '2', 'DÃ­as Premium');
INSERT INTO `site_lang` VALUES ('331', '2', 'Usuario');
INSERT INTO `site_lang` VALUES ('330', '2', 'Usted tiene que escribir su nombre de usuario !');
INSERT INTO `site_lang` VALUES ('328', '2', 'Pulse la barra espaciadora para volver a la secciÃ³n de citas .');
INSERT INTO `site_lang` VALUES ('329', '2', 'Escribe tu nombre de usuario de Instagram');
INSERT INTO `site_lang` VALUES ('326', '2', 'Reportar  y Bloquear');
INSERT INTO `site_lang` VALUES ('327', '2', 'Seguro que deseas reportar?');
INSERT INTO `site_lang` VALUES ('325', '2', 'Tu lo/a has bloqueado o el/ella te a bloqueado , no puedes chatear con Ã©l/ella , lo siento');
INSERT INTO `site_lang` VALUES ('322', '2', 'Hola, soy');
INSERT INTO `site_lang` VALUES ('323', '2', 'aÃ±os de edad y soy de');
INSERT INTO `site_lang` VALUES ('324', '2', 'Le hemos mandado un correo electrÃ³nico para verificar su cuenta');
INSERT INTO `site_lang` VALUES ('321', '2', 'Por favor, aÃ±ada una foto de perfil');
INSERT INTO `site_lang` VALUES ('320', '2', 'Por favor, verifica tu cuenta , le hemos enviado un email a su correo electrÃ³nico');
INSERT INTO `site_lang` VALUES ('317', '2', 'minutos');
INSERT INTO `site_lang` VALUES ('318', '2', 'segundos');
INSERT INTO `site_lang` VALUES ('319', '2', 'hace');
INSERT INTO `site_lang` VALUES ('315', '2', 'dÃ­as');
INSERT INTO `site_lang` VALUES ('316', '2', 'horas');
INSERT INTO `site_lang` VALUES ('314', '2', 'Meses');
INSERT INTO `site_lang` VALUES ('313', '2', 'aÃ±os');
INSERT INTO `site_lang` VALUES ('311', '2', 'minuto');
INSERT INTO `site_lang` VALUES ('312', '2', 'segundo');
INSERT INTO `site_lang` VALUES ('308', '2', 'Mes');
INSERT INTO `site_lang` VALUES ('309', '2', 'dÃ­a');
INSERT INTO `site_lang` VALUES ('310', '2', 'hora');
INSERT INTO `site_lang` VALUES ('307', '2', 'aÃ±o');
INSERT INTO `site_lang` VALUES ('306', '2', '0 segundos');
INSERT INTO `site_lang` VALUES ('305', '2', 'CrÃ©ditos por $');
INSERT INTO `site_lang` VALUES ('304', '2', 'Costo');
INSERT INTO `site_lang` VALUES ('303', '2', 'No te gusta nadie');
INSERT INTO `site_lang` VALUES ('302', '2', 'visitÃ³');
INSERT INTO `site_lang` VALUES ('301', '2', 'Usted todavia no tiene visitas');
INSERT INTO `site_lang` VALUES ('300', '2', 'EDAD');
INSERT INTO `site_lang` VALUES ('299', '2', 'No me gusta');
INSERT INTO `site_lang` VALUES ('298', '2', 'Me Gusta');
INSERT INTO `site_lang` VALUES ('297', '2', 'Mensajes');
INSERT INTO `site_lang` VALUES ('296', '2', 'Ver gente que gusta de ti');
INSERT INTO `site_lang` VALUES ('295', '2', 'Personas que me gustan');
INSERT INTO `site_lang` VALUES ('294', '2', 'Actualizar la cuenta a premium');
INSERT INTO `site_lang` VALUES ('293', '2', 'Personas que han visitado tu perfil para verte');
INSERT INTO `site_lang` VALUES ('292', '2', 'Eliminar');
INSERT INTO `site_lang` VALUES ('291', '2', 'Foto Publica');
INSERT INTO `site_lang` VALUES ('290', '2', 'Fotos Privadas');
INSERT INTO `site_lang` VALUES ('289', '2', 'Establecer como perfil');
INSERT INTO `site_lang` VALUES ('288', '2', 'Se visto por millones');
INSERT INTO `site_lang` VALUES ('287', '2', 'AgrÃ©game aquÃ­');
INSERT INTO `site_lang` VALUES ('286', '2', 'Visitas');
INSERT INTO `site_lang` VALUES ('282', '2', 'AÃ±adir desde');
INSERT INTO `site_lang` VALUES ('283', '2', 'AÃ±adir');
INSERT INTO `site_lang` VALUES ('284', '2', 'Fotos');
INSERT INTO `site_lang` VALUES ('285', '2', 'Creditos');
INSERT INTO `site_lang` VALUES ('281', '2', 'Fotos Privadas');
INSERT INTO `site_lang` VALUES ('280', '2', 'Fotos publicas');
INSERT INTO `site_lang` VALUES ('278', '2', 'Fans');
INSERT INTO `site_lang` VALUES ('279', '2', 'Sin datos');
INSERT INTO `site_lang` VALUES ('277', '2', 'Reportar');
INSERT INTO `site_lang` VALUES ('275', '2', 'Por favor espera');
INSERT INTO `site_lang` VALUES ('276', '2', 'Intereses');
INSERT INTO `site_lang` VALUES ('274', '2', 'AÃ±o');
INSERT INTO `site_lang` VALUES ('273', '2', 'Mes');
INSERT INTO `site_lang` VALUES ('272', '2', 'DÃ­a');
INSERT INTO `site_lang` VALUES ('271', '2', 'Cuando alguien me envÃ­a un mensaje');
INSERT INTO `site_lang` VALUES ('270', '2', 'Cuando los nuevos usuarios viven cerca de mÃ­');
INSERT INTO `site_lang` VALUES ('269', '2', 'Cuando me sale una coincidencia');
INSERT INTO `site_lang` VALUES ('268', '2', 'Cuando alguien me gusta');
INSERT INTO `site_lang` VALUES ('267', '2', 'Ninguna');
INSERT INTO `site_lang` VALUES ('266', '2', 'Soy dueÃ±o de una moto');
INSERT INTO `site_lang` VALUES ('265', '2', 'Soy dueÃ±o de un auto');
INSERT INTO `site_lang` VALUES ('264', '2', 'Padre/Madre con coche');
INSERT INTO `site_lang` VALUES ('263', '2', 'Transporte');
INSERT INTO `site_lang` VALUES ('262', '2', 'Beber');
INSERT INTO `site_lang` VALUES ('261', '2', 'A veces');
INSERT INTO `site_lang` VALUES ('260', '2', 'No');
INSERT INTO `site_lang` VALUES ('259', '2', 'Si');
INSERT INTO `site_lang` VALUES ('258', '2', 'Fumo');
INSERT INTO `site_lang` VALUES ('257', '2', 'Solo');
INSERT INTO `site_lang` VALUES ('256', '2', 'Con compaÃ±ero');
INSERT INTO `site_lang` VALUES ('255', '2', 'Residencia de estudiantes');
INSERT INTO `site_lang` VALUES ('254', '2', 'Con compaÃ±ero de piso');
INSERT INTO `site_lang` VALUES ('253', '2', 'Con Padre/Madre');
INSERT INTO `site_lang` VALUES ('252', '2', 'Viviendo');
INSERT INTO `site_lang` VALUES ('251', '2', 'Gordo');
INSERT INTO `site_lang` VALUES ('250', '2', 'Corpulento');
INSERT INTO `site_lang` VALUES ('249', '2', 'Atletico');
INSERT INTO `site_lang` VALUES ('248', '2', 'Promedio');
INSERT INTO `site_lang` VALUES ('247', '2', 'Delgado');
INSERT INTO `site_lang` VALUES ('246', '2', 'Tipo de cuerpo');
INSERT INTO `site_lang` VALUES ('245', '2', 'Otro/s');
INSERT INTO `site_lang` VALUES ('244', '2', 'Indio');
INSERT INTO `site_lang` VALUES ('243', '2', 'Islas del PacÃ­fico');
INSERT INTO `site_lang` VALUES ('242', '2', 'Hispano/Latino');
INSERT INTO `site_lang` VALUES ('241', '2', 'Nativo americano');
INSERT INTO `site_lang` VALUES ('240', '2', 'Blanco');
INSERT INTO `site_lang` VALUES ('239', '2', 'Negro');
INSERT INTO `site_lang` VALUES ('238', '2', 'Medio Este');
INSERT INTO `site_lang` VALUES ('237', '2', 'Asia');
INSERT INTO `site_lang` VALUES ('236', '2', 'Ã‰tnica');
INSERT INTO `site_lang` VALUES ('235', '2', 'Peso');
INSERT INTO `site_lang` VALUES ('234', '2', 'mas de');
INSERT INTO `site_lang` VALUES ('233', '2', 'menos que');
INSERT INTO `site_lang` VALUES ('232', '2', 'Altura');
INSERT INTO `site_lang` VALUES ('231', '2', 'Bisexual');
INSERT INTO `site_lang` VALUES ('230', '2', 'Heterosexual');
INSERT INTO `site_lang` VALUES ('229', '2', 'Mente abierta');
INSERT INTO `site_lang` VALUES ('228', '2', 'Gay');
INSERT INTO `site_lang` VALUES ('227', '2', 'Sexualidad');
INSERT INTO `site_lang` VALUES ('226', '2', 'Abierta');
INSERT INTO `site_lang` VALUES ('225', '2', 'Casado');
INSERT INTO `site_lang` VALUES ('224', '2', 'SÃ³lo');
INSERT INTO `site_lang` VALUES ('223', '2', 'Relaciones');
INSERT INTO `site_lang` VALUES ('222', '2', 'InformaciÃ³n extendida ( opcional)');
INSERT INTO `site_lang` VALUES ('220', '2', 'MEJORAR');
INSERT INTO `site_lang` VALUES ('221', '2', 'Notificaciones');
INSERT INTO `site_lang` VALUES ('219', '2', 'Basico');
INSERT INTO `site_lang` VALUES ('218', '2', 'hasta');
INSERT INTO `site_lang` VALUES ('217', '2', 'Espere mÃ¡s');
INSERT INTO `site_lang` VALUES ('216', '2', 'Finalizar llamada');
INSERT INTO `site_lang` VALUES ('214', '2', 'La espera a sido demasiado larga');
INSERT INTO `site_lang` VALUES ('215', '2', 'Parece que tu amigo no tiene cÃ¡mara web o no estÃ¡ disponible');
INSERT INTO `site_lang` VALUES ('213', '2', 'No puedes hacer videollamadas , porque tu no tienes cÃ¡mara web');
INSERT INTO `site_lang` VALUES ('212', '2', 'Imposible hacer una llamada!');
INSERT INTO `site_lang` VALUES ('211', '2', 'SÃ³lo los usuarios premium pueden realizar videollamadas');
INSERT INTO `site_lang` VALUES ('209', '2', 'Por favor, permitir el acceso a tu cÃ¡mara web .');
INSERT INTO `site_lang` VALUES ('210', '2', 'Ya estÃ¡s en una videollamada , tu tienes que poner fin a la otra llamada antes de iniciar otra');
INSERT INTO `site_lang` VALUES ('208', '2', 'estÃ¡ desconectado , intÃ©ntelo de nuevo cuando tu amigo estÃ© en lÃ­nea');
INSERT INTO `site_lang` VALUES ('207', '2', 'Esta en otra videollamada , no puedes llamar ahora');
INSERT INTO `site_lang` VALUES ('206', '2', 'Si, Eliminar!');
INSERT INTO `site_lang` VALUES ('204', '2', 'Terminos de cuenta');
INSERT INTO `site_lang` VALUES ('205', '2', 'Tus datos se perderÃ¡n sin recuperaciÃ³n , desea continuar ?');
INSERT INTO `site_lang` VALUES ('203', '2', 'InformaciÃ³n actualizada correctamente');
INSERT INTO `site_lang` VALUES ('202', '2', 'Si, comprar esto!');
INSERT INTO `site_lang` VALUES ('201', '2', 'Para mÃ¡s conversaciÃ³nes diarias , costo');
INSERT INTO `site_lang` VALUES ('200', '2', 'Expandir limitaciÃ³n diaria');
INSERT INTO `site_lang` VALUES ('198', '2', 'Porfavor, selecciona 1 regalo');
INSERT INTO `site_lang` VALUES ('199', '2', 'Usted no tiene crÃ©ditos suficientes para enviar el regalo');
INSERT INTO `site_lang` VALUES ('197', '2', 'Por favor , seleccione una foto');
INSERT INTO `site_lang` VALUES ('194', '2', 'Tener acceso');
INSERT INTO `site_lang` VALUES ('195', '2', 'No gracias');
INSERT INTO `site_lang` VALUES ('196', '2', 'Por favor seleccione un mÃ©todo de pago');
INSERT INTO `site_lang` VALUES ('193', '2', 'fotos privadas para');
INSERT INTO `site_lang` VALUES ('192', '2', 'Obtener acceso a');
INSERT INTO `site_lang` VALUES ('191', '2', 'Comprar permisos para fotos privadas');
INSERT INTO `site_lang` VALUES ('189', '2', 'SÃ­ , tu puedes ver mis fotos privadas');
INSERT INTO `site_lang` VALUES ('190', '2', 'No, no puedo mostrarte mis fotos privadas');
INSERT INTO `site_lang` VALUES ('188', '2', 'El correo electrÃ³nico ya existe , pruebe con otro');
INSERT INTO `site_lang` VALUES ('187', '2', 'ContraseÃ±a muy corta');
INSERT INTO `site_lang` VALUES ('186', '2', 'Elegir la funciÃ³n de autocompletar');
INSERT INTO `site_lang` VALUES ('184', '2', 'ContraseÃ±a incorrecta');
INSERT INTO `site_lang` VALUES ('185', '2', 'AÃ±adir una fecha vÃ¡lida');
INSERT INTO `site_lang` VALUES ('183', '2', 'Este email no existe');
INSERT INTO `site_lang` VALUES ('182', '2', 'Por favor, rellene todas las opciones');
INSERT INTO `site_lang` VALUES ('181', '2', 'Porfavor introduzca un formato de correo electrÃ³nico vÃ¡lido');
INSERT INTO `site_lang` VALUES ('180', '2', 'Recupera tu contraseÃ±a');
INSERT INTO `site_lang` VALUES ('179', '2', 'Acceder a mi cuenta');
INSERT INTO `site_lang` VALUES ('178', '2', 'Si no recuerdas tu contraseÃ±a , haga clic en el enlace a continuaciÃ³n para configurar una nueva');
INSERT INTO `site_lang` VALUES ('177', '2', 'Hola');
INSERT INTO `site_lang` VALUES ('176', '2', 'No');
INSERT INTO `site_lang` VALUES ('175', '2', 'Si');
INSERT INTO `site_lang` VALUES ('174', '2', 'Hola , Â¿Puedo tener acceso a tus fotos privadas ?');
INSERT INTO `site_lang` VALUES ('173', '2', 'Me gusta esto');
INSERT INTO `site_lang` VALUES ('172', '2', 'personas mÃ¡s les gusta esto');
INSERT INTO `site_lang` VALUES ('171', '2', 'DÃ­as premium');
INSERT INTO `site_lang` VALUES ('170', '2', 'Comprar');
INSERT INTO `site_lang` VALUES ('169', '2', 'Diciembre');
INSERT INTO `site_lang` VALUES ('168', '2', 'Noviembre');
INSERT INTO `site_lang` VALUES ('167', '2', 'Octubre');
INSERT INTO `site_lang` VALUES ('166', '2', 'Septiembre');
INSERT INTO `site_lang` VALUES ('165', '2', 'Agosto');
INSERT INTO `site_lang` VALUES ('164', '2', 'Julio');
INSERT INTO `site_lang` VALUES ('163', '2', 'Junio');
INSERT INTO `site_lang` VALUES ('162', '2', 'Mayo');
INSERT INTO `site_lang` VALUES ('161', '2', 'Abril');
INSERT INTO `site_lang` VALUES ('160', '2', 'Marzo');
INSERT INTO `site_lang` VALUES ('159', '2', 'Febrero');
INSERT INTO `site_lang` VALUES ('158', '2', 'Enero');
INSERT INTO `site_lang` VALUES ('157', '2', 'Usted no tiene coincidencias todavÃ­a');
INSERT INTO `site_lang` VALUES ('156', '2', 'Tu no tienes fans todavÃ­a');
INSERT INTO `site_lang` VALUES ('155', '2', 'No hay usuarios populares cerca de ti');
INSERT INTO `site_lang` VALUES ('154', '2', 'Personas encontradas');
INSERT INTO `site_lang` VALUES ('153', '2', 'Sin resultados');
INSERT INTO `site_lang` VALUES ('152', '2', 'Verificado');
INSERT INTO `site_lang` VALUES ('151', '2', 'En linea ahora');
INSERT INTO `site_lang` VALUES ('149', '2', 'DespuÃ©s de eliminar el perfil , algunos de sus datos se perderÃ¡n sin recuperaciÃ³n');
INSERT INTO `site_lang` VALUES ('150', '2', 'Borrar Perfil');
INSERT INTO `site_lang` VALUES ('148', '2', 'Desactivar Perfil');
INSERT INTO `site_lang` VALUES ('147', '2', 'Nueva contraseÃ±a');
INSERT INTO `site_lang` VALUES ('146', '2', 'Puede cambiar tu contraseÃ±a actual abajo');
INSERT INTO `site_lang` VALUES ('145', '2', 'Cambiar contraseÃ±a');
INSERT INTO `site_lang` VALUES ('144', '2', 'Actualizar a cuenta premium');
INSERT INTO `site_lang` VALUES ('143', '2', 'AÃ±ade creditos');
INSERT INTO `site_lang` VALUES ('142', '2', 'CrÃ©ditos actuales');
INSERT INTO `site_lang` VALUES ('140', '2', 'Comprar crÃ©ditos para enviar Regalos y Desbloquear fotos privadas');
INSERT INTO `site_lang` VALUES ('141', '2', 'Tipo de cuenta');
INSERT INTO `site_lang` VALUES ('139', '2', 'Tu cuenta ya esta verificada');
INSERT INTO `site_lang` VALUES ('138', '2', 'Conectar con Facebook');
INSERT INTO `site_lang` VALUES ('137', '2', 'Para verificar tu cuenta , conectate con tu cuenta de Facebook');
INSERT INTO `site_lang` VALUES ('136', '2', 'Tu cuenta a sido verificada');
INSERT INTO `site_lang` VALUES ('135', '2', 'Actualizar perfil');
INSERT INTO `site_lang` VALUES ('134', '2', 'Lenguaje');
INSERT INTO `site_lang` VALUES ('133', '2', 'Puede editar la informaciÃ³n de su perfil abajo');
INSERT INTO `site_lang` VALUES ('132', '2', 'Informacion Personal');
INSERT INTO `site_lang` VALUES ('131', '2', 'Eliminar');
INSERT INTO `site_lang` VALUES ('2', '17', 'Bienvenue sur l&#039;espace le plus rapide pour rencontrer de nouvelles personnes');
INSERT INTO `site_lang` VALUES ('130', '2', 'Seguridad');
INSERT INTO `site_lang` VALUES ('129', '2', 'Verificar');
INSERT INTO `site_lang` VALUES ('128', '2', 'Creditos');
INSERT INTO `site_lang` VALUES ('127', '2', 'Personal');
INSERT INTO `site_lang` VALUES ('126', '2', 'Desbloquear fotos privadas');
INSERT INTO `site_lang` VALUES ('124', '2', 'Ahora tu tienes');
INSERT INTO `site_lang` VALUES ('125', '2', 'Pedir permiso para');
INSERT INTO `site_lang` VALUES ('123', '2', 'Los crÃ©ditos se han aÃ±adido correctamente');
INSERT INTO `site_lang` VALUES ('122', '2', 'Hombres y Mujeres');
INSERT INTO `site_lang` VALUES ('121', '2', 'Solo Mujeres');
INSERT INTO `site_lang` VALUES ('120', '2', 'Solo hombres');
INSERT INTO `site_lang` VALUES ('119', '2', 'Tu edad');
INSERT INTO `site_lang` VALUES ('118', '2', 'Informacion Personal');
INSERT INTO `site_lang` VALUES ('117', '2', 'Acerca de');
INSERT INTO `site_lang` VALUES ('116', '2', 'Usuarios mÃ¡s populares');
INSERT INTO `site_lang` VALUES ('114', '2', 'en un radio de');
INSERT INTO `site_lang` VALUES ('115', '2', 'Mundo');
INSERT INTO `site_lang` VALUES ('113', '2', 'Que tienen entre');
INSERT INTO `site_lang` VALUES ('112', '2', 'Ambos');
INSERT INTO `site_lang` VALUES ('111', '2', 'Hombres');
INSERT INTO `site_lang` VALUES ('110', '2', 'Mujeres');
INSERT INTO `site_lang` VALUES ('109', '2', 'Mostrame');
INSERT INTO `site_lang` VALUES ('108', '2', 'En linea ahora');
INSERT INTO `site_lang` VALUES ('107', '2', 'Todos los usuarios');
INSERT INTO `site_lang` VALUES ('104', '2', 'Por favor completa tu perfil antes de comenzar');
INSERT INTO `site_lang` VALUES ('105', '2', 'Tus Coincidencias');
INSERT INTO `site_lang` VALUES ('106', '2', 'Filtro de bÃºsqueda');
INSERT INTO `site_lang` VALUES ('103', '2', 'TÃ©rminos de Uso');
INSERT INTO `site_lang` VALUES ('102', '2', 'PolÃ­tica de privacidad');
INSERT INTO `site_lang` VALUES ('101', '2', 'Tus fans');
INSERT INTO `site_lang` VALUES ('100', '2', 'O esperar hasta maÃ±ana para seguir conociendo personas');
INSERT INTO `site_lang` VALUES ('99', '2', 'conversaciones diarias');
INSERT INTO `site_lang` VALUES ('98', '2', 'y obtener hasta');
INSERT INTO `site_lang` VALUES ('97', '2', 'Actualiza tu cuenta a Premium');
INSERT INTO `site_lang` VALUES ('96', '2', 'o');
INSERT INTO `site_lang` VALUES ('95', '2', 'mas conversaciones al dia');
INSERT INTO `site_lang` VALUES ('94', '2', 'Comprar');
INSERT INTO `site_lang` VALUES ('93', '2', 'Para continuar en el chat');
INSERT INTO `site_lang` VALUES ('92', '2', 'usted ha alcanzado el lÃ­mite de nuevas conversaciones diarias');
INSERT INTO `site_lang` VALUES ('91', '2', 'Chat');
INSERT INTO `site_lang` VALUES ('90', '2', 'Enviar');
INSERT INTO `site_lang` VALUES ('89', '2', 'Escribe el texto aqui');
INSERT INTO `site_lang` VALUES ('88', '2', 'Insignia usuario Premium');
INSERT INTO `site_lang` VALUES ('87', '2', 'Desbloquear todas las fotos privadas');
INSERT INTO `site_lang` VALUES ('86', '2', 'Videollamadas ilimitadas');
INSERT INTO `site_lang` VALUES ('85', '2', 'nuevos chats por dÃ­a');
INSERT INTO `site_lang` VALUES ('84', '2', 'CaracterÃ­sticas de la cuenta premium');
INSERT INTO `site_lang` VALUES ('83', '2', 'Compra Creditos');
INSERT INTO `site_lang` VALUES ('81', '2', 'Pagar con');
INSERT INTO `site_lang` VALUES ('82', '2', 'Pagar con');
INSERT INTO `site_lang` VALUES ('80', '2', 'Seleccionar mÃ©todo de pago');
INSERT INTO `site_lang` VALUES ('79', '2', 'Selecciona el pack de crÃ©ditos');
INSERT INTO `site_lang` VALUES ('78', '2', 'Comprar crÃ©ditos / Mejora tu cuenta');
INSERT INTO `site_lang` VALUES ('77', '2', 'Enviar regalos');
INSERT INTO `site_lang` VALUES ('75', '2', 'Enviar un regalo a');
INSERT INTO `site_lang` VALUES ('76', '2', 'Elige el regalo que desea enviar a');
INSERT INTO `site_lang` VALUES ('74', '2', 'AÃ±adir Foto');
INSERT INTO `site_lang` VALUES ('73', '2', 'Creditos');
INSERT INTO `site_lang` VALUES ('72', '2', 'Elige la foto que desea mostrar en tu portada');
INSERT INTO `site_lang` VALUES ('71', '2', 'Agregarse a las portadas');
INSERT INTO `site_lang` VALUES ('70', '2', 'AÃ±adir fotos');
INSERT INTO `site_lang` VALUES ('69', '2', 'AÃ±adir tu foto');
INSERT INTO `site_lang` VALUES ('68', '2', 'Fotos Privadas');
INSERT INTO `site_lang` VALUES ('67', '2', 'Fotos Publicas');
INSERT INTO `site_lang` VALUES ('66', '2', 'Todas las Fotos');
INSERT INTO `site_lang` VALUES ('65', '2', 'Administra tus fotos');
INSERT INTO `site_lang` VALUES ('63', '2', 'Privacidad');
INSERT INTO `site_lang` VALUES ('64', '2', 'Contactos');
INSERT INTO `site_lang` VALUES ('62', '2', 'Condiciones');
INSERT INTO `site_lang` VALUES ('61', '2', 'Sugerencias');
INSERT INTO `site_lang` VALUES ('60', '2', 'Nuevos Mensajes');
INSERT INTO `site_lang` VALUES ('59', '2', 'En linea ahora');
INSERT INTO `site_lang` VALUES ('58', '2', 'Conversaciones');
INSERT INTO `site_lang` VALUES ('57', '2', 'Fans');
INSERT INTO `site_lang` VALUES ('56', '2', 'Todas');
INSERT INTO `site_lang` VALUES ('55', '2', 'Ajustes');
INSERT INTO `site_lang` VALUES ('54', '2', 'Administrar fotos');
INSERT INTO `site_lang` VALUES ('53', '2', 'Fans');
INSERT INTO `site_lang` VALUES ('52', '2', 'Los mÃ¡s populares');
INSERT INTO `site_lang` VALUES ('51', '2', 'Coincidencias');
INSERT INTO `site_lang` VALUES ('50', '2', 'Descubrir');
INSERT INTO `site_lang` VALUES ('49', '2', 'Conoce gente nueva');
INSERT INTO `site_lang` VALUES ('48', '2', 'Cerrar sesiÃ³n');
INSERT INTO `site_lang` VALUES ('44', '2', 'y');
INSERT INTO `site_lang` VALUES ('45', '2', 'PolÃ­tica de privacidad');
INSERT INTO `site_lang` VALUES ('46', '2', 'Perfil');
INSERT INTO `site_lang` VALUES ('47', '2', 'Ajustes');
INSERT INTO `site_lang` VALUES ('43', '2', 'TÃ©rminos y Condiciones');
INSERT INTO `site_lang` VALUES ('42', '2', 'Al continuar, usted confirma que ha leÃ­do y estÃ¡ de acuerdo con nuestro');
INSERT INTO `site_lang` VALUES ('41', '2', 'RegÃ­strate');
INSERT INTO `site_lang` VALUES ('0', '17', 'Rencontrer de nouvelles personnes');
INSERT INTO `site_lang` VALUES ('40', '2', 'Conocer Hombres y Mujeres');
INSERT INTO `site_lang` VALUES ('39', '2', 'Conocer chicos');
INSERT INTO `site_lang` VALUES ('38', '2', 'Conocer chicas');
INSERT INTO `site_lang` VALUES ('37', '2', 'Estoy para');
INSERT INTO `site_lang` VALUES ('36', '2', 'Mujer');
INSERT INTO `site_lang` VALUES ('35', '2', 'Masculino');
INSERT INTO `site_lang` VALUES ('34', '2', 'GÃ©nero');
INSERT INTO `site_lang` VALUES ('33', '2', 'Â¿DÃ³nde vives?');
INSERT INTO `site_lang` VALUES ('32', '2', 'Ciudad');
INSERT INTO `site_lang` VALUES ('29', '2', 'ContraseÃ±a');
INSERT INTO `site_lang` VALUES ('30', '2', 'CumpleaÃ±os');
INSERT INTO `site_lang` VALUES ('31', '2', 'Por favor, seleccione');
INSERT INTO `site_lang` VALUES ('28', '2', 'Email');
INSERT INTO `site_lang` VALUES ('24', '2', 'Hazte miembro ahora');
INSERT INTO `site_lang` VALUES ('25', '2', 'UnetÃ© a la mejor comunidad para conocer gente nueva');
INSERT INTO `site_lang` VALUES ('26', '2', 'Nombre');
INSERT INTO `site_lang` VALUES ('27', '2', 'Su nombre o apodo');
INSERT INTO `site_lang` VALUES ('22', '2', 'Coincidencias');
INSERT INTO `site_lang` VALUES ('23', '2', 'Disfruta con nuestro popular juego de descubrimientos, es una gran manera de romper el hielo y charlar con gente nueva');
INSERT INTO `site_lang` VALUES ('19', '2', 'Puede realizar videollamadas de calidad de forma gratuita a cualquier persona , sin lÃ­mites de duraciÃ³n de la llamada , simplemente disfruta de ver a la persona que estÃ© hablando contigo');
INSERT INTO `site_lang` VALUES ('20', '2', 'Gente cerca');
INSERT INTO `site_lang` VALUES ('21', '2', 'No mostraremos la ubicaciÃ³n exacta , pero usted serÃ¡ capaz de encontrar a las personas cercanas que tienen mismos intereses que tu');
INSERT INTO `site_lang` VALUES ('18', '2', 'Video Chat');
INSERT INTO `site_lang` VALUES ('16', '2', 'Chat');
INSERT INTO `site_lang` VALUES ('17', '2', 'Chat privado de gran alcance para conocer nuevos amigos , puede enviar emoticons y fotos privadas a cualquiera.');
INSERT INTO `site_lang` VALUES ('15', '2', 'Recuperar contraseÃ±a');
INSERT INTO `site_lang` VALUES ('14', '2', 'Recuperar contraseÃ±a');
INSERT INTO `site_lang` VALUES ('13', '2', 'Iniciar sesiÃ³n ahora');
INSERT INTO `site_lang` VALUES ('12', '2', 'Â¿Se le olvido su contraseÃ±a ?');
INSERT INTO `site_lang` VALUES ('11', '2', 'Tu contraseÃ±a');
INSERT INTO `site_lang` VALUES ('10', '2', 'Tu correo electrÃ³nico');
INSERT INTO `site_lang` VALUES ('9', '2', 'Bienvenido de nuevo');
INSERT INTO `site_lang` VALUES ('8', '2', 'Crear tu cuenta');
INSERT INTO `site_lang` VALUES ('7', '2', 'Conectar con');
INSERT INTO `site_lang` VALUES ('6', '2', 'PRONTO DISPONIBLE');
INSERT INTO `site_lang` VALUES ('5', '2', 'Pronto tendremos nuestras aplicaciones para lÃ­nea de telÃ©fono');
INSERT INTO `site_lang` VALUES ('4', '2', 'Por favor, visÃ­tenos desde su ordenador portÃ¡til o PC');
INSERT INTO `site_lang` VALUES ('3', '2', 'Por ahora nuestro sitio sÃ³lo funciona para usuarios de Windows');
INSERT INTO `site_lang` VALUES ('2', '2', 'Bienvenido al lugar mÃ¡s rÃ¡pido para conocer gente nueva');
INSERT INTO `site_lang` VALUES ('1', '2', 'Iniciar sesiÃ³n');
INSERT INTO `site_lang` VALUES ('0', '2', 'Conoce gente nueva');
INSERT INTO `site_lang` VALUES ('208', '35', 'is offline, try again when your friend is online');
INSERT INTO `site_lang` VALUES ('209', '35', 'Please allow access to your Webcam.');
INSERT INTO `site_lang` VALUES ('210', '35', 'You are already in a videocall, you have to end the other call before start another');
INSERT INTO `site_lang` VALUES ('211', '35', 'Only premium users can make videocalls');
INSERT INTO `site_lang` VALUES ('212', '35', 'Impossible to make a call!');
INSERT INTO `site_lang` VALUES ('213', '35', 'You cant make videocall because you dont have webcam');
INSERT INTO `site_lang` VALUES ('214', '35', 'Too long wait');
INSERT INTO `site_lang` VALUES ('215', '35', 'Seems that your friend do not have webcam or he is not available');
INSERT INTO `site_lang` VALUES ('216', '35', 'End call');
INSERT INTO `site_lang` VALUES ('217', '35', 'Wait more');
INSERT INTO `site_lang` VALUES ('218', '35', 'until');
INSERT INTO `site_lang` VALUES ('219', '35', 'Basic');
INSERT INTO `site_lang` VALUES ('220', '35', 'UPGRADE');
INSERT INTO `site_lang` VALUES ('221', '35', 'Notifications');
INSERT INTO `site_lang` VALUES ('222', '35', 'Extended info (optional)');
INSERT INTO `site_lang` VALUES ('223', '35', 'Relationship');
INSERT INTO `site_lang` VALUES ('224', '35', 'Single');
INSERT INTO `site_lang` VALUES ('225', '35', 'Taken');
INSERT INTO `site_lang` VALUES ('226', '35', 'Open');
INSERT INTO `site_lang` VALUES ('227', '35', 'Sexuality');
INSERT INTO `site_lang` VALUES ('228', '35', 'Gay');
INSERT INTO `site_lang` VALUES ('229', '35', 'Open-minded');
INSERT INTO `site_lang` VALUES ('230', '35', 'Straight');
INSERT INTO `site_lang` VALUES ('231', '35', 'Bisexual');
INSERT INTO `site_lang` VALUES ('232', '35', 'Height');
INSERT INTO `site_lang` VALUES ('233', '35', 'less than');
INSERT INTO `site_lang` VALUES ('234', '35', 'more than');
INSERT INTO `site_lang` VALUES ('235', '35', 'Weight');
INSERT INTO `site_lang` VALUES ('236', '35', 'Ethnicity');
INSERT INTO `site_lang` VALUES ('237', '35', 'Asian');
INSERT INTO `site_lang` VALUES ('238', '35', 'Middle Eastern');
INSERT INTO `site_lang` VALUES ('239', '35', 'Black');
INSERT INTO `site_lang` VALUES ('240', '35', 'White');
INSERT INTO `site_lang` VALUES ('241', '35', 'Native American');
INSERT INTO `site_lang` VALUES ('242', '35', 'Hispanic/latin');
INSERT INTO `site_lang` VALUES ('243', '35', 'Pacific Islander');
INSERT INTO `site_lang` VALUES ('244', '35', 'Indian');
INSERT INTO `site_lang` VALUES ('245', '35', 'Other');
INSERT INTO `site_lang` VALUES ('246', '35', 'Body type');
INSERT INTO `site_lang` VALUES ('247', '35', 'Slim');
INSERT INTO `site_lang` VALUES ('248', '35', 'Average');
INSERT INTO `site_lang` VALUES ('249', '35', 'Athletic');
INSERT INTO `site_lang` VALUES ('250', '35', 'Heavy set');
INSERT INTO `site_lang` VALUES ('251', '35', 'Curvy');
INSERT INTO `site_lang` VALUES ('252', '35', 'Living');
INSERT INTO `site_lang` VALUES ('253', '35', 'With parents');
INSERT INTO `site_lang` VALUES ('254', '35', 'With housemate');
INSERT INTO `site_lang` VALUES ('255', '35', 'Student dormitory');
INSERT INTO `site_lang` VALUES ('256', '35', 'With partner');
INSERT INTO `site_lang` VALUES ('257', '35', 'Alone');
INSERT INTO `site_lang` VALUES ('258', '35', 'Smoke');
INSERT INTO `site_lang` VALUES ('259', '35', 'Yes');
INSERT INTO `site_lang` VALUES ('260', '35', 'No');
INSERT INTO `site_lang` VALUES ('261', '35', 'Sometimes');
INSERT INTO `site_lang` VALUES ('262', '35', 'Drink');
INSERT INTO `site_lang` VALUES ('263', '35', 'Transport');
INSERT INTO `site_lang` VALUES ('264', '35', 'Parents car');
INSERT INTO `site_lang` VALUES ('265', '35', 'I own a car');
INSERT INTO `site_lang` VALUES ('266', '35', 'I own a motorbike');
INSERT INTO `site_lang` VALUES ('267', '35', 'None');
INSERT INTO `site_lang` VALUES ('268', '35', 'When someone likes me');
INSERT INTO `site_lang` VALUES ('269', '35', 'When i get a match');
INSERT INTO `site_lang` VALUES ('270', '35', 'When new users near me join in');
INSERT INTO `site_lang` VALUES ('271', '35', 'When someone send me a message');
INSERT INTO `site_lang` VALUES ('272', '35', 'Day');
INSERT INTO `site_lang` VALUES ('273', '35', 'Month');
INSERT INTO `site_lang` VALUES ('274', '35', 'Year');
INSERT INTO `site_lang` VALUES ('275', '35', 'Please wait');
INSERT INTO `site_lang` VALUES ('276', '35', 'Interests');
INSERT INTO `site_lang` VALUES ('277', '35', 'Report');
INSERT INTO `site_lang` VALUES ('278', '35', 'Fans');
INSERT INTO `site_lang` VALUES ('279', '35', 'No data');
INSERT INTO `site_lang` VALUES ('280', '35', 'Public Photos');
INSERT INTO `site_lang` VALUES ('281', '35', 'Private photos');
INSERT INTO `site_lang` VALUES ('282', '35', 'Add from ');
INSERT INTO `site_lang` VALUES ('283', '35', 'Add');
INSERT INTO `site_lang` VALUES ('284', '35', 'Photos');
INSERT INTO `site_lang` VALUES ('285', '35', 'Credits');
INSERT INTO `site_lang` VALUES ('286', '35', 'Visits');
INSERT INTO `site_lang` VALUES ('287', '35', 'Add me here');
INSERT INTO `site_lang` VALUES ('288', '35', 'get seen by millions');
INSERT INTO `site_lang` VALUES ('289', '35', 'Set as profile');
INSERT INTO `site_lang` VALUES ('290', '35', 'Private photo');
INSERT INTO `site_lang` VALUES ('291', '35', 'Public photo');
INSERT INTO `site_lang` VALUES ('292', '35', 'Delete');
INSERT INTO `site_lang` VALUES ('293', '35', 'people visited your profile for see them');
INSERT INTO `site_lang` VALUES ('294', '35', 'Upgrade your account to premium');
INSERT INTO `site_lang` VALUES ('295', '35', 'People i like');
INSERT INTO `site_lang` VALUES ('296', '35', 'people liked you, for see them');
INSERT INTO `site_lang` VALUES ('297', '35', 'Messages');
INSERT INTO `site_lang` VALUES ('298', '35', 'Like');
INSERT INTO `site_lang` VALUES ('299', '35', 'Dislike');
INSERT INTO `site_lang` VALUES ('300', '35', 'AGE');
INSERT INTO `site_lang` VALUES ('301', '35', 'You dont have any visit yet');
INSERT INTO `site_lang` VALUES ('302', '35', 'visited');
INSERT INTO `site_lang` VALUES ('303', '35', 'You do not like anyone');
INSERT INTO `site_lang` VALUES ('304', '35', 'Cost');
INSERT INTO `site_lang` VALUES ('305', '35', 'Credits for $');
INSERT INTO `site_lang` VALUES ('306', '35', '0 seconds');
INSERT INTO `site_lang` VALUES ('307', '35', 'year');
INSERT INTO `site_lang` VALUES ('308', '35', 'month');
INSERT INTO `site_lang` VALUES ('309', '35', 'day');
INSERT INTO `site_lang` VALUES ('310', '35', 'hour');
INSERT INTO `site_lang` VALUES ('311', '35', 'minute');
INSERT INTO `site_lang` VALUES ('312', '35', 'second');
INSERT INTO `site_lang` VALUES ('313', '35', 'years');
INSERT INTO `site_lang` VALUES ('314', '35', 'months');
INSERT INTO `site_lang` VALUES ('315', '35', 'days');
INSERT INTO `site_lang` VALUES ('316', '35', 'hours');
INSERT INTO `site_lang` VALUES ('317', '35', 'minutes');
INSERT INTO `site_lang` VALUES ('318', '35', 'seconds');
INSERT INTO `site_lang` VALUES ('319', '35', 'ago');
INSERT INTO `site_lang` VALUES ('320', '35', 'Please verify your account, check your email');
INSERT INTO `site_lang` VALUES ('321', '35', 'Please add a profile photo');
INSERT INTO `site_lang` VALUES ('322', '35', 'Hi, im');
INSERT INTO `site_lang` VALUES ('323', '35', 'years old and im from');
INSERT INTO `site_lang` VALUES ('324', '35', 'We sended you a email for verify your account');
INSERT INTO `site_lang` VALUES ('325', '35', 'is blocking you or you blocked him, you cant chat with him sorry');
INSERT INTO `site_lang` VALUES ('326', '35', 'Report and block');
INSERT INTO `site_lang` VALUES ('327', '35', 'Are you sure you want to report');
INSERT INTO `site_lang` VALUES ('328', '35', 'Press backspace key for smart return to the meeting section.');
INSERT INTO `site_lang` VALUES ('329', '35', 'Write your instagram username');
INSERT INTO `site_lang` VALUES ('330', '35', 'You need to write your username!');
INSERT INTO `site_lang` VALUES ('331', '35', 'username');
INSERT INTO `site_lang` VALUES ('332', '35', 'days of Premium');
INSERT INTO `site_lang` VALUES ('333', '35', 'Wrong');
INSERT INTO `site_lang` VALUES ('334', '35', 'Spotlight');
INSERT INTO `site_lang` VALUES ('335', '35', 'Service cost');
INSERT INTO `site_lang` VALUES ('336', '35', 'Password successfully changed');
INSERT INTO `site_lang` VALUES ('337', '35', 'is calling you..');
INSERT INTO `site_lang` VALUES ('338', '35', 'Photos of ');
INSERT INTO `site_lang` VALUES ('339', '35', 'of');
INSERT INTO `site_lang` VALUES ('340', '35', 'Loading...');
INSERT INTO `site_lang` VALUES ('341', '35', 'We sent you a email with your info, it may take up to 1 min to arrive');
INSERT INTO `site_lang` VALUES ('342', '35', 'likes you and wants to chat in');
INSERT INTO `site_lang` VALUES ('343', '35', 'has seen you in discover and likes. The feeling is mutual?');
INSERT INTO `site_lang` VALUES ('344', '35', 'Find out if you also like');
INSERT INTO `site_lang` VALUES ('345', '35', 'You received this notice because you registered as');
INSERT INTO `site_lang` VALUES ('346', '35', 'Unsubscribe');
INSERT INTO `site_lang` VALUES ('347', '35', 'Choose a new password');
INSERT INTO `site_lang` VALUES ('348', '35', 'if you forgot your password, click on the link below to get a new');
INSERT INTO `site_lang` VALUES ('349', '35', 'You have a match at');
INSERT INTO `site_lang` VALUES ('350', '35', 'Its a match!');
INSERT INTO `site_lang` VALUES ('351', '35', 'thinks the feeling is mutual');
INSERT INTO `site_lang` VALUES ('352', '35', 'Go and say something to');
INSERT INTO `site_lang` VALUES ('353', '35', 'New message from');
INSERT INTO `site_lang` VALUES ('354', '35', 'you have a new message from');
INSERT INTO `site_lang` VALUES ('355', '35', 'Respond to');
INSERT INTO `site_lang` VALUES ('356', '35', 'Have fun!');
INSERT INTO `site_lang` VALUES ('357', '35', 'is new and lives closer to you');
INSERT INTO `site_lang` VALUES ('358', '35', 'is new at');
INSERT INTO `site_lang` VALUES ('359', '35', 'and lives closer to you');
INSERT INTO `site_lang` VALUES ('360', '35', 'Check out the profile');
INSERT INTO `site_lang` VALUES ('361', '35', 'Welcome');
INSERT INTO `site_lang` VALUES ('362', '35', 'Well done, now you are in');
INSERT INTO `site_lang` VALUES ('363', '35', 'Here are a few tips');
INSERT INTO `site_lang` VALUES ('364', '35', 'Now you are a new member of');
INSERT INTO `site_lang` VALUES ('365', '35', 'Verify your account');
INSERT INTO `site_lang` VALUES ('366', '35', 'Newsflash');
INSERT INTO `site_lang` VALUES ('367', '35', 'people in your area wants to know you');
INSERT INTO `site_lang` VALUES ('368', '35', 'In');
INSERT INTO `site_lang` VALUES ('369', '35', 'you can meet people instantly');
INSERT INTO `site_lang` VALUES ('370', '35', 'Meet new people');
INSERT INTO `site_lang` VALUES ('371', '35', 'Nobody is going to fall in love with a blank page. The more information you get, the more chances to find that special someone!');
INSERT INTO `site_lang` VALUES ('372', '35', 'Add photos and complete your profile');
INSERT INTO `site_lang` VALUES ('373', '35', 'More than 1 million people have joined $site_name You probably want to know some of them.');
INSERT INTO `site_lang` VALUES ('374', '35', 'Start meeting new people now');
INSERT INTO `site_lang` VALUES ('375', '35', 'Here are your connection details');
INSERT INTO `site_lang` VALUES ('376', '35', 'E-mail');
INSERT INTO `site_lang` VALUES ('377', '35', 'Password');
INSERT INTO `site_lang` VALUES ('378', '35', 'Please save your connection information in a safe place');
INSERT INTO `site_lang` VALUES ('379', '35', 'Go to');
INSERT INTO `site_lang` VALUES ('380', '35', 'Welcome to');
INSERT INTO `site_lang` VALUES ('381', '35', 'calling...');
INSERT INTO `site_lang` VALUES ('382', '35', 'dont like you');
INSERT INTO `site_lang` VALUES ('383', '35', 'must like you for start a videocall');
INSERT INTO `site_lang` VALUES ('384', '35', 'Ok, i understand');
INSERT INTO `site_lang` VALUES ('0', '36', 'meet new people!');
INSERT INTO `site_lang` VALUES ('1', '36', 'Login');
INSERT INTO `site_lang` VALUES ('2', '36', 'Welcome to the fastest growing place to meet new people');
INSERT INTO `site_lang` VALUES ('3', '36', 'For now our site works only for Desktop users');
INSERT INTO `site_lang` VALUES ('4', '36', 'Please visit us from your laptop or PC');
INSERT INTO `site_lang` VALUES ('5', '36', 'Soon we will have our phone apps online');
INSERT INTO `site_lang` VALUES ('6', '36', 'SOON AVAILABLE');
INSERT INTO `site_lang` VALUES ('7', '36', 'Connect with ');
INSERT INTO `site_lang` VALUES ('8', '36', 'Create your account');
INSERT INTO `site_lang` VALUES ('9', '36', 'Welcome back');
INSERT INTO `site_lang` VALUES ('10', '36', 'Your email');
INSERT INTO `site_lang` VALUES ('11', '36', 'Your password');
INSERT INTO `site_lang` VALUES ('12', '36', 'do you forget your password?');
INSERT INTO `site_lang` VALUES ('13', '36', 'Login now');
INSERT INTO `site_lang` VALUES ('14', '36', 'Password recover');
INSERT INTO `site_lang` VALUES ('15', '36', 'Recover password');
INSERT INTO `site_lang` VALUES ('16', '36', 'Chat');
INSERT INTO `site_lang` VALUES ('17', '36', 'Powerfull private chat for meet new friends, you can send emoticons and private photos to anyone.');
INSERT INTO `site_lang` VALUES ('18', '36', 'Video Chat');
INSERT INTO `site_lang` VALUES ('19', '36', 'You can make quality videocalls for free to anyone, without limits of call duration, just enjoy seeing the person who is chatting with you');
INSERT INTO `site_lang` VALUES ('20', '36', 'People nearby');
INSERT INTO `site_lang` VALUES ('21', '36', 'We wont show your exact location, but you will be able to find people nearby who like the same things you do.');
INSERT INTO `site_lang` VALUES ('22', '36', 'Matches');
INSERT INTO `site_lang` VALUES ('23', '36', 'Play our popular Discover game and get matched with other users. Its a great way to break the ice and chat to new people.');
INSERT INTO `site_lang` VALUES ('24', '36', 'Become a member now');
INSERT INTO `site_lang` VALUES ('25', '36', 'Join the worlds bestest community for meeting new people!.');
INSERT INTO `site_lang` VALUES ('26', '36', 'Name');
INSERT INTO `site_lang` VALUES ('27', '36', 'Your name or nickname');
INSERT INTO `site_lang` VALUES ('28', '36', 'Email');
INSERT INTO `site_lang` VALUES ('29', '36', 'Password');
INSERT INTO `site_lang` VALUES ('30', '36', 'Birthday');
INSERT INTO `site_lang` VALUES ('31', '36', 'Please select');
INSERT INTO `site_lang` VALUES ('32', '36', 'City');
INSERT INTO `site_lang` VALUES ('33', '36', 'Where do you live?');
INSERT INTO `site_lang` VALUES ('34', '36', 'Gender');
INSERT INTO `site_lang` VALUES ('35', '36', 'Male');
INSERT INTO `site_lang` VALUES ('36', '36', 'Female');
INSERT INTO `site_lang` VALUES ('37', '36', 'Im here to');
INSERT INTO `site_lang` VALUES ('38', '36', 'Meet girls');
INSERT INTO `site_lang` VALUES ('39', '36', 'Meet boys');
INSERT INTO `site_lang` VALUES ('40', '36', 'Meet boys and girls');
INSERT INTO `site_lang` VALUES ('41', '36', 'Sign up');
INSERT INTO `site_lang` VALUES ('42', '36', 'By continuing, you are confirming that you have read and agree to our');
INSERT INTO `site_lang` VALUES ('43', '36', 'Terms and Conditions');
INSERT INTO `site_lang` VALUES ('44', '36', 'and');
INSERT INTO `site_lang` VALUES ('45', '36', 'Privacy Policy');
INSERT INTO `site_lang` VALUES ('46', '36', 'Profile');
INSERT INTO `site_lang` VALUES ('47', '36', 'Settings');
INSERT INTO `site_lang` VALUES ('48', '36', 'Logout');
INSERT INTO `site_lang` VALUES ('49', '36', 'Meet new people');
INSERT INTO `site_lang` VALUES ('50', '36', 'Discover');
INSERT INTO `site_lang` VALUES ('51', '36', 'Matches');
INSERT INTO `site_lang` VALUES ('52', '36', 'Most populars');
INSERT INTO `site_lang` VALUES ('53', '36', 'Fans');
INSERT INTO `site_lang` VALUES ('54', '36', 'Manage photos');
INSERT INTO `site_lang` VALUES ('55', '36', 'Settings');
INSERT INTO `site_lang` VALUES ('56', '36', 'All');
INSERT INTO `site_lang` VALUES ('57', '36', 'Fans');
INSERT INTO `site_lang` VALUES ('58', '36', 'Conversations');
INSERT INTO `site_lang` VALUES ('59', '36', 'Online now');
INSERT INTO `site_lang` VALUES ('60', '36', 'New messages');
INSERT INTO `site_lang` VALUES ('61', '36', 'Who to like');
INSERT INTO `site_lang` VALUES ('62', '36', 'Terms');
INSERT INTO `site_lang` VALUES ('63', '36', 'Privacy');
INSERT INTO `site_lang` VALUES ('64', '36', 'Contact');
INSERT INTO `site_lang` VALUES ('65', '36', 'Manage your photos');
INSERT INTO `site_lang` VALUES ('66', '36', 'All Photos');
INSERT INTO `site_lang` VALUES ('67', '36', 'Public Photos');
INSERT INTO `site_lang` VALUES ('68', '36', 'Private Photos');
INSERT INTO `site_lang` VALUES ('69', '36', 'Add your photos');
INSERT INTO `site_lang` VALUES ('70', '36', 'add photos');
INSERT INTO `site_lang` VALUES ('71', '36', 'Add yourself to the Spotlight');
INSERT INTO `site_lang` VALUES ('72', '36', 'Pick the photo you want to show in the Spotlight, cost ');
INSERT INTO `site_lang` VALUES ('73', '36', 'Credits');
INSERT INTO `site_lang` VALUES ('74', '36', 'Add photo');
INSERT INTO `site_lang` VALUES ('75', '36', 'Send gift to ');
INSERT INTO `site_lang` VALUES ('76', '36', 'Pick the gift you want to send to ');
INSERT INTO `site_lang` VALUES ('77', '36', 'Send gift');
INSERT INTO `site_lang` VALUES ('78', '36', 'Buy credits / Upgrade account');
INSERT INTO `site_lang` VALUES ('79', '36', 'Select credits package');
INSERT INTO `site_lang` VALUES ('80', '36', 'Select payment method');
INSERT INTO `site_lang` VALUES ('81', '36', 'Pay with');
INSERT INTO `site_lang` VALUES ('82', '36', 'Pay with');
INSERT INTO `site_lang` VALUES ('83', '36', 'Buy credits');
INSERT INTO `site_lang` VALUES ('84', '36', 'Premium Account Features');
INSERT INTO `site_lang` VALUES ('85', '36', 'new chats per day');
INSERT INTO `site_lang` VALUES ('86', '36', 'Unlimited videocalls');
INSERT INTO `site_lang` VALUES ('87', '36', 'Unblock all private photos');
INSERT INTO `site_lang` VALUES ('88', '36', 'Premium user badge');
INSERT INTO `site_lang` VALUES ('89', '36', 'Write text here');
INSERT INTO `site_lang` VALUES ('90', '36', 'Send');
INSERT INTO `site_lang` VALUES ('91', '36', 'Chat');
INSERT INTO `site_lang` VALUES ('92', '36', 'you have reached the limit of new daily conversations');
INSERT INTO `site_lang` VALUES ('93', '36', 'To continue chatting');
INSERT INTO `site_lang` VALUES ('94', '36', 'Buy');
INSERT INTO `site_lang` VALUES ('95', '36', 'more daily conversation');
INSERT INTO `site_lang` VALUES ('96', '36', 'or');
INSERT INTO `site_lang` VALUES ('97', '36', 'Upgrade your account to Premium');
INSERT INTO `site_lang` VALUES ('98', '36', 'and get up to');
INSERT INTO `site_lang` VALUES ('99', '36', 'daily conversations');
INSERT INTO `site_lang` VALUES ('100', '36', 'or wait until tomorrow for continue meeting people');
INSERT INTO `site_lang` VALUES ('101', '36', 'Your fans');
INSERT INTO `site_lang` VALUES ('102', '36', 'Privacy Policy');
INSERT INTO `site_lang` VALUES ('103', '36', 'Terms of Use');
INSERT INTO `site_lang` VALUES ('104', '36', 'Please complete your profile before start in ');
INSERT INTO `site_lang` VALUES ('105', '36', 'Your matches');
INSERT INTO `site_lang` VALUES ('106', '36', 'Filter Search');
INSERT INTO `site_lang` VALUES ('107', '36', 'All users');
INSERT INTO `site_lang` VALUES ('108', '36', 'Online now');
INSERT INTO `site_lang` VALUES ('109', '36', 'Show me');
INSERT INTO `site_lang` VALUES ('110', '36', 'Girls');
INSERT INTO `site_lang` VALUES ('111', '36', 'Boys');
INSERT INTO `site_lang` VALUES ('112', '36', 'Both');
INSERT INTO `site_lang` VALUES ('113', '36', 'who are between');
INSERT INTO `site_lang` VALUES ('114', '36', 'in a radius of');
INSERT INTO `site_lang` VALUES ('115', '36', 'World');
INSERT INTO `site_lang` VALUES ('116', '36', 'Most popular users');
INSERT INTO `site_lang` VALUES ('117', '36', 'About ');
INSERT INTO `site_lang` VALUES ('118', '36', 'Personal info');
INSERT INTO `site_lang` VALUES ('119', '36', 'years old');
INSERT INTO `site_lang` VALUES ('120', '36', 'Only boys');
INSERT INTO `site_lang` VALUES ('121', '36', 'Only girls');
INSERT INTO `site_lang` VALUES ('122', '36', 'boys and girls');
INSERT INTO `site_lang` VALUES ('123', '36', 'Credits successfully added to your account');
INSERT INTO `site_lang` VALUES ('124', '36', 'Now you have');
INSERT INTO `site_lang` VALUES ('125', '36', 'Ask permission to');
INSERT INTO `site_lang` VALUES ('126', '36', 'Unblock private photos');
INSERT INTO `site_lang` VALUES ('127', '36', 'Personal');
INSERT INTO `site_lang` VALUES ('128', '36', 'Credits');
INSERT INTO `site_lang` VALUES ('129', '36', 'Verify');
INSERT INTO `site_lang` VALUES ('130', '36', 'Change password');
INSERT INTO `site_lang` VALUES ('131', '36', 'Delete');
INSERT INTO `site_lang` VALUES ('132', '36', 'Personal information');
INSERT INTO `site_lang` VALUES ('133', '36', 'You can edit your profile information bellow');
INSERT INTO `site_lang` VALUES ('134', '36', 'Site language');
INSERT INTO `site_lang` VALUES ('135', '36', 'Update profile');
INSERT INTO `site_lang` VALUES ('136', '36', 'Verify account');
INSERT INTO `site_lang` VALUES ('137', '36', 'For verify your account , connect with your facebook account');
INSERT INTO `site_lang` VALUES ('138', '36', 'Connect with Facebook');
INSERT INTO `site_lang` VALUES ('139', '36', 'You are account is already verified');
INSERT INTO `site_lang` VALUES ('140', '36', 'Buy credits for send Gifs and Unblock private photos');
INSERT INTO `site_lang` VALUES ('141', '36', 'Account type');
INSERT INTO `site_lang` VALUES ('142', '36', 'Current credits');
INSERT INTO `site_lang` VALUES ('143', '36', 'Add credits');
INSERT INTO `site_lang` VALUES ('144', '36', 'Upgrade to premium account');
INSERT INTO `site_lang` VALUES ('145', '36', 'Change password');
INSERT INTO `site_lang` VALUES ('146', '36', 'You can change your current password bellow');
INSERT INTO `site_lang` VALUES ('147', '36', 'New password');
INSERT INTO `site_lang` VALUES ('148', '36', 'Profile desactivation');
INSERT INTO `site_lang` VALUES ('149', '36', 'After delete your profile, some of your data will be lost without recovery.');
INSERT INTO `site_lang` VALUES ('150', '36', 'Delete profile');
INSERT INTO `site_lang` VALUES ('151', '36', 'Online now');
INSERT INTO `site_lang` VALUES ('152', '36', 'Verified');
INSERT INTO `site_lang` VALUES ('153', '36', 'Nothing found');
INSERT INTO `site_lang` VALUES ('154', '36', 'people found');
INSERT INTO `site_lang` VALUES ('155', '36', 'No popular users near you');
INSERT INTO `site_lang` VALUES ('156', '36', 'You dont have any fans yet');
INSERT INTO `site_lang` VALUES ('157', '36', 'You dont have matches yet');
INSERT INTO `site_lang` VALUES ('158', '36', 'January');
INSERT INTO `site_lang` VALUES ('159', '36', 'February');
INSERT INTO `site_lang` VALUES ('160', '36', 'March');
INSERT INTO `site_lang` VALUES ('161', '36', 'April');
INSERT INTO `site_lang` VALUES ('162', '36', 'May');
INSERT INTO `site_lang` VALUES ('163', '36', 'June');
INSERT INTO `site_lang` VALUES ('164', '36', 'July');
INSERT INTO `site_lang` VALUES ('165', '36', 'August');
INSERT INTO `site_lang` VALUES ('166', '36', 'September');
INSERT INTO `site_lang` VALUES ('167', '36', 'October');
INSERT INTO `site_lang` VALUES ('168', '36', 'November');
INSERT INTO `site_lang` VALUES ('169', '36', 'December');
INSERT INTO `site_lang` VALUES ('170', '36', 'Buy');
INSERT INTO `site_lang` VALUES ('171', '36', 'Days Premium');
INSERT INTO `site_lang` VALUES ('172', '36', 'persons more like this');
INSERT INTO `site_lang` VALUES ('173', '36', 'like this');
INSERT INTO `site_lang` VALUES ('174', '36', 'Hello, can i have access to your private photos ?');
INSERT INTO `site_lang` VALUES ('175', '36', 'Yes');
INSERT INTO `site_lang` VALUES ('176', '36', 'No');
INSERT INTO `site_lang` VALUES ('177', '36', 'Hi');
INSERT INTO `site_lang` VALUES ('178', '36', 'If you dont remember your password, click the link below to set a new one:');
INSERT INTO `site_lang` VALUES ('179', '36', 'Login to my account');
INSERT INTO `site_lang` VALUES ('180', '36', 'Password recover');
INSERT INTO `site_lang` VALUES ('181', '36', 'Invalid email format');
INSERT INTO `site_lang` VALUES ('182', '36', 'Please fill all the inputs');
INSERT INTO `site_lang` VALUES ('183', '36', 'Email dont exist');
INSERT INTO `site_lang` VALUES ('184', '36', 'Wrong password');
INSERT INTO `site_lang` VALUES ('185', '36', 'Add a valid date');
INSERT INTO `site_lang` VALUES ('186', '36', 'Choose city from the autocomplete');
INSERT INTO `site_lang` VALUES ('187', '36', 'Password too short');
INSERT INTO `site_lang` VALUES ('188', '36', 'Email already exist, try another');
INSERT INTO `site_lang` VALUES ('189', '36', 'Yes, you can see my private photos');
INSERT INTO `site_lang` VALUES ('190', '36', 'No, i cant show you my private photos');
INSERT INTO `site_lang` VALUES ('191', '36', 'Buy private photos permission');
INSERT INTO `site_lang` VALUES ('192', '36', 'Get access to');
INSERT INTO `site_lang` VALUES ('193', '36', 'private photos for ');
INSERT INTO `site_lang` VALUES ('194', '36', 'Get access');
INSERT INTO `site_lang` VALUES ('195', '36', 'No thanks');
INSERT INTO `site_lang` VALUES ('196', '36', 'Please, select a payment method');
INSERT INTO `site_lang` VALUES ('197', '36', 'Please, select 1 photo');
INSERT INTO `site_lang` VALUES ('198', '36', 'Please, select 1 gift');
INSERT INTO `site_lang` VALUES ('199', '36', 'You dont have enought credits for send the gift');
INSERT INTO `site_lang` VALUES ('200', '36', 'Expand daily limitation ');
INSERT INTO `site_lang` VALUES ('201', '36', 'more daily conversation, cost ');
INSERT INTO `site_lang` VALUES ('202', '36', 'Yes, buy it!');
INSERT INTO `site_lang` VALUES ('203', '36', 'Information updated successfully');
INSERT INTO `site_lang` VALUES ('204', '36', 'Account termination');
INSERT INTO `site_lang` VALUES ('205', '36', 'Your data will be lost without recovery, continue?');
INSERT INTO `site_lang` VALUES ('206', '36', 'Yes, delete it!');
INSERT INTO `site_lang` VALUES ('207', '36', 'is in another videocall , you cant call now');
INSERT INTO `site_lang` VALUES ('208', '36', 'is offline, try again when your friend is online');
INSERT INTO `site_lang` VALUES ('209', '36', 'Please allow access to your Webcam.');
INSERT INTO `site_lang` VALUES ('210', '36', 'You are already in a videocall, you have to end the other call before start another');
INSERT INTO `site_lang` VALUES ('211', '36', 'Only premium users can make videocalls');
INSERT INTO `site_lang` VALUES ('212', '36', 'Impossible to make a call!');
INSERT INTO `site_lang` VALUES ('213', '36', 'You cant make videocall because you dont have webcam');
INSERT INTO `site_lang` VALUES ('214', '36', 'Too long wait');
INSERT INTO `site_lang` VALUES ('215', '36', 'Seems that your friend do not have webcam or he is not available');
INSERT INTO `site_lang` VALUES ('216', '36', 'End call');
INSERT INTO `site_lang` VALUES ('217', '36', 'Wait more');
INSERT INTO `site_lang` VALUES ('218', '36', 'until');
INSERT INTO `site_lang` VALUES ('219', '36', 'Basic');
INSERT INTO `site_lang` VALUES ('220', '36', 'UPGRADE');
INSERT INTO `site_lang` VALUES ('221', '36', 'Notifications');
INSERT INTO `site_lang` VALUES ('222', '36', 'Extended info (optional)');
INSERT INTO `site_lang` VALUES ('223', '36', 'Relationship');
INSERT INTO `site_lang` VALUES ('224', '36', 'Single');
INSERT INTO `site_lang` VALUES ('225', '36', 'Taken');
INSERT INTO `site_lang` VALUES ('226', '36', 'Open');
INSERT INTO `site_lang` VALUES ('227', '36', 'Sexuality');
INSERT INTO `site_lang` VALUES ('228', '36', 'Gay');
INSERT INTO `site_lang` VALUES ('229', '36', 'Open-minded');
INSERT INTO `site_lang` VALUES ('230', '36', 'Straight');
INSERT INTO `site_lang` VALUES ('231', '36', 'Bisexual');
INSERT INTO `site_lang` VALUES ('232', '36', 'Height');
INSERT INTO `site_lang` VALUES ('233', '36', 'less than');
INSERT INTO `site_lang` VALUES ('234', '36', 'more than');
INSERT INTO `site_lang` VALUES ('235', '36', 'Weight');
INSERT INTO `site_lang` VALUES ('236', '36', 'Ethnicity');
INSERT INTO `site_lang` VALUES ('237', '36', 'Asian');
INSERT INTO `site_lang` VALUES ('238', '36', 'Middle Eastern');
INSERT INTO `site_lang` VALUES ('239', '36', 'Black');
INSERT INTO `site_lang` VALUES ('240', '36', 'White');
INSERT INTO `site_lang` VALUES ('241', '36', 'Native American');
INSERT INTO `site_lang` VALUES ('242', '36', 'Hispanic/latin');
INSERT INTO `site_lang` VALUES ('243', '36', 'Pacific Islander');
INSERT INTO `site_lang` VALUES ('244', '36', 'Indian');
INSERT INTO `site_lang` VALUES ('245', '36', 'Other');
INSERT INTO `site_lang` VALUES ('246', '36', 'Body type');
INSERT INTO `site_lang` VALUES ('247', '36', 'Slim');
INSERT INTO `site_lang` VALUES ('248', '36', 'Average');
INSERT INTO `site_lang` VALUES ('249', '36', 'Athletic');
INSERT INTO `site_lang` VALUES ('250', '36', 'Heavy set');
INSERT INTO `site_lang` VALUES ('251', '36', 'Curvy');
INSERT INTO `site_lang` VALUES ('252', '36', 'Living');
INSERT INTO `site_lang` VALUES ('253', '36', 'With parents');
INSERT INTO `site_lang` VALUES ('254', '36', 'With housemate');
INSERT INTO `site_lang` VALUES ('255', '36', 'Student dormitory');
INSERT INTO `site_lang` VALUES ('256', '36', 'With partner');
INSERT INTO `site_lang` VALUES ('257', '36', 'Alone');
INSERT INTO `site_lang` VALUES ('258', '36', 'Smoke');
INSERT INTO `site_lang` VALUES ('259', '36', 'Yes');
INSERT INTO `site_lang` VALUES ('260', '36', 'No');
INSERT INTO `site_lang` VALUES ('261', '36', 'Sometimes');
INSERT INTO `site_lang` VALUES ('262', '36', 'Drink');
INSERT INTO `site_lang` VALUES ('263', '36', 'Transport');
INSERT INTO `site_lang` VALUES ('264', '36', 'Parents car');
INSERT INTO `site_lang` VALUES ('265', '36', 'I own a car');
INSERT INTO `site_lang` VALUES ('266', '36', 'I own a motorbike');
INSERT INTO `site_lang` VALUES ('267', '36', 'None');
INSERT INTO `site_lang` VALUES ('268', '36', 'When someone likes me');
INSERT INTO `site_lang` VALUES ('269', '36', 'When i get a match');
INSERT INTO `site_lang` VALUES ('270', '36', 'When new users near me join in');
INSERT INTO `site_lang` VALUES ('271', '36', 'When someone send me a message');
INSERT INTO `site_lang` VALUES ('272', '36', 'Day');
INSERT INTO `site_lang` VALUES ('273', '36', 'Month');
INSERT INTO `site_lang` VALUES ('274', '36', 'Year');
INSERT INTO `site_lang` VALUES ('275', '36', 'Please wait');
INSERT INTO `site_lang` VALUES ('276', '36', 'Interests');
INSERT INTO `site_lang` VALUES ('277', '36', 'Report');
INSERT INTO `site_lang` VALUES ('278', '36', 'Fans');
INSERT INTO `site_lang` VALUES ('279', '36', 'No data');
INSERT INTO `site_lang` VALUES ('280', '36', 'Public Photos');
INSERT INTO `site_lang` VALUES ('281', '36', 'Private photos');
INSERT INTO `site_lang` VALUES ('282', '36', 'Add from ');
INSERT INTO `site_lang` VALUES ('283', '36', 'Add');
INSERT INTO `site_lang` VALUES ('284', '36', 'Photos');
INSERT INTO `site_lang` VALUES ('285', '36', 'Credits');
INSERT INTO `site_lang` VALUES ('286', '36', 'Visits');
INSERT INTO `site_lang` VALUES ('287', '36', 'Add me here');
INSERT INTO `site_lang` VALUES ('288', '36', 'get seen by millions');
INSERT INTO `site_lang` VALUES ('289', '36', 'Set as profile');
INSERT INTO `site_lang` VALUES ('290', '36', 'Private photo');
INSERT INTO `site_lang` VALUES ('291', '36', 'Public photo');
INSERT INTO `site_lang` VALUES ('292', '36', 'Delete');
INSERT INTO `site_lang` VALUES ('293', '36', 'people visited your profile for see them');
INSERT INTO `site_lang` VALUES ('294', '36', 'Upgrade your account to premium');
INSERT INTO `site_lang` VALUES ('295', '36', 'People i like');
INSERT INTO `site_lang` VALUES ('296', '36', 'people liked you, for see them');
INSERT INTO `site_lang` VALUES ('297', '36', 'Messages');
INSERT INTO `site_lang` VALUES ('298', '36', 'Like');
INSERT INTO `site_lang` VALUES ('299', '36', 'Dislike');
INSERT INTO `site_lang` VALUES ('300', '36', 'AGE');
INSERT INTO `site_lang` VALUES ('301', '36', 'You dont have any visit yet');
INSERT INTO `site_lang` VALUES ('302', '36', 'visited');
INSERT INTO `site_lang` VALUES ('303', '36', 'You do not like anyone');
INSERT INTO `site_lang` VALUES ('304', '36', 'Cost');
INSERT INTO `site_lang` VALUES ('305', '36', 'Credits for $');
INSERT INTO `site_lang` VALUES ('306', '36', '0 seconds');
INSERT INTO `site_lang` VALUES ('307', '36', 'year');
INSERT INTO `site_lang` VALUES ('308', '36', 'month');
INSERT INTO `site_lang` VALUES ('309', '36', 'day');
INSERT INTO `site_lang` VALUES ('310', '36', 'hour');
INSERT INTO `site_lang` VALUES ('311', '36', 'minute');
INSERT INTO `site_lang` VALUES ('312', '36', 'second');
INSERT INTO `site_lang` VALUES ('313', '36', 'years');
INSERT INTO `site_lang` VALUES ('314', '36', 'months');
INSERT INTO `site_lang` VALUES ('315', '36', 'days');
INSERT INTO `site_lang` VALUES ('316', '36', 'hours');
INSERT INTO `site_lang` VALUES ('317', '36', 'minutes');
INSERT INTO `site_lang` VALUES ('318', '36', 'seconds');
INSERT INTO `site_lang` VALUES ('319', '36', 'ago');
INSERT INTO `site_lang` VALUES ('320', '36', 'Please verify your account, check your email');
INSERT INTO `site_lang` VALUES ('321', '36', 'Please add a profile photo');
INSERT INTO `site_lang` VALUES ('322', '36', 'Hi, im');
INSERT INTO `site_lang` VALUES ('323', '36', 'years old and im from');
INSERT INTO `site_lang` VALUES ('324', '36', 'We sended you a email for verify your account');
INSERT INTO `site_lang` VALUES ('325', '36', 'is blocking you or you blocked him, you cant chat with him sorry');
INSERT INTO `site_lang` VALUES ('326', '36', 'Report and block');
INSERT INTO `site_lang` VALUES ('327', '36', 'Are you sure you want to report');
INSERT INTO `site_lang` VALUES ('328', '36', 'Press backspace key for smart return to the meeting section.');
INSERT INTO `site_lang` VALUES ('329', '36', 'Write your instagram username');
INSERT INTO `site_lang` VALUES ('330', '36', 'You need to write your username!');
INSERT INTO `site_lang` VALUES ('331', '36', 'username');
INSERT INTO `site_lang` VALUES ('332', '36', 'days of Premium');
INSERT INTO `site_lang` VALUES ('333', '36', 'Wrong');
INSERT INTO `site_lang` VALUES ('334', '36', 'Spotlight');
INSERT INTO `site_lang` VALUES ('335', '36', 'Service cost');
INSERT INTO `site_lang` VALUES ('336', '36', 'Password successfully changed');
INSERT INTO `site_lang` VALUES ('337', '36', 'is calling you..');
INSERT INTO `site_lang` VALUES ('338', '36', 'Photos of ');
INSERT INTO `site_lang` VALUES ('339', '36', 'of');
INSERT INTO `site_lang` VALUES ('340', '36', 'Loading...');
INSERT INTO `site_lang` VALUES ('341', '36', 'We sent you a email with your info, it may take up to 1 min to arrive');
INSERT INTO `site_lang` VALUES ('342', '36', 'likes you and wants to chat in');
INSERT INTO `site_lang` VALUES ('343', '36', 'has seen you in discover and likes. The feeling is mutual?');
INSERT INTO `site_lang` VALUES ('344', '36', 'Find out if you also like');
INSERT INTO `site_lang` VALUES ('345', '36', 'You received this notice because you registered as');
INSERT INTO `site_lang` VALUES ('346', '36', 'Unsubscribe');
INSERT INTO `site_lang` VALUES ('347', '36', 'Choose a new password');
INSERT INTO `site_lang` VALUES ('348', '36', 'if you forgot your password, click on the link below to get a new');
INSERT INTO `site_lang` VALUES ('349', '36', 'You have a match at');
INSERT INTO `site_lang` VALUES ('350', '36', 'Its a match!');
INSERT INTO `site_lang` VALUES ('351', '36', 'thinks the feeling is mutual');
INSERT INTO `site_lang` VALUES ('352', '36', 'Go and say something to');
INSERT INTO `site_lang` VALUES ('353', '36', 'New message from');
INSERT INTO `site_lang` VALUES ('354', '36', 'you have a new message from');
INSERT INTO `site_lang` VALUES ('355', '36', 'Respond to');
INSERT INTO `site_lang` VALUES ('356', '36', 'Have fun!');
INSERT INTO `site_lang` VALUES ('357', '36', 'is new and lives closer to you');
INSERT INTO `site_lang` VALUES ('358', '36', 'is new at');
INSERT INTO `site_lang` VALUES ('359', '36', 'and lives closer to you');
INSERT INTO `site_lang` VALUES ('360', '36', 'Check out the profile');
INSERT INTO `site_lang` VALUES ('361', '36', 'Welcome');
INSERT INTO `site_lang` VALUES ('362', '36', 'Well done, now you are in');
INSERT INTO `site_lang` VALUES ('363', '36', 'Here are a few tips');
INSERT INTO `site_lang` VALUES ('364', '36', 'Now you are a new member of');
INSERT INTO `site_lang` VALUES ('365', '36', 'Verify your account');
INSERT INTO `site_lang` VALUES ('366', '36', 'Newsflash');
INSERT INTO `site_lang` VALUES ('367', '36', 'people in your area wants to know you');
INSERT INTO `site_lang` VALUES ('368', '36', 'In');
INSERT INTO `site_lang` VALUES ('369', '36', 'you can meet people instantly');
INSERT INTO `site_lang` VALUES ('370', '36', 'Meet new people');
INSERT INTO `site_lang` VALUES ('371', '36', 'Nobody is going to fall in love with a blank page. The more information you get, the more chances to find that special someone!');
INSERT INTO `site_lang` VALUES ('372', '36', 'Add photos and complete your profile');
INSERT INTO `site_lang` VALUES ('373', '36', 'More than 1 million people have joined $site_name You probably want to know some of them.');
INSERT INTO `site_lang` VALUES ('374', '36', 'Start meeting new people now');
INSERT INTO `site_lang` VALUES ('375', '36', 'Here are your connection details');
INSERT INTO `site_lang` VALUES ('376', '36', 'E-mail');
INSERT INTO `site_lang` VALUES ('377', '36', 'Password');
INSERT INTO `site_lang` VALUES ('378', '36', 'Please save your connection information in a safe place');
INSERT INTO `site_lang` VALUES ('379', '36', 'Go to');
INSERT INTO `site_lang` VALUES ('380', '36', 'Welcome to');
INSERT INTO `site_lang` VALUES ('381', '36', 'calling...');
INSERT INTO `site_lang` VALUES ('382', '36', 'dont like you');
INSERT INTO `site_lang` VALUES ('383', '36', 'must like you for start a videocall');
INSERT INTO `site_lang` VALUES ('384', '36', 'Ok, i understand');
INSERT INTO `site_lang` VALUES ('0', '38', 'meet new people!');
INSERT INTO `site_lang` VALUES ('1', '38', 'Login');
INSERT INTO `site_lang` VALUES ('2', '38', 'Welcome to the fastest growing place to meet new people');
INSERT INTO `site_lang` VALUES ('3', '38', 'For now our site works only for Desktop users');
INSERT INTO `site_lang` VALUES ('4', '38', 'Please visit us from your laptop or PC');
INSERT INTO `site_lang` VALUES ('5', '38', 'Soon we will have our phone apps online');
INSERT INTO `site_lang` VALUES ('6', '38', 'SOON AVAILABLE');
INSERT INTO `site_lang` VALUES ('7', '38', 'Connect with ');
INSERT INTO `site_lang` VALUES ('8', '38', 'Create your account');
INSERT INTO `site_lang` VALUES ('9', '38', 'Welcome back');
INSERT INTO `site_lang` VALUES ('10', '38', 'Your email');
INSERT INTO `site_lang` VALUES ('11', '38', 'Your password');
INSERT INTO `site_lang` VALUES ('12', '38', 'do you forget your password?');
INSERT INTO `site_lang` VALUES ('13', '38', 'Login now');
INSERT INTO `site_lang` VALUES ('14', '38', 'Password recover');
INSERT INTO `site_lang` VALUES ('15', '38', 'Recover password');
INSERT INTO `site_lang` VALUES ('16', '38', 'Chat');
INSERT INTO `site_lang` VALUES ('17', '38', 'Powerfull private chat for meet new friends, you can send emoticons and private photos to anyone.');
INSERT INTO `site_lang` VALUES ('18', '38', 'Video Chat');
INSERT INTO `site_lang` VALUES ('19', '38', 'You can make quality videocalls for free to anyone, without limits of call duration, just enjoy seeing the person who is chatting with you');
INSERT INTO `site_lang` VALUES ('20', '38', 'People nearby');
INSERT INTO `site_lang` VALUES ('21', '38', 'We wont show your exact location, but you will be able to find people nearby who like the same things you do.');
INSERT INTO `site_lang` VALUES ('22', '38', 'Matches');
INSERT INTO `site_lang` VALUES ('23', '38', 'Play our popular Discover game and get matched with other users. Its a great way to break the ice and chat to new people.');
INSERT INTO `site_lang` VALUES ('24', '38', 'Become a member now');
INSERT INTO `site_lang` VALUES ('25', '38', 'Join the worlds bestest community for meeting new people!.');
INSERT INTO `site_lang` VALUES ('26', '38', 'Name');
INSERT INTO `site_lang` VALUES ('27', '38', 'Your name or nickname');
INSERT INTO `site_lang` VALUES ('28', '38', 'Email');
INSERT INTO `site_lang` VALUES ('29', '38', 'Password');
INSERT INTO `site_lang` VALUES ('30', '38', 'Birthday');
INSERT INTO `site_lang` VALUES ('31', '38', 'Please select');
INSERT INTO `site_lang` VALUES ('32', '38', 'City');
INSERT INTO `site_lang` VALUES ('33', '38', 'Where do you live?');
INSERT INTO `site_lang` VALUES ('34', '38', 'Gender');
INSERT INTO `site_lang` VALUES ('35', '38', 'Male');
INSERT INTO `site_lang` VALUES ('36', '38', 'Female');
INSERT INTO `site_lang` VALUES ('37', '38', 'Im here to');
INSERT INTO `site_lang` VALUES ('38', '38', 'Meet girls');
INSERT INTO `site_lang` VALUES ('39', '38', 'Meet boys');
INSERT INTO `site_lang` VALUES ('40', '38', 'Meet boys and girls');
INSERT INTO `site_lang` VALUES ('41', '38', 'Sign up');
INSERT INTO `site_lang` VALUES ('42', '38', 'By continuing, you are confirming that you have read and agree to our');
INSERT INTO `site_lang` VALUES ('43', '38', 'Terms and Conditions');
INSERT INTO `site_lang` VALUES ('44', '38', 'and');
INSERT INTO `site_lang` VALUES ('45', '38', 'Privacy Policy');
INSERT INTO `site_lang` VALUES ('46', '38', 'Profile');
INSERT INTO `site_lang` VALUES ('47', '38', 'Settings');
INSERT INTO `site_lang` VALUES ('48', '38', 'Logout');
INSERT INTO `site_lang` VALUES ('49', '38', 'Meet new people');
INSERT INTO `site_lang` VALUES ('50', '38', 'Discover');
INSERT INTO `site_lang` VALUES ('51', '38', 'Matches');
INSERT INTO `site_lang` VALUES ('52', '38', 'Most populars');
INSERT INTO `site_lang` VALUES ('53', '38', 'Fans');
INSERT INTO `site_lang` VALUES ('54', '38', 'Manage photos');
INSERT INTO `site_lang` VALUES ('55', '38', 'Settings');
INSERT INTO `site_lang` VALUES ('56', '38', 'All');
INSERT INTO `site_lang` VALUES ('57', '38', 'Fans');
INSERT INTO `site_lang` VALUES ('58', '38', 'Conversations');
INSERT INTO `site_lang` VALUES ('59', '38', 'Online now');
INSERT INTO `site_lang` VALUES ('60', '38', 'New messages');
INSERT INTO `site_lang` VALUES ('61', '38', 'Who to like');
INSERT INTO `site_lang` VALUES ('62', '38', 'Terms');
INSERT INTO `site_lang` VALUES ('63', '38', 'Privacy');
INSERT INTO `site_lang` VALUES ('64', '38', 'Contact');
INSERT INTO `site_lang` VALUES ('65', '38', 'Manage your photos');
INSERT INTO `site_lang` VALUES ('66', '38', 'All Photos');
INSERT INTO `site_lang` VALUES ('67', '38', 'Public Photos');
INSERT INTO `site_lang` VALUES ('68', '38', 'Private Photos');
INSERT INTO `site_lang` VALUES ('69', '38', 'Add your photos');
INSERT INTO `site_lang` VALUES ('70', '38', 'add photos');
INSERT INTO `site_lang` VALUES ('71', '38', 'Add yourself to the Spotlight');
INSERT INTO `site_lang` VALUES ('72', '38', 'Pick the photo you want to show in the Spotlight, cost ');
INSERT INTO `site_lang` VALUES ('73', '38', 'Credits');
INSERT INTO `site_lang` VALUES ('74', '38', 'Add photo');
INSERT INTO `site_lang` VALUES ('75', '38', 'Send gift to ');
INSERT INTO `site_lang` VALUES ('76', '38', 'Pick the gift you want to send to ');
INSERT INTO `site_lang` VALUES ('77', '38', 'Send gift');
INSERT INTO `site_lang` VALUES ('78', '38', 'Buy credits / Upgrade account');
INSERT INTO `site_lang` VALUES ('79', '38', 'Select credits package');
INSERT INTO `site_lang` VALUES ('80', '38', 'Select payment method');
INSERT INTO `site_lang` VALUES ('81', '38', 'Pay with');
INSERT INTO `site_lang` VALUES ('82', '38', 'Pay with');
INSERT INTO `site_lang` VALUES ('83', '38', 'Buy credits');
INSERT INTO `site_lang` VALUES ('84', '38', 'Premium Account Features');
INSERT INTO `site_lang` VALUES ('85', '38', 'new chats per day');
INSERT INTO `site_lang` VALUES ('86', '38', 'Unlimited videocalls');
INSERT INTO `site_lang` VALUES ('87', '38', 'Unblock all private photos');
INSERT INTO `site_lang` VALUES ('88', '38', 'Premium user badge');
INSERT INTO `site_lang` VALUES ('89', '38', 'Write text here');
INSERT INTO `site_lang` VALUES ('90', '38', 'Send');
INSERT INTO `site_lang` VALUES ('91', '38', 'Chat');
INSERT INTO `site_lang` VALUES ('92', '38', 'you have reached the limit of new daily conversations');
INSERT INTO `site_lang` VALUES ('93', '38', 'To continue chatting');
INSERT INTO `site_lang` VALUES ('94', '38', 'Buy');
INSERT INTO `site_lang` VALUES ('95', '38', 'more daily conversation');
INSERT INTO `site_lang` VALUES ('96', '38', 'or');
INSERT INTO `site_lang` VALUES ('97', '38', 'Upgrade your account to Premium');
INSERT INTO `site_lang` VALUES ('98', '38', 'and get up to');
INSERT INTO `site_lang` VALUES ('99', '38', 'daily conversations');
INSERT INTO `site_lang` VALUES ('100', '38', 'or wait until tomorrow for continue meeting people');
INSERT INTO `site_lang` VALUES ('101', '38', 'Your fans');
INSERT INTO `site_lang` VALUES ('102', '38', 'Privacy Policy');
INSERT INTO `site_lang` VALUES ('103', '38', 'Terms of Use');
INSERT INTO `site_lang` VALUES ('104', '38', 'Please complete your profile before start in ');
INSERT INTO `site_lang` VALUES ('105', '38', 'Your matches');
INSERT INTO `site_lang` VALUES ('106', '38', 'Filter Search');
INSERT INTO `site_lang` VALUES ('107', '38', 'All users');
INSERT INTO `site_lang` VALUES ('108', '38', 'Online now');
INSERT INTO `site_lang` VALUES ('109', '38', 'Show me');
INSERT INTO `site_lang` VALUES ('110', '38', 'Girls');
INSERT INTO `site_lang` VALUES ('111', '38', 'Boys');
INSERT INTO `site_lang` VALUES ('112', '38', 'Both');
INSERT INTO `site_lang` VALUES ('113', '38', 'who are between');
INSERT INTO `site_lang` VALUES ('114', '38', 'in a radius of');
INSERT INTO `site_lang` VALUES ('115', '38', 'World');
INSERT INTO `site_lang` VALUES ('116', '38', 'Most popular users');
INSERT INTO `site_lang` VALUES ('117', '38', 'About ');
INSERT INTO `site_lang` VALUES ('118', '38', 'Personal info');
INSERT INTO `site_lang` VALUES ('119', '38', 'years old');
INSERT INTO `site_lang` VALUES ('120', '38', 'Only boys');
INSERT INTO `site_lang` VALUES ('121', '38', 'Only girls');
INSERT INTO `site_lang` VALUES ('122', '38', 'boys and girls');
INSERT INTO `site_lang` VALUES ('123', '38', 'Credits successfully added to your account');
INSERT INTO `site_lang` VALUES ('124', '38', 'Now you have');
INSERT INTO `site_lang` VALUES ('125', '38', 'Ask permission to');
INSERT INTO `site_lang` VALUES ('126', '38', 'Unblock private photos');
INSERT INTO `site_lang` VALUES ('127', '38', 'Personal');
INSERT INTO `site_lang` VALUES ('128', '38', 'Credits');
INSERT INTO `site_lang` VALUES ('129', '38', 'Verify');
INSERT INTO `site_lang` VALUES ('130', '38', 'Change password');
INSERT INTO `site_lang` VALUES ('131', '38', 'Delete');
INSERT INTO `site_lang` VALUES ('132', '38', 'Personal information');
INSERT INTO `site_lang` VALUES ('133', '38', 'You can edit your profile information bellow');
INSERT INTO `site_lang` VALUES ('134', '38', 'Site language');
INSERT INTO `site_lang` VALUES ('135', '38', 'Update profile');
INSERT INTO `site_lang` VALUES ('136', '38', 'Verify account');
INSERT INTO `site_lang` VALUES ('137', '38', 'For verify your account , connect with your facebook account');
INSERT INTO `site_lang` VALUES ('138', '38', 'Connect with Facebook');
INSERT INTO `site_lang` VALUES ('139', '38', 'You are account is already verified');
INSERT INTO `site_lang` VALUES ('140', '38', 'Buy credits for send Gifs and Unblock private photos');
INSERT INTO `site_lang` VALUES ('141', '38', 'Account type');
INSERT INTO `site_lang` VALUES ('142', '38', 'Current credits');
INSERT INTO `site_lang` VALUES ('143', '38', 'Add credits');
INSERT INTO `site_lang` VALUES ('144', '38', 'Upgrade to premium account');
INSERT INTO `site_lang` VALUES ('145', '38', 'Change password');
INSERT INTO `site_lang` VALUES ('146', '38', 'You can change your current password bellow');
INSERT INTO `site_lang` VALUES ('147', '38', 'New password');
INSERT INTO `site_lang` VALUES ('148', '38', 'Profile desactivation');
INSERT INTO `site_lang` VALUES ('149', '38', 'After delete your profile, some of your data will be lost without recovery.');
INSERT INTO `site_lang` VALUES ('150', '38', 'Delete profile');
INSERT INTO `site_lang` VALUES ('151', '38', 'Online now');
INSERT INTO `site_lang` VALUES ('152', '38', 'Verified');
INSERT INTO `site_lang` VALUES ('153', '38', 'Nothing found');
INSERT INTO `site_lang` VALUES ('154', '38', 'people found');
INSERT INTO `site_lang` VALUES ('155', '38', 'No popular users near you');
INSERT INTO `site_lang` VALUES ('156', '38', 'You dont have any fans yet');
INSERT INTO `site_lang` VALUES ('157', '38', 'You dont have matches yet');
INSERT INTO `site_lang` VALUES ('158', '38', 'January');
INSERT INTO `site_lang` VALUES ('159', '38', 'February');
INSERT INTO `site_lang` VALUES ('160', '38', 'March');
INSERT INTO `site_lang` VALUES ('161', '38', 'April');
INSERT INTO `site_lang` VALUES ('162', '38', 'May');
INSERT INTO `site_lang` VALUES ('163', '38', 'June');
INSERT INTO `site_lang` VALUES ('164', '38', 'July');
INSERT INTO `site_lang` VALUES ('165', '38', 'August');
INSERT INTO `site_lang` VALUES ('166', '38', 'September');
INSERT INTO `site_lang` VALUES ('167', '38', 'October');
INSERT INTO `site_lang` VALUES ('168', '38', 'November');
INSERT INTO `site_lang` VALUES ('169', '38', 'December');
INSERT INTO `site_lang` VALUES ('170', '38', 'Buy');
INSERT INTO `site_lang` VALUES ('171', '38', 'Days Premium');
INSERT INTO `site_lang` VALUES ('172', '38', 'persons more like this');
INSERT INTO `site_lang` VALUES ('173', '38', 'like this');
INSERT INTO `site_lang` VALUES ('174', '38', 'Hello, can i have access to your private photos ?');
INSERT INTO `site_lang` VALUES ('175', '38', 'Yes');
INSERT INTO `site_lang` VALUES ('176', '38', 'No');
INSERT INTO `site_lang` VALUES ('177', '38', 'Hi');
INSERT INTO `site_lang` VALUES ('178', '38', 'If you dont remember your password, click the link below to set a new one:');
INSERT INTO `site_lang` VALUES ('179', '38', 'Login to my account');
INSERT INTO `site_lang` VALUES ('180', '38', 'Password recover');
INSERT INTO `site_lang` VALUES ('181', '38', 'Invalid email format');
INSERT INTO `site_lang` VALUES ('182', '38', 'Please fill all the inputs');
INSERT INTO `site_lang` VALUES ('183', '38', 'Email dont exist');
INSERT INTO `site_lang` VALUES ('184', '38', 'Wrong password');
INSERT INTO `site_lang` VALUES ('185', '38', 'Add a valid date');
INSERT INTO `site_lang` VALUES ('186', '38', 'Choose city from the autocomplete');
INSERT INTO `site_lang` VALUES ('187', '38', 'Password too short');
INSERT INTO `site_lang` VALUES ('188', '38', 'Email already exist, try another');
INSERT INTO `site_lang` VALUES ('189', '38', 'Yes, you can see my private photos');
INSERT INTO `site_lang` VALUES ('190', '38', 'No, i cant show you my private photos');
INSERT INTO `site_lang` VALUES ('191', '38', 'Buy private photos permission');
INSERT INTO `site_lang` VALUES ('192', '38', 'Get access to');
INSERT INTO `site_lang` VALUES ('193', '38', 'private photos for ');
INSERT INTO `site_lang` VALUES ('194', '38', 'Get access');
INSERT INTO `site_lang` VALUES ('195', '38', 'No thanks');
INSERT INTO `site_lang` VALUES ('196', '38', 'Please, select a payment method');
INSERT INTO `site_lang` VALUES ('197', '38', 'Please, select 1 photo');
INSERT INTO `site_lang` VALUES ('198', '38', 'Please, select 1 gift');
INSERT INTO `site_lang` VALUES ('199', '38', 'You dont have enought credits for send the gift');
INSERT INTO `site_lang` VALUES ('200', '38', 'Expand daily limitation ');
INSERT INTO `site_lang` VALUES ('201', '38', 'more daily conversation, cost ');
INSERT INTO `site_lang` VALUES ('202', '38', 'Yes, buy it!');
INSERT INTO `site_lang` VALUES ('203', '38', 'Information updated successfully');
INSERT INTO `site_lang` VALUES ('204', '38', 'Account termination');
INSERT INTO `site_lang` VALUES ('205', '38', 'Your data will be lost without recovery, continue?');
INSERT INTO `site_lang` VALUES ('206', '38', 'Yes, delete it!');
INSERT INTO `site_lang` VALUES ('207', '38', 'is in another videocall , you cant call now');
INSERT INTO `site_lang` VALUES ('208', '38', 'is offline, try again when your friend is online');
INSERT INTO `site_lang` VALUES ('209', '38', 'Please allow access to your Webcam.');
INSERT INTO `site_lang` VALUES ('210', '38', 'You are already in a videocall, you have to end the other call before start another');
INSERT INTO `site_lang` VALUES ('211', '38', 'Only premium users can make videocalls');
INSERT INTO `site_lang` VALUES ('212', '38', 'Impossible to make a call!');
INSERT INTO `site_lang` VALUES ('213', '38', 'You cant make videocall because you dont have webcam');
INSERT INTO `site_lang` VALUES ('214', '38', 'Too long wait');
INSERT INTO `site_lang` VALUES ('215', '38', 'Seems that your friend do not have webcam or he is not available');
INSERT INTO `site_lang` VALUES ('216', '38', 'End call');
INSERT INTO `site_lang` VALUES ('217', '38', 'Wait more');
INSERT INTO `site_lang` VALUES ('218', '38', 'until');
INSERT INTO `site_lang` VALUES ('219', '38', 'Basic');
INSERT INTO `site_lang` VALUES ('220', '38', 'UPGRADE');
INSERT INTO `site_lang` VALUES ('221', '38', 'Notifications');
INSERT INTO `site_lang` VALUES ('222', '38', 'Extended info (optional)');
INSERT INTO `site_lang` VALUES ('223', '38', 'Relationship');
INSERT INTO `site_lang` VALUES ('224', '38', 'Single');
INSERT INTO `site_lang` VALUES ('225', '38', 'Taken');
INSERT INTO `site_lang` VALUES ('226', '38', 'Open');
INSERT INTO `site_lang` VALUES ('227', '38', 'Sexuality');
INSERT INTO `site_lang` VALUES ('228', '38', 'Gay');
INSERT INTO `site_lang` VALUES ('229', '38', 'Open-minded');
INSERT INTO `site_lang` VALUES ('230', '38', 'Straight');
INSERT INTO `site_lang` VALUES ('231', '38', 'Bisexual');
INSERT INTO `site_lang` VALUES ('232', '38', 'Height');
INSERT INTO `site_lang` VALUES ('233', '38', 'less than');
INSERT INTO `site_lang` VALUES ('234', '38', 'more than');
INSERT INTO `site_lang` VALUES ('235', '38', 'Weight');
INSERT INTO `site_lang` VALUES ('236', '38', 'Ethnicity');
INSERT INTO `site_lang` VALUES ('237', '38', 'Asian');
INSERT INTO `site_lang` VALUES ('238', '38', 'Middle Eastern');
INSERT INTO `site_lang` VALUES ('239', '38', 'Black');
INSERT INTO `site_lang` VALUES ('240', '38', 'White');
INSERT INTO `site_lang` VALUES ('241', '38', 'Native American');
INSERT INTO `site_lang` VALUES ('242', '38', 'Hispanic/latin');
INSERT INTO `site_lang` VALUES ('243', '38', 'Pacific Islander');
INSERT INTO `site_lang` VALUES ('244', '38', 'Indian');
INSERT INTO `site_lang` VALUES ('245', '38', 'Other');
INSERT INTO `site_lang` VALUES ('246', '38', 'Body type');
INSERT INTO `site_lang` VALUES ('247', '38', 'Slim');
INSERT INTO `site_lang` VALUES ('248', '38', 'Average');
INSERT INTO `site_lang` VALUES ('249', '38', 'Athletic');
INSERT INTO `site_lang` VALUES ('250', '38', 'Heavy set');
INSERT INTO `site_lang` VALUES ('251', '38', 'Curvy');
INSERT INTO `site_lang` VALUES ('252', '38', 'Living');
INSERT INTO `site_lang` VALUES ('253', '38', 'With parents');
INSERT INTO `site_lang` VALUES ('254', '38', 'With housemate');
INSERT INTO `site_lang` VALUES ('255', '38', 'Student dormitory');
INSERT INTO `site_lang` VALUES ('256', '38', 'With partner');
INSERT INTO `site_lang` VALUES ('257', '38', 'Alone');
INSERT INTO `site_lang` VALUES ('258', '38', 'Smoke');
INSERT INTO `site_lang` VALUES ('259', '38', 'Yes');
INSERT INTO `site_lang` VALUES ('260', '38', 'No');
INSERT INTO `site_lang` VALUES ('261', '38', 'Sometimes');
INSERT INTO `site_lang` VALUES ('262', '38', 'Drink');
INSERT INTO `site_lang` VALUES ('263', '38', 'Transport');
INSERT INTO `site_lang` VALUES ('264', '38', 'Parents car');
INSERT INTO `site_lang` VALUES ('265', '38', 'I own a car');
INSERT INTO `site_lang` VALUES ('266', '38', 'I own a motorbike');
INSERT INTO `site_lang` VALUES ('267', '38', 'None');
INSERT INTO `site_lang` VALUES ('268', '38', 'When someone likes me');
INSERT INTO `site_lang` VALUES ('269', '38', 'When i get a match');
INSERT INTO `site_lang` VALUES ('270', '38', 'When new users near me join in');
INSERT INTO `site_lang` VALUES ('271', '38', 'When someone send me a message');
INSERT INTO `site_lang` VALUES ('272', '38', 'Day');
INSERT INTO `site_lang` VALUES ('273', '38', 'Month');
INSERT INTO `site_lang` VALUES ('274', '38', 'Year');
INSERT INTO `site_lang` VALUES ('275', '38', 'Please wait');
INSERT INTO `site_lang` VALUES ('276', '38', 'Interests');
INSERT INTO `site_lang` VALUES ('277', '38', 'Report');
INSERT INTO `site_lang` VALUES ('278', '38', 'Fans');
INSERT INTO `site_lang` VALUES ('279', '38', 'No data');
INSERT INTO `site_lang` VALUES ('280', '38', 'Public Photos');
INSERT INTO `site_lang` VALUES ('281', '38', 'Private photos');
INSERT INTO `site_lang` VALUES ('282', '38', 'Add from ');
INSERT INTO `site_lang` VALUES ('283', '38', 'Add');
INSERT INTO `site_lang` VALUES ('284', '38', 'Photos');
INSERT INTO `site_lang` VALUES ('285', '38', 'Credits');
INSERT INTO `site_lang` VALUES ('286', '38', 'Visits');
INSERT INTO `site_lang` VALUES ('287', '38', 'Add me here');
INSERT INTO `site_lang` VALUES ('288', '38', 'get seen by millions');
INSERT INTO `site_lang` VALUES ('289', '38', 'Set as profile');
INSERT INTO `site_lang` VALUES ('290', '38', 'Private photo');
INSERT INTO `site_lang` VALUES ('291', '38', 'Public photo');
INSERT INTO `site_lang` VALUES ('292', '38', 'Delete');
INSERT INTO `site_lang` VALUES ('293', '38', 'people visited your profile for see them');
INSERT INTO `site_lang` VALUES ('294', '38', 'Upgrade your account to premium');
INSERT INTO `site_lang` VALUES ('295', '38', 'People i like');
INSERT INTO `site_lang` VALUES ('296', '38', 'people liked you, for see them');
INSERT INTO `site_lang` VALUES ('297', '38', 'Messages');
INSERT INTO `site_lang` VALUES ('298', '38', 'Like');
INSERT INTO `site_lang` VALUES ('299', '38', 'Dislike');
INSERT INTO `site_lang` VALUES ('300', '38', 'AGE');
INSERT INTO `site_lang` VALUES ('301', '38', 'You dont have any visit yet');
INSERT INTO `site_lang` VALUES ('302', '38', 'visited');
INSERT INTO `site_lang` VALUES ('303', '38', 'You do not like anyone');
INSERT INTO `site_lang` VALUES ('304', '38', 'Cost');
INSERT INTO `site_lang` VALUES ('305', '38', 'Credits for $');
INSERT INTO `site_lang` VALUES ('306', '38', '0 seconds');
INSERT INTO `site_lang` VALUES ('307', '38', 'year');
INSERT INTO `site_lang` VALUES ('308', '38', 'month');
INSERT INTO `site_lang` VALUES ('309', '38', 'day');
INSERT INTO `site_lang` VALUES ('310', '38', 'hour');
INSERT INTO `site_lang` VALUES ('311', '38', 'minute');
INSERT INTO `site_lang` VALUES ('312', '38', 'second');
INSERT INTO `site_lang` VALUES ('313', '38', 'years');
INSERT INTO `site_lang` VALUES ('314', '38', 'months');
INSERT INTO `site_lang` VALUES ('315', '38', 'days');
INSERT INTO `site_lang` VALUES ('316', '38', 'hours');
INSERT INTO `site_lang` VALUES ('317', '38', 'minutes');
INSERT INTO `site_lang` VALUES ('318', '38', 'seconds');
INSERT INTO `site_lang` VALUES ('319', '38', 'ago');
INSERT INTO `site_lang` VALUES ('320', '38', 'Please verify your account, check your email');
INSERT INTO `site_lang` VALUES ('321', '38', 'Please add a profile photo');
INSERT INTO `site_lang` VALUES ('322', '38', 'Hi, im');
INSERT INTO `site_lang` VALUES ('323', '38', 'years old and im from');
INSERT INTO `site_lang` VALUES ('324', '38', 'We sended you a email for verify your account');
INSERT INTO `site_lang` VALUES ('325', '38', 'is blocking you or you blocked him, you cant chat with him sorry');
INSERT INTO `site_lang` VALUES ('326', '38', 'Report and block');
INSERT INTO `site_lang` VALUES ('327', '38', 'Are you sure you want to report');
INSERT INTO `site_lang` VALUES ('328', '38', 'Press backspace key for smart return to the meeting section.');
INSERT INTO `site_lang` VALUES ('329', '38', 'Write your instagram username');
INSERT INTO `site_lang` VALUES ('330', '38', 'You need to write your username!');
INSERT INTO `site_lang` VALUES ('331', '38', 'username');
INSERT INTO `site_lang` VALUES ('332', '38', 'days of Premium');
INSERT INTO `site_lang` VALUES ('333', '38', 'Wrong');
INSERT INTO `site_lang` VALUES ('334', '38', 'Spotlight');
INSERT INTO `site_lang` VALUES ('335', '38', 'Service cost');
INSERT INTO `site_lang` VALUES ('336', '38', 'Password successfully changed');
INSERT INTO `site_lang` VALUES ('337', '38', 'is calling you..');
INSERT INTO `site_lang` VALUES ('338', '38', 'Photos of ');
INSERT INTO `site_lang` VALUES ('339', '38', 'of');
INSERT INTO `site_lang` VALUES ('340', '38', 'Loading...');
INSERT INTO `site_lang` VALUES ('341', '38', 'We sent you a email with your info, it may take up to 1 min to arrive');
INSERT INTO `site_lang` VALUES ('342', '38', 'likes you and wants to chat in');
INSERT INTO `site_lang` VALUES ('343', '38', 'has seen you in discover and likes. The feeling is mutual?');
INSERT INTO `site_lang` VALUES ('344', '38', 'Find out if you also like');
INSERT INTO `site_lang` VALUES ('345', '38', 'You received this notice because you registered as');
INSERT INTO `site_lang` VALUES ('346', '38', 'Unsubscribe');
INSERT INTO `site_lang` VALUES ('347', '38', 'Choose a new password');
INSERT INTO `site_lang` VALUES ('348', '38', 'if you forgot your password, click on the link below to get a new');
INSERT INTO `site_lang` VALUES ('349', '38', 'You have a match at');
INSERT INTO `site_lang` VALUES ('350', '38', 'Its a match!');
INSERT INTO `site_lang` VALUES ('351', '38', 'thinks the feeling is mutual');
INSERT INTO `site_lang` VALUES ('352', '38', 'Go and say something to');
INSERT INTO `site_lang` VALUES ('353', '38', 'New message from');
INSERT INTO `site_lang` VALUES ('354', '38', 'you have a new message from');
INSERT INTO `site_lang` VALUES ('355', '38', 'Respond to');
INSERT INTO `site_lang` VALUES ('356', '38', 'Have fun!');
INSERT INTO `site_lang` VALUES ('357', '38', 'is new and lives closer to you');
INSERT INTO `site_lang` VALUES ('358', '38', 'is new at');
INSERT INTO `site_lang` VALUES ('359', '38', 'and lives closer to you');
INSERT INTO `site_lang` VALUES ('360', '38', 'Check out the profile');
INSERT INTO `site_lang` VALUES ('361', '38', 'Welcome');
INSERT INTO `site_lang` VALUES ('362', '38', 'Well done, now you are in');
INSERT INTO `site_lang` VALUES ('363', '38', 'Here are a few tips');
INSERT INTO `site_lang` VALUES ('364', '38', 'Now you are a new member of');
INSERT INTO `site_lang` VALUES ('365', '38', 'Verify your account');
INSERT INTO `site_lang` VALUES ('366', '38', 'Newsflash');
INSERT INTO `site_lang` VALUES ('367', '38', 'people in your area wants to know you');
INSERT INTO `site_lang` VALUES ('368', '38', 'In');
INSERT INTO `site_lang` VALUES ('369', '38', 'you can meet people instantly');
INSERT INTO `site_lang` VALUES ('370', '38', 'Meet new people');
INSERT INTO `site_lang` VALUES ('371', '38', 'Nobody is going to fall in love with a blank page. The more information you get, the more chances to find that special someone!');
INSERT INTO `site_lang` VALUES ('372', '38', 'Add photos and complete your profile');
INSERT INTO `site_lang` VALUES ('373', '38', 'More than 1 million people have joined $site_name You probably want to know some of them.');
INSERT INTO `site_lang` VALUES ('374', '38', 'Start meeting new people now');
INSERT INTO `site_lang` VALUES ('375', '38', 'Here are your connection details');
INSERT INTO `site_lang` VALUES ('376', '38', 'E-mail');
INSERT INTO `site_lang` VALUES ('377', '38', 'Password');
INSERT INTO `site_lang` VALUES ('378', '38', 'Please save your connection information in a safe place');
INSERT INTO `site_lang` VALUES ('379', '38', 'Go to');
INSERT INTO `site_lang` VALUES ('380', '38', 'Welcome to');
INSERT INTO `site_lang` VALUES ('381', '38', 'calling...');
INSERT INTO `site_lang` VALUES ('382', '38', 'dont like you');
INSERT INTO `site_lang` VALUES ('383', '38', 'must like you for start a videocall');
INSERT INTO `site_lang` VALUES ('384', '38', 'Ok, i understand');
INSERT INTO `site_lang` VALUES ('0', '39', 'meet new people!');
INSERT INTO `site_lang` VALUES ('1', '39', 'Login');
INSERT INTO `site_lang` VALUES ('2', '39', 'Welcome to the fastest growing place to meet new people');
INSERT INTO `site_lang` VALUES ('3', '39', 'For now our site works only for Desktop users');
INSERT INTO `site_lang` VALUES ('4', '39', 'Please visit us from your laptop or PC');
INSERT INTO `site_lang` VALUES ('5', '39', 'Soon we will have our phone apps online');
INSERT INTO `site_lang` VALUES ('6', '39', 'SOON AVAILABLE');
INSERT INTO `site_lang` VALUES ('7', '39', 'Connect with ');
INSERT INTO `site_lang` VALUES ('8', '39', 'Create your account');
INSERT INTO `site_lang` VALUES ('9', '39', 'Welcome back');
INSERT INTO `site_lang` VALUES ('10', '39', 'Your email');
INSERT INTO `site_lang` VALUES ('11', '39', 'Your password');
INSERT INTO `site_lang` VALUES ('12', '39', 'do you forget your password?');
INSERT INTO `site_lang` VALUES ('13', '39', 'Login now');
INSERT INTO `site_lang` VALUES ('14', '39', 'Password recover');
INSERT INTO `site_lang` VALUES ('15', '39', 'Recover password');
INSERT INTO `site_lang` VALUES ('16', '39', 'Chat');
INSERT INTO `site_lang` VALUES ('17', '39', 'Powerfull private chat for meet new friends, you can send emoticons and private photos to anyone.');
INSERT INTO `site_lang` VALUES ('18', '39', 'Video Chat');
INSERT INTO `site_lang` VALUES ('19', '39', 'You can make quality videocalls for free to anyone, without limits of call duration, just enjoy seeing the person who is chatting with you');
INSERT INTO `site_lang` VALUES ('20', '39', 'People nearby');
INSERT INTO `site_lang` VALUES ('21', '39', 'We wont show your exact location, but you will be able to find people nearby who like the same things you do.');
INSERT INTO `site_lang` VALUES ('22', '39', 'Matches');
INSERT INTO `site_lang` VALUES ('23', '39', 'Play our popular Discover game and get matched with other users. Its a great way to break the ice and chat to new people.');
INSERT INTO `site_lang` VALUES ('24', '39', 'Become a member now');
INSERT INTO `site_lang` VALUES ('25', '39', 'Join the worlds bestest community for meeting new people!.');
INSERT INTO `site_lang` VALUES ('26', '39', 'Name');
INSERT INTO `site_lang` VALUES ('27', '39', 'Your name or nickname');
INSERT INTO `site_lang` VALUES ('28', '39', 'Email');
INSERT INTO `site_lang` VALUES ('29', '39', 'Password');
INSERT INTO `site_lang` VALUES ('30', '39', 'Birthday');
INSERT INTO `site_lang` VALUES ('31', '39', 'Please select');
INSERT INTO `site_lang` VALUES ('32', '39', 'City');
INSERT INTO `site_lang` VALUES ('33', '39', 'Where do you live?');
INSERT INTO `site_lang` VALUES ('34', '39', 'Gender');
INSERT INTO `site_lang` VALUES ('35', '39', 'Male');
INSERT INTO `site_lang` VALUES ('36', '39', 'Female');
INSERT INTO `site_lang` VALUES ('37', '39', 'Im here to');
INSERT INTO `site_lang` VALUES ('38', '39', 'Meet girls');
INSERT INTO `site_lang` VALUES ('39', '39', 'Meet boys');
INSERT INTO `site_lang` VALUES ('40', '39', 'Meet boys and girls');
INSERT INTO `site_lang` VALUES ('41', '39', 'Sign up');
INSERT INTO `site_lang` VALUES ('42', '39', 'By continuing, you are confirming that you have read and agree to our');
INSERT INTO `site_lang` VALUES ('43', '39', 'Terms and Conditions');
INSERT INTO `site_lang` VALUES ('44', '39', 'and');
INSERT INTO `site_lang` VALUES ('45', '39', 'Privacy Policy');
INSERT INTO `site_lang` VALUES ('46', '39', 'Profile');
INSERT INTO `site_lang` VALUES ('47', '39', 'Settings');
INSERT INTO `site_lang` VALUES ('48', '39', 'Logout');
INSERT INTO `site_lang` VALUES ('49', '39', 'Meet new people');
INSERT INTO `site_lang` VALUES ('50', '39', 'Discover');
INSERT INTO `site_lang` VALUES ('51', '39', 'Matches');
INSERT INTO `site_lang` VALUES ('52', '39', 'Most populars');
INSERT INTO `site_lang` VALUES ('53', '39', 'Fans');
INSERT INTO `site_lang` VALUES ('54', '39', 'Manage photos');
INSERT INTO `site_lang` VALUES ('55', '39', 'Settings');
INSERT INTO `site_lang` VALUES ('56', '39', 'All');
INSERT INTO `site_lang` VALUES ('57', '39', 'Fans');
INSERT INTO `site_lang` VALUES ('58', '39', 'Conversations');
INSERT INTO `site_lang` VALUES ('59', '39', 'Online now');
INSERT INTO `site_lang` VALUES ('60', '39', 'New messages');
INSERT INTO `site_lang` VALUES ('61', '39', 'Who to like');
INSERT INTO `site_lang` VALUES ('62', '39', 'Terms');
INSERT INTO `site_lang` VALUES ('63', '39', 'Privacy');
INSERT INTO `site_lang` VALUES ('64', '39', 'Contact');
INSERT INTO `site_lang` VALUES ('65', '39', 'Manage your photos');
INSERT INTO `site_lang` VALUES ('66', '39', 'All Photos');
INSERT INTO `site_lang` VALUES ('67', '39', 'Public Photos');
INSERT INTO `site_lang` VALUES ('68', '39', 'Private Photos');
INSERT INTO `site_lang` VALUES ('69', '39', 'Add your photos');
INSERT INTO `site_lang` VALUES ('70', '39', 'add photos');
INSERT INTO `site_lang` VALUES ('71', '39', 'Add yourself to the Spotlight');
INSERT INTO `site_lang` VALUES ('72', '39', 'Pick the photo you want to show in the Spotlight, cost ');
INSERT INTO `site_lang` VALUES ('73', '39', 'Credits');
INSERT INTO `site_lang` VALUES ('74', '39', 'Add photo');
INSERT INTO `site_lang` VALUES ('75', '39', 'Send gift to ');
INSERT INTO `site_lang` VALUES ('76', '39', 'Pick the gift you want to send to ');
INSERT INTO `site_lang` VALUES ('77', '39', 'Send gift');
INSERT INTO `site_lang` VALUES ('78', '39', 'Buy credits / Upgrade account');
INSERT INTO `site_lang` VALUES ('79', '39', 'Select credits package');
INSERT INTO `site_lang` VALUES ('80', '39', 'Select payment method');
INSERT INTO `site_lang` VALUES ('81', '39', 'Pay with');
INSERT INTO `site_lang` VALUES ('82', '39', 'Pay with');
INSERT INTO `site_lang` VALUES ('83', '39', 'Buy credits');
INSERT INTO `site_lang` VALUES ('84', '39', 'Premium Account Features');
INSERT INTO `site_lang` VALUES ('85', '39', 'new chats per day');
INSERT INTO `site_lang` VALUES ('86', '39', 'Unlimited videocalls');
INSERT INTO `site_lang` VALUES ('87', '39', 'Unblock all private photos');
INSERT INTO `site_lang` VALUES ('88', '39', 'Premium user badge');
INSERT INTO `site_lang` VALUES ('89', '39', 'Write text here');
INSERT INTO `site_lang` VALUES ('90', '39', 'Send');
INSERT INTO `site_lang` VALUES ('91', '39', 'Chat');
INSERT INTO `site_lang` VALUES ('92', '39', 'you have reached the limit of new daily conversations');
INSERT INTO `site_lang` VALUES ('93', '39', 'To continue chatting');
INSERT INTO `site_lang` VALUES ('94', '39', 'Buy');
INSERT INTO `site_lang` VALUES ('95', '39', 'more daily conversation');
INSERT INTO `site_lang` VALUES ('96', '39', 'or');
INSERT INTO `site_lang` VALUES ('97', '39', 'Upgrade your account to Premium');
INSERT INTO `site_lang` VALUES ('98', '39', 'and get up to');
INSERT INTO `site_lang` VALUES ('99', '39', 'daily conversations');
INSERT INTO `site_lang` VALUES ('100', '39', 'or wait until tomorrow for continue meeting people');
INSERT INTO `site_lang` VALUES ('101', '39', 'Your fans');
INSERT INTO `site_lang` VALUES ('102', '39', 'Privacy Policy');
INSERT INTO `site_lang` VALUES ('103', '39', 'Terms of Use');
INSERT INTO `site_lang` VALUES ('104', '39', 'Please complete your profile before start in ');
INSERT INTO `site_lang` VALUES ('105', '39', 'Your matches');
INSERT INTO `site_lang` VALUES ('106', '39', 'Filter Search');
INSERT INTO `site_lang` VALUES ('107', '39', 'All users');
INSERT INTO `site_lang` VALUES ('108', '39', 'Online now');
INSERT INTO `site_lang` VALUES ('109', '39', 'Show me');
INSERT INTO `site_lang` VALUES ('110', '39', 'Girls');
INSERT INTO `site_lang` VALUES ('111', '39', 'Boys');
INSERT INTO `site_lang` VALUES ('112', '39', 'Both');
INSERT INTO `site_lang` VALUES ('113', '39', 'who are between');
INSERT INTO `site_lang` VALUES ('114', '39', 'in a radius of');
INSERT INTO `site_lang` VALUES ('115', '39', 'World');
INSERT INTO `site_lang` VALUES ('116', '39', 'Most popular users');
INSERT INTO `site_lang` VALUES ('117', '39', 'About ');
INSERT INTO `site_lang` VALUES ('118', '39', 'Personal info');
INSERT INTO `site_lang` VALUES ('119', '39', 'years old');
INSERT INTO `site_lang` VALUES ('120', '39', 'Only boys');
INSERT INTO `site_lang` VALUES ('121', '39', 'Only girls');
INSERT INTO `site_lang` VALUES ('122', '39', 'boys and girls');
INSERT INTO `site_lang` VALUES ('123', '39', 'Credits successfully added to your account');
INSERT INTO `site_lang` VALUES ('124', '39', 'Now you have');
INSERT INTO `site_lang` VALUES ('125', '39', 'Ask permission to');
INSERT INTO `site_lang` VALUES ('126', '39', 'Unblock private photos');
INSERT INTO `site_lang` VALUES ('127', '39', 'Personal');
INSERT INTO `site_lang` VALUES ('128', '39', 'Credits');
INSERT INTO `site_lang` VALUES ('129', '39', 'Verify');
INSERT INTO `site_lang` VALUES ('130', '39', 'Change password');
INSERT INTO `site_lang` VALUES ('131', '39', 'Delete');
INSERT INTO `site_lang` VALUES ('132', '39', 'Personal information');
INSERT INTO `site_lang` VALUES ('133', '39', 'You can edit your profile information bellow');
INSERT INTO `site_lang` VALUES ('134', '39', 'Site language');
INSERT INTO `site_lang` VALUES ('135', '39', 'Update profile');
INSERT INTO `site_lang` VALUES ('136', '39', 'Verify account');
INSERT INTO `site_lang` VALUES ('137', '39', 'For verify your account , connect with your facebook account');
INSERT INTO `site_lang` VALUES ('138', '39', 'Connect with Facebook');
INSERT INTO `site_lang` VALUES ('139', '39', 'You are account is already verified');
INSERT INTO `site_lang` VALUES ('140', '39', 'Buy credits for send Gifs and Unblock private photos');
INSERT INTO `site_lang` VALUES ('141', '39', 'Account type');
INSERT INTO `site_lang` VALUES ('142', '39', 'Current credits');
INSERT INTO `site_lang` VALUES ('143', '39', 'Add credits');
INSERT INTO `site_lang` VALUES ('144', '39', 'Upgrade to premium account');
INSERT INTO `site_lang` VALUES ('145', '39', 'Change password');
INSERT INTO `site_lang` VALUES ('146', '39', 'You can change your current password bellow');
INSERT INTO `site_lang` VALUES ('147', '39', 'New password');
INSERT INTO `site_lang` VALUES ('148', '39', 'Profile desactivation');
INSERT INTO `site_lang` VALUES ('149', '39', 'After delete your profile, some of your data will be lost without recovery.');
INSERT INTO `site_lang` VALUES ('150', '39', 'Delete profile');
INSERT INTO `site_lang` VALUES ('151', '39', 'Online now');
INSERT INTO `site_lang` VALUES ('152', '39', 'Verified');
INSERT INTO `site_lang` VALUES ('153', '39', 'Nothing found');
INSERT INTO `site_lang` VALUES ('154', '39', 'people found');
INSERT INTO `site_lang` VALUES ('155', '39', 'No popular users near you');
INSERT INTO `site_lang` VALUES ('156', '39', 'You dont have any fans yet');
INSERT INTO `site_lang` VALUES ('157', '39', 'You dont have matches yet');
INSERT INTO `site_lang` VALUES ('158', '39', 'January');
INSERT INTO `site_lang` VALUES ('159', '39', 'February');
INSERT INTO `site_lang` VALUES ('160', '39', 'March');
INSERT INTO `site_lang` VALUES ('161', '39', 'April');
INSERT INTO `site_lang` VALUES ('162', '39', 'May');
INSERT INTO `site_lang` VALUES ('163', '39', 'June');
INSERT INTO `site_lang` VALUES ('164', '39', 'July');
INSERT INTO `site_lang` VALUES ('165', '39', 'August');
INSERT INTO `site_lang` VALUES ('166', '39', 'September');
INSERT INTO `site_lang` VALUES ('167', '39', 'October');
INSERT INTO `site_lang` VALUES ('168', '39', 'November');
INSERT INTO `site_lang` VALUES ('169', '39', 'December');
INSERT INTO `site_lang` VALUES ('170', '39', 'Buy');
INSERT INTO `site_lang` VALUES ('171', '39', 'Days Premium');
INSERT INTO `site_lang` VALUES ('172', '39', 'persons more like this');
INSERT INTO `site_lang` VALUES ('173', '39', 'like this');
INSERT INTO `site_lang` VALUES ('174', '39', 'Hello, can i have access to your private photos ?');
INSERT INTO `site_lang` VALUES ('175', '39', 'Yes');
INSERT INTO `site_lang` VALUES ('176', '39', 'No');
INSERT INTO `site_lang` VALUES ('177', '39', 'Hi');
INSERT INTO `site_lang` VALUES ('178', '39', 'If you dont remember your password, click the link below to set a new one:');
INSERT INTO `site_lang` VALUES ('179', '39', 'Login to my account');
INSERT INTO `site_lang` VALUES ('180', '39', 'Password recover');
INSERT INTO `site_lang` VALUES ('181', '39', 'Invalid email format');
INSERT INTO `site_lang` VALUES ('182', '39', 'Please fill all the inputs');
INSERT INTO `site_lang` VALUES ('183', '39', 'Email dont exist');
INSERT INTO `site_lang` VALUES ('184', '39', 'Wrong password');
INSERT INTO `site_lang` VALUES ('185', '39', 'Add a valid date');
INSERT INTO `site_lang` VALUES ('186', '39', 'Choose city from the autocomplete');
INSERT INTO `site_lang` VALUES ('187', '39', 'Password too short');
INSERT INTO `site_lang` VALUES ('188', '39', 'Email already exist, try another');
INSERT INTO `site_lang` VALUES ('189', '39', 'Yes, you can see my private photos');
INSERT INTO `site_lang` VALUES ('190', '39', 'No, i cant show you my private photos');
INSERT INTO `site_lang` VALUES ('191', '39', 'Buy private photos permission');
INSERT INTO `site_lang` VALUES ('192', '39', 'Get access to');
INSERT INTO `site_lang` VALUES ('193', '39', 'private photos for ');
INSERT INTO `site_lang` VALUES ('194', '39', 'Get access');
INSERT INTO `site_lang` VALUES ('195', '39', 'No thanks');
INSERT INTO `site_lang` VALUES ('196', '39', 'Please, select a payment method');
INSERT INTO `site_lang` VALUES ('197', '39', 'Please, select 1 photo');
INSERT INTO `site_lang` VALUES ('198', '39', 'Please, select 1 gift');
INSERT INTO `site_lang` VALUES ('199', '39', 'You dont have enought credits for send the gift');
INSERT INTO `site_lang` VALUES ('200', '39', 'Expand daily limitation ');
INSERT INTO `site_lang` VALUES ('201', '39', 'more daily conversation, cost ');
INSERT INTO `site_lang` VALUES ('202', '39', 'Yes, buy it!');
INSERT INTO `site_lang` VALUES ('203', '39', 'Information updated successfully');
INSERT INTO `site_lang` VALUES ('204', '39', 'Account termination');
INSERT INTO `site_lang` VALUES ('205', '39', 'Your data will be lost without recovery, continue?');
INSERT INTO `site_lang` VALUES ('206', '39', 'Yes, delete it!');
INSERT INTO `site_lang` VALUES ('207', '39', 'is in another videocall , you cant call now');
INSERT INTO `site_lang` VALUES ('208', '39', 'is offline, try again when your friend is online');
INSERT INTO `site_lang` VALUES ('209', '39', 'Please allow access to your Webcam.');
INSERT INTO `site_lang` VALUES ('210', '39', 'You are already in a videocall, you have to end the other call before start another');
INSERT INTO `site_lang` VALUES ('211', '39', 'Only premium users can make videocalls');
INSERT INTO `site_lang` VALUES ('212', '39', 'Impossible to make a call!');
INSERT INTO `site_lang` VALUES ('213', '39', 'You cant make videocall because you dont have webcam');
INSERT INTO `site_lang` VALUES ('214', '39', 'Too long wait');
INSERT INTO `site_lang` VALUES ('215', '39', 'Seems that your friend do not have webcam or he is not available');
INSERT INTO `site_lang` VALUES ('216', '39', 'End call');
INSERT INTO `site_lang` VALUES ('217', '39', 'Wait more');
INSERT INTO `site_lang` VALUES ('218', '39', 'until');
INSERT INTO `site_lang` VALUES ('219', '39', 'Basic');
INSERT INTO `site_lang` VALUES ('220', '39', 'UPGRADE');
INSERT INTO `site_lang` VALUES ('221', '39', 'Notifications');
INSERT INTO `site_lang` VALUES ('222', '39', 'Extended info (optional)');
INSERT INTO `site_lang` VALUES ('223', '39', 'Relationship');
INSERT INTO `site_lang` VALUES ('224', '39', 'Single');
INSERT INTO `site_lang` VALUES ('225', '39', 'Taken');
INSERT INTO `site_lang` VALUES ('226', '39', 'Open');
INSERT INTO `site_lang` VALUES ('227', '39', 'Sexuality');
INSERT INTO `site_lang` VALUES ('228', '39', 'Gay');
INSERT INTO `site_lang` VALUES ('229', '39', 'Open-minded');
INSERT INTO `site_lang` VALUES ('230', '39', 'Straight');
INSERT INTO `site_lang` VALUES ('231', '39', 'Bisexual');
INSERT INTO `site_lang` VALUES ('232', '39', 'Height');
INSERT INTO `site_lang` VALUES ('233', '39', 'less than');
INSERT INTO `site_lang` VALUES ('234', '39', 'more than');
INSERT INTO `site_lang` VALUES ('235', '39', 'Weight');
INSERT INTO `site_lang` VALUES ('236', '39', 'Ethnicity');
INSERT INTO `site_lang` VALUES ('237', '39', 'Asian');
INSERT INTO `site_lang` VALUES ('238', '39', 'Middle Eastern');
INSERT INTO `site_lang` VALUES ('239', '39', 'Black');
INSERT INTO `site_lang` VALUES ('240', '39', 'White');
INSERT INTO `site_lang` VALUES ('241', '39', 'Native American');
INSERT INTO `site_lang` VALUES ('242', '39', 'Hispanic/latin');
INSERT INTO `site_lang` VALUES ('243', '39', 'Pacific Islander');
INSERT INTO `site_lang` VALUES ('244', '39', 'Indian');
INSERT INTO `site_lang` VALUES ('245', '39', 'Other');
INSERT INTO `site_lang` VALUES ('246', '39', 'Body type');
INSERT INTO `site_lang` VALUES ('247', '39', 'Slim');
INSERT INTO `site_lang` VALUES ('248', '39', 'Average');
INSERT INTO `site_lang` VALUES ('249', '39', 'Athletic');
INSERT INTO `site_lang` VALUES ('250', '39', 'Heavy set');
INSERT INTO `site_lang` VALUES ('251', '39', 'Curvy');
INSERT INTO `site_lang` VALUES ('252', '39', 'Living');
INSERT INTO `site_lang` VALUES ('253', '39', 'With parents');
INSERT INTO `site_lang` VALUES ('254', '39', 'With housemate');
INSERT INTO `site_lang` VALUES ('255', '39', 'Student dormitory');
INSERT INTO `site_lang` VALUES ('256', '39', 'With partner');
INSERT INTO `site_lang` VALUES ('257', '39', 'Alone');
INSERT INTO `site_lang` VALUES ('258', '39', 'Smoke');
INSERT INTO `site_lang` VALUES ('259', '39', 'Yes');
INSERT INTO `site_lang` VALUES ('260', '39', 'No');
INSERT INTO `site_lang` VALUES ('261', '39', 'Sometimes');
INSERT INTO `site_lang` VALUES ('262', '39', 'Drink');
INSERT INTO `site_lang` VALUES ('263', '39', 'Transport');
INSERT INTO `site_lang` VALUES ('264', '39', 'Parents car');
INSERT INTO `site_lang` VALUES ('265', '39', 'I own a car');
INSERT INTO `site_lang` VALUES ('266', '39', 'I own a motorbike');
INSERT INTO `site_lang` VALUES ('267', '39', 'None');
INSERT INTO `site_lang` VALUES ('268', '39', 'When someone likes me');
INSERT INTO `site_lang` VALUES ('269', '39', 'When i get a match');
INSERT INTO `site_lang` VALUES ('270', '39', 'When new users near me join in');
INSERT INTO `site_lang` VALUES ('271', '39', 'When someone send me a message');
INSERT INTO `site_lang` VALUES ('272', '39', 'Day');
INSERT INTO `site_lang` VALUES ('273', '39', 'Month');
INSERT INTO `site_lang` VALUES ('274', '39', 'Year');
INSERT INTO `site_lang` VALUES ('275', '39', 'Please wait');
INSERT INTO `site_lang` VALUES ('276', '39', 'Interests');
INSERT INTO `site_lang` VALUES ('277', '39', 'Report');
INSERT INTO `site_lang` VALUES ('278', '39', 'Fans');
INSERT INTO `site_lang` VALUES ('279', '39', 'No data');
INSERT INTO `site_lang` VALUES ('280', '39', 'Public Photos');
INSERT INTO `site_lang` VALUES ('281', '39', 'Private photos');
INSERT INTO `site_lang` VALUES ('282', '39', 'Add from ');
INSERT INTO `site_lang` VALUES ('283', '39', 'Add');
INSERT INTO `site_lang` VALUES ('284', '39', 'Photos');
INSERT INTO `site_lang` VALUES ('285', '39', 'Credits');
INSERT INTO `site_lang` VALUES ('286', '39', 'Visits');
INSERT INTO `site_lang` VALUES ('287', '39', 'Add me here');
INSERT INTO `site_lang` VALUES ('288', '39', 'get seen by millions');
INSERT INTO `site_lang` VALUES ('289', '39', 'Set as profile');
INSERT INTO `site_lang` VALUES ('290', '39', 'Private photo');
INSERT INTO `site_lang` VALUES ('291', '39', 'Public photo');
INSERT INTO `site_lang` VALUES ('292', '39', 'Delete');
INSERT INTO `site_lang` VALUES ('293', '39', 'people visited your profile for see them');
INSERT INTO `site_lang` VALUES ('294', '39', 'Upgrade your account to premium');
INSERT INTO `site_lang` VALUES ('295', '39', 'People i like');
INSERT INTO `site_lang` VALUES ('296', '39', 'people liked you, for see them');
INSERT INTO `site_lang` VALUES ('297', '39', 'Messages');
INSERT INTO `site_lang` VALUES ('298', '39', 'Like');
INSERT INTO `site_lang` VALUES ('299', '39', 'Dislike');
INSERT INTO `site_lang` VALUES ('300', '39', 'AGE');
INSERT INTO `site_lang` VALUES ('301', '39', 'You dont have any visit yet');
INSERT INTO `site_lang` VALUES ('302', '39', 'visited');
INSERT INTO `site_lang` VALUES ('303', '39', 'You do not like anyone');
INSERT INTO `site_lang` VALUES ('304', '39', 'Cost');
INSERT INTO `site_lang` VALUES ('305', '39', 'Credits for $');
INSERT INTO `site_lang` VALUES ('306', '39', '0 seconds');
INSERT INTO `site_lang` VALUES ('307', '39', 'year');
INSERT INTO `site_lang` VALUES ('308', '39', 'month');
INSERT INTO `site_lang` VALUES ('309', '39', 'day');
INSERT INTO `site_lang` VALUES ('310', '39', 'hour');
INSERT INTO `site_lang` VALUES ('311', '39', 'minute');
INSERT INTO `site_lang` VALUES ('312', '39', 'second');
INSERT INTO `site_lang` VALUES ('313', '39', 'years');
INSERT INTO `site_lang` VALUES ('314', '39', 'months');
INSERT INTO `site_lang` VALUES ('315', '39', 'days');
INSERT INTO `site_lang` VALUES ('316', '39', 'hours');
INSERT INTO `site_lang` VALUES ('317', '39', 'minutes');
INSERT INTO `site_lang` VALUES ('318', '39', 'seconds');
INSERT INTO `site_lang` VALUES ('319', '39', 'ago');
INSERT INTO `site_lang` VALUES ('320', '39', 'Please verify your account, check your email');
INSERT INTO `site_lang` VALUES ('321', '39', 'Please add a profile photo');
INSERT INTO `site_lang` VALUES ('322', '39', 'Hi, im');
INSERT INTO `site_lang` VALUES ('323', '39', 'years old and im from');
INSERT INTO `site_lang` VALUES ('324', '39', 'We sended you a email for verify your account');
INSERT INTO `site_lang` VALUES ('325', '39', 'is blocking you or you blocked him, you cant chat with him sorry');
INSERT INTO `site_lang` VALUES ('326', '39', 'Report and block');
INSERT INTO `site_lang` VALUES ('327', '39', 'Are you sure you want to report');
INSERT INTO `site_lang` VALUES ('328', '39', 'Press backspace key for smart return to the meeting section.');
INSERT INTO `site_lang` VALUES ('329', '39', 'Write your instagram username');
INSERT INTO `site_lang` VALUES ('330', '39', 'You need to write your username!');
INSERT INTO `site_lang` VALUES ('331', '39', 'username');
INSERT INTO `site_lang` VALUES ('332', '39', 'days of Premium');
INSERT INTO `site_lang` VALUES ('333', '39', 'Wrong');
INSERT INTO `site_lang` VALUES ('334', '39', 'Spotlight');
INSERT INTO `site_lang` VALUES ('335', '39', 'Service cost');
INSERT INTO `site_lang` VALUES ('336', '39', 'Password successfully changed');
INSERT INTO `site_lang` VALUES ('337', '39', 'is calling you..');
INSERT INTO `site_lang` VALUES ('338', '39', 'Photos of ');
INSERT INTO `site_lang` VALUES ('339', '39', 'of');
INSERT INTO `site_lang` VALUES ('340', '39', 'Loading...');
INSERT INTO `site_lang` VALUES ('341', '39', 'We sent you a email with your info, it may take up to 1 min to arrive');
INSERT INTO `site_lang` VALUES ('342', '39', 'likes you and wants to chat in');
INSERT INTO `site_lang` VALUES ('343', '39', 'has seen you in discover and likes. The feeling is mutual?');
INSERT INTO `site_lang` VALUES ('344', '39', 'Find out if you also like');
INSERT INTO `site_lang` VALUES ('345', '39', 'You received this notice because you registered as');
INSERT INTO `site_lang` VALUES ('346', '39', 'Unsubscribe');
INSERT INTO `site_lang` VALUES ('347', '39', 'Choose a new password');
INSERT INTO `site_lang` VALUES ('348', '39', 'if you forgot your password, click on the link below to get a new');
INSERT INTO `site_lang` VALUES ('349', '39', 'You have a match at');
INSERT INTO `site_lang` VALUES ('350', '39', 'Its a match!');
INSERT INTO `site_lang` VALUES ('351', '39', 'thinks the feeling is mutual');
INSERT INTO `site_lang` VALUES ('352', '39', 'Go and say something to');
INSERT INTO `site_lang` VALUES ('353', '39', 'New message from');
INSERT INTO `site_lang` VALUES ('354', '39', 'you have a new message from');
INSERT INTO `site_lang` VALUES ('355', '39', 'Respond to');
INSERT INTO `site_lang` VALUES ('356', '39', 'Have fun!');
INSERT INTO `site_lang` VALUES ('357', '39', 'is new and lives closer to you');
INSERT INTO `site_lang` VALUES ('358', '39', 'is new at');
INSERT INTO `site_lang` VALUES ('359', '39', 'and lives closer to you');
INSERT INTO `site_lang` VALUES ('360', '39', 'Check out the profile');
INSERT INTO `site_lang` VALUES ('361', '39', 'Welcome');
INSERT INTO `site_lang` VALUES ('362', '39', 'Well done, now you are in');
INSERT INTO `site_lang` VALUES ('363', '39', 'Here are a few tips');
INSERT INTO `site_lang` VALUES ('364', '39', 'Now you are a new member of');
INSERT INTO `site_lang` VALUES ('365', '39', 'Verify your account');
INSERT INTO `site_lang` VALUES ('366', '39', 'Newsflash');
INSERT INTO `site_lang` VALUES ('367', '39', 'people in your area wants to know you');
INSERT INTO `site_lang` VALUES ('368', '39', 'In');
INSERT INTO `site_lang` VALUES ('369', '39', 'you can meet people instantly');
INSERT INTO `site_lang` VALUES ('370', '39', 'Meet new people');
INSERT INTO `site_lang` VALUES ('371', '39', 'Nobody is going to fall in love with a blank page. The more information you get, the more chances to find that special someone!');
INSERT INTO `site_lang` VALUES ('372', '39', 'Add photos and complete your profile');
INSERT INTO `site_lang` VALUES ('373', '39', 'More than 1 million people have joined $site_name You probably want to know some of them.');
INSERT INTO `site_lang` VALUES ('374', '39', 'Start meeting new people now');
INSERT INTO `site_lang` VALUES ('375', '39', 'Here are your connection details');
INSERT INTO `site_lang` VALUES ('376', '39', 'E-mail');
INSERT INTO `site_lang` VALUES ('377', '39', 'Password');
INSERT INTO `site_lang` VALUES ('378', '39', 'Please save your connection information in a safe place');
INSERT INTO `site_lang` VALUES ('379', '39', 'Go to');
INSERT INTO `site_lang` VALUES ('380', '39', 'Welcome to');
INSERT INTO `site_lang` VALUES ('381', '39', 'calling...');
INSERT INTO `site_lang` VALUES ('382', '39', 'dont like you');
INSERT INTO `site_lang` VALUES ('383', '39', 'must like you for start a videocall');
INSERT INTO `site_lang` VALUES ('384', '39', 'Ok, i understand');
INSERT INTO `site_lang` VALUES ('0', '40', 'meet new people!');
INSERT INTO `site_lang` VALUES ('1', '40', 'Login');
INSERT INTO `site_lang` VALUES ('2', '40', 'Welcome to the fastest growing place to meet new people');
INSERT INTO `site_lang` VALUES ('3', '40', 'For now our site works only for Desktop users');
INSERT INTO `site_lang` VALUES ('4', '40', 'Please visit us from your laptop or PC');
INSERT INTO `site_lang` VALUES ('5', '40', 'Soon we will have our phone apps online');
INSERT INTO `site_lang` VALUES ('6', '40', 'SOON AVAILABLE');
INSERT INTO `site_lang` VALUES ('7', '40', 'Connect with ');
INSERT INTO `site_lang` VALUES ('8', '40', 'Create your account');
INSERT INTO `site_lang` VALUES ('9', '40', 'Welcome back');
INSERT INTO `site_lang` VALUES ('10', '40', 'Your email');
INSERT INTO `site_lang` VALUES ('11', '40', 'Your password');
INSERT INTO `site_lang` VALUES ('12', '40', 'do you forget your password?');
INSERT INTO `site_lang` VALUES ('13', '40', 'Login now');
INSERT INTO `site_lang` VALUES ('14', '40', 'Password recover');
INSERT INTO `site_lang` VALUES ('15', '40', 'Recover password');
INSERT INTO `site_lang` VALUES ('16', '40', 'Chat');
INSERT INTO `site_lang` VALUES ('17', '40', 'Powerfull private chat for meet new friends, you can send emoticons and private photos to anyone.');
INSERT INTO `site_lang` VALUES ('18', '40', 'Video Chat');
INSERT INTO `site_lang` VALUES ('19', '40', 'You can make quality videocalls for free to anyone, without limits of call duration, just enjoy seeing the person who is chatting with you');
INSERT INTO `site_lang` VALUES ('20', '40', 'People nearby');
INSERT INTO `site_lang` VALUES ('21', '40', 'We wont show your exact location, but you will be able to find people nearby who like the same things you do.');
INSERT INTO `site_lang` VALUES ('22', '40', 'Matches');
INSERT INTO `site_lang` VALUES ('23', '40', 'Play our popular Discover game and get matched with other users. Its a great way to break the ice and chat to new people.');
INSERT INTO `site_lang` VALUES ('24', '40', 'Become a member now');
INSERT INTO `site_lang` VALUES ('25', '40', 'Join the worlds bestest community for meeting new people!.');
INSERT INTO `site_lang` VALUES ('26', '40', 'Name');
INSERT INTO `site_lang` VALUES ('27', '40', 'Your name or nickname');
INSERT INTO `site_lang` VALUES ('28', '40', 'Email');
INSERT INTO `site_lang` VALUES ('29', '40', 'Password');
INSERT INTO `site_lang` VALUES ('30', '40', 'Birthday');
INSERT INTO `site_lang` VALUES ('31', '40', 'Please select');
INSERT INTO `site_lang` VALUES ('32', '40', 'City');
INSERT INTO `site_lang` VALUES ('33', '40', 'Where do you live?');
INSERT INTO `site_lang` VALUES ('34', '40', 'Gender');
INSERT INTO `site_lang` VALUES ('35', '40', 'Male');
INSERT INTO `site_lang` VALUES ('36', '40', 'Female');
INSERT INTO `site_lang` VALUES ('37', '40', 'Im here to');
INSERT INTO `site_lang` VALUES ('38', '40', 'Meet girls');
INSERT INTO `site_lang` VALUES ('39', '40', 'Meet boys');
INSERT INTO `site_lang` VALUES ('40', '40', 'Meet boys and girls');
INSERT INTO `site_lang` VALUES ('41', '40', 'Sign up');
INSERT INTO `site_lang` VALUES ('42', '40', 'By continuing, you are confirming that you have read and agree to our');
INSERT INTO `site_lang` VALUES ('43', '40', 'Terms and Conditions');
INSERT INTO `site_lang` VALUES ('44', '40', 'and');
INSERT INTO `site_lang` VALUES ('45', '40', 'Privacy Policy');
INSERT INTO `site_lang` VALUES ('46', '40', 'Profile');
INSERT INTO `site_lang` VALUES ('47', '40', 'Settings');
INSERT INTO `site_lang` VALUES ('48', '40', 'Logout');
INSERT INTO `site_lang` VALUES ('49', '40', 'Meet new people');
INSERT INTO `site_lang` VALUES ('50', '40', 'Discover');
INSERT INTO `site_lang` VALUES ('51', '40', 'Matches');
INSERT INTO `site_lang` VALUES ('52', '40', 'Most populars');
INSERT INTO `site_lang` VALUES ('53', '40', 'Fans');
INSERT INTO `site_lang` VALUES ('54', '40', 'Manage photos');
INSERT INTO `site_lang` VALUES ('55', '40', 'Settings');
INSERT INTO `site_lang` VALUES ('56', '40', 'All');
INSERT INTO `site_lang` VALUES ('57', '40', 'Fans');
INSERT INTO `site_lang` VALUES ('58', '40', 'Conversations');
INSERT INTO `site_lang` VALUES ('59', '40', 'Online now');
INSERT INTO `site_lang` VALUES ('60', '40', 'New messages');
INSERT INTO `site_lang` VALUES ('61', '40', 'Who to like');
INSERT INTO `site_lang` VALUES ('62', '40', 'Terms');
INSERT INTO `site_lang` VALUES ('63', '40', 'Privacy');
INSERT INTO `site_lang` VALUES ('64', '40', 'Contact');
INSERT INTO `site_lang` VALUES ('65', '40', 'Manage your photos');
INSERT INTO `site_lang` VALUES ('66', '40', 'All Photos');
INSERT INTO `site_lang` VALUES ('67', '40', 'Public Photos');
INSERT INTO `site_lang` VALUES ('68', '40', 'Private Photos');
INSERT INTO `site_lang` VALUES ('69', '40', 'Add your photos');
INSERT INTO `site_lang` VALUES ('70', '40', 'add photos');
INSERT INTO `site_lang` VALUES ('71', '40', 'Add yourself to the Spotlight');
INSERT INTO `site_lang` VALUES ('72', '40', 'Pick the photo you want to show in the Spotlight, cost ');
INSERT INTO `site_lang` VALUES ('73', '40', 'Credits');
INSERT INTO `site_lang` VALUES ('74', '40', 'Add photo');
INSERT INTO `site_lang` VALUES ('75', '40', 'Send gift to ');
INSERT INTO `site_lang` VALUES ('76', '40', 'Pick the gift you want to send to ');
INSERT INTO `site_lang` VALUES ('77', '40', 'Send gift');
INSERT INTO `site_lang` VALUES ('78', '40', 'Buy credits / Upgrade account');
INSERT INTO `site_lang` VALUES ('79', '40', 'Select credits package');
INSERT INTO `site_lang` VALUES ('80', '40', 'Select payment method');
INSERT INTO `site_lang` VALUES ('81', '40', 'Pay with');
INSERT INTO `site_lang` VALUES ('82', '40', 'Pay with');
INSERT INTO `site_lang` VALUES ('83', '40', 'Buy credits');
INSERT INTO `site_lang` VALUES ('84', '40', 'Premium Account Features');
INSERT INTO `site_lang` VALUES ('85', '40', 'new chats per day');
INSERT INTO `site_lang` VALUES ('86', '40', 'Unlimited videocalls');
INSERT INTO `site_lang` VALUES ('87', '40', 'Unblock all private photos');
INSERT INTO `site_lang` VALUES ('88', '40', 'Premium user badge');
INSERT INTO `site_lang` VALUES ('89', '40', 'Write text here');
INSERT INTO `site_lang` VALUES ('90', '40', 'Send');
INSERT INTO `site_lang` VALUES ('91', '40', 'Chat');
INSERT INTO `site_lang` VALUES ('92', '40', 'you have reached the limit of new daily conversations');
INSERT INTO `site_lang` VALUES ('93', '40', 'To continue chatting');
INSERT INTO `site_lang` VALUES ('94', '40', 'Buy');
INSERT INTO `site_lang` VALUES ('95', '40', 'more daily conversation');
INSERT INTO `site_lang` VALUES ('96', '40', 'or');
INSERT INTO `site_lang` VALUES ('97', '40', 'Upgrade your account to Premium');
INSERT INTO `site_lang` VALUES ('98', '40', 'and get up to');
INSERT INTO `site_lang` VALUES ('99', '40', 'daily conversations');
INSERT INTO `site_lang` VALUES ('100', '40', 'or wait until tomorrow for continue meeting people');
INSERT INTO `site_lang` VALUES ('101', '40', 'Your fans');
INSERT INTO `site_lang` VALUES ('102', '40', 'Privacy Policy');
INSERT INTO `site_lang` VALUES ('103', '40', 'Terms of Use');
INSERT INTO `site_lang` VALUES ('104', '40', 'Please complete your profile before start in ');
INSERT INTO `site_lang` VALUES ('105', '40', 'Your matches');
INSERT INTO `site_lang` VALUES ('106', '40', 'Filter Search');
INSERT INTO `site_lang` VALUES ('107', '40', 'All users');
INSERT INTO `site_lang` VALUES ('108', '40', 'Online now');
INSERT INTO `site_lang` VALUES ('109', '40', 'Show me');
INSERT INTO `site_lang` VALUES ('110', '40', 'Girls');
INSERT INTO `site_lang` VALUES ('111', '40', 'Boys');
INSERT INTO `site_lang` VALUES ('112', '40', 'Both');
INSERT INTO `site_lang` VALUES ('113', '40', 'who are between');
INSERT INTO `site_lang` VALUES ('114', '40', 'in a radius of');
INSERT INTO `site_lang` VALUES ('115', '40', 'World');
INSERT INTO `site_lang` VALUES ('116', '40', 'Most popular users');
INSERT INTO `site_lang` VALUES ('117', '40', 'About ');
INSERT INTO `site_lang` VALUES ('118', '40', 'Personal info');
INSERT INTO `site_lang` VALUES ('119', '40', 'years old');
INSERT INTO `site_lang` VALUES ('120', '40', 'Only boys');
INSERT INTO `site_lang` VALUES ('121', '40', 'Only girls');
INSERT INTO `site_lang` VALUES ('122', '40', 'boys and girls');
INSERT INTO `site_lang` VALUES ('123', '40', 'Credits successfully added to your account');
INSERT INTO `site_lang` VALUES ('124', '40', 'Now you have');
INSERT INTO `site_lang` VALUES ('125', '40', 'Ask permission to');
INSERT INTO `site_lang` VALUES ('126', '40', 'Unblock private photos');
INSERT INTO `site_lang` VALUES ('127', '40', 'Personal');
INSERT INTO `site_lang` VALUES ('128', '40', 'Credits');
INSERT INTO `site_lang` VALUES ('129', '40', 'Verify');
INSERT INTO `site_lang` VALUES ('130', '40', 'Change password');
INSERT INTO `site_lang` VALUES ('131', '40', 'Delete');
INSERT INTO `site_lang` VALUES ('132', '40', 'Personal information');
INSERT INTO `site_lang` VALUES ('133', '40', 'You can edit your profile information bellow');
INSERT INTO `site_lang` VALUES ('134', '40', 'Site language');
INSERT INTO `site_lang` VALUES ('135', '40', 'Update profile');
INSERT INTO `site_lang` VALUES ('136', '40', 'Verify account');
INSERT INTO `site_lang` VALUES ('137', '40', 'For verify your account , connect with your facebook account');
INSERT INTO `site_lang` VALUES ('138', '40', 'Connect with Facebook');
INSERT INTO `site_lang` VALUES ('139', '40', 'You are account is already verified');
INSERT INTO `site_lang` VALUES ('140', '40', 'Buy credits for send Gifs and Unblock private photos');
INSERT INTO `site_lang` VALUES ('141', '40', 'Account type');
INSERT INTO `site_lang` VALUES ('142', '40', 'Current credits');
INSERT INTO `site_lang` VALUES ('143', '40', 'Add credits');
INSERT INTO `site_lang` VALUES ('144', '40', 'Upgrade to premium account');
INSERT INTO `site_lang` VALUES ('145', '40', 'Change password');
INSERT INTO `site_lang` VALUES ('146', '40', 'You can change your current password bellow');
INSERT INTO `site_lang` VALUES ('147', '40', 'New password');
INSERT INTO `site_lang` VALUES ('148', '40', 'Profile desactivation');
INSERT INTO `site_lang` VALUES ('149', '40', 'After delete your profile, some of your data will be lost without recovery.');
INSERT INTO `site_lang` VALUES ('150', '40', 'Delete profile');
INSERT INTO `site_lang` VALUES ('151', '40', 'Online now');
INSERT INTO `site_lang` VALUES ('152', '40', 'Verified');
INSERT INTO `site_lang` VALUES ('153', '40', 'Nothing found');
INSERT INTO `site_lang` VALUES ('154', '40', 'people found');
INSERT INTO `site_lang` VALUES ('155', '40', 'No popular users near you');
INSERT INTO `site_lang` VALUES ('156', '40', 'You dont have any fans yet');
INSERT INTO `site_lang` VALUES ('157', '40', 'You dont have matches yet');
INSERT INTO `site_lang` VALUES ('158', '40', 'January');
INSERT INTO `site_lang` VALUES ('159', '40', 'February');
INSERT INTO `site_lang` VALUES ('160', '40', 'March');
INSERT INTO `site_lang` VALUES ('161', '40', 'April');
INSERT INTO `site_lang` VALUES ('162', '40', 'May');
INSERT INTO `site_lang` VALUES ('163', '40', 'June');
INSERT INTO `site_lang` VALUES ('164', '40', 'July');
INSERT INTO `site_lang` VALUES ('165', '40', 'August');
INSERT INTO `site_lang` VALUES ('166', '40', 'September');
INSERT INTO `site_lang` VALUES ('167', '40', 'October');
INSERT INTO `site_lang` VALUES ('168', '40', 'November');
INSERT INTO `site_lang` VALUES ('169', '40', 'December');
INSERT INTO `site_lang` VALUES ('170', '40', 'Buy');
INSERT INTO `site_lang` VALUES ('171', '40', 'Days Premium');
INSERT INTO `site_lang` VALUES ('172', '40', 'persons more like this');
INSERT INTO `site_lang` VALUES ('173', '40', 'like this');
INSERT INTO `site_lang` VALUES ('174', '40', 'Hello, can i have access to your private photos ?');
INSERT INTO `site_lang` VALUES ('175', '40', 'Yes');
INSERT INTO `site_lang` VALUES ('176', '40', 'No');
INSERT INTO `site_lang` VALUES ('177', '40', 'Hi');
INSERT INTO `site_lang` VALUES ('178', '40', 'If you dont remember your password, click the link below to set a new one:');
INSERT INTO `site_lang` VALUES ('179', '40', 'Login to my account');
INSERT INTO `site_lang` VALUES ('180', '40', 'Password recover');
INSERT INTO `site_lang` VALUES ('181', '40', 'Invalid email format');
INSERT INTO `site_lang` VALUES ('182', '40', 'Please fill all the inputs');
INSERT INTO `site_lang` VALUES ('183', '40', 'Email dont exist');
INSERT INTO `site_lang` VALUES ('184', '40', 'Wrong password');
INSERT INTO `site_lang` VALUES ('185', '40', 'Add a valid date');
INSERT INTO `site_lang` VALUES ('186', '40', 'Choose city from the autocomplete');
INSERT INTO `site_lang` VALUES ('187', '40', 'Password too short');
INSERT INTO `site_lang` VALUES ('188', '40', 'Email already exist, try another');
INSERT INTO `site_lang` VALUES ('189', '40', 'Yes, you can see my private photos');
INSERT INTO `site_lang` VALUES ('190', '40', 'No, i cant show you my private photos');
INSERT INTO `site_lang` VALUES ('191', '40', 'Buy private photos permission');
INSERT INTO `site_lang` VALUES ('192', '40', 'Get access to');
INSERT INTO `site_lang` VALUES ('193', '40', 'private photos for ');
INSERT INTO `site_lang` VALUES ('194', '40', 'Get access');
INSERT INTO `site_lang` VALUES ('195', '40', 'No thanks');
INSERT INTO `site_lang` VALUES ('196', '40', 'Please, select a payment method');
INSERT INTO `site_lang` VALUES ('197', '40', 'Please, select 1 photo');
INSERT INTO `site_lang` VALUES ('198', '40', 'Please, select 1 gift');
INSERT INTO `site_lang` VALUES ('199', '40', 'You dont have enought credits for send the gift');
INSERT INTO `site_lang` VALUES ('200', '40', 'Expand daily limitation ');
INSERT INTO `site_lang` VALUES ('201', '40', 'more daily conversation, cost ');
INSERT INTO `site_lang` VALUES ('202', '40', 'Yes, buy it!');
INSERT INTO `site_lang` VALUES ('203', '40', 'Information updated successfully');
INSERT INTO `site_lang` VALUES ('204', '40', 'Account termination');
INSERT INTO `site_lang` VALUES ('205', '40', 'Your data will be lost without recovery, continue?');
INSERT INTO `site_lang` VALUES ('206', '40', 'Yes, delete it!');
INSERT INTO `site_lang` VALUES ('207', '40', 'is in another videocall , you cant call now');
INSERT INTO `site_lang` VALUES ('208', '40', 'is offline, try again when your friend is online');
INSERT INTO `site_lang` VALUES ('209', '40', 'Please allow access to your Webcam.');
INSERT INTO `site_lang` VALUES ('210', '40', 'You are already in a videocall, you have to end the other call before start another');
INSERT INTO `site_lang` VALUES ('211', '40', 'Only premium users can make videocalls');
INSERT INTO `site_lang` VALUES ('212', '40', 'Impossible to make a call!');
INSERT INTO `site_lang` VALUES ('213', '40', 'You cant make videocall because you dont have webcam');
INSERT INTO `site_lang` VALUES ('214', '40', 'Too long wait');
INSERT INTO `site_lang` VALUES ('215', '40', 'Seems that your friend do not have webcam or he is not available');
INSERT INTO `site_lang` VALUES ('216', '40', 'End call');
INSERT INTO `site_lang` VALUES ('217', '40', 'Wait more');
INSERT INTO `site_lang` VALUES ('218', '40', 'until');
INSERT INTO `site_lang` VALUES ('219', '40', 'Basic');
INSERT INTO `site_lang` VALUES ('220', '40', 'UPGRADE');
INSERT INTO `site_lang` VALUES ('221', '40', 'Notifications');
INSERT INTO `site_lang` VALUES ('222', '40', 'Extended info (optional)');
INSERT INTO `site_lang` VALUES ('223', '40', 'Relationship');
INSERT INTO `site_lang` VALUES ('224', '40', 'Single');
INSERT INTO `site_lang` VALUES ('225', '40', 'Taken');
INSERT INTO `site_lang` VALUES ('226', '40', 'Open');
INSERT INTO `site_lang` VALUES ('227', '40', 'Sexuality');
INSERT INTO `site_lang` VALUES ('228', '40', 'Gay');
INSERT INTO `site_lang` VALUES ('229', '40', 'Open-minded');
INSERT INTO `site_lang` VALUES ('230', '40', 'Straight');
INSERT INTO `site_lang` VALUES ('231', '40', 'Bisexual');
INSERT INTO `site_lang` VALUES ('232', '40', 'Height');
INSERT INTO `site_lang` VALUES ('233', '40', 'less than');
INSERT INTO `site_lang` VALUES ('234', '40', 'more than');
INSERT INTO `site_lang` VALUES ('235', '40', 'Weight');
INSERT INTO `site_lang` VALUES ('236', '40', 'Ethnicity');
INSERT INTO `site_lang` VALUES ('237', '40', 'Asian');
INSERT INTO `site_lang` VALUES ('238', '40', 'Middle Eastern');
INSERT INTO `site_lang` VALUES ('239', '40', 'Black');
INSERT INTO `site_lang` VALUES ('240', '40', 'White');
INSERT INTO `site_lang` VALUES ('241', '40', 'Native American');
INSERT INTO `site_lang` VALUES ('242', '40', 'Hispanic/latin');
INSERT INTO `site_lang` VALUES ('243', '40', 'Pacific Islander');
INSERT INTO `site_lang` VALUES ('244', '40', 'Indian');
INSERT INTO `site_lang` VALUES ('245', '40', 'Other');
INSERT INTO `site_lang` VALUES ('246', '40', 'Body type');
INSERT INTO `site_lang` VALUES ('247', '40', 'Slim');
INSERT INTO `site_lang` VALUES ('248', '40', 'Average');
INSERT INTO `site_lang` VALUES ('249', '40', 'Athletic');
INSERT INTO `site_lang` VALUES ('250', '40', 'Heavy set');
INSERT INTO `site_lang` VALUES ('251', '40', 'Curvy');
INSERT INTO `site_lang` VALUES ('252', '40', 'Living');
INSERT INTO `site_lang` VALUES ('253', '40', 'With parents');
INSERT INTO `site_lang` VALUES ('254', '40', 'With housemate');
INSERT INTO `site_lang` VALUES ('255', '40', 'Student dormitory');
INSERT INTO `site_lang` VALUES ('256', '40', 'With partner');
INSERT INTO `site_lang` VALUES ('257', '40', 'Alone');
INSERT INTO `site_lang` VALUES ('258', '40', 'Smoke');
INSERT INTO `site_lang` VALUES ('259', '40', 'Yes');
INSERT INTO `site_lang` VALUES ('260', '40', 'No');
INSERT INTO `site_lang` VALUES ('261', '40', 'Sometimes');
INSERT INTO `site_lang` VALUES ('262', '40', 'Drink');
INSERT INTO `site_lang` VALUES ('263', '40', 'Transport');
INSERT INTO `site_lang` VALUES ('264', '40', 'Parents car');
INSERT INTO `site_lang` VALUES ('265', '40', 'I own a car');
INSERT INTO `site_lang` VALUES ('266', '40', 'I own a motorbike');
INSERT INTO `site_lang` VALUES ('267', '40', 'None');
INSERT INTO `site_lang` VALUES ('268', '40', 'When someone likes me');
INSERT INTO `site_lang` VALUES ('269', '40', 'When i get a match');
INSERT INTO `site_lang` VALUES ('270', '40', 'When new users near me join in');
INSERT INTO `site_lang` VALUES ('271', '40', 'When someone send me a message');
INSERT INTO `site_lang` VALUES ('272', '40', 'Day');
INSERT INTO `site_lang` VALUES ('273', '40', 'Month');
INSERT INTO `site_lang` VALUES ('274', '40', 'Year');
INSERT INTO `site_lang` VALUES ('275', '40', 'Please wait');
INSERT INTO `site_lang` VALUES ('276', '40', 'Interests');
INSERT INTO `site_lang` VALUES ('277', '40', 'Report');
INSERT INTO `site_lang` VALUES ('278', '40', 'Fans');
INSERT INTO `site_lang` VALUES ('279', '40', 'No data');
INSERT INTO `site_lang` VALUES ('280', '40', 'Public Photos');
INSERT INTO `site_lang` VALUES ('281', '40', 'Private photos');
INSERT INTO `site_lang` VALUES ('282', '40', 'Add from ');
INSERT INTO `site_lang` VALUES ('283', '40', 'Add');
INSERT INTO `site_lang` VALUES ('284', '40', 'Photos');
INSERT INTO `site_lang` VALUES ('285', '40', 'Credits');
INSERT INTO `site_lang` VALUES ('286', '40', 'Visits');
INSERT INTO `site_lang` VALUES ('287', '40', 'Add me here');
INSERT INTO `site_lang` VALUES ('288', '40', 'get seen by millions');
INSERT INTO `site_lang` VALUES ('289', '40', 'Set as profile');
INSERT INTO `site_lang` VALUES ('290', '40', 'Private photo');
INSERT INTO `site_lang` VALUES ('291', '40', 'Public photo');
INSERT INTO `site_lang` VALUES ('292', '40', 'Delete');
INSERT INTO `site_lang` VALUES ('293', '40', 'people visited your profile for see them');
INSERT INTO `site_lang` VALUES ('294', '40', 'Upgrade your account to premium');
INSERT INTO `site_lang` VALUES ('295', '40', 'People i like');
INSERT INTO `site_lang` VALUES ('296', '40', 'people liked you, for see them');
INSERT INTO `site_lang` VALUES ('297', '40', 'Messages');
INSERT INTO `site_lang` VALUES ('298', '40', 'Like');
INSERT INTO `site_lang` VALUES ('299', '40', 'Dislike');
INSERT INTO `site_lang` VALUES ('300', '40', 'AGE');
INSERT INTO `site_lang` VALUES ('301', '40', 'You dont have any visit yet');
INSERT INTO `site_lang` VALUES ('302', '40', 'visited');
INSERT INTO `site_lang` VALUES ('303', '40', 'You do not like anyone');
INSERT INTO `site_lang` VALUES ('304', '40', 'Cost');
INSERT INTO `site_lang` VALUES ('305', '40', 'Credits for $');
INSERT INTO `site_lang` VALUES ('306', '40', '0 seconds');
INSERT INTO `site_lang` VALUES ('307', '40', 'year');
INSERT INTO `site_lang` VALUES ('308', '40', 'month');
INSERT INTO `site_lang` VALUES ('309', '40', 'day');
INSERT INTO `site_lang` VALUES ('310', '40', 'hour');
INSERT INTO `site_lang` VALUES ('311', '40', 'minute');
INSERT INTO `site_lang` VALUES ('312', '40', 'second');
INSERT INTO `site_lang` VALUES ('313', '40', 'years');
INSERT INTO `site_lang` VALUES ('314', '40', 'months');
INSERT INTO `site_lang` VALUES ('315', '40', 'days');
INSERT INTO `site_lang` VALUES ('316', '40', 'hours');
INSERT INTO `site_lang` VALUES ('317', '40', 'minutes');
INSERT INTO `site_lang` VALUES ('318', '40', 'seconds');
INSERT INTO `site_lang` VALUES ('319', '40', 'ago');
INSERT INTO `site_lang` VALUES ('320', '40', 'Please verify your account, check your email');
INSERT INTO `site_lang` VALUES ('321', '40', 'Please add a profile photo');
INSERT INTO `site_lang` VALUES ('322', '40', 'Hi, im');
INSERT INTO `site_lang` VALUES ('323', '40', 'years old and im from');
INSERT INTO `site_lang` VALUES ('324', '40', 'We sended you a email for verify your account');
INSERT INTO `site_lang` VALUES ('325', '40', 'is blocking you or you blocked him, you cant chat with him sorry');
INSERT INTO `site_lang` VALUES ('326', '40', 'Report and block');
INSERT INTO `site_lang` VALUES ('327', '40', 'Are you sure you want to report');
INSERT INTO `site_lang` VALUES ('328', '40', 'Press backspace key for smart return to the meeting section.');
INSERT INTO `site_lang` VALUES ('329', '40', 'Write your instagram username');
INSERT INTO `site_lang` VALUES ('330', '40', 'You need to write your username!');
INSERT INTO `site_lang` VALUES ('331', '40', 'username');
INSERT INTO `site_lang` VALUES ('332', '40', 'days of Premium');
INSERT INTO `site_lang` VALUES ('333', '40', 'Wrong');
INSERT INTO `site_lang` VALUES ('334', '40', 'Spotlight');
INSERT INTO `site_lang` VALUES ('335', '40', 'Service cost');
INSERT INTO `site_lang` VALUES ('336', '40', 'Password successfully changed');
INSERT INTO `site_lang` VALUES ('337', '40', 'is calling you..');
INSERT INTO `site_lang` VALUES ('338', '40', 'Photos of ');
INSERT INTO `site_lang` VALUES ('339', '40', 'of');
INSERT INTO `site_lang` VALUES ('340', '40', 'Loading...');
INSERT INTO `site_lang` VALUES ('341', '40', 'We sent you a email with your info, it may take up to 1 min to arrive');
INSERT INTO `site_lang` VALUES ('342', '40', 'likes you and wants to chat in');
INSERT INTO `site_lang` VALUES ('343', '40', 'has seen you in discover and likes. The feeling is mutual?');
INSERT INTO `site_lang` VALUES ('344', '40', 'Find out if you also like');
INSERT INTO `site_lang` VALUES ('345', '40', 'You received this notice because you registered as');
INSERT INTO `site_lang` VALUES ('346', '40', 'Unsubscribe');
INSERT INTO `site_lang` VALUES ('347', '40', 'Choose a new password');
INSERT INTO `site_lang` VALUES ('348', '40', 'if you forgot your password, click on the link below to get a new');
INSERT INTO `site_lang` VALUES ('349', '40', 'You have a match at');
INSERT INTO `site_lang` VALUES ('350', '40', 'Its a match!');
INSERT INTO `site_lang` VALUES ('351', '40', 'thinks the feeling is mutual');
INSERT INTO `site_lang` VALUES ('352', '40', 'Go and say something to');
INSERT INTO `site_lang` VALUES ('353', '40', 'New message from');
INSERT INTO `site_lang` VALUES ('354', '40', 'you have a new message from');
INSERT INTO `site_lang` VALUES ('355', '40', 'Respond to');
INSERT INTO `site_lang` VALUES ('356', '40', 'Have fun!');
INSERT INTO `site_lang` VALUES ('357', '40', 'is new and lives closer to you');
INSERT INTO `site_lang` VALUES ('358', '40', 'is new at');
INSERT INTO `site_lang` VALUES ('359', '40', 'and lives closer to you');
INSERT INTO `site_lang` VALUES ('360', '40', 'Check out the profile');
INSERT INTO `site_lang` VALUES ('361', '40', 'Welcome');
INSERT INTO `site_lang` VALUES ('362', '40', 'Well done, now you are in');
INSERT INTO `site_lang` VALUES ('363', '40', 'Here are a few tips');
INSERT INTO `site_lang` VALUES ('364', '40', 'Now you are a new member of');
INSERT INTO `site_lang` VALUES ('365', '40', 'Verify your account');
INSERT INTO `site_lang` VALUES ('366', '40', 'Newsflash');
INSERT INTO `site_lang` VALUES ('367', '40', 'people in your area wants to know you');
INSERT INTO `site_lang` VALUES ('368', '40', 'In');
INSERT INTO `site_lang` VALUES ('369', '40', 'you can meet people instantly');
INSERT INTO `site_lang` VALUES ('370', '40', 'Meet new people');
INSERT INTO `site_lang` VALUES ('371', '40', 'Nobody is going to fall in love with a blank page. The more information you get, the more chances to find that special someone!');
INSERT INTO `site_lang` VALUES ('372', '40', 'Add photos and complete your profile');
INSERT INTO `site_lang` VALUES ('373', '40', 'More than 1 million people have joined $site_name You probably want to know some of them.');
INSERT INTO `site_lang` VALUES ('374', '40', 'Start meeting new people now');
INSERT INTO `site_lang` VALUES ('375', '40', 'Here are your connection details');
INSERT INTO `site_lang` VALUES ('376', '40', 'E-mail');
INSERT INTO `site_lang` VALUES ('377', '40', 'Password');
INSERT INTO `site_lang` VALUES ('378', '40', 'Please save your connection information in a safe place');
INSERT INTO `site_lang` VALUES ('379', '40', 'Go to');
INSERT INTO `site_lang` VALUES ('380', '40', 'Welcome to');
INSERT INTO `site_lang` VALUES ('381', '40', 'calling...');
INSERT INTO `site_lang` VALUES ('382', '40', 'dont like you');
INSERT INTO `site_lang` VALUES ('383', '40', 'must like you for start a videocall');
INSERT INTO `site_lang` VALUES ('384', '40', 'Ok, i understand');
INSERT INTO `site_lang` VALUES ('0', '41', 'meet new people!');
INSERT INTO `site_lang` VALUES ('1', '41', 'Login');
INSERT INTO `site_lang` VALUES ('2', '41', 'Welcome to the fastest growing place to meet new people');
INSERT INTO `site_lang` VALUES ('3', '41', 'For now our site works only for Desktop users');
INSERT INTO `site_lang` VALUES ('4', '41', 'Please visit us from your laptop or PC');
INSERT INTO `site_lang` VALUES ('5', '41', 'Soon we will have our phone apps online');
INSERT INTO `site_lang` VALUES ('6', '41', 'SOON AVAILABLE');
INSERT INTO `site_lang` VALUES ('7', '41', 'Connect with ');
INSERT INTO `site_lang` VALUES ('8', '41', 'Create your account');
INSERT INTO `site_lang` VALUES ('9', '41', 'Welcome back');
INSERT INTO `site_lang` VALUES ('10', '41', 'Your email');
INSERT INTO `site_lang` VALUES ('11', '41', 'Your password');
INSERT INTO `site_lang` VALUES ('12', '41', 'do you forget your password?');
INSERT INTO `site_lang` VALUES ('13', '41', 'Login now');
INSERT INTO `site_lang` VALUES ('14', '41', 'Password recover');
INSERT INTO `site_lang` VALUES ('15', '41', 'Recover password');
INSERT INTO `site_lang` VALUES ('16', '41', 'Chat');
INSERT INTO `site_lang` VALUES ('17', '41', 'Powerfull private chat for meet new friends, you can send emoticons and private photos to anyone.');
INSERT INTO `site_lang` VALUES ('18', '41', 'Video Chat');
INSERT INTO `site_lang` VALUES ('19', '41', 'You can make quality videocalls for free to anyone, without limits of call duration, just enjoy seeing the person who is chatting with you');
INSERT INTO `site_lang` VALUES ('20', '41', 'People nearby');
INSERT INTO `site_lang` VALUES ('21', '41', 'We wont show your exact location, but you will be able to find people nearby who like the same things you do.');
INSERT INTO `site_lang` VALUES ('22', '41', 'Matches');
INSERT INTO `site_lang` VALUES ('23', '41', 'Play our popular Discover game and get matched with other users. Its a great way to break the ice and chat to new people.');
INSERT INTO `site_lang` VALUES ('24', '41', 'Become a member now');
INSERT INTO `site_lang` VALUES ('25', '41', 'Join the worlds bestest community for meeting new people!.');
INSERT INTO `site_lang` VALUES ('26', '41', 'Name');
INSERT INTO `site_lang` VALUES ('27', '41', 'Your name or nickname');
INSERT INTO `site_lang` VALUES ('28', '41', 'Email');
INSERT INTO `site_lang` VALUES ('29', '41', 'Password');
INSERT INTO `site_lang` VALUES ('30', '41', 'Birthday');
INSERT INTO `site_lang` VALUES ('31', '41', 'Please select');
INSERT INTO `site_lang` VALUES ('32', '41', 'City');
INSERT INTO `site_lang` VALUES ('33', '41', 'Where do you live?');
INSERT INTO `site_lang` VALUES ('34', '41', 'Gender');
INSERT INTO `site_lang` VALUES ('35', '41', 'Male');
INSERT INTO `site_lang` VALUES ('36', '41', 'Female');
INSERT INTO `site_lang` VALUES ('37', '41', 'Im here to');
INSERT INTO `site_lang` VALUES ('38', '41', 'Meet girls');
INSERT INTO `site_lang` VALUES ('39', '41', 'Meet boys');
INSERT INTO `site_lang` VALUES ('40', '41', 'Meet boys and girls');
INSERT INTO `site_lang` VALUES ('41', '41', 'Sign up');
INSERT INTO `site_lang` VALUES ('42', '41', 'By continuing, you are confirming that you have read and agree to our');
INSERT INTO `site_lang` VALUES ('43', '41', 'Terms and Conditions');
INSERT INTO `site_lang` VALUES ('44', '41', 'and');
INSERT INTO `site_lang` VALUES ('45', '41', 'Privacy Policy');
INSERT INTO `site_lang` VALUES ('46', '41', 'Profile');
INSERT INTO `site_lang` VALUES ('47', '41', 'Settings');
INSERT INTO `site_lang` VALUES ('48', '41', 'Logout');
INSERT INTO `site_lang` VALUES ('49', '41', 'Meet new people');
INSERT INTO `site_lang` VALUES ('50', '41', 'Discover');
INSERT INTO `site_lang` VALUES ('51', '41', 'Matches');
INSERT INTO `site_lang` VALUES ('52', '41', 'Most populars');
INSERT INTO `site_lang` VALUES ('53', '41', 'Fans');
INSERT INTO `site_lang` VALUES ('54', '41', 'Manage photos');
INSERT INTO `site_lang` VALUES ('55', '41', 'Settings');
INSERT INTO `site_lang` VALUES ('56', '41', 'All');
INSERT INTO `site_lang` VALUES ('57', '41', 'Fans');
INSERT INTO `site_lang` VALUES ('58', '41', 'Conversations');
INSERT INTO `site_lang` VALUES ('59', '41', 'Online now');
INSERT INTO `site_lang` VALUES ('60', '41', 'New messages');
INSERT INTO `site_lang` VALUES ('61', '41', 'Who to like');
INSERT INTO `site_lang` VALUES ('62', '41', 'Terms');
INSERT INTO `site_lang` VALUES ('63', '41', 'Privacy');
INSERT INTO `site_lang` VALUES ('64', '41', 'Contact');
INSERT INTO `site_lang` VALUES ('65', '41', 'Manage your photos');
INSERT INTO `site_lang` VALUES ('66', '41', 'All Photos');
INSERT INTO `site_lang` VALUES ('67', '41', 'Public Photos');
INSERT INTO `site_lang` VALUES ('68', '41', 'Private Photos');
INSERT INTO `site_lang` VALUES ('69', '41', 'Add your photos');
INSERT INTO `site_lang` VALUES ('70', '41', 'add photos');
INSERT INTO `site_lang` VALUES ('71', '41', 'Add yourself to the Spotlight');
INSERT INTO `site_lang` VALUES ('72', '41', 'Pick the photo you want to show in the Spotlight, cost ');
INSERT INTO `site_lang` VALUES ('73', '41', 'Credits');
INSERT INTO `site_lang` VALUES ('74', '41', 'Add photo');
INSERT INTO `site_lang` VALUES ('75', '41', 'Send gift to ');
INSERT INTO `site_lang` VALUES ('76', '41', 'Pick the gift you want to send to ');
INSERT INTO `site_lang` VALUES ('77', '41', 'Send gift');
INSERT INTO `site_lang` VALUES ('78', '41', 'Buy credits / Upgrade account');
INSERT INTO `site_lang` VALUES ('79', '41', 'Select credits package');
INSERT INTO `site_lang` VALUES ('80', '41', 'Select payment method');
INSERT INTO `site_lang` VALUES ('81', '41', 'Pay with');
INSERT INTO `site_lang` VALUES ('82', '41', 'Pay with');
INSERT INTO `site_lang` VALUES ('83', '41', 'Buy credits');
INSERT INTO `site_lang` VALUES ('84', '41', 'Premium Account Features');
INSERT INTO `site_lang` VALUES ('85', '41', 'new chats per day');
INSERT INTO `site_lang` VALUES ('86', '41', 'Unlimited videocalls');
INSERT INTO `site_lang` VALUES ('87', '41', 'Unblock all private photos');
INSERT INTO `site_lang` VALUES ('88', '41', 'Premium user badge');
INSERT INTO `site_lang` VALUES ('89', '41', 'Write text here');
INSERT INTO `site_lang` VALUES ('90', '41', 'Send');
INSERT INTO `site_lang` VALUES ('91', '41', 'Chat');
INSERT INTO `site_lang` VALUES ('92', '41', 'you have reached the limit of new daily conversations');
INSERT INTO `site_lang` VALUES ('93', '41', 'To continue chatting');
INSERT INTO `site_lang` VALUES ('94', '41', 'Buy');
INSERT INTO `site_lang` VALUES ('95', '41', 'more daily conversation');
INSERT INTO `site_lang` VALUES ('96', '41', 'or');
INSERT INTO `site_lang` VALUES ('97', '41', 'Upgrade your account to Premium');
INSERT INTO `site_lang` VALUES ('98', '41', 'and get up to');
INSERT INTO `site_lang` VALUES ('99', '41', 'daily conversations');
INSERT INTO `site_lang` VALUES ('100', '41', 'or wait until tomorrow for continue meeting people');
INSERT INTO `site_lang` VALUES ('101', '41', 'Your fans');
INSERT INTO `site_lang` VALUES ('102', '41', 'Privacy Policy');
INSERT INTO `site_lang` VALUES ('103', '41', 'Terms of Use');
INSERT INTO `site_lang` VALUES ('104', '41', 'Please complete your profile before start in ');
INSERT INTO `site_lang` VALUES ('105', '41', 'Your matches');
INSERT INTO `site_lang` VALUES ('106', '41', 'Filter Search');
INSERT INTO `site_lang` VALUES ('107', '41', 'All users');
INSERT INTO `site_lang` VALUES ('108', '41', 'Online now');
INSERT INTO `site_lang` VALUES ('109', '41', 'Show me');
INSERT INTO `site_lang` VALUES ('110', '41', 'Girls');
INSERT INTO `site_lang` VALUES ('111', '41', 'Boys');
INSERT INTO `site_lang` VALUES ('112', '41', 'Both');
INSERT INTO `site_lang` VALUES ('113', '41', 'who are between');
INSERT INTO `site_lang` VALUES ('114', '41', 'in a radius of');
INSERT INTO `site_lang` VALUES ('115', '41', 'World');
INSERT INTO `site_lang` VALUES ('116', '41', 'Most popular users');
INSERT INTO `site_lang` VALUES ('117', '41', 'About ');
INSERT INTO `site_lang` VALUES ('118', '41', 'Personal info');
INSERT INTO `site_lang` VALUES ('119', '41', 'years old');
INSERT INTO `site_lang` VALUES ('120', '41', 'Only boys');
INSERT INTO `site_lang` VALUES ('121', '41', 'Only girls');
INSERT INTO `site_lang` VALUES ('122', '41', 'boys and girls');
INSERT INTO `site_lang` VALUES ('123', '41', 'Credits successfully added to your account');
INSERT INTO `site_lang` VALUES ('124', '41', 'Now you have');
INSERT INTO `site_lang` VALUES ('125', '41', 'Ask permission to');
INSERT INTO `site_lang` VALUES ('126', '41', 'Unblock private photos');
INSERT INTO `site_lang` VALUES ('127', '41', 'Personal');
INSERT INTO `site_lang` VALUES ('128', '41', 'Credits');
INSERT INTO `site_lang` VALUES ('129', '41', 'Verify');
INSERT INTO `site_lang` VALUES ('130', '41', 'Change password');
INSERT INTO `site_lang` VALUES ('131', '41', 'Delete');
INSERT INTO `site_lang` VALUES ('132', '41', 'Personal information');
INSERT INTO `site_lang` VALUES ('133', '41', 'You can edit your profile information bellow');
INSERT INTO `site_lang` VALUES ('134', '41', 'Site language');
INSERT INTO `site_lang` VALUES ('135', '41', 'Update profile');
INSERT INTO `site_lang` VALUES ('136', '41', 'Verify account');
INSERT INTO `site_lang` VALUES ('137', '41', 'For verify your account , connect with your facebook account');
INSERT INTO `site_lang` VALUES ('138', '41', 'Connect with Facebook');
INSERT INTO `site_lang` VALUES ('139', '41', 'You are account is already verified');
INSERT INTO `site_lang` VALUES ('140', '41', 'Buy credits for send Gifs and Unblock private photos');
INSERT INTO `site_lang` VALUES ('141', '41', 'Account type');
INSERT INTO `site_lang` VALUES ('142', '41', 'Current credits');
INSERT INTO `site_lang` VALUES ('143', '41', 'Add credits');
INSERT INTO `site_lang` VALUES ('144', '41', 'Upgrade to premium account');
INSERT INTO `site_lang` VALUES ('145', '41', 'Change password');
INSERT INTO `site_lang` VALUES ('146', '41', 'You can change your current password bellow');
INSERT INTO `site_lang` VALUES ('147', '41', 'New password');
INSERT INTO `site_lang` VALUES ('148', '41', 'Profile desactivation');
INSERT INTO `site_lang` VALUES ('149', '41', 'After delete your profile, some of your data will be lost without recovery.');
INSERT INTO `site_lang` VALUES ('150', '41', 'Delete profile');
INSERT INTO `site_lang` VALUES ('151', '41', 'Online now');
INSERT INTO `site_lang` VALUES ('152', '41', 'Verified');
INSERT INTO `site_lang` VALUES ('153', '41', 'Nothing found');
INSERT INTO `site_lang` VALUES ('154', '41', 'people found');
INSERT INTO `site_lang` VALUES ('155', '41', 'No popular users near you');
INSERT INTO `site_lang` VALUES ('156', '41', 'You dont have any fans yet');
INSERT INTO `site_lang` VALUES ('157', '41', 'You dont have matches yet');
INSERT INTO `site_lang` VALUES ('158', '41', 'January');
INSERT INTO `site_lang` VALUES ('159', '41', 'February');
INSERT INTO `site_lang` VALUES ('160', '41', 'March');
INSERT INTO `site_lang` VALUES ('161', '41', 'April');
INSERT INTO `site_lang` VALUES ('162', '41', 'May');
INSERT INTO `site_lang` VALUES ('163', '41', 'June');
INSERT INTO `site_lang` VALUES ('164', '41', 'July');
INSERT INTO `site_lang` VALUES ('165', '41', 'August');
INSERT INTO `site_lang` VALUES ('166', '41', 'September');
INSERT INTO `site_lang` VALUES ('167', '41', 'October');
INSERT INTO `site_lang` VALUES ('168', '41', 'November');
INSERT INTO `site_lang` VALUES ('169', '41', 'December');
INSERT INTO `site_lang` VALUES ('170', '41', 'Buy');
INSERT INTO `site_lang` VALUES ('171', '41', 'Days Premium');
INSERT INTO `site_lang` VALUES ('172', '41', 'persons more like this');
INSERT INTO `site_lang` VALUES ('173', '41', 'like this');
INSERT INTO `site_lang` VALUES ('174', '41', 'Hello, can i have access to your private photos ?');
INSERT INTO `site_lang` VALUES ('175', '41', 'Yes');
INSERT INTO `site_lang` VALUES ('176', '41', 'No');
INSERT INTO `site_lang` VALUES ('177', '41', 'Hi');
INSERT INTO `site_lang` VALUES ('178', '41', 'If you dont remember your password, click the link below to set a new one:');
INSERT INTO `site_lang` VALUES ('179', '41', 'Login to my account');
INSERT INTO `site_lang` VALUES ('180', '41', 'Password recover');
INSERT INTO `site_lang` VALUES ('181', '41', 'Invalid email format');
INSERT INTO `site_lang` VALUES ('182', '41', 'Please fill all the inputs');
INSERT INTO `site_lang` VALUES ('183', '41', 'Email dont exist');
INSERT INTO `site_lang` VALUES ('184', '41', 'Wrong password');
INSERT INTO `site_lang` VALUES ('185', '41', 'Add a valid date');
INSERT INTO `site_lang` VALUES ('186', '41', 'Choose city from the autocomplete');
INSERT INTO `site_lang` VALUES ('187', '41', 'Password too short');
INSERT INTO `site_lang` VALUES ('188', '41', 'Email already exist, try another');
INSERT INTO `site_lang` VALUES ('189', '41', 'Yes, you can see my private photos');
INSERT INTO `site_lang` VALUES ('190', '41', 'No, i cant show you my private photos');
INSERT INTO `site_lang` VALUES ('191', '41', 'Buy private photos permission');
INSERT INTO `site_lang` VALUES ('192', '41', 'Get access to');
INSERT INTO `site_lang` VALUES ('193', '41', 'private photos for ');
INSERT INTO `site_lang` VALUES ('194', '41', 'Get access');
INSERT INTO `site_lang` VALUES ('195', '41', 'No thanks');
INSERT INTO `site_lang` VALUES ('196', '41', 'Please, select a payment method');
INSERT INTO `site_lang` VALUES ('197', '41', 'Please, select 1 photo');
INSERT INTO `site_lang` VALUES ('198', '41', 'Please, select 1 gift');
INSERT INTO `site_lang` VALUES ('199', '41', 'You dont have enought credits for send the gift');
INSERT INTO `site_lang` VALUES ('200', '41', 'Expand daily limitation ');
INSERT INTO `site_lang` VALUES ('201', '41', 'more daily conversation, cost ');
INSERT INTO `site_lang` VALUES ('202', '41', 'Yes, buy it!');
INSERT INTO `site_lang` VALUES ('203', '41', 'Information updated successfully');
INSERT INTO `site_lang` VALUES ('204', '41', 'Account termination');
INSERT INTO `site_lang` VALUES ('205', '41', 'Your data will be lost without recovery, continue?');
INSERT INTO `site_lang` VALUES ('206', '41', 'Yes, delete it!');
INSERT INTO `site_lang` VALUES ('207', '41', 'is in another videocall , you cant call now');
INSERT INTO `site_lang` VALUES ('208', '41', 'is offline, try again when your friend is online');
INSERT INTO `site_lang` VALUES ('209', '41', 'Please allow access to your Webcam.');
INSERT INTO `site_lang` VALUES ('210', '41', 'You are already in a videocall, you have to end the other call before start another');
INSERT INTO `site_lang` VALUES ('211', '41', 'Only premium users can make videocalls');
INSERT INTO `site_lang` VALUES ('212', '41', 'Impossible to make a call!');
INSERT INTO `site_lang` VALUES ('213', '41', 'You cant make videocall because you dont have webcam');
INSERT INTO `site_lang` VALUES ('214', '41', 'Too long wait');
INSERT INTO `site_lang` VALUES ('215', '41', 'Seems that your friend do not have webcam or he is not available');
INSERT INTO `site_lang` VALUES ('216', '41', 'End call');
INSERT INTO `site_lang` VALUES ('217', '41', 'Wait more');
INSERT INTO `site_lang` VALUES ('218', '41', 'until');
INSERT INTO `site_lang` VALUES ('219', '41', 'Basic');
INSERT INTO `site_lang` VALUES ('220', '41', 'UPGRADE');
INSERT INTO `site_lang` VALUES ('221', '41', 'Notifications');
INSERT INTO `site_lang` VALUES ('222', '41', 'Extended info (optional)');
INSERT INTO `site_lang` VALUES ('223', '41', 'Relationship');
INSERT INTO `site_lang` VALUES ('224', '41', 'Single');
INSERT INTO `site_lang` VALUES ('225', '41', 'Taken');
INSERT INTO `site_lang` VALUES ('226', '41', 'Open');
INSERT INTO `site_lang` VALUES ('227', '41', 'Sexuality');
INSERT INTO `site_lang` VALUES ('228', '41', 'Gay');
INSERT INTO `site_lang` VALUES ('229', '41', 'Open-minded');
INSERT INTO `site_lang` VALUES ('230', '41', 'Straight');
INSERT INTO `site_lang` VALUES ('231', '41', 'Bisexual');
INSERT INTO `site_lang` VALUES ('232', '41', 'Height');
INSERT INTO `site_lang` VALUES ('233', '41', 'less than');
INSERT INTO `site_lang` VALUES ('234', '41', 'more than');
INSERT INTO `site_lang` VALUES ('235', '41', 'Weight');
INSERT INTO `site_lang` VALUES ('236', '41', 'Ethnicity');
INSERT INTO `site_lang` VALUES ('237', '41', 'Asian');
INSERT INTO `site_lang` VALUES ('238', '41', 'Middle Eastern');
INSERT INTO `site_lang` VALUES ('239', '41', 'Black');
INSERT INTO `site_lang` VALUES ('240', '41', 'White');
INSERT INTO `site_lang` VALUES ('241', '41', 'Native American');
INSERT INTO `site_lang` VALUES ('242', '41', 'Hispanic/latin');
INSERT INTO `site_lang` VALUES ('243', '41', 'Pacific Islander');
INSERT INTO `site_lang` VALUES ('244', '41', 'Indian');
INSERT INTO `site_lang` VALUES ('245', '41', 'Other');
INSERT INTO `site_lang` VALUES ('246', '41', 'Body type');
INSERT INTO `site_lang` VALUES ('247', '41', 'Slim');
INSERT INTO `site_lang` VALUES ('248', '41', 'Average');
INSERT INTO `site_lang` VALUES ('249', '41', 'Athletic');
INSERT INTO `site_lang` VALUES ('250', '41', 'Heavy set');
INSERT INTO `site_lang` VALUES ('251', '41', 'Curvy');
INSERT INTO `site_lang` VALUES ('252', '41', 'Living');
INSERT INTO `site_lang` VALUES ('253', '41', 'With parents');
INSERT INTO `site_lang` VALUES ('254', '41', 'With housemate');
INSERT INTO `site_lang` VALUES ('255', '41', 'Student dormitory');
INSERT INTO `site_lang` VALUES ('256', '41', 'With partner');
INSERT INTO `site_lang` VALUES ('257', '41', 'Alone');
INSERT INTO `site_lang` VALUES ('258', '41', 'Smoke');
INSERT INTO `site_lang` VALUES ('259', '41', 'Yes');
INSERT INTO `site_lang` VALUES ('260', '41', 'No');
INSERT INTO `site_lang` VALUES ('261', '41', 'Sometimes');
INSERT INTO `site_lang` VALUES ('262', '41', 'Drink');
INSERT INTO `site_lang` VALUES ('263', '41', 'Transport');
INSERT INTO `site_lang` VALUES ('264', '41', 'Parents car');
INSERT INTO `site_lang` VALUES ('265', '41', 'I own a car');
INSERT INTO `site_lang` VALUES ('266', '41', 'I own a motorbike');
INSERT INTO `site_lang` VALUES ('267', '41', 'None');
INSERT INTO `site_lang` VALUES ('268', '41', 'When someone likes me');
INSERT INTO `site_lang` VALUES ('269', '41', 'When i get a match');
INSERT INTO `site_lang` VALUES ('270', '41', 'When new users near me join in');
INSERT INTO `site_lang` VALUES ('271', '41', 'When someone send me a message');
INSERT INTO `site_lang` VALUES ('272', '41', 'Day');
INSERT INTO `site_lang` VALUES ('273', '41', 'Month');
INSERT INTO `site_lang` VALUES ('274', '41', 'Year');
INSERT INTO `site_lang` VALUES ('275', '41', 'Please wait');
INSERT INTO `site_lang` VALUES ('276', '41', 'Interests');
INSERT INTO `site_lang` VALUES ('277', '41', 'Report');
INSERT INTO `site_lang` VALUES ('278', '41', 'Fans');
INSERT INTO `site_lang` VALUES ('279', '41', 'No data');
INSERT INTO `site_lang` VALUES ('280', '41', 'Public Photos');
INSERT INTO `site_lang` VALUES ('281', '41', 'Private photos');
INSERT INTO `site_lang` VALUES ('282', '41', 'Add from ');
INSERT INTO `site_lang` VALUES ('283', '41', 'Add');
INSERT INTO `site_lang` VALUES ('284', '41', 'Photos');
INSERT INTO `site_lang` VALUES ('285', '41', 'Credits');
INSERT INTO `site_lang` VALUES ('286', '41', 'Visits');
INSERT INTO `site_lang` VALUES ('287', '41', 'Add me here');
INSERT INTO `site_lang` VALUES ('288', '41', 'get seen by millions');
INSERT INTO `site_lang` VALUES ('289', '41', 'Set as profile');
INSERT INTO `site_lang` VALUES ('290', '41', 'Private photo');
INSERT INTO `site_lang` VALUES ('291', '41', 'Public photo');
INSERT INTO `site_lang` VALUES ('292', '41', 'Delete');
INSERT INTO `site_lang` VALUES ('293', '41', 'people visited your profile for see them');
INSERT INTO `site_lang` VALUES ('294', '41', 'Upgrade your account to premium');
INSERT INTO `site_lang` VALUES ('295', '41', 'People i like');
INSERT INTO `site_lang` VALUES ('296', '41', 'people liked you, for see them');
INSERT INTO `site_lang` VALUES ('297', '41', 'Messages');
INSERT INTO `site_lang` VALUES ('298', '41', 'Like');
INSERT INTO `site_lang` VALUES ('299', '41', 'Dislike');
INSERT INTO `site_lang` VALUES ('300', '41', 'AGE');
INSERT INTO `site_lang` VALUES ('301', '41', 'You dont have any visit yet');
INSERT INTO `site_lang` VALUES ('302', '41', 'visited');
INSERT INTO `site_lang` VALUES ('303', '41', 'You do not like anyone');
INSERT INTO `site_lang` VALUES ('304', '41', 'Cost');
INSERT INTO `site_lang` VALUES ('305', '41', 'Credits for $');
INSERT INTO `site_lang` VALUES ('306', '41', '0 seconds');
INSERT INTO `site_lang` VALUES ('307', '41', 'year');
INSERT INTO `site_lang` VALUES ('308', '41', 'month');
INSERT INTO `site_lang` VALUES ('309', '41', 'day');
INSERT INTO `site_lang` VALUES ('310', '41', 'hour');
INSERT INTO `site_lang` VALUES ('311', '41', 'minute');
INSERT INTO `site_lang` VALUES ('312', '41', 'second');
INSERT INTO `site_lang` VALUES ('313', '41', 'years');
INSERT INTO `site_lang` VALUES ('314', '41', 'months');
INSERT INTO `site_lang` VALUES ('315', '41', 'days');
INSERT INTO `site_lang` VALUES ('316', '41', 'hours');
INSERT INTO `site_lang` VALUES ('317', '41', 'minutes');
INSERT INTO `site_lang` VALUES ('318', '41', 'seconds');
INSERT INTO `site_lang` VALUES ('319', '41', 'ago');
INSERT INTO `site_lang` VALUES ('320', '41', 'Please verify your account, check your email');
INSERT INTO `site_lang` VALUES ('321', '41', 'Please add a profile photo');
INSERT INTO `site_lang` VALUES ('322', '41', 'Hi, im');
INSERT INTO `site_lang` VALUES ('323', '41', 'years old and im from');
INSERT INTO `site_lang` VALUES ('324', '41', 'We sended you a email for verify your account');
INSERT INTO `site_lang` VALUES ('325', '41', 'is blocking you or you blocked him, you cant chat with him sorry');
INSERT INTO `site_lang` VALUES ('326', '41', 'Report and block');
INSERT INTO `site_lang` VALUES ('327', '41', 'Are you sure you want to report');
INSERT INTO `site_lang` VALUES ('328', '41', 'Press backspace key for smart return to the meeting section.');
INSERT INTO `site_lang` VALUES ('329', '41', 'Write your instagram username');
INSERT INTO `site_lang` VALUES ('330', '41', 'You need to write your username!');
INSERT INTO `site_lang` VALUES ('331', '41', 'username');
INSERT INTO `site_lang` VALUES ('332', '41', 'days of Premium');
INSERT INTO `site_lang` VALUES ('333', '41', 'Wrong');
INSERT INTO `site_lang` VALUES ('334', '41', 'Spotlight');
INSERT INTO `site_lang` VALUES ('335', '41', 'Service cost');
INSERT INTO `site_lang` VALUES ('336', '41', 'Password successfully changed');
INSERT INTO `site_lang` VALUES ('337', '41', 'is calling you..');
INSERT INTO `site_lang` VALUES ('338', '41', 'Photos of ');
INSERT INTO `site_lang` VALUES ('339', '41', 'of');
INSERT INTO `site_lang` VALUES ('340', '41', 'Loading...');
INSERT INTO `site_lang` VALUES ('341', '41', 'We sent you a email with your info, it may take up to 1 min to arrive');
INSERT INTO `site_lang` VALUES ('342', '41', 'likes you and wants to chat in');
INSERT INTO `site_lang` VALUES ('343', '41', 'has seen you in discover and likes. The feeling is mutual?');
INSERT INTO `site_lang` VALUES ('344', '41', 'Find out if you also like');
INSERT INTO `site_lang` VALUES ('345', '41', 'You received this notice because you registered as');
INSERT INTO `site_lang` VALUES ('346', '41', 'Unsubscribe');
INSERT INTO `site_lang` VALUES ('347', '41', 'Choose a new password');
INSERT INTO `site_lang` VALUES ('348', '41', 'if you forgot your password, click on the link below to get a new');
INSERT INTO `site_lang` VALUES ('349', '41', 'You have a match at');
INSERT INTO `site_lang` VALUES ('350', '41', 'Its a match!');
INSERT INTO `site_lang` VALUES ('351', '41', 'thinks the feeling is mutual');
INSERT INTO `site_lang` VALUES ('352', '41', 'Go and say something to');
INSERT INTO `site_lang` VALUES ('353', '41', 'New message from');
INSERT INTO `site_lang` VALUES ('354', '41', 'you have a new message from');
INSERT INTO `site_lang` VALUES ('355', '41', 'Respond to');
INSERT INTO `site_lang` VALUES ('356', '41', 'Have fun!');
INSERT INTO `site_lang` VALUES ('357', '41', 'is new and lives closer to you');
INSERT INTO `site_lang` VALUES ('358', '41', 'is new at');
INSERT INTO `site_lang` VALUES ('359', '41', 'and lives closer to you');
INSERT INTO `site_lang` VALUES ('360', '41', 'Check out the profile');
INSERT INTO `site_lang` VALUES ('361', '41', 'Welcome');
INSERT INTO `site_lang` VALUES ('362', '41', 'Well done, now you are in');
INSERT INTO `site_lang` VALUES ('363', '41', 'Here are a few tips');
INSERT INTO `site_lang` VALUES ('364', '41', 'Now you are a new member of');
INSERT INTO `site_lang` VALUES ('365', '41', 'Verify your account');
INSERT INTO `site_lang` VALUES ('366', '41', 'Newsflash');
INSERT INTO `site_lang` VALUES ('367', '41', 'people in your area wants to know you');
INSERT INTO `site_lang` VALUES ('368', '41', 'In');
INSERT INTO `site_lang` VALUES ('369', '41', 'you can meet people instantly');
INSERT INTO `site_lang` VALUES ('370', '41', 'Meet new people');
INSERT INTO `site_lang` VALUES ('371', '41', 'Nobody is going to fall in love with a blank page. The more information you get, the more chances to find that special someone!');
INSERT INTO `site_lang` VALUES ('372', '41', 'Add photos and complete your profile');
INSERT INTO `site_lang` VALUES ('373', '41', 'More than 1 million people have joined $site_name You probably want to know some of them.');
INSERT INTO `site_lang` VALUES ('374', '41', 'Start meeting new people now');
INSERT INTO `site_lang` VALUES ('375', '41', 'Here are your connection details');
INSERT INTO `site_lang` VALUES ('376', '41', 'E-mail');
INSERT INTO `site_lang` VALUES ('377', '41', 'Password');
INSERT INTO `site_lang` VALUES ('378', '41', 'Please save your connection information in a safe place');
INSERT INTO `site_lang` VALUES ('379', '41', 'Go to');
INSERT INTO `site_lang` VALUES ('380', '41', 'Welcome to');
INSERT INTO `site_lang` VALUES ('381', '41', 'calling...');
INSERT INTO `site_lang` VALUES ('382', '41', 'dont like you');
INSERT INTO `site_lang` VALUES ('383', '41', 'must like you for start a videocall');
INSERT INTO `site_lang` VALUES ('384', '41', 'Ok, i understand');
INSERT INTO `site_lang` VALUES ('0', '42', 'meet new people!');
INSERT INTO `site_lang` VALUES ('1', '42', 'Login');
INSERT INTO `site_lang` VALUES ('2', '42', 'Welcome to the fastest growing place to meet new people');
INSERT INTO `site_lang` VALUES ('3', '42', 'For now our site works only for Desktop users');
INSERT INTO `site_lang` VALUES ('4', '42', 'Please visit us from your laptop or PC');
INSERT INTO `site_lang` VALUES ('5', '42', 'Soon we will have our phone apps online');
INSERT INTO `site_lang` VALUES ('6', '42', 'SOON AVAILABLE');
INSERT INTO `site_lang` VALUES ('7', '42', 'Connect with ');
INSERT INTO `site_lang` VALUES ('8', '42', 'Create your account');
INSERT INTO `site_lang` VALUES ('9', '42', 'Welcome back');
INSERT INTO `site_lang` VALUES ('10', '42', 'Your email');
INSERT INTO `site_lang` VALUES ('11', '42', 'Your password');
INSERT INTO `site_lang` VALUES ('12', '42', 'do you forget your password?');
INSERT INTO `site_lang` VALUES ('13', '42', 'Login now');
INSERT INTO `site_lang` VALUES ('14', '42', 'Password recover');
INSERT INTO `site_lang` VALUES ('15', '42', 'Recover password');
INSERT INTO `site_lang` VALUES ('16', '42', 'Chat');
INSERT INTO `site_lang` VALUES ('17', '42', 'Powerfull private chat for meet new friends, you can send emoticons and private photos to anyone.');
INSERT INTO `site_lang` VALUES ('18', '42', 'Video Chat');
INSERT INTO `site_lang` VALUES ('19', '42', 'You can make quality videocalls for free to anyone, without limits of call duration, just enjoy seeing the person who is chatting with you');
INSERT INTO `site_lang` VALUES ('20', '42', 'People nearby');
INSERT INTO `site_lang` VALUES ('21', '42', 'We wont show your exact location, but you will be able to find people nearby who like the same things you do.');
INSERT INTO `site_lang` VALUES ('22', '42', 'Matches');
INSERT INTO `site_lang` VALUES ('23', '42', 'Play our popular Discover game and get matched with other users. Its a great way to break the ice and chat to new people.');
INSERT INTO `site_lang` VALUES ('24', '42', 'Become a member now');
INSERT INTO `site_lang` VALUES ('25', '42', 'Join the worlds bestest community for meeting new people!.');
INSERT INTO `site_lang` VALUES ('26', '42', 'Name');
INSERT INTO `site_lang` VALUES ('27', '42', 'Your name or nickname');
INSERT INTO `site_lang` VALUES ('28', '42', 'Email');
INSERT INTO `site_lang` VALUES ('29', '42', 'Password');
INSERT INTO `site_lang` VALUES ('30', '42', 'Birthday');
INSERT INTO `site_lang` VALUES ('31', '42', 'Please select');
INSERT INTO `site_lang` VALUES ('32', '42', 'City');
INSERT INTO `site_lang` VALUES ('33', '42', 'Where do you live?');
INSERT INTO `site_lang` VALUES ('34', '42', 'Gender');
INSERT INTO `site_lang` VALUES ('35', '42', 'Male');
INSERT INTO `site_lang` VALUES ('36', '42', 'Female');
INSERT INTO `site_lang` VALUES ('37', '42', 'Im here to');
INSERT INTO `site_lang` VALUES ('38', '42', 'Meet girls');
INSERT INTO `site_lang` VALUES ('39', '42', 'Meet boys');
INSERT INTO `site_lang` VALUES ('40', '42', 'Meet boys and girls');
INSERT INTO `site_lang` VALUES ('41', '42', 'Sign up');
INSERT INTO `site_lang` VALUES ('42', '42', 'By continuing, you are confirming that you have read and agree to our');
INSERT INTO `site_lang` VALUES ('43', '42', 'Terms and Conditions');
INSERT INTO `site_lang` VALUES ('44', '42', 'and');
INSERT INTO `site_lang` VALUES ('45', '42', 'Privacy Policy');
INSERT INTO `site_lang` VALUES ('46', '42', 'Profile');
INSERT INTO `site_lang` VALUES ('47', '42', 'Settings');
INSERT INTO `site_lang` VALUES ('48', '42', 'Logout');
INSERT INTO `site_lang` VALUES ('49', '42', 'Meet new people');
INSERT INTO `site_lang` VALUES ('50', '42', 'Discover');
INSERT INTO `site_lang` VALUES ('51', '42', 'Matches');
INSERT INTO `site_lang` VALUES ('52', '42', 'Most populars');
INSERT INTO `site_lang` VALUES ('53', '42', 'Fans');
INSERT INTO `site_lang` VALUES ('54', '42', 'Manage photos');
INSERT INTO `site_lang` VALUES ('55', '42', 'Settings');
INSERT INTO `site_lang` VALUES ('56', '42', 'All');
INSERT INTO `site_lang` VALUES ('57', '42', 'Fans');
INSERT INTO `site_lang` VALUES ('58', '42', 'Conversations');
INSERT INTO `site_lang` VALUES ('59', '42', 'Online now');
INSERT INTO `site_lang` VALUES ('60', '42', 'New messages');
INSERT INTO `site_lang` VALUES ('61', '42', 'Who to like');
INSERT INTO `site_lang` VALUES ('62', '42', 'Terms');
INSERT INTO `site_lang` VALUES ('63', '42', 'Privacy');
INSERT INTO `site_lang` VALUES ('64', '42', 'Contact');
INSERT INTO `site_lang` VALUES ('65', '42', 'Manage your photos');
INSERT INTO `site_lang` VALUES ('66', '42', 'All Photos');
INSERT INTO `site_lang` VALUES ('67', '42', 'Public Photos');
INSERT INTO `site_lang` VALUES ('68', '42', 'Private Photos');
INSERT INTO `site_lang` VALUES ('69', '42', 'Add your photos');
INSERT INTO `site_lang` VALUES ('70', '42', 'add photos');
INSERT INTO `site_lang` VALUES ('71', '42', 'Add yourself to the Spotlight');
INSERT INTO `site_lang` VALUES ('72', '42', 'Pick the photo you want to show in the Spotlight, cost ');
INSERT INTO `site_lang` VALUES ('73', '42', 'Credits');
INSERT INTO `site_lang` VALUES ('74', '42', 'Add photo');
INSERT INTO `site_lang` VALUES ('75', '42', 'Send gift to ');
INSERT INTO `site_lang` VALUES ('76', '42', 'Pick the gift you want to send to ');
INSERT INTO `site_lang` VALUES ('77', '42', 'Send gift');
INSERT INTO `site_lang` VALUES ('78', '42', 'Buy credits / Upgrade account');
INSERT INTO `site_lang` VALUES ('79', '42', 'Select credits package');
INSERT INTO `site_lang` VALUES ('80', '42', 'Select payment method');
INSERT INTO `site_lang` VALUES ('81', '42', 'Pay with');
INSERT INTO `site_lang` VALUES ('82', '42', 'Pay with');
INSERT INTO `site_lang` VALUES ('83', '42', 'Buy credits');
INSERT INTO `site_lang` VALUES ('84', '42', 'Premium Account Features');
INSERT INTO `site_lang` VALUES ('85', '42', 'new chats per day');
INSERT INTO `site_lang` VALUES ('86', '42', 'Unlimited videocalls');
INSERT INTO `site_lang` VALUES ('87', '42', 'Unblock all private photos');
INSERT INTO `site_lang` VALUES ('88', '42', 'Premium user badge');
INSERT INTO `site_lang` VALUES ('89', '42', 'Write text here');
INSERT INTO `site_lang` VALUES ('90', '42', 'Send');
INSERT INTO `site_lang` VALUES ('91', '42', 'Chat');
INSERT INTO `site_lang` VALUES ('92', '42', 'you have reached the limit of new daily conversations');
INSERT INTO `site_lang` VALUES ('93', '42', 'To continue chatting');
INSERT INTO `site_lang` VALUES ('94', '42', 'Buy');
INSERT INTO `site_lang` VALUES ('95', '42', 'more daily conversation');
INSERT INTO `site_lang` VALUES ('96', '42', 'or');
INSERT INTO `site_lang` VALUES ('97', '42', 'Upgrade your account to Premium');
INSERT INTO `site_lang` VALUES ('98', '42', 'and get up to');
INSERT INTO `site_lang` VALUES ('99', '42', 'daily conversations');
INSERT INTO `site_lang` VALUES ('100', '42', 'or wait until tomorrow for continue meeting people');
INSERT INTO `site_lang` VALUES ('101', '42', 'Your fans');
INSERT INTO `site_lang` VALUES ('102', '42', 'Privacy Policy');
INSERT INTO `site_lang` VALUES ('103', '42', 'Terms of Use');
INSERT INTO `site_lang` VALUES ('104', '42', 'Please complete your profile before start in ');
INSERT INTO `site_lang` VALUES ('105', '42', 'Your matches');
INSERT INTO `site_lang` VALUES ('106', '42', 'Filter Search');
INSERT INTO `site_lang` VALUES ('107', '42', 'All users');
INSERT INTO `site_lang` VALUES ('108', '42', 'Online now');
INSERT INTO `site_lang` VALUES ('109', '42', 'Show me');
INSERT INTO `site_lang` VALUES ('110', '42', 'Girls');
INSERT INTO `site_lang` VALUES ('111', '42', 'Boys');
INSERT INTO `site_lang` VALUES ('112', '42', 'Both');
INSERT INTO `site_lang` VALUES ('113', '42', 'who are between');
INSERT INTO `site_lang` VALUES ('114', '42', 'in a radius of');
INSERT INTO `site_lang` VALUES ('115', '42', 'World');
INSERT INTO `site_lang` VALUES ('116', '42', 'Most popular users');
INSERT INTO `site_lang` VALUES ('117', '42', 'About ');
INSERT INTO `site_lang` VALUES ('118', '42', 'Personal info');
INSERT INTO `site_lang` VALUES ('119', '42', 'years old');
INSERT INTO `site_lang` VALUES ('120', '42', 'Only boys');
INSERT INTO `site_lang` VALUES ('121', '42', 'Only girls');
INSERT INTO `site_lang` VALUES ('122', '42', 'boys and girls');
INSERT INTO `site_lang` VALUES ('123', '42', 'Credits successfully added to your account');
INSERT INTO `site_lang` VALUES ('124', '42', 'Now you have');
INSERT INTO `site_lang` VALUES ('125', '42', 'Ask permission to');
INSERT INTO `site_lang` VALUES ('126', '42', 'Unblock private photos');
INSERT INTO `site_lang` VALUES ('127', '42', 'Personal');
INSERT INTO `site_lang` VALUES ('128', '42', 'Credits');
INSERT INTO `site_lang` VALUES ('129', '42', 'Verify');
INSERT INTO `site_lang` VALUES ('130', '42', 'Change password');
INSERT INTO `site_lang` VALUES ('131', '42', 'Delete');
INSERT INTO `site_lang` VALUES ('132', '42', 'Personal information');
INSERT INTO `site_lang` VALUES ('133', '42', 'You can edit your profile information bellow');
INSERT INTO `site_lang` VALUES ('134', '42', 'Site language');
INSERT INTO `site_lang` VALUES ('135', '42', 'Update profile');
INSERT INTO `site_lang` VALUES ('136', '42', 'Verify account');
INSERT INTO `site_lang` VALUES ('137', '42', 'For verify your account , connect with your facebook account');
INSERT INTO `site_lang` VALUES ('138', '42', 'Connect with Facebook');
INSERT INTO `site_lang` VALUES ('139', '42', 'You are account is already verified');
INSERT INTO `site_lang` VALUES ('140', '42', 'Buy credits for send Gifs and Unblock private photos');
INSERT INTO `site_lang` VALUES ('141', '42', 'Account type');
INSERT INTO `site_lang` VALUES ('142', '42', 'Current credits');
INSERT INTO `site_lang` VALUES ('143', '42', 'Add credits');
INSERT INTO `site_lang` VALUES ('144', '42', 'Upgrade to premium account');
INSERT INTO `site_lang` VALUES ('145', '42', 'Change password');
INSERT INTO `site_lang` VALUES ('146', '42', 'You can change your current password bellow');
INSERT INTO `site_lang` VALUES ('147', '42', 'New password');
INSERT INTO `site_lang` VALUES ('148', '42', 'Profile desactivation');
INSERT INTO `site_lang` VALUES ('149', '42', 'After delete your profile, some of your data will be lost without recovery.');
INSERT INTO `site_lang` VALUES ('150', '42', 'Delete profile');
INSERT INTO `site_lang` VALUES ('151', '42', 'Online now');
INSERT INTO `site_lang` VALUES ('152', '42', 'Verified');
INSERT INTO `site_lang` VALUES ('153', '42', 'Nothing found');
INSERT INTO `site_lang` VALUES ('154', '42', 'people found');
INSERT INTO `site_lang` VALUES ('155', '42', 'No popular users near you');
INSERT INTO `site_lang` VALUES ('156', '42', 'You dont have any fans yet');
INSERT INTO `site_lang` VALUES ('157', '42', 'You dont have matches yet');
INSERT INTO `site_lang` VALUES ('158', '42', 'January');
INSERT INTO `site_lang` VALUES ('159', '42', 'February');
INSERT INTO `site_lang` VALUES ('160', '42', 'March');
INSERT INTO `site_lang` VALUES ('161', '42', 'April');
INSERT INTO `site_lang` VALUES ('162', '42', 'May');
INSERT INTO `site_lang` VALUES ('163', '42', 'June');
INSERT INTO `site_lang` VALUES ('164', '42', 'July');
INSERT INTO `site_lang` VALUES ('165', '42', 'August');
INSERT INTO `site_lang` VALUES ('166', '42', 'September');
INSERT INTO `site_lang` VALUES ('167', '42', 'October');
INSERT INTO `site_lang` VALUES ('168', '42', 'November');
INSERT INTO `site_lang` VALUES ('169', '42', 'December');
INSERT INTO `site_lang` VALUES ('170', '42', 'Buy');
INSERT INTO `site_lang` VALUES ('171', '42', 'Days Premium');
INSERT INTO `site_lang` VALUES ('172', '42', 'persons more like this');
INSERT INTO `site_lang` VALUES ('173', '42', 'like this');
INSERT INTO `site_lang` VALUES ('174', '42', 'Hello, can i have access to your private photos ?');
INSERT INTO `site_lang` VALUES ('175', '42', 'Yes');
INSERT INTO `site_lang` VALUES ('176', '42', 'No');
INSERT INTO `site_lang` VALUES ('177', '42', 'Hi');
INSERT INTO `site_lang` VALUES ('178', '42', 'If you dont remember your password, click the link below to set a new one:');
INSERT INTO `site_lang` VALUES ('179', '42', 'Login to my account');
INSERT INTO `site_lang` VALUES ('180', '42', 'Password recover');
INSERT INTO `site_lang` VALUES ('181', '42', 'Invalid email format');
INSERT INTO `site_lang` VALUES ('182', '42', 'Please fill all the inputs');
INSERT INTO `site_lang` VALUES ('183', '42', 'Email dont exist');
INSERT INTO `site_lang` VALUES ('184', '42', 'Wrong password');
INSERT INTO `site_lang` VALUES ('185', '42', 'Add a valid date');
INSERT INTO `site_lang` VALUES ('186', '42', 'Choose city from the autocomplete');
INSERT INTO `site_lang` VALUES ('187', '42', 'Password too short');
INSERT INTO `site_lang` VALUES ('188', '42', 'Email already exist, try another');
INSERT INTO `site_lang` VALUES ('189', '42', 'Yes, you can see my private photos');
INSERT INTO `site_lang` VALUES ('190', '42', 'No, i cant show you my private photos');
INSERT INTO `site_lang` VALUES ('191', '42', 'Buy private photos permission');
INSERT INTO `site_lang` VALUES ('192', '42', 'Get access to');
INSERT INTO `site_lang` VALUES ('193', '42', 'private photos for ');
INSERT INTO `site_lang` VALUES ('194', '42', 'Get access');
INSERT INTO `site_lang` VALUES ('195', '42', 'No thanks');
INSERT INTO `site_lang` VALUES ('196', '42', 'Please, select a payment method');
INSERT INTO `site_lang` VALUES ('197', '42', 'Please, select 1 photo');
INSERT INTO `site_lang` VALUES ('198', '42', 'Please, select 1 gift');
INSERT INTO `site_lang` VALUES ('199', '42', 'You dont have enought credits for send the gift');
INSERT INTO `site_lang` VALUES ('200', '42', 'Expand daily limitation ');
INSERT INTO `site_lang` VALUES ('201', '42', 'more daily conversation, cost ');
INSERT INTO `site_lang` VALUES ('202', '42', 'Yes, buy it!');
INSERT INTO `site_lang` VALUES ('203', '42', 'Information updated successfully');
INSERT INTO `site_lang` VALUES ('204', '42', 'Account termination');
INSERT INTO `site_lang` VALUES ('205', '42', 'Your data will be lost without recovery, continue?');
INSERT INTO `site_lang` VALUES ('206', '42', 'Yes, delete it!');
INSERT INTO `site_lang` VALUES ('207', '42', 'is in another videocall , you cant call now');
INSERT INTO `site_lang` VALUES ('208', '42', 'is offline, try again when your friend is online');
INSERT INTO `site_lang` VALUES ('209', '42', 'Please allow access to your Webcam.');
INSERT INTO `site_lang` VALUES ('210', '42', 'You are already in a videocall, you have to end the other call before start another');
INSERT INTO `site_lang` VALUES ('211', '42', 'Only premium users can make videocalls');
INSERT INTO `site_lang` VALUES ('212', '42', 'Impossible to make a call!');
INSERT INTO `site_lang` VALUES ('213', '42', 'You cant make videocall because you dont have webcam');
INSERT INTO `site_lang` VALUES ('214', '42', 'Too long wait');
INSERT INTO `site_lang` VALUES ('215', '42', 'Seems that your friend do not have webcam or he is not available');
INSERT INTO `site_lang` VALUES ('216', '42', 'End call');
INSERT INTO `site_lang` VALUES ('217', '42', 'Wait more');
INSERT INTO `site_lang` VALUES ('218', '42', 'until');
INSERT INTO `site_lang` VALUES ('219', '42', 'Basic');
INSERT INTO `site_lang` VALUES ('220', '42', 'UPGRADE');
INSERT INTO `site_lang` VALUES ('221', '42', 'Notifications');
INSERT INTO `site_lang` VALUES ('222', '42', 'Extended info (optional)');
INSERT INTO `site_lang` VALUES ('223', '42', 'Relationship');
INSERT INTO `site_lang` VALUES ('224', '42', 'Single');
INSERT INTO `site_lang` VALUES ('225', '42', 'Taken');
INSERT INTO `site_lang` VALUES ('226', '42', 'Open');
INSERT INTO `site_lang` VALUES ('227', '42', 'Sexuality');
INSERT INTO `site_lang` VALUES ('228', '42', 'Gay');
INSERT INTO `site_lang` VALUES ('229', '42', 'Open-minded');
INSERT INTO `site_lang` VALUES ('230', '42', 'Straight');
INSERT INTO `site_lang` VALUES ('231', '42', 'Bisexual');
INSERT INTO `site_lang` VALUES ('232', '42', 'Height');
INSERT INTO `site_lang` VALUES ('233', '42', 'less than');
INSERT INTO `site_lang` VALUES ('234', '42', 'more than');
INSERT INTO `site_lang` VALUES ('235', '42', 'Weight');
INSERT INTO `site_lang` VALUES ('236', '42', 'Ethnicity');
INSERT INTO `site_lang` VALUES ('237', '42', 'Asian');
INSERT INTO `site_lang` VALUES ('238', '42', 'Middle Eastern');
INSERT INTO `site_lang` VALUES ('239', '42', 'Black');
INSERT INTO `site_lang` VALUES ('240', '42', 'White');
INSERT INTO `site_lang` VALUES ('241', '42', 'Native American');
INSERT INTO `site_lang` VALUES ('242', '42', 'Hispanic/latin');
INSERT INTO `site_lang` VALUES ('243', '42', 'Pacific Islander');
INSERT INTO `site_lang` VALUES ('244', '42', 'Indian');
INSERT INTO `site_lang` VALUES ('245', '42', 'Other');
INSERT INTO `site_lang` VALUES ('246', '42', 'Body type');
INSERT INTO `site_lang` VALUES ('247', '42', 'Slim');
INSERT INTO `site_lang` VALUES ('248', '42', 'Average');
INSERT INTO `site_lang` VALUES ('249', '42', 'Athletic');
INSERT INTO `site_lang` VALUES ('250', '42', 'Heavy set');
INSERT INTO `site_lang` VALUES ('251', '42', 'Curvy');
INSERT INTO `site_lang` VALUES ('252', '42', 'Living');
INSERT INTO `site_lang` VALUES ('253', '42', 'With parents');
INSERT INTO `site_lang` VALUES ('254', '42', 'With housemate');
INSERT INTO `site_lang` VALUES ('255', '42', 'Student dormitory');
INSERT INTO `site_lang` VALUES ('256', '42', 'With partner');
INSERT INTO `site_lang` VALUES ('257', '42', 'Alone');
INSERT INTO `site_lang` VALUES ('258', '42', 'Smoke');
INSERT INTO `site_lang` VALUES ('259', '42', 'Yes');
INSERT INTO `site_lang` VALUES ('260', '42', 'No');
INSERT INTO `site_lang` VALUES ('261', '42', 'Sometimes');
INSERT INTO `site_lang` VALUES ('262', '42', 'Drink');
INSERT INTO `site_lang` VALUES ('263', '42', 'Transport');
INSERT INTO `site_lang` VALUES ('264', '42', 'Parents car');
INSERT INTO `site_lang` VALUES ('265', '42', 'I own a car');
INSERT INTO `site_lang` VALUES ('266', '42', 'I own a motorbike');
INSERT INTO `site_lang` VALUES ('267', '42', 'None');
INSERT INTO `site_lang` VALUES ('268', '42', 'When someone likes me');
INSERT INTO `site_lang` VALUES ('269', '42', 'When i get a match');
INSERT INTO `site_lang` VALUES ('270', '42', 'When new users near me join in');
INSERT INTO `site_lang` VALUES ('271', '42', 'When someone send me a message');
INSERT INTO `site_lang` VALUES ('272', '42', 'Day');
INSERT INTO `site_lang` VALUES ('273', '42', 'Month');
INSERT INTO `site_lang` VALUES ('274', '42', 'Year');
INSERT INTO `site_lang` VALUES ('275', '42', 'Please wait');
INSERT INTO `site_lang` VALUES ('276', '42', 'Interests');
INSERT INTO `site_lang` VALUES ('277', '42', 'Report');
INSERT INTO `site_lang` VALUES ('278', '42', 'Fans');
INSERT INTO `site_lang` VALUES ('279', '42', 'No data');
INSERT INTO `site_lang` VALUES ('280', '42', 'Public Photos');
INSERT INTO `site_lang` VALUES ('281', '42', 'Private photos');
INSERT INTO `site_lang` VALUES ('282', '42', 'Add from ');
INSERT INTO `site_lang` VALUES ('283', '42', 'Add');
INSERT INTO `site_lang` VALUES ('284', '42', 'Photos');
INSERT INTO `site_lang` VALUES ('285', '42', 'Credits');
INSERT INTO `site_lang` VALUES ('286', '42', 'Visits');
INSERT INTO `site_lang` VALUES ('287', '42', 'Add me here');
INSERT INTO `site_lang` VALUES ('288', '42', 'get seen by millions');
INSERT INTO `site_lang` VALUES ('289', '42', 'Set as profile');
INSERT INTO `site_lang` VALUES ('290', '42', 'Private photo');
INSERT INTO `site_lang` VALUES ('291', '42', 'Public photo');
INSERT INTO `site_lang` VALUES ('292', '42', 'Delete');
INSERT INTO `site_lang` VALUES ('293', '42', 'people visited your profile for see them');
INSERT INTO `site_lang` VALUES ('294', '42', 'Upgrade your account to premium');
INSERT INTO `site_lang` VALUES ('295', '42', 'People i like');
INSERT INTO `site_lang` VALUES ('296', '42', 'people liked you, for see them');
INSERT INTO `site_lang` VALUES ('297', '42', 'Messages');
INSERT INTO `site_lang` VALUES ('298', '42', 'Like');
INSERT INTO `site_lang` VALUES ('299', '42', 'Dislike');
INSERT INTO `site_lang` VALUES ('300', '42', 'AGE');
INSERT INTO `site_lang` VALUES ('301', '42', 'You dont have any visit yet');
INSERT INTO `site_lang` VALUES ('302', '42', 'visited');
INSERT INTO `site_lang` VALUES ('303', '42', 'You do not like anyone');
INSERT INTO `site_lang` VALUES ('304', '42', 'Cost');
INSERT INTO `site_lang` VALUES ('305', '42', 'Credits for $');
INSERT INTO `site_lang` VALUES ('306', '42', '0 seconds');
INSERT INTO `site_lang` VALUES ('307', '42', 'year');
INSERT INTO `site_lang` VALUES ('308', '42', 'month');
INSERT INTO `site_lang` VALUES ('309', '42', 'day');
INSERT INTO `site_lang` VALUES ('310', '42', 'hour');
INSERT INTO `site_lang` VALUES ('311', '42', 'minute');
INSERT INTO `site_lang` VALUES ('312', '42', 'second');
INSERT INTO `site_lang` VALUES ('313', '42', 'years');
INSERT INTO `site_lang` VALUES ('314', '42', 'months');
INSERT INTO `site_lang` VALUES ('315', '42', 'days');
INSERT INTO `site_lang` VALUES ('316', '42', 'hours');
INSERT INTO `site_lang` VALUES ('317', '42', 'minutes');
INSERT INTO `site_lang` VALUES ('318', '42', 'seconds');
INSERT INTO `site_lang` VALUES ('319', '42', 'ago');
INSERT INTO `site_lang` VALUES ('320', '42', 'Please verify your account, check your email');
INSERT INTO `site_lang` VALUES ('321', '42', 'Please add a profile photo');
INSERT INTO `site_lang` VALUES ('322', '42', 'Hi, im');
INSERT INTO `site_lang` VALUES ('323', '42', 'years old and im from');
INSERT INTO `site_lang` VALUES ('324', '42', 'We sended you a email for verify your account');
INSERT INTO `site_lang` VALUES ('325', '42', 'is blocking you or you blocked him, you cant chat with him sorry');
INSERT INTO `site_lang` VALUES ('326', '42', 'Report and block');
INSERT INTO `site_lang` VALUES ('327', '42', 'Are you sure you want to report');
INSERT INTO `site_lang` VALUES ('328', '42', 'Press backspace key for smart return to the meeting section.');
INSERT INTO `site_lang` VALUES ('329', '42', 'Write your instagram username');
INSERT INTO `site_lang` VALUES ('330', '42', 'You need to write your username!');
INSERT INTO `site_lang` VALUES ('331', '42', 'username');
INSERT INTO `site_lang` VALUES ('332', '42', 'days of Premium');
INSERT INTO `site_lang` VALUES ('333', '42', 'Wrong');
INSERT INTO `site_lang` VALUES ('334', '42', 'Spotlight');
INSERT INTO `site_lang` VALUES ('335', '42', 'Service cost');
INSERT INTO `site_lang` VALUES ('336', '42', 'Password successfully changed');
INSERT INTO `site_lang` VALUES ('337', '42', 'is calling you..');
INSERT INTO `site_lang` VALUES ('338', '42', 'Photos of ');
INSERT INTO `site_lang` VALUES ('339', '42', 'of');
INSERT INTO `site_lang` VALUES ('340', '42', 'Loading...');
INSERT INTO `site_lang` VALUES ('341', '42', 'We sent you a email with your info, it may take up to 1 min to arrive');
INSERT INTO `site_lang` VALUES ('342', '42', 'likes you and wants to chat in');
INSERT INTO `site_lang` VALUES ('343', '42', 'has seen you in discover and likes. The feeling is mutual?');
INSERT INTO `site_lang` VALUES ('344', '42', 'Find out if you also like');
INSERT INTO `site_lang` VALUES ('345', '42', 'You received this notice because you registered as');
INSERT INTO `site_lang` VALUES ('346', '42', 'Unsubscribe');
INSERT INTO `site_lang` VALUES ('347', '42', 'Choose a new password');
INSERT INTO `site_lang` VALUES ('348', '42', 'if you forgot your password, click on the link below to get a new');
INSERT INTO `site_lang` VALUES ('349', '42', 'You have a match at');
INSERT INTO `site_lang` VALUES ('350', '42', 'Its a match!');
INSERT INTO `site_lang` VALUES ('351', '42', 'thinks the feeling is mutual');
INSERT INTO `site_lang` VALUES ('352', '42', 'Go and say something to');
INSERT INTO `site_lang` VALUES ('353', '42', 'New message from');
INSERT INTO `site_lang` VALUES ('354', '42', 'you have a new message from');
INSERT INTO `site_lang` VALUES ('355', '42', 'Respond to');
INSERT INTO `site_lang` VALUES ('356', '42', 'Have fun!');
INSERT INTO `site_lang` VALUES ('357', '42', 'is new and lives closer to you');
INSERT INTO `site_lang` VALUES ('358', '42', 'is new at');
INSERT INTO `site_lang` VALUES ('359', '42', 'and lives closer to you');
INSERT INTO `site_lang` VALUES ('360', '42', 'Check out the profile');
INSERT INTO `site_lang` VALUES ('361', '42', 'Welcome');
INSERT INTO `site_lang` VALUES ('362', '42', 'Well done, now you are in');
INSERT INTO `site_lang` VALUES ('363', '42', 'Here are a few tips');
INSERT INTO `site_lang` VALUES ('364', '42', 'Now you are a new member of');
INSERT INTO `site_lang` VALUES ('365', '42', 'Verify your account');
INSERT INTO `site_lang` VALUES ('366', '42', 'Newsflash');
INSERT INTO `site_lang` VALUES ('367', '42', 'people in your area wants to know you');
INSERT INTO `site_lang` VALUES ('368', '42', 'In');
INSERT INTO `site_lang` VALUES ('369', '42', 'you can meet people instantly');
INSERT INTO `site_lang` VALUES ('370', '42', 'Meet new people');
INSERT INTO `site_lang` VALUES ('371', '42', 'Nobody is going to fall in love with a blank page. The more information you get, the more chances to find that special someone!');
INSERT INTO `site_lang` VALUES ('372', '42', 'Add photos and complete your profile');
INSERT INTO `site_lang` VALUES ('373', '42', 'More than 1 million people have joined $site_name You probably want to know some of them.');
INSERT INTO `site_lang` VALUES ('374', '42', 'Start meeting new people now');
INSERT INTO `site_lang` VALUES ('375', '42', 'Here are your connection details');
INSERT INTO `site_lang` VALUES ('376', '42', 'E-mail');
INSERT INTO `site_lang` VALUES ('377', '42', 'Password');
INSERT INTO `site_lang` VALUES ('378', '42', 'Please save your connection information in a safe place');
INSERT INTO `site_lang` VALUES ('379', '42', 'Go to');
INSERT INTO `site_lang` VALUES ('380', '42', 'Welcome to');
INSERT INTO `site_lang` VALUES ('381', '42', 'calling...');
INSERT INTO `site_lang` VALUES ('382', '42', 'dont like you');
INSERT INTO `site_lang` VALUES ('383', '42', 'must like you for start a videocall');
INSERT INTO `site_lang` VALUES ('384', '42', 'Ok, i understand');
INSERT INTO `site_lang` VALUES ('381', '43', 'calling...');
INSERT INTO `site_lang` VALUES ('382', '43', 'dont like you');
INSERT INTO `site_lang` VALUES ('383', '43', 'must like you for start a videocall');
INSERT INTO `site_lang` VALUES ('384', '43', 'Ok, i understand');
INSERT INTO `site_lang` VALUES ('0', '44', 'meet new people!');
INSERT INTO `site_lang` VALUES ('1', '44', 'Login');
INSERT INTO `site_lang` VALUES ('2', '44', 'Welcome to the fastest growing place to meet new people');
INSERT INTO `site_lang` VALUES ('3', '44', 'For now our site works only for Desktop users');
INSERT INTO `site_lang` VALUES ('4', '44', 'Please visit us from your laptop or PC');
INSERT INTO `site_lang` VALUES ('5', '44', 'Soon we will have our phone apps online');
INSERT INTO `site_lang` VALUES ('6', '44', 'SOON AVAILABLE');
INSERT INTO `site_lang` VALUES ('7', '44', 'Connect with ');
INSERT INTO `site_lang` VALUES ('8', '44', 'Create your account');
INSERT INTO `site_lang` VALUES ('9', '44', 'Welcome back');
INSERT INTO `site_lang` VALUES ('10', '44', 'Your email');
INSERT INTO `site_lang` VALUES ('11', '44', 'Your password');
INSERT INTO `site_lang` VALUES ('12', '44', 'do you forget your password?');
INSERT INTO `site_lang` VALUES ('13', '44', 'Login now');
INSERT INTO `site_lang` VALUES ('14', '44', 'Password recover');
INSERT INTO `site_lang` VALUES ('15', '44', 'Recover password');
INSERT INTO `site_lang` VALUES ('16', '44', 'Chat');
INSERT INTO `site_lang` VALUES ('17', '44', 'Powerfull private chat for meet new friends, you can send emoticons and private photos to anyone.');
INSERT INTO `site_lang` VALUES ('18', '44', 'Video Chat');
INSERT INTO `site_lang` VALUES ('19', '44', 'You can make quality videocalls for free to anyone, without limits of call duration, just enjoy seeing the person who is chatting with you');
INSERT INTO `site_lang` VALUES ('20', '44', 'People nearby');
INSERT INTO `site_lang` VALUES ('21', '44', 'We wont show your exact location, but you will be able to find people nearby who like the same things you do.');
INSERT INTO `site_lang` VALUES ('22', '44', 'Matches');
INSERT INTO `site_lang` VALUES ('23', '44', 'Play our popular Discover game and get matched with other users. Its a great way to break the ice and chat to new people.');
INSERT INTO `site_lang` VALUES ('24', '44', 'Become a member now');
INSERT INTO `site_lang` VALUES ('25', '44', 'Join the worlds bestest community for meeting new people!.');
INSERT INTO `site_lang` VALUES ('26', '44', 'Name');
INSERT INTO `site_lang` VALUES ('27', '44', 'Your name or nickname');
INSERT INTO `site_lang` VALUES ('28', '44', 'Email');
INSERT INTO `site_lang` VALUES ('29', '44', 'Password');
INSERT INTO `site_lang` VALUES ('30', '44', 'Birthday');
INSERT INTO `site_lang` VALUES ('31', '44', 'Please select');
INSERT INTO `site_lang` VALUES ('32', '44', 'City');
INSERT INTO `site_lang` VALUES ('33', '44', 'Where do you live?');
INSERT INTO `site_lang` VALUES ('34', '44', 'Gender');
INSERT INTO `site_lang` VALUES ('35', '44', 'Male');
INSERT INTO `site_lang` VALUES ('36', '44', 'Female');
INSERT INTO `site_lang` VALUES ('37', '44', 'Im here to');
INSERT INTO `site_lang` VALUES ('38', '44', 'Meet girls');
INSERT INTO `site_lang` VALUES ('39', '44', 'Meet boys');
INSERT INTO `site_lang` VALUES ('40', '44', 'Meet boys and girls');
INSERT INTO `site_lang` VALUES ('41', '44', 'Sign up');
INSERT INTO `site_lang` VALUES ('42', '44', 'By continuing, you are confirming that you have read and agree to our');
INSERT INTO `site_lang` VALUES ('43', '44', 'Terms and Conditions');
INSERT INTO `site_lang` VALUES ('44', '44', 'and');
INSERT INTO `site_lang` VALUES ('45', '44', 'Privacy Policy');
INSERT INTO `site_lang` VALUES ('46', '44', 'Profile');
INSERT INTO `site_lang` VALUES ('47', '44', 'Settings');
INSERT INTO `site_lang` VALUES ('48', '44', 'Logout');
INSERT INTO `site_lang` VALUES ('49', '44', 'Meet new people');
INSERT INTO `site_lang` VALUES ('50', '44', 'Discover');
INSERT INTO `site_lang` VALUES ('51', '44', 'Matches');
INSERT INTO `site_lang` VALUES ('52', '44', 'Most populars');
INSERT INTO `site_lang` VALUES ('53', '44', 'Fans');
INSERT INTO `site_lang` VALUES ('54', '44', 'Manage photos');
INSERT INTO `site_lang` VALUES ('55', '44', 'Settings');
INSERT INTO `site_lang` VALUES ('56', '44', 'All');
INSERT INTO `site_lang` VALUES ('57', '44', 'Fans');
INSERT INTO `site_lang` VALUES ('58', '44', 'Conversations');
INSERT INTO `site_lang` VALUES ('59', '44', 'Online now');
INSERT INTO `site_lang` VALUES ('60', '44', 'New messages');
INSERT INTO `site_lang` VALUES ('61', '44', 'Who to like');
INSERT INTO `site_lang` VALUES ('62', '44', 'Terms');
INSERT INTO `site_lang` VALUES ('63', '44', 'Privacy');
INSERT INTO `site_lang` VALUES ('64', '44', 'Contact');
INSERT INTO `site_lang` VALUES ('65', '44', 'Manage your photos');
INSERT INTO `site_lang` VALUES ('66', '44', 'All Photos');
INSERT INTO `site_lang` VALUES ('67', '44', 'Public Photos');
INSERT INTO `site_lang` VALUES ('68', '44', 'Private Photos');
INSERT INTO `site_lang` VALUES ('69', '44', 'Add your photos');
INSERT INTO `site_lang` VALUES ('70', '44', 'add photos');
INSERT INTO `site_lang` VALUES ('71', '44', 'Add yourself to the Spotlight');
INSERT INTO `site_lang` VALUES ('72', '44', 'Pick the photo you want to show in the Spotlight, cost ');
INSERT INTO `site_lang` VALUES ('73', '44', 'Credits');
INSERT INTO `site_lang` VALUES ('74', '44', 'Add photo');
INSERT INTO `site_lang` VALUES ('75', '44', 'Send gift to ');
INSERT INTO `site_lang` VALUES ('76', '44', 'Pick the gift you want to send to ');
INSERT INTO `site_lang` VALUES ('77', '44', 'Send gift');
INSERT INTO `site_lang` VALUES ('78', '44', 'Buy credits / Upgrade account');
INSERT INTO `site_lang` VALUES ('79', '44', 'Select credits package');
INSERT INTO `site_lang` VALUES ('80', '44', 'Select payment method');
INSERT INTO `site_lang` VALUES ('81', '44', 'Pay with');
INSERT INTO `site_lang` VALUES ('82', '44', 'Pay with');
INSERT INTO `site_lang` VALUES ('83', '44', 'Buy credits');
INSERT INTO `site_lang` VALUES ('84', '44', 'Premium Account Features');
INSERT INTO `site_lang` VALUES ('85', '44', 'new chats per day');
INSERT INTO `site_lang` VALUES ('86', '44', 'Unlimited videocalls');
INSERT INTO `site_lang` VALUES ('87', '44', 'Unblock all private photos');
INSERT INTO `site_lang` VALUES ('88', '44', 'Premium user badge');
INSERT INTO `site_lang` VALUES ('89', '44', 'Write text here');
INSERT INTO `site_lang` VALUES ('90', '44', 'Send');
INSERT INTO `site_lang` VALUES ('91', '44', 'Chat');
INSERT INTO `site_lang` VALUES ('92', '44', 'you have reached the limit of new daily conversations');
INSERT INTO `site_lang` VALUES ('93', '44', 'To continue chatting');
INSERT INTO `site_lang` VALUES ('94', '44', 'Buy');
INSERT INTO `site_lang` VALUES ('95', '44', 'more daily conversation');
INSERT INTO `site_lang` VALUES ('96', '44', 'or');
INSERT INTO `site_lang` VALUES ('97', '44', 'Upgrade your account to Premium');
INSERT INTO `site_lang` VALUES ('98', '44', 'and get up to');
INSERT INTO `site_lang` VALUES ('99', '44', 'daily conversations');
INSERT INTO `site_lang` VALUES ('100', '44', 'or wait until tomorrow for continue meeting people');
INSERT INTO `site_lang` VALUES ('101', '44', 'Your fans');
INSERT INTO `site_lang` VALUES ('102', '44', 'Privacy Policy');
INSERT INTO `site_lang` VALUES ('103', '44', 'Terms of Use');
INSERT INTO `site_lang` VALUES ('104', '44', 'Please complete your profile before start in ');
INSERT INTO `site_lang` VALUES ('105', '44', 'Your matches');
INSERT INTO `site_lang` VALUES ('106', '44', 'Filter Search');
INSERT INTO `site_lang` VALUES ('107', '44', 'All users');
INSERT INTO `site_lang` VALUES ('108', '44', 'Online now');
INSERT INTO `site_lang` VALUES ('109', '44', 'Show me');
INSERT INTO `site_lang` VALUES ('110', '44', 'Girls');
INSERT INTO `site_lang` VALUES ('111', '44', 'Boys');
INSERT INTO `site_lang` VALUES ('112', '44', 'Both');
INSERT INTO `site_lang` VALUES ('113', '44', 'who are between');
INSERT INTO `site_lang` VALUES ('114', '44', 'in a radius of');
INSERT INTO `site_lang` VALUES ('115', '44', 'World');
INSERT INTO `site_lang` VALUES ('116', '44', 'Most popular users');
INSERT INTO `site_lang` VALUES ('117', '44', 'About ');
INSERT INTO `site_lang` VALUES ('118', '44', 'Personal info');
INSERT INTO `site_lang` VALUES ('119', '44', 'years old');
INSERT INTO `site_lang` VALUES ('120', '44', 'Only boys');
INSERT INTO `site_lang` VALUES ('121', '44', 'Only girls');
INSERT INTO `site_lang` VALUES ('122', '44', 'boys and girls');
INSERT INTO `site_lang` VALUES ('123', '44', 'Credits successfully added to your account');
INSERT INTO `site_lang` VALUES ('124', '44', 'Now you have');
INSERT INTO `site_lang` VALUES ('125', '44', 'Ask permission to');
INSERT INTO `site_lang` VALUES ('126', '44', 'Unblock private photos');
INSERT INTO `site_lang` VALUES ('127', '44', 'Personal');
INSERT INTO `site_lang` VALUES ('128', '44', 'Credits');
INSERT INTO `site_lang` VALUES ('129', '44', 'Verify');
INSERT INTO `site_lang` VALUES ('130', '44', 'Change password');
INSERT INTO `site_lang` VALUES ('131', '44', 'Delete');
INSERT INTO `site_lang` VALUES ('132', '44', 'Personal information');
INSERT INTO `site_lang` VALUES ('133', '44', 'You can edit your profile information bellow');
INSERT INTO `site_lang` VALUES ('134', '44', 'Site language');
INSERT INTO `site_lang` VALUES ('135', '44', 'Update profile');
INSERT INTO `site_lang` VALUES ('136', '44', 'Verify account');
INSERT INTO `site_lang` VALUES ('137', '44', 'For verify your account , connect with your facebook account');
INSERT INTO `site_lang` VALUES ('138', '44', 'Connect with Facebook');
INSERT INTO `site_lang` VALUES ('139', '44', 'You are account is already verified');
INSERT INTO `site_lang` VALUES ('140', '44', 'Buy credits for send Gifs and Unblock private photos');
INSERT INTO `site_lang` VALUES ('141', '44', 'Account type');
INSERT INTO `site_lang` VALUES ('142', '44', 'Current credits');
INSERT INTO `site_lang` VALUES ('143', '44', 'Add credits');
INSERT INTO `site_lang` VALUES ('144', '44', 'Upgrade to premium account');
INSERT INTO `site_lang` VALUES ('145', '44', 'Change password');
INSERT INTO `site_lang` VALUES ('146', '44', 'You can change your current password bellow');
INSERT INTO `site_lang` VALUES ('147', '44', 'New password');
INSERT INTO `site_lang` VALUES ('148', '44', 'Profile desactivation');
INSERT INTO `site_lang` VALUES ('149', '44', 'After delete your profile, some of your data will be lost without recovery.');
INSERT INTO `site_lang` VALUES ('150', '44', 'Delete profile');
INSERT INTO `site_lang` VALUES ('151', '44', 'Online now');
INSERT INTO `site_lang` VALUES ('152', '44', 'Verified');
INSERT INTO `site_lang` VALUES ('153', '44', 'Nothing found');
INSERT INTO `site_lang` VALUES ('154', '44', 'people found');
INSERT INTO `site_lang` VALUES ('155', '44', 'No popular users near you');
INSERT INTO `site_lang` VALUES ('156', '44', 'You dont have any fans yet');
INSERT INTO `site_lang` VALUES ('157', '44', 'You dont have matches yet');
INSERT INTO `site_lang` VALUES ('158', '44', 'January');
INSERT INTO `site_lang` VALUES ('159', '44', 'February');
INSERT INTO `site_lang` VALUES ('160', '44', 'March');
INSERT INTO `site_lang` VALUES ('161', '44', 'April');
INSERT INTO `site_lang` VALUES ('162', '44', 'May');
INSERT INTO `site_lang` VALUES ('163', '44', 'June');
INSERT INTO `site_lang` VALUES ('164', '44', 'July');
INSERT INTO `site_lang` VALUES ('165', '44', 'August');
INSERT INTO `site_lang` VALUES ('166', '44', 'September');
INSERT INTO `site_lang` VALUES ('167', '44', 'October');
INSERT INTO `site_lang` VALUES ('168', '44', 'November');
INSERT INTO `site_lang` VALUES ('169', '44', 'December');
INSERT INTO `site_lang` VALUES ('170', '44', 'Buy');
INSERT INTO `site_lang` VALUES ('171', '44', 'Days Premium');
INSERT INTO `site_lang` VALUES ('172', '44', 'persons more like this');
INSERT INTO `site_lang` VALUES ('173', '44', 'like this');
INSERT INTO `site_lang` VALUES ('174', '44', 'Hello, can i have access to your private photos ?');
INSERT INTO `site_lang` VALUES ('175', '44', 'Yes');
INSERT INTO `site_lang` VALUES ('176', '44', 'No');
INSERT INTO `site_lang` VALUES ('177', '44', 'Hi');
INSERT INTO `site_lang` VALUES ('178', '44', 'If you dont remember your password, click the link below to set a new one:');
INSERT INTO `site_lang` VALUES ('179', '44', 'Login to my account');
INSERT INTO `site_lang` VALUES ('180', '44', 'Password recover');
INSERT INTO `site_lang` VALUES ('181', '44', 'Invalid email format');
INSERT INTO `site_lang` VALUES ('182', '44', 'Please fill all the inputs');
INSERT INTO `site_lang` VALUES ('183', '44', 'Email dont exist');
INSERT INTO `site_lang` VALUES ('184', '44', 'Wrong password');
INSERT INTO `site_lang` VALUES ('185', '44', 'Add a valid date');
INSERT INTO `site_lang` VALUES ('186', '44', 'Choose city from the autocomplete');
INSERT INTO `site_lang` VALUES ('187', '44', 'Password too short');
INSERT INTO `site_lang` VALUES ('188', '44', 'Email already exist, try another');
INSERT INTO `site_lang` VALUES ('189', '44', 'Yes, you can see my private photos');
INSERT INTO `site_lang` VALUES ('190', '44', 'No, i cant show you my private photos');
INSERT INTO `site_lang` VALUES ('191', '44', 'Buy private photos permission');
INSERT INTO `site_lang` VALUES ('192', '44', 'Get access to');
INSERT INTO `site_lang` VALUES ('193', '44', 'private photos for ');
INSERT INTO `site_lang` VALUES ('194', '44', 'Get access');
INSERT INTO `site_lang` VALUES ('195', '44', 'No thanks');
INSERT INTO `site_lang` VALUES ('196', '44', 'Please, select a payment method');
INSERT INTO `site_lang` VALUES ('197', '44', 'Please, select 1 photo');
INSERT INTO `site_lang` VALUES ('198', '44', 'Please, select 1 gift');
INSERT INTO `site_lang` VALUES ('199', '44', 'You dont have enought credits for send the gift');
INSERT INTO `site_lang` VALUES ('200', '44', 'Expand daily limitation ');
INSERT INTO `site_lang` VALUES ('201', '44', 'more daily conversation, cost ');
INSERT INTO `site_lang` VALUES ('202', '44', 'Yes, buy it!');
INSERT INTO `site_lang` VALUES ('203', '44', 'Information updated successfully');
INSERT INTO `site_lang` VALUES ('204', '44', 'Account termination');
INSERT INTO `site_lang` VALUES ('205', '44', 'Your data will be lost without recovery, continue?');
INSERT INTO `site_lang` VALUES ('206', '44', 'Yes, delete it!');
INSERT INTO `site_lang` VALUES ('207', '44', 'is in another videocall , you cant call now');
INSERT INTO `site_lang` VALUES ('208', '44', 'is offline, try again when your friend is online');
INSERT INTO `site_lang` VALUES ('209', '44', 'Please allow access to your Webcam.');
INSERT INTO `site_lang` VALUES ('210', '44', 'You are already in a videocall, you have to end the other call before start another');
INSERT INTO `site_lang` VALUES ('211', '44', 'Only premium users can make videocalls');
INSERT INTO `site_lang` VALUES ('212', '44', 'Impossible to make a call!');
INSERT INTO `site_lang` VALUES ('213', '44', 'You cant make videocall because you dont have webcam');
INSERT INTO `site_lang` VALUES ('214', '44', 'Too long wait');
INSERT INTO `site_lang` VALUES ('215', '44', 'Seems that your friend do not have webcam or he is not available');
INSERT INTO `site_lang` VALUES ('216', '44', 'End call');
INSERT INTO `site_lang` VALUES ('217', '44', 'Wait more');
INSERT INTO `site_lang` VALUES ('218', '44', 'until');
INSERT INTO `site_lang` VALUES ('219', '44', 'Basic');
INSERT INTO `site_lang` VALUES ('220', '44', 'UPGRADE');
INSERT INTO `site_lang` VALUES ('221', '44', 'Notifications');
INSERT INTO `site_lang` VALUES ('222', '44', 'Extended info (optional)');
INSERT INTO `site_lang` VALUES ('223', '44', 'Relationship');
INSERT INTO `site_lang` VALUES ('224', '44', 'Single');
INSERT INTO `site_lang` VALUES ('225', '44', 'Taken');
INSERT INTO `site_lang` VALUES ('226', '44', 'Open');
INSERT INTO `site_lang` VALUES ('227', '44', 'Sexuality');
INSERT INTO `site_lang` VALUES ('228', '44', 'Gay');
INSERT INTO `site_lang` VALUES ('229', '44', 'Open-minded');
INSERT INTO `site_lang` VALUES ('230', '44', 'Straight');
INSERT INTO `site_lang` VALUES ('231', '44', 'Bisexual');
INSERT INTO `site_lang` VALUES ('232', '44', 'Height');
INSERT INTO `site_lang` VALUES ('233', '44', 'less than');
INSERT INTO `site_lang` VALUES ('234', '44', 'more than');
INSERT INTO `site_lang` VALUES ('235', '44', 'Weight');
INSERT INTO `site_lang` VALUES ('236', '44', 'Ethnicity');
INSERT INTO `site_lang` VALUES ('237', '44', 'Asian');
INSERT INTO `site_lang` VALUES ('238', '44', 'Middle Eastern');
INSERT INTO `site_lang` VALUES ('239', '44', 'Black');
INSERT INTO `site_lang` VALUES ('240', '44', 'White');
INSERT INTO `site_lang` VALUES ('241', '44', 'Native American');
INSERT INTO `site_lang` VALUES ('242', '44', 'Hispanic/latin');
INSERT INTO `site_lang` VALUES ('243', '44', 'Pacific Islander');
INSERT INTO `site_lang` VALUES ('244', '44', 'Indian');
INSERT INTO `site_lang` VALUES ('245', '44', 'Other');
INSERT INTO `site_lang` VALUES ('246', '44', 'Body type');
INSERT INTO `site_lang` VALUES ('247', '44', 'Slim');
INSERT INTO `site_lang` VALUES ('248', '44', 'Average');
INSERT INTO `site_lang` VALUES ('249', '44', 'Athletic');
INSERT INTO `site_lang` VALUES ('250', '44', 'Heavy set');
INSERT INTO `site_lang` VALUES ('251', '44', 'Curvy');
INSERT INTO `site_lang` VALUES ('252', '44', 'Living');
INSERT INTO `site_lang` VALUES ('253', '44', 'With parents');
INSERT INTO `site_lang` VALUES ('254', '44', 'With housemate');
INSERT INTO `site_lang` VALUES ('255', '44', 'Student dormitory');
INSERT INTO `site_lang` VALUES ('256', '44', 'With partner');
INSERT INTO `site_lang` VALUES ('257', '44', 'Alone');
INSERT INTO `site_lang` VALUES ('258', '44', 'Smoke');
INSERT INTO `site_lang` VALUES ('259', '44', 'Yes');
INSERT INTO `site_lang` VALUES ('260', '44', 'No');
INSERT INTO `site_lang` VALUES ('261', '44', 'Sometimes');
INSERT INTO `site_lang` VALUES ('262', '44', 'Drink');
INSERT INTO `site_lang` VALUES ('263', '44', 'Transport');
INSERT INTO `site_lang` VALUES ('264', '44', 'Parents car');
INSERT INTO `site_lang` VALUES ('265', '44', 'I own a car');
INSERT INTO `site_lang` VALUES ('266', '44', 'I own a motorbike');
INSERT INTO `site_lang` VALUES ('267', '44', 'None');
INSERT INTO `site_lang` VALUES ('268', '44', 'When someone likes me');
INSERT INTO `site_lang` VALUES ('269', '44', 'When i get a match');
INSERT INTO `site_lang` VALUES ('270', '44', 'When new users near me join in');
INSERT INTO `site_lang` VALUES ('271', '44', 'When someone send me a message');
INSERT INTO `site_lang` VALUES ('272', '44', 'Day');
INSERT INTO `site_lang` VALUES ('273', '44', 'Month');
INSERT INTO `site_lang` VALUES ('274', '44', 'Year');
INSERT INTO `site_lang` VALUES ('275', '44', 'Please wait');
INSERT INTO `site_lang` VALUES ('276', '44', 'Interests');
INSERT INTO `site_lang` VALUES ('277', '44', 'Report');
INSERT INTO `site_lang` VALUES ('278', '44', 'Fans');
INSERT INTO `site_lang` VALUES ('279', '44', 'No data');
INSERT INTO `site_lang` VALUES ('280', '44', 'Public Photos');
INSERT INTO `site_lang` VALUES ('281', '44', 'Private photos');
INSERT INTO `site_lang` VALUES ('282', '44', 'Add from ');
INSERT INTO `site_lang` VALUES ('283', '44', 'Add');
INSERT INTO `site_lang` VALUES ('284', '44', 'Photos');
INSERT INTO `site_lang` VALUES ('285', '44', 'Credits');
INSERT INTO `site_lang` VALUES ('286', '44', 'Visits');
INSERT INTO `site_lang` VALUES ('287', '44', 'Add me here');
INSERT INTO `site_lang` VALUES ('288', '44', 'get seen by millions');
INSERT INTO `site_lang` VALUES ('289', '44', 'Set as profile');
INSERT INTO `site_lang` VALUES ('290', '44', 'Private photo');
INSERT INTO `site_lang` VALUES ('291', '44', 'Public photo');
INSERT INTO `site_lang` VALUES ('292', '44', 'Delete');
INSERT INTO `site_lang` VALUES ('293', '44', 'people visited your profile for see them');
INSERT INTO `site_lang` VALUES ('294', '44', 'Upgrade your account to premium');
INSERT INTO `site_lang` VALUES ('295', '44', 'People i like');
INSERT INTO `site_lang` VALUES ('296', '44', 'people liked you, for see them');
INSERT INTO `site_lang` VALUES ('297', '44', 'Messages');
INSERT INTO `site_lang` VALUES ('298', '44', 'Like');
INSERT INTO `site_lang` VALUES ('299', '44', 'Dislike');
INSERT INTO `site_lang` VALUES ('300', '44', 'AGE');
INSERT INTO `site_lang` VALUES ('301', '44', 'You dont have any visit yet');
INSERT INTO `site_lang` VALUES ('302', '44', 'visited');
INSERT INTO `site_lang` VALUES ('303', '44', 'You do not like anyone');
INSERT INTO `site_lang` VALUES ('304', '44', 'Cost');
INSERT INTO `site_lang` VALUES ('305', '44', 'Credits for $');
INSERT INTO `site_lang` VALUES ('306', '44', '0 seconds');
INSERT INTO `site_lang` VALUES ('307', '44', 'year');
INSERT INTO `site_lang` VALUES ('308', '44', 'month');
INSERT INTO `site_lang` VALUES ('309', '44', 'day');
INSERT INTO `site_lang` VALUES ('310', '44', 'hour');
INSERT INTO `site_lang` VALUES ('311', '44', 'minute');
INSERT INTO `site_lang` VALUES ('312', '44', 'second');
INSERT INTO `site_lang` VALUES ('313', '44', 'years');
INSERT INTO `site_lang` VALUES ('314', '44', 'months');
INSERT INTO `site_lang` VALUES ('315', '44', 'days');
INSERT INTO `site_lang` VALUES ('316', '44', 'hours');
INSERT INTO `site_lang` VALUES ('317', '44', 'minutes');
INSERT INTO `site_lang` VALUES ('318', '44', 'seconds');
INSERT INTO `site_lang` VALUES ('319', '44', 'ago');
INSERT INTO `site_lang` VALUES ('320', '44', 'Please verify your account, check your email');
INSERT INTO `site_lang` VALUES ('321', '44', 'Please add a profile photo');
INSERT INTO `site_lang` VALUES ('322', '44', 'Hi, im');
INSERT INTO `site_lang` VALUES ('323', '44', 'years old and im from');
INSERT INTO `site_lang` VALUES ('324', '44', 'We sended you a email for verify your account');
INSERT INTO `site_lang` VALUES ('325', '44', 'is blocking you or you blocked him, you cant chat with him sorry');
INSERT INTO `site_lang` VALUES ('326', '44', 'Report and block');
INSERT INTO `site_lang` VALUES ('327', '44', 'Are you sure you want to report');
INSERT INTO `site_lang` VALUES ('328', '44', 'Press backspace key for smart return to the meeting section.');
INSERT INTO `site_lang` VALUES ('329', '44', 'Write your instagram username');
INSERT INTO `site_lang` VALUES ('330', '44', 'You need to write your username!');
INSERT INTO `site_lang` VALUES ('331', '44', 'username');
INSERT INTO `site_lang` VALUES ('332', '44', 'days of Premium');
INSERT INTO `site_lang` VALUES ('333', '44', 'Wrong');
INSERT INTO `site_lang` VALUES ('334', '44', 'Spotlight');
INSERT INTO `site_lang` VALUES ('335', '44', 'Service cost');
INSERT INTO `site_lang` VALUES ('336', '44', 'Password successfully changed');
INSERT INTO `site_lang` VALUES ('337', '44', 'is calling you..');
INSERT INTO `site_lang` VALUES ('338', '44', 'Photos of ');
INSERT INTO `site_lang` VALUES ('339', '44', 'of');
INSERT INTO `site_lang` VALUES ('340', '44', 'Loading...');
INSERT INTO `site_lang` VALUES ('341', '44', 'We sent you a email with your info, it may take up to 1 min to arrive');
INSERT INTO `site_lang` VALUES ('342', '44', 'likes you and wants to chat in');
INSERT INTO `site_lang` VALUES ('343', '44', 'has seen you in discover and likes. The feeling is mutual?');
INSERT INTO `site_lang` VALUES ('344', '44', 'Find out if you also like');
INSERT INTO `site_lang` VALUES ('345', '44', 'You received this notice because you registered as');
INSERT INTO `site_lang` VALUES ('346', '44', 'Unsubscribe');
INSERT INTO `site_lang` VALUES ('347', '44', 'Choose a new password');
INSERT INTO `site_lang` VALUES ('348', '44', 'if you forgot your password, click on the link below to get a new');
INSERT INTO `site_lang` VALUES ('349', '44', 'You have a match at');
INSERT INTO `site_lang` VALUES ('350', '44', 'Its a match!');
INSERT INTO `site_lang` VALUES ('351', '44', 'thinks the feeling is mutual');
INSERT INTO `site_lang` VALUES ('352', '44', 'Go and say something to');
INSERT INTO `site_lang` VALUES ('353', '44', 'New message from');
INSERT INTO `site_lang` VALUES ('354', '44', 'you have a new message from');
INSERT INTO `site_lang` VALUES ('355', '44', 'Respond to');
INSERT INTO `site_lang` VALUES ('356', '44', 'Have fun!');
INSERT INTO `site_lang` VALUES ('357', '44', 'is new and lives closer to you');
INSERT INTO `site_lang` VALUES ('358', '44', 'is new at');
INSERT INTO `site_lang` VALUES ('359', '44', 'and lives closer to you');
INSERT INTO `site_lang` VALUES ('360', '44', 'Check out the profile');
INSERT INTO `site_lang` VALUES ('361', '44', 'Welcome');
INSERT INTO `site_lang` VALUES ('362', '44', 'Well done, now you are in');
INSERT INTO `site_lang` VALUES ('363', '44', 'Here are a few tips');
INSERT INTO `site_lang` VALUES ('364', '44', 'Now you are a new member of');
INSERT INTO `site_lang` VALUES ('365', '44', 'Verify your account');
INSERT INTO `site_lang` VALUES ('366', '44', 'Newsflash');
INSERT INTO `site_lang` VALUES ('367', '44', 'people in your area wants to know you');
INSERT INTO `site_lang` VALUES ('368', '44', 'In');
INSERT INTO `site_lang` VALUES ('369', '44', 'you can meet people instantly');
INSERT INTO `site_lang` VALUES ('370', '44', 'Meet new people');
INSERT INTO `site_lang` VALUES ('371', '44', 'Nobody is going to fall in love with a blank page. The more information you get, the more chances to find that special someone!');
INSERT INTO `site_lang` VALUES ('372', '44', 'Add photos and complete your profile');
INSERT INTO `site_lang` VALUES ('373', '44', 'More than 1 million people have joined $site_name You probably want to know some of them.');
INSERT INTO `site_lang` VALUES ('374', '44', 'Start meeting new people now');
INSERT INTO `site_lang` VALUES ('375', '44', 'Here are your connection details');
INSERT INTO `site_lang` VALUES ('376', '44', 'E-mail');
INSERT INTO `site_lang` VALUES ('377', '44', 'Password');
INSERT INTO `site_lang` VALUES ('378', '44', 'Please save your connection information in a safe place');
INSERT INTO `site_lang` VALUES ('379', '44', 'Go to');
INSERT INTO `site_lang` VALUES ('380', '44', 'Welcome to');
INSERT INTO `site_lang` VALUES ('381', '44', 'calling...');
INSERT INTO `site_lang` VALUES ('382', '44', 'dont like you');
INSERT INTO `site_lang` VALUES ('383', '44', 'must like you for start a videocall');
INSERT INTO `site_lang` VALUES ('384', '44', 'Ok, i understand');
INSERT INTO `site_lang` VALUES ('381', '45', 'calling...');
INSERT INTO `site_lang` VALUES ('382', '45', 'dont like you');
INSERT INTO `site_lang` VALUES ('383', '45', 'must like you for start a videocall');
INSERT INTO `site_lang` VALUES ('384', '45', 'Ok, i understand');
INSERT INTO `site_lang` VALUES ('0', '46', 'meet new people!');
INSERT INTO `site_lang` VALUES ('1', '46', 'Login');
INSERT INTO `site_lang` VALUES ('2', '46', 'Welcome to the fastest growing place to meet new people');
INSERT INTO `site_lang` VALUES ('3', '46', 'For now our site works only for Desktop users');
INSERT INTO `site_lang` VALUES ('4', '46', 'Please visit us from your laptop or PC');
INSERT INTO `site_lang` VALUES ('5', '46', 'Soon we will have our phone apps online');
INSERT INTO `site_lang` VALUES ('6', '46', 'SOON AVAILABLE');
INSERT INTO `site_lang` VALUES ('7', '46', 'Connect with ');
INSERT INTO `site_lang` VALUES ('8', '46', 'Create your account');
INSERT INTO `site_lang` VALUES ('9', '46', 'Welcome back');
INSERT INTO `site_lang` VALUES ('10', '46', 'Your email');
INSERT INTO `site_lang` VALUES ('11', '46', 'Your password');
INSERT INTO `site_lang` VALUES ('12', '46', 'do you forget your password?');
INSERT INTO `site_lang` VALUES ('13', '46', 'Login now');
INSERT INTO `site_lang` VALUES ('14', '46', 'Password recover');
INSERT INTO `site_lang` VALUES ('15', '46', 'Recover password');
INSERT INTO `site_lang` VALUES ('16', '46', 'Chat');
INSERT INTO `site_lang` VALUES ('17', '46', 'Powerfull private chat for meet new friends, you can send emoticons and private photos to anyone.');
INSERT INTO `site_lang` VALUES ('18', '46', 'Video Chat');
INSERT INTO `site_lang` VALUES ('19', '46', 'You can make quality videocalls for free to anyone, without limits of call duration, just enjoy seeing the person who is chatting with you');
INSERT INTO `site_lang` VALUES ('20', '46', 'People nearby');
INSERT INTO `site_lang` VALUES ('21', '46', 'We wont show your exact location, but you will be able to find people nearby who like the same things you do.');
INSERT INTO `site_lang` VALUES ('22', '46', 'Matches');
INSERT INTO `site_lang` VALUES ('23', '46', 'Play our popular Discover game and get matched with other users. Its a great way to break the ice and chat to new people.');
INSERT INTO `site_lang` VALUES ('24', '46', 'Become a member now');
INSERT INTO `site_lang` VALUES ('25', '46', 'Join the worlds bestest community for meeting new people!.');
INSERT INTO `site_lang` VALUES ('26', '46', 'Name');
INSERT INTO `site_lang` VALUES ('27', '46', 'Your name or nickname');
INSERT INTO `site_lang` VALUES ('28', '46', 'Email');
INSERT INTO `site_lang` VALUES ('29', '46', 'Password');
INSERT INTO `site_lang` VALUES ('30', '46', 'Birthday');
INSERT INTO `site_lang` VALUES ('31', '46', 'Please select');
INSERT INTO `site_lang` VALUES ('32', '46', 'City');
INSERT INTO `site_lang` VALUES ('33', '46', 'Where do you live?');
INSERT INTO `site_lang` VALUES ('34', '46', 'Gender');
INSERT INTO `site_lang` VALUES ('35', '46', 'Male');
INSERT INTO `site_lang` VALUES ('36', '46', 'Female');
INSERT INTO `site_lang` VALUES ('37', '46', 'Im here to');
INSERT INTO `site_lang` VALUES ('38', '46', 'Meet girls');
INSERT INTO `site_lang` VALUES ('39', '46', 'Meet boys');
INSERT INTO `site_lang` VALUES ('40', '46', 'Meet boys and girls');
INSERT INTO `site_lang` VALUES ('41', '46', 'Sign up');
INSERT INTO `site_lang` VALUES ('42', '46', 'By continuing, you are confirming that you have read and agree to our');
INSERT INTO `site_lang` VALUES ('43', '46', 'Terms and Conditions');
INSERT INTO `site_lang` VALUES ('44', '46', 'and');
INSERT INTO `site_lang` VALUES ('45', '46', 'Privacy Policy');
INSERT INTO `site_lang` VALUES ('46', '46', 'Profile');
INSERT INTO `site_lang` VALUES ('47', '46', 'Settings');
INSERT INTO `site_lang` VALUES ('48', '46', 'Logout');
INSERT INTO `site_lang` VALUES ('49', '46', 'Meet new people');
INSERT INTO `site_lang` VALUES ('50', '46', 'Discover');
INSERT INTO `site_lang` VALUES ('51', '46', 'Matches');
INSERT INTO `site_lang` VALUES ('52', '46', 'Most populars');
INSERT INTO `site_lang` VALUES ('53', '46', 'Fans');
INSERT INTO `site_lang` VALUES ('54', '46', 'Manage photos');
INSERT INTO `site_lang` VALUES ('55', '46', 'Settings');
INSERT INTO `site_lang` VALUES ('56', '46', 'All');
INSERT INTO `site_lang` VALUES ('57', '46', 'Fans');
INSERT INTO `site_lang` VALUES ('58', '46', 'Conversations');
INSERT INTO `site_lang` VALUES ('59', '46', 'Online now');
INSERT INTO `site_lang` VALUES ('60', '46', 'New messages');
INSERT INTO `site_lang` VALUES ('61', '46', 'Who to like');
INSERT INTO `site_lang` VALUES ('62', '46', 'Terms');
INSERT INTO `site_lang` VALUES ('63', '46', 'Privacy');
INSERT INTO `site_lang` VALUES ('64', '46', 'Contact');
INSERT INTO `site_lang` VALUES ('65', '46', 'Manage your photos');
INSERT INTO `site_lang` VALUES ('66', '46', 'All Photos');
INSERT INTO `site_lang` VALUES ('67', '46', 'Public Photos');
INSERT INTO `site_lang` VALUES ('68', '46', 'Private Photos');
INSERT INTO `site_lang` VALUES ('69', '46', 'Add your photos');
INSERT INTO `site_lang` VALUES ('70', '46', 'add photos');
INSERT INTO `site_lang` VALUES ('71', '46', 'Add yourself to the Spotlight');
INSERT INTO `site_lang` VALUES ('72', '46', 'Pick the photo you want to show in the Spotlight, cost ');
INSERT INTO `site_lang` VALUES ('73', '46', 'Credits');
INSERT INTO `site_lang` VALUES ('74', '46', 'Add photo');
INSERT INTO `site_lang` VALUES ('75', '46', 'Send gift to ');
INSERT INTO `site_lang` VALUES ('76', '46', 'Pick the gift you want to send to ');
INSERT INTO `site_lang` VALUES ('77', '46', 'Send gift');
INSERT INTO `site_lang` VALUES ('78', '46', 'Buy credits / Upgrade account');
INSERT INTO `site_lang` VALUES ('79', '46', 'Select credits package');
INSERT INTO `site_lang` VALUES ('80', '46', 'Select payment method');
INSERT INTO `site_lang` VALUES ('81', '46', 'Pay with');
INSERT INTO `site_lang` VALUES ('82', '46', 'Pay with');
INSERT INTO `site_lang` VALUES ('83', '46', 'Buy credits');
INSERT INTO `site_lang` VALUES ('84', '46', 'Premium Account Features');
INSERT INTO `site_lang` VALUES ('85', '46', 'new chats per day');
INSERT INTO `site_lang` VALUES ('86', '46', 'Unlimited videocalls');
INSERT INTO `site_lang` VALUES ('87', '46', 'Unblock all private photos');
INSERT INTO `site_lang` VALUES ('88', '46', 'Premium user badge');
INSERT INTO `site_lang` VALUES ('89', '46', 'Write text here');
INSERT INTO `site_lang` VALUES ('90', '46', 'Send');
INSERT INTO `site_lang` VALUES ('91', '46', 'Chat');
INSERT INTO `site_lang` VALUES ('92', '46', 'you have reached the limit of new daily conversations');
INSERT INTO `site_lang` VALUES ('93', '46', 'To continue chatting');
INSERT INTO `site_lang` VALUES ('94', '46', 'Buy');
INSERT INTO `site_lang` VALUES ('95', '46', 'more daily conversation');
INSERT INTO `site_lang` VALUES ('96', '46', 'or');
INSERT INTO `site_lang` VALUES ('97', '46', 'Upgrade your account to Premium');
INSERT INTO `site_lang` VALUES ('98', '46', 'and get up to');
INSERT INTO `site_lang` VALUES ('99', '46', 'daily conversations');
INSERT INTO `site_lang` VALUES ('100', '46', 'or wait until tomorrow for continue meeting people');
INSERT INTO `site_lang` VALUES ('101', '46', 'Your fans');
INSERT INTO `site_lang` VALUES ('102', '46', 'Privacy Policy');
INSERT INTO `site_lang` VALUES ('103', '46', 'Terms of Use');
INSERT INTO `site_lang` VALUES ('104', '46', 'Please complete your profile before start in ');
INSERT INTO `site_lang` VALUES ('105', '46', 'Your matches');
INSERT INTO `site_lang` VALUES ('106', '46', 'Filter Search');
INSERT INTO `site_lang` VALUES ('107', '46', 'All users');
INSERT INTO `site_lang` VALUES ('108', '46', 'Online now');
INSERT INTO `site_lang` VALUES ('109', '46', 'Show me');
INSERT INTO `site_lang` VALUES ('110', '46', 'Girls');
INSERT INTO `site_lang` VALUES ('111', '46', 'Boys');
INSERT INTO `site_lang` VALUES ('112', '46', 'Both');
INSERT INTO `site_lang` VALUES ('113', '46', 'who are between');
INSERT INTO `site_lang` VALUES ('114', '46', 'in a radius of');
INSERT INTO `site_lang` VALUES ('115', '46', 'World');
INSERT INTO `site_lang` VALUES ('116', '46', 'Most popular users');
INSERT INTO `site_lang` VALUES ('117', '46', 'About ');
INSERT INTO `site_lang` VALUES ('118', '46', 'Personal info');
INSERT INTO `site_lang` VALUES ('119', '46', 'years old');
INSERT INTO `site_lang` VALUES ('120', '46', 'Only boys');
INSERT INTO `site_lang` VALUES ('121', '46', 'Only girls');
INSERT INTO `site_lang` VALUES ('122', '46', 'boys and girls');
INSERT INTO `site_lang` VALUES ('123', '46', 'Credits successfully added to your account');
INSERT INTO `site_lang` VALUES ('124', '46', 'Now you have');
INSERT INTO `site_lang` VALUES ('125', '46', 'Ask permission to');
INSERT INTO `site_lang` VALUES ('126', '46', 'Unblock private photos');
INSERT INTO `site_lang` VALUES ('127', '46', 'Personal');
INSERT INTO `site_lang` VALUES ('128', '46', 'Credits');
INSERT INTO `site_lang` VALUES ('129', '46', 'Verify');
INSERT INTO `site_lang` VALUES ('130', '46', 'Change password');
INSERT INTO `site_lang` VALUES ('131', '46', 'Delete');
INSERT INTO `site_lang` VALUES ('132', '46', 'Personal information');
INSERT INTO `site_lang` VALUES ('133', '46', 'You can edit your profile information bellow');
INSERT INTO `site_lang` VALUES ('134', '46', 'Site language');
INSERT INTO `site_lang` VALUES ('135', '46', 'Update profile');
INSERT INTO `site_lang` VALUES ('136', '46', 'Verify account');
INSERT INTO `site_lang` VALUES ('137', '46', 'For verify your account , connect with your facebook account');
INSERT INTO `site_lang` VALUES ('138', '46', 'Connect with Facebook');
INSERT INTO `site_lang` VALUES ('139', '46', 'You are account is already verified');
INSERT INTO `site_lang` VALUES ('140', '46', 'Buy credits for send Gifs and Unblock private photos');
INSERT INTO `site_lang` VALUES ('141', '46', 'Account type');
INSERT INTO `site_lang` VALUES ('142', '46', 'Current credits');
INSERT INTO `site_lang` VALUES ('143', '46', 'Add credits');
INSERT INTO `site_lang` VALUES ('144', '46', 'Upgrade to premium account');
INSERT INTO `site_lang` VALUES ('145', '46', 'Change password');
INSERT INTO `site_lang` VALUES ('146', '46', 'You can change your current password bellow');
INSERT INTO `site_lang` VALUES ('147', '46', 'New password');
INSERT INTO `site_lang` VALUES ('148', '46', 'Profile desactivation');
INSERT INTO `site_lang` VALUES ('149', '46', 'After delete your profile, some of your data will be lost without recovery.');
INSERT INTO `site_lang` VALUES ('150', '46', 'Delete profile');
INSERT INTO `site_lang` VALUES ('151', '46', 'Online now');
INSERT INTO `site_lang` VALUES ('152', '46', 'Verified');
INSERT INTO `site_lang` VALUES ('153', '46', 'Nothing found');
INSERT INTO `site_lang` VALUES ('154', '46', 'people found');
INSERT INTO `site_lang` VALUES ('155', '46', 'No popular users near you');
INSERT INTO `site_lang` VALUES ('156', '46', 'You dont have any fans yet');
INSERT INTO `site_lang` VALUES ('157', '46', 'You dont have matches yet');
INSERT INTO `site_lang` VALUES ('158', '46', 'January');
INSERT INTO `site_lang` VALUES ('159', '46', 'February');
INSERT INTO `site_lang` VALUES ('160', '46', 'March');
INSERT INTO `site_lang` VALUES ('161', '46', 'April');
INSERT INTO `site_lang` VALUES ('162', '46', 'May');
INSERT INTO `site_lang` VALUES ('163', '46', 'June');
INSERT INTO `site_lang` VALUES ('164', '46', 'July');
INSERT INTO `site_lang` VALUES ('165', '46', 'August');
INSERT INTO `site_lang` VALUES ('166', '46', 'September');
INSERT INTO `site_lang` VALUES ('167', '46', 'October');
INSERT INTO `site_lang` VALUES ('168', '46', 'November');
INSERT INTO `site_lang` VALUES ('169', '46', 'December');
INSERT INTO `site_lang` VALUES ('170', '46', 'Buy');
INSERT INTO `site_lang` VALUES ('171', '46', 'Days Premium');
INSERT INTO `site_lang` VALUES ('172', '46', 'persons more like this');
INSERT INTO `site_lang` VALUES ('173', '46', 'like this');
INSERT INTO `site_lang` VALUES ('174', '46', 'Hello, can i have access to your private photos ?');
INSERT INTO `site_lang` VALUES ('175', '46', 'Yes');
INSERT INTO `site_lang` VALUES ('176', '46', 'No');
INSERT INTO `site_lang` VALUES ('177', '46', 'Hi');
INSERT INTO `site_lang` VALUES ('178', '46', 'If you dont remember your password, click the link below to set a new one:');
INSERT INTO `site_lang` VALUES ('179', '46', 'Login to my account');
INSERT INTO `site_lang` VALUES ('180', '46', 'Password recover');
INSERT INTO `site_lang` VALUES ('181', '46', 'Invalid email format');
INSERT INTO `site_lang` VALUES ('182', '46', 'Please fill all the inputs');
INSERT INTO `site_lang` VALUES ('183', '46', 'Email dont exist');
INSERT INTO `site_lang` VALUES ('184', '46', 'Wrong password');
INSERT INTO `site_lang` VALUES ('185', '46', 'Add a valid date');
INSERT INTO `site_lang` VALUES ('186', '46', 'Choose city from the autocomplete');
INSERT INTO `site_lang` VALUES ('187', '46', 'Password too short');
INSERT INTO `site_lang` VALUES ('188', '46', 'Email already exist, try another');
INSERT INTO `site_lang` VALUES ('189', '46', 'Yes, you can see my private photos');
INSERT INTO `site_lang` VALUES ('190', '46', 'No, i cant show you my private photos');
INSERT INTO `site_lang` VALUES ('191', '46', 'Buy private photos permission');
INSERT INTO `site_lang` VALUES ('192', '46', 'Get access to');
INSERT INTO `site_lang` VALUES ('193', '46', 'private photos for ');
INSERT INTO `site_lang` VALUES ('194', '46', 'Get access');
INSERT INTO `site_lang` VALUES ('195', '46', 'No thanks');
INSERT INTO `site_lang` VALUES ('196', '46', 'Please, select a payment method');
INSERT INTO `site_lang` VALUES ('197', '46', 'Please, select 1 photo');
INSERT INTO `site_lang` VALUES ('198', '46', 'Please, select 1 gift');
INSERT INTO `site_lang` VALUES ('199', '46', 'You dont have enought credits for send the gift');
INSERT INTO `site_lang` VALUES ('200', '46', 'Expand daily limitation ');
INSERT INTO `site_lang` VALUES ('201', '46', 'more daily conversation, cost ');
INSERT INTO `site_lang` VALUES ('202', '46', 'Yes, buy it!');
INSERT INTO `site_lang` VALUES ('203', '46', 'Information updated successfully');
INSERT INTO `site_lang` VALUES ('204', '46', 'Account termination');
INSERT INTO `site_lang` VALUES ('205', '46', 'Your data will be lost without recovery, continue?');
INSERT INTO `site_lang` VALUES ('206', '46', 'Yes, delete it!');
INSERT INTO `site_lang` VALUES ('207', '46', 'is in another videocall , you cant call now');
INSERT INTO `site_lang` VALUES ('208', '46', 'is offline, try again when your friend is online');
INSERT INTO `site_lang` VALUES ('209', '46', 'Please allow access to your Webcam.');
INSERT INTO `site_lang` VALUES ('210', '46', 'You are already in a videocall, you have to end the other call before start another');
INSERT INTO `site_lang` VALUES ('211', '46', 'Only premium users can make videocalls');
INSERT INTO `site_lang` VALUES ('212', '46', 'Impossible to make a call!');
INSERT INTO `site_lang` VALUES ('213', '46', 'You cant make videocall because you dont have webcam');
INSERT INTO `site_lang` VALUES ('214', '46', 'Too long wait');
INSERT INTO `site_lang` VALUES ('215', '46', 'Seems that your friend do not have webcam or he is not available');
INSERT INTO `site_lang` VALUES ('216', '46', 'End call');
INSERT INTO `site_lang` VALUES ('217', '46', 'Wait more');
INSERT INTO `site_lang` VALUES ('218', '46', 'until');
INSERT INTO `site_lang` VALUES ('219', '46', 'Basic');
INSERT INTO `site_lang` VALUES ('220', '46', 'UPGRADE');
INSERT INTO `site_lang` VALUES ('221', '46', 'Notifications');
INSERT INTO `site_lang` VALUES ('222', '46', 'Extended info (optional)');
INSERT INTO `site_lang` VALUES ('223', '46', 'Relationship');
INSERT INTO `site_lang` VALUES ('224', '46', 'Single');
INSERT INTO `site_lang` VALUES ('225', '46', 'Taken');
INSERT INTO `site_lang` VALUES ('226', '46', 'Open');
INSERT INTO `site_lang` VALUES ('227', '46', 'Sexuality');
INSERT INTO `site_lang` VALUES ('228', '46', 'Gay');
INSERT INTO `site_lang` VALUES ('229', '46', 'Open-minded');
INSERT INTO `site_lang` VALUES ('230', '46', 'Straight');
INSERT INTO `site_lang` VALUES ('231', '46', 'Bisexual');
INSERT INTO `site_lang` VALUES ('232', '46', 'Height');
INSERT INTO `site_lang` VALUES ('233', '46', 'less than');
INSERT INTO `site_lang` VALUES ('234', '46', 'more than');
INSERT INTO `site_lang` VALUES ('235', '46', 'Weight');
INSERT INTO `site_lang` VALUES ('236', '46', 'Ethnicity');
INSERT INTO `site_lang` VALUES ('237', '46', 'Asian');
INSERT INTO `site_lang` VALUES ('238', '46', 'Middle Eastern');
INSERT INTO `site_lang` VALUES ('239', '46', 'Black');
INSERT INTO `site_lang` VALUES ('240', '46', 'White');
INSERT INTO `site_lang` VALUES ('241', '46', 'Native American');
INSERT INTO `site_lang` VALUES ('242', '46', 'Hispanic/latin');
INSERT INTO `site_lang` VALUES ('243', '46', 'Pacific Islander');
INSERT INTO `site_lang` VALUES ('244', '46', 'Indian');
INSERT INTO `site_lang` VALUES ('245', '46', 'Other');
INSERT INTO `site_lang` VALUES ('246', '46', 'Body type');
INSERT INTO `site_lang` VALUES ('247', '46', 'Slim');
INSERT INTO `site_lang` VALUES ('248', '46', 'Average');
INSERT INTO `site_lang` VALUES ('249', '46', 'Athletic');
INSERT INTO `site_lang` VALUES ('250', '46', 'Heavy set');
INSERT INTO `site_lang` VALUES ('251', '46', 'Curvy');
INSERT INTO `site_lang` VALUES ('252', '46', 'Living');
INSERT INTO `site_lang` VALUES ('253', '46', 'With parents');
INSERT INTO `site_lang` VALUES ('254', '46', 'With housemate');
INSERT INTO `site_lang` VALUES ('255', '46', 'Student dormitory');
INSERT INTO `site_lang` VALUES ('256', '46', 'With partner');
INSERT INTO `site_lang` VALUES ('257', '46', 'Alone');
INSERT INTO `site_lang` VALUES ('258', '46', 'Smoke');
INSERT INTO `site_lang` VALUES ('259', '46', 'Yes');
INSERT INTO `site_lang` VALUES ('260', '46', 'No');
INSERT INTO `site_lang` VALUES ('261', '46', 'Sometimes');
INSERT INTO `site_lang` VALUES ('262', '46', 'Drink');
INSERT INTO `site_lang` VALUES ('263', '46', 'Transport');
INSERT INTO `site_lang` VALUES ('264', '46', 'Parents car');
INSERT INTO `site_lang` VALUES ('265', '46', 'I own a car');
INSERT INTO `site_lang` VALUES ('266', '46', 'I own a motorbike');
INSERT INTO `site_lang` VALUES ('267', '46', 'None');
INSERT INTO `site_lang` VALUES ('268', '46', 'When someone likes me');
INSERT INTO `site_lang` VALUES ('269', '46', 'When i get a match');
INSERT INTO `site_lang` VALUES ('270', '46', 'When new users near me join in');
INSERT INTO `site_lang` VALUES ('271', '46', 'When someone send me a message');
INSERT INTO `site_lang` VALUES ('272', '46', 'Day');
INSERT INTO `site_lang` VALUES ('273', '46', 'Month');
INSERT INTO `site_lang` VALUES ('274', '46', 'Year');
INSERT INTO `site_lang` VALUES ('275', '46', 'Please wait');
INSERT INTO `site_lang` VALUES ('276', '46', 'Interests');
INSERT INTO `site_lang` VALUES ('277', '46', 'Report');
INSERT INTO `site_lang` VALUES ('278', '46', 'Fans');
INSERT INTO `site_lang` VALUES ('279', '46', 'No data');
INSERT INTO `site_lang` VALUES ('280', '46', 'Public Photos');
INSERT INTO `site_lang` VALUES ('281', '46', 'Private photos');
INSERT INTO `site_lang` VALUES ('282', '46', 'Add from ');
INSERT INTO `site_lang` VALUES ('283', '46', 'Add');
INSERT INTO `site_lang` VALUES ('284', '46', 'Photos');
INSERT INTO `site_lang` VALUES ('285', '46', 'Credits');
INSERT INTO `site_lang` VALUES ('286', '46', 'Visits');
INSERT INTO `site_lang` VALUES ('287', '46', 'Add me here');
INSERT INTO `site_lang` VALUES ('288', '46', 'get seen by millions');
INSERT INTO `site_lang` VALUES ('289', '46', 'Set as profile');
INSERT INTO `site_lang` VALUES ('290', '46', 'Private photo');
INSERT INTO `site_lang` VALUES ('291', '46', 'Public photo');
INSERT INTO `site_lang` VALUES ('292', '46', 'Delete');
INSERT INTO `site_lang` VALUES ('293', '46', 'people visited your profile for see them');
INSERT INTO `site_lang` VALUES ('294', '46', 'Upgrade your account to premium');
INSERT INTO `site_lang` VALUES ('295', '46', 'People i like');
INSERT INTO `site_lang` VALUES ('296', '46', 'people liked you, for see them');
INSERT INTO `site_lang` VALUES ('297', '46', 'Messages');
INSERT INTO `site_lang` VALUES ('298', '46', 'Like');
INSERT INTO `site_lang` VALUES ('299', '46', 'Dislike');
INSERT INTO `site_lang` VALUES ('300', '46', 'AGE');
INSERT INTO `site_lang` VALUES ('301', '46', 'You dont have any visit yet');
INSERT INTO `site_lang` VALUES ('302', '46', 'visited');
INSERT INTO `site_lang` VALUES ('303', '46', 'You do not like anyone');
INSERT INTO `site_lang` VALUES ('304', '46', 'Cost');
INSERT INTO `site_lang` VALUES ('305', '46', 'Credits for $');
INSERT INTO `site_lang` VALUES ('306', '46', '0 seconds');
INSERT INTO `site_lang` VALUES ('307', '46', 'year');
INSERT INTO `site_lang` VALUES ('308', '46', 'month');
INSERT INTO `site_lang` VALUES ('309', '46', 'day');
INSERT INTO `site_lang` VALUES ('310', '46', 'hour');
INSERT INTO `site_lang` VALUES ('311', '46', 'minute');
INSERT INTO `site_lang` VALUES ('312', '46', 'second');
INSERT INTO `site_lang` VALUES ('313', '46', 'years');
INSERT INTO `site_lang` VALUES ('314', '46', 'months');
INSERT INTO `site_lang` VALUES ('315', '46', 'days');
INSERT INTO `site_lang` VALUES ('316', '46', 'hours');
INSERT INTO `site_lang` VALUES ('317', '46', 'minutes');
INSERT INTO `site_lang` VALUES ('318', '46', 'seconds');
INSERT INTO `site_lang` VALUES ('319', '46', 'ago');
INSERT INTO `site_lang` VALUES ('320', '46', 'Please verify your account, check your email');
INSERT INTO `site_lang` VALUES ('321', '46', 'Please add a profile photo');
INSERT INTO `site_lang` VALUES ('322', '46', 'Hi, im');
INSERT INTO `site_lang` VALUES ('323', '46', 'years old and im from');
INSERT INTO `site_lang` VALUES ('324', '46', 'We sended you a email for verify your account');
INSERT INTO `site_lang` VALUES ('325', '46', 'is blocking you or you blocked him, you cant chat with him sorry');
INSERT INTO `site_lang` VALUES ('326', '46', 'Report and block');
INSERT INTO `site_lang` VALUES ('327', '46', 'Are you sure you want to report');
INSERT INTO `site_lang` VALUES ('328', '46', 'Press backspace key for smart return to the meeting section.');
INSERT INTO `site_lang` VALUES ('329', '46', 'Write your instagram username');
INSERT INTO `site_lang` VALUES ('330', '46', 'You need to write your username!');
INSERT INTO `site_lang` VALUES ('331', '46', 'username');
INSERT INTO `site_lang` VALUES ('332', '46', 'days of Premium');
INSERT INTO `site_lang` VALUES ('333', '46', 'Wrong');
INSERT INTO `site_lang` VALUES ('334', '46', 'Spotlight');
INSERT INTO `site_lang` VALUES ('335', '46', 'Service cost');
INSERT INTO `site_lang` VALUES ('336', '46', 'Password successfully changed');
INSERT INTO `site_lang` VALUES ('337', '46', 'is calling you..');
INSERT INTO `site_lang` VALUES ('338', '46', 'Photos of ');
INSERT INTO `site_lang` VALUES ('339', '46', 'of');
INSERT INTO `site_lang` VALUES ('340', '46', 'Loading...');
INSERT INTO `site_lang` VALUES ('341', '46', 'We sent you a email with your info, it may take up to 1 min to arrive');
INSERT INTO `site_lang` VALUES ('342', '46', 'likes you and wants to chat in');
INSERT INTO `site_lang` VALUES ('343', '46', 'has seen you in discover and likes. The feeling is mutual?');
INSERT INTO `site_lang` VALUES ('344', '46', 'Find out if you also like');
INSERT INTO `site_lang` VALUES ('345', '46', 'You received this notice because you registered as');
INSERT INTO `site_lang` VALUES ('346', '46', 'Unsubscribe');
INSERT INTO `site_lang` VALUES ('347', '46', 'Choose a new password');
INSERT INTO `site_lang` VALUES ('348', '46', 'if you forgot your password, click on the link below to get a new');
INSERT INTO `site_lang` VALUES ('349', '46', 'You have a match at');
INSERT INTO `site_lang` VALUES ('350', '46', 'Its a match!');
INSERT INTO `site_lang` VALUES ('351', '46', 'thinks the feeling is mutual');
INSERT INTO `site_lang` VALUES ('352', '46', 'Go and say something to');
INSERT INTO `site_lang` VALUES ('353', '46', 'New message from');
INSERT INTO `site_lang` VALUES ('354', '46', 'you have a new message from');
INSERT INTO `site_lang` VALUES ('355', '46', 'Respond to');
INSERT INTO `site_lang` VALUES ('356', '46', 'Have fun!');
INSERT INTO `site_lang` VALUES ('357', '46', 'is new and lives closer to you');
INSERT INTO `site_lang` VALUES ('358', '46', 'is new at');
INSERT INTO `site_lang` VALUES ('359', '46', 'and lives closer to you');
INSERT INTO `site_lang` VALUES ('360', '46', 'Check out the profile');
INSERT INTO `site_lang` VALUES ('361', '46', 'Welcome');
INSERT INTO `site_lang` VALUES ('362', '46', 'Well done, now you are in');
INSERT INTO `site_lang` VALUES ('363', '46', 'Here are a few tips');
INSERT INTO `site_lang` VALUES ('364', '46', 'Now you are a new member of');
INSERT INTO `site_lang` VALUES ('365', '46', 'Verify your account');
INSERT INTO `site_lang` VALUES ('366', '46', 'Newsflash');
INSERT INTO `site_lang` VALUES ('367', '46', 'people in your area wants to know you');
INSERT INTO `site_lang` VALUES ('368', '46', 'In');
INSERT INTO `site_lang` VALUES ('369', '46', 'you can meet people instantly');
INSERT INTO `site_lang` VALUES ('370', '46', 'Meet new people');
INSERT INTO `site_lang` VALUES ('371', '46', 'Nobody is going to fall in love with a blank page. The more information you get, the more chances to find that special someone!');
INSERT INTO `site_lang` VALUES ('372', '46', 'Add photos and complete your profile');
INSERT INTO `site_lang` VALUES ('373', '46', 'More than 1 million people have joined $site_name You probably want to know some of them.');
INSERT INTO `site_lang` VALUES ('374', '46', 'Start meeting new people now');
INSERT INTO `site_lang` VALUES ('375', '46', 'Here are your connection details');
INSERT INTO `site_lang` VALUES ('376', '46', 'E-mail');
INSERT INTO `site_lang` VALUES ('377', '46', 'Password');
INSERT INTO `site_lang` VALUES ('378', '46', 'Please save your connection information in a safe place');
INSERT INTO `site_lang` VALUES ('379', '46', 'Go to');
INSERT INTO `site_lang` VALUES ('380', '46', 'Welcome to');
INSERT INTO `site_lang` VALUES ('381', '46', 'calling...');
INSERT INTO `site_lang` VALUES ('382', '46', 'dont like you');
INSERT INTO `site_lang` VALUES ('383', '46', 'must like you for start a videocall');
INSERT INTO `site_lang` VALUES ('384', '46', 'Ok, i understand');
INSERT INTO `site_lang` VALUES ('0', '47', 'meet new people!');
INSERT INTO `site_lang` VALUES ('1', '47', 'Login');
INSERT INTO `site_lang` VALUES ('2', '47', 'Welcome to the fastest growing place to meet new people');
INSERT INTO `site_lang` VALUES ('3', '47', 'For now our site works only for Desktop users');
INSERT INTO `site_lang` VALUES ('4', '47', 'Please visit us from your laptop or PC');
INSERT INTO `site_lang` VALUES ('5', '47', 'Soon we will have our phone apps online');
INSERT INTO `site_lang` VALUES ('6', '47', 'SOON AVAILABLE');
INSERT INTO `site_lang` VALUES ('7', '47', 'Connect with ');
INSERT INTO `site_lang` VALUES ('8', '47', 'Create your account');
INSERT INTO `site_lang` VALUES ('9', '47', 'Welcome back');
INSERT INTO `site_lang` VALUES ('10', '47', 'Your email');
INSERT INTO `site_lang` VALUES ('11', '47', 'Your password');
INSERT INTO `site_lang` VALUES ('12', '47', 'do you forget your password?');
INSERT INTO `site_lang` VALUES ('13', '47', 'Login now');
INSERT INTO `site_lang` VALUES ('14', '47', 'Password recover');
INSERT INTO `site_lang` VALUES ('15', '47', 'Recover password');
INSERT INTO `site_lang` VALUES ('16', '47', 'Chat');
INSERT INTO `site_lang` VALUES ('17', '47', 'Powerfull private chat for meet new friends, you can send emoticons and private photos to anyone.');
INSERT INTO `site_lang` VALUES ('18', '47', 'Video Chat');
INSERT INTO `site_lang` VALUES ('19', '47', 'You can make quality videocalls for free to anyone, without limits of call duration, just enjoy seeing the person who is chatting with you');
INSERT INTO `site_lang` VALUES ('20', '47', 'People nearby');
INSERT INTO `site_lang` VALUES ('21', '47', 'We wont show your exact location, but you will be able to find people nearby who like the same things you do.');
INSERT INTO `site_lang` VALUES ('22', '47', 'Matches');
INSERT INTO `site_lang` VALUES ('23', '47', 'Play our popular Discover game and get matched with other users. Its a great way to break the ice and chat to new people.');
INSERT INTO `site_lang` VALUES ('24', '47', 'Become a member now');
INSERT INTO `site_lang` VALUES ('25', '47', 'Join the worlds bestest community for meeting new people!.');
INSERT INTO `site_lang` VALUES ('26', '47', 'Name');
INSERT INTO `site_lang` VALUES ('27', '47', 'Your name or nickname');
INSERT INTO `site_lang` VALUES ('28', '47', 'Email');
INSERT INTO `site_lang` VALUES ('29', '47', 'Password');
INSERT INTO `site_lang` VALUES ('30', '47', 'Birthday');
INSERT INTO `site_lang` VALUES ('31', '47', 'Please select');
INSERT INTO `site_lang` VALUES ('32', '47', 'City');
INSERT INTO `site_lang` VALUES ('33', '47', 'Where do you live?');
INSERT INTO `site_lang` VALUES ('34', '47', 'Gender');
INSERT INTO `site_lang` VALUES ('35', '47', 'Male');
INSERT INTO `site_lang` VALUES ('36', '47', 'Female');
INSERT INTO `site_lang` VALUES ('37', '47', 'Im here to');
INSERT INTO `site_lang` VALUES ('38', '47', 'Meet girls');
INSERT INTO `site_lang` VALUES ('39', '47', 'Meet boys');
INSERT INTO `site_lang` VALUES ('40', '47', 'Meet boys and girls');
INSERT INTO `site_lang` VALUES ('41', '47', 'Sign up');
INSERT INTO `site_lang` VALUES ('42', '47', 'By continuing, you are confirming that you have read and agree to our');
INSERT INTO `site_lang` VALUES ('43', '47', 'Terms and Conditions');
INSERT INTO `site_lang` VALUES ('44', '47', 'and');
INSERT INTO `site_lang` VALUES ('45', '47', 'Privacy Policy');
INSERT INTO `site_lang` VALUES ('46', '47', 'Profile');
INSERT INTO `site_lang` VALUES ('47', '47', 'Settings');
INSERT INTO `site_lang` VALUES ('48', '47', 'Logout');
INSERT INTO `site_lang` VALUES ('49', '47', 'Meet new people');
INSERT INTO `site_lang` VALUES ('50', '47', 'Discover');
INSERT INTO `site_lang` VALUES ('51', '47', 'Matches');
INSERT INTO `site_lang` VALUES ('52', '47', 'Most populars');
INSERT INTO `site_lang` VALUES ('53', '47', 'Fans');
INSERT INTO `site_lang` VALUES ('54', '47', 'Manage photos');
INSERT INTO `site_lang` VALUES ('55', '47', 'Settings');
INSERT INTO `site_lang` VALUES ('56', '47', 'All');
INSERT INTO `site_lang` VALUES ('57', '47', 'Fans');
INSERT INTO `site_lang` VALUES ('58', '47', 'Conversations');
INSERT INTO `site_lang` VALUES ('59', '47', 'Online now');
INSERT INTO `site_lang` VALUES ('60', '47', 'New messages');
INSERT INTO `site_lang` VALUES ('61', '47', 'Who to like');
INSERT INTO `site_lang` VALUES ('62', '47', 'Terms');
INSERT INTO `site_lang` VALUES ('63', '47', 'Privacy');
INSERT INTO `site_lang` VALUES ('64', '47', 'Contact');
INSERT INTO `site_lang` VALUES ('65', '47', 'Manage your photos');
INSERT INTO `site_lang` VALUES ('66', '47', 'All Photos');
INSERT INTO `site_lang` VALUES ('67', '47', 'Public Photos');
INSERT INTO `site_lang` VALUES ('68', '47', 'Private Photos');
INSERT INTO `site_lang` VALUES ('69', '47', 'Add your photos');
INSERT INTO `site_lang` VALUES ('70', '47', 'add photos');
INSERT INTO `site_lang` VALUES ('71', '47', 'Add yourself to the Spotlight');
INSERT INTO `site_lang` VALUES ('72', '47', 'Pick the photo you want to show in the Spotlight, cost ');
INSERT INTO `site_lang` VALUES ('73', '47', 'Credits');
INSERT INTO `site_lang` VALUES ('74', '47', 'Add photo');
INSERT INTO `site_lang` VALUES ('75', '47', 'Send gift to ');
INSERT INTO `site_lang` VALUES ('76', '47', 'Pick the gift you want to send to ');
INSERT INTO `site_lang` VALUES ('77', '47', 'Send gift');
INSERT INTO `site_lang` VALUES ('78', '47', 'Buy credits / Upgrade account');
INSERT INTO `site_lang` VALUES ('79', '47', 'Select credits package');
INSERT INTO `site_lang` VALUES ('80', '47', 'Select payment method');
INSERT INTO `site_lang` VALUES ('81', '47', 'Pay with');
INSERT INTO `site_lang` VALUES ('82', '47', 'Pay with');
INSERT INTO `site_lang` VALUES ('83', '47', 'Buy credits');
INSERT INTO `site_lang` VALUES ('84', '47', 'Premium Account Features');
INSERT INTO `site_lang` VALUES ('85', '47', 'new chats per day');
INSERT INTO `site_lang` VALUES ('86', '47', 'Unlimited videocalls');
INSERT INTO `site_lang` VALUES ('87', '47', 'Unblock all private photos');
INSERT INTO `site_lang` VALUES ('88', '47', 'Premium user badge');
INSERT INTO `site_lang` VALUES ('89', '47', 'Write text here');
INSERT INTO `site_lang` VALUES ('90', '47', 'Send');
INSERT INTO `site_lang` VALUES ('91', '47', 'Chat');
INSERT INTO `site_lang` VALUES ('92', '47', 'you have reached the limit of new daily conversations');
INSERT INTO `site_lang` VALUES ('93', '47', 'To continue chatting');
INSERT INTO `site_lang` VALUES ('94', '47', 'Buy');
INSERT INTO `site_lang` VALUES ('95', '47', 'more daily conversation');
INSERT INTO `site_lang` VALUES ('96', '47', 'or');
INSERT INTO `site_lang` VALUES ('97', '47', 'Upgrade your account to Premium');
INSERT INTO `site_lang` VALUES ('98', '47', 'and get up to');
INSERT INTO `site_lang` VALUES ('99', '47', 'daily conversations');
INSERT INTO `site_lang` VALUES ('100', '47', 'or wait until tomorrow for continue meeting people');
INSERT INTO `site_lang` VALUES ('101', '47', 'Your fans');
INSERT INTO `site_lang` VALUES ('102', '47', 'Privacy Policy');
INSERT INTO `site_lang` VALUES ('103', '47', 'Terms of Use');
INSERT INTO `site_lang` VALUES ('104', '47', 'Please complete your profile before start in ');
INSERT INTO `site_lang` VALUES ('105', '47', 'Your matches');
INSERT INTO `site_lang` VALUES ('106', '47', 'Filter Search');
INSERT INTO `site_lang` VALUES ('107', '47', 'All users');
INSERT INTO `site_lang` VALUES ('108', '47', 'Online now');
INSERT INTO `site_lang` VALUES ('109', '47', 'Show me');
INSERT INTO `site_lang` VALUES ('110', '47', 'Girls');
INSERT INTO `site_lang` VALUES ('111', '47', 'Boys');
INSERT INTO `site_lang` VALUES ('112', '47', 'Both');
INSERT INTO `site_lang` VALUES ('113', '47', 'who are between');
INSERT INTO `site_lang` VALUES ('114', '47', 'in a radius of');
INSERT INTO `site_lang` VALUES ('115', '47', 'World');
INSERT INTO `site_lang` VALUES ('116', '47', 'Most popular users');
INSERT INTO `site_lang` VALUES ('117', '47', 'About ');
INSERT INTO `site_lang` VALUES ('118', '47', 'Personal info');
INSERT INTO `site_lang` VALUES ('119', '47', 'years old');
INSERT INTO `site_lang` VALUES ('120', '47', 'Only boys');
INSERT INTO `site_lang` VALUES ('121', '47', 'Only girls');
INSERT INTO `site_lang` VALUES ('122', '47', 'boys and girls');
INSERT INTO `site_lang` VALUES ('123', '47', 'Credits successfully added to your account');
INSERT INTO `site_lang` VALUES ('124', '47', 'Now you have');
INSERT INTO `site_lang` VALUES ('125', '47', 'Ask permission to');
INSERT INTO `site_lang` VALUES ('126', '47', 'Unblock private photos');
INSERT INTO `site_lang` VALUES ('127', '47', 'Personal');
INSERT INTO `site_lang` VALUES ('128', '47', 'Credits');
INSERT INTO `site_lang` VALUES ('129', '47', 'Verify');
INSERT INTO `site_lang` VALUES ('130', '47', 'Change password');
INSERT INTO `site_lang` VALUES ('131', '47', 'Delete');
INSERT INTO `site_lang` VALUES ('132', '47', 'Personal information');
INSERT INTO `site_lang` VALUES ('133', '47', 'You can edit your profile information bellow');
INSERT INTO `site_lang` VALUES ('134', '47', 'Site language');
INSERT INTO `site_lang` VALUES ('135', '47', 'Update profile');
INSERT INTO `site_lang` VALUES ('136', '47', 'Verify account');
INSERT INTO `site_lang` VALUES ('137', '47', 'For verify your account , connect with your facebook account');
INSERT INTO `site_lang` VALUES ('138', '47', 'Connect with Facebook');
INSERT INTO `site_lang` VALUES ('139', '47', 'You are account is already verified');
INSERT INTO `site_lang` VALUES ('140', '47', 'Buy credits for send Gifs and Unblock private photos');
INSERT INTO `site_lang` VALUES ('141', '47', 'Account type');
INSERT INTO `site_lang` VALUES ('142', '47', 'Current credits');
INSERT INTO `site_lang` VALUES ('143', '47', 'Add credits');
INSERT INTO `site_lang` VALUES ('144', '47', 'Upgrade to premium account');
INSERT INTO `site_lang` VALUES ('145', '47', 'Change password');
INSERT INTO `site_lang` VALUES ('146', '47', 'You can change your current password bellow');
INSERT INTO `site_lang` VALUES ('147', '47', 'New password');
INSERT INTO `site_lang` VALUES ('148', '47', 'Profile desactivation');
INSERT INTO `site_lang` VALUES ('149', '47', 'After delete your profile, some of your data will be lost without recovery.');
INSERT INTO `site_lang` VALUES ('150', '47', 'Delete profile');
INSERT INTO `site_lang` VALUES ('151', '47', 'Online now');
INSERT INTO `site_lang` VALUES ('152', '47', 'Verified');
INSERT INTO `site_lang` VALUES ('153', '47', 'Nothing found');
INSERT INTO `site_lang` VALUES ('154', '47', 'people found');
INSERT INTO `site_lang` VALUES ('155', '47', 'No popular users near you');
INSERT INTO `site_lang` VALUES ('156', '47', 'You dont have any fans yet');
INSERT INTO `site_lang` VALUES ('157', '47', 'You dont have matches yet');
INSERT INTO `site_lang` VALUES ('158', '47', 'January');
INSERT INTO `site_lang` VALUES ('159', '47', 'February');
INSERT INTO `site_lang` VALUES ('160', '47', 'March');
INSERT INTO `site_lang` VALUES ('161', '47', 'April');
INSERT INTO `site_lang` VALUES ('162', '47', 'May');
INSERT INTO `site_lang` VALUES ('163', '47', 'June');
INSERT INTO `site_lang` VALUES ('164', '47', 'July');
INSERT INTO `site_lang` VALUES ('165', '47', 'August');
INSERT INTO `site_lang` VALUES ('166', '47', 'September');
INSERT INTO `site_lang` VALUES ('167', '47', 'October');
INSERT INTO `site_lang` VALUES ('168', '47', 'November');
INSERT INTO `site_lang` VALUES ('169', '47', 'December');
INSERT INTO `site_lang` VALUES ('170', '47', 'Buy');
INSERT INTO `site_lang` VALUES ('171', '47', 'Days Premium');
INSERT INTO `site_lang` VALUES ('172', '47', 'persons more like this');
INSERT INTO `site_lang` VALUES ('173', '47', 'like this');
INSERT INTO `site_lang` VALUES ('174', '47', 'Hello, can i have access to your private photos ?');
INSERT INTO `site_lang` VALUES ('175', '47', 'Yes');
INSERT INTO `site_lang` VALUES ('176', '47', 'No');
INSERT INTO `site_lang` VALUES ('177', '47', 'Hi');
INSERT INTO `site_lang` VALUES ('178', '47', 'If you dont remember your password, click the link below to set a new one:');
INSERT INTO `site_lang` VALUES ('179', '47', 'Login to my account');
INSERT INTO `site_lang` VALUES ('180', '47', 'Password recover');
INSERT INTO `site_lang` VALUES ('181', '47', 'Invalid email format');
INSERT INTO `site_lang` VALUES ('182', '47', 'Please fill all the inputs');
INSERT INTO `site_lang` VALUES ('183', '47', 'Email dont exist');
INSERT INTO `site_lang` VALUES ('184', '47', 'Wrong password');
INSERT INTO `site_lang` VALUES ('185', '47', 'Add a valid date');
INSERT INTO `site_lang` VALUES ('186', '47', 'Choose city from the autocomplete');
INSERT INTO `site_lang` VALUES ('187', '47', 'Password too short');
INSERT INTO `site_lang` VALUES ('188', '47', 'Email already exist, try another');
INSERT INTO `site_lang` VALUES ('189', '47', 'Yes, you can see my private photos');
INSERT INTO `site_lang` VALUES ('190', '47', 'No, i cant show you my private photos');
INSERT INTO `site_lang` VALUES ('191', '47', 'Buy private photos permission');
INSERT INTO `site_lang` VALUES ('192', '47', 'Get access to');
INSERT INTO `site_lang` VALUES ('193', '47', 'private photos for ');
INSERT INTO `site_lang` VALUES ('194', '47', 'Get access');
INSERT INTO `site_lang` VALUES ('195', '47', 'No thanks');
INSERT INTO `site_lang` VALUES ('196', '47', 'Please, select a payment method');
INSERT INTO `site_lang` VALUES ('197', '47', 'Please, select 1 photo');
INSERT INTO `site_lang` VALUES ('198', '47', 'Please, select 1 gift');
INSERT INTO `site_lang` VALUES ('199', '47', 'You dont have enought credits for send the gift');
INSERT INTO `site_lang` VALUES ('200', '47', 'Expand daily limitation ');
INSERT INTO `site_lang` VALUES ('201', '47', 'more daily conversation, cost ');
INSERT INTO `site_lang` VALUES ('202', '47', 'Yes, buy it!');
INSERT INTO `site_lang` VALUES ('203', '47', 'Information updated successfully');
INSERT INTO `site_lang` VALUES ('204', '47', 'Account termination');
INSERT INTO `site_lang` VALUES ('205', '47', 'Your data will be lost without recovery, continue?');
INSERT INTO `site_lang` VALUES ('206', '47', 'Yes, delete it!');
INSERT INTO `site_lang` VALUES ('207', '47', 'is in another videocall , you cant call now');
INSERT INTO `site_lang` VALUES ('208', '47', 'is offline, try again when your friend is online');
INSERT INTO `site_lang` VALUES ('209', '47', 'Please allow access to your Webcam.');
INSERT INTO `site_lang` VALUES ('210', '47', 'You are already in a videocall, you have to end the other call before start another');
INSERT INTO `site_lang` VALUES ('211', '47', 'Only premium users can make videocalls');
INSERT INTO `site_lang` VALUES ('212', '47', 'Impossible to make a call!');
INSERT INTO `site_lang` VALUES ('213', '47', 'You cant make videocall because you dont have webcam');
INSERT INTO `site_lang` VALUES ('214', '47', 'Too long wait');
INSERT INTO `site_lang` VALUES ('215', '47', 'Seems that your friend do not have webcam or he is not available');
INSERT INTO `site_lang` VALUES ('216', '47', 'End call');
INSERT INTO `site_lang` VALUES ('217', '47', 'Wait more');
INSERT INTO `site_lang` VALUES ('218', '47', 'until');
INSERT INTO `site_lang` VALUES ('219', '47', 'Basic');
INSERT INTO `site_lang` VALUES ('220', '47', 'UPGRADE');
INSERT INTO `site_lang` VALUES ('221', '47', 'Notifications');
INSERT INTO `site_lang` VALUES ('222', '47', 'Extended info (optional)');
INSERT INTO `site_lang` VALUES ('223', '47', 'Relationship');
INSERT INTO `site_lang` VALUES ('224', '47', 'Single');
INSERT INTO `site_lang` VALUES ('225', '47', 'Taken');
INSERT INTO `site_lang` VALUES ('226', '47', 'Open');
INSERT INTO `site_lang` VALUES ('227', '47', 'Sexuality');
INSERT INTO `site_lang` VALUES ('228', '47', 'Gay');
INSERT INTO `site_lang` VALUES ('229', '47', 'Open-minded');
INSERT INTO `site_lang` VALUES ('230', '47', 'Straight');
INSERT INTO `site_lang` VALUES ('231', '47', 'Bisexual');
INSERT INTO `site_lang` VALUES ('232', '47', 'Height');
INSERT INTO `site_lang` VALUES ('233', '47', 'less than');
INSERT INTO `site_lang` VALUES ('234', '47', 'more than');
INSERT INTO `site_lang` VALUES ('235', '47', 'Weight');
INSERT INTO `site_lang` VALUES ('236', '47', 'Ethnicity');
INSERT INTO `site_lang` VALUES ('237', '47', 'Asian');
INSERT INTO `site_lang` VALUES ('238', '47', 'Middle Eastern');
INSERT INTO `site_lang` VALUES ('239', '47', 'Black');
INSERT INTO `site_lang` VALUES ('240', '47', 'White');
INSERT INTO `site_lang` VALUES ('241', '47', 'Native American');
INSERT INTO `site_lang` VALUES ('242', '47', 'Hispanic/latin');
INSERT INTO `site_lang` VALUES ('243', '47', 'Pacific Islander');
INSERT INTO `site_lang` VALUES ('244', '47', 'Indian');
INSERT INTO `site_lang` VALUES ('245', '47', 'Other');
INSERT INTO `site_lang` VALUES ('246', '47', 'Body type');
INSERT INTO `site_lang` VALUES ('247', '47', 'Slim');
INSERT INTO `site_lang` VALUES ('248', '47', 'Average');
INSERT INTO `site_lang` VALUES ('249', '47', 'Athletic');
INSERT INTO `site_lang` VALUES ('250', '47', 'Heavy set');
INSERT INTO `site_lang` VALUES ('251', '47', 'Curvy');
INSERT INTO `site_lang` VALUES ('252', '47', 'Living');
INSERT INTO `site_lang` VALUES ('253', '47', 'With parents');
INSERT INTO `site_lang` VALUES ('254', '47', 'With housemate');
INSERT INTO `site_lang` VALUES ('255', '47', 'Student dormitory');
INSERT INTO `site_lang` VALUES ('256', '47', 'With partner');
INSERT INTO `site_lang` VALUES ('257', '47', 'Alone');
INSERT INTO `site_lang` VALUES ('258', '47', 'Smoke');
INSERT INTO `site_lang` VALUES ('259', '47', 'Yes');
INSERT INTO `site_lang` VALUES ('260', '47', 'No');
INSERT INTO `site_lang` VALUES ('261', '47', 'Sometimes');
INSERT INTO `site_lang` VALUES ('262', '47', 'Drink');
INSERT INTO `site_lang` VALUES ('263', '47', 'Transport');
INSERT INTO `site_lang` VALUES ('264', '47', 'Parents car');
INSERT INTO `site_lang` VALUES ('265', '47', 'I own a car');
INSERT INTO `site_lang` VALUES ('266', '47', 'I own a motorbike');
INSERT INTO `site_lang` VALUES ('267', '47', 'None');
INSERT INTO `site_lang` VALUES ('268', '47', 'When someone likes me');
INSERT INTO `site_lang` VALUES ('269', '47', 'When i get a match');
INSERT INTO `site_lang` VALUES ('270', '47', 'When new users near me join in');
INSERT INTO `site_lang` VALUES ('271', '47', 'When someone send me a message');
INSERT INTO `site_lang` VALUES ('272', '47', 'Day');
INSERT INTO `site_lang` VALUES ('273', '47', 'Month');
INSERT INTO `site_lang` VALUES ('274', '47', 'Year');
INSERT INTO `site_lang` VALUES ('275', '47', 'Please wait');
INSERT INTO `site_lang` VALUES ('276', '47', 'Interests');
INSERT INTO `site_lang` VALUES ('277', '47', 'Report');
INSERT INTO `site_lang` VALUES ('278', '47', 'Fans');
INSERT INTO `site_lang` VALUES ('279', '47', 'No data');
INSERT INTO `site_lang` VALUES ('280', '47', 'Public Photos');
INSERT INTO `site_lang` VALUES ('281', '47', 'Private photos');
INSERT INTO `site_lang` VALUES ('282', '47', 'Add from ');
INSERT INTO `site_lang` VALUES ('283', '47', 'Add');
INSERT INTO `site_lang` VALUES ('284', '47', 'Photos');
INSERT INTO `site_lang` VALUES ('285', '47', 'Credits');
INSERT INTO `site_lang` VALUES ('286', '47', 'Visits');
INSERT INTO `site_lang` VALUES ('287', '47', 'Add me here');
INSERT INTO `site_lang` VALUES ('288', '47', 'get seen by millions');
INSERT INTO `site_lang` VALUES ('289', '47', 'Set as profile');
INSERT INTO `site_lang` VALUES ('290', '47', 'Private photo');
INSERT INTO `site_lang` VALUES ('291', '47', 'Public photo');
INSERT INTO `site_lang` VALUES ('292', '47', 'Delete');
INSERT INTO `site_lang` VALUES ('293', '47', 'people visited your profile for see them');
INSERT INTO `site_lang` VALUES ('294', '47', 'Upgrade your account to premium');
INSERT INTO `site_lang` VALUES ('295', '47', 'People i like');
INSERT INTO `site_lang` VALUES ('296', '47', 'people liked you, for see them');
INSERT INTO `site_lang` VALUES ('297', '47', 'Messages');
INSERT INTO `site_lang` VALUES ('298', '47', 'Like');
INSERT INTO `site_lang` VALUES ('299', '47', 'Dislike');
INSERT INTO `site_lang` VALUES ('300', '47', 'AGE');
INSERT INTO `site_lang` VALUES ('301', '47', 'You dont have any visit yet');
INSERT INTO `site_lang` VALUES ('302', '47', 'visited');
INSERT INTO `site_lang` VALUES ('303', '47', 'You do not like anyone');
INSERT INTO `site_lang` VALUES ('304', '47', 'Cost');
INSERT INTO `site_lang` VALUES ('305', '47', 'Credits for $');
INSERT INTO `site_lang` VALUES ('306', '47', '0 seconds');
INSERT INTO `site_lang` VALUES ('307', '47', 'year');
INSERT INTO `site_lang` VALUES ('308', '47', 'month');
INSERT INTO `site_lang` VALUES ('309', '47', 'day');
INSERT INTO `site_lang` VALUES ('310', '47', 'hour');
INSERT INTO `site_lang` VALUES ('311', '47', 'minute');
INSERT INTO `site_lang` VALUES ('312', '47', 'second');
INSERT INTO `site_lang` VALUES ('313', '47', 'years');
INSERT INTO `site_lang` VALUES ('314', '47', 'months');
INSERT INTO `site_lang` VALUES ('315', '47', 'days');
INSERT INTO `site_lang` VALUES ('316', '47', 'hours');
INSERT INTO `site_lang` VALUES ('317', '47', 'minutes');
INSERT INTO `site_lang` VALUES ('318', '47', 'seconds');
INSERT INTO `site_lang` VALUES ('319', '47', 'ago');
INSERT INTO `site_lang` VALUES ('320', '47', 'Please verify your account, check your email');
INSERT INTO `site_lang` VALUES ('321', '47', 'Please add a profile photo');
INSERT INTO `site_lang` VALUES ('322', '47', 'Hi, im');
INSERT INTO `site_lang` VALUES ('323', '47', 'years old and im from');
INSERT INTO `site_lang` VALUES ('324', '47', 'We sended you a email for verify your account');
INSERT INTO `site_lang` VALUES ('325', '47', 'is blocking you or you blocked him, you cant chat with him sorry');
INSERT INTO `site_lang` VALUES ('326', '47', 'Report and block');
INSERT INTO `site_lang` VALUES ('327', '47', 'Are you sure you want to report');
INSERT INTO `site_lang` VALUES ('328', '47', 'Press backspace key for smart return to the meeting section.');
INSERT INTO `site_lang` VALUES ('329', '47', 'Write your instagram username');
INSERT INTO `site_lang` VALUES ('330', '47', 'You need to write your username!');
INSERT INTO `site_lang` VALUES ('331', '47', 'username');
INSERT INTO `site_lang` VALUES ('332', '47', 'days of Premium');
INSERT INTO `site_lang` VALUES ('333', '47', 'Wrong');
INSERT INTO `site_lang` VALUES ('334', '47', 'Spotlight');
INSERT INTO `site_lang` VALUES ('335', '47', 'Service cost');
INSERT INTO `site_lang` VALUES ('336', '47', 'Password successfully changed');
INSERT INTO `site_lang` VALUES ('337', '47', 'is calling you..');
INSERT INTO `site_lang` VALUES ('338', '47', 'Photos of ');
INSERT INTO `site_lang` VALUES ('339', '47', 'of');
INSERT INTO `site_lang` VALUES ('340', '47', 'Loading...');
INSERT INTO `site_lang` VALUES ('341', '47', 'We sent you a email with your info, it may take up to 1 min to arrive');
INSERT INTO `site_lang` VALUES ('342', '47', 'likes you and wants to chat in');
INSERT INTO `site_lang` VALUES ('343', '47', 'has seen you in discover and likes. The feeling is mutual?');
INSERT INTO `site_lang` VALUES ('344', '47', 'Find out if you also like');
INSERT INTO `site_lang` VALUES ('345', '47', 'You received this notice because you registered as');
INSERT INTO `site_lang` VALUES ('346', '47', 'Unsubscribe');
INSERT INTO `site_lang` VALUES ('347', '47', 'Choose a new password');
INSERT INTO `site_lang` VALUES ('348', '47', 'if you forgot your password, click on the link below to get a new');
INSERT INTO `site_lang` VALUES ('349', '47', 'You have a match at');
INSERT INTO `site_lang` VALUES ('350', '47', 'Its a match!');
INSERT INTO `site_lang` VALUES ('351', '47', 'thinks the feeling is mutual');
INSERT INTO `site_lang` VALUES ('352', '47', 'Go and say something to');
INSERT INTO `site_lang` VALUES ('353', '47', 'New message from');
INSERT INTO `site_lang` VALUES ('354', '47', 'you have a new message from');
INSERT INTO `site_lang` VALUES ('355', '47', 'Respond to');
INSERT INTO `site_lang` VALUES ('356', '47', 'Have fun!');
INSERT INTO `site_lang` VALUES ('357', '47', 'is new and lives closer to you');
INSERT INTO `site_lang` VALUES ('358', '47', 'is new at');
INSERT INTO `site_lang` VALUES ('359', '47', 'and lives closer to you');
INSERT INTO `site_lang` VALUES ('360', '47', 'Check out the profile');
INSERT INTO `site_lang` VALUES ('361', '47', 'Welcome');
INSERT INTO `site_lang` VALUES ('362', '47', 'Well done, now you are in');
INSERT INTO `site_lang` VALUES ('363', '47', 'Here are a few tips');
INSERT INTO `site_lang` VALUES ('364', '47', 'Now you are a new member of');
INSERT INTO `site_lang` VALUES ('365', '47', 'Verify your account');
INSERT INTO `site_lang` VALUES ('366', '47', 'Newsflash');
INSERT INTO `site_lang` VALUES ('367', '47', 'people in your area wants to know you');
INSERT INTO `site_lang` VALUES ('368', '47', 'In');
INSERT INTO `site_lang` VALUES ('369', '47', 'you can meet people instantly');
INSERT INTO `site_lang` VALUES ('370', '47', 'Meet new people');
INSERT INTO `site_lang` VALUES ('371', '47', 'Nobody is going to fall in love with a blank page. The more information you get, the more chances to find that special someone!');
INSERT INTO `site_lang` VALUES ('372', '47', 'Add photos and complete your profile');
INSERT INTO `site_lang` VALUES ('373', '47', 'More than 1 million people have joined $site_name You probably want to know some of them.');
INSERT INTO `site_lang` VALUES ('374', '47', 'Start meeting new people now');
INSERT INTO `site_lang` VALUES ('375', '47', 'Here are your connection details');
INSERT INTO `site_lang` VALUES ('376', '47', 'E-mail');
INSERT INTO `site_lang` VALUES ('377', '47', 'Password');
INSERT INTO `site_lang` VALUES ('378', '47', 'Please save your connection information in a safe place');
INSERT INTO `site_lang` VALUES ('379', '47', 'Go to');
INSERT INTO `site_lang` VALUES ('380', '47', 'Welcome to');
INSERT INTO `site_lang` VALUES ('381', '47', 'calling...');
INSERT INTO `site_lang` VALUES ('382', '47', 'dont like you');
INSERT INTO `site_lang` VALUES ('383', '47', 'must like you for start a videocall');
INSERT INTO `site_lang` VALUES ('384', '47', 'Ok, i understand');
INSERT INTO `site_lang` VALUES ('0', '48', 'meet new people!');
INSERT INTO `site_lang` VALUES ('1', '48', 'Login');
INSERT INTO `site_lang` VALUES ('2', '48', 'Welcome to the fastest growing place to meet new people');
INSERT INTO `site_lang` VALUES ('3', '48', 'For now our site works only for Desktop users');
INSERT INTO `site_lang` VALUES ('4', '48', 'Please visit us from your laptop or PC');
INSERT INTO `site_lang` VALUES ('5', '48', 'Soon we will have our phone apps online');
INSERT INTO `site_lang` VALUES ('6', '48', 'SOON AVAILABLE');
INSERT INTO `site_lang` VALUES ('7', '48', 'Connect with ');
INSERT INTO `site_lang` VALUES ('8', '48', 'Create your account');
INSERT INTO `site_lang` VALUES ('9', '48', 'Welcome back');
INSERT INTO `site_lang` VALUES ('10', '48', 'Your email');
INSERT INTO `site_lang` VALUES ('11', '48', 'Your password');
INSERT INTO `site_lang` VALUES ('12', '48', 'do you forget your password?');
INSERT INTO `site_lang` VALUES ('13', '48', 'Login now');
INSERT INTO `site_lang` VALUES ('14', '48', 'Password recover');
INSERT INTO `site_lang` VALUES ('15', '48', 'Recover password');
INSERT INTO `site_lang` VALUES ('16', '48', 'Chat');
INSERT INTO `site_lang` VALUES ('17', '48', 'Powerfull private chat for meet new friends, you can send emoticons and private photos to anyone.');
INSERT INTO `site_lang` VALUES ('18', '48', 'Video Chat');
INSERT INTO `site_lang` VALUES ('19', '48', 'You can make quality videocalls for free to anyone, without limits of call duration, just enjoy seeing the person who is chatting with you');
INSERT INTO `site_lang` VALUES ('20', '48', 'People nearby');
INSERT INTO `site_lang` VALUES ('21', '48', 'We wont show your exact location, but you will be able to find people nearby who like the same things you do.');
INSERT INTO `site_lang` VALUES ('22', '48', 'Matches');
INSERT INTO `site_lang` VALUES ('23', '48', 'Play our popular Discover game and get matched with other users. Its a great way to break the ice and chat to new people.');
INSERT INTO `site_lang` VALUES ('24', '48', 'Become a member now');
INSERT INTO `site_lang` VALUES ('25', '48', 'Join the worlds bestest community for meeting new people!.');
INSERT INTO `site_lang` VALUES ('26', '48', 'Name');
INSERT INTO `site_lang` VALUES ('27', '48', 'Your name or nickname');
INSERT INTO `site_lang` VALUES ('28', '48', 'Email');
INSERT INTO `site_lang` VALUES ('29', '48', 'Password');
INSERT INTO `site_lang` VALUES ('30', '48', 'Birthday');
INSERT INTO `site_lang` VALUES ('31', '48', 'Please select');
INSERT INTO `site_lang` VALUES ('32', '48', 'City');
INSERT INTO `site_lang` VALUES ('33', '48', 'Where do you live?');
INSERT INTO `site_lang` VALUES ('34', '48', 'Gender');
INSERT INTO `site_lang` VALUES ('35', '48', 'Male');
INSERT INTO `site_lang` VALUES ('36', '48', 'Female');
INSERT INTO `site_lang` VALUES ('37', '48', 'Im here to');
INSERT INTO `site_lang` VALUES ('38', '48', 'Meet girls');
INSERT INTO `site_lang` VALUES ('39', '48', 'Meet boys');
INSERT INTO `site_lang` VALUES ('40', '48', 'Meet boys and girls');
INSERT INTO `site_lang` VALUES ('41', '48', 'Sign up');
INSERT INTO `site_lang` VALUES ('42', '48', 'By continuing, you are confirming that you have read and agree to our');
INSERT INTO `site_lang` VALUES ('43', '48', 'Terms and Conditions');
INSERT INTO `site_lang` VALUES ('44', '48', 'and');
INSERT INTO `site_lang` VALUES ('45', '48', 'Privacy Policy');
INSERT INTO `site_lang` VALUES ('46', '48', 'Profile');
INSERT INTO `site_lang` VALUES ('47', '48', 'Settings');
INSERT INTO `site_lang` VALUES ('48', '48', 'Logout');
INSERT INTO `site_lang` VALUES ('49', '48', 'Meet new people');
INSERT INTO `site_lang` VALUES ('50', '48', 'Discover');
INSERT INTO `site_lang` VALUES ('51', '48', 'Matches');
INSERT INTO `site_lang` VALUES ('52', '48', 'Most populars');
INSERT INTO `site_lang` VALUES ('53', '48', 'Fans');
INSERT INTO `site_lang` VALUES ('54', '48', 'Manage photos');
INSERT INTO `site_lang` VALUES ('55', '48', 'Settings');
INSERT INTO `site_lang` VALUES ('56', '48', 'All');
INSERT INTO `site_lang` VALUES ('57', '48', 'Fans');
INSERT INTO `site_lang` VALUES ('58', '48', 'Conversations');
INSERT INTO `site_lang` VALUES ('59', '48', 'Online now');
INSERT INTO `site_lang` VALUES ('60', '48', 'New messages');
INSERT INTO `site_lang` VALUES ('61', '48', 'Who to like');
INSERT INTO `site_lang` VALUES ('62', '48', 'Terms');
INSERT INTO `site_lang` VALUES ('63', '48', 'Privacy');
INSERT INTO `site_lang` VALUES ('64', '48', 'Contact');
INSERT INTO `site_lang` VALUES ('65', '48', 'Manage your photos');
INSERT INTO `site_lang` VALUES ('66', '48', 'All Photos');
INSERT INTO `site_lang` VALUES ('67', '48', 'Public Photos');
INSERT INTO `site_lang` VALUES ('68', '48', 'Private Photos');
INSERT INTO `site_lang` VALUES ('69', '48', 'Add your photos');
INSERT INTO `site_lang` VALUES ('70', '48', 'add photos');
INSERT INTO `site_lang` VALUES ('71', '48', 'Add yourself to the Spotlight');
INSERT INTO `site_lang` VALUES ('72', '48', 'Pick the photo you want to show in the Spotlight, cost ');
INSERT INTO `site_lang` VALUES ('73', '48', 'Credits');
INSERT INTO `site_lang` VALUES ('74', '48', 'Add photo');
INSERT INTO `site_lang` VALUES ('75', '48', 'Send gift to ');
INSERT INTO `site_lang` VALUES ('76', '48', 'Pick the gift you want to send to ');
INSERT INTO `site_lang` VALUES ('77', '48', 'Send gift');
INSERT INTO `site_lang` VALUES ('78', '48', 'Buy credits / Upgrade account');
INSERT INTO `site_lang` VALUES ('79', '48', 'Select credits package');
INSERT INTO `site_lang` VALUES ('80', '48', 'Select payment method');
INSERT INTO `site_lang` VALUES ('81', '48', 'Pay with');
INSERT INTO `site_lang` VALUES ('82', '48', 'Pay with');
INSERT INTO `site_lang` VALUES ('83', '48', 'Buy credits');
INSERT INTO `site_lang` VALUES ('84', '48', 'Premium Account Features');
INSERT INTO `site_lang` VALUES ('85', '48', 'new chats per day');
INSERT INTO `site_lang` VALUES ('86', '48', 'Unlimited videocalls');
INSERT INTO `site_lang` VALUES ('87', '48', 'Unblock all private photos');
INSERT INTO `site_lang` VALUES ('88', '48', 'Premium user badge');
INSERT INTO `site_lang` VALUES ('89', '48', 'Write text here');
INSERT INTO `site_lang` VALUES ('90', '48', 'Send');
INSERT INTO `site_lang` VALUES ('91', '48', 'Chat');
INSERT INTO `site_lang` VALUES ('92', '48', 'you have reached the limit of new daily conversations');
INSERT INTO `site_lang` VALUES ('93', '48', 'To continue chatting');
INSERT INTO `site_lang` VALUES ('94', '48', 'Buy');
INSERT INTO `site_lang` VALUES ('95', '48', 'more daily conversation');
INSERT INTO `site_lang` VALUES ('96', '48', 'or');
INSERT INTO `site_lang` VALUES ('97', '48', 'Upgrade your account to Premium');
INSERT INTO `site_lang` VALUES ('98', '48', 'and get up to');
INSERT INTO `site_lang` VALUES ('99', '48', 'daily conversations');
INSERT INTO `site_lang` VALUES ('100', '48', 'or wait until tomorrow for continue meeting people');
INSERT INTO `site_lang` VALUES ('101', '48', 'Your fans');
INSERT INTO `site_lang` VALUES ('102', '48', 'Privacy Policy');
INSERT INTO `site_lang` VALUES ('103', '48', 'Terms of Use');
INSERT INTO `site_lang` VALUES ('104', '48', 'Please complete your profile before start in ');
INSERT INTO `site_lang` VALUES ('105', '48', 'Your matches');
INSERT INTO `site_lang` VALUES ('106', '48', 'Filter Search');
INSERT INTO `site_lang` VALUES ('107', '48', 'All users');
INSERT INTO `site_lang` VALUES ('108', '48', 'Online now');
INSERT INTO `site_lang` VALUES ('109', '48', 'Show me');
INSERT INTO `site_lang` VALUES ('110', '48', 'Girls');
INSERT INTO `site_lang` VALUES ('111', '48', 'Boys');
INSERT INTO `site_lang` VALUES ('112', '48', 'Both');
INSERT INTO `site_lang` VALUES ('113', '48', 'who are between');
INSERT INTO `site_lang` VALUES ('114', '48', 'in a radius of');
INSERT INTO `site_lang` VALUES ('115', '48', 'World');
INSERT INTO `site_lang` VALUES ('116', '48', 'Most popular users');
INSERT INTO `site_lang` VALUES ('117', '48', 'About ');
INSERT INTO `site_lang` VALUES ('118', '48', 'Personal info');
INSERT INTO `site_lang` VALUES ('119', '48', 'years old');
INSERT INTO `site_lang` VALUES ('120', '48', 'Only boys');
INSERT INTO `site_lang` VALUES ('121', '48', 'Only girls');
INSERT INTO `site_lang` VALUES ('122', '48', 'boys and girls');
INSERT INTO `site_lang` VALUES ('123', '48', 'Credits successfully added to your account');
INSERT INTO `site_lang` VALUES ('124', '48', 'Now you have');
INSERT INTO `site_lang` VALUES ('125', '48', 'Ask permission to');
INSERT INTO `site_lang` VALUES ('126', '48', 'Unblock private photos');
INSERT INTO `site_lang` VALUES ('127', '48', 'Personal');
INSERT INTO `site_lang` VALUES ('128', '48', 'Credits');
INSERT INTO `site_lang` VALUES ('129', '48', 'Verify');
INSERT INTO `site_lang` VALUES ('130', '48', 'Change password');
INSERT INTO `site_lang` VALUES ('131', '48', 'Delete');
INSERT INTO `site_lang` VALUES ('132', '48', 'Personal information');
INSERT INTO `site_lang` VALUES ('133', '48', 'You can edit your profile information bellow');
INSERT INTO `site_lang` VALUES ('134', '48', 'Site language');
INSERT INTO `site_lang` VALUES ('135', '48', 'Update profile');
INSERT INTO `site_lang` VALUES ('136', '48', 'Verify account');
INSERT INTO `site_lang` VALUES ('137', '48', 'For verify your account , connect with your facebook account');
INSERT INTO `site_lang` VALUES ('138', '48', 'Connect with Facebook');
INSERT INTO `site_lang` VALUES ('139', '48', 'You are account is already verified');
INSERT INTO `site_lang` VALUES ('140', '48', 'Buy credits for send Gifs and Unblock private photos');
INSERT INTO `site_lang` VALUES ('141', '48', 'Account type');
INSERT INTO `site_lang` VALUES ('142', '48', 'Current credits');
INSERT INTO `site_lang` VALUES ('143', '48', 'Add credits');
INSERT INTO `site_lang` VALUES ('144', '48', 'Upgrade to premium account');
INSERT INTO `site_lang` VALUES ('145', '48', 'Change password');
INSERT INTO `site_lang` VALUES ('146', '48', 'You can change your current password bellow');
INSERT INTO `site_lang` VALUES ('147', '48', 'New password');
INSERT INTO `site_lang` VALUES ('148', '48', 'Profile desactivation');
INSERT INTO `site_lang` VALUES ('149', '48', 'After delete your profile, some of your data will be lost without recovery.');
INSERT INTO `site_lang` VALUES ('150', '48', 'Delete profile');
INSERT INTO `site_lang` VALUES ('151', '48', 'Online now');
INSERT INTO `site_lang` VALUES ('152', '48', 'Verified');
INSERT INTO `site_lang` VALUES ('153', '48', 'Nothing found');
INSERT INTO `site_lang` VALUES ('154', '48', 'people found');
INSERT INTO `site_lang` VALUES ('155', '48', 'No popular users near you');
INSERT INTO `site_lang` VALUES ('156', '48', 'You dont have any fans yet');
INSERT INTO `site_lang` VALUES ('157', '48', 'You dont have matches yet');
INSERT INTO `site_lang` VALUES ('158', '48', 'January');
INSERT INTO `site_lang` VALUES ('159', '48', 'February');
INSERT INTO `site_lang` VALUES ('160', '48', 'March');
INSERT INTO `site_lang` VALUES ('161', '48', 'April');
INSERT INTO `site_lang` VALUES ('162', '48', 'May');
INSERT INTO `site_lang` VALUES ('163', '48', 'June');
INSERT INTO `site_lang` VALUES ('164', '48', 'July');
INSERT INTO `site_lang` VALUES ('165', '48', 'August');
INSERT INTO `site_lang` VALUES ('166', '48', 'September');
INSERT INTO `site_lang` VALUES ('167', '48', 'October');
INSERT INTO `site_lang` VALUES ('168', '48', 'November');
INSERT INTO `site_lang` VALUES ('169', '48', 'December');
INSERT INTO `site_lang` VALUES ('170', '48', 'Buy');
INSERT INTO `site_lang` VALUES ('171', '48', 'Days Premium');
INSERT INTO `site_lang` VALUES ('172', '48', 'persons more like this');
INSERT INTO `site_lang` VALUES ('173', '48', 'like this');
INSERT INTO `site_lang` VALUES ('174', '48', 'Hello, can i have access to your private photos ?');
INSERT INTO `site_lang` VALUES ('175', '48', 'Yes');
INSERT INTO `site_lang` VALUES ('176', '48', 'No');
INSERT INTO `site_lang` VALUES ('177', '48', 'Hi');
INSERT INTO `site_lang` VALUES ('178', '48', 'If you dont remember your password, click the link below to set a new one:');
INSERT INTO `site_lang` VALUES ('179', '48', 'Login to my account');
INSERT INTO `site_lang` VALUES ('180', '48', 'Password recover');
INSERT INTO `site_lang` VALUES ('181', '48', 'Invalid email format');
INSERT INTO `site_lang` VALUES ('182', '48', 'Please fill all the inputs');
INSERT INTO `site_lang` VALUES ('183', '48', 'Email dont exist');
INSERT INTO `site_lang` VALUES ('184', '48', 'Wrong password');
INSERT INTO `site_lang` VALUES ('185', '48', 'Add a valid date');
INSERT INTO `site_lang` VALUES ('186', '48', 'Choose city from the autocomplete');
INSERT INTO `site_lang` VALUES ('187', '48', 'Password too short');
INSERT INTO `site_lang` VALUES ('188', '48', 'Email already exist, try another');
INSERT INTO `site_lang` VALUES ('189', '48', 'Yes, you can see my private photos');
INSERT INTO `site_lang` VALUES ('190', '48', 'No, i cant show you my private photos');
INSERT INTO `site_lang` VALUES ('191', '48', 'Buy private photos permission');
INSERT INTO `site_lang` VALUES ('192', '48', 'Get access to');
INSERT INTO `site_lang` VALUES ('193', '48', 'private photos for ');
INSERT INTO `site_lang` VALUES ('194', '48', 'Get access');
INSERT INTO `site_lang` VALUES ('195', '48', 'No thanks');
INSERT INTO `site_lang` VALUES ('196', '48', 'Please, select a payment method');
INSERT INTO `site_lang` VALUES ('197', '48', 'Please, select 1 photo');
INSERT INTO `site_lang` VALUES ('198', '48', 'Please, select 1 gift');
INSERT INTO `site_lang` VALUES ('199', '48', 'You dont have enought credits for send the gift');
INSERT INTO `site_lang` VALUES ('200', '48', 'Expand daily limitation ');
INSERT INTO `site_lang` VALUES ('201', '48', 'more daily conversation, cost ');
INSERT INTO `site_lang` VALUES ('202', '48', 'Yes, buy it!');
INSERT INTO `site_lang` VALUES ('203', '48', 'Information updated successfully');
INSERT INTO `site_lang` VALUES ('204', '48', 'Account termination');
INSERT INTO `site_lang` VALUES ('205', '48', 'Your data will be lost without recovery, continue?');
INSERT INTO `site_lang` VALUES ('206', '48', 'Yes, delete it!');
INSERT INTO `site_lang` VALUES ('207', '48', 'is in another videocall , you cant call now');
INSERT INTO `site_lang` VALUES ('208', '48', 'is offline, try again when your friend is online');
INSERT INTO `site_lang` VALUES ('209', '48', 'Please allow access to your Webcam.');
INSERT INTO `site_lang` VALUES ('210', '48', 'You are already in a videocall, you have to end the other call before start another');
INSERT INTO `site_lang` VALUES ('211', '48', 'Only premium users can make videocalls');
INSERT INTO `site_lang` VALUES ('212', '48', 'Impossible to make a call!');
INSERT INTO `site_lang` VALUES ('213', '48', 'You cant make videocall because you dont have webcam');
INSERT INTO `site_lang` VALUES ('214', '48', 'Too long wait');
INSERT INTO `site_lang` VALUES ('215', '48', 'Seems that your friend do not have webcam or he is not available');
INSERT INTO `site_lang` VALUES ('216', '48', 'End call');
INSERT INTO `site_lang` VALUES ('217', '48', 'Wait more');
INSERT INTO `site_lang` VALUES ('218', '48', 'until');
INSERT INTO `site_lang` VALUES ('219', '48', 'Basic');
INSERT INTO `site_lang` VALUES ('220', '48', 'UPGRADE');
INSERT INTO `site_lang` VALUES ('221', '48', 'Notifications');
INSERT INTO `site_lang` VALUES ('222', '48', 'Extended info (optional)');
INSERT INTO `site_lang` VALUES ('223', '48', 'Relationship');
INSERT INTO `site_lang` VALUES ('224', '48', 'Single');
INSERT INTO `site_lang` VALUES ('225', '48', 'Taken');
INSERT INTO `site_lang` VALUES ('226', '48', 'Open');
INSERT INTO `site_lang` VALUES ('227', '48', 'Sexuality');
INSERT INTO `site_lang` VALUES ('228', '48', 'Gay');
INSERT INTO `site_lang` VALUES ('229', '48', 'Open-minded');
INSERT INTO `site_lang` VALUES ('230', '48', 'Straight');
INSERT INTO `site_lang` VALUES ('231', '48', 'Bisexual');
INSERT INTO `site_lang` VALUES ('232', '48', 'Height');
INSERT INTO `site_lang` VALUES ('233', '48', 'less than');
INSERT INTO `site_lang` VALUES ('234', '48', 'more than');
INSERT INTO `site_lang` VALUES ('235', '48', 'Weight');
INSERT INTO `site_lang` VALUES ('236', '48', 'Ethnicity');
INSERT INTO `site_lang` VALUES ('237', '48', 'Asian');
INSERT INTO `site_lang` VALUES ('238', '48', 'Middle Eastern');
INSERT INTO `site_lang` VALUES ('239', '48', 'Black');
INSERT INTO `site_lang` VALUES ('240', '48', 'White');
INSERT INTO `site_lang` VALUES ('241', '48', 'Native American');
INSERT INTO `site_lang` VALUES ('242', '48', 'Hispanic/latin');
INSERT INTO `site_lang` VALUES ('243', '48', 'Pacific Islander');
INSERT INTO `site_lang` VALUES ('244', '48', 'Indian');
INSERT INTO `site_lang` VALUES ('245', '48', 'Other');
INSERT INTO `site_lang` VALUES ('246', '48', 'Body type');
INSERT INTO `site_lang` VALUES ('247', '48', 'Slim');
INSERT INTO `site_lang` VALUES ('248', '48', 'Average');
INSERT INTO `site_lang` VALUES ('249', '48', 'Athletic');
INSERT INTO `site_lang` VALUES ('250', '48', 'Heavy set');
INSERT INTO `site_lang` VALUES ('251', '48', 'Curvy');
INSERT INTO `site_lang` VALUES ('252', '48', 'Living');
INSERT INTO `site_lang` VALUES ('253', '48', 'With parents');
INSERT INTO `site_lang` VALUES ('254', '48', 'With housemate');
INSERT INTO `site_lang` VALUES ('255', '48', 'Student dormitory');
INSERT INTO `site_lang` VALUES ('256', '48', 'With partner');
INSERT INTO `site_lang` VALUES ('257', '48', 'Alone');
INSERT INTO `site_lang` VALUES ('258', '48', 'Smoke');
INSERT INTO `site_lang` VALUES ('259', '48', 'Yes');
INSERT INTO `site_lang` VALUES ('260', '48', 'No');
INSERT INTO `site_lang` VALUES ('261', '48', 'Sometimes');
INSERT INTO `site_lang` VALUES ('262', '48', 'Drink');
INSERT INTO `site_lang` VALUES ('263', '48', 'Transport');
INSERT INTO `site_lang` VALUES ('264', '48', 'Parents car');
INSERT INTO `site_lang` VALUES ('265', '48', 'I own a car');
INSERT INTO `site_lang` VALUES ('266', '48', 'I own a motorbike');
INSERT INTO `site_lang` VALUES ('267', '48', 'None');
INSERT INTO `site_lang` VALUES ('268', '48', 'When someone likes me');
INSERT INTO `site_lang` VALUES ('269', '48', 'When i get a match');
INSERT INTO `site_lang` VALUES ('270', '48', 'When new users near me join in');
INSERT INTO `site_lang` VALUES ('271', '48', 'When someone send me a message');
INSERT INTO `site_lang` VALUES ('272', '48', 'Day');
INSERT INTO `site_lang` VALUES ('273', '48', 'Month');
INSERT INTO `site_lang` VALUES ('274', '48', 'Year');
INSERT INTO `site_lang` VALUES ('275', '48', 'Please wait');
INSERT INTO `site_lang` VALUES ('276', '48', 'Interests');
INSERT INTO `site_lang` VALUES ('277', '48', 'Report');
INSERT INTO `site_lang` VALUES ('278', '48', 'Fans');
INSERT INTO `site_lang` VALUES ('279', '48', 'No data');
INSERT INTO `site_lang` VALUES ('280', '48', 'Public Photos');
INSERT INTO `site_lang` VALUES ('281', '48', 'Private photos');
INSERT INTO `site_lang` VALUES ('282', '48', 'Add from ');
INSERT INTO `site_lang` VALUES ('283', '48', 'Add');
INSERT INTO `site_lang` VALUES ('284', '48', 'Photos');
INSERT INTO `site_lang` VALUES ('285', '48', 'Credits');
INSERT INTO `site_lang` VALUES ('286', '48', 'Visits');
INSERT INTO `site_lang` VALUES ('287', '48', 'Add me here');
INSERT INTO `site_lang` VALUES ('288', '48', 'get seen by millions');
INSERT INTO `site_lang` VALUES ('289', '48', 'Set as profile');
INSERT INTO `site_lang` VALUES ('290', '48', 'Private photo');
INSERT INTO `site_lang` VALUES ('291', '48', 'Public photo');
INSERT INTO `site_lang` VALUES ('292', '48', 'Delete');
INSERT INTO `site_lang` VALUES ('293', '48', 'people visited your profile for see them');
INSERT INTO `site_lang` VALUES ('294', '48', 'Upgrade your account to premium');
INSERT INTO `site_lang` VALUES ('295', '48', 'People i like');
INSERT INTO `site_lang` VALUES ('296', '48', 'people liked you, for see them');
INSERT INTO `site_lang` VALUES ('297', '48', 'Messages');
INSERT INTO `site_lang` VALUES ('298', '48', 'Like');
INSERT INTO `site_lang` VALUES ('299', '48', 'Dislike');
INSERT INTO `site_lang` VALUES ('300', '48', 'AGE');
INSERT INTO `site_lang` VALUES ('301', '48', 'You dont have any visit yet');
INSERT INTO `site_lang` VALUES ('302', '48', 'visited');
INSERT INTO `site_lang` VALUES ('303', '48', 'You do not like anyone');
INSERT INTO `site_lang` VALUES ('304', '48', 'Cost');
INSERT INTO `site_lang` VALUES ('305', '48', 'Credits for $');
INSERT INTO `site_lang` VALUES ('306', '48', '0 seconds');
INSERT INTO `site_lang` VALUES ('307', '48', 'year');
INSERT INTO `site_lang` VALUES ('308', '48', 'month');
INSERT INTO `site_lang` VALUES ('309', '48', 'day');
INSERT INTO `site_lang` VALUES ('310', '48', 'hour');
INSERT INTO `site_lang` VALUES ('311', '48', 'minute');
INSERT INTO `site_lang` VALUES ('312', '48', 'second');
INSERT INTO `site_lang` VALUES ('313', '48', 'years');
INSERT INTO `site_lang` VALUES ('314', '48', 'months');
INSERT INTO `site_lang` VALUES ('315', '48', 'days');
INSERT INTO `site_lang` VALUES ('316', '48', 'hours');
INSERT INTO `site_lang` VALUES ('317', '48', 'minutes');
INSERT INTO `site_lang` VALUES ('318', '48', 'seconds');
INSERT INTO `site_lang` VALUES ('319', '48', 'ago');
INSERT INTO `site_lang` VALUES ('320', '48', 'Please verify your account, check your email');
INSERT INTO `site_lang` VALUES ('321', '48', 'Please add a profile photo');
INSERT INTO `site_lang` VALUES ('322', '48', 'Hi, im');
INSERT INTO `site_lang` VALUES ('323', '48', 'years old and im from');
INSERT INTO `site_lang` VALUES ('324', '48', 'We sended you a email for verify your account');
INSERT INTO `site_lang` VALUES ('325', '48', 'is blocking you or you blocked him, you cant chat with him sorry');
INSERT INTO `site_lang` VALUES ('326', '48', 'Report and block');
INSERT INTO `site_lang` VALUES ('327', '48', 'Are you sure you want to report');
INSERT INTO `site_lang` VALUES ('328', '48', 'Press backspace key for smart return to the meeting section.');
INSERT INTO `site_lang` VALUES ('329', '48', 'Write your instagram username');
INSERT INTO `site_lang` VALUES ('330', '48', 'You need to write your username!');
INSERT INTO `site_lang` VALUES ('331', '48', 'username');
INSERT INTO `site_lang` VALUES ('332', '48', 'days of Premium');
INSERT INTO `site_lang` VALUES ('333', '48', 'Wrong');
INSERT INTO `site_lang` VALUES ('334', '48', 'Spotlight');
INSERT INTO `site_lang` VALUES ('335', '48', 'Service cost');
INSERT INTO `site_lang` VALUES ('336', '48', 'Password successfully changed');
INSERT INTO `site_lang` VALUES ('337', '48', 'is calling you..');
INSERT INTO `site_lang` VALUES ('338', '48', 'Photos of ');
INSERT INTO `site_lang` VALUES ('339', '48', 'of');
INSERT INTO `site_lang` VALUES ('340', '48', 'Loading...');
INSERT INTO `site_lang` VALUES ('341', '48', 'We sent you a email with your info, it may take up to 1 min to arrive');
INSERT INTO `site_lang` VALUES ('342', '48', 'likes you and wants to chat in');
INSERT INTO `site_lang` VALUES ('343', '48', 'has seen you in discover and likes. The feeling is mutual?');
INSERT INTO `site_lang` VALUES ('344', '48', 'Find out if you also like');
INSERT INTO `site_lang` VALUES ('345', '48', 'You received this notice because you registered as');
INSERT INTO `site_lang` VALUES ('346', '48', 'Unsubscribe');
INSERT INTO `site_lang` VALUES ('347', '48', 'Choose a new password');
INSERT INTO `site_lang` VALUES ('348', '48', 'if you forgot your password, click on the link below to get a new');
INSERT INTO `site_lang` VALUES ('349', '48', 'You have a match at');
INSERT INTO `site_lang` VALUES ('350', '48', 'Its a match!');
INSERT INTO `site_lang` VALUES ('351', '48', 'thinks the feeling is mutual');
INSERT INTO `site_lang` VALUES ('352', '48', 'Go and say something to');
INSERT INTO `site_lang` VALUES ('353', '48', 'New message from');
INSERT INTO `site_lang` VALUES ('354', '48', 'you have a new message from');
INSERT INTO `site_lang` VALUES ('355', '48', 'Respond to');
INSERT INTO `site_lang` VALUES ('356', '48', 'Have fun!');
INSERT INTO `site_lang` VALUES ('357', '48', 'is new and lives closer to you');
INSERT INTO `site_lang` VALUES ('358', '48', 'is new at');
INSERT INTO `site_lang` VALUES ('359', '48', 'and lives closer to you');
INSERT INTO `site_lang` VALUES ('360', '48', 'Check out the profile');
INSERT INTO `site_lang` VALUES ('361', '48', 'Welcome');
INSERT INTO `site_lang` VALUES ('362', '48', 'Well done, now you are in');
INSERT INTO `site_lang` VALUES ('363', '48', 'Here are a few tips');
INSERT INTO `site_lang` VALUES ('364', '48', 'Now you are a new member of');
INSERT INTO `site_lang` VALUES ('365', '48', 'Verify your account');
INSERT INTO `site_lang` VALUES ('366', '48', 'Newsflash');
INSERT INTO `site_lang` VALUES ('367', '48', 'people in your area wants to know you');
INSERT INTO `site_lang` VALUES ('368', '48', 'In');
INSERT INTO `site_lang` VALUES ('369', '48', 'you can meet people instantly');
INSERT INTO `site_lang` VALUES ('370', '48', 'Meet new people');
INSERT INTO `site_lang` VALUES ('371', '48', 'Nobody is going to fall in love with a blank page. The more information you get, the more chances to find that special someone!');
INSERT INTO `site_lang` VALUES ('372', '48', 'Add photos and complete your profile');
INSERT INTO `site_lang` VALUES ('373', '48', 'More than 1 million people have joined $site_name You probably want to know some of them.');
INSERT INTO `site_lang` VALUES ('374', '48', 'Start meeting new people now');
INSERT INTO `site_lang` VALUES ('375', '48', 'Here are your connection details');
INSERT INTO `site_lang` VALUES ('376', '48', 'E-mail');
INSERT INTO `site_lang` VALUES ('377', '48', 'Password');
INSERT INTO `site_lang` VALUES ('378', '48', 'Please save your connection information in a safe place');
INSERT INTO `site_lang` VALUES ('379', '48', 'Go to');
INSERT INTO `site_lang` VALUES ('380', '48', 'Welcome to');
INSERT INTO `site_lang` VALUES ('381', '48', 'calling...');
INSERT INTO `site_lang` VALUES ('382', '48', 'dont like you');
INSERT INTO `site_lang` VALUES ('383', '48', 'must like you for start a videocall');
INSERT INTO `site_lang` VALUES ('384', '48', 'Ok, i understand');

-- ----------------------------
-- Table structure for spotlight
-- ----------------------------
DROP TABLE IF EXISTS `spotlight`;
CREATE TABLE `spotlight` (
  `id` int(9) NOT NULL AUTO_INCREMENT,
  `u_id` int(9) NOT NULL,
  `time` varchar(100) NOT NULL,
  `lat` varchar(100) NOT NULL,
  `lng` varchar(100) NOT NULL,
  `photo` varchar(300) NOT NULL,
  `lang` int(3) NOT NULL,
  `country` varchar(255) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of spotlight
-- ----------------------------

-- ----------------------------
-- Table structure for users
-- ----------------------------
DROP TABLE IF EXISTS `users`;
CREATE TABLE `users` (
  `id` int(9) NOT NULL AUTO_INCREMENT,
  `name` varchar(100) NOT NULL,
  `email` varchar(100) NOT NULL,
  `pass` varchar(200) NOT NULL,
  `age` int(3) NOT NULL,
  `birthday` varchar(100) NOT NULL,
  `city` varchar(100) NOT NULL,
  `country` varchar(100) NOT NULL,
  `gender` int(1) NOT NULL,
  `lat` varchar(100) NOT NULL,
  `lng` varchar(100) NOT NULL,
  `credits` int(9) NOT NULL DEFAULT '0',
  `premium` int(9) NOT NULL DEFAULT '0',
  `last_access` varchar(100) NOT NULL DEFAULT '0',
  `app_id` varchar(300) NOT NULL DEFAULT '0',
  `facebook_id` varchar(100) NOT NULL DEFAULT '0',
  `looking` int(1) NOT NULL,
  `verified` int(1) NOT NULL DEFAULT '0',
  `popular` int(9) NOT NULL DEFAULT '0',
  `lang` int(3) NOT NULL DEFAULT '1',
  `admin` int(9) NOT NULL DEFAULT '0',
  `fake` int(1) DEFAULT '0',
  `online_day` int(1) NOT NULL,
  `join_date` varchar(100) DEFAULT NULL,
  `s_age` varchar(10) DEFAULT '',
  `s_gender` int(1) DEFAULT NULL,
  `s_radious` int(9) DEFAULT '20000',
  `sexy` int(9) DEFAULT '0',
  `total` int(9) DEFAULT '0',
  `bio` longtext,
  `meet` int(5) DEFAULT '0',
  `discover` int(5) DEFAULT '0',
  `twitter_id` varchar(200) DEFAULT NULL,
  `google_id` varchar(200) DEFAULT NULL,
  `instagram_id` varchar(200) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of users
-- ----------------------------
INSERT INTO `users` VALUES ('1', 'Admin', 'admin@sm.com', '$1$mq8mlJJ/$ABQT/prNY/btIMM55J4pe.', '33', 'January 01, 1990', 'Baltimore', 'United States', '2', '39.2903848', '-76.61218930000001', '200', '0', '1470894969', '0', '0', '2', '0', '38', '1', '1', '0', '0', '02/20/2018', '18,23,1', '1', '1000000', '0', '0', 'Hi, im Adin, 33 years old and im from United States', '0', '0', '', '', '');

-- ----------------------------
-- Table structure for users_blocks
-- ----------------------------
DROP TABLE IF EXISTS `users_blocks`;
CREATE TABLE `users_blocks` (
  `uid1` int(9) NOT NULL,
  `uid2` int(9) NOT NULL,
  PRIMARY KEY (`uid1`,`uid2`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;

-- ----------------------------
-- Records of users_blocks
-- ----------------------------

-- ----------------------------
-- Table structure for users_chat
-- ----------------------------
DROP TABLE IF EXISTS `users_chat`;
CREATE TABLE `users_chat` (
  `uid` int(9) NOT NULL,
  `date` varchar(100) NOT NULL,
  `count` int(9) NOT NULL,
  `last_chat` varchar(50) NOT NULL,
  PRIMARY KEY (`date`,`uid`),
  UNIQUE KEY `KEY` (`date`,`uid`) USING BTREE
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of users_chat
-- ----------------------------

-- ----------------------------
-- Table structure for users_extended
-- ----------------------------
DROP TABLE IF EXISTS `users_extended`;
CREATE TABLE `users_extended` (
  `uid` int(9) NOT NULL,
  `field1` longtext,
  `field2` longtext,
  `field3` longtext,
  `field4` varchar(100) DEFAULT NULL,
  `field5` varchar(100) DEFAULT NULL,
  `field6` varchar(100) DEFAULT NULL,
  `field7` varchar(100) DEFAULT NULL,
  `field8` varchar(100) DEFAULT NULL,
  `field9` varchar(100) DEFAULT NULL,
  `field10` varchar(100) DEFAULT NULL,
  PRIMARY KEY (`uid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of users_extended
-- ----------------------------
INSERT INTO `users_extended` VALUES ('1', null, null, null, null, null, null, null, null, null, null);

-- ----------------------------
-- Table structure for users_gift
-- ----------------------------
DROP TABLE IF EXISTS `users_gift`;
CREATE TABLE `users_gift` (
  `id` int(9) NOT NULL AUTO_INCREMENT,
  `s_id` int(9) DEFAULT NULL,
  `r_id` int(9) DEFAULT NULL,
  `g_id` int(9) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=16 DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of users_gift
-- ----------------------------

-- ----------------------------
-- Table structure for users_interest
-- ----------------------------
DROP TABLE IF EXISTS `users_interest`;
CREATE TABLE `users_interest` (
  `i_id` int(9) NOT NULL,
  `u_id` int(9) NOT NULL,
  `name` varchar(100) DEFAULT NULL,
  PRIMARY KEY (`i_id`,`u_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of users_interest
-- ----------------------------

-- ----------------------------
-- Table structure for users_likes
-- ----------------------------
DROP TABLE IF EXISTS `users_likes`;
CREATE TABLE `users_likes` (
  `u1` int(11) NOT NULL,
  `u2` int(11) NOT NULL,
  `love` int(1) NOT NULL,
  `time` varchar(20) NOT NULL,
  `notification` int(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`u1`,`u2`),
  UNIQUE KEY `KEY` (`u1`,`u2`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of users_likes
-- ----------------------------

-- ----------------------------
-- Table structure for users_notifications
-- ----------------------------
DROP TABLE IF EXISTS `users_notifications`;
CREATE TABLE `users_notifications` (
  `uid` int(9) NOT NULL,
  `visit` int(1) DEFAULT '1',
  `match_m` int(1) DEFAULT '1',
  `fan` int(1) DEFAULT '1',
  `near_me` int(1) DEFAULT '1',
  `message` int(1) DEFAULT '1',
  PRIMARY KEY (`uid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of users_notifications
-- ----------------------------
INSERT INTO `users_notifications` VALUES ('1', '1', '1', '1', '1', '1');

-- ----------------------------
-- Table structure for users_photos
-- ----------------------------
DROP TABLE IF EXISTS `users_photos`;
CREATE TABLE `users_photos` (
  `id` int(9) NOT NULL AUTO_INCREMENT,
  `u_id` int(9) NOT NULL,
  `photo` varchar(250) NOT NULL,
  `desc` text NOT NULL,
  `approved` int(1) NOT NULL DEFAULT '1',
  `blocked` int(1) NOT NULL DEFAULT '0',
  `thumb` varchar(250) NOT NULL,
  `profile` int(1) NOT NULL DEFAULT '0',
  `private` varchar(250) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of users_photos
-- ----------------------------

-- ----------------------------
-- Table structure for users_premium
-- ----------------------------
DROP TABLE IF EXISTS `users_premium`;
CREATE TABLE `users_premium` (
  `uid` int(9) NOT NULL,
  `premium` varchar(100) NOT NULL DEFAULT '0',
  PRIMARY KEY (`uid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of users_premium
-- ----------------------------

-- ----------------------------
-- Table structure for users_videocall
-- ----------------------------
DROP TABLE IF EXISTS `users_videocall`;
CREATE TABLE `users_videocall` (
  `u_id` int(9) NOT NULL,
  `peer_id` varchar(100) NOT NULL,
  `status` int(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`u_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of users_videocall
-- ----------------------------
INSERT INTO `users_videocall` VALUES ('1', 'uumy3jwnd59izfr0', '1');

-- ----------------------------
-- Table structure for users_visits
-- ----------------------------
DROP TABLE IF EXISTS `users_visits`;
CREATE TABLE `users_visits` (
  `u1` int(11) NOT NULL,
  `u2` int(11) NOT NULL,
  `timeago` varchar(100) NOT NULL,
  `notification` int(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`u1`,`u2`),
  UNIQUE KEY `KEY` (`u1`,`u2`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of users_visits
-- ----------------------------

-- ----------------------------
-- Table structure for videocall
-- ----------------------------
DROP TABLE IF EXISTS `videocall`;
CREATE TABLE `videocall` (
  `id` int(9) NOT NULL AUTO_INCREMENT,
  `c_id` int(9) NOT NULL,
  `r_id` int(9) NOT NULL,
  `time` varchar(100) NOT NULL,
  `date` varchar(100) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=49 DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of videocall
-- ----------------------------
